/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"
#include "Files.h"
#include "Strings.h"
#include "Dates.h"
#include "DevCPM.h"


export SET CPfrontCPG_opt;
export Files_Name CPfrontCPG_includePath;
export SHORTCHAR CPfrontCPG_modName[32];
static Files_File CPfrontCPG_HFile, CPfrontCPG_BFile, CPfrontCPG_HIFile;
static Files_Writer CPfrontCPG_R[3];
export INTEGER CPfrontCPG_currFile, CPfrontCPG_level;
static INTEGER CPfrontCPG_pos[3], CPfrontCPG_logicPos[3];

export INTEGER CPfrontCPG__3__desc[];
export SYSTEM_TYPEDESC *CPfrontCPG__3__typ = (SYSTEM_TYPEDESC*)CPfrontCPG__3__desc;

static void CPfrontCPG_Append (Files_Writer *R, Files_File F);
export void CPfrontCPG_CloseFiles (void);
static void CPfrontCPG_MakeFileName (SHORTCHAR *name, INTEGER name__len, Files_Name fname, CHAR *ext, \
INTEGER ext__len);
export void CPfrontCPG_OpenFiles (SHORTCHAR *moduleName, INTEGER moduleName__len);
export void CPfrontCPG_Write (SHORTCHAR ch);
export void CPfrontCPG_WriteHex (INTEGER i);
export void CPfrontCPG_WriteHexInt (INTEGER i);
export void CPfrontCPG_WriteInt (INTEGER i);
export void CPfrontCPG_WriteLn (void);
export void CPfrontCPG_WriteOrigString (SHORTCHAR *s, INTEGER s__len);
export void CPfrontCPG_WriteReal (REAL r, CHAR suffx);
export void CPfrontCPG_WriteString (SHORTCHAR *s, INTEGER s__len);
export void CPfrontCPG_WriteTime (void);

export void CPfrontCPG__reg();
export void CPfrontCPG__body();
export struct SYSTEM_MODDESC CPfrontCPG__desc;


void CPfrontCPG_WriteLn (void)
{
	__ENTER("CPfrontCPG.WriteLn");
	__Files_Writer_WriteByte(CPfrontCPG_R[__X(CPfrontCPG_currFile, 3)], 13);
	__Files_Writer_WriteByte(CPfrontCPG_R[__X(CPfrontCPG_currFile, 3)], 10);
	CPfrontCPG_pos[__X(CPfrontCPG_currFile, 3)] = 0;
	CPfrontCPG_logicPos[__X(CPfrontCPG_currFile, 3)] = 0;
	__EXIT;
}

void CPfrontCPG_Write (SHORTCHAR ch)
{
	INTEGER l;
	__ENTER("CPfrontCPG.Write");
	if (CPfrontCPG_pos[__X(CPfrontCPG_currFile, 3)] > 100 && ch == (SHORTCHAR)' ') {
		if (CPfrontCPG_logicPos[__X(CPfrontCPG_currFile, 3)] <= 30000) {
			__Files_Writer_WriteByte(CPfrontCPG_R[__X(CPfrontCPG_currFile, 3)], 32);
			__Files_Writer_WriteByte(CPfrontCPG_R[__X(CPfrontCPG_currFile, 3)], 92);
			l = CPfrontCPG_logicPos[__X(CPfrontCPG_currFile, 3)];
			CPfrontCPG_WriteLn();
			CPfrontCPG_logicPos[__X(CPfrontCPG_currFile, 3)] = l + 4;
		} else {
			CPfrontCPG_WriteLn();
		}
	} else {
		__Files_Writer_WriteByte(CPfrontCPG_R[__X(CPfrontCPG_currFile, 3)], (BYTE)ch);
		CPfrontCPG_pos[__X(CPfrontCPG_currFile, 3)] += 1;
		CPfrontCPG_logicPos[__X(CPfrontCPG_currFile, 3)] += 1;
	}
	__EXIT;
}

void CPfrontCPG_WriteOrigString (SHORTCHAR *s, INTEGER s__len)
{
	INTEGER i;
	SHORTCHAR ch;
	__ENTER("CPfrontCPG.WriteOrigString");
	__DUP(s, s__len);
	i = 0;
	ch = s[0];
	while (ch != 0) {
		CPfrontCPG_Write(ch);
		i += 1;
		ch = s[__X(i, s__len)];
	}
	__DEL(s);
	__EXIT;
}

void CPfrontCPG_WriteString (SHORTCHAR *s, INTEGER s__len)
{
	INTEGER i;
	SHORTCHAR ch;
	__ENTER("CPfrontCPG.WriteString");
	__DUP(s, s__len);
	if (__STRCMPSS(s, "Windows") == 0) {
		CPfrontCPG_WriteOrigString((SHORTCHAR*)"Windows_", 9);
	} else {
		i = 0;
		ch = s[0];
		while (ch != 0) {
			if (ch == (SHORTCHAR)'^') {
				CPfrontCPG_Write((SHORTCHAR)'_');
				CPfrontCPG_Write((SHORTCHAR)'_');
				CPfrontCPG_Write((SHORTCHAR)'r');
				CPfrontCPG_Write((SHORTCHAR)'e');
				CPfrontCPG_Write((SHORTCHAR)'c');
			} else {
				CPfrontCPG_Write(ch);
			}
			i += 1;
			ch = s[__X(i, s__len)];
		}
	}
	__DEL(s);
	__EXIT;
}

void CPfrontCPG_WriteHex (INTEGER i)
{
	SHORTCHAR s[3];
	INTEGER digit;
	__ENTER("CPfrontCPG.WriteHex");
	digit = __ASHR((INTEGER)((SHORTINT)i), 4, INTEGER);
	if (digit < 10) {
		s[0] = (SHORTCHAR)(48 + digit);
	} else {
		s[0] = (SHORTCHAR)(87 + digit);
	}
	digit = __MASK((INTEGER)((SHORTINT)i), -16);
	if (digit < 10) {
		s[1] = (SHORTCHAR)(48 + digit);
	} else {
		s[1] = (SHORTCHAR)(87 + digit);
	}
	s[2] = 0;
	CPfrontCPG_WriteString(s, 3);
	__EXIT;
}

void CPfrontCPG_WriteHexInt (INTEGER i)
{
	__ENTER("CPfrontCPG.WriteHexInt");
	CPfrontCPG_Write((SHORTCHAR)'0');
	CPfrontCPG_Write((SHORTCHAR)'x');
	CPfrontCPG_WriteHex(__MASK(__ASHR(i, 24, INTEGER), -256));
	CPfrontCPG_WriteHex(__MASK(__ASHR(i, 16, INTEGER), -256));
	CPfrontCPG_WriteHex(__MASK(__ASHR(i, 8, INTEGER), -256));
	CPfrontCPG_WriteHex(__MASK(i, -256));
	__EXIT;
}

void CPfrontCPG_WriteInt (INTEGER i)
{
	CHAR s[20];
	INTEGER i1, k;
	__ENTER("CPfrontCPG.WriteInt");
	if (i == (-2147483647-1)) {
		CPfrontCPG_Write((SHORTCHAR)'(');
		CPfrontCPG_WriteInt(i + 1);
		CPfrontCPG_WriteString((SHORTCHAR*)"-1)", 4);
	} else {
		i1 = __ABS(i);
		s[0] = (CHAR)(__MOD(i1, 10) + 48);
		i1 = __DIV(i1, 10);
		k = 1;
		while (i1 > 0) {
			s[__X(k, 20)] = (CHAR)(__MOD(i1, 10) + 48);
			i1 = __DIV(i1, 10);
			k += 1;
		}
		if (i < 0) {
			s[__X(k, 20)] = (CHAR)L'-';
			k += 1;
		}
		while (k > 0) {
			k -= 1;
			CPfrontCPG_Write((SHORTCHAR)s[__X(k, 20)]);
		}
	}
	__EXIT;
}

void CPfrontCPG_WriteReal (REAL r, CHAR suffx)
{
	CHAR s[32];
	CHAR ch;
	INTEGER i;
	SHORTCHAR _str__27[32];
	__ENTER("CPfrontCPG.WriteReal");
	if (__ABS(r) > 1.0E+308) {
		CPfrontCPG_Write((SHORTCHAR)'(');
		CPfrontCPG_WriteReal(r / (REAL)(REAL)2, suffx);
		CPfrontCPG_WriteString((SHORTCHAR*)" * 2)", 6);
		__EXIT;
		return;
	}
	if ((r < 2147483647.0 && r > -2147483648.0) && r == (REAL)((INTEGER)__ENTIER(r))) {
		if (suffx == (CHAR)L'f') {
			CPfrontCPG_WriteString((SHORTCHAR*)"(SHORTREAL)", 12);
		} else {
			CPfrontCPG_WriteString((SHORTCHAR*)"(REAL)", 7);
		}
		CPfrontCPG_WriteInt((INTEGER)__ENTIER(r));
	} else {
		if (suffx == (CHAR)L'f') {
			Strings_RealToString((SHORTREAL)r, (void*)s, 32);
		} else {
			Strings_RealToString(r, (void*)s, 32);
		}
		i = 0;
		ch = s[0];
		while (ch != (CHAR)L'D' && ch != 0) {
			i += 1;
			ch = s[__X(i, 32)];
		}
		if (ch == (CHAR)L'D') {
			s[__X(i, 32)] = (CHAR)L'e';
		}
		__STRCOPYTS(s, _str__27, 32);
		CPfrontCPG_WriteString(_str__27, __STRLENS(_str__27) + 1);
	}
	__EXIT;
}

void CPfrontCPG_WriteTime (void)
{
	Dates_Time t;
	Dates_Date d;
	__ENTER("CPfrontCPG.WriteTime");
	Dates_GetDateTime(&d, Dates_Date__typ, &t, Dates_Time__typ);
	CPfrontCPG_WriteInt(d.year);
	CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
	CPfrontCPG_WriteInt(d.month);
	CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
	CPfrontCPG_WriteInt(d.day);
	CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
	CPfrontCPG_WriteInt(t.hour);
	CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
	CPfrontCPG_WriteInt(t.minute);
	CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
	CPfrontCPG_WriteInt(t.second);
	__EXIT;
}

static void CPfrontCPG_Append (Files_Writer *R, Files_File F)
{
	Files_Reader R1 = NIL;
	BYTE buffer[4096];
	INTEGER oldPos;
	__ENTER("CPfrontCPG.Append");
	if (F != NIL) {
		R1 = __Files_File_NewReader(F, NIL);
		oldPos = __Files_Reader_Pos(R1);
		__Files_Reader_ReadBytes(R1, (void*)buffer, 4096, 0, 4096);
		while (__Files_Reader_Pos(R1) != oldPos) {
			__Files_Writer_WriteBytes(*R, (void*)buffer, 4096, 0, __Files_Reader_Pos(R1) - oldPos);
			oldPos = __Files_Reader_Pos(R1);
			__Files_Reader_ReadBytes(R1, (void*)buffer, 4096, 0, 4096);
		}
	}
	__EXIT;
}

static void CPfrontCPG_MakeFileName (SHORTCHAR *name, INTEGER name__len, Files_Name fname, CHAR *ext, \
INTEGER ext__len)
{
	INTEGER i, j;
	CHAR ch;
	__ENTER("CPfrontCPG.MakeFileName");
	__DUP(ext, ext__len);
	if (__STRCMPSS(name, "Windows") == 0) {
		__MOVE(((CHAR[]){87, 105, 110, 100, 111, 119, 115, 95, 0}), fname, 18);
		i = 8;
	} else {
		i = 0;
		while (name[__X(i, name__len)] != 0) {
			fname[__X(i, 256)] = name[__X(i, name__len)];
			i += 1;
		}
		fname[__X(i, 256)] = 0;
	}
	j = 0;
	do {
		ch = ext[__X(j, ext__len)];
		fname[__X(i, 256)] = ch;
		i += 1;
		j += 1;
	} while (!(ch == 0));
	__DEL(ext);
	__EXIT;
}

static struct OpenFiles__15 {
	Files_Name *name;
	struct OpenFiles__15 *lnk;
} *OpenFiles__15_s;

static void __16 (SHORTCHAR *moduleName, INTEGER moduleName__len, Files_File *f);
static Files_File __18 (Files_Name name);

static void __16 (SHORTCHAR *moduleName, INTEGER moduleName__len, Files_File *f)
{
	INTEGER res;
	Files_Locator loc = NIL;
	Files_Name dir, name;
	__ENTER("CPfrontCPG.New");
	*f = NIL;
	__STRCOPYSL(moduleName, name, 256);
	loc = __Files_Directory_This(Files_dir, (void*)DevCPM_codePath, 256);
	if (DevCPM_legacy) {
		Kernel_SplitName(name, 256, (void*)dir, 256, (void*)name, 256);
		loc = __Files_Locator_This(__Files_Locator_This(loc, (void*)dir, 256), (void*)DevCPM_codeDir, 16);
	}
	*f = __Files_Directory_New(Files_dir, loc, 1);
	__EXIT;
}

static Files_File __18 (Files_Name name)
{
	Files_Locator loc = NIL;
	Files_Name name__copy;
	__ENTER("CPfrontCPG.Old");
	__DUPARR(name);
	loc = __Files_Directory_This(Files_dir, (void*)CPfrontCPG_includePath, 256);
	__EXIT;
	return __Files_Directory_Old(Files_dir, loc, name, 1);
}

void CPfrontCPG_OpenFiles (SHORTCHAR *moduleName, INTEGER moduleName__len)
{
	Files_Name name;
	struct OpenFiles__15 _s;
	__ENTER("CPfrontCPG.OpenFiles");
	_s.name = (void*)name;
	_s.lnk = OpenFiles__15_s;
	OpenFiles__15_s = &_s;
	__STRCOPYSS(moduleName, CPfrontCPG_modName, 32);
	__16((void*)moduleName, moduleName__len, &CPfrontCPG_HFile);
	if (CPfrontCPG_HFile != NIL) {
		CPfrontCPG_R[0] = __Files_File_NewWriter(CPfrontCPG_HFile, NIL);
	} else {
		DevCPM_err(153);
	}
	__16((void*)moduleName, moduleName__len, &CPfrontCPG_BFile);
	if (CPfrontCPG_BFile != NIL) {
		CPfrontCPG_R[1] = __Files_File_NewWriter(CPfrontCPG_BFile, NIL);
	} else {
		DevCPM_err(153);
	}
	__16((void*)moduleName, moduleName__len, &CPfrontCPG_HIFile);
	if (CPfrontCPG_HIFile != NIL) {
		CPfrontCPG_R[2] = __Files_File_NewWriter(CPfrontCPG_HIFile, NIL);
	} else {
		DevCPM_err(153);
	}
	if (__IN(8, CPfrontCPG_opt)) {
		CPfrontCPG_MakeFileName((void*)moduleName, moduleName__len, name, (CHAR*)((CHAR[]){46, 104, 48, 0}), \
4);
		CPfrontCPG_Append(&CPfrontCPG_R[2], __18(name));
		CPfrontCPG_MakeFileName((void*)moduleName, moduleName__len, name, (CHAR*)((CHAR[]){46, 99, 48, 0}), \
4);
		CPfrontCPG_Append(&CPfrontCPG_R[1], __18(name));
	}
	CPfrontCPG_pos[0] = 0;
	CPfrontCPG_pos[1] = 0;
	CPfrontCPG_pos[2] = 0;
	CPfrontCPG_logicPos[0] = 0;
	CPfrontCPG_logicPos[1] = 0;
	CPfrontCPG_logicPos[2] = 0;
	OpenFiles__15_s = _s.lnk;
	__EXIT;
}

static struct CloseFiles__2 {
	struct CloseFiles__2 *lnk;
} *CloseFiles__2_s;

static void __8 (Files_Type ext);
static void __11 (Files_Type ext, Files_File f);

static void __11 (Files_Type ext, Files_File f)
{
	INTEGER res;
	Files_Name dir, name;
	SHORTCHAR _str__13[256];
	__ENTER("CPfrontCPG.Register");
	__STRCOPYSL(CPfrontCPG_modName, name, 256);
	if (DevCPM_legacy) {
		Kernel_SplitName(name, 256, (void*)dir, 256, (void*)name, 256);
	}
	__STRCOPYTS(name, _str__13, 256);
	CPfrontCPG_MakeFileName((void*)_str__13, __STRLENS(_str__13) + 1, name, ext, 16);
	__Files_File_Register(f, name, (CHAR*)((CHAR[]){42, 0}), 1, &res);
	__EXIT;
}

static void __8 (Files_Type ext)
{
	Files_Locator loc = NIL;
	Files_Name dir, name;
	SHORTCHAR _str__10[256];
	__ENTER("CPfrontCPG.Delete");
	__STRCOPYSL(CPfrontCPG_modName, name, 256);
	loc = __Files_Directory_This(Files_dir, (void*)DevCPM_codePath, 256);
	if (DevCPM_legacy) {
		Kernel_SplitName(name, 256, (void*)dir, 256, (void*)name, 256);
		loc = __Files_Locator_This(__Files_Locator_This(loc, (void*)dir, 256), (void*)DevCPM_codeDir, 16);
	}
	__STRCOPYTS(name, _str__10, 256);
	CPfrontCPG_MakeFileName((void*)_str__10, __STRLENS(_str__10) + 1, name, ext, 16);
	__Files_Directory_Delete(Files_dir, loc, name);
	__EXIT;
}

void CPfrontCPG_CloseFiles (void)
{
	Files_Name dir, name;
	INTEGER res;
	CHAR _str__7[16];
	CHAR _str__6[16];
	CHAR _str__5[16];
	CHAR _str__4[16];
	CHAR _str__3[16];
	struct CloseFiles__2 _s;
	__ENTER("CPfrontCPG.CloseFiles");
	_s.lnk = CloseFiles__2_s;
	CloseFiles__2_s = &_s;
	if (DevCPM_verbose > 0) {
		if (DevCPM_noerr) {
			DevCPM_LogWStr((void*)((CHAR[]){32, 32, 32, 32, 0}), 5);
			DevCPM_LogWNum(__Files_Writer_Pos(CPfrontCPG_R[1]), 0);
			DevCPM_LogWStr((void*)((CHAR[]){32, 98, 121, 116, 101, 115, 0}), 7);
			DevCPM_LogWLn();
		}
	}
	if (DevCPM_noerr) {
		if (__STRCMPSS(CPfrontCPG_modName, "SYSTEM") == 0) {
			if (!__IN(10, CPfrontCPG_opt)) {
				__MOVE(((CHAR[]){46, 99, 0}), _str__7, 6);
				__11((void*)_str__7, CPfrontCPG_BFile);
			}
		} else if (!__IN(10, CPfrontCPG_opt)) {
			CPfrontCPG_Append(&CPfrontCPG_R[2], CPfrontCPG_HFile);
			__MOVE(((CHAR[]){46, 104, 0}), _str__6, 6);
			__11((void*)_str__6, CPfrontCPG_HIFile);
			__MOVE(((CHAR[]){46, 99, 0}), _str__5, 6);
			__11((void*)_str__5, CPfrontCPG_BFile);
		} else {
			__MOVE(((CHAR[]){46, 104, 0}), _str__4, 6);
			__8((void*)_str__4);
			__MOVE(((CHAR[]){46, 99, 0}), _str__3, 6);
			__11((void*)_str__3, CPfrontCPG_BFile);
		}
	}
	CPfrontCPG_HFile = NIL;
	CPfrontCPG_BFile = NIL;
	CPfrontCPG_HIFile = NIL;
	CPfrontCPG_R[0] = NIL;
	CPfrontCPG_R[1] = NIL;
	CPfrontCPG_R[2] = NIL;
	CloseFiles__2_s = _s.lnk;
	__EXIT;
}

export INTEGER CPfrontCPG__1__desc[] = {
	3,
	(INTEGER)&CPfrontCPG__desc,
	0<<8 | 0x02,
	(INTEGER)Files_Writer__desc
};
export INTEGER CPfrontCPG__2__desc[] = {
	3,
	(INTEGER)&CPfrontCPG__desc,
	0<<8 | 0x02,
	6
};
export INTEGER CPfrontCPG__3__desc[] = {
	32,
	(INTEGER)&CPfrontCPG__desc,
	0<<8 | 0x02,
	2
};
static SYSTEM_MODDESC *CPfrontCPG__imp[] = {
	&Dates__desc,
	&DevCPM__desc,
	&Files__desc,
	&Kernel__desc,
	&Strings__desc,
};
static INTEGER CPfrontCPG__exp[] = {
	40,
	0x7045e9e2, 0, 1<<8 | 0x41, 0,
	0x227d6f36, (INTEGER)CPfrontCPG_Append, 11<<8 | 0x14, 0,
	0x5589de0a, (INTEGER)&CPfrontCPG_BFile, 18<<8 | 0x13, (INTEGER)Files_File__desc,
	0x528c19ed, 0, 24<<8 | 0x41, 0,
	0x5814f4d6, (INTEGER)CPfrontCPG_CloseFiles, 33<<8 | 0x44, 0,
	0x5589de0a, (INTEGER)&CPfrontCPG_HFile, 44<<8 | 0x13, (INTEGER)Files_File__desc,
	0x5589de0a, (INTEGER)&CPfrontCPG_HIFile, 50<<8 | 0x13, (INTEGER)Files_File__desc,
	0x564d045a, 0, 57<<8 | 0x41, 0,
	0x5fcf3f34, 0, 68<<8 | 0x41, 0,
	0x227d6f36, (INTEGER)CPfrontCPG_MakeFileName, 82<<8 | 0x14, 0,
	0x7350ca4d, (INTEGER)CPfrontCPG_OpenFiles, 95<<8 | 0x44, 0,
	0x9fd8eb09, 0, 105<<8 | 0x41, 0,
	0x48a8cd9a, (INTEGER)&CPfrontCPG_R, 116<<8 | 0x13, (INTEGER)CPfrontCPG__1__desc,
	0x37608962, (INTEGER)CPfrontCPG_Write, 118<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)CPfrontCPG_WriteHex, 124<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)CPfrontCPG_WriteHexInt, 133<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)CPfrontCPG_WriteInt, 145<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)CPfrontCPG_WriteLn, 154<<8 | 0x44, 0,
	0xa84762da, (INTEGER)CPfrontCPG_WriteOrigString, 162<<8 | 0x44, 0,
	0xd7d37c1e, (INTEGER)CPfrontCPG_WriteReal, 178<<8 | 0x44, 0,
	0xa84762da, (INTEGER)CPfrontCPG_WriteString, 188<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)CPfrontCPG_WriteTime, 200<<8 | 0x44, 0,
	0x4ccb49e8, 0, 210<<8 | 0x41, 0,
	0x480a545f, 0, 215<<8 | 0x41, 0,
	0x57e82b87, (INTEGER)&CPfrontCPG_currFile, 222<<8 | 0x43, 6,
	0x7484f455, 0, 231<<8 | 0x41, 0,
	0x7045e9e2, 0, 237<<8 | 0x41, 0,
	0xdcfd0d85, (INTEGER)&CPfrontCPG_includePath, 246<<8 | 0x43, (INTEGER)Files_Name__desc,
	0x564d045a, 0, 258<<8 | 0x41, 0,
	0x57e82b87, (INTEGER)&CPfrontCPG_level, 265<<8 | 0x43, 6,
	0x39bb8d9b, (INTEGER)&CPfrontCPG_logicPos, 271<<8 | 0x13, (INTEGER)CPfrontCPG__2__desc,
	0x79c7d28c, 0, 280<<8 | 0x41, 0,
	0xdb878790, (INTEGER)&CPfrontCPG_modName, 289<<8 | 0x43, (INTEGER)CPfrontCPG__3__desc,
	0x45497286, 0, 297<<8 | 0x41, 0,
	0x6fa7963a, (INTEGER)&CPfrontCPG_opt, 303<<8 | 0x43, 9,
	0x39bb8d9b, (INTEGER)&CPfrontCPG_pos, 307<<8 | 0x13, (INTEGER)CPfrontCPG__2__desc,
	0x41886f31, 0, 311<<8 | 0x41, 0,
	0x5fcf3f34, 0, 319<<8 | 0x41, 0,
	0x5b0e2283, 0, 326<<8 | 0x41, 0,
	0x528c19ed, 0, 333<<8 | 0x41, 0,
};
static char CPfrontCPG__names[] = {
	0,
	'A','l','i','g','n','m','e','n','t',0,
	'A','p','p','e','n','d',0,
	'B','F','i','l','e',0,
	'B','o','d','y','F','i','l','e',0,
	'C','l','o','s','e','F','i','l','e','s',0,
	'H','F','i','l','e',0,
	'H','I','F','i','l','e',0,
	'H','e','a','d','e','r','F','i','l','e',0,
	'H','e','a','d','e','r','I','n','c','l','u','d','e',0,
	'M','a','k','e','F','i','l','e','N','a','m','e',0,
	'O','p','e','n','F','i','l','e','s',0,
	'O','p','t','i','o','n','C','h','a','r',0,
	'R',0,
	'W','r','i','t','e',0,
	'W','r','i','t','e','H','e','x',0,
	'W','r','i','t','e','H','e','x','I','n','t',0,
	'W','r','i','t','e','I','n','t',0,
	'W','r','i','t','e','L','n',0,
	'W','r','i','t','e','O','r','i','g','S','t','r','i','n','g',0,
	'W','r','i','t','e','R','e','a','l',0,
	'W','r','i','t','e','S','t','r','i','n','g',0,
	'W','r','i','t','e','T','i','m','e',0,
	'a','n','s','i',0,
	'a','s','s','e','r','t',0,
	'c','u','r','r','F','i','l','e',0,
	'e','x','t','s','f',0,
	'i','n','c','l','u','d','e','0',0,
	'i','n','c','l','u','d','e','P','a','t','h',0,
	'i','n','x','c','h','k',0,
	'l','e','v','e','l',0,
	'l','o','g','i','c','P','o','s',0,
	'm','a','i','n','p','r','o','g',0,
	'm','o','d','N','a','m','e',0,
	'n','e','w','s','f',0,
	'o','p','t',0,
	'p','o','s',0,
	'p','t','r','i','n','i','t',0,
	'r','a','n','c','h','k',0,
	't','y','p','c','h','k',0,
	'v','c','p','p',0,
};
static INTEGER CPfrontCPG__ptrs[] = {
	(INTEGER)&CPfrontCPG_HFile + 0, 
	(INTEGER)&CPfrontCPG_BFile + 0, 
	(INTEGER)&CPfrontCPG_HIFile + 0, 
	(INTEGER)&CPfrontCPG_R + 0, 
	(INTEGER)&CPfrontCPG_R + 4, 
	(INTEGER)&CPfrontCPG_R + 8, 
};
struct SYSTEM_MODDESC CPfrontCPG__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 17}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	CPfrontCPG__body,
	0,
	5, /* nofimps */ 
	6, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	CPfrontCPG__names,
	CPfrontCPG__ptrs,
	CPfrontCPG__imp,
	(SYSTEM_DIRECTORY*)CPfrontCPG__exp,
	"CPfrontCPG"
};

export void CPfrontCPG__reg()
{
	__BEGREG(CPfrontCPG__desc);
	Kernel__reg();
	Files__reg();
	Strings__reg();
	Dates__reg();
	DevCPM__reg();
	__REGMOD(CPfrontCPG__desc);
	__ENDREG;
}

export void CPfrontCPG__body()
{
	__BEGBODY(CPfrontCPG__desc);
	Kernel__body();
	Files__body();
	Strings__body();
	Dates__body();
	DevCPM__body();
	__ENDBODY;
}
