/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "DevCPM.h"
#include "Files.h"
#include "DevCPS.h"
#include "DevCPT.h"
#include "CPfrontCPG.h"
#include "CPfrontCPC.h"

typedef
	struct CPfrontCPV_ExitInfo {
		SHORTINT level, label;
	} CPfrontCPV_ExitInfo;


static BOOLEAN CPfrontCPV_assert, CPfrontCPV_inxchk, CPfrontCPV_mainprog, CPfrontCPV_ansi;
static SHORTINT CPfrontCPV_stamp, CPfrontCPV_recno;
static CPfrontCPV_ExitInfo CPfrontCPV_exit;
static SHORTINT CPfrontCPV_nofExitLabels;

export INTEGER CPfrontCPV_ExitInfo__desc[];
export SYSTEM_TYPEDESC *CPfrontCPV_ExitInfo__typ = (SYSTEM_TYPEDESC*)(CPfrontCPV_ExitInfo__desc + 2);

static void CPfrontCPV_ActualPar (DevCPT_Node n, DevCPT_Object fp);
static void CPfrontCPV_AddCopy (DevCPT_Node left, DevCPT_Node right, BOOLEAN first);
static void CPfrontCPV_Adr (DevCPT_Node n, SHORTINT prec, BOOLEAN cast_adr);
export void CPfrontCPV_AdrAndSize (DevCPT_Object topScope);
static void CPfrontCPV_CaseStat (DevCPT_Node n, DevCPT_Object outerProc);
static void CPfrontCPV_Convert (DevCPT_Node n, SHORTINT form, SHORTINT prec);
static void CPfrontCPV_CountTProcs (DevCPT_Struct rec);
static void CPfrontCPV_DefineTDescs (DevCPT_Node n, BOOLEAN close);
static void CPfrontCPV_Entier (DevCPT_Node n, SHORTINT prec);
static void CPfrontCPV_IfStat (DevCPT_Node n, BOOLEAN withtrap, DevCPT_Object outerProc);
static BOOLEAN CPfrontCPV_ImplicitReturn (DevCPT_Node n);
static void CPfrontCPV_Index (DevCPT_Node n, DevCPT_Node d, SHORTINT prec, SHORTINT dim);
export void CPfrontCPV_Init (SET opt);
static void CPfrontCPV_LEntier (DevCPT_Node n, SHORTINT prec);
static void CPfrontCPV_Len (DevCPT_Node n, INTEGER dim, BOOLEAN incl0x);
export void CPfrontCPV_Module (DevCPT_Node prog);
static void CPfrontCPV_NewArr (DevCPT_Node d, DevCPT_Node x);
static SHORTINT CPfrontCPV_Precedence (SHORTINT class, SHORTINT subclass, SHORTINT form, SHORTINT comp);
static BOOLEAN CPfrontCPV_SameExp (DevCPT_Node n1, DevCPT_Node n2);
static BOOLEAN CPfrontCPV_SideEffects (DevCPT_Node n);
static void CPfrontCPV_Stamp (DevCPT_String *s);
static void CPfrontCPV_StringCopy (DevCPT_Node left, DevCPT_Node right, BOOLEAN exp);
static void CPfrontCPV_StringModifier (DevCPT_Node n);
static DevCPT_Object CPfrontCPV_SuperProc (DevCPT_Node n);
static void CPfrontCPV_Traverse (DevCPT_Object obj, DevCPT_Object outerScope, BOOLEAN exported);
static void CPfrontCPV_TraverseType (DevCPT_Struct typ);
export void CPfrontCPV_TypSize (DevCPT_Struct typ);
static void CPfrontCPV_TypeOf (DevCPT_Node n);
static void CPfrontCPV_compStat (DevCPT_Node n, BOOLEAN exp);
static void CPfrontCPV_design (DevCPT_Node n, SHORTINT prec);
static void CPfrontCPV_design_adr (DevCPT_Node n, SHORTINT prec, BOOLEAN adr);
static void CPfrontCPV_expr (DevCPT_Node n, SHORTINT prec);
static void CPfrontCPV_expr_val (DevCPT_Node n, SHORTINT prec, BOOLEAN lvalue);
static void CPfrontCPV_stat (DevCPT_Node n, DevCPT_Object outerProc);

export void CPfrontCPV__reg();
export void CPfrontCPV__body();
export struct SYSTEM_MODDESC CPfrontCPV__desc;


void CPfrontCPV_Init (SET opt)
{
	__ENTER("CPfrontCPV.Init");
	CPfrontCPC_Init(opt);
	CPfrontCPV_stamp = 0;
	CPfrontCPV_recno = 0;
	CPfrontCPV_nofExitLabels = 0;
	CPfrontCPV_assert = __IN(2, opt);
	CPfrontCPV_inxchk = __IN(0, opt);
	CPfrontCPV_mainprog = __IN(10, CPfrontCPG_opt);
	CPfrontCPV_ansi = __IN(6, CPfrontCPG_opt);
	__EXIT;
}

void CPfrontCPV_TypSize (DevCPT_Struct typ)
{
	SHORTINT f, c;
	INTEGER offset, size, base, fbase, off0;
	DevCPT_Object fld = NIL;
	DevCPT_Struct btyp = NIL;
	__ENTER("CPfrontCPV.TypSize");
	if (typ == DevCPT_undftyp) {
		DevCPM_err(58);
	} else if (typ->size == -1) {
		f = typ->form;
		c = typ->comp;
		if ((INTEGER)c == 4) {
			btyp = typ->BaseTyp;
			if (btyp == NIL) {
				offset = 0;
				base = 1;
			} else {
				CPfrontCPV_TypSize(btyp);
				offset = btyp->size - __ASHR(__ABS((INTEGER)btyp->sysflag), 8, INTEGER);
				base = btyp->align;
			}
			fld = typ->link;
			while (fld != NIL && (INTEGER)fld->mode == 4) {
				btyp = fld->typ;
				CPfrontCPV_TypSize(btyp);
				size = btyp->size;
				fbase = CPfrontCPC_BaseAlignment(btyp);
				if ((INTEGER)typ->sysflag == 7) {
					fld->adr = 0;
					if (size > offset) {
						offset = size;
					}
				} else {
					CPfrontCPC_Align(&offset, fbase);
					fld->adr = offset;
					offset += size;
				}
				if (fbase > base) {
					base = fbase;
				}
				fld = fld->link;
			}
			off0 = offset;
			if (offset == 0) {
				offset = 1;
			}
			CPfrontCPC_Align(&offset, base);
			typ->size = offset;
			typ->align = base;
			typ->sysflag = (SHORTINT)(__MASK((INTEGER)typ->sysflag, -256) + (INTEGER)((SHORTINT)__ASHL(offset - \
off0, 8, INTEGER)));
			if (__MASK((INTEGER)typ->sysflag, -256) == 0) {
				typ->sysflag = (SHORTINT)(-((INTEGER)typ->sysflag));
			}
			typ->n = -1;
		} else if ((INTEGER)c == 2) {
			CPfrontCPV_TypSize(typ->BaseTyp);
			typ->size = typ->n * typ->BaseTyp->size;
		} else if ((INTEGER)f == 13) {
			typ->size = 4;
			if (typ->BaseTyp == DevCPT_undftyp) {
				DevCPM_Mark(128, typ->n);
			} else {
				CPfrontCPV_TypSize(typ->BaseTyp);
			}
			if (typ->BaseTyp == DevCPT_anytyp && typ->strobj == NIL) {
				typ->strobj = DevCPT_anyptrtyp->strobj;
			}
		} else if ((INTEGER)f == 14) {
			typ->size = 4;
		} else if ((INTEGER)c == 3) {
			btyp = typ->BaseTyp;
			CPfrontCPV_TypSize(btyp);
			if ((INTEGER)typ->sysflag == 1 || typ->untagged) {
				typ->size = 4;
			} else if ((INTEGER)btyp->comp == 3) {
				typ->size = btyp->size + 4;
			} else {
				typ->size = 8;
			}
		}
		if (typ->strobj == NIL) {
			CPfrontCPV_recno += 1;
			typ->align += __ASHL((INTEGER)CPfrontCPV_recno, 16, INTEGER);
		}
	}
	__EXIT;
}

static struct CountTProcs__7 {
	DevCPT_Struct *rec;
	struct CountTProcs__7 *lnk;
} *CountTProcs__7_s;

static void __8 (DevCPT_Object obj);

static void __8 (DevCPT_Object obj)
{
	DevCPT_Object redef = NIL;
	DevCPT_String _ptr__10 = NIL;
	__ENTER("CPfrontCPV.TProcs");
	if (obj != NIL) {
		__8(obj->left);
		if ((INTEGER)obj->mode == 13) {
			_ptr__10 = obj->name;
			DevCPT_FindBaseField((void*)_ptr__10->data, _ptr__10->len[0], (*CountTProcs__7_s->rec), &redef);
			if (redef != NIL) {
				obj->num = redef->num;
				if (!__IN(2, obj->conval->setval) || (redef->conval->setval & 0x1a0000) == 0x0) {
					DevCPM_Mark(119, ((*CountTProcs__7_s->rec))->txtpos);
				}
			} else {
				obj->num = ((*CountTProcs__7_s->rec))->n;
				((*CountTProcs__7_s->rec))->n += 1;
			}
			if ((obj->conval->setval & 0x0a0002) == 0x0) {
				DevCPM_Mark(129, obj->adr);
			}
		}
		__8(obj->right);
	}
	__EXIT;
}

static void CPfrontCPV_CountTProcs (DevCPT_Struct rec)
{
	DevCPT_Struct btyp = NIL;
	struct CountTProcs__7 _s;
	__ENTER("CPfrontCPV.CountTProcs");
	_s.rec = &rec;
	_s.lnk = CountTProcs__7_s;
	CountTProcs__7_s = &_s;
	if (rec->n == -1) {
		if (rec->untagged) {
			rec->n = 0;
		} else {
			rec->n = DevCPT_anytyp->n;
		}
		btyp = rec->BaseTyp;
		if (btyp != NIL) {
			CPfrontCPV_CountTProcs(btyp);
			rec->n = btyp->n;
		}
		__8(rec->link);
	}
	CountTProcs__7_s = _s.lnk;
	__EXIT;
}

static void CPfrontCPV_TraverseType (DevCPT_Struct typ)
{
	DevCPT_Object p = NIL;
	__ENTER("CPfrontCPV.TraverseType");
	if (!typ->allocated) {
		typ->allocated = 1;
		CPfrontCPV_TypSize(typ);
		if ((INTEGER)typ->comp == 4) {
			CPfrontCPV_CountTProcs(typ);
			if ((INTEGER)typ->extlev > 14) {
				DevCPM_Mark(233, typ->txtpos);
			}
			if (typ->BaseTyp != NIL) {
				CPfrontCPV_TraverseType(typ->BaseTyp);
			}
			CPfrontCPV_Traverse(typ->link, typ->strobj, 0);
		} else if ((INTEGER)typ->form == 13) {
			if (typ->BaseTyp == DevCPT_undftyp) {
				DevCPM_Mark(128, typ->txtpos);
			}
			CPfrontCPV_TraverseType(typ->BaseTyp);
			if (!typ->untagged && __IN(typ->BaseTyp->comp, 0x0c)) {
				CPfrontCPC_InsertArrayType(typ->BaseTyp);
			}
		} else if ((INTEGER)typ->form == 14) {
			CPfrontCPV_TraverseType(typ->BaseTyp);
			p = typ->link;
			while (p != NIL) {
				CPfrontCPV_TraverseType(p->typ);
				p = p->link;
			}
		} else {
			CPfrontCPV_TraverseType(typ->BaseTyp);
		}
	}
	__EXIT;
}

static void CPfrontCPV_Stamp (DevCPT_String *s)
{
	SHORTINT i, j, k;
	SHORTCHAR n[10];
	DevCPT_String t = NIL;
	__ENTER("CPfrontCPV.Stamp");
	CPfrontCPV_stamp += 1;
	i = 0;
	j = CPfrontCPV_stamp;
	while (((*s)->data)[__X(i, (*s)->len[0])] != 0) {
		i += 1;
	}
	if ((INTEGER)i > 25) {
		i = 25;
	}
	if ((INTEGER)i + 12 > (*s)->len[0]) {
		t = __NEWARR(1, (INTEGER)i + 12);
		__STRCOPYSS((*s)->data, t->data, t->len[0]);
		*s = t;
	}
	((*s)->data)[__X(i, (*s)->len[0])] = (SHORTCHAR)'_';
	((*s)->data)[__X((INTEGER)i + 1, (*s)->len[0])] = (SHORTCHAR)'_';
	i += 2;
	k = 0;
	do {
		n[__X(k, 10)] = (SHORTCHAR)(__MOD((INTEGER)j, 10) + 48);
		j = (SHORTINT)__DIV((INTEGER)j, 10);
		k += 1;
	} while (!((INTEGER)j == 0));
	do {
		k -= 1;
		((*s)->data)[__X(i, (*s)->len[0])] = n[__X(k, 10)];
		i += 1;
	} while (!((INTEGER)k == 0));
	((*s)->data)[__X(i, (*s)->len[0])] = 0;
	__EXIT;
}

static void CPfrontCPV_Traverse (DevCPT_Object obj, DevCPT_Object outerScope, BOOLEAN exported)
{
	SHORTINT mode;
	DevCPT_Object scope = NIL;
	DevCPT_Object p = NIL;
	__ENTER("CPfrontCPV.Traverse");
	if (obj != NIL) {
		CPfrontCPV_Traverse(obj->left, outerScope, exported);
		if ((obj->name->data)[0] == (SHORTCHAR)'@') {
			(obj->name->data)[0] = (SHORTCHAR)'_';
			CPfrontCPV_Stamp(&obj->name);
		}
		obj->linkadr = 0;
		mode = obj->mode;
		if ((INTEGER)mode == 5 && ((INTEGER)obj->vis != 0) == exported) {
			CPfrontCPV_TraverseType(obj->typ);
		} else if (__IN(mode, 0x16)) {
			CPfrontCPV_TraverseType(obj->typ);
		}
		if (!exported) {
			if (__IN(mode, 0x60) && (INTEGER)obj->mnolev > 0) {
				obj->entry = obj->name;
				obj->name = __NEWARR(1, __STRLENS(obj->name->data) + 12);
				CPfrontCPV_Stamp(&obj->name);
			}
			if (__IN(mode, 0x26)) {
				obj->scope = outerScope;
			} else if (__IN(mode, 0x26c0)) {
				CPfrontCPV_TraverseType(obj->typ);
				p = obj->link;
				while (p != NIL) {
					CPfrontCPV_TraverseType(p->typ);
					p = p->link;
				}
				scope = obj->scope;
				scope->leaf = 1;
				scope->name = __NEWARR(1, __STRLENS(obj->name->data) + 12);
				__STRCOPYSS(obj->name->data, scope->name->data, scope->name->len[0]);
				CPfrontCPV_Stamp(&scope->name);
				if ((INTEGER)mode == 9) {
					obj->adr = 1;
				}
				if ((INTEGER)scope->mnolev > 1) {
					outerScope->leaf = 0;
				}
				CPfrontCPV_Traverse(obj->scope->right, obj->scope, 0);
				if ((obj->conval->setval & 0x0a0002) == 0x0) {
					DevCPM_Mark(129, obj->adr);
				}
			}
		}
		CPfrontCPV_Traverse(obj->right, outerScope, exported);
	}
	__EXIT;
}

void CPfrontCPV_AdrAndSize (DevCPT_Object topScope)
{
	__ENTER("CPfrontCPV.AdrAndSize");
	DevCPM_errpos = topScope->adr;
	topScope->leaf = 1;
	CPfrontCPV_Traverse(topScope->right, topScope, 1);
	CPfrontCPV_Traverse(topScope->right, topScope, 0);
	DevCPT_char8typ->strobj->linkadr = 2;
	DevCPT_char16typ->strobj->linkadr = 2;
	DevCPT_settyp->strobj->linkadr = 2;
	DevCPT_real32typ->strobj->linkadr = 2;
	DevCPT_real64typ->strobj->linkadr = 2;
	DevCPT_int8typ->strobj->linkadr = 2;
	DevCPT_int16typ->strobj->linkadr = 2;
	DevCPT_int32typ->strobj->linkadr = 2;
	DevCPT_int64typ->strobj->linkadr = 2;
	DevCPT_booltyp->strobj->linkadr = 2;
	DevCPT_sysptrtyp->strobj->linkadr = 2;
	DevCPT_guidtyp->strobj->linkadr = 2;
	DevCPT_iunktyp->strobj->linkadr = 2;
	DevCPT_anyptrtyp->strobj->linkadr = 2;
	DevCPT_anytyp->strobj->linkadr = 2;
	__EXIT;
}

static SHORTINT CPfrontCPV_Precedence (SHORTINT class, SHORTINT subclass, SHORTINT form, SHORTINT comp)
{
	__ENTER("CPfrontCPV.Precedence");
	switch (class) {
		case 0: case 2: case 4: case 7: case 9: 
		case 13: 
			__EXIT;
			return 10;
			break;
		case 5: 
			if (__IN(3, CPfrontCPG_opt)) {
				__EXIT;
				return 10;
			} else {
				__EXIT;
				return 9;
			}
			break;
		case 1: 
			if (__IN(comp, 0x0c)) {
				__EXIT;
				return 10;
			} else {
				__EXIT;
				return 9;
			}
			break;
		case 3: 
			__EXIT;
			return 9;
			break;
		case 11: 
			switch (subclass) {
				case 7: case 20: case 24: case 29: case 33: 
				case 36: case 37: 
					__EXIT;
					return 9;
					break;
				case 16: case 21: case 22: case 23: case 25: 
				case 26: 
					__EXIT;
					return 10;
					break;
				default: __CASECHK;
			}
			break;
		case 12: 
			switch (subclass) {
				case 1: 
					if ((INTEGER)form == 9) {
						__EXIT;
						return 4;
					} else {
						__EXIT;
						return 8;
					}
					break;
				case 2: 
					if ((INTEGER)form == 9) {
						__EXIT;
						return 3;
					} else {
						__EXIT;
						return 8;
					}
					break;
				case 3: case 4: 
					__EXIT;
					return 10;
					break;
				case 6: 
					if ((INTEGER)form == 9) {
						__EXIT;
						return 2;
					} else {
						__EXIT;
						return 7;
					}
					break;
				case 7: 
					if ((INTEGER)form == 9) {
						__EXIT;
						return 4;
					} else {
						__EXIT;
						return 7;
					}
					break;
				case 11: case 12: case 13: case 14: 
					__EXIT;
					return 6;
					break;
				case 9: case 10: 
					__EXIT;
					return 5;
					break;
				case 5: 
					__EXIT;
					return 1;
					break;
				case 8: 
					__EXIT;
					return 0;
					break;
				case 15: case 17: case 18: case 19: case 26: 
				case 27: case 28: case 34: case 35: 
					__EXIT;
					return 10;
					break;
				default: __CASECHK;
			}
			break;
		case 10: 
			__EXIT;
			return 10;
			break;
		case 6: case 8: 
			__EXIT;
			return 12;
			break;
		case 30: 
			__EXIT;
			return 10;
			break;
		default: __CASECHK;
	}
	__RETCHK;
}

static void CPfrontCPV_Len (DevCPT_Node n, INTEGER dim, BOOLEAN incl0x)
{
	INTEGER d;
	DevCPT_Struct array = NIL;
	__ENTER("CPfrontCPV.Len");
	while ((INTEGER)n->class == 4) {
		dim += 1;
		n = n->left;
	}
	while ((INTEGER)n->class == 11 && (INTEGER)n->subcl == 29) {
		n = n->left;
	}
	if ((INTEGER)n->typ->form == 10) {
		CPfrontCPG_WriteString((SHORTCHAR*)"__STRLENS(", 11);
		CPfrontCPV_expr(n, -1);
		CPfrontCPG_Write((SHORTCHAR)')');
		if (incl0x) {
			CPfrontCPG_WriteString((SHORTCHAR*)" + 1", 5);
		}
	} else if ((INTEGER)n->typ->form == 17) {
		CPfrontCPG_WriteString((SHORTCHAR*)"__STRLEN(", 10);
		CPfrontCPV_expr(n, -1);
		CPfrontCPG_Write((SHORTCHAR)')');
		if (incl0x) {
			CPfrontCPG_WriteString((SHORTCHAR*)" + 1", 5);
		}
	} else if ((INTEGER)n->class == 3 && (INTEGER)n->typ->comp == 3) {
		d = dim;
		array = n->typ;
		while (d > 0) {
			array = array->BaseTyp;
			d -= 1;
		}
		if ((INTEGER)array->comp == 3) {
			CPfrontCPV_expr(n->left, 10);
			CPfrontCPG_WriteString((SHORTCHAR*)"->len[", 7);
			CPfrontCPG_WriteInt(dim);
			CPfrontCPG_Write((SHORTCHAR)']');
		} else {
			CPfrontCPG_WriteInt(array->n);
		}
	} else {
		CPfrontCPC_Len(n->obj, n->typ, dim);
	}
	__EXIT;
}

static BOOLEAN CPfrontCPV_SameExp (DevCPT_Node n1, DevCPT_Node n2)
{
	__ENTER("CPfrontCPV.SameExp");
	while ((INTEGER)n1->class == (INTEGER)n2->class && n1->typ == n2->typ) {
		switch (n1->class) {
			case 0: case 1: case 9: 
				__EXIT;
				return n1->obj == n2->obj;
				break;
			case 7: 
				__EXIT;
				return __IN(n1->typ->form, 0x70) && n1->conval->intval == n2->conval->intval;
				break;
			case 2: 
				if (n1->obj != n2->obj) {
					__EXIT;
					return 0;
				}
				break;
			case 3: case 5: 
				break;
			case 4: 
				if (!CPfrontCPV_SameExp(n1->right, n2->right)) {
					__EXIT;
					return 0;
				}
				break;
			case 11: 
				if ((INTEGER)n1->subcl != (INTEGER)n2->subcl || (INTEGER)n1->subcl == 16) {
					__EXIT;
					return 0;
				}
				break;
			case 12: 
				if ((INTEGER)n1->subcl != (INTEGER)n2->subcl || !CPfrontCPV_SameExp(n1->right, n2->right)) {
					__EXIT;
					return 0;
				}
				break;
			default: 
				__EXIT;
				return 0;
				break;
		}
		n1 = n1->left;
		n2 = n2->left;
	}
	__EXIT;
	return 0;
}

static BOOLEAN CPfrontCPV_SideEffects (DevCPT_Node n)
{
	__ENTER("CPfrontCPV.SideEffects");
	if (n != NIL) {
		__EXIT;
		return ((INTEGER)n->class == 13 || CPfrontCPV_SideEffects(n->left)) || CPfrontCPV_SideEffects(n->right);
	} else {
		__EXIT;
		return 0;
	}
	__RETCHK;
}

static void CPfrontCPV_Entier (DevCPT_Node n, SHORTINT prec)
{
	__ENTER("CPfrontCPV.Entier");
	if (__IN(n->typ->form, 0x0180)) {
		CPfrontCPG_WriteString((SHORTCHAR*)"__ENTIER(", 10);
		CPfrontCPV_expr(n, -1);
		CPfrontCPG_Write((SHORTCHAR)')');
	} else {
		CPfrontCPV_expr(n, prec);
	}
	__EXIT;
}

static void CPfrontCPV_LEntier (DevCPT_Node n, SHORTINT prec)
{
	__ENTER("CPfrontCPV.LEntier");
	if (__IN(n->typ->form, 0x0180)) {
		CPfrontCPG_WriteString((SHORTCHAR*)"__ENTIERL(", 11);
		CPfrontCPV_expr(n, -1);
		CPfrontCPG_Write((SHORTCHAR)')');
	} else {
		CPfrontCPV_expr(n, prec);
	}
	__EXIT;
}

static void CPfrontCPV_Convert (DevCPT_Node n, SHORTINT form, SHORTINT prec)
{
	__ENTER("CPfrontCPV.Convert");
	switch (form) {
		case 4: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(BYTE)", 7);
			CPfrontCPV_Entier(n, 9);
			break;
		case 5: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(SHORTINT)", 11);
			CPfrontCPV_Entier(n, 9);
			break;
		case 6: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(INTEGER)", 10);
			CPfrontCPV_Entier(n, 9);
			break;
		case 18: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(LONGINT)", 10);
			CPfrontCPV_LEntier(n, 9);
			break;
		case 3: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(SHORTCHAR)", 12);
			CPfrontCPV_Entier(n, 9);
			break;
		case 16: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(CHAR)", 7);
			CPfrontCPV_Entier(n, 9);
			break;
		case 9: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(SET)", 6);
			CPfrontCPV_Entier(n, 9);
			break;
		case 7: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(SHORTREAL)", 12);
			CPfrontCPV_expr(n, prec);
			break;
		case 8: 
			CPfrontCPG_WriteString((SHORTCHAR*)"(REAL)", 7);
			CPfrontCPV_expr(n, prec);
			break;
		default: 
			CPfrontCPV_expr(n, prec);
			break;
	}
	__EXIT;
}

static void CPfrontCPV_TypeOf (DevCPT_Node n)
{
	__ENTER("CPfrontCPV.TypeOf");
	if ((INTEGER)n->class == 8) {
		CPfrontCPC_Andent(n->typ);
		CPfrontCPG_WriteString((SHORTCHAR*)"__typ", 6);
	} else if ((INTEGER)n->typ->form == 13) {
		CPfrontCPG_WriteString((SHORTCHAR*)"__TYPEOF(", 10);
		CPfrontCPV_expr(n, -1);
		CPfrontCPG_Write((SHORTCHAR)')');
	} else if (__IN(n->class, 0x15)) {
		CPfrontCPC_Andent(n->typ);
		CPfrontCPG_WriteString((SHORTCHAR*)"__typ", 6);
	} else if ((INTEGER)n->class == 3) {
		CPfrontCPG_WriteString((SHORTCHAR*)"__TYPEOF(", 10);
		CPfrontCPV_expr(n->left, -1);
		CPfrontCPG_Write((SHORTCHAR)')');
	} else if ((INTEGER)n->class == 5) {
		CPfrontCPV_TypeOf(n->left);
	} else if ((INTEGER)n->class == 11 && (INTEGER)n->subcl == 29) {
		CPfrontCPC_TypeOf(n->left->obj);
	} else {
		CPfrontCPC_TypeOf(n->obj);
	}
	__EXIT;
}

static void CPfrontCPV_Index (DevCPT_Node n, DevCPT_Node d, SHORTINT prec, SHORTINT dim)
{
	__ENTER("CPfrontCPV.Index");
	if ((!CPfrontCPV_inxchk || (INTEGER)n->right->class == 7 && (n->right->conval->intval == 0 || (INTEGER)n->left->typ->comp \
!= 3)) || (INTEGER)n->left->typ->comp == 3 && n->left->typ->untagged) {
		CPfrontCPV_expr(n->right, prec);
	} else {
		if (CPfrontCPV_SideEffects(n->right)) {
			CPfrontCPG_WriteString((SHORTCHAR*)"__XF(", 6);
		} else {
			CPfrontCPG_WriteString((SHORTCHAR*)"__X(", 5);
		}
		CPfrontCPV_expr(n->right, -1);
		CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
		CPfrontCPV_Len(d, dim, 0);
		CPfrontCPG_Write((SHORTCHAR)')');
	}
	__EXIT;
}

static void CPfrontCPV_Adr (DevCPT_Node n, SHORTINT prec, BOOLEAN cast_adr)
{
	__ENTER("CPfrontCPV.Adr");
	if (__IN(n->typ->form, 0x020400)) {
		CPfrontCPV_expr(n, prec);
	} else if (((INTEGER)n->class == 3 && (INTEGER)n->subcl == 0) && !__IN(n->typ->comp, 0x0c)) {
		CPfrontCPV_expr(n->left, prec);
	} else if ((INTEGER)n->class == 1 && !__IN(n->typ->comp, 0x0c)) {
		CPfrontCPC_CompleteIdent(n->obj);
	} else if (cast_adr) {
		CPfrontCPV_design_adr(n, prec, 1);
	} else {
		CPfrontCPG_Write((SHORTCHAR)'&');
		CPfrontCPV_expr(n, prec);
	}
	__EXIT;
}

static void CPfrontCPV_design_adr (DevCPT_Node n, SHORTINT prec, BOOLEAN adr)
{
	DevCPT_Object obj = NIL;
	DevCPT_Struct typ = NIL;
	SHORTINT class, designPrec, comp;
	DevCPT_Node d = NIL;
	DevCPT_Node x = NIL;
	SHORTINT dims, i, _for__38;
	DevCPT_String _ptr__37 = NIL;
	__ENTER("CPfrontCPV.design_adr");
	comp = n->typ->comp;
	obj = n->obj;
	class = n->class;
	if (adr && (INTEGER)class != 0) {
		CPfrontCPG_Write((SHORTCHAR)'&');
	}
	designPrec = CPfrontCPV_Precedence(class, n->subcl, n->typ->form, comp);
	if ((((INTEGER)class == 0 && (INTEGER)obj->mnolev > 0) && (INTEGER)obj->mnolev != CPfrontCPG_level) && \
(INTEGER)prec == 10) {
		designPrec = 9;
	}
	if ((INTEGER)prec > (INTEGER)designPrec) {
		CPfrontCPG_Write((SHORTCHAR)'(');
	}
	if ((INTEGER)prec == 11) {
		CPfrontCPG_Write((SHORTCHAR)'*');
	}
	switch (class) {
		case 9: 
			CPfrontCPC_Ident(n->obj);
			break;
		case 0: 
			if (adr) {
				CPfrontCPC_CompleteIdentAdr(n->obj);
			} else {
				CPfrontCPC_CompleteIdent(n->obj);
			}
			break;
		case 1: 
			if (!__IN(comp, 0x0c)) {
				CPfrontCPG_Write((SHORTCHAR)'*');
			}
			CPfrontCPC_CompleteIdent(n->obj);
			break;
		case 2: 
			if ((INTEGER)n->left->class == 3) {
				CPfrontCPV_expr(n->left->left, designPrec);
				CPfrontCPG_WriteString((SHORTCHAR*)"->", 3);
			} else {
				CPfrontCPV_design(n->left, designPrec);
				CPfrontCPG_Write((SHORTCHAR)'.');
			}
			CPfrontCPC_Ident(n->obj);
			break;
		case 3: 
			if ((INTEGER)n->subcl != 0) {
				CPfrontCPV_expr(n->left, designPrec);
			} else {
				if (__IN(n->typ->comp, 0x0c)) {
					if (n->typ->untagged) {
						CPfrontCPV_expr(n->left, designPrec);
					} else {
						CPfrontCPV_expr(n->left, 10);
						CPfrontCPG_WriteString((SHORTCHAR*)"->data", 7);
					}
				} else {
					CPfrontCPG_Write((SHORTCHAR)'*');
					CPfrontCPV_expr(n->left, designPrec);
				}
			}
			break;
		case 4: 
			d = n->left;
			if ((INTEGER)d->typ->comp == 3) {
				dims = 0;
				while ((INTEGER)d->class == 4) {
					d = d->left;
					dims += 1;
				}
				if ((INTEGER)n->typ->comp == 3) {
					CPfrontCPV_Adr(d, designPrec, 0);
				} else {
					CPfrontCPV_design(d, designPrec);
				}
				CPfrontCPG_Write((SHORTCHAR)'[');
				if ((INTEGER)n->typ->comp == 3) {
					CPfrontCPG_Write((SHORTCHAR)'(');
				}
				i = dims;
				x = n;
				while (x != d) {
					if (x->left != d) {
						CPfrontCPV_Index(x, d, 7, i);
						CPfrontCPG_WriteString((SHORTCHAR*)" + ", 4);
						CPfrontCPV_Len(d, i, 0);
						CPfrontCPG_WriteString((SHORTCHAR*)" * (", 5);
						i -= 1;
					} else {
						CPfrontCPV_Index(x, d, -1, i);
					}
					x = x->left;
				}
				_for__38 = dims;
				i = 1;
				while ((INTEGER)i <= (INTEGER)_for__38) {
					CPfrontCPG_Write((SHORTCHAR)')');
					i += 1;
				}
				if ((INTEGER)n->typ->comp == 3) {
					CPfrontCPG_Write((SHORTCHAR)')');
					while ((INTEGER)i <= d->typ->n) {
						CPfrontCPG_WriteString((SHORTCHAR*)" * ", 4);
						CPfrontCPV_Len(d, i, 0);
						i += 1;
					}
				}
				CPfrontCPG_Write((SHORTCHAR)']');
			} else {
				CPfrontCPV_design(n->left, designPrec);
				CPfrontCPG_Write((SHORTCHAR)'[');
				CPfrontCPV_Index(n, n->left, -1, 0);
				CPfrontCPG_Write((SHORTCHAR)']');
			}
			break;
		case 5: 
			typ = n->typ;
			obj = n->left->obj;
			if (__IN(3, CPfrontCPG_opt)) {
				if ((INTEGER)typ->comp == 4) {
					CPfrontCPG_WriteString((SHORTCHAR*)"__GUARDR(", 10);
					if ((INTEGER)obj->mnolev != CPfrontCPG_level) {
						_ptr__37 = obj->scope->name;
						CPfrontCPG_WriteString(_ptr__37->data, _ptr__37->len[0]);
						CPfrontCPG_WriteString((SHORTCHAR*)"__curr->", 9);
						CPfrontCPC_Ident(obj);
					} else {
						CPfrontCPC_Ident(obj);
					}
				} else {
					if (typ->BaseTyp->strobj == NIL) {
						CPfrontCPG_WriteString((SHORTCHAR*)"__GUARDA(", 10);
					} else {
						CPfrontCPG_WriteString((SHORTCHAR*)"__GUARDP(", 10);
					}
					CPfrontCPV_expr(n->left, -1);
					typ = typ->BaseTyp;
				}
				CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
				CPfrontCPC_Andent(typ);
				CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
				CPfrontCPG_WriteInt(typ->extlev);
				CPfrontCPG_Write((SHORTCHAR)')');
			} else {
				if ((INTEGER)typ->comp == 4) {
					CPfrontCPG_WriteString((SHORTCHAR*)"*(", 3);
					CPfrontCPC_Ident(typ->strobj);
					CPfrontCPG_WriteString((SHORTCHAR*)"*)", 3);
					CPfrontCPC_CompleteIdent(obj);
				} else {
					CPfrontCPG_Write((SHORTCHAR)'(');
					CPfrontCPC_Ident(typ->strobj);
					CPfrontCPG_Write((SHORTCHAR)')');
					CPfrontCPV_expr(n->left, designPrec);
				}
			}
			break;
		case 6: 
			__HALT(100);
			if (__IN(3, CPfrontCPG_opt)) {
				if ((INTEGER)n->left->class == 1) {
					CPfrontCPG_WriteString((SHORTCHAR*)"__GUARDEQR(", 12);
					CPfrontCPC_CompleteIdent(n->left->obj);
					CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
					CPfrontCPV_TypeOf(n->left);
				} else {
					CPfrontCPG_WriteString((SHORTCHAR*)"__GUARDEQP(", 12);
					CPfrontCPV_expr(n->left->left, -1);
				}
				CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
				CPfrontCPC_Ident(n->left->typ->strobj);
				CPfrontCPG_Write((SHORTCHAR)')');
			} else {
				CPfrontCPV_expr(n->left, -1);
			}
			break;
		case 11: 
			if ((INTEGER)n->subcl == 29) {
				CPfrontCPV_design(n->left, prec);
			}
			break;
		default: __CASECHK;
	}
	if ((INTEGER)prec > (INTEGER)designPrec) {
		CPfrontCPG_Write((SHORTCHAR)')');
	}
	__EXIT;
}

static void CPfrontCPV_design (DevCPT_Node n, SHORTINT prec)
{
	__ENTER("CPfrontCPV.design");
	CPfrontCPV_design_adr(n, prec, 0);
	__EXIT;
}

static void CPfrontCPV_ActualPar (DevCPT_Node n, DevCPT_Object fp)
{
	DevCPT_Struct typ = NIL;
	DevCPT_Struct aptyp = NIL;
	SHORTINT comp, form, mode, prec, dim;
	BOOLEAN useAdr;
	DevCPT_Node n1 = NIL;
	__ENTER("CPfrontCPV.ActualPar");
	CPfrontCPG_Write((SHORTCHAR)'(');
	while (n != NIL) {
		typ = fp->typ;
		comp = typ->comp;
		form = typ->form;
		mode = fp->mode;
		prec = -1;
		if ((INTEGER)mode == 2 && n->typ == DevCPT_niltyp) {
			CPfrontCPG_Write((SHORTCHAR)'0');
		} else if ((INTEGER)mode == 2 && ((INTEGER)n->subcl == 46 || (INTEGER)n->subcl == 45)) {
			CPfrontCPG_WriteString((SHORTCHAR*)"(void*)", 8);
			CPfrontCPV_expr(n->left, -1);
			CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
			if ((INTEGER)n->subcl == 45) {
				CPfrontCPG_WriteString((SHORTCHAR*)"(SYSTEM_TYPEDESC*)", 19);
			}
			CPfrontCPV_expr(n->right, -1);
		} else {
			useAdr = 0;
			if (((INTEGER)mode == 2 && (INTEGER)n->class == 11) && (INTEGER)n->subcl == 29) {
				CPfrontCPG_Write((SHORTCHAR)'(');
				CPfrontCPC_Ident(n->typ->strobj);
				CPfrontCPG_WriteString((SHORTCHAR*)"*)", 3);
				prec = 10;
			}
			if (!__IN(n->typ->comp, 0x0c)) {
				if ((INTEGER)mode == 2) {
					if (CPfrontCPV_ansi && typ != n->typ) {
						CPfrontCPG_WriteString((SHORTCHAR*)"(void*)", 8);
					}
					useAdr = 1;
					prec = 9;
				} else if (CPfrontCPV_ansi) {
					if (__IN(comp, 0x0c) && (INTEGER)n->class == 7) {
						if ((INTEGER)n->typ->form == 10) {
							CPfrontCPG_WriteString((SHORTCHAR*)"(SHORTCHAR*)", 13);
						} else {
							CPfrontCPG_WriteString((SHORTCHAR*)"(CHAR*)", 8);
						}
					} else if (((INTEGER)form == 13 && typ != n->typ) && n->typ != DevCPT_niltyp) {
						CPfrontCPG_WriteString((SHORTCHAR*)"(void*)", 8);
					}
				} else {
					if (__IN(form, 0x0180) && __IN(n->typ->form, 0x70)) {
						CPfrontCPG_WriteString((SHORTCHAR*)"(REAL)", 7);
						prec = 9;
					} else if ((INTEGER)form == 6 && (INTEGER)n->typ->form < 6) {
						CPfrontCPG_WriteString((SHORTCHAR*)"(INTEGER)", 10);
						prec = 9;
					}
				}
			} else if (CPfrontCPV_ansi) {
				if (((INTEGER)mode == 2 && typ != n->typ) && (INTEGER)prec == -1) {
					CPfrontCPG_WriteString((SHORTCHAR*)"(void*)", 8);
				}
			}
			n1 = n;
			if (((INTEGER)mode == 2 && (INTEGER)n->class == 11) && (INTEGER)n->subcl == 29) {
				n1 = n->left;
			}
			if (useAdr) {
				CPfrontCPV_Adr(n1, prec, 1);
			} else {
				CPfrontCPV_expr(n1, prec);
			}
			if ((((INTEGER)form == 18 && (INTEGER)n->class == 7) && n->conval->intval <= 2147483647) && n->conval->intval \
>= (-2147483647-1)) {
				CPfrontCPG_Write((SHORTCHAR)'L');
			} else if ((INTEGER)comp == 4 && (INTEGER)mode == 2) {
				if (!typ->untagged) {
					CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
					CPfrontCPV_TypeOf(n);
				}
			} else if ((INTEGER)comp == 3 && !typ->untagged) {
				if (n->typ->untagged && (INTEGER)n->typ->comp != 2) {
					DevCPM_err(137);
				}
				if ((INTEGER)n->class == 7) {
					CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
					CPfrontCPG_WriteInt(n->conval->intval2);
				} else {
					aptyp = n->typ;
					dim = 0;
					while ((INTEGER)typ->comp == 3 && (INTEGER)typ->BaseTyp->form != 1) {
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPV_Len(n, dim, 1);
						typ = typ->BaseTyp;
						aptyp = aptyp->BaseTyp;
						dim += 1;
					}
				}
			}
		}
		n = n->link;
		fp = fp->link;
		if (n != NIL) {
			CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
		}
	}
	CPfrontCPG_Write((SHORTCHAR)')');
	__EXIT;
}

static DevCPT_Object CPfrontCPV_SuperProc (DevCPT_Node n)
{
	DevCPT_Object obj = NIL;
	DevCPT_Struct typ = NIL;
	DevCPT_String _ptr__29 = NIL;
	__ENTER("CPfrontCPV.SuperProc");
	typ = n->right->typ;
	if ((INTEGER)typ->form == 13) {
		typ = typ->BaseTyp;
	}
	_ptr__29 = n->left->obj->name;
	DevCPT_FindField((void*)_ptr__29->data, _ptr__29->len[0], typ->BaseTyp, &obj);
	__EXIT;
	return obj;
}

static void CPfrontCPV_StringModifier (DevCPT_Node n)
{
	BOOLEAN trunc;
	__ENTER("CPfrontCPV.StringModifier");
	trunc = 0;
	while ((INTEGER)n->class == 11 && (INTEGER)n->subcl == 20) {
		if ((INTEGER)n->typ->form == 10) {
			trunc = 1;
		}
		n = n->left;
	}
	if ((INTEGER)n->typ->form == 10 || (INTEGER)n->typ->form == 15 && (INTEGER)n->typ->BaseTyp->form == 3) \
{
		CPfrontCPG_Write((SHORTCHAR)'S');
	} else if (trunc) {
		CPfrontCPG_Write((SHORTCHAR)'T');
	} else {
		CPfrontCPG_Write((SHORTCHAR)'L');
	}
	__EXIT;
}

static void CPfrontCPV_expr_val (DevCPT_Node n, SHORTINT prec, BOOLEAN lvalue)
{
	SHORTINT class, subclass, form, exprPrec;
	DevCPT_Struct typ = NIL;
	DevCPT_Node l = NIL;
	DevCPT_Node r = NIL;
	DevCPT_Object proc = NIL;
	__ENTER("CPfrontCPV.expr_val");
	class = n->class;
	subclass = n->subcl;
	form = n->typ->form;
	l = n->left;
	r = n->right;
	exprPrec = CPfrontCPV_Precedence(class, subclass, form, n->typ->comp);
	if ((INTEGER)exprPrec <= (INTEGER)prec && __IN(class, 0x3ce0)) {
		CPfrontCPG_Write((SHORTCHAR)'(');
	}
	switch (class) {
		case 7: 
			CPfrontCPC_Constant(n->conval, form);
			break;
		case 10: 
			CPfrontCPG_WriteString((SHORTCHAR*)"__SETRNG(", 10);
			CPfrontCPV_expr(l, -1);
			CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
			CPfrontCPV_expr(r, -1);
			CPfrontCPG_Write((SHORTCHAR)')');
			break;
		case 11: 
			switch (subclass) {
				case 33: 
					CPfrontCPG_Write((SHORTCHAR)'!');
					CPfrontCPV_expr(l, exprPrec);
					break;
				case 7: 
					if ((INTEGER)form == 9) {
						CPfrontCPG_Write((SHORTCHAR)'~');
					} else {
						CPfrontCPG_Write((SHORTCHAR)'-');
					}
					CPfrontCPV_expr(l, exprPrec);
					break;
				case 16: 
					typ = n->obj->typ;
					if ((INTEGER)l->typ->comp == 4) {
						CPfrontCPG_WriteString((SHORTCHAR*)"__IS(", 6);
						CPfrontCPC_TypeOf(l->obj);
					} else {
						CPfrontCPG_WriteString((SHORTCHAR*)"__ISP(", 7);
						CPfrontCPV_expr(l, -1);
						typ = typ->BaseTyp;
					}
					CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
					CPfrontCPC_Andent(typ);
					CPfrontCPG_WriteString((SHORTCHAR*)"__typ, ", 8);
					CPfrontCPG_WriteInt(typ->extlev);
					CPfrontCPG_Write((SHORTCHAR)')');
					break;
				case 20: 
					if (__IN(form, 0x020400)) {
						CPfrontCPV_expr(l, exprPrec);
					} else {
						CPfrontCPV_Convert(l, form, exprPrec);
					}
					break;
				case 26: 
					CPfrontCPG_WriteString((SHORTCHAR*)"__SETOF(", 9);
					CPfrontCPV_Entier(l, -1);
					CPfrontCPG_Write((SHORTCHAR)')');
					break;
				case 21: 
					if (CPfrontCPV_SideEffects(l)) {
						if ((INTEGER)l->typ->form == 8) {
							CPfrontCPG_WriteString((SHORTCHAR*)"__ABSFD(", 9);
						} else if ((INTEGER)l->typ->form == 7) {
							CPfrontCPG_WriteString((SHORTCHAR*)"__ABSFF(", 9);
						} else if ((INTEGER)l->typ->form == 18) {
							CPfrontCPG_WriteString((SHORTCHAR*)"__ABSL(", 8);
						} else {
							CPfrontCPG_WriteString((SHORTCHAR*)"__ABSF(", 8);
						}
					} else {
						CPfrontCPG_WriteString((SHORTCHAR*)"__ABS(", 7);
					}
					CPfrontCPV_expr(l, -1);
					CPfrontCPG_Write((SHORTCHAR)')');
					break;
				case 22: 
					CPfrontCPG_WriteString((SHORTCHAR*)"__CAP(", 7);
					CPfrontCPV_expr(l, -1);
					CPfrontCPG_Write((SHORTCHAR)')');
					break;
				case 23: 
					CPfrontCPG_WriteString((SHORTCHAR*)"__ODD(", 7);
					CPfrontCPV_expr(l, -1);
					CPfrontCPG_Write((SHORTCHAR)')');
					break;
				case 37: 
					if ((INTEGER)l->class != 8) {
						DevCPM_err(110);
					}
					CPfrontCPG_WriteString((SHORTCHAR*)"sizeof(", 8);
					CPfrontCPC_Andent(l->typ);
					CPfrontCPG_Write((SHORTCHAR)')');
					break;
				case 36: 
					CPfrontCPG_WriteString((SHORTCHAR*)"(INTEGER)", 10);
					CPfrontCPV_TypeOf(l);
					break;
				case 24: 
					CPfrontCPG_WriteString((SHORTCHAR*)"(INTEGER)", 10);
					if ((INTEGER)l->class == 8) {
						CPfrontCPV_TypeOf(l);
					} else if ((INTEGER)l->class == 1) {
						CPfrontCPC_CompleteIdent(l->obj);
					} else {
						if (!__IN(l->typ->form, 0x020400) && !__IN(l->typ->comp, 0x0c)) {
							CPfrontCPV_Adr(l, exprPrec, 1);
						} else {
							CPfrontCPV_expr(l, exprPrec);
						}
					}
					break;
				case 29: 
					if ((!lvalue && !__IN(n->typ->form, 0x8180)) && !__IN(l->typ->form, 0x8180)) {
						CPfrontCPG_Write((SHORTCHAR)'(');
						CPfrontCPC_Ident(n->typ->strobj);
						CPfrontCPG_Write((SHORTCHAR)')');
						CPfrontCPV_expr(l, exprPrec);
					} else if (__IN(l->class, 0x17)) {
						CPfrontCPG_WriteString((SHORTCHAR*)"__VAL(", 7);
						CPfrontCPC_Ident(n->typ->strobj);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPV_expr(l, -1);
						CPfrontCPG_Write((SHORTCHAR)')');
					} else {
						if ((INTEGER)n->typ->form == 7) {
							CPfrontCPG_WriteString((SHORTCHAR*)"__VALSR((INTEGER)", 18);
						} else if ((INTEGER)n->typ->form == 8) {
							CPfrontCPG_WriteString((SHORTCHAR*)"__VALR((LONGINT)", 17);
						} else {
							CPfrontCPG_Write((SHORTCHAR)'(');
							CPfrontCPC_Ident(n->typ->strobj);
							CPfrontCPG_Write((SHORTCHAR)')');
						}
						if ((INTEGER)l->typ->form == 7) {
							CPfrontCPG_WriteString((SHORTCHAR*)"__VALI(", 8);
							CPfrontCPV_expr(l, -1);
							CPfrontCPG_Write((SHORTCHAR)')');
						} else if ((INTEGER)l->typ->form == 8) {
							CPfrontCPG_WriteString((SHORTCHAR*)"__VALL(", 8);
							CPfrontCPV_expr(l, -1);
							CPfrontCPG_Write((SHORTCHAR)')');
						} else {
							CPfrontCPV_expr(l, exprPrec);
						}
						if (__IN(n->typ->form, 0x0180)) {
							CPfrontCPG_Write((SHORTCHAR)')');
						}
					}
					break;
				default: 
					DevCPM_err(217);
					break;
			}
			break;
		case 12: 
			switch (subclass) {
				case 19: 
					CPfrontCPV_Len(l, r->conval->intval, 0);
					break;
				case 3: case 4: case 15: case 17: case 18: 
				case 26: case 27: case 28: case 34: case 35: 
					switch (subclass) {
						case 15: 
							CPfrontCPG_WriteString((SHORTCHAR*)"__IN(", 6);
							break;
						case 17: 
							if ((INTEGER)r->class == 7) {
								if (r->conval->intval >= 0) {
									CPfrontCPG_WriteString((SHORTCHAR*)"__ASHL(", 8);
								} else {
									CPfrontCPG_WriteString((SHORTCHAR*)"__ASHR(", 8);
								}
							} else if (!CPfrontCPV_SideEffects(r)) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__ASH(", 7);
							} else if ((INTEGER)form == 18) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__ASHFL(", 9);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)"__ASHF(", 8);
							}
							break;
						case 18: 
							CPfrontCPG_WriteString((SHORTCHAR*)"__MASK(", 8);
							break;
						case 26: 
							CPfrontCPG_WriteString((SHORTCHAR*)"__BIT(", 7);
							break;
						case 27: 
							if ((INTEGER)r->class == 7) {
								if (r->conval->intval >= 0) {
									CPfrontCPG_WriteString((SHORTCHAR*)"__LSHL(", 8);
								} else {
									CPfrontCPG_WriteString((SHORTCHAR*)"__LSHR(", 8);
								}
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)"__LSH(", 7);
							}
							break;
						case 28: 
							if ((INTEGER)r->class == 7) {
								if (r->conval->intval >= 0) {
									CPfrontCPG_WriteString((SHORTCHAR*)"__ROTL(", 8);
								} else {
									CPfrontCPG_WriteString((SHORTCHAR*)"__ROTR(", 8);
								}
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)"__ROT(", 7);
							}
							break;
						case 3: 
							if ((!CPfrontCPV_SideEffects(n) && (INTEGER)r->class == 7) && r->conval->intval > 0) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__DIV(", 7);
							} else if ((INTEGER)form == 18) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__DIVFL(", 9);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)"__DIVF(", 8);
							}
							break;
						case 4: 
							if ((!CPfrontCPV_SideEffects(n) && (INTEGER)r->class == 7) && r->conval->intval > 0) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MOD(", 7);
							} else if ((INTEGER)form == 18) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MODFL(", 9);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MODF(", 8);
							}
							break;
						case 34: 
							if (!CPfrontCPV_SideEffects(n)) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MIN(", 7);
							} else if ((INTEGER)form == 7) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MINFF(", 9);
							} else if ((INTEGER)form == 8) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MINFD(", 9);
							} else if ((INTEGER)form == 18) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MINFL(", 9);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MINF(", 8);
							}
							break;
						case 35: 
							if (!CPfrontCPV_SideEffects(n)) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MAX(", 7);
							} else if ((INTEGER)form == 7) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MAXFF(", 9);
							} else if ((INTEGER)form == 8) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MAXFD(", 9);
							} else if ((INTEGER)form == 18) {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MAXFL(", 9);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MAXF(", 8);
							}
							break;
						default: __CASECHK;
					}
					CPfrontCPV_expr(l, -1);
					CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
					if ((__IN(subclass, 0x18020000) && (INTEGER)r->class == 7) && r->conval->intval < 0) {
						CPfrontCPG_WriteInt(-r->conval->intval);
					} else {
						CPfrontCPV_expr(r, -1);
					}
					if (__IN(subclass, 0x18020000)) {
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPC_Ident(l->typ->strobj);
					}
					CPfrontCPG_Write((SHORTCHAR)')');
					break;
				case 9: case 10: case 11: case 12: case 13: 
				case 14: 
					if (__IN(l->typ->form, 0x028400)) {
						CPfrontCPG_WriteString((SHORTCHAR*)"__STRCMP", 9);
						if ((INTEGER)r->class == 11 && (INTEGER)r->subcl == 20) {
							CPfrontCPV_StringModifier(r);
							CPfrontCPV_StringModifier(l);
							CPfrontCPG_Write((SHORTCHAR)'(');
							CPfrontCPV_expr(r, -1);
							CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
							CPfrontCPV_expr(l, -1);
							if ((INTEGER)subclass >= 11) {
								subclass = (SHORTINT)(__MASK((INTEGER)subclass - 13, -4) + 11);
							}
						} else {
							CPfrontCPV_StringModifier(l);
							CPfrontCPV_StringModifier(r);
							CPfrontCPG_Write((SHORTCHAR)'(');
							CPfrontCPV_expr(l, -1);
							CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
							CPfrontCPV_expr(r, -1);
						}
						CPfrontCPG_Write((SHORTCHAR)')');
						CPfrontCPC_Cmp(subclass);
						CPfrontCPG_Write((SHORTCHAR)'0');
					} else {
						CPfrontCPV_expr(l, exprPrec);
						CPfrontCPC_Cmp(subclass);
						typ = l->typ;
						if ((((INTEGER)typ->form == 13 && (INTEGER)r->typ->form != 11) && r->typ != typ) && r->typ != DevCPT_sysptrtyp) \
{
							CPfrontCPG_WriteString((SHORTCHAR*)"(void *) ", 10);
						}
						CPfrontCPV_expr(r, exprPrec);
					}
					break;
				default: 
					CPfrontCPV_expr(l, exprPrec);
					switch (subclass) {
						case 1: 
							if ((INTEGER)form == 9) {
								CPfrontCPG_WriteString((SHORTCHAR*)" & ", 4);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)" * ", 4);
							}
							break;
						case 2: 
							if ((INTEGER)form == 9) {
								CPfrontCPG_WriteOrigString((SHORTCHAR*)" ^ ", 4);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)" / ", 4);
								if (r->obj == NIL || __IN(r->obj->typ->form, 0x70)) {
									CPfrontCPG_Write((SHORTCHAR)'(');
									CPfrontCPC_Ident(n->typ->strobj);
									CPfrontCPG_Write((SHORTCHAR)')');
								}
							}
							break;
						case 5: 
							CPfrontCPG_WriteString((SHORTCHAR*)" && ", 5);
							break;
						case 6: 
							if (__IN(form, 0x020400)) {
								DevCPM_err(265);
							} else if ((INTEGER)form == 9) {
								CPfrontCPG_WriteString((SHORTCHAR*)" | ", 4);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)" + ", 4);
							}
							break;
						case 7: 
							if ((INTEGER)form == 9) {
								CPfrontCPG_WriteString((SHORTCHAR*)" & ~", 5);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)" - ", 4);
							}
							break;
						case 8: 
							CPfrontCPG_WriteString((SHORTCHAR*)" || ", 5);
							break;
						default: __CASECHK;
					}
					CPfrontCPV_expr(r, exprPrec);
					break;
			}
			break;
		case 13: 
			if (l->obj != NIL && (INTEGER)l->obj->mode == 13) {
				if ((INTEGER)l->subcl == 1) {
					proc = CPfrontCPV_SuperProc(n);
				} else {
					CPfrontCPG_WriteString((SHORTCHAR*)"__", 3);
					proc = CPfrontCPC_BaseTProc(l->obj);
				}
				CPfrontCPC_Ident(proc);
				n->obj = proc->link;
			} else if ((INTEGER)l->class == 9) {
				CPfrontCPV_design(l, 10);
			} else {
				CPfrontCPV_design(l, 11);
			}
			CPfrontCPV_ActualPar(r, n->obj);
			break;
		case 30: 
			CPfrontCPG_Write((SHORTCHAR)'(');
			CPfrontCPV_compStat(l, 1);
			CPfrontCPV_expr(r, -1);
			CPfrontCPG_Write((SHORTCHAR)')');
			break;
		default: 
			CPfrontCPV_design(n, prec);
			break;
	}
	if ((INTEGER)exprPrec <= (INTEGER)prec && __IN(class, 0x3ca0)) {
		CPfrontCPG_Write((SHORTCHAR)')');
	}
	__EXIT;
}

static void CPfrontCPV_expr (DevCPT_Node n, SHORTINT prec)
{
	__ENTER("CPfrontCPV.expr");
	CPfrontCPV_expr_val(n, prec, 0);
	__EXIT;
}

static void CPfrontCPV_IfStat (DevCPT_Node n, BOOLEAN withtrap, DevCPT_Object outerProc)
{
	DevCPT_Node if_ = NIL;
	DevCPT_Object obj = NIL;
	DevCPT_Struct typ = NIL;
	INTEGER adr;
	DevCPT_String _ptr__14 = NIL;
	__ENTER("CPfrontCPV.IfStat");
	if_ = n->left;
	while (if_ != NIL) {
		CPfrontCPG_WriteString((SHORTCHAR*)"if ", 4);
		CPfrontCPV_expr(if_->left, 12);
		CPfrontCPG_Write((SHORTCHAR)' ');
		CPfrontCPC_BegBlk();
		if ((INTEGER)n->class == 27 && if_->left->left != NIL) {
			obj = if_->left->left->obj;
			typ = obj->typ;
			adr = obj->adr;
			if ((INTEGER)typ->comp == 4) {
				CPfrontCPC_BegStat();
				CPfrontCPC_Ident(if_->left->obj);
				CPfrontCPG_WriteString((SHORTCHAR*)" *", 3);
				_ptr__14 = obj->name;
				CPfrontCPG_WriteString(_ptr__14->data, _ptr__14->len[0]);
				CPfrontCPG_WriteString((SHORTCHAR*)"__ = (void*)", 13);
				obj->adr = 0;
				CPfrontCPC_CompleteIdent(obj);
				CPfrontCPC_EndStat();
			}
			obj->adr = 1;
			obj->typ = if_->left->obj->typ;
			CPfrontCPV_stat(if_->right, outerProc);
			obj->typ = typ;
			obj->adr = adr;
		} else {
			CPfrontCPV_stat(if_->right, outerProc);
		}
		if_ = if_->link;
		if ((if_ != NIL || n->right != NIL) || withtrap) {
			CPfrontCPC_EndBlk0();
			CPfrontCPG_WriteString((SHORTCHAR*)" else ", 7);
		} else {
			CPfrontCPC_EndBlk();
		}
	}
	if (withtrap) {
		CPfrontCPG_WriteString((SHORTCHAR*)"__WITHCHK", 10);
		CPfrontCPC_EndStat();
	} else if (n->right != NIL) {
		CPfrontCPC_BegBlk();
		CPfrontCPV_stat(n->right, outerProc);
		CPfrontCPC_EndBlk();
	}
	__EXIT;
}

static void CPfrontCPV_CaseStat (DevCPT_Node n, DevCPT_Object outerProc)
{
	DevCPT_Node switchCase = NIL;
	DevCPT_Node label = NIL;
	INTEGER low, high;
	SHORTINT form, i;
	__ENTER("CPfrontCPV.CaseStat");
	CPfrontCPG_WriteString((SHORTCHAR*)"switch ", 8);
	CPfrontCPV_expr(n->left, 12);
	CPfrontCPG_Write((SHORTCHAR)' ');
	CPfrontCPC_BegBlk();
	form = n->left->typ->form;
	switchCase = n->right->left;
	while (switchCase != NIL) {
		label = switchCase->left;
		i = 0;
		while (label != NIL) {
			low = label->conval->intval;
			high = label->conval->intval2;
			while (low <= high) {
				if ((INTEGER)i == 0) {
					CPfrontCPC_BegStat();
				}
				CPfrontCPC_Case(low, form);
				low += 1;
				i += 1;
				if ((INTEGER)i == 5) {
					CPfrontCPG_WriteLn();
					i = 0;
				}
			}
			label = label->link;
		}
		if ((INTEGER)i > 0) {
			CPfrontCPG_WriteLn();
		}
		CPfrontCPC_Indent(1);
		CPfrontCPV_stat(switchCase->right, outerProc);
		CPfrontCPC_BegStat();
		CPfrontCPG_WriteString((SHORTCHAR*)"break", 6);
		CPfrontCPC_EndStat();
		CPfrontCPC_Indent(-1);
		switchCase = switchCase->link;
	}
	CPfrontCPC_BegStat();
	CPfrontCPG_WriteString((SHORTCHAR*)"default: ", 10);
	if (n->right->conval->setval != 0x0) {
		CPfrontCPC_Indent(1);
		CPfrontCPG_WriteLn();
		CPfrontCPV_stat(n->right->right, outerProc);
		CPfrontCPC_BegStat();
		CPfrontCPG_WriteString((SHORTCHAR*)"break", 6);
		CPfrontCPC_Indent(-1);
	} else {
		CPfrontCPG_WriteString((SHORTCHAR*)"__CASECHK", 10);
	}
	CPfrontCPC_EndStat();
	CPfrontCPC_EndBlk();
	__EXIT;
}

static BOOLEAN CPfrontCPV_ImplicitReturn (DevCPT_Node n)
{
	__ENTER("CPfrontCPV.ImplicitReturn");
	while (n != NIL && (INTEGER)n->class != 26) {
		n = n->link;
	}
	__EXIT;
	return n == NIL;
}

static void CPfrontCPV_NewArr (DevCPT_Node d, DevCPT_Node x)
{
	DevCPT_Struct typ = NIL;
	DevCPT_Struct base = NIL;
	INTEGER elem, n;
	__ENTER("CPfrontCPV.NewArr");
	typ = d->typ->BaseTyp;
	base = typ->BaseTyp;
	elem = 1;
	CPfrontCPV_design(d, -1);
	CPfrontCPG_WriteString((SHORTCHAR*)" = __NEWARR", 12);
	if ((INTEGER)typ->comp == 2) {
		CPfrontCPG_Write((SHORTCHAR)'0');
		elem = typ->n;
	} else if (__IN(base->comp, 0x0c)) {
		CPfrontCPG_WriteInt(typ->n + 1);
		while ((INTEGER)base->comp == 3) {
			base = base->BaseTyp;
		}
	}
	while ((INTEGER)base->comp == 2) {
		elem = elem * base->n;
		base = base->BaseTyp;
	}
	CPfrontCPG_Write((SHORTCHAR)'(');
	if ((INTEGER)base->comp == 4) {
		if (base->untagged) {
			DevCPM_err(138);
		}
		CPfrontCPG_WriteString((SHORTCHAR*)"(INTEGER)", 10);
		CPfrontCPC_Andent(base);
		CPfrontCPG_WriteString((SHORTCHAR*)"__typ", 6);
	} else {
		switch (base->form) {
			case 0: case 1: case 3: 
				n = 1;
				break;
			case 5: 
				n = 2;
				break;
			case 4: 
				n = 3;
				break;
			case 6: 
				n = 4;
				break;
			case 2: 
				n = 5;
				break;
			case 9: 
				n = 6;
				break;
			case 7: 
				n = 7;
				break;
			case 8: 
				n = 8;
				break;
			case 16: 
				n = 9;
				break;
			case 18: 
				n = 10;
				break;
			case 14: 
				n = 11;
				break;
			case 13: 
				if (base->untagged) {
					n = 12;
				} else {
					n = 0;
				}
				break;
			default: __CASECHK;
		}
		CPfrontCPG_WriteInt(n);
	}
	CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
	if ((INTEGER)typ->comp == 3) {
		if (base == typ->BaseTyp) {
			CPfrontCPV_expr(x, -1);
		} else {
			while (x != NIL) {
				CPfrontCPV_expr(x, -1);
				CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
				x = x->link;
			}
			CPfrontCPG_WriteInt(elem);
		}
	} else {
		CPfrontCPG_WriteInt(elem);
	}
	CPfrontCPG_Write((SHORTCHAR)')');
	__EXIT;
}

static void CPfrontCPV_DefineTDescs (DevCPT_Node n, BOOLEAN close)
{
	__ENTER("CPfrontCPV.DefineTDescs");
	while (n != NIL && (INTEGER)n->class == 14) {
		CPfrontCPC_TDescDecl(n->typ);
		n = n->link;
	}
	CPfrontCPC_ModDescDecl(close);
	__EXIT;
}

static void CPfrontCPV_AddCopy (DevCPT_Node left, DevCPT_Node right, BOOLEAN first)
{
	__ENTER("CPfrontCPV.AddCopy");
	if (first) {
		CPfrontCPG_WriteString((SHORTCHAR*)"__STRCOPY", 10);
	} else {
		CPfrontCPG_WriteString((SHORTCHAR*)"__STRAPND", 10);
	}
	CPfrontCPV_StringModifier(right);
	CPfrontCPV_StringModifier(left);
	CPfrontCPG_Write((SHORTCHAR)'(');
	CPfrontCPV_expr(right, -1);
	CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
	CPfrontCPV_expr(left, -1);
	CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
	if (left->typ->untagged) {
		CPfrontCPG_WriteString((SHORTCHAR*)"-1", 3);
	} else {
		CPfrontCPV_Len(left, 0, 0);
	}
	CPfrontCPG_Write((SHORTCHAR)')');
	__EXIT;
}

static void CPfrontCPV_StringCopy (DevCPT_Node left, DevCPT_Node right, BOOLEAN exp)
{
	__ENTER("CPfrontCPV.StringCopy");
	__ASSERT((INTEGER)right->class != 7, 0);
	if ((INTEGER)right->class == 12) {
		__ASSERT((INTEGER)right->subcl == 6, 0);
		if (!CPfrontCPV_SameExp(left, right->left)) {
			CPfrontCPV_AddCopy(left, right->left, 1);
			if (exp) {
				CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
			} else {
				CPfrontCPC_EndStat();
				CPfrontCPC_BegStat();
			}
		}
		right = right->right;
		while ((INTEGER)right->class == 12) {
			__ASSERT((INTEGER)right->subcl == 6, 0);
			CPfrontCPV_AddCopy(left, right->left, 0);
			if (exp) {
				CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
			} else {
				CPfrontCPC_EndStat();
				CPfrontCPC_BegStat();
			}
			right = right->right;
		}
		CPfrontCPV_AddCopy(left, right, 0);
	} else {
		CPfrontCPV_AddCopy(left, right, 1);
	}
	__EXIT;
}

static void CPfrontCPV_compStat (DevCPT_Node n, BOOLEAN exp)
{
	DevCPT_Node l = NIL;
	DevCPT_Node r = NIL;
	__ENTER("CPfrontCPV.compStat");
	while (n != NIL && DevCPM_noerr) {
		if (!exp) {
			CPfrontCPC_BegStat();
		}
		__ASSERT((INTEGER)n->class == 19, 0);
		l = n->left;
		r = n->right;
		if ((INTEGER)n->subcl == 0) {
			if (__IN(r->typ->form, 0x020400)) {
				if ((INTEGER)r->class != 7) {
					CPfrontCPV_StringCopy(l, r, exp);
				} else {
					CPfrontCPG_WriteString((SHORTCHAR*)"__MOVE(", 8);
					CPfrontCPV_expr(r, -1);
					CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
					CPfrontCPV_expr(l, -1);
					CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
					CPfrontCPG_WriteInt(r->conval->intval2 * r->typ->BaseTyp->size);
					CPfrontCPG_Write((SHORTCHAR)')');
				}
			} else {
				__ASSERT(__IN(l->typ->form, 0x012008), 0);
				CPfrontCPV_design(l, -1);
				CPfrontCPG_WriteString((SHORTCHAR*)" = ", 4);
				CPfrontCPV_expr(r, -1);
			}
		} else {
			__ASSERT((INTEGER)n->subcl == 1, 0);
			__ASSERT((INTEGER)l->typ->BaseTyp->comp == 3, 0);
			CPfrontCPV_NewArr(l, r);
		}
		if (exp) {
			CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
			CPfrontCPG_WriteLn();
			CPfrontCPC_BegStat();
			CPfrontCPG_Write(9);
		} else {
			CPfrontCPC_EndStat();
		}
		n = n->link;
	}
	__EXIT;
}

static void CPfrontCPV_stat (DevCPT_Node n, DevCPT_Object outerProc)
{
	DevCPT_Object proc = NIL;
	CPfrontCPV_ExitInfo saved;
	DevCPT_Node l = NIL;
	DevCPT_Node r = NIL;
	__ENTER("CPfrontCPV.stat");
	while (n != NIL && DevCPM_noerr) {
		DevCPM_errpos = n->conval->intval;
		if (!__IN(n->class, 0x40004000)) {
			CPfrontCPC_BegStat();
		}
		switch (n->class) {
			case 18: 
				if (n->obj == NIL) {
					__HALT(100);
				} else {
					proc = n->obj;
					CPfrontCPC_TypeDefs(proc->scope->right, 0);
					if (!proc->scope->leaf) {
						CPfrontCPC_DefineInter(proc);
					}
					CPfrontCPG_level += 1;
					CPfrontCPV_stat(n->left, proc);
					CPfrontCPG_level -= 1;
					CPfrontCPC_EnterProc(proc);
					CPfrontCPV_stat(n->right, proc);
					CPfrontCPC_ExitProc(proc, 1, CPfrontCPV_ImplicitReturn(n->right));
				}
				break;
			case 14: 
				break;
			case 19: 
				switch (n->subcl) {
					case 0: 
						l = n->left;
						r = n->right;
						if (__IN(l->typ->comp, 0x0c)) {
							if (__IN(r->typ->form, 0x020400) && (INTEGER)r->class != 7) {
								CPfrontCPV_StringCopy(l, r, 0);
							} else {
								CPfrontCPG_WriteString((SHORTCHAR*)"__MOVE(", 8);
								CPfrontCPV_expr(r, -1);
								CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
								CPfrontCPV_expr(l, -1);
								CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
								if (r->typ == DevCPT_string8typ) {
									CPfrontCPG_WriteInt(r->conval->intval2);
								} else if (r->typ == DevCPT_string16typ) {
									CPfrontCPG_WriteInt(r->conval->intval2 * DevCPT_char16typ->size);
								} else {
									CPfrontCPG_WriteInt(r->typ->size);
								}
								CPfrontCPG_Write((SHORTCHAR)')');
							}
						} else {
							if ((((INTEGER)l->typ->form == 13 && l->obj != NIL) && l->obj->adr == 1) && (INTEGER)l->obj->mode \
== 1) {
								l->obj->adr = 0;
								CPfrontCPV_design(l, -1);
								l->obj->adr = 1;
								if ((INTEGER)r->typ->form != 11) {
									CPfrontCPG_WriteString((SHORTCHAR*)" = (void*)", 11);
								} else {
									CPfrontCPG_WriteString((SHORTCHAR*)" = ", 4);
								}
							} else {
								CPfrontCPV_design(l, -1);
								CPfrontCPG_WriteString((SHORTCHAR*)" = ", 4);
							}
							if (l->typ == r->typ) {
								CPfrontCPV_expr(r, -1);
							} else if (((__IN(l->typ->form, 0x6000) && (INTEGER)r->typ->form != 11) && l->typ->strobj != NIL) \
&& (l->typ->strobj->name->data)[0] != 0) {
								CPfrontCPG_Write((SHORTCHAR)'(');
								CPfrontCPC_Ident(l->typ->strobj);
								CPfrontCPG_Write((SHORTCHAR)')');
								CPfrontCPV_expr(r, -1);
							} else if ((INTEGER)l->typ->comp == 4) {
								CPfrontCPG_WriteString((SHORTCHAR*)"*(", 3);
								CPfrontCPC_Andent(l->typ);
								CPfrontCPG_WriteString((SHORTCHAR*)"*)", 3);
								CPfrontCPV_Adr(r, 9, 0);
							} else {
								CPfrontCPV_expr(r, -1);
							}
						}
						break;
					case 1: 
						if ((INTEGER)n->left->typ->BaseTyp->comp == 4) {
							CPfrontCPV_design(n->left, -1);
							CPfrontCPG_WriteString((SHORTCHAR*)" = ", 4);
							CPfrontCPG_WriteString((SHORTCHAR*)"__NEW(", 7);
							CPfrontCPC_Andent(n->left->typ->BaseTyp);
							CPfrontCPG_WriteString((SHORTCHAR*)"__typ)", 7);
						} else if (__IN(n->left->typ->BaseTyp->comp, 0x0c)) {
							CPfrontCPV_NewArr(n->left, n->right);
						}
						break;
					case 13: case 14: 
						CPfrontCPV_expr_val(n->left, -1, 1);
						CPfrontCPC_Increment((INTEGER)n->subcl == 14);
						CPfrontCPV_expr(n->right, -1);
						break;
					case 15: case 16: 
						CPfrontCPV_expr_val(n->left, -1, 1);
						CPfrontCPC_SetInclude((INTEGER)n->subcl == 16);
						CPfrontCPG_WriteString((SHORTCHAR*)"__SETOF(", 9);
						CPfrontCPV_expr(n->right, -1);
						CPfrontCPG_Write((SHORTCHAR)')');
						break;
					case 18: 
						__HALT(100);
						CPfrontCPG_WriteString((SHORTCHAR*)"__COPY(", 8);
						CPfrontCPV_expr(n->right, -1);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPV_expr(n->left, -1);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPV_Len(n->left, 0, 0);
						CPfrontCPG_Write((SHORTCHAR)')');
						break;
					case 31: 
						CPfrontCPG_WriteString((SHORTCHAR*)"__MOVE(", 8);
						CPfrontCPV_expr(n->right, -1);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPV_expr(n->left, -1);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPV_expr(n->right->link, -1);
						CPfrontCPG_Write((SHORTCHAR)')');
						break;
					case 24: 
						CPfrontCPG_WriteString((SHORTCHAR*)"__GET(", 7);
						CPfrontCPV_expr(n->right, -1);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPV_expr(n->left, -1);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						if (n->left->typ->strobj != NIL) {
							CPfrontCPC_Ident(n->left->typ->strobj);
						} else if (__IN(n->left->typ->form, 0x6000)) {
							CPfrontCPG_WriteString((SHORTCHAR*)"void*", 6);
						} else {
							DevCPM_err(217);
						}
						CPfrontCPG_Write((SHORTCHAR)')');
						break;
					case 25: 
						CPfrontCPG_WriteString((SHORTCHAR*)"__PUT(", 7);
						CPfrontCPV_expr(n->left, -1);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						CPfrontCPV_expr(n->right, -1);
						CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
						if (n->right->typ->strobj != NIL) {
							CPfrontCPC_Ident(n->right->typ->strobj);
						} else if (__IN(n->right->typ->form, 0x6000)) {
							CPfrontCPG_WriteString((SHORTCHAR*)"void*", 6);
						} else {
							DevCPM_err(217);
						}
						CPfrontCPG_Write((SHORTCHAR)')');
						break;
					case 26: case 27: 
						DevCPM_err(217);
						break;
					default: __CASECHK;
				}
				break;
			case 13: 
				if (n->left->obj != NIL && (INTEGER)n->left->obj->mode == 13) {
					if ((INTEGER)n->left->subcl == 1) {
						proc = CPfrontCPV_SuperProc(n);
					} else {
						CPfrontCPG_WriteString((SHORTCHAR*)"__", 3);
						proc = CPfrontCPC_BaseTProc(n->left->obj);
					}
					CPfrontCPC_Ident(proc);
					n->obj = proc->link;
				} else if ((INTEGER)n->left->class == 9) {
					CPfrontCPV_design(n->left, 10);
				} else {
					CPfrontCPV_design(n->left, 11);
				}
				CPfrontCPV_ActualPar(n->right, n->obj);
				break;
			case 20: 
				if ((INTEGER)n->subcl != 32) {
					CPfrontCPV_IfStat(n, 0, outerProc);
				} else if (CPfrontCPV_assert) {
					CPfrontCPG_WriteString((SHORTCHAR*)"__ASSERT(", 10);
					CPfrontCPV_expr(n->left->left->left, -1);
					CPfrontCPG_WriteString((SHORTCHAR*)", ", 3);
					CPfrontCPG_WriteInt(n->left->right->right->conval->intval);
					CPfrontCPG_Write((SHORTCHAR)')');
					CPfrontCPC_EndStat();
				}
				break;
			case 21: 
				CPfrontCPV_exit.level += 1;
				CPfrontCPV_CaseStat(n, outerProc);
				CPfrontCPV_exit.level -= 1;
				break;
			case 22: 
				CPfrontCPV_exit.level += 1;
				CPfrontCPG_WriteString((SHORTCHAR*)"while ", 7);
				CPfrontCPV_expr(n->left, 12);
				CPfrontCPG_Write((SHORTCHAR)' ');
				CPfrontCPC_BegBlk();
				CPfrontCPV_stat(n->right, outerProc);
				CPfrontCPC_EndBlk();
				CPfrontCPV_exit.level -= 1;
				break;
			case 23: 
				CPfrontCPV_exit.level += 1;
				CPfrontCPG_WriteString((SHORTCHAR*)"do ", 4);
				CPfrontCPC_BegBlk();
				CPfrontCPV_stat(n->left, outerProc);
				CPfrontCPC_EndBlk0();
				CPfrontCPG_WriteString((SHORTCHAR*)" while (!", 10);
				CPfrontCPV_expr(n->right, 9);
				CPfrontCPG_Write((SHORTCHAR)')');
				CPfrontCPV_exit.level -= 1;
				break;
			case 24: 
				saved = CPfrontCPV_exit;
				CPfrontCPV_exit.level = 0;
				CPfrontCPV_exit.label = -1;
				CPfrontCPG_WriteString((SHORTCHAR*)"for (;;) ", 10);
				CPfrontCPC_BegBlk();
				CPfrontCPV_stat(n->left, outerProc);
				CPfrontCPC_EndBlk();
				if ((INTEGER)CPfrontCPV_exit.label != -1) {
					CPfrontCPC_BegStat();
					CPfrontCPG_WriteString((SHORTCHAR*)"exit__", 7);
					CPfrontCPG_WriteInt(CPfrontCPV_exit.label);
					CPfrontCPG_Write((SHORTCHAR)':');
					CPfrontCPC_EndStat();
				}
				CPfrontCPV_exit = saved;
				break;
			case 25: 
				if ((INTEGER)CPfrontCPV_exit.level == 0) {
					CPfrontCPG_WriteString((SHORTCHAR*)"break", 6);
				} else {
					if ((INTEGER)CPfrontCPV_exit.label == -1) {
						CPfrontCPV_exit.label = CPfrontCPV_nofExitLabels;
						CPfrontCPV_nofExitLabels += 1;
					}
					CPfrontCPG_WriteString((SHORTCHAR*)"goto exit__", 12);
					CPfrontCPG_WriteInt(CPfrontCPV_exit.label);
				}
				break;
			case 26: 
				if (CPfrontCPG_level == 0) {
					if (CPfrontCPV_mainprog) {
						CPfrontCPG_WriteString((SHORTCHAR*)"__FINI", 7);
					} else {
						CPfrontCPG_WriteString((SHORTCHAR*)"__ENDMOD", 9);
					}
				} else {
					CPfrontCPC_ExitProc(outerProc, 0, 0);
					CPfrontCPG_WriteString((SHORTCHAR*)"return", 7);
					if (n->left != NIL) {
						CPfrontCPG_Write((SHORTCHAR)' ');
						if ((INTEGER)n->left->typ->form == 13 && n->obj->typ != n->left->typ) {
							CPfrontCPG_WriteString((SHORTCHAR*)"(void*)", 8);
							CPfrontCPV_expr(n->left, 10);
						} else {
							CPfrontCPV_expr(n->left, -1);
						}
					}
				}
				break;
			case 27: 
				CPfrontCPV_IfStat(n, (INTEGER)n->subcl == 0, outerProc);
				break;
			case 28: 
				CPfrontCPC_Halt(n->right->conval->intval);
				break;
			case 30: 
				CPfrontCPV_compStat(n->left, 0);
				CPfrontCPV_stat(n->right, outerProc);
				break;
			default: __CASECHK;
		}
		if (!__IN(n->class, 0x49744000)) {
			CPfrontCPC_EndStat();
		}
		n = n->link;
	}
	__EXIT;
}

void CPfrontCPV_Module (DevCPT_Node prog)
{
	__ENTER("CPfrontCPV.Module");
	CPfrontCPG_level = 0;
	if (!CPfrontCPV_mainprog) {
		CPfrontCPC_GenHdr(prog->right);
		CPfrontCPC_GenHdrIncludes();
	}
	CPfrontCPC_GenBdy(prog->right, prog->link != NIL);
	__ASSERT((INTEGER)prog->class == 18 && prog->obj == NIL, 0);
	CPfrontCPG_level += 1;
	CPfrontCPV_stat(prog->left, NIL);
	CPfrontCPG_level -= 1;
	CPfrontCPV_DefineTDescs(prog->right, prog->link != NIL);
	CPfrontCPC_RegEntry(prog->right);
	CPfrontCPC_EnterBody();
	CPfrontCPV_stat(prog->right, NIL);
	CPfrontCPC_ExitBody();
	if (prog->link != NIL) {
		CPfrontCPC_EnterClose();
		CPfrontCPV_stat(prog->link, NIL);
		CPfrontCPC_ExitClose();
	}
	if (CPfrontCPV_mainprog) {
		CPfrontCPC_MainBody();
	}
	CPfrontCPC_CleanupArrays();
	__EXIT;
}

static INTEGER CPfrontCPV_ExitInfo__flds[] = {
	2, 
	0, 0, 1<<8 | 0x15, 5,
	0, 2, 7<<8 | 0x15, 5,
};
export INTEGER CPfrontCPV_ExitInfo__desc[] = {
	-1, 
	0, 
	4,
	(INTEGER)&CPfrontCPV__desc,
	13<<8 | 0x01,
	(INTEGER)(CPfrontCPV_ExitInfo__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)CPfrontCPV_ExitInfo__flds, 
	-4
};
static SYSTEM_MODDESC *CPfrontCPV__imp[] = {
	&CPfrontCPC__desc,
	&CPfrontCPG__desc,
	&DevCPM__desc,
	&DevCPS__desc,
	&DevCPT__desc,
};
static INTEGER CPfrontCPV__exp[] = {
	44,
	0x227d6f36, (INTEGER)CPfrontCPV_ActualPar, 22<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_AddCopy, 32<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_Adr, 40<<8 | 0x14, 0,
	0x1cdfadf1, (INTEGER)CPfrontCPV_AdrAndSize, 44<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_CaseStat, 55<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_Convert, 64<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_CountTProcs, 72<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_DefineTDescs, 84<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_Entier, 97<<8 | 0x14, 0,
	0x65b2350d, 0xee0f1ebc, 13<<8 | 0x12, (INTEGER)(CPfrontCPV_ExitInfo__desc + 2),
	0x227d6f36, (INTEGER)CPfrontCPV_IfStat, 104<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_ImplicitReturn, 111<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_Index, 126<<8 | 0x14, 0,
	0x18ea5fb4, (INTEGER)CPfrontCPV_Init, 132<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_LEntier, 137<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_Len, 145<<8 | 0x14, 0,
	0x5a85f0e0, (INTEGER)CPfrontCPV_Module, 149<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_NewArr, 156<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_Precedence, 163<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_SameExp, 174<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_SideEffects, 182<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_Stamp, 194<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_StringCopy, 200<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_StringModifier, 211<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_SuperProc, 226<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_Traverse, 236<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_TraverseType, 245<<8 | 0x14, 0,
	0x8b95859d, (INTEGER)CPfrontCPV_TypSize, 258<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_TypeOf, 266<<8 | 0x14, 0,
	0x0de13ad6, (INTEGER)&CPfrontCPV_ansi, 273<<8 | 0x13, 1,
	0x0de13ad6, (INTEGER)&CPfrontCPV_assert, 278<<8 | 0x13, 1,
	0x227d6f36, (INTEGER)CPfrontCPV_compStat, 285<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_design, 294<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_design_adr, 301<<8 | 0x14, 0,
	0xc07b8823, (INTEGER)&CPfrontCPV_exit, 312<<8 | 0x13, (INTEGER)(CPfrontCPV_ExitInfo__desc + 2),
	0x227d6f36, (INTEGER)CPfrontCPV_expr, 317<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)CPfrontCPV_expr_val, 322<<8 | 0x14, 0,
	0x0de13ad6, (INTEGER)&CPfrontCPV_inxchk, 331<<8 | 0x13, 1,
	0x0de13ad6, (INTEGER)&CPfrontCPV_mainprog, 338<<8 | 0x13, 1,
	0x13a66ad3, (INTEGER)&CPfrontCPV_nofExitLabels, 347<<8 | 0x13, 5,
	0x528c19ed, 0, 361<<8 | 0x41, 0,
	0x13a66ad3, (INTEGER)&CPfrontCPV_recno, 371<<8 | 0x13, 5,
	0x13a66ad3, (INTEGER)&CPfrontCPV_stamp, 377<<8 | 0x13, 5,
	0x227d6f36, (INTEGER)CPfrontCPV_stat, 383<<8 | 0x14, 0,
};
static char CPfrontCPV__names[] = {
	0,
	'l','e','v','e','l',0,
	'l','a','b','e','l',0,
	'E','x','i','t','I','n','f','o',0,
	'A','c','t','u','a','l','P','a','r',0,
	'A','d','d','C','o','p','y',0,
	'A','d','r',0,
	'A','d','r','A','n','d','S','i','z','e',0,
	'C','a','s','e','S','t','a','t',0,
	'C','o','n','v','e','r','t',0,
	'C','o','u','n','t','T','P','r','o','c','s',0,
	'D','e','f','i','n','e','T','D','e','s','c','s',0,
	'E','n','t','i','e','r',0,
	'I','f','S','t','a','t',0,
	'I','m','p','l','i','c','i','t','R','e','t','u','r','n',0,
	'I','n','d','e','x',0,
	'I','n','i','t',0,
	'L','E','n','t','i','e','r',0,
	'L','e','n',0,
	'M','o','d','u','l','e',0,
	'N','e','w','A','r','r',0,
	'P','r','e','c','e','d','e','n','c','e',0,
	'S','a','m','e','E','x','p',0,
	'S','i','d','e','E','f','f','e','c','t','s',0,
	'S','t','a','m','p',0,
	'S','t','r','i','n','g','C','o','p','y',0,
	'S','t','r','i','n','g','M','o','d','i','f','i','e','r',0,
	'S','u','p','e','r','P','r','o','c',0,
	'T','r','a','v','e','r','s','e',0,
	'T','r','a','v','e','r','s','e','T','y','p','e',0,
	'T','y','p','S','i','z','e',0,
	'T','y','p','e','O','f',0,
	'a','n','s','i',0,
	'a','s','s','e','r','t',0,
	'c','o','m','p','S','t','a','t',0,
	'd','e','s','i','g','n',0,
	'd','e','s','i','g','n','_','a','d','r',0,
	'e','x','i','t',0,
	'e','x','p','r',0,
	'e','x','p','r','_','v','a','l',0,
	'i','n','x','c','h','k',0,
	'm','a','i','n','p','r','o','g',0,
	'n','o','f','E','x','i','t','L','a','b','e','l','s',0,
	'p','r','o','c','e','s','s','o','r',0,
	'r','e','c','n','o',0,
	's','t','a','m','p',0,
	's','t','a','t',0,
};
static INTEGER CPfrontCPV__ptrs[] = {
	0
};
struct SYSTEM_MODDESC CPfrontCPV__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 19}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	CPfrontCPV__body,
	0,
	5, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	CPfrontCPV__names,
	CPfrontCPV__ptrs,
	CPfrontCPV__imp,
	(SYSTEM_DIRECTORY*)CPfrontCPV__exp,
	"CPfrontCPV"
};

export void CPfrontCPV__reg()
{
	__BEGREG(CPfrontCPV__desc);
	DevCPM__reg();
	DevCPS__reg();
	DevCPT__reg();
	CPfrontCPG__reg();
	CPfrontCPC__reg();
	__REGMOD(CPfrontCPV__desc);
	__ENDREG;
}

export void CPfrontCPV__body()
{
	__BEGBODY(CPfrontCPV__desc);
	DevCPM__body();
	DevCPS__body();
	DevCPT__body();
	CPfrontCPG__body();
	CPfrontCPC__body();
	__ENDBODY;
}
