/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"

typedef
	struct Dates_Date {
		INTEGER year, month, day;
	} Dates_Date;

typedef
	struct Dates_Hook__rec *Dates_Hook;

typedef
	struct Dates_Hook__rec {
		char _prvt0[1];
	} Dates_Hook__rec;

export void Dates_Hook_DateToString (Dates_Hook h, Dates_Date d, INTEGER format, CHAR *str, INTEGER str__len);
typedef
	struct Dates_Time {
		INTEGER hour, minute, second;
	} Dates_Time;

export void Dates_Hook_GetTime (Dates_Hook h, Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time *t, SYSTEM_TYPEDESC \
*t__typ);
export void Dates_Hook_GetUTCBias (Dates_Hook h, INTEGER *bias);
export void Dates_Hook_GetUTCTime (Dates_Hook h, Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time *t, \
SYSTEM_TYPEDESC *t__typ);
export void Dates_Hook_TimeToString (Dates_Hook h, Dates_Time t, CHAR *str, INTEGER str__len);
#define __Dates_Hook_DateToString(h, d, format, str, str__len) __SEND(__TYPEOF(h), 1, void(*)(Dates_Hook, \
Dates_Date, INTEGER, CHAR*, INTEGER ), (h, d, format, str, str__len))
#define __Dates_Hook_GetTime(h, d, d__typ, t, t__typ) __SEND(__TYPEOF(h), 2, void(*)(Dates_Hook, Dates_Date*, \
SYSTEM_TYPEDESC *, Dates_Time*, SYSTEM_TYPEDESC *), (h, d, d__typ, t, t__typ))
#define __Dates_Hook_GetUTCBias(h, bias) __SEND(__TYPEOF(h), 3, void(*)(Dates_Hook, INTEGER*), (h, bias))
#define __Dates_Hook_GetUTCTime(h, d, d__typ, t, t__typ) __SEND(__TYPEOF(h), 4, void(*)(Dates_Hook, Dates_Date*, \
SYSTEM_TYPEDESC *, Dates_Time*, SYSTEM_TYPEDESC *), (h, d, d__typ, t, t__typ))
#define __Dates_Hook_TimeToString(h, t, str, str__len) __SEND(__TYPEOF(h), 5, void(*)(Dates_Hook, Dates_Time, \
CHAR*, INTEGER ), (h, t, str, str__len))


static INTEGER Dates_M[8], Dates_N[8];
static Dates_Hook Dates_hook;

export INTEGER Dates_Date__desc[];
export SYSTEM_TYPEDESC *Dates_Date__typ = (SYSTEM_TYPEDESC*)(Dates_Date__desc + 2);
export INTEGER Dates_Time__desc[];
export SYSTEM_TYPEDESC *Dates_Time__typ = (SYSTEM_TYPEDESC*)(Dates_Time__desc + 2);
export INTEGER Dates_Hook__rec__desc[];
export SYSTEM_TYPEDESC *Dates_Hook__rec__typ = (SYSTEM_TYPEDESC*)(Dates_Hook__rec__desc + 7);
export INTEGER Dates_Hook__desc[];
export SYSTEM_TYPEDESC *Dates_Hook__typ = (SYSTEM_TYPEDESC*)Dates_Hook__desc;

export void Dates_DateToString (Dates_Date *d, SYSTEM_TYPEDESC *d__typ, INTEGER format, CHAR *str, INTEGER \
str__len);
export INTEGER Dates_Day (Dates_Date *d, SYSTEM_TYPEDESC *d__typ);
export INTEGER Dates_DayOfWeek (Dates_Date *d, SYSTEM_TYPEDESC *d__typ);
export void Dates_DayToDate (INTEGER n, Dates_Date *d, SYSTEM_TYPEDESC *d__typ);
export void Dates_GetDate (Dates_Date *d, SYSTEM_TYPEDESC *d__typ);
export void Dates_GetDateTime (Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time *t, SYSTEM_TYPEDESC \
*t__typ);
export void Dates_GetEasterDate (INTEGER year, Dates_Date *d, SYSTEM_TYPEDESC *d__typ);
export void Dates_GetTime (Dates_Time *t, SYSTEM_TYPEDESC *t__typ);
export void Dates_GetUTCBias (INTEGER *bias);
export void Dates_GetUTCDate (Dates_Date *d, SYSTEM_TYPEDESC *d__typ);
export void Dates_GetUTCDateTime (Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time *t, SYSTEM_TYPEDESC \
*t__typ);
export void Dates_GetUTCTime (Dates_Time *t, SYSTEM_TYPEDESC *t__typ);
export void Dates_SetHook (Dates_Hook h);
export void Dates_TimeToString (Dates_Time *t, SYSTEM_TYPEDESC *t__typ, CHAR *str, INTEGER str__len);
export BOOLEAN Dates_ValidDate (Dates_Date *d, SYSTEM_TYPEDESC *d__typ);
export BOOLEAN Dates_ValidTime (Dates_Time *t, SYSTEM_TYPEDESC *t__typ);

export void Dates__reg();
export void Dates__body();
export struct SYSTEM_MODDESC Dates__desc;


void Dates_SetHook (Dates_Hook h)
{
	__ENTER("Dates.SetHook");
	Dates_hook = h;
	__EXIT;
}

BOOLEAN Dates_ValidTime (Dates_Time *t, SYSTEM_TYPEDESC *t__typ)
{
	__ENTER("Dates.ValidTime");
	__EXIT;
	return (((((*t).hour >= 0 && (*t).hour <= 23) && (*t).minute >= 0) && (*t).minute <= 59) && (*t).second \
>= 0) && (*t).second <= 59;
}

BOOLEAN Dates_ValidDate (Dates_Date *d, SYSTEM_TYPEDESC *d__typ)
{
	INTEGER y, m, d1;
	__ENTER("Dates.ValidDate");
	if (((((*d).year < 1 || (*d).year > 9999) || (*d).month < 1) || (*d).month > 12) || (*d).day < 1) {
		__EXIT;
		return 0;
	} else {
		y = (*d).year;
		m = (*d).month;
		if (m == 2) {
			if (y < 1583 && __MASK(y, -4) == 0 || __MASK(y, -4) == 0 && (__MOD(y, 100) != 0 || __MOD(y, 400) == \
0)) {
				d1 = 29;
			} else {
				d1 = 28;
			}
		} else if (__IN(m, 0x15aa)) {
			d1 = 31;
		} else {
			d1 = 30;
		}
		if (((y == 1582 && m == 10) && (*d).day > 4) && (*d).day < 15) {
			__EXIT;
			return 0;
		}
		__EXIT;
		return (*d).day <= d1;
	}
	__RETCHK;
}

INTEGER Dates_Day (Dates_Date *d, SYSTEM_TYPEDESC *d__typ)
{
	INTEGER y, m, n;
	__ENTER("Dates.Day");
	y = (*d).year;
	m = (*d).month - 3;
	if (m < 0) {
		m += 12;
		y -= 1;
	}
	n = ((__ASHR(y * 1461, 2, INTEGER) + __DIV(m * 153 + 2, 5)) + (*d).day) - 306;
	if (n > 577737) {
		n = n - __ASHR(__DIV(y, 100) * 3 - 5, 2, INTEGER);
	}
	__EXIT;
	return n;
}

void Dates_DayToDate (INTEGER n, Dates_Date *d, SYSTEM_TYPEDESC *d__typ)
{
	INTEGER c, y, m;
	__ENTER("Dates.DayToDate");
	if (n > 577737) {
		n = __ASHL(n, 2, INTEGER) + 1215;
		c = __DIV(n, 146097);
		n = __ASHR(__MOD(n, 146097), 2, INTEGER);
	} else {
		n = n + 305;
		c = 0;
	}
	n = __ASHL(n, 2, INTEGER) + 3;
	y = __DIV(n, 1461);
	n = __ASHR(__MOD(n, 1461), 2, INTEGER);
	n = n * 5 + 2;
	m = __DIV(n, 153);
	n = __DIV(__MOD(n, 153), 5);
	if (m > 9) {
		m = m - 12;
		y += 1;
	}
	(*d).year = (SHORTINT)(100 * c + y);
	(*d).month = (SHORTINT)(m + 3);
	(*d).day = (SHORTINT)(n + 1);
	__EXIT;
}

void Dates_GetDate (Dates_Date *d, SYSTEM_TYPEDESC *d__typ)
{
	Dates_Time t;
	__ENTER("Dates.GetDate");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_GetTime(Dates_hook, d, d__typ, &t, Dates_Time__typ);
	__EXIT;
}

void Dates_GetTime (Dates_Time *t, SYSTEM_TYPEDESC *t__typ)
{
	Dates_Date d;
	__ENTER("Dates.GetTime");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_GetTime(Dates_hook, &d, Dates_Date__typ, t, t__typ);
	__EXIT;
}

void Dates_GetDateTime (Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time *t, SYSTEM_TYPEDESC *t__typ)
{
	__ENTER("Dates.GetDateTime");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_GetTime(Dates_hook, d, d__typ, t, t__typ);
	__EXIT;
}

void Dates_GetUTCDate (Dates_Date *d, SYSTEM_TYPEDESC *d__typ)
{
	Dates_Time t;
	__ENTER("Dates.GetUTCDate");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_GetUTCTime(Dates_hook, d, d__typ, &t, Dates_Time__typ);
	__EXIT;
}

void Dates_GetUTCTime (Dates_Time *t, SYSTEM_TYPEDESC *t__typ)
{
	Dates_Date d;
	__ENTER("Dates.GetUTCTime");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_GetUTCTime(Dates_hook, &d, Dates_Date__typ, t, t__typ);
	__EXIT;
}

void Dates_GetUTCDateTime (Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time *t, SYSTEM_TYPEDESC *t__typ)
{
	__ENTER("Dates.GetUTCDateTime");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_GetUTCTime(Dates_hook, d, d__typ, t, t__typ);
	__EXIT;
}

void Dates_GetUTCBias (INTEGER *bias)
{
	__ENTER("Dates.GetUTCBias");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_GetUTCBias(Dates_hook, bias);
	__EXIT;
}

void Dates_GetEasterDate (INTEGER year, Dates_Date *d, SYSTEM_TYPEDESC *d__typ)
{
	INTEGER k, m, n, a, b, c, d0, e, o, month, day;
	__ENTER("Dates.GetEasterDate");
	__ASSERT(year >= 1583 && year <= 2299, 20);
	k = __DIV(year, 100) - 15;
	m = Dates_M[__X(k, 8)];
	n = Dates_N[__X(k, 8)];
	a = __MOD(year, 19);
	b = __MASK(year, -4);
	c = __MOD(year, 7);
	d0 = __MOD(19 * a + m, 30);
	e = __MOD(((__ASHL(b, 1, INTEGER) + __ASHL(c, 2, INTEGER)) + 6 * d0) + n, 7);
	o = (21 + d0) + e;
	month = 3 + __DIV(o, 31);
	day = __MOD(o, 31) + 1;
	if (month == 4) {
		if (day == 26) {
			day = 19;
		} else if (((day == 25 && d0 == 28) && e == 6) && a > 10) {
			day = 18;
		}
	}
	(*d).year = year;
	(*d).month = month;
	(*d).day = day;
	__EXIT;
}

INTEGER Dates_DayOfWeek (Dates_Date *d, SYSTEM_TYPEDESC *d__typ)
{
	__ENTER("Dates.DayOfWeek");
	__EXIT;
	return (SHORTINT)__MODF(4 + Dates_Day(d, d__typ), 7);
}

void Dates_DateToString (Dates_Date *d, SYSTEM_TYPEDESC *d__typ, INTEGER format, CHAR *str, INTEGER str__len)
{
	__ENTER("Dates.DateToString");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_DateToString(Dates_hook, *d, format, (void*)str, str__len);
	__EXIT;
}

void Dates_TimeToString (Dates_Time *t, SYSTEM_TYPEDESC *t__typ, CHAR *str, INTEGER str__len)
{
	__ENTER("Dates.TimeToString");
	__ASSERT(Dates_hook != NIL, 100);
	__Dates_Hook_TimeToString(Dates_hook, *t, (void*)str, str__len);
	__EXIT;
}

static INTEGER Dates_Date__flds[] = {
	3, 
	0, 0, 1<<8 | 0x45, 6,
	0, 4, 6<<8 | 0x45, 6,
	0, 8, 12<<8 | 0x45, 6,
};
export INTEGER Dates_Date__desc[] = {
	-1, 
	0, 
	12,
	(INTEGER)&Dates__desc,
	16<<8 | 0x01,
	(INTEGER)(Dates_Date__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dates_Date__flds, 
	-4
};
static INTEGER Dates_Time__flds[] = {
	3, 
	0, 0, 21<<8 | 0x45, 6,
	0, 4, 26<<8 | 0x45, 6,
	0, 8, 33<<8 | 0x45, 6,
};
export INTEGER Dates_Time__desc[] = {
	-1, 
	0, 
	12,
	(INTEGER)&Dates__desc,
	40<<8 | 0x01,
	(INTEGER)(Dates_Time__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dates_Time__flds, 
	-4
};
static INTEGER Dates_Hook__rec__flds[] = {
	0, 
};
export INTEGER Dates_Hook__rec__desc[] = {
	-1, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	1,
	(INTEGER)&Dates__desc,
	45<<8 | 0x1d,
	(INTEGER)(Kernel_Hook__rec__desc + 2),
	(INTEGER)(Dates_Hook__rec__desc + 7),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dates_Hook__rec__flds, 
	-4
};
export INTEGER Dates_Hook__desc[] = {
	0,
	(INTEGER)&Dates__desc,
	51<<8 | 0x03,
	(INTEGER)(Dates_Hook__rec__desc + 7)
};
export INTEGER Dates__3__desc[] = {
	8,
	(INTEGER)&Dates__desc,
	0<<8 | 0x02,
	6
};
static SYSTEM_MODDESC *Dates__imp[] = {
	&Kernel__desc,
};
static INTEGER Dates__exp[] = {
	35,
	0x4752c6c2, 0xc3540889, 16<<8 | 0x42, (INTEGER)(Dates_Date__desc + 2),
	0x0334ec39, (INTEGER)Dates_DateToString, 56<<8 | 0x44, 0,
	0x4f7ae567, (INTEGER)Dates_Day, 69<<8 | 0x44, 0,
	0x4f7ae567, (INTEGER)Dates_DayOfWeek, 73<<8 | 0x44, 0,
	0x422b1703, (INTEGER)Dates_DayToDate, 83<<8 | 0x44, 0,
	0xdfd1e4f2, (INTEGER)Dates_GetDate, 93<<8 | 0x44, 0,
	0x7ce80628, (INTEGER)Dates_GetDateTime, 101<<8 | 0x44, 0,
	0x422b1703, (INTEGER)Dates_GetEasterDate, 113<<8 | 0x44, 0,
	0xd5e8a0c6, (INTEGER)Dates_GetTime, 127<<8 | 0x44, 0,
	0x637dd0bd, (INTEGER)Dates_GetUTCBias, 135<<8 | 0x44, 0,
	0xdfd1e4f2, (INTEGER)Dates_GetUTCDate, 146<<8 | 0x44, 0,
	0x7ce80628, (INTEGER)Dates_GetUTCDateTime, 157<<8 | 0x44, 0,
	0xd5e8a0c6, (INTEGER)Dates_GetUTCTime, 172<<8 | 0x44, 0,
	0x816dc441, 0x816dc441, 51<<8 | 0x42, (INTEGER)Dates_Hook__desc,
	0xe2339981, 0xd9ad8ed4, 45<<8 | 0x12, (INTEGER)(Dates_Hook__rec__desc + 7),
	0x8d7b9a95, (INTEGER)&Dates_M, 183<<8 | 0x13, (INTEGER)Dates__3__desc,
	0x8d7b9a95, (INTEGER)&Dates_N, 185<<8 | 0x13, (INTEGER)Dates__3__desc,
	0xc86e506f, (INTEGER)Dates_SetHook, 187<<8 | 0x44, 0,
	0xfa761818, 0xb2dcedd9, 40<<8 | 0x42, (INTEGER)(Dates_Time__desc + 2),
	0x925f74f4, (INTEGER)Dates_TimeToString, 195<<8 | 0x44, 0,
	0xe0a89baa, (INTEGER)Dates_ValidDate, 208<<8 | 0x44, 0,
	0xea91df9e, (INTEGER)Dates_ValidTime, 218<<8 | 0x44, 0,
	0x5fcf3f34, 0, 228<<8 | 0x41, 0,
	0x45497286, 0, 240<<8 | 0x41, 0,
	0x8d00952c, (INTEGER)&Dates_hook, 247<<8 | 0x13, (INTEGER)Dates_Hook__desc,
	0x528c19ed, 0, 252<<8 | 0x41, 0,
	0x564d045a, 0, 257<<8 | 0x41, 0,
	0x45497286, 0, 264<<8 | 0x41, 0,
	0x5b0e2283, 0, 281<<8 | 0x41, 0,
	0x41886f31, 0, 291<<8 | 0x41, 0,
	0x564d045a, 0, 300<<8 | 0x41, 0,
	0x4ccb49e8, 0, 306<<8 | 0x41, 0,
	0x5b0e2283, 0, 313<<8 | 0x41, 0,
	0x528c19ed, 0, 322<<8 | 0x41, 0,
	0x5fcf3f34, 0, 330<<8 | 0x41, 0,
};
static char Dates__names[] = {
	0,
	'y','e','a','r',0,
	'm','o','n','t','h',0,
	'd','a','y',0,
	'D','a','t','e',0,
	'h','o','u','r',0,
	'm','i','n','u','t','e',0,
	's','e','c','o','n','d',0,
	'T','i','m','e',0,
	'H','o','o','k','^',0,
	'H','o','o','k',0,
	'D','a','t','e','T','o','S','t','r','i','n','g',0,
	'D','a','y',0,
	'D','a','y','O','f','W','e','e','k',0,
	'D','a','y','T','o','D','a','t','e',0,
	'G','e','t','D','a','t','e',0,
	'G','e','t','D','a','t','e','T','i','m','e',0,
	'G','e','t','E','a','s','t','e','r','D','a','t','e',0,
	'G','e','t','T','i','m','e',0,
	'G','e','t','U','T','C','B','i','a','s',0,
	'G','e','t','U','T','C','D','a','t','e',0,
	'G','e','t','U','T','C','D','a','t','e','T','i','m','e',0,
	'G','e','t','U','T','C','T','i','m','e',0,
	'M',0,
	'N',0,
	'S','e','t','H','o','o','k',0,
	'T','i','m','e','T','o','S','t','r','i','n','g',0,
	'V','a','l','i','d','D','a','t','e',0,
	'V','a','l','i','d','T','i','m','e',0,
	'a','b','b','r','e','v','i','a','t','e','d',0,
	'f','r','i','d','a','y',0,
	'h','o','o','k',0,
	'l','o','n','g',0,
	'm','o','n','d','a','y',0,
	'p','l','a','i','n','A','b','b','r','e','v','i','a','t','e','d',0,
	'p','l','a','i','n','L','o','n','g',0,
	's','a','t','u','r','d','a','y',0,
	's','h','o','r','t',0,
	's','u','n','d','a','y',0,
	't','h','u','r','s','d','a','y',0,
	't','u','e','s','d','a','y',0,
	'w','e','d','n','e','s','d','a','y',0,
};
static INTEGER Dates__ptrs[] = {
	(INTEGER)&Dates_hook + 0, 
};
struct SYSTEM_MODDESC Dates__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 1}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Dates__body,
	0,
	1, /* nofimps */ 
	1, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Dates__names,
	Dates__ptrs,
	Dates__imp,
	(SYSTEM_DIRECTORY*)Dates__exp,
	"Dates"
};

export void Dates__reg()
{
	__BEGREG(Dates__desc);
	Kernel__reg();
	__REGMOD(Dates__desc);
	Dates_Hook__rec__desc[6] = Kernel_Hook__rec__desc[1];
	__ENDREG;
}

export void Dates__body()
{
	__BEGBODY(Dates__desc);
	Kernel__body();
	Dates_M[0] = 22;
	Dates_N[0] = 2;
	Dates_M[1] = 22;
	Dates_N[1] = 2;
	Dates_M[2] = 23;
	Dates_N[2] = 3;
	Dates_M[3] = 23;
	Dates_N[3] = 4;
	Dates_M[4] = 24;
	Dates_N[4] = 5;
	Dates_M[5] = 24;
	Dates_N[5] = 5;
	Dates_M[6] = 24;
	Dates_N[6] = 6;
	Dates_M[7] = 25;
	Dates_N[7] = 0;
	__ENDBODY;
}
