/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"
#include "Files.h"
#include "Log.h"

struct Dev2LnkBase__8 {
	INTEGER imageBase, subsystem;
	BOOLEAN elfStatic;
	SHORTCHAR elfInterpreter[128];
	SHORTCHAR rpath[128];
	SHORTCHAR OSABI;
};

typedef
	BYTE *Dev2LnkBase_BYTES;

typedef
	struct Dev2LnkBase_Directory__rec *Dev2LnkBase_Directory;

typedef
	struct Dev2LnkBase_Directory__rec {
		Files_Name path;
		BOOLEAN legacy;
		Dev2LnkBase_Directory next;
	} Dev2LnkBase_Directory__rec;

typedef
	struct Dev2LnkBase_Section__rec *Dev2LnkBase_Section;

typedef
	struct Dev2LnkBase_FixRec {
		INTEGER ftype, offs;
		Dev2LnkBase_Section sec;
	} Dev2LnkBase_FixRec;

typedef
	struct Dev2LnkBase_FixTable {
		Dev2LnkBase_Section sec;
		struct Dev2LnkBase_FixRec_ARRAY *tab;
		INTEGER len;
	} Dev2LnkBase_FixTable;

typedef
	struct Dev2LnkBase_Module__rec *Dev2LnkBase_Module;

typedef
	SHORTCHAR Dev2LnkBase_Name[256];

typedef
	struct Dev2LnkBase_Symbol__rec *Dev2LnkBase_Symbol;

typedef
	struct Dev2LnkBase_Module__rec {
		Dev2LnkBase_Module next;
		Dev2LnkBase_Name name;
		Dev2LnkBase_Section data, code, vars;
		Dev2LnkBase_FixTable codeFix, dataFix;
		INTEGER mDesc, termadr;
		BOOLEAN isDll, exported;
		Dev2LnkBase_Symbol exp;
	} Dev2LnkBase_Module__rec;

typedef
	SHORTCHAR Dev2LnkBase_SName[256];

typedef
	SHORTCHAR *Dev2LnkBase_STRING;

typedef
	struct Dev2LnkBase_Section__rec {
		INTEGER addr, size;
		struct BYTE_ARRAY *bytes;
	} Dev2LnkBase_Section__rec;

typedef
	struct Dev2LnkBase_StringTable {
		struct SHORTCHAR_ARRAY *tab;
		INTEGER len;
	} Dev2LnkBase_StringTable;

typedef
	struct Dev2LnkBase_Symbol__rec {
		Dev2LnkBase_Symbol next;
		Dev2LnkBase_Section sect;
		INTEGER addr, namIdx, symIdx;
		Dev2LnkBase_SName name;
		INTEGER typ;
	} Dev2LnkBase_Symbol__rec;


#ifndef Dev2LnkBase_FixRec_ARRAY_DEF
#define Dev2LnkBase_FixRec_ARRAY_DEF
typedef struct Dev2LnkBase_FixRec_ARRAY {
	INTEGER gc[3], len[1];
	Dev2LnkBase_FixRec data[1];
} Dev2LnkBase_FixRec_ARRAY;
#endif 

export BOOLEAN Dev2LnkBase_error;
export BOOLEAN Dev2LnkBase_trap;
export INTEGER Dev2LnkBase_target;
export BOOLEAN Dev2LnkBase_outPe, Dev2LnkBase_outElf, Dev2LnkBase_outDll;
export BOOLEAN Dev2LnkBase_dynaInit;
export Files_Name Dev2LnkBase_outputPath, Dev2LnkBase_outputName;
export Files_Type Dev2LnkBase_outputType;
export Dev2LnkBase_Name Dev2LnkBase_KernelName, Dev2LnkBase_mainName;
export Dev2LnkBase_Directory Dev2LnkBase_objList;
export Dev2LnkBase_Module Dev2LnkBase_kernelMod, Dev2LnkBase_mainMod;
export Dev2LnkBase_Module Dev2LnkBase_modList, Dev2LnkBase_lastMod, Dev2LnkBase_initMod, Dev2LnkBase_dllList;
export INTEGER Dev2LnkBase_modCount, Dev2LnkBase_impCount, Dev2LnkBase_impDllCount, Dev2LnkBase_expCount;
export Dev2LnkBase_Symbol Dev2LnkBase_expList;
export INTEGER Dev2LnkBase_ImageBase;
export INTEGER Dev2LnkBase_codeSize, Dev2LnkBase_dataSize, Dev2LnkBase_varsSize, Dev2LnkBase_initOffs, \
Dev2LnkBase_finiOffs;
static INTEGER Dev2LnkBase_pltEntrySize, Dev2LnkBase_pltIniSize;
export INTEGER Dev2LnkBase_relCount;
export struct INTEGER_ARRAY *Dev2LnkBase_relTab;
export struct Dev2LnkBase__8 Dev2LnkBase_opt;

export INTEGER Dev2LnkBase_Section__rec__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Section__rec__typ = (SYSTEM_TYPEDESC*)(Dev2LnkBase_Section__rec__desc \
+ 2);
export INTEGER Dev2LnkBase__1__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__1__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase__1__desc;
export INTEGER Dev2LnkBase_BYTES__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_BYTES__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase_BYTES__desc;
export INTEGER Dev2LnkBase_Symbol__rec__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Symbol__rec__typ = (SYSTEM_TYPEDESC*)(Dev2LnkBase_Symbol__rec__desc \
+ 2);
export INTEGER Dev2LnkBase_Symbol__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Symbol__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase_Symbol__desc;
export INTEGER Dev2LnkBase_Section__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Section__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase_Section__desc;
export INTEGER Dev2LnkBase_SName__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_SName__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase_SName__desc;
export INTEGER Dev2LnkBase_FixRec__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_FixRec__typ = (SYSTEM_TYPEDESC*)(Dev2LnkBase_FixRec__desc + 2);
export INTEGER Dev2LnkBase_FixTable__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_FixTable__typ = (SYSTEM_TYPEDESC*)(Dev2LnkBase_FixTable__desc + 2);
export INTEGER Dev2LnkBase__3__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__3__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase__3__desc;
export INTEGER Dev2LnkBase__2__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__2__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase__2__desc;
export INTEGER Dev2LnkBase_StringTable__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_StringTable__typ = (SYSTEM_TYPEDESC*)(Dev2LnkBase_StringTable__desc \
+ 2);
export INTEGER Dev2LnkBase__5__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__5__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase__5__desc;
export INTEGER Dev2LnkBase__4__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__4__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase__4__desc;
export INTEGER Dev2LnkBase_Module__rec__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Module__rec__typ = (SYSTEM_TYPEDESC*)(Dev2LnkBase_Module__rec__desc \
+ 2);
export INTEGER Dev2LnkBase_Module__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Module__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase_Module__desc;
export INTEGER Dev2LnkBase_Name__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Name__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase_Name__desc;
export INTEGER Dev2LnkBase_Directory__rec__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Directory__rec__typ = (SYSTEM_TYPEDESC*)(Dev2LnkBase_Directory__rec__desc \
+ 2);
export INTEGER Dev2LnkBase_Directory__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_Directory__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase_Directory__desc;
export INTEGER Dev2LnkBase__8__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__8__typ = (SYSTEM_TYPEDESC*)(Dev2LnkBase__8__desc + 2);
export INTEGER Dev2LnkBase__6__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__6__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase__6__desc;
export INTEGER Dev2LnkBase__7__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__7__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase__7__desc;
export INTEGER Dev2LnkBase_STRING__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase_STRING__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase_STRING__desc;
export INTEGER Dev2LnkBase__10__desc[];
export SYSTEM_TYPEDESC *Dev2LnkBase__10__typ = (SYSTEM_TYPEDESC*)Dev2LnkBase__10__desc;

export void Dev2LnkBase_AddDllName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, SHORTCHAR *name, \
INTEGER name__len, SHORTCHAR *ext, INTEGER ext__len, INTEGER *idx);
static void Dev2LnkBase_AddFix (Dev2LnkBase_FixTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER addr, INTEGER \
fixtype, Dev2LnkBase_Section sec);
export void Dev2LnkBase_AddHintName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER hint, \
SHORTCHAR *name, INTEGER name__len, INTEGER *idx);
export void Dev2LnkBase_AddName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, SHORTCHAR *name, \
INTEGER name__len, INTEGER *idx);
export void Dev2LnkBase_AddReloc (INTEGER addr);
export INTEGER Dev2LnkBase_Aligned (INTEGER pos, INTEGER alignment);
export void Dev2LnkBase_BeginLinking (void);
static void Dev2LnkBase_CheckFixSize (Dev2LnkBase_FixTable *t, SYSTEM_TYPEDESC *t__typ);
static void Dev2LnkBase_CheckStrSize (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER len);
static void Dev2LnkBase_CountDllSizes (void);
export void Dev2LnkBase_DoFixups (void);
export void Dev2LnkBase_Error (CHAR *msg, INTEGER msg__len);
export void Dev2LnkBase_ExportProc (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER \
addr);
export void Dev2LnkBase_ExportVar (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER \
addr);
export void Dev2LnkBase_FixCode (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec);
export void Dev2LnkBase_FixCopy (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec);
export void Dev2LnkBase_FixData (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec);
export void Dev2LnkBase_FixRel (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec);
static void Dev2LnkBase_GenInitCode (void);
static INTEGER Dev2LnkBase_Get4 (BYTE *d, INTEGER d__len, INTEGER a);
export void Dev2LnkBase_ImportProc (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER \
*adr);
export void Dev2LnkBase_Init (INTEGER tgt);
export void Dev2LnkBase_InitFixTable (Dev2LnkBase_FixTable *t, SYSTEM_TYPEDESC *t__typ, Dev2LnkBase_Section \
sec);
export void Dev2LnkBase_InitStringTable (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER \
size);
export Dev2LnkBase_Section Dev2LnkBase_NewSection (INTEGER size);
static void Dev2LnkBase_Put4 (BYTE *d, INTEGER d__len, INTEGER a, INTEGER x);
export void Dev2LnkBase_RegMod (Dev2LnkBase_Module mod);
export void Dev2LnkBase_SetAddr (INTEGER codeBase, INTEGER dataBase, INTEGER varsBase);
export void Dev2LnkBase_SortReloc (void);
export Dev2LnkBase_Module Dev2LnkBase_ThisDll (SHORTCHAR *name, INTEGER name__len);
export Files_File Dev2LnkBase_ThisObjFile (CHAR *modName, INTEGER modName__len);
export void Dev2LnkBase_WriteStringTable (Files_Writer out, Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC \
*t__typ);

export void Dev2LnkBase__reg();
export void Dev2LnkBase__body();
export struct SYSTEM_MODDESC Dev2LnkBase__desc;


void Dev2LnkBase_Init (INTEGER tgt)
{
	__ENTER("Dev2LnkBase.Init");
	Dev2LnkBase_outPe = 0;
	Dev2LnkBase_outElf = 0;
	Dev2LnkBase_outDll = 0;
	Dev2LnkBase_dynaInit = 0;
	Dev2LnkBase_opt.imageBase = 0;
	Dev2LnkBase_opt.subsystem = 0;
	Dev2LnkBase_opt.elfStatic = 0;
	Dev2LnkBase_opt.elfInterpreter[0] = 0;
	Dev2LnkBase_opt.OSABI = 0;
	Dev2LnkBase_opt.rpath[0] = 0;
	Dev2LnkBase_modCount = 0;
	Dev2LnkBase_modList = NIL;
	Dev2LnkBase_lastMod = NIL;
	Dev2LnkBase_kernelMod = NIL;
	Dev2LnkBase_mainMod = NIL;
	Dev2LnkBase_initMod = NIL;
	Dev2LnkBase_dllList = NIL;
	Dev2LnkBase_impCount = 0;
	Dev2LnkBase_impDllCount = 0;
	Dev2LnkBase_expList = NIL;
	Dev2LnkBase_expCount = 0;
	Dev2LnkBase_relCount = 0;
	Dev2LnkBase_ImageBase = 0;
	Dev2LnkBase_varsSize = 0;
	Dev2LnkBase_dataSize = 0;
	Dev2LnkBase_codeSize = 0;
	Dev2LnkBase_outputPath[0] = 0;
	Dev2LnkBase_outputName[0] = 0;
	Dev2LnkBase_mainName[0] = 0;
	__MOVE("Kernel", Dev2LnkBase_KernelName, 7);
	Dev2LnkBase_target = tgt;
	switch (tgt) {
		case 3: 
			__MOVE(((CHAR[]){101, 120, 101, 0}), Dev2LnkBase_outputType, 8);
			Dev2LnkBase_outPe = 1;
			break;
		case 4: 
			__MOVE(((CHAR[]){100, 108, 108, 0}), Dev2LnkBase_outputType, 8);
			Dev2LnkBase_outPe = 1;
			Dev2LnkBase_outDll = 1;
			break;
		case 1: 
			Dev2LnkBase_outputType[0] = 0;
			Dev2LnkBase_outElf = 1;
			break;
		case 2: 
			__MOVE(((CHAR[]){115, 111, 0}), Dev2LnkBase_outputType, 6);
			Dev2LnkBase_outElf = 1;
			Dev2LnkBase_outDll = 1;
			break;
		case 0: 
			__MOVE(((CHAR[]){111, 117, 116, 0}), Dev2LnkBase_outputType, 8);
			Dev2LnkBase_outElf = 1;
			Dev2LnkBase_opt.elfStatic = 1;
			break;
		default: __CASECHK;
	}
	Dev2LnkBase_pltIniSize = 0;
	Dev2LnkBase_pltEntrySize = 6;
	__EXIT;
}

void Dev2LnkBase_Error (CHAR *msg, INTEGER msg__len)
{
	__ENTER("Dev2LnkBase.Error");
	__DUP(msg, msg__len);
	Dev2LnkBase_error = 1;
	Log_String(msg, msg__len);
	Log_Ln();
	if (Dev2LnkBase_trap) {
		__HALT(100);
	} else {
		Kernel_Quit(1);
	}
	__DEL(msg);
	__EXIT;
}

Dev2LnkBase_Section Dev2LnkBase_NewSection (INTEGER size)
{
	Dev2LnkBase_Section sec = NIL;
	__ENTER("Dev2LnkBase.NewSection");
	sec = __NEW(Dev2LnkBase_Section__rec__typ);
	sec->size = size;
	sec->addr = 0;
	__EXIT;
	return sec;
}

void Dev2LnkBase_RegMod (Dev2LnkBase_Module mod)
{
	__ENTER("Dev2LnkBase.RegMod");
	if (__STRCMPSS(mod->name, Dev2LnkBase_KernelName) == 0) {
		Dev2LnkBase_kernelMod = mod;
	}
	if (__STRCMPSS(mod->name, Dev2LnkBase_mainName) == 0) {
		Dev2LnkBase_mainMod = mod;
	}
	if (Dev2LnkBase_lastMod == NIL) {
		Dev2LnkBase_modList = mod;
	} else {
		Dev2LnkBase_lastMod->next = mod;
	}
	Dev2LnkBase_lastMod = mod;
	Dev2LnkBase_modCount += 1;
	Dev2LnkBase_codeSize += mod->code->size;
	Dev2LnkBase_varsSize += mod->vars->size;
	Dev2LnkBase_dataSize += mod->data->size;
	__EXIT;
}

Dev2LnkBase_Module Dev2LnkBase_ThisDll (SHORTCHAR *name, INTEGER name__len)
{
	INTEGER i, j;
	Dev2LnkBase_Module lib = NIL;
	__ENTER("Dev2LnkBase.ThisDll");
	lib = Dev2LnkBase_dllList;
	while (lib != NIL && __STRCMPSS(lib->name, name) != 0) {
		lib = lib->next;
	}
	if (lib == NIL) {
		lib = __NEW(Dev2LnkBase_Module__rec__typ);
		__STRCOPYSS(name, lib->name, 256);
		lib->isDll = 1;
		lib->code = Dev2LnkBase_NewSection(0);
		lib->exp = __NEW(Dev2LnkBase_Symbol__rec__typ);
		i = 0;
		j = 1;
		while (name[__X(j, name__len)] != 0) {
			lib->exp->name[__X(i, 256)] = name[__X(j, name__len)];
			i += 1;
			j += 1;
		}
		lib->exp->name[__X(i, 256)] = 0;
		lib->exp->addr = -1;
		lib->next = Dev2LnkBase_dllList;
		Dev2LnkBase_dllList = lib;
		Dev2LnkBase_impDllCount += 1;
	}
	__EXIT;
	return lib;
}

void Dev2LnkBase_ImportProc (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER *adr)
{
	Dev2LnkBase_Symbol sym = NIL;
	Dev2LnkBase_Symbol prev = NIL;
	__ENTER("Dev2LnkBase.ImportProc");
	prev = mod->exp;
	sym = prev->next;
	while (sym != NIL && __STRCMPSS(sym->name, name) != 0) {
		prev = sym;
		sym = prev->next;
	}
	if (sym == NIL) {
		sym = __NEW(Dev2LnkBase_Symbol__rec__typ);
		__STRCOPYSS(name, sym->name, 256);
		sym->addr = mod->code->size;
		prev->next = sym;
		mod->code->size += Dev2LnkBase_pltEntrySize;
		Dev2LnkBase_impCount += 1;
	}
	*adr = sym->addr;
	__EXIT;
}

void Dev2LnkBase_ExportProc (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER addr)
{
	Dev2LnkBase_Symbol sym = NIL;
	SHORTCHAR _str__21[256];
	__ENTER("Dev2LnkBase.ExportProc");
	sym = __NEW(Dev2LnkBase_Symbol__rec__typ);
	__STRCOPYSS(mod->name, _str__21, 256);
	__STRAPNDSS("_", _str__21, 256);
	__STRAPNDSS(name, _str__21, 256);
	__STRCOPYSS(_str__21, sym->name, 256);
	sym->sect = mod->code;
	sym->addr = addr;
	sym->next = Dev2LnkBase_expList;
	sym->typ = 0;
	Dev2LnkBase_expList = sym;
	Dev2LnkBase_expCount += 1;
	__EXIT;
}

void Dev2LnkBase_ExportVar (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER addr)
{
	Dev2LnkBase_Symbol sym = NIL;
	__ENTER("Dev2LnkBase.ExportVar");
	sym = __NEW(Dev2LnkBase_Symbol__rec__typ);
	__STRCOPYSS(name, sym->name, 256);
	sym->sect = mod->data;
	sym->addr = addr;
	sym->next = Dev2LnkBase_expList;
	sym->typ = 1;
	Dev2LnkBase_expList = sym;
	Dev2LnkBase_expCount += 1;
	__EXIT;
}

void Dev2LnkBase_InitFixTable (Dev2LnkBase_FixTable *t, SYSTEM_TYPEDESC *t__typ, Dev2LnkBase_Section sec)
{
	__ENTER("Dev2LnkBase.InitFixTable");
	(*t).sec = sec;
	(*t).len = 0;
	__EXIT;
}

static void Dev2LnkBase_CheckFixSize (Dev2LnkBase_FixTable *t, SYSTEM_TYPEDESC *t__typ)
{
	struct Dev2LnkBase_FixRec_ARRAY *newtab = NIL;
	INTEGER i;
	__ENTER("Dev2LnkBase.CheckFixSize");
	if ((*t).tab == NIL) {
		(*t).tab = __NEWARR((INTEGER)Dev2LnkBase_FixRec__typ, 256);
	} else if ((*t).len >= (*t).tab->len[0]) {
		newtab = __NEWARR((INTEGER)Dev2LnkBase_FixRec__typ, __ASHL((*t).tab->len[0], 1, INTEGER));
		i = 0;
		while (i < (*t).tab->len[0]) {
			(newtab->data)[__X(i, newtab->len[0])] = ((*t).tab->data)[__X(i, (*t).tab->len[0])];
			i += 1;
		}
		(*t).tab = newtab;
	}
	__EXIT;
}

static void Dev2LnkBase_AddFix (Dev2LnkBase_FixTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER addr, INTEGER \
fixtype, Dev2LnkBase_Section sec)
{
	__ENTER("Dev2LnkBase.AddFix");
	__ASSERT(sec != NIL, 0);
	Dev2LnkBase_CheckFixSize(t, t__typ);
	((*t).tab->data)[__X((*t).len, (*t).tab->len[0])].offs = addr;
	((*t).tab->data)[__X((*t).len, (*t).tab->len[0])].ftype = fixtype;
	((*t).tab->data)[__X((*t).len, (*t).tab->len[0])].sec = sec;
	(*t).len += 1;
	__EXIT;
}

void Dev2LnkBase_FixCode (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec)
{
	__ENTER("Dev2LnkBase.FixCode");
	Dev2LnkBase_AddFix(&mod->codeFix, Dev2LnkBase_FixTable__typ, addr, 1, sec);
	Dev2LnkBase_relCount += 1;
	__EXIT;
}

void Dev2LnkBase_FixRel (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec)
{
	__ENTER("Dev2LnkBase.FixRel");
	Dev2LnkBase_AddFix(&mod->codeFix, Dev2LnkBase_FixTable__typ, addr, 2, sec);
	__EXIT;
}

void Dev2LnkBase_FixData (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec)
{
	__ENTER("Dev2LnkBase.FixData");
	Dev2LnkBase_AddFix(&mod->dataFix, Dev2LnkBase_FixTable__typ, addr, 1, sec);
	Dev2LnkBase_relCount += 1;
	__EXIT;
}

void Dev2LnkBase_FixCopy (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec)
{
	__ENTER("Dev2LnkBase.FixCopy");
	Dev2LnkBase_AddFix(&mod->dataFix, Dev2LnkBase_FixTable__typ, addr, 5, sec);
	Dev2LnkBase_relCount += 1;
	__EXIT;
}

static INTEGER Dev2LnkBase_Get4 (BYTE *d, INTEGER d__len, INTEGER a)
{
	__ENTER("Dev2LnkBase.Get4");
	__EXIT;
	return __ASHL(__ASHL(__ASHL((INTEGER)d[__X(a + 3, d__len)], 8, INTEGER) + __MASK((INTEGER)d[__X(a + 2, \
d__len)], -256), 8, INTEGER) + __MASK((INTEGER)d[__X(a + 1, d__len)], -256), 8, INTEGER) + __MASK((INTEGER)d[__X(a, \
d__len)], -256);
}

static void Dev2LnkBase_Put4 (BYTE *d, INTEGER d__len, INTEGER a, INTEGER x)
{
	__ENTER("Dev2LnkBase.Put4");
	d[__X(a, d__len)] = (BYTE)x;
	d[__X(a + 1, d__len)] = (BYTE)__ASHR(x, 8, INTEGER);
	d[__X(a + 2, d__len)] = (BYTE)__ASHR(x, 16, INTEGER);
	d[__X(a + 3, d__len)] = (BYTE)__ASHR(x, 24, INTEGER);
	__EXIT;
}

void Dev2LnkBase_AddReloc (INTEGER addr)
{
	__ENTER("Dev2LnkBase.AddReloc");
	(Dev2LnkBase_relTab->data)[__X(Dev2LnkBase_relCount, Dev2LnkBase_relTab->len[0])] = addr;
	Dev2LnkBase_relCount += 1;
	__EXIT;
}

static struct DoFixups__12 {
	struct DoFixups__12 *lnk;
} *DoFixups__12_s;

static void __13 (Dev2LnkBase_FixTable t);

static void __13 (Dev2LnkBase_FixTable t)
{
	INTEGER i, offs, old, new;
	Dev2LnkBase_Section tsec = NIL;
	Dev2LnkBase_Section ssec = NIL;
	INTEGER _for__18;
	struct BYTE_ARRAY *_ptr__17 = NIL;
	struct BYTE_ARRAY *_ptr__16 = NIL;
	struct BYTE_ARRAY *_ptr__15 = NIL;
	__ENTER("Dev2LnkBase.DoFix");
	tsec = t.sec;
	_for__18 = t.len - 1;
	i = 0;
	while (i <= _for__18) {
		offs = (t.tab->data)[__X(i, t.tab->len[0])].offs;
		ssec = (t.tab->data)[__X(i, t.tab->len[0])].sec;
		old = (_ptr__17 = tsec->bytes, 
			Dev2LnkBase_Get4(_ptr__17->data, _ptr__17->len[0], offs));
		switch ((t.tab->data)[__X(i, t.tab->len[0])].ftype) {
			case 1: 
				new = ssec->addr + old;
				Dev2LnkBase_AddReloc(t.sec->addr + offs);
				break;
			case 2: 
				new = (ssec->addr - t.sec->addr) + old;
				break;
			case 5: 
				new = (_ptr__16 = ssec->bytes, 
					Dev2LnkBase_Get4(_ptr__16->data, _ptr__16->len[0], old));
				if (new != 0) {
					Dev2LnkBase_AddReloc(t.sec->addr + offs);
				}
				break;
			default: __CASECHK;
		}
		_ptr__15 = tsec->bytes;
		Dev2LnkBase_Put4(_ptr__15->data, _ptr__15->len[0], offs, new);
		i += 1;
	}
	__EXIT;
}

void Dev2LnkBase_DoFixups (void)
{
	Dev2LnkBase_Module mod = NIL;
	struct DoFixups__12 _s;
	__ENTER("Dev2LnkBase.DoFixups");
	_s.lnk = DoFixups__12_s;
	DoFixups__12_s = &_s;
	Dev2LnkBase_relTab = __NEWARR(4, Dev2LnkBase_relCount + Dev2LnkBase_impCount);
	Dev2LnkBase_relCount = 0;
	__13(Dev2LnkBase_initMod->codeFix);
	mod = Dev2LnkBase_modList;
	while (mod != NIL) {
		__13(mod->dataFix);
		__13(mod->codeFix);
		mod = mod->next;
	}
	DoFixups__12_s = _s.lnk;
	__EXIT;
}

static struct SortReloc__56 {
	struct SortReloc__56 *lnk;
} *SortReloc__56_s;

static void __57 (INTEGER l, INTEGER r);

static void __57 (INTEGER l, INTEGER r)
{
	INTEGER i, j, x, t;
	__ENTER("Dev2LnkBase.QuickSort");
	i = l;
	j = r;
	x = (Dev2LnkBase_relTab->data)[__X(__ASHR(l + r, 1, INTEGER), Dev2LnkBase_relTab->len[0])];
	do {
		while ((Dev2LnkBase_relTab->data)[__X(i, Dev2LnkBase_relTab->len[0])] < x) {
			i += 1;
		}
		while ((Dev2LnkBase_relTab->data)[__X(j, Dev2LnkBase_relTab->len[0])] > x) {
			j -= 1;
		}
		if (i <= j) {
			t = (Dev2LnkBase_relTab->data)[__X(i, Dev2LnkBase_relTab->len[0])];
			(Dev2LnkBase_relTab->data)[__X(i, Dev2LnkBase_relTab->len[0])] = (Dev2LnkBase_relTab->data)[__X(j, \
Dev2LnkBase_relTab->len[0])];
			(Dev2LnkBase_relTab->data)[__X(j, Dev2LnkBase_relTab->len[0])] = t;
			i += 1;
			j -= 1;
		}
	} while (!(i > j));
	if (l < j) {
		__57(l, j);
	}
	if (i < r) {
		__57(i, r);
	}
	__EXIT;
}

void Dev2LnkBase_SortReloc (void)
{
	struct SortReloc__56 _s;
	__ENTER("Dev2LnkBase.SortReloc");
	_s.lnk = SortReloc__56_s;
	SortReloc__56_s = &_s;
	__57(0, Dev2LnkBase_relCount - 1);
	SortReloc__56_s = _s.lnk;
	__EXIT;
}

void Dev2LnkBase_InitStringTable (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER size)
{
	__ENTER("Dev2LnkBase.InitStringTable");
	if (size > 0 && ((*t).tab == NIL || (*t).tab->len[0] < size)) {
		(*t).tab = __NEWARR(1, size);
	}
	(*t).len = 0;
	__EXIT;
}

static void Dev2LnkBase_CheckStrSize (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER len)
{
	struct SHORTCHAR_ARRAY *newtab = NIL;
	INTEGER i;
	__ENTER("Dev2LnkBase.CheckStrSize");
	if ((*t).tab == NIL) {
		(*t).tab = __NEWARR(1, 500);
	} else if ((*t).len + len >= (*t).tab->len[0]) {
		newtab = __NEWARR(1, __ASHL((*t).tab->len[0], 1, INTEGER));
		i = 0;
		while (i < (*t).tab->len[0]) {
			(newtab->data)[__X(i, newtab->len[0])] = ((*t).tab->data)[__X(i, (*t).tab->len[0])];
			i += 1;
		}
		(*t).tab = newtab;
	}
	__EXIT;
}

void Dev2LnkBase_AddName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, SHORTCHAR *name, INTEGER \
name__len, INTEGER *idx)
{
	INTEGER i, len;
	__ENTER("Dev2LnkBase.AddName");
	len = __STRLENS(name);
	Dev2LnkBase_CheckStrSize(t, t__typ, len);
	*idx = (*t).len;
	i = 0;
	while (name[__X(i, name__len)] != 0) {
		((*t).tab->data)[__X((*t).len, (*t).tab->len[0])] = name[__X(i, name__len)];
		(*t).len += 1;
		i += 1;
	}
	((*t).tab->data)[__X((*t).len, (*t).tab->len[0])] = 0;
	(*t).len += 1;
	if (__ODD((*t).len)) {
		((*t).tab->data)[__X((*t).len, (*t).tab->len[0])] = 0;
		(*t).len += 1;
	}
	__EXIT;
}

void Dev2LnkBase_AddHintName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER hint, SHORTCHAR \
*name, INTEGER name__len, INTEGER *idx)
{
	INTEGER i;
	__ENTER("Dev2LnkBase.AddHintName");
	Dev2LnkBase_CheckStrSize(t, t__typ, 2);
	*idx = (*t).len;
	((*t).tab->data)[__X((*t).len, (*t).tab->len[0])] = (SHORTCHAR)hint;
	(*t).len += 1;
	((*t).tab->data)[__X((*t).len, (*t).tab->len[0])] = (SHORTCHAR)__ASHR(hint, 8, INTEGER);
	(*t).len += 1;
	Dev2LnkBase_AddName(t, t__typ, name, name__len, &i);
	__EXIT;
}

void Dev2LnkBase_AddDllName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, SHORTCHAR *name, INTEGER \
name__len, SHORTCHAR *ext, INTEGER ext__len, INTEGER *idx)
{
	INTEGER i, dot;
	struct SHORTCHAR_ARRAY *_ptr__2 = NIL;
	__ENTER("Dev2LnkBase.AddDllName");
	i = 0;
	dot = 0;
	while (name[__X(i, name__len)] != 0) {
		if (name[__X(i, name__len)] == (SHORTCHAR)'.') {
			dot = i;
		}
		i += 1;
	}
	if (dot > 0) {
		Dev2LnkBase_AddName(t, t__typ, name, name__len, idx);
	} else {
		_ptr__2 = __NEWARR(1, name__len + ext__len);
		__STRCOPYSS(name, _ptr__2->data, _ptr__2->len[0]);
		__STRAPNDSS(ext, _ptr__2->data, _ptr__2->len[0]);
		Dev2LnkBase_AddName(t, t__typ, (void*)_ptr__2->data, __STRLENS(_ptr__2->data) + 1, idx);
	}
	__EXIT;
}

void Dev2LnkBase_WriteStringTable (Files_Writer out, Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ)
{
	INTEGER i;
	__ENTER("Dev2LnkBase.WriteStringTable");
	i = 0;
	while (i != (*t).len) {
		__Files_Writer_WriteByte(out, (BYTE)((*t).tab->data)[__X(i, (*t).tab->len[0])]);
		i += 1;
	}
	__EXIT;
}

INTEGER Dev2LnkBase_Aligned (INTEGER pos, INTEGER alignment)
{
	__ENTER("Dev2LnkBase.Aligned");
	__EXIT;
	return __DIVF(pos + (alignment - 1), alignment) * alignment;
}

static struct ThisObjFile__60 {
	CHAR *modName;
	INTEGER modName__len;
	struct ThisObjFile__60 *lnk;
} *ThisObjFile__60_s;

static Files_File __61 (CHAR *path, INTEGER path__len, CHAR *modMame, INTEGER modMame__len, BOOLEAN legacy);

static Files_File __61 (CHAR *path, INTEGER path__len, CHAR *modMame, INTEGER modMame__len, BOOLEAN legacy)
{
	Files_File f = NIL;
	Files_Locator loc = NIL;
	Files_Name dir, fname;
	__ENTER("Dev2LnkBase.Old");
	loc = __Files_Directory_This(Files_dir, (void*)path, path__len);
	if (legacy) {
		Kernel_SplitName(ThisObjFile__60_s->modName, ThisObjFile__60_s->modName__len, (void*)dir, 256, (void*)fname, \
256);
		Kernel_MakeFileName((void*)fname, 256, (CHAR*)((CHAR[]){111, 99, 102, 0}), 4);
		loc = __Files_Locator_This(__Files_Locator_This(loc, (void*)dir, 256), (void*)((CHAR[]){67, 111, 100, \
101, 0}), 5);
		f = __Files_Directory_Old(Files_dir, loc, fname, 1);
		if (f == NIL && dir[0] == 0) {
			loc = __Files_Locator_This(__Files_Locator_This(__Files_Directory_This(Files_dir, (void*)path, path__len), \
(void*)((CHAR[]){83, 121, 115, 116, 101, 109, 0}), 7), (void*)((CHAR[]){67, 111, 100, 101, 0}), 5);
			f = __Files_Directory_Old(Files_dir, loc, fname, 1);
		}
	} else {
		__STRCOPYLL(ThisObjFile__60_s->modName, fname, 256);
		Kernel_MakeFileName((void*)fname, 256, (CHAR*)((CHAR[]){111, 99, 102, 0}), 4);
		f = __Files_Directory_Old(Files_dir, loc, fname, 1);
	}
	__EXIT;
	return f;
}

Files_File Dev2LnkBase_ThisObjFile (CHAR *modName, INTEGER modName__len)
{
	Files_File f = NIL;
	Dev2LnkBase_Directory d = NIL;
	struct ThisObjFile__60 _s;
	__ENTER("Dev2LnkBase.ThisObjFile");
	_s.modName = (void*)modName; _s.modName__len = modName__len;
	_s.lnk = ThisObjFile__60_s;
	ThisObjFile__60_s = &_s;
	f = NIL;
	d = Dev2LnkBase_objList;
	while (f == NIL && d != NIL) {
		f = __61((void*)d->path, 256, (void*)modName, modName__len, d->legacy);
		d = d->next;
	}
	ThisObjFile__60_s = _s.lnk;
	__EXIT;
	return f;
}

static void Dev2LnkBase_CountDllSizes (void)
{
	Dev2LnkBase_Module lib = NIL;
	__ENTER("Dev2LnkBase.CountDllSizes");
	lib = Dev2LnkBase_dllList;
	Dev2LnkBase_codeSize += Dev2LnkBase_pltIniSize;
	while (lib != NIL) {
		Dev2LnkBase_codeSize += lib->code->size;
		lib = lib->next;
	}
	__EXIT;
}

static struct GenInitCode__27 {
	INTEGER *init, *fini, *cp;
	struct BYTE_ARRAY **bytes;
	struct GenInitCode__27 *lnk;
} *GenInitCode__27_s;

static void __29 (SHORTCHAR c);
static void __31 (SHORTCHAR c, INTEGER x);
static void __33 (SHORTCHAR x0, SHORTCHAR x1);
static void __35 (SHORTCHAR x0, SHORTCHAR x1, SHORTCHAR x2);
static void __37 (void);
static void __39 (Dev2LnkBase_Module mod);
static void __41 (void);
static void __43 (Dev2LnkBase_Module mod);
static void __45 (void);

static void __29 (SHORTCHAR c)
{
	__ENTER("Dev2LnkBase.Emit1");
	(((*GenInitCode__27_s->bytes))->data)[__X((*GenInitCode__27_s->cp), ((*GenInitCode__27_s->bytes))->len[0])] \
= (BYTE)c;
	(*GenInitCode__27_s->cp) += 1;
	__EXIT;
}

static void __33 (SHORTCHAR x0, SHORTCHAR x1)
{
	__ENTER("Dev2LnkBase.Emit2");
	__29(x0);
	__29(x1);
	__EXIT;
}

static void __35 (SHORTCHAR x0, SHORTCHAR x1, SHORTCHAR x2)
{
	__ENTER("Dev2LnkBase.Emit3");
	__29(x0);
	__29(x1);
	__29(x2);
	__EXIT;
}

static void __31 (SHORTCHAR c, INTEGER x)
{
	__ENTER("Dev2LnkBase.Emit1W");
	(((*GenInitCode__27_s->bytes))->data)[__X((*GenInitCode__27_s->cp), ((*GenInitCode__27_s->bytes))->len[0])] \
= (BYTE)c;
	(((*GenInitCode__27_s->bytes))->data)[__X((*GenInitCode__27_s->cp) + 1, ((*GenInitCode__27_s->bytes))->len[0])] \
= (BYTE)x;
	(((*GenInitCode__27_s->bytes))->data)[__X((*GenInitCode__27_s->cp) + 2, ((*GenInitCode__27_s->bytes))->len[0])] \
= (BYTE)__ASHR(x, 8, INTEGER);
	(((*GenInitCode__27_s->bytes))->data)[__X((*GenInitCode__27_s->cp) + 3, ((*GenInitCode__27_s->bytes))->len[0])] \
= (BYTE)__ASHR(x, 16, INTEGER);
	(((*GenInitCode__27_s->bytes))->data)[__X((*GenInitCode__27_s->cp) + 4, ((*GenInitCode__27_s->bytes))->len[0])] \
= (BYTE)__ASHR(x, 24, INTEGER);
	(*GenInitCode__27_s->cp) += 5;
	__EXIT;
}

static void __41 (void)
{
	__ENTER("Dev2LnkBase.InitDynamic");
	__31(187, Dev2LnkBase_lastMod->mDesc);
	Dev2LnkBase_FixCode(Dev2LnkBase_initMod, (*GenInitCode__27_s->cp) - 4, Dev2LnkBase_lastMod->data);
	__31(232, -(*GenInitCode__27_s->cp) - 5);
	Dev2LnkBase_FixRel(Dev2LnkBase_initMod, (*GenInitCode__27_s->cp) - 4, Dev2LnkBase_mainMod->code);
	__EXIT;
}

static void __43 (Dev2LnkBase_Module mod)
{
	__ENTER("Dev2LnkBase.InitStatic");
	while (mod != NIL) {
		if (mod == Dev2LnkBase_kernelMod || mod == Dev2LnkBase_mainMod) {
			__31(187, Dev2LnkBase_lastMod->mDesc);
			Dev2LnkBase_FixCode(Dev2LnkBase_initMod, (*GenInitCode__27_s->cp) - 4, Dev2LnkBase_lastMod->data);
		}
		__31(232, -(*GenInitCode__27_s->cp) - 5);
		Dev2LnkBase_FixRel(Dev2LnkBase_initMod, (*GenInitCode__27_s->cp) - 4, mod->code);
		mod = mod->next;
	}
	__EXIT;
}

static void __37 (void)
{
	__ENTER("Dev2LnkBase.FiniDynamic");
	if (Dev2LnkBase_mainMod->termadr != 0) {
		__31(232, (Dev2LnkBase_mainMod->termadr - (*GenInitCode__27_s->cp)) - 5);
		Dev2LnkBase_FixRel(Dev2LnkBase_initMod, (*GenInitCode__27_s->cp) - 4, Dev2LnkBase_mainMod->code);
	}
	__29(195);
	__EXIT;
}

static void __39 (Dev2LnkBase_Module mod)
{
	__ENTER("Dev2LnkBase.FiniStatic");
	if (mod != NIL) {
		__39(mod->next);
		if (mod->termadr != 0) {
			__31(232, (mod->termadr - (*GenInitCode__27_s->cp)) - 5);
			Dev2LnkBase_FixRel(Dev2LnkBase_initMod, (*GenInitCode__27_s->cp) - 4, mod->code);
		}
	}
	__EXIT;
}

static void __45 (void)
{
	__ENTER("Dev2LnkBase.WinDllMain");
	__29((SHORTCHAR)'U');
	__33(137, 229);
	__35(139, (SHORTCHAR)'E', 12);
	__35(131, 248, 1);
	__33((SHORTCHAR)'t', 11);
	__33(133, 192);
	__33((SHORTCHAR)'u', 12);
	__31(232, ((*GenInitCode__27_s->fini) - (*GenInitCode__27_s->cp)) - 5);
	__33(235, 5);
	__31(232, ((*GenInitCode__27_s->init) - (*GenInitCode__27_s->cp)) - 5);
	__31(184, 1);
	__29(201);
	__35(194, 12, 0);
	__EXIT;
}

static void Dev2LnkBase_GenInitCode (void)
{
	INTEGER init, fini, dllmain, cp;
	struct BYTE_ARRAY *bytes = NIL;
	Dev2LnkBase_Module _ptr__28 = NIL;
	struct GenInitCode__27 _s;
	__ENTER("Dev2LnkBase.GenInitCode");
	_s.init = &init;
	_s.fini = &fini;
	_s.cp = &cp;
	_s.bytes = &bytes;
	_s.lnk = GenInitCode__27_s;
	GenInitCode__27_s = &_s;
	Dev2LnkBase_initMod = __NEW(Dev2LnkBase_Module__rec__typ);
	Dev2LnkBase_initMod->code = Dev2LnkBase_NewSection(50 + 10 * Dev2LnkBase_modCount);
	Dev2LnkBase_initMod->code->bytes = __NEWARR(3, Dev2LnkBase_initMod->code->size);
	_ptr__28 = Dev2LnkBase_initMod;
	Dev2LnkBase_InitFixTable(&_ptr__28->codeFix, Dev2LnkBase_FixTable__typ, Dev2LnkBase_initMod->code);
	bytes = Dev2LnkBase_initMod->code->bytes;
	cp = 0;
	init = cp;
	if (Dev2LnkBase_dynaInit) {
		__41();
	} else {
		__43(Dev2LnkBase_modList);
	}
	if (Dev2LnkBase_outDll) {
		__29(195);
	}
	fini = cp;
	if (Dev2LnkBase_dynaInit) {
		__37();
	} else {
		__39(Dev2LnkBase_modList);
	}
	__29(195);
	Dev2LnkBase_initOffs = init;
	Dev2LnkBase_finiOffs = fini;
	if (Dev2LnkBase_outDll && Dev2LnkBase_outPe) {
		dllmain = cp;
		__45();
		Dev2LnkBase_initOffs = dllmain;
	}
	Dev2LnkBase_initMod->code->size = cp;
	Dev2LnkBase_codeSize += Dev2LnkBase_initMod->code->size;
	GenInitCode__27_s = _s.lnk;
	__EXIT;
}

void Dev2LnkBase_BeginLinking (void)
{
	__ENTER("Dev2LnkBase.BeginLinking");
	if (Dev2LnkBase_mainMod == NIL) {
		Dev2LnkBase_mainMod = Dev2LnkBase_lastMod;
	}
	if (Dev2LnkBase_outputName[0] == 0) {
		__STRCOPYSL(Dev2LnkBase_mainMod->name, Dev2LnkBase_outputName, 256);
		Kernel_MakeFileName((void*)Dev2LnkBase_outputName, 256, Dev2LnkBase_outputType, 16);
	}
	Dev2LnkBase_GenInitCode();
	Dev2LnkBase_CountDllSizes();
	__EXIT;
}

void Dev2LnkBase_SetAddr (INTEGER codeBase, INTEGER dataBase, INTEGER varsBase)
{
	Dev2LnkBase_Module mod = NIL;
	Dev2LnkBase_Symbol sym = NIL;
	__ENTER("Dev2LnkBase.SetAddr");
	mod = Dev2LnkBase_initMod;
	mod->code->addr = codeBase;
	codeBase += mod->code->size;
	mod = Dev2LnkBase_modList;
	while (mod != NIL) {
		mod->code->addr = codeBase;
		codeBase += mod->code->size;
		mod->data->addr = dataBase;
		dataBase += mod->data->size;
		mod->vars->addr = varsBase;
		varsBase += mod->vars->size;
		mod = mod->next;
	}
	codeBase += Dev2LnkBase_pltIniSize;
	mod = Dev2LnkBase_dllList;
	while (mod != NIL) {
		mod->code->addr = codeBase;
		codeBase += mod->code->size;
		sym = mod->exp->next;
		while (sym != NIL) {
			sym->addr += mod->code->addr;
			sym = sym->next;
		}
		mod = mod->next;
	}
	sym = Dev2LnkBase_expList;
	while (sym != NIL) {
		sym->addr += sym->sect->addr;
		sym = sym->next;
	}
	__EXIT;
}

static INTEGER Dev2LnkBase_Section__rec__flds[] = {
	3, 
	0, 0, 1<<8 | 0x45, 6,
	0, 4, 6<<8 | 0x45, 6,
	0, 8, 11<<8 | 0x45, (INTEGER)Dev2LnkBase__1__desc,
};
export INTEGER Dev2LnkBase_Section__rec__desc[] = {
	-1, 
	0, 
	12,
	(INTEGER)&Dev2LnkBase__desc,
	17<<8 | 0x01,
	(INTEGER)(Dev2LnkBase_Section__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkBase_Section__rec__flds, 
	8, -8
};
export INTEGER Dev2LnkBase_BYTES__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	26<<8 | 0x12,
	4
};
export INTEGER Dev2LnkBase__1__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x03,
	(INTEGER)Dev2LnkBase_BYTES__desc
};
static INTEGER Dev2LnkBase_Symbol__rec__flds[] = {
	7, 
	0, 0, 32<<8 | 0x45, (INTEGER)Dev2LnkBase_Symbol__desc,
	0, 4, 37<<8 | 0x45, (INTEGER)Dev2LnkBase_Section__desc,
	0, 8, 1<<8 | 0x45, 6,
	0, 12, 42<<8 | 0x45, 6,
	0, 16, 49<<8 | 0x45, 6,
	0, 20, 56<<8 | 0x45, (INTEGER)Dev2LnkBase_SName__desc,
	0, 276, 61<<8 | 0x45, 6,
};
export INTEGER Dev2LnkBase_Symbol__rec__desc[] = {
	-1, 
	0, 
	280,
	(INTEGER)&Dev2LnkBase__desc,
	65<<8 | 0x01,
	(INTEGER)(Dev2LnkBase_Symbol__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkBase_Symbol__rec__flds, 
	0, 4, -12
};
export INTEGER Dev2LnkBase_Symbol__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	73<<8 | 0x03,
	(INTEGER)(Dev2LnkBase_Symbol__rec__desc + 2)
};
export INTEGER Dev2LnkBase_Section__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	80<<8 | 0x03,
	(INTEGER)(Dev2LnkBase_Section__rec__desc + 2)
};
export INTEGER Dev2LnkBase_SName__desc[] = {
	256,
	(INTEGER)&Dev2LnkBase__desc,
	88<<8 | 0x02,
	2
};
static INTEGER Dev2LnkBase_FixRec__flds[] = {
	3, 
	0, 0, 94<<8 | 0x45, 6,
	0, 4, 100<<8 | 0x45, 6,
	0, 8, 105<<8 | 0x45, (INTEGER)Dev2LnkBase_Section__desc,
};
export INTEGER Dev2LnkBase_FixRec__desc[] = {
	-1, 
	0, 
	12,
	(INTEGER)&Dev2LnkBase__desc,
	109<<8 | 0x01,
	(INTEGER)(Dev2LnkBase_FixRec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkBase_FixRec__flds, 
	8, -8
};
static INTEGER Dev2LnkBase_FixTable__flds[] = {
	3, 
	0, 0, 105<<8 | 0x25, (INTEGER)Dev2LnkBase_Section__desc,
	0, 4, 116<<8 | 0x25, (INTEGER)Dev2LnkBase__3__desc,
	0, 8, 120<<8 | 0x25, 6,
};
export INTEGER Dev2LnkBase_FixTable__desc[] = {
	-1, 
	0, 
	12,
	(INTEGER)&Dev2LnkBase__desc,
	124<<8 | 0x01,
	(INTEGER)(Dev2LnkBase_FixTable__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkBase_FixTable__flds, 
	0, 4, -12
};
export INTEGER Dev2LnkBase__2__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x12,
	(INTEGER)(Dev2LnkBase_FixRec__desc + 2)
};
export INTEGER Dev2LnkBase__3__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x03,
	(INTEGER)Dev2LnkBase__2__desc
};
static INTEGER Dev2LnkBase_StringTable__flds[] = {
	2, 
	0, 0, 116<<8 | 0x25, (INTEGER)Dev2LnkBase__5__desc,
	0, 4, 120<<8 | 0x25, 6,
};
export INTEGER Dev2LnkBase_StringTable__desc[] = {
	-1, 
	0, 
	8,
	(INTEGER)&Dev2LnkBase__desc,
	133<<8 | 0x01,
	(INTEGER)(Dev2LnkBase_StringTable__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkBase_StringTable__flds, 
	0, -8
};
export INTEGER Dev2LnkBase__4__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x12,
	2
};
export INTEGER Dev2LnkBase__5__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x03,
	(INTEGER)Dev2LnkBase__4__desc
};
static INTEGER Dev2LnkBase_Module__rec__flds[] = {
	12, 
	0, 0, 32<<8 | 0x45, (INTEGER)Dev2LnkBase_Module__desc,
	0, 4, 56<<8 | 0x45, (INTEGER)Dev2LnkBase_Name__desc,
	0, 260, 145<<8 | 0x45, (INTEGER)Dev2LnkBase_Section__desc,
	0, 264, 150<<8 | 0x45, (INTEGER)Dev2LnkBase_Section__desc,
	0, 268, 155<<8 | 0x45, (INTEGER)Dev2LnkBase_Section__desc,
	0, 272, 160<<8 | 0x45, (INTEGER)(Dev2LnkBase_FixTable__desc + 2),
	0, 284, 168<<8 | 0x45, (INTEGER)(Dev2LnkBase_FixTable__desc + 2),
	0, 296, 176<<8 | 0x45, 6,
	0, 300, 182<<8 | 0x45, 6,
	0, 304, 190<<8 | 0x45, 1,
	0, 305, 196<<8 | 0x45, 1,
	0, 308, 205<<8 | 0x45, (INTEGER)Dev2LnkBase_Symbol__desc,
};
export INTEGER Dev2LnkBase_Module__rec__desc[] = {
	-1, 
	0, 
	312,
	(INTEGER)&Dev2LnkBase__desc,
	209<<8 | 0x01,
	(INTEGER)(Dev2LnkBase_Module__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkBase_Module__rec__flds, 
	0, 260, 264, 268, 272, 276, 284, 288, 308, -40
};
export INTEGER Dev2LnkBase_Module__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	217<<8 | 0x03,
	(INTEGER)(Dev2LnkBase_Module__rec__desc + 2)
};
export INTEGER Dev2LnkBase_Name__desc[] = {
	256,
	(INTEGER)&Dev2LnkBase__desc,
	224<<8 | 0x02,
	2
};
static INTEGER Dev2LnkBase_Directory__rec__flds[] = {
	3, 
	0, 0, 229<<8 | 0x45, (INTEGER)Files_Name__desc,
	0, 512, 234<<8 | 0x45, 1,
	0, 516, 32<<8 | 0x45, (INTEGER)Dev2LnkBase_Directory__desc,
};
export INTEGER Dev2LnkBase_Directory__rec__desc[] = {
	-1, 
	0, 
	520,
	(INTEGER)&Dev2LnkBase__desc,
	241<<8 | 0x01,
	(INTEGER)(Dev2LnkBase_Directory__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkBase_Directory__rec__flds, 
	516, -8
};
export INTEGER Dev2LnkBase_Directory__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	252<<8 | 0x03,
	(INTEGER)(Dev2LnkBase_Directory__rec__desc + 2)
};
static INTEGER Dev2LnkBase__8__flds[] = {
	6, 
	0, 0, 262<<8 | 0x45, 6,
	0, 4, 272<<8 | 0x45, 6,
	0, 8, 282<<8 | 0x45, 1,
	0, 9, 292<<8 | 0x45, (INTEGER)Dev2LnkBase__6__desc,
	0, 137, 307<<8 | 0x45, (INTEGER)Dev2LnkBase__7__desc,
	0, 265, 313<<8 | 0x45, 2,
};
export INTEGER Dev2LnkBase__8__desc[] = {
	-1, 
	0, 
	268,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x01,
	(INTEGER)(Dev2LnkBase__8__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkBase__8__flds, 
	-4
};
export INTEGER Dev2LnkBase__6__desc[] = {
	128,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x02,
	2
};
export INTEGER Dev2LnkBase__7__desc[] = {
	128,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x02,
	2
};
export INTEGER Dev2LnkBase_STRING__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	319<<8 | 0x12,
	2
};
export INTEGER Dev2LnkBase__9__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x12,
	6
};
export INTEGER Dev2LnkBase__10__desc[] = {
	0,
	(INTEGER)&Dev2LnkBase__desc,
	0<<8 | 0x03,
	(INTEGER)Dev2LnkBase__9__desc
};
static SYSTEM_MODDESC *Dev2LnkBase__imp[] = {
	&Files__desc,
	&Kernel__desc,
	&Log__desc,
};
static INTEGER Dev2LnkBase__exp[] = {
	84,
	0x198d2333, (INTEGER)Dev2LnkBase_AddDllName, 326<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkBase_AddFix, 337<<8 | 0x14, 0,
	0x6caac479, (INTEGER)Dev2LnkBase_AddHintName, 344<<8 | 0x44, 0,
	0x61772a28, (INTEGER)Dev2LnkBase_AddName, 356<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)Dev2LnkBase_AddReloc, 364<<8 | 0x44, 0,
	0xbbb8c781, (INTEGER)Dev2LnkBase_Aligned, 373<<8 | 0x44, 0,
	0xf0442620, 0xf0442620, 26<<8 | 0x42, (INTEGER)Dev2LnkBase_BYTES__desc,
	0x5814f4d6, (INTEGER)Dev2LnkBase_BeginLinking, 381<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkBase_CheckFixSize, 394<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkBase_CheckStrSize, 407<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkBase_CountDllSizes, 420<<8 | 0x14, 0,
	0x0a420fc4, 0x0a420fc4, 252<<8 | 0x42, (INTEGER)Dev2LnkBase_Directory__desc,
	0x54e1c758, 0x2e3be0f3, 241<<8 | 0x12, (INTEGER)(Dev2LnkBase_Directory__rec__desc + 2),
	0x5814f4d6, (INTEGER)Dev2LnkBase_DoFixups, 434<<8 | 0x44, 0,
	0xf082c441, (INTEGER)Dev2LnkBase_Error, 443<<8 | 0x44, 0,
	0x147ba2f3, (INTEGER)Dev2LnkBase_ExportProc, 449<<8 | 0x44, 0,
	0x147ba2f3, (INTEGER)Dev2LnkBase_ExportVar, 460<<8 | 0x44, 0,
	0xdc2c70e2, (INTEGER)Dev2LnkBase_FixCode, 470<<8 | 0x44, 0,
	0xdc2c70e2, (INTEGER)Dev2LnkBase_FixCopy, 478<<8 | 0x44, 0,
	0xdc2c70e2, (INTEGER)Dev2LnkBase_FixData, 486<<8 | 0x44, 0,
	0x963decfd, 0x929dbb9d, 109<<8 | 0x42, (INTEGER)(Dev2LnkBase_FixRec__desc + 2),
	0xdc2c70e2, (INTEGER)Dev2LnkBase_FixRel, 494<<8 | 0x44, 0,
	0x39a4e685, 0x63fec961, 124<<8 | 0x42, (INTEGER)(Dev2LnkBase_FixTable__desc + 2),
	0x227d6f36, (INTEGER)Dev2LnkBase_GenInitCode, 501<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkBase_Get4, 513<<8 | 0x14, 0,
	0x57e82b87, (INTEGER)&Dev2LnkBase_ImageBase, 518<<8 | 0x43, 6,
	0x68e09563, (INTEGER)Dev2LnkBase_ImportProc, 528<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)Dev2LnkBase_Init, 539<<8 | 0x44, 0,
	0x3aec05b3, (INTEGER)Dev2LnkBase_InitFixTable, 544<<8 | 0x44, 0,
	0x43772802, (INTEGER)Dev2LnkBase_InitStringTable, 557<<8 | 0x44, 0,
	0x2ee99242, (INTEGER)&Dev2LnkBase_KernelName, 573<<8 | 0x43, (INTEGER)Dev2LnkBase_Name__desc,
	0xa69a226b, 0xa69a226b, 217<<8 | 0x42, (INTEGER)Dev2LnkBase_Module__desc,
	0x2786f41e, 0xc959bc52, 209<<8 | 0x12, (INTEGER)(Dev2LnkBase_Module__rec__desc + 2),
	0xa0673c20, 0xa0673c20, 224<<8 | 0x42, (INTEGER)Dev2LnkBase_Name__desc,
	0x4de50ae3, (INTEGER)Dev2LnkBase_NewSection, 584<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkBase_Put4, 595<<8 | 0x14, 0,
	0x7469f3a5, (INTEGER)Dev2LnkBase_RegMod, 600<<8 | 0x44, 0,
	0x8fe11ea3, 0x8fe11ea3, 88<<8 | 0x12, (INTEGER)Dev2LnkBase_SName__desc,
	0xa91209ab, 0xa91209ab, 319<<8 | 0x42, (INTEGER)Dev2LnkBase_STRING__desc,
	0xe983056b, 0xe983056b, 80<<8 | 0x42, (INTEGER)Dev2LnkBase_Section__desc,
	0x1473570e, 0xa5501230, 17<<8 | 0x12, (INTEGER)(Dev2LnkBase_Section__rec__desc + 2),
	0x9f3bd0bf, (INTEGER)Dev2LnkBase_SetAddr, 607<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)Dev2LnkBase_SortReloc, 615<<8 | 0x44, 0,
	0xb355d3b3, 0x74e93588, 133<<8 | 0x42, (INTEGER)(Dev2LnkBase_StringTable__desc + 2),
	0x11f2da61, 0x11f2da61, 73<<8 | 0x42, (INTEGER)Dev2LnkBase_Symbol__desc,
	0x8682dc48, 0x02cfacea, 65<<8 | 0x12, (INTEGER)(Dev2LnkBase_Symbol__rec__desc + 2),
	0xc1f3d5e0, (INTEGER)Dev2LnkBase_ThisDll, 625<<8 | 0x44, 0,
	0xf8b27db1, (INTEGER)Dev2LnkBase_ThisObjFile, 633<<8 | 0x44, 0,
	0xc0e9bfc4, (INTEGER)Dev2LnkBase_WriteStringTable, 645<<8 | 0x44, 0,
	0x8cff8310, (INTEGER)&Dev2LnkBase_codeSize, 662<<8 | 0x23, 6,
	0x8cff8310, (INTEGER)&Dev2LnkBase_dataSize, 671<<8 | 0x23, 6,
	0xe18ec28b, (INTEGER)&Dev2LnkBase_dllList, 680<<8 | 0x23, (INTEGER)Dev2LnkBase_Module__desc,
	0x44ec5d5b, (INTEGER)&Dev2LnkBase_dynaInit, 688<<8 | 0x43, 1,
	0x9ffbf5cc, (INTEGER)&Dev2LnkBase_error, 697<<8 | 0x23, 1,
	0x8cff8310, (INTEGER)&Dev2LnkBase_expCount, 703<<8 | 0x23, 6,
	0x531633d2, (INTEGER)&Dev2LnkBase_expList, 712<<8 | 0x23, (INTEGER)Dev2LnkBase_Symbol__desc,
	0x8cff8310, (INTEGER)&Dev2LnkBase_finiOffs, 720<<8 | 0x23, 6,
	0x8cff8310, (INTEGER)&Dev2LnkBase_impCount, 729<<8 | 0x23, 6,
	0x8cff8310, (INTEGER)&Dev2LnkBase_impDllCount, 738<<8 | 0x23, 6,
	0xe18ec28b, (INTEGER)&Dev2LnkBase_initMod, 750<<8 | 0x23, (INTEGER)Dev2LnkBase_Module__desc,
	0x8cff8310, (INTEGER)&Dev2LnkBase_initOffs, 758<<8 | 0x23, 6,
	0x3a996a1c, (INTEGER)&Dev2LnkBase_kernelMod, 767<<8 | 0x43, (INTEGER)Dev2LnkBase_Module__desc,
	0xe18ec28b, (INTEGER)&Dev2LnkBase_lastMod, 777<<8 | 0x23, (INTEGER)Dev2LnkBase_Module__desc,
	0x3a996a1c, (INTEGER)&Dev2LnkBase_mainMod, 785<<8 | 0x43, (INTEGER)Dev2LnkBase_Module__desc,
	0x2ee99242, (INTEGER)&Dev2LnkBase_mainName, 793<<8 | 0x43, (INTEGER)Dev2LnkBase_Name__desc,
	0x8cff8310, (INTEGER)&Dev2LnkBase_modCount, 802<<8 | 0x23, 6,
	0xe18ec28b, (INTEGER)&Dev2LnkBase_modList, 811<<8 | 0x23, (INTEGER)Dev2LnkBase_Module__desc,
	0x8e0d7545, (INTEGER)&Dev2LnkBase_objList, 819<<8 | 0x43, (INTEGER)Dev2LnkBase_Directory__desc,
	0x5d0d86b9, (INTEGER)&Dev2LnkBase_opt, 827<<8 | 0x43, (INTEGER)(Dev2LnkBase__8__desc + 2),
	0x9ffbf5cc, (INTEGER)&Dev2LnkBase_outDll, 831<<8 | 0x23, 1,
	0x9ffbf5cc, (INTEGER)&Dev2LnkBase_outElf, 838<<8 | 0x23, 1,
	0x9ffbf5cc, (INTEGER)&Dev2LnkBase_outPe, 845<<8 | 0x23, 1,
	0xdcfd0d85, (INTEGER)&Dev2LnkBase_outputName, 851<<8 | 0x43, (INTEGER)Files_Name__desc,
	0xdcfd0d85, (INTEGER)&Dev2LnkBase_outputPath, 862<<8 | 0x43, (INTEGER)Files_Name__desc,
	0x93ff290c, (INTEGER)&Dev2LnkBase_outputType, 873<<8 | 0x23, (INTEGER)Files_Type__desc,
	0x1ee54c0a, (INTEGER)&Dev2LnkBase_pltEntrySize, 884<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkBase_pltIniSize, 897<<8 | 0x13, 6,
	0x8cff8310, (INTEGER)&Dev2LnkBase_relCount, 908<<8 | 0x23, 6,
	0x7ade6cc6, (INTEGER)&Dev2LnkBase_relTab, 917<<8 | 0x23, (INTEGER)Dev2LnkBase__10__desc,
	0x8cff8310, (INTEGER)&Dev2LnkBase_target, 924<<8 | 0x23, 6,
	0x44ec5d5b, (INTEGER)&Dev2LnkBase_trap, 931<<8 | 0x43, 1,
	0x528c19ed, 0, 936<<8 | 0x41, 0,
	0x564d045a, 0, 943<<8 | 0x41, 0,
	0x8cff8310, (INTEGER)&Dev2LnkBase_varsSize, 951<<8 | 0x23, 6,
};
static char Dev2LnkBase__names[] = {
	0,
	'a','d','d','r',0,
	's','i','z','e',0,
	'b','y','t','e','s',0,
	'S','e','c','t','i','o','n','^',0,
	'B','Y','T','E','S',0,
	'n','e','x','t',0,
	's','e','c','t',0,
	'n','a','m','I','d','x',0,
	's','y','m','I','d','x',0,
	'n','a','m','e',0,
	't','y','p',0,
	'S','y','m','b','o','l','^',0,
	'S','y','m','b','o','l',0,
	'S','e','c','t','i','o','n',0,
	'S','N','a','m','e',0,
	'f','t','y','p','e',0,
	'o','f','f','s',0,
	's','e','c',0,
	'F','i','x','R','e','c',0,
	't','a','b',0,
	'l','e','n',0,
	'F','i','x','T','a','b','l','e',0,
	'S','t','r','i','n','g','T','a','b','l','e',0,
	'd','a','t','a',0,
	'c','o','d','e',0,
	'v','a','r','s',0,
	'c','o','d','e','F','i','x',0,
	'd','a','t','a','F','i','x',0,
	'm','D','e','s','c',0,
	't','e','r','m','a','d','r',0,
	'i','s','D','l','l',0,
	'e','x','p','o','r','t','e','d',0,
	'e','x','p',0,
	'M','o','d','u','l','e','^',0,
	'M','o','d','u','l','e',0,
	'N','a','m','e',0,
	'p','a','t','h',0,
	'l','e','g','a','c','y',0,
	'D','i','r','e','c','t','o','r','y','^',0,
	'D','i','r','e','c','t','o','r','y',0,
	'i','m','a','g','e','B','a','s','e',0,
	's','u','b','s','y','s','t','e','m',0,
	'e','l','f','S','t','a','t','i','c',0,
	'e','l','f','I','n','t','e','r','p','r','e','t','e','r',0,
	'r','p','a','t','h',0,
	'O','S','A','B','I',0,
	'S','T','R','I','N','G',0,
	'A','d','d','D','l','l','N','a','m','e',0,
	'A','d','d','F','i','x',0,
	'A','d','d','H','i','n','t','N','a','m','e',0,
	'A','d','d','N','a','m','e',0,
	'A','d','d','R','e','l','o','c',0,
	'A','l','i','g','n','e','d',0,
	'B','e','g','i','n','L','i','n','k','i','n','g',0,
	'C','h','e','c','k','F','i','x','S','i','z','e',0,
	'C','h','e','c','k','S','t','r','S','i','z','e',0,
	'C','o','u','n','t','D','l','l','S','i','z','e','s',0,
	'D','o','F','i','x','u','p','s',0,
	'E','r','r','o','r',0,
	'E','x','p','o','r','t','P','r','o','c',0,
	'E','x','p','o','r','t','V','a','r',0,
	'F','i','x','C','o','d','e',0,
	'F','i','x','C','o','p','y',0,
	'F','i','x','D','a','t','a',0,
	'F','i','x','R','e','l',0,
	'G','e','n','I','n','i','t','C','o','d','e',0,
	'G','e','t','4',0,
	'I','m','a','g','e','B','a','s','e',0,
	'I','m','p','o','r','t','P','r','o','c',0,
	'I','n','i','t',0,
	'I','n','i','t','F','i','x','T','a','b','l','e',0,
	'I','n','i','t','S','t','r','i','n','g','T','a','b','l','e',0,
	'K','e','r','n','e','l','N','a','m','e',0,
	'N','e','w','S','e','c','t','i','o','n',0,
	'P','u','t','4',0,
	'R','e','g','M','o','d',0,
	'S','e','t','A','d','d','r',0,
	'S','o','r','t','R','e','l','o','c',0,
	'T','h','i','s','D','l','l',0,
	'T','h','i','s','O','b','j','F','i','l','e',0,
	'W','r','i','t','e','S','t','r','i','n','g','T','a','b','l','e',0,
	'c','o','d','e','S','i','z','e',0,
	'd','a','t','a','S','i','z','e',0,
	'd','l','l','L','i','s','t',0,
	'd','y','n','a','I','n','i','t',0,
	'e','r','r','o','r',0,
	'e','x','p','C','o','u','n','t',0,
	'e','x','p','L','i','s','t',0,
	'f','i','n','i','O','f','f','s',0,
	'i','m','p','C','o','u','n','t',0,
	'i','m','p','D','l','l','C','o','u','n','t',0,
	'i','n','i','t','M','o','d',0,
	'i','n','i','t','O','f','f','s',0,
	'k','e','r','n','e','l','M','o','d',0,
	'l','a','s','t','M','o','d',0,
	'm','a','i','n','M','o','d',0,
	'm','a','i','n','N','a','m','e',0,
	'm','o','d','C','o','u','n','t',0,
	'm','o','d','L','i','s','t',0,
	'o','b','j','L','i','s','t',0,
	'o','p','t',0,
	'o','u','t','D','l','l',0,
	'o','u','t','E','l','f',0,
	'o','u','t','P','e',0,
	'o','u','t','p','u','t','N','a','m','e',0,
	'o','u','t','p','u','t','P','a','t','h',0,
	'o','u','t','p','u','t','T','y','p','e',0,
	'p','l','t','E','n','t','r','y','S','i','z','e',0,
	'p','l','t','I','n','i','S','i','z','e',0,
	'r','e','l','C','o','u','n','t',0,
	'r','e','l','T','a','b',0,
	't','a','r','g','e','t',0,
	't','r','a','p',0,
	't','y','p','O','b','j',0,
	't','y','p','P','r','o','c',0,
	'v','a','r','s','S','i','z','e',0,
};
static INTEGER Dev2LnkBase__ptrs[] = {
	(INTEGER)&Dev2LnkBase_objList + 0, 
	(INTEGER)&Dev2LnkBase_kernelMod + 0, 
	(INTEGER)&Dev2LnkBase_mainMod + 0, 
	(INTEGER)&Dev2LnkBase_modList + 0, 
	(INTEGER)&Dev2LnkBase_lastMod + 0, 
	(INTEGER)&Dev2LnkBase_initMod + 0, 
	(INTEGER)&Dev2LnkBase_dllList + 0, 
	(INTEGER)&Dev2LnkBase_expList + 0, 
	(INTEGER)&Dev2LnkBase_relTab + 0, 
};
struct SYSTEM_MODDESC Dev2LnkBase__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 15}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Dev2LnkBase__body,
	0,
	3, /* nofimps */ 
	9, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Dev2LnkBase__names,
	Dev2LnkBase__ptrs,
	Dev2LnkBase__imp,
	(SYSTEM_DIRECTORY*)Dev2LnkBase__exp,
	"Dev2LnkBase"
};

export void Dev2LnkBase__reg()
{
	__BEGREG(Dev2LnkBase__desc);
	Kernel__reg();
	Files__reg();
	Log__reg();
	__REGMOD(Dev2LnkBase__desc);
	__ENDREG;
}

export void Dev2LnkBase__body()
{
	__BEGBODY(Dev2LnkBase__desc);
	Kernel__body();
	Files__body();
	Log__body();
	__ENDBODY;
}
