/*  CPfront 1.0 -48 */

#ifndef Dev2LnkBase__h
#define Dev2LnkBase__h

#include "SYSTEM.h"
#include "Files.h"

struct Dev2LnkBase__8 {
	INTEGER imageBase, subsystem;
	BOOLEAN elfStatic;
	SHORTCHAR elfInterpreter[128];
	SHORTCHAR rpath[128];
	SHORTCHAR OSABI;
};

typedef
	BYTE *Dev2LnkBase_BYTES;

typedef
	struct Dev2LnkBase_Directory__rec *Dev2LnkBase_Directory;

typedef
	struct Dev2LnkBase_Directory__rec {
		Files_Name path;
		BOOLEAN legacy;
		Dev2LnkBase_Directory next;
	} Dev2LnkBase_Directory__rec;

typedef
	struct Dev2LnkBase_Section__rec *Dev2LnkBase_Section;

typedef
	struct Dev2LnkBase_FixRec {
		INTEGER ftype, offs;
		Dev2LnkBase_Section sec;
	} Dev2LnkBase_FixRec;

typedef
	struct Dev2LnkBase_FixTable {
		Dev2LnkBase_Section sec;
		struct Dev2LnkBase_FixRec_ARRAY *tab;
		INTEGER len;
	} Dev2LnkBase_FixTable;

typedef
	struct Dev2LnkBase_Module__rec *Dev2LnkBase_Module;

typedef
	SHORTCHAR Dev2LnkBase_Name[256];

typedef
	struct Dev2LnkBase_Symbol__rec *Dev2LnkBase_Symbol;

typedef
	struct Dev2LnkBase_Module__rec {
		Dev2LnkBase_Module next;
		Dev2LnkBase_Name name;
		Dev2LnkBase_Section data, code, vars;
		Dev2LnkBase_FixTable codeFix, dataFix;
		INTEGER mDesc, termadr;
		BOOLEAN isDll, exported;
		Dev2LnkBase_Symbol exp;
	} Dev2LnkBase_Module__rec;

typedef
	SHORTCHAR Dev2LnkBase_SName[256];

typedef
	SHORTCHAR *Dev2LnkBase_STRING;

typedef
	struct Dev2LnkBase_Section__rec {
		INTEGER addr, size;
		struct BYTE_ARRAY *bytes;
	} Dev2LnkBase_Section__rec;

typedef
	struct Dev2LnkBase_StringTable {
		struct SHORTCHAR_ARRAY *tab;
		INTEGER len;
	} Dev2LnkBase_StringTable;

typedef
	struct Dev2LnkBase_Symbol__rec {
		Dev2LnkBase_Symbol next;
		Dev2LnkBase_Section sect;
		INTEGER addr, namIdx, symIdx;
		Dev2LnkBase_SName name;
		INTEGER typ;
	} Dev2LnkBase_Symbol__rec;


#ifndef Dev2LnkBase_FixRec_ARRAY_DEF
#define Dev2LnkBase_FixRec_ARRAY_DEF
typedef struct Dev2LnkBase_FixRec_ARRAY {
	INTEGER gc[3], len[1];
	Dev2LnkBase_FixRec data[1];
} Dev2LnkBase_FixRec_ARRAY;
#endif 

import BOOLEAN Dev2LnkBase_error;
import BOOLEAN Dev2LnkBase_trap;
import INTEGER Dev2LnkBase_target;
import BOOLEAN Dev2LnkBase_outPe, Dev2LnkBase_outElf, Dev2LnkBase_outDll;
import BOOLEAN Dev2LnkBase_dynaInit;
import Files_Name Dev2LnkBase_outputPath, Dev2LnkBase_outputName;
import Files_Type Dev2LnkBase_outputType;
import Dev2LnkBase_Name Dev2LnkBase_KernelName, Dev2LnkBase_mainName;
import Dev2LnkBase_Directory Dev2LnkBase_objList;
import Dev2LnkBase_Module Dev2LnkBase_kernelMod, Dev2LnkBase_mainMod;
import Dev2LnkBase_Module Dev2LnkBase_modList, Dev2LnkBase_lastMod, Dev2LnkBase_initMod, Dev2LnkBase_dllList;
import INTEGER Dev2LnkBase_modCount, Dev2LnkBase_impCount, Dev2LnkBase_impDllCount, Dev2LnkBase_expCount;
import Dev2LnkBase_Symbol Dev2LnkBase_expList;
import INTEGER Dev2LnkBase_ImageBase;
import INTEGER Dev2LnkBase_codeSize, Dev2LnkBase_dataSize, Dev2LnkBase_varsSize, Dev2LnkBase_initOffs, \
Dev2LnkBase_finiOffs, Dev2LnkBase_relCount;
import struct INTEGER_ARRAY *Dev2LnkBase_relTab;
import struct Dev2LnkBase__8 Dev2LnkBase_opt;

import INTEGER Dev2LnkBase_Section__rec__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Section__rec__typ;
import INTEGER Dev2LnkBase__1__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__1__typ;
import INTEGER Dev2LnkBase_BYTES__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_BYTES__typ;
import INTEGER Dev2LnkBase_Symbol__rec__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Symbol__rec__typ;
import INTEGER Dev2LnkBase_Symbol__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Symbol__typ;
import INTEGER Dev2LnkBase_Section__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Section__typ;
import INTEGER Dev2LnkBase_SName__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_SName__typ;
import INTEGER Dev2LnkBase_FixRec__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_FixRec__typ;
import INTEGER Dev2LnkBase_FixTable__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_FixTable__typ;
import INTEGER Dev2LnkBase__3__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__3__typ;
import INTEGER Dev2LnkBase__2__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__2__typ;
import INTEGER Dev2LnkBase_StringTable__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_StringTable__typ;
import INTEGER Dev2LnkBase__5__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__5__typ;
import INTEGER Dev2LnkBase__4__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__4__typ;
import INTEGER Dev2LnkBase_Module__rec__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Module__rec__typ;
import INTEGER Dev2LnkBase_Module__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Module__typ;
import INTEGER Dev2LnkBase_Name__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Name__typ;
import INTEGER Dev2LnkBase_Directory__rec__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Directory__rec__typ;
import INTEGER Dev2LnkBase_Directory__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_Directory__typ;
import INTEGER Dev2LnkBase__8__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__8__typ;
import INTEGER Dev2LnkBase__6__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__6__typ;
import INTEGER Dev2LnkBase__7__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__7__typ;
import INTEGER Dev2LnkBase_STRING__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase_STRING__typ;
import INTEGER Dev2LnkBase__10__desc[];
import SYSTEM_TYPEDESC *Dev2LnkBase__10__typ;

import void Dev2LnkBase_AddDllName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, SHORTCHAR *name, \
INTEGER name__len, SHORTCHAR *ext, INTEGER ext__len, INTEGER *idx);
import void Dev2LnkBase_AddHintName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER hint, \
SHORTCHAR *name, INTEGER name__len, INTEGER *idx);
import void Dev2LnkBase_AddName (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, SHORTCHAR *name, \
INTEGER name__len, INTEGER *idx);
import void Dev2LnkBase_AddReloc (INTEGER addr);
import INTEGER Dev2LnkBase_Aligned (INTEGER pos, INTEGER alignment);
import void Dev2LnkBase_BeginLinking (void);
import void Dev2LnkBase_DoFixups (void);
import void Dev2LnkBase_Error (CHAR *msg, INTEGER msg__len);
import void Dev2LnkBase_ExportProc (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER \
addr);
import void Dev2LnkBase_ExportVar (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER \
addr);
import void Dev2LnkBase_FixCode (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec);
import void Dev2LnkBase_FixCopy (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec);
import void Dev2LnkBase_FixData (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec);
import void Dev2LnkBase_FixRel (Dev2LnkBase_Module mod, INTEGER addr, Dev2LnkBase_Section sec);
import void Dev2LnkBase_ImportProc (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER \
*adr);
import void Dev2LnkBase_Init (INTEGER tgt);
import void Dev2LnkBase_InitFixTable (Dev2LnkBase_FixTable *t, SYSTEM_TYPEDESC *t__typ, Dev2LnkBase_Section \
sec);
import void Dev2LnkBase_InitStringTable (Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC *t__typ, INTEGER \
size);
import Dev2LnkBase_Section Dev2LnkBase_NewSection (INTEGER size);
import void Dev2LnkBase_RegMod (Dev2LnkBase_Module mod);
import void Dev2LnkBase_SetAddr (INTEGER codeBase, INTEGER dataBase, INTEGER varsBase);
import void Dev2LnkBase_SortReloc (void);
import Dev2LnkBase_Module Dev2LnkBase_ThisDll (SHORTCHAR *name, INTEGER name__len);
import Files_File Dev2LnkBase_ThisObjFile (CHAR *modName, INTEGER modName__len);
import void Dev2LnkBase_WriteStringTable (Files_Writer out, Dev2LnkBase_StringTable *t, SYSTEM_TYPEDESC \
*t__typ);

import void Dev2LnkBase__reg();
import void Dev2LnkBase__body();
import struct SYSTEM_MODDESC Dev2LnkBase__desc;

#endif
