/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Dev2LnkBase.h"
#include "Files.h"

typedef
	SHORTCHAR *Dev2LnkLoad_StrPtr;




export void Dev2LnkLoad_AddModule (CHAR *modname, INTEGER modname__len);
static void Dev2LnkLoad_CollectExports (Dev2LnkBase_Module mod);
static INTEGER Dev2LnkLoad_DWord (Dev2LnkBase_Module mod, INTEGER a);
export void Dev2LnkLoad_ExportAll (void);
export void Dev2LnkLoad_ExportModule (CHAR *modname, INTEGER modname__len);
export void Dev2LnkLoad_ExportVariable (CHAR *modname, INTEGER modname__len, SHORTCHAR *varname, INTEGER \
varname__len);
static INTEGER Dev2LnkLoad_Get3 (BYTE *d, INTEGER d__len, INTEGER a);
static INTEGER Dev2LnkLoad_Get4 (BYTE *d, INTEGER d__len, INTEGER a);
static void Dev2LnkLoad_GetDir (Dev2LnkBase_Module mod, INTEGER *pDir, INTEGER *numobj);
static Dev2LnkLoad_StrPtr Dev2LnkLoad_GetPName (Dev2LnkBase_Module mod, INTEGER idx);
static Dev2LnkBase_Module Dev2LnkLoad_LoadModule (SHORTCHAR *modName, INTEGER modName__len);
static INTEGER Dev2LnkLoad_MWord (Dev2LnkBase_Module mod, INTEGER offs);
export void Dev2LnkLoad_MainModule (CHAR *modname, INTEGER modname__len);
static void Dev2LnkLoad_Put4 (BYTE *d, INTEGER d__len, INTEGER a, INTEGER x);
static void Dev2LnkLoad_PutMWord (Dev2LnkBase_Module mod, INTEGER offs, INTEGER x);
static void Dev2LnkLoad_Read4 (Files_Reader inp, INTEGER *x);
static void Dev2LnkLoad_ReadName (Files_Reader inp, SHORTCHAR *name, INTEGER name__len);
static void Dev2LnkLoad_ReadNum (Files_Reader inp, INTEGER *x);
static INTEGER Dev2LnkLoad_SearchFprint (Dev2LnkBase_Module mod, INTEGER fprint);
static INTEGER Dev2LnkLoad_SearchName (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len);
static void Dev2LnkLoad_SearchObj (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER \
mode, INTEGER fprint, INTEGER opt, Dev2LnkBase_Section *sec, INTEGER *adr);
export Dev2LnkBase_Module Dev2LnkLoad_ThisMod (SHORTCHAR *name, INTEGER name__len, SHORTCHAR *parent, \
INTEGER parent__len);

export void Dev2LnkLoad__reg();
export void Dev2LnkLoad__body();
export struct SYSTEM_MODDESC Dev2LnkLoad__desc;


Dev2LnkBase_Module Dev2LnkLoad_ThisMod (SHORTCHAR *name, INTEGER name__len, SHORTCHAR *parent, INTEGER \
parent__len)
{
	Dev2LnkBase_Module mod = NIL;
	struct CHAR_ARRAY *_ptr__72 = NIL;
	__ENTER("Dev2LnkLoad.ThisMod");
	if (name[0] == (SHORTCHAR)'$') {
		mod = Dev2LnkBase_ThisDll(name, name__len);
	} else {
		mod = Dev2LnkBase_modList;
		while (mod != NIL && __STRCMPSS(mod->name, name) != 0) {
			mod = mod->next;
		}
		if (mod == NIL) {
			if (parent[0] == 0) {
				mod = Dev2LnkLoad_LoadModule(name, name__len);
				__ASSERT(mod != NIL, 100);
				Dev2LnkBase_RegMod(mod);
			} else {
				_ptr__72 = __NEWARR(9, 9 + (name__len + (8 + parent__len)));
				__STRCOPYLL(((CHAR[]){114, 101, 113, 117, 105, 114, 101, 100, 32, 0}), _ptr__72->data, _ptr__72->len[0]);
				__STRAPNDSL(name, _ptr__72->data, _ptr__72->len[0]);
				__STRAPNDLL(((CHAR[]){32, 98, 101, 102, 111, 114, 101, 32, 0}), _ptr__72->data, _ptr__72->len[0]);
				__STRAPNDSL(parent, _ptr__72->data, _ptr__72->len[0]);
				Dev2LnkBase_Error(_ptr__72->data, __STRLEN(_ptr__72->data) + 1);
			}
		}
	}
	__EXIT;
	return mod;
}

static void Dev2LnkLoad_Read4 (Files_Reader inp, INTEGER *x)
{
	BYTE b;
	INTEGER y;
	__ENTER("Dev2LnkLoad.Read4");
	__Files_Reader_ReadByte(inp, &b);
	y = __MASK((INTEGER)b, -256);
	__Files_Reader_ReadByte(inp, &b);
	y = y + __ASHL(__MASK((INTEGER)b, -256), 8, INTEGER);
	__Files_Reader_ReadByte(inp, &b);
	y = y + __ASHL(__MASK((INTEGER)b, -256), 16, INTEGER);
	__Files_Reader_ReadByte(inp, &b);
	*x = y + __ASHL((INTEGER)b, 24, INTEGER);
	__EXIT;
}

static void Dev2LnkLoad_ReadNum (Files_Reader inp, INTEGER *x)
{
	BYTE b;
	INTEGER s, y;
	__ENTER("Dev2LnkLoad.ReadNum");
	s = 0;
	y = 0;
	__Files_Reader_ReadByte(inp, &b);
	while ((INTEGER)b < 0) {
		y += __ASH((INTEGER)b + 128, s, INTEGER);
		s += 7;
		__Files_Reader_ReadByte(inp, &b);
	}
	*x = __ASH(__MASK((INTEGER)b + 64, -128) - 64, s, INTEGER) + y;
	__EXIT;
}

static void Dev2LnkLoad_ReadName (Files_Reader inp, SHORTCHAR *name, INTEGER name__len)
{
	INTEGER i;
	BYTE b;
	__ENTER("Dev2LnkLoad.ReadName");
	i = 0;
	do {
		__Files_Reader_ReadByte(inp, &b);
		name[__X(i, name__len)] = (SHORTCHAR)b;
		i += 1;
	} while (!((INTEGER)b == 0));
	__EXIT;
}

static INTEGER Dev2LnkLoad_Get3 (BYTE *d, INTEGER d__len, INTEGER a)
{
	__ENTER("Dev2LnkLoad.Get3");
	__EXIT;
	return (__MASK((INTEGER)d[__X(a, d__len)], -256) + __ASHL(__MASK((INTEGER)d[__X(a + 1, d__len)], -256), \
8, INTEGER)) + __ASHL((INTEGER)d[__X(a + 2, d__len)], 16, INTEGER);
}

static INTEGER Dev2LnkLoad_Get4 (BYTE *d, INTEGER d__len, INTEGER a)
{
	__ENTER("Dev2LnkLoad.Get4");
	__EXIT;
	return __ASHL(__ASHL(__ASHL((INTEGER)d[__X(a + 3, d__len)], 8, INTEGER) + __MASK((INTEGER)d[__X(a + 2, \
d__len)], -256), 8, INTEGER) + __MASK((INTEGER)d[__X(a + 1, d__len)], -256), 8, INTEGER) + __MASK((INTEGER)d[__X(a, \
d__len)], -256);
}

static void Dev2LnkLoad_Put4 (BYTE *d, INTEGER d__len, INTEGER a, INTEGER x)
{
	__ENTER("Dev2LnkLoad.Put4");
	d[__X(a, d__len)] = (BYTE)x;
	d[__X(a + 1, d__len)] = (BYTE)__ASHR(x, 8, INTEGER);
	d[__X(a + 2, d__len)] = (BYTE)__ASHR(x, 16, INTEGER);
	d[__X(a + 3, d__len)] = (BYTE)__ASHR(x, 24, INTEGER);
	__EXIT;
}

static INTEGER Dev2LnkLoad_DWord (Dev2LnkBase_Module mod, INTEGER a)
{
	struct BYTE_ARRAY *_ptr__5 = NIL;
	__ENTER("Dev2LnkLoad.DWord");
	__EXIT;
	return (_ptr__5 = mod->data->bytes, 
		Dev2LnkLoad_Get4((void*)_ptr__5->data, _ptr__5->len[0], a));
}

static INTEGER Dev2LnkLoad_MWord (Dev2LnkBase_Module mod, INTEGER offs)
{
	struct BYTE_ARRAY *_ptr__53 = NIL;
	__ENTER("Dev2LnkLoad.MWord");
	__EXIT;
	return (_ptr__53 = mod->data->bytes, 
		Dev2LnkLoad_Get4((void*)_ptr__53->data, _ptr__53->len[0], mod->mDesc + offs));
}

static void Dev2LnkLoad_PutMWord (Dev2LnkBase_Module mod, INTEGER offs, INTEGER x)
{
	struct BYTE_ARRAY *_ptr__58 = NIL;
	__ENTER("Dev2LnkLoad.PutMWord");
	_ptr__58 = mod->data->bytes;
	Dev2LnkLoad_Put4((void*)_ptr__58->data, _ptr__58->len[0], mod->mDesc + offs, x);
	__EXIT;
}

static Dev2LnkLoad_StrPtr Dev2LnkLoad_GetPName (Dev2LnkBase_Module mod, INTEGER idx)
{
	INTEGER pNames;
	__ENTER("Dev2LnkLoad.GetPName");
	pNames = Dev2LnkLoad_MWord(mod, 84);
	__EXIT;
	return (Dev2LnkLoad_StrPtr)((INTEGER)&(mod->data->bytes->data)[__X(pNames + idx, mod->data->bytes->len[0])]);
}

static void Dev2LnkLoad_GetDir (Dev2LnkBase_Module mod, INTEGER *pDir, INTEGER *numobj)
{
	__ENTER("Dev2LnkLoad.GetDir");
	*pDir = Dev2LnkLoad_MWord(mod, 96);
	*numobj = Dev2LnkLoad_DWord(mod, *pDir);
	*pDir = *pDir + 4;
	__EXIT;
}

static INTEGER Dev2LnkLoad_SearchFprint (Dev2LnkBase_Module mod, INTEGER fprint)
{
	INTEGER p, numobj, fp;
	__ENTER("Dev2LnkLoad.SearchFprint");
	Dev2LnkLoad_GetDir(mod, &p, &numobj);
	fp = Dev2LnkLoad_DWord(mod, p + 4);
	while (fp != fprint && numobj > 0) {
		p += 16;
		numobj -= 1;
		fp = Dev2LnkLoad_DWord(mod, p + 4);
	}
	if (fp == fprint) {
		__EXIT;
		return p;
	} else {
		__EXIT;
		return -1;
	}
	__RETCHK;
}

static INTEGER Dev2LnkLoad_SearchName (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len)
{
	INTEGER l, r, m, p, id, p0, numobj;
	Dev2LnkLoad_StrPtr s = NIL;
	__ENTER("Dev2LnkLoad.SearchName");
	Dev2LnkLoad_GetDir(mod, &p0, &numobj);
	l = 0;
	r = numobj - 1;
	while (l <= r) {
		m = __ASHR(l + r, 1, INTEGER);
		p = p0 + __ASHL(m, 4, INTEGER);
		id = Dev2LnkLoad_DWord(mod, p + 8);
		s = Dev2LnkLoad_GetPName(mod, __ASHR(id, 8, INTEGER));
		if (__STRCMPSS(name, s) == 0) {
			__EXIT;
			return p;
		} else if (__STRCMPSS(name, s) > 0) {
			l = m + 1;
		} else {
			r = m - 1;
		}
	}
	__EXIT;
	return -1;
}

static void Dev2LnkLoad_SearchObj (Dev2LnkBase_Module mod, SHORTCHAR *name, INTEGER name__len, INTEGER \
mode, INTEGER fprint, INTEGER opt, Dev2LnkBase_Section *sec, INTEGER *adr)
{
	INTEGER pObj, id, md, fp;
	struct CHAR_ARRAY *_ptr__70 = NIL;
	struct CHAR_ARRAY *_ptr__69 = NIL;
	struct CHAR_ARRAY *_ptr__68 = NIL;
	struct CHAR_ARRAY *_ptr__67 = NIL;
	struct CHAR_ARRAY *_ptr__66 = NIL;
	struct CHAR_ARRAY *_ptr__65 = NIL;
	__ENTER("Dev2LnkLoad.SearchObj");
	*sec = NIL;
	*sec = NIL;
	*adr = -1;
	if (mod->isDll) {
		if (mode == 4) {
			*sec = mod->code;
			Dev2LnkBase_ImportProc(mod, name, name__len, adr);
		} else if (mode == 2) {
			_ptr__70 = __NEWARR(9, name__len + 21);
			__STRCOPYSL(name, _ptr__70->data, _ptr__70->len[0]);
			__STRAPNDLL(((CHAR[]){32, 105, 109, 112, 111, 114, 116, 32, 116, 121, 112, 101, 32, 102, 114, 111, \
109, 32, 68, 76, 76, 0}), _ptr__70->data, _ptr__70->len[0]);
			Dev2LnkBase_Error(_ptr__70->data, __STRLEN(_ptr__70->data) + 1);
		} else if (mode == 3) {
			_ptr__69 = __NEWARR(9, name__len + 20);
			__STRCOPYSL(name, _ptr__69->data, _ptr__69->len[0]);
			__STRAPNDLL(((CHAR[]){32, 105, 109, 112, 111, 114, 116, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, \
68, 76, 76, 0}), _ptr__69->data, _ptr__69->len[0]);
			Dev2LnkBase_Error(_ptr__69->data, __STRLEN(_ptr__69->data) + 1);
		}
	} else if (name[0] == 0) {
		pObj = Dev2LnkLoad_SearchFprint(mod, fprint);
		if (pObj < 0) {
			Dev2LnkBase_Error((CHAR*)((CHAR[]){97, 110, 111, 110, 121, 109, 111, 117, 115, 32, 116, 121, 112, 101, \
32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 0}), 25);
		} else {
			id = Dev2LnkLoad_DWord(mod, pObj + 8);
			if (__MASK(id, -16) == 2 && __ASHR(id, 8, INTEGER) == 0) {
				*adr = Dev2LnkLoad_DWord(mod, pObj + 12);
				*sec = mod->data;
			} else {
				Dev2LnkBase_Error((CHAR*)((CHAR[]){97, 110, 111, 110, 121, 109, 111, 117, 115, 32, 116, 121, 112, \
101, 32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 0}), 25);
			}
		}
	} else {
		pObj = Dev2LnkLoad_SearchName(mod, name, name__len);
		if (pObj < 0) {
			_ptr__68 = __NEWARR(9, 255 + (1 + (name__len + 11)));
			__STRCOPYSL(mod->name, _ptr__68->data, _ptr__68->len[0]);
			__STRAPNDLL(((CHAR[]){46, 0}), _ptr__68->data, _ptr__68->len[0]);
			__STRAPNDSL(name, _ptr__68->data, _ptr__68->len[0]);
			__STRAPNDLL(((CHAR[]){32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 32, 0}), _ptr__68->data, _ptr__68->len[0]);
			Dev2LnkBase_Error(_ptr__68->data, __STRLEN(_ptr__68->data) + 1);
		} else {
			fp = Dev2LnkLoad_DWord(mod, pObj);
			id = Dev2LnkLoad_DWord(mod, pObj + 8);
			md = __MASK(id, -16);
			if (__ODD(opt) && mode == 2) {
				fp = Dev2LnkLoad_DWord(mod, pObj + 4);
			}
			if (md != mode) {
				_ptr__67 = __NEWARR(9, 255 + (1 + (name__len + 16)));
				__STRCOPYSL(mod->name, _ptr__67->data, _ptr__67->len[0]);
				__STRAPNDLL(((CHAR[]){46, 0}), _ptr__67->data, _ptr__67->len[0]);
				__STRAPNDSL(name, _ptr__67->data, _ptr__67->len[0]);
				__STRAPNDLL(((CHAR[]){32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 99, 108, 97, 115, 115, 0}), \
_ptr__67->data, _ptr__67->len[0]);
				Dev2LnkBase_Error(_ptr__67->data, __STRLEN(_ptr__67->data) + 1);
			} else if (fp != fprint) {
				_ptr__66 = __NEWARR(9, 255 + (1 + (name__len + 17)));
				__STRCOPYSL(mod->name, _ptr__66->data, _ptr__66->len[0]);
				__STRAPNDLL(((CHAR[]){46, 0}), _ptr__66->data, _ptr__66->len[0]);
				__STRAPNDSL(name, _ptr__66->data, _ptr__66->len[0]);
				__STRAPNDLL(((CHAR[]){32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 102, 112, 114, 105, 110, \
116, 0}), _ptr__66->data, _ptr__66->len[0]);
				Dev2LnkBase_Error(_ptr__66->data, __STRLEN(_ptr__66->data) + 1);
			} else if (mode == 2) {
				if (opt > 1 && __MASK(__ASHR(id, 4, INTEGER), -16) != 4) {
					_ptr__65 = __NEWARR(9, 255 + (1 + (name__len + 21)));
					__STRCOPYSL(mod->name, _ptr__65->data, _ptr__65->len[0]);
					__STRAPNDLL(((CHAR[]){46, 0}), _ptr__65->data, _ptr__65->len[0]);
					__STRAPNDSL(name, _ptr__65->data, _ptr__65->len[0]);
					__STRAPNDLL(((CHAR[]){32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 118, 105, 115, 105, 98, \
105, 108, 105, 116, 121, 0}), _ptr__65->data, _ptr__65->len[0]);
					Dev2LnkBase_Error(_ptr__65->data, __STRLEN(_ptr__65->data) + 1);
				}
				*sec = mod->data;
				*adr = Dev2LnkLoad_DWord(mod, pObj + 12);
			} else if (mode == 3) {
				*sec = mod->vars;
				*adr = Dev2LnkLoad_DWord(mod, pObj + 4);
			} else if (mode == 4) {
				*sec = mod->code;
				*adr = Dev2LnkLoad_DWord(mod, pObj + 4);
			}
		}
	}
	__EXIT;
}

static struct LoadModule__15 {
	SHORTCHAR *modName;
	INTEGER modName__len;
	Dev2LnkBase_Module *mod;
	Files_Reader *inp;
	INTEGER *nofimp;
	Dev2LnkBase_Module (*import_)[128];
	struct LoadModule__15 *lnk;
} *LoadModule__15_s;

static void __18 (INTEGER link, INTEGER offset, Dev2LnkBase_Section sec, INTEGER val);
static void __28 (Dev2LnkBase_Module imod, SHORTCHAR *name, INTEGER name__len, INTEGER mode, INTEGER fp, \
INTEGER opt);
static void __30 (void);
static void __34 (SHORTCHAR *name, INTEGER name__len, INTEGER fp);
static void __36 (Dev2LnkBase_Section sec, INTEGER val);
static void __38 (void);
static void __41 (void);
static void __44 (Dev2LnkBase_Section sec);
static void __47 (void);
static void __49 (INTEGER fixt, INTEGER link);

static void __41 (void)
{
	INTEGER mtag, processor, i;
	Dev2LnkBase_Name iname;
	INTEGER headSize, descSize, metaSize, codeSize, varsSize, dataSize, _for__43;
	__ENTER("Dev2LnkLoad.ReadHeader");
	Dev2LnkLoad_Read4((*LoadModule__15_s->inp), &mtag);
	Dev2LnkLoad_Read4((*LoadModule__15_s->inp), &processor);
	Dev2LnkLoad_Read4((*LoadModule__15_s->inp), &headSize);
	Dev2LnkLoad_Read4((*LoadModule__15_s->inp), &metaSize);
	Dev2LnkLoad_Read4((*LoadModule__15_s->inp), &descSize);
	Dev2LnkLoad_Read4((*LoadModule__15_s->inp), &codeSize);
	Dev2LnkLoad_Read4((*LoadModule__15_s->inp), &varsSize);
	dataSize = metaSize + descSize;
	((*LoadModule__15_s->mod))->mDesc = metaSize;
	((*LoadModule__15_s->mod))->data = Dev2LnkBase_NewSection(dataSize);
	((*LoadModule__15_s->mod))->code = Dev2LnkBase_NewSection(codeSize);
	((*LoadModule__15_s->mod))->vars = Dev2LnkBase_NewSection(varsSize);
	Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &(*LoadModule__15_s->nofimp));
	Dev2LnkLoad_ReadName((*LoadModule__15_s->inp), (void*)iname, 256);
	__STRCOPYSS(LoadModule__15_s->modName, ((*LoadModule__15_s->mod))->name, 256);
	_for__43 = (*LoadModule__15_s->nofimp);
	i = 1;
	while (i <= _for__43) {
		Dev2LnkLoad_ReadName((*LoadModule__15_s->inp), (void*)iname, 256);
		if (__STRCMPSS(iname, "$$") == 0) {
			__MOVE(Dev2LnkBase_KernelName, iname, 256);
		}
		((*LoadModule__15_s->import_))[__X(i, 128)] = Dev2LnkLoad_ThisMod((void*)iname, 256, LoadModule__15_s->modName, \
LoadModule__15_s->modName__len);
		i += 1;
	}
	__Files_Reader_SetPos((*LoadModule__15_s->inp), headSize);
	__EXIT;
}

static void __44 (Dev2LnkBase_Section sec)
{
	struct BYTE_ARRAY *_ptr__46 = NIL;
	__ENTER("Dev2LnkLoad.ReadSection");
	sec->bytes = __NEWARR(3, sec->size);
	_ptr__46 = sec->bytes;
	__Files_Reader_ReadBytes((*LoadModule__15_s->inp), (void*)_ptr__46->data, _ptr__46->len[0], 0, sec->size);
	__EXIT;
}

static void __49 (INTEGER fixt, INTEGER link)
{
	struct CHAR_ARRAY *_ptr__51 = NIL;
	__ENTER("Dev2LnkLoad.WrongLink");
	_ptr__51 = __NEWARR(9, 15 + LoadModule__15_s->modName__len);
	__STRCOPYLL(((CHAR[]){32, 87, 114, 111, 110, 103, 32, 108, 105, 110, 107, 32, 105, 110, 32, 0}), _ptr__51->data, \
_ptr__51->len[0]);
	__STRAPNDSL(LoadModule__15_s->modName, _ptr__51->data, _ptr__51->len[0]);
	Dev2LnkBase_Error(_ptr__51->data, __STRLEN(_ptr__51->data) + 1);
	__EXIT;
}

static void __18 (INTEGER link, INTEGER offset, Dev2LnkBase_Section sec, INTEGER val)
{
	INTEGER fixtype, fixdat;
	struct BYTE_ARRAY *_ptr__27 = NIL;
	struct BYTE_ARRAY *_ptr__26 = NIL;
	struct BYTE_ARRAY *_ptr__25 = NIL;
	struct BYTE_ARRAY *_ptr__24 = NIL;
	struct BYTE_ARRAY *_ptr__23 = NIL;
	struct BYTE_ARRAY *_ptr__22 = NIL;
	struct BYTE_ARRAY *_ptr__21 = NIL;
	struct BYTE_ARRAY *_ptr__20 = NIL;
	__ENTER("Dev2LnkLoad.FixChain");
	while (link != 0) {
		if (link > 0) {
			fixdat = (_ptr__27 = ((*LoadModule__15_s->mod))->code->bytes, 
				Dev2LnkLoad_Get3((void*)_ptr__27->data, _ptr__27->len[0], link));
			fixtype = (((*LoadModule__15_s->mod))->code->bytes->data)[__X(link + 3, ((*LoadModule__15_s->mod))->code->bytes->len[0])];
			if (fixtype == 100) {
				_ptr__26 = ((*LoadModule__15_s->mod))->code->bytes;
				Dev2LnkLoad_Put4((void*)_ptr__26->data, _ptr__26->len[0], link, offset + val);
				Dev2LnkBase_FixCode((*LoadModule__15_s->mod), link, sec);
				link = fixdat;
			} else if (fixtype == 101) {
				_ptr__25 = ((*LoadModule__15_s->mod))->code->bytes;
				Dev2LnkLoad_Put4((void*)_ptr__25->data, _ptr__25->len[0], link, ((offset + val) - link) - 4);
				Dev2LnkBase_FixRel((*LoadModule__15_s->mod), link, sec);
				link = fixdat;
			} else if (fixtype == 103) {
				_ptr__24 = ((*LoadModule__15_s->mod))->code->bytes;
				Dev2LnkLoad_Put4((void*)_ptr__24->data, _ptr__24->len[0], link, fixdat);
				Dev2LnkBase_FixCode((*LoadModule__15_s->mod), link, sec);
				link = link + 4;
			} else if (fixtype == 104) {
				_ptr__23 = ((*LoadModule__15_s->mod))->code->bytes;
				Dev2LnkLoad_Put4((void*)_ptr__23->data, _ptr__23->len[0], link, fixdat);
				Dev2LnkBase_FixCode((*LoadModule__15_s->mod), link, sec);
				link = 0;
			} else {
				__49(fixtype, link);
				__EXIT;
				return;
			}
		} else {
			link = -link;
			fixdat = (_ptr__22 = ((*LoadModule__15_s->mod))->data->bytes, 
				Dev2LnkLoad_Get3((void*)_ptr__22->data, _ptr__22->len[0], link));
			fixtype = (((*LoadModule__15_s->mod))->data->bytes->data)[__X(link + 3, ((*LoadModule__15_s->mod))->data->bytes->len[0])];
			if (fixtype == 100) {
				_ptr__21 = ((*LoadModule__15_s->mod))->data->bytes;
				Dev2LnkLoad_Put4((void*)_ptr__21->data, _ptr__21->len[0], link, offset + val);
				Dev2LnkBase_FixData((*LoadModule__15_s->mod), link, sec);
				link = fixdat;
			} else if (fixtype == 102) {
				_ptr__20 = ((*LoadModule__15_s->mod))->data->bytes;
				Dev2LnkLoad_Put4((void*)_ptr__20->data, _ptr__20->len[0], link, offset + val);
				Dev2LnkBase_FixCopy((*LoadModule__15_s->mod), link, sec);
				link = fixdat;
			} else {
				__49(fixtype, link);
				__EXIT;
				return;
			}
		}
	}
	__EXIT;
}

static void __36 (Dev2LnkBase_Section sec, INTEGER val)
{
	INTEGER offset, link;
	__ENTER("Dev2LnkLoad.FixLocal");
	Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &link);
	while (link != 0) {
		Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &offset);
		__18(link, offset, sec, val);
		Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &link);
	}
	__EXIT;
}

static void __28 (Dev2LnkBase_Module imod, SHORTCHAR *name, INTEGER name__len, INTEGER mode, INTEGER fp, \
INTEGER opt)
{
	INTEGER offset, link;
	Dev2LnkBase_Section sec = NIL;
	INTEGER adr;
	__ENTER("Dev2LnkLoad.FixExt");
	Dev2LnkLoad_SearchObj(imod, name, name__len, mode, fp, opt, &sec, &adr);
	Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &link);
	while (link != 0) {
		Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &offset);
		__18(link, offset, sec, adr);
		Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &link);
	}
	__EXIT;
}

static void __34 (SHORTCHAR *name, INTEGER name__len, INTEGER fp)
{
	INTEGER offset, link;
	Dev2LnkBase_Section sec = NIL;
	INTEGER oadr;
	__ENTER("Dev2LnkLoad.FixKernel");
	Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &link);
	if (link != 0) {
		if (Dev2LnkBase_kernelMod != NIL && (*LoadModule__15_s->mod) != Dev2LnkBase_kernelMod) {
			Dev2LnkLoad_SearchObj(Dev2LnkBase_kernelMod, name, name__len, 4, fp, -1, &sec, &oadr);
			while (link != 0) {
				Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &offset);
				__18(link, offset, sec, oadr);
				Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &link);
			}
		} else {
			Dev2LnkBase_Error((CHAR*)((CHAR[]){110, 111, 32, 107, 101, 114, 110, 101, 108, 0}), 10);
			__EXIT;
			return;
		}
	}
	__EXIT;
}

static void __38 (void)
{
	INTEGER mno, otag, fprint, opt;
	Dev2LnkBase_Name name;
	INTEGER _for__40;
	__ENTER("Dev2LnkLoad.ReadFixups");
	__34((void*)"NewRec", 7, 1311221831);
	__34((void*)"NewArr", 7, 1980140664);
	__36(((*LoadModule__15_s->mod))->data, 0);
	__36(((*LoadModule__15_s->mod))->data, ((*LoadModule__15_s->mod))->mDesc);
	__36(((*LoadModule__15_s->mod))->code, 0);
	__36(((*LoadModule__15_s->mod))->vars, 0);
	_for__40 = (*LoadModule__15_s->nofimp);
	mno = 1;
	while (mno <= _for__40) {
		Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &otag);
		while (otag != 0) {
			Dev2LnkLoad_ReadName((*LoadModule__15_s->inp), (void*)name, 256);
			Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &fprint);
			if (otag == 2) {
				Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &opt);
			} else {
				opt = 0;
			}
			if (otag != 1) {
				__28(((*LoadModule__15_s->import_))[__X(mno, 128)], (void*)name, 256, otag, fprint, opt);
				if (Dev2LnkBase_error) {
					__EXIT;
					return;
				}
			}
			Dev2LnkLoad_ReadNum((*LoadModule__15_s->inp), &otag);
		}
		mno += 1;
	}
	__EXIT;
}

static void __30 (void)
{
	Dev2LnkBase_Module imod = NIL;
	INTEGER i, imptab, refcnt, _for__33;
	struct BYTE_ARRAY *_ptr__32 = NIL;
	__ENTER("Dev2LnkLoad.FixImpRef");
	imptab = Dev2LnkLoad_MWord((*LoadModule__15_s->mod), 92);
	_for__33 = (*LoadModule__15_s->nofimp);
	i = 1;
	while (i <= _for__33) {
		imod = ((*LoadModule__15_s->import_))[__X(i, 128)];
		if (!imod->isDll) {
			_ptr__32 = ((*LoadModule__15_s->mod))->data->bytes;
			Dev2LnkLoad_Put4((void*)_ptr__32->data, _ptr__32->len[0], imptab, imod->mDesc);
			Dev2LnkBase_FixData((*LoadModule__15_s->mod), imptab, imod->data);
			refcnt = Dev2LnkLoad_MWord(imod, 8);
			Dev2LnkLoad_PutMWord(imod, 8, refcnt + 1);
		}
		imptab += 4;
		i += 1;
	}
	__EXIT;
}

static void __47 (void)
{
	SET opts;
	__ENTER("Dev2LnkLoad.SetOpts");
	opts = (SET)Dev2LnkLoad_MWord((*LoadModule__15_s->mod), 4);
	if (!Dev2LnkBase_dynaInit) {
		opts |= __SETOF(16);
	}
	if (Dev2LnkBase_outDll) {
		opts |= __SETOF(24);
	}
	Dev2LnkLoad_PutMWord((*LoadModule__15_s->mod), 4, (INTEGER)opts);
	__EXIT;
}

static Dev2LnkBase_Module Dev2LnkLoad_LoadModule (SHORTCHAR *modName, INTEGER modName__len)
{
	Dev2LnkBase_Module mod = NIL;
	Files_File file = NIL;
	Files_Reader inp = NIL;
	INTEGER nofimp;
	Dev2LnkBase_Module import_[128] = {0};
	struct CHAR_ARRAY *_ptr__17 = NIL;
	struct CHAR_ARRAY *_ptr__16 = NIL;
	struct LoadModule__15 _s;
	__ENTER("Dev2LnkLoad.LoadModule");
	_s.modName = (void*)modName; _s.modName__len = modName__len;
	_s.mod = &mod;
	_s.inp = &inp;
	_s.nofimp = &nofimp;
	_s.import_ = (void*)import_;
	_s.lnk = LoadModule__15_s;
	LoadModule__15_s = &_s;
	file = (_ptr__17 = __NEWARR(9, modName__len), 
		__STRCOPYSL(modName, _ptr__17->data, _ptr__17->len[0]), 
		Dev2LnkBase_ThisObjFile((void*)_ptr__17->data, __STRLEN(_ptr__17->data) + 1));
	if (file == NIL) {
		_ptr__16 = __NEWARR(9, modName__len + 10);
		__STRCOPYSL(modName, _ptr__16->data, _ptr__16->len[0]);
		__STRAPNDLL(((CHAR[]){32, 110, 111, 116, 32, 102, 111, 117, 110, 100, 0}), _ptr__16->data, _ptr__16->len[0]);
		Dev2LnkBase_Error(_ptr__16->data, __STRLEN(_ptr__16->data) + 1);
		LoadModule__15_s = _s.lnk;
		__EXIT;
		return NIL;
	}
	inp = __Files_File_NewReader(file, NIL);
	__Files_Reader_SetPos(inp, 0);
	mod = __NEW(Dev2LnkBase_Module__rec__typ);
	mod->isDll = 0;
	__41();
	__44(mod->data);
	__44(mod->code);
	Dev2LnkBase_InitFixTable(&mod->dataFix, Dev2LnkBase_FixTable__typ, mod->data);
	Dev2LnkBase_InitFixTable(&mod->codeFix, Dev2LnkBase_FixTable__typ, mod->code);
	__38();
	mod->termadr = Dev2LnkLoad_MWord(mod, 40);
	__30();
	__47();
	if (Dev2LnkBase_lastMod != NIL) {
		Dev2LnkLoad_PutMWord(mod, 0, Dev2LnkBase_lastMod->mDesc);
		Dev2LnkBase_FixData(mod, mod->mDesc, Dev2LnkBase_lastMod->data);
	}
	__Files_File_Close(file);
	LoadModule__15_s = _s.lnk;
	__EXIT;
	return mod;
}

static void Dev2LnkLoad_CollectExports (Dev2LnkBase_Module mod)
{
	INTEGER p, numobj, id, vis, mode, addr;
	Dev2LnkLoad_StrPtr name = NIL;
	__ENTER("Dev2LnkLoad.CollectExports");
	if (!mod->exported) {
		Dev2LnkLoad_GetDir(mod, &p, &numobj);
		while (numobj > 0) {
			id = Dev2LnkLoad_DWord(mod, p + 8);
			mode = __MASK(id, -16);
			vis = __MASK(__ASHR(id, 4, INTEGER), -16);
			if (vis != 1 && mode == 4) {
				name = Dev2LnkLoad_GetPName(mod, __ASHR(id, 8, INTEGER));
				addr = Dev2LnkLoad_DWord(mod, p + 4);
				Dev2LnkBase_ExportProc(mod, (void*)name, __STRLENS(name) + 1, addr);
			}
			numobj -= 1;
			p += 16;
		}
		mod->exported = 1;
	}
	__EXIT;
}

void Dev2LnkLoad_ExportVariable (CHAR *modname, INTEGER modname__len, SHORTCHAR *varname, INTEGER varname__len)
{
	INTEGER p, numobj, id, vis, mode, addr;
	Dev2LnkLoad_StrPtr name = NIL;
	Dev2LnkBase_Module mod = NIL;
	struct SHORTCHAR_ARRAY *_ptr__10 = NIL;
	__ENTER("Dev2LnkLoad.ExportVariable");
	__DUP(varname, varname__len);
	mod = Dev2LnkBase_modList;
	while (mod != NIL) {
		mod = mod->next;
	}
	mod = (_ptr__10 = __NEWARR(1, modname__len), 
		__STRCOPYTS(modname, _ptr__10->data, _ptr__10->len[0]), 
		Dev2LnkLoad_ThisMod((void*)_ptr__10->data, __STRLENS(_ptr__10->data) + 1, (void*)"", 1));
	Dev2LnkLoad_GetDir(mod, &p, &numobj);
	while (numobj > 0) {
		id = Dev2LnkLoad_DWord(mod, p + 8);
		mode = __MASK(id, -16);
		vis = __MASK(__ASHR(id, 4, INTEGER), -16);
		if (vis != 1 && mode == 3) {
			name = Dev2LnkLoad_GetPName(mod, __ASHR(id, 8, INTEGER));
			addr = Dev2LnkLoad_DWord(mod, p + 4);
			if (__STRCMPSS(varname, name) == 0) {
				Dev2LnkBase_ExportVar(mod, (void*)name, __STRLENS(name) + 1, addr);
			}
		}
		numobj -= 1;
		p += 16;
	}
	__DEL(varname);
	__EXIT;
}

void Dev2LnkLoad_AddModule (CHAR *modname, INTEGER modname__len)
{
	Dev2LnkBase_Module mod = NIL;
	struct SHORTCHAR_ARRAY *_ptr__2 = NIL;
	__ENTER("Dev2LnkLoad.AddModule");
	mod = (_ptr__2 = __NEWARR(1, modname__len), 
		__STRCOPYTS(modname, _ptr__2->data, _ptr__2->len[0]), 
		Dev2LnkLoad_ThisMod((void*)_ptr__2->data, __STRLENS(_ptr__2->data) + 1, (void*)"", 1));
	__EXIT;
}

void Dev2LnkLoad_MainModule (CHAR *modname, INTEGER modname__len)
{
	Dev2LnkBase_Module mod = NIL;
	struct SHORTCHAR_ARRAY *_ptr__55 = NIL;
	__ENTER("Dev2LnkLoad.MainModule");
	mod = (_ptr__55 = __NEWARR(1, modname__len), 
		__STRCOPYTS(modname, _ptr__55->data, _ptr__55->len[0]), 
		Dev2LnkLoad_ThisMod((void*)_ptr__55->data, __STRLENS(_ptr__55->data) + 1, (void*)"", 1));
	if (mod != NIL) {
		Dev2LnkBase_mainMod = mod;
	}
	__EXIT;
}

void Dev2LnkLoad_ExportModule (CHAR *modname, INTEGER modname__len)
{
	Dev2LnkBase_Module mod = NIL;
	struct SHORTCHAR_ARRAY *_ptr__8 = NIL;
	__ENTER("Dev2LnkLoad.ExportModule");
	mod = (_ptr__8 = __NEWARR(1, modname__len), 
		__STRCOPYTS(modname, _ptr__8->data, _ptr__8->len[0]), 
		Dev2LnkLoad_ThisMod((void*)_ptr__8->data, __STRLENS(_ptr__8->data) + 1, (void*)"", 1));
	if (mod != NIL) {
		Dev2LnkLoad_CollectExports(mod);
	}
	__EXIT;
}

void Dev2LnkLoad_ExportAll (void)
{
	Dev2LnkBase_Module mod = NIL;
	__ENTER("Dev2LnkLoad.ExportAll");
	mod = Dev2LnkBase_modList;
	while (mod != NIL) {
		Dev2LnkLoad_CollectExports(mod);
		mod = mod->next;
	}
	__EXIT;
}

static SYSTEM_MODDESC *Dev2LnkLoad__imp[] = {
	&Files__desc,
	&Dev2LnkBase__desc,
};
static INTEGER Dev2LnkLoad__exp[] = {
	22,
	0x143ec369, (INTEGER)Dev2LnkLoad_AddModule, 1<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_CollectExports, 11<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_DWord, 26<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)Dev2LnkLoad_ExportAll, 32<<8 | 0x44, 0,
	0x143ec369, (INTEGER)Dev2LnkLoad_ExportModule, 42<<8 | 0x44, 0,
	0x252c6859, (INTEGER)Dev2LnkLoad_ExportVariable, 55<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_Get3, 70<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_Get4, 75<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_GetDir, 80<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_GetPName, 87<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_LoadModule, 96<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_MWord, 107<<8 | 0x14, 0,
	0x143ec369, (INTEGER)Dev2LnkLoad_MainModule, 113<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_Put4, 124<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_PutMWord, 129<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_Read4, 138<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_ReadName, 144<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_ReadNum, 153<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_SearchFprint, 161<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_SearchName, 174<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkLoad_SearchObj, 185<<8 | 0x14, 0,
	0x3eff586e, (INTEGER)Dev2LnkLoad_ThisMod, 195<<8 | 0x44, 0,
};
static char Dev2LnkLoad__names[] = {
	0,
	'A','d','d','M','o','d','u','l','e',0,
	'C','o','l','l','e','c','t','E','x','p','o','r','t','s',0,
	'D','W','o','r','d',0,
	'E','x','p','o','r','t','A','l','l',0,
	'E','x','p','o','r','t','M','o','d','u','l','e',0,
	'E','x','p','o','r','t','V','a','r','i','a','b','l','e',0,
	'G','e','t','3',0,
	'G','e','t','4',0,
	'G','e','t','D','i','r',0,
	'G','e','t','P','N','a','m','e',0,
	'L','o','a','d','M','o','d','u','l','e',0,
	'M','W','o','r','d',0,
	'M','a','i','n','M','o','d','u','l','e',0,
	'P','u','t','4',0,
	'P','u','t','M','W','o','r','d',0,
	'R','e','a','d','4',0,
	'R','e','a','d','N','a','m','e',0,
	'R','e','a','d','N','u','m',0,
	'S','e','a','r','c','h','F','p','r','i','n','t',0,
	'S','e','a','r','c','h','N','a','m','e',0,
	'S','e','a','r','c','h','O','b','j',0,
	'T','h','i','s','M','o','d',0,
};
static INTEGER Dev2LnkLoad__ptrs[] = {
	0
};
struct SYSTEM_MODDESC Dev2LnkLoad__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 16}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Dev2LnkLoad__body,
	0,
	2, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Dev2LnkLoad__names,
	Dev2LnkLoad__ptrs,
	Dev2LnkLoad__imp,
	(SYSTEM_DIRECTORY*)Dev2LnkLoad__exp,
	"Dev2LnkLoad"
};

export void Dev2LnkLoad__reg()
{
	__BEGREG(Dev2LnkLoad__desc);
	Dev2LnkBase__reg();
	Files__reg();
	__REGMOD(Dev2LnkLoad__desc);
	__ENDREG;
}

export void Dev2LnkLoad__body()
{
	__BEGBODY(Dev2LnkLoad__desc);
	Dev2LnkBase__body();
	Files__body();
	__ENDBODY;
}
