/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"
#include "Dev2LnkChmod.h"
#include "Dev2LnkBase.h"
#include "Files.h"

typedef
	struct Dev2LnkWriteElf_Section {
		INTEGER namIdx, type, flags, size, addr, offs, align, link, info, entrySize;
	} Dev2LnkWriteElf_Section;

typedef
	struct Dev2LnkWriteElf_Segment {
		INTEGER type, addr, offs, msize, fsize, align, flags;
	} Dev2LnkWriteElf_Segment;


static Files_File Dev2LnkWriteElf_outFile;
static Files_Writer Dev2LnkWriteElf_out;
static INTEGER Dev2LnkWriteElf_entry_addr, Dev2LnkWriteElf_init_addr, Dev2LnkWriteElf_fini_addr;
static SHORTCHAR Dev2LnkWriteElf_interpreter[128];
static INTEGER Dev2LnkWriteElf_elfType, Dev2LnkWriteElf_sectionCount, Dev2LnkWriteElf_shtOffset, Dev2LnkWriteElf_shtSize, \
Dev2LnkWriteElf_idxSecNames;
static Dev2LnkWriteElf_Section Dev2LnkWriteElf_code, Dev2LnkWriteElf_data, Dev2LnkWriteElf_vars, Dev2LnkWriteElf_dyna, \
Dev2LnkWriteElf_dsym, Dev2LnkWriteElf_dstr, Dev2LnkWriteElf_hash, Dev2LnkWriteElf_relo, Dev2LnkWriteElf_empty, \
Dev2LnkWriteElf_intp, Dev2LnkWriteElf_noteobsd, Dev2LnkWriteElf_shstr;
static Dev2LnkWriteElf_Segment Dev2LnkWriteElf_phtseg, Dev2LnkWriteElf_intseg, Dev2LnkWriteElf_codeseg, \
Dev2LnkWriteElf_dataseg, Dev2LnkWriteElf_dynaseg, Dev2LnkWriteElf_noteobsdseg, Dev2LnkWriteElf_obsdwxneedseg, \
Dev2LnkWriteElf_dsymseg;
static Dev2LnkBase_StringTable Dev2LnkWriteElf_symNames, Dev2LnkWriteElf_secNames;
static INTEGER Dev2LnkWriteElf_siOutName, Dev2LnkWriteElf_siRPath, Dev2LnkWriteElf_symCount, Dev2LnkWriteElf_symIdx, \
Dev2LnkWriteElf_symImp;
static struct INTEGER_ARRAY *Dev2LnkWriteElf_hashtab;

export INTEGER Dev2LnkWriteElf_Section__desc[];
export SYSTEM_TYPEDESC *Dev2LnkWriteElf_Section__typ = (SYSTEM_TYPEDESC*)(Dev2LnkWriteElf_Section__desc \
+ 2);
export INTEGER Dev2LnkWriteElf_Segment__desc[];
export SYSTEM_TYPEDESC *Dev2LnkWriteElf_Segment__typ = (SYSTEM_TYPEDESC*)(Dev2LnkWriteElf_Segment__desc \
+ 2);

static void Dev2LnkWriteElf_AddSymbol (SHORTCHAR *name, INTEGER name__len, INTEGER *idx, INTEGER *namIdx);
static void Dev2LnkWriteElf_CalculateLayout (void);
static void Dev2LnkWriteElf_CollectExport (void);
static void Dev2LnkWriteElf_CollectImport (void);
static void Dev2LnkWriteElf_DefSections (void);
static void Dev2LnkWriteElf_DefSegments (void);
export void Dev2LnkWriteElf_GetBases (INTEGER *codeBase, INTEGER *dataBase, INTEGER *varsBase);
static INTEGER Dev2LnkWriteElf_HashStr (SHORTCHAR *name, INTEGER name__len);
export void Dev2LnkWriteElf_Init (void);
static void Dev2LnkWriteElf_MakeHash (struct INTEGER_ARRAY **bucket, struct INTEGER_ARRAY **chain);
static void Dev2LnkWriteElf_PadTo (INTEGER pos);
static void Dev2LnkWriteElf_Write1 (INTEGER x);
static void Dev2LnkWriteElf_Write2 (INTEGER x);
static void Dev2LnkWriteElf_Write4 (INTEGER x);
static void Dev2LnkWriteElf_WriteCh (SHORTCHAR ch);
static void Dev2LnkWriteElf_WriteCode (void);
static void Dev2LnkWriteElf_WriteData (void);
static void Dev2LnkWriteElf_WriteDynamic (void);
static void Dev2LnkWriteElf_WriteElfHeader (void);
static void Dev2LnkWriteElf_WriteHash (void);
static void Dev2LnkWriteElf_WriteInterpreter (void);
static void Dev2LnkWriteElf_WriteObsdNote (void);
export void Dev2LnkWriteElf_WriteOut (void);
static void Dev2LnkWriteElf_WritePlt (void);
static void Dev2LnkWriteElf_WriteProgramHeaderTable (void);
static void Dev2LnkWriteElf_WriteReloc (void);
static void Dev2LnkWriteElf_WriteSectionTable (void);
static void Dev2LnkWriteElf_WriteStr (SHORTCHAR *s, INTEGER s__len, INTEGER len);
static void Dev2LnkWriteElf_WriteSymbol (INTEGER namIdx, INTEGER val, INTEGER si, INTEGER typ);
static void Dev2LnkWriteElf_WriteSymbolTable (void);

export void Dev2LnkWriteElf__reg();
export void Dev2LnkWriteElf__body();
export struct SYSTEM_MODDESC Dev2LnkWriteElf__desc;


static void Dev2LnkWriteElf_WriteCh (SHORTCHAR ch)
{
	__ENTER("Dev2LnkWriteElf.WriteCh");
	__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)ch);
	__EXIT;
}

static void Dev2LnkWriteElf_Write1 (INTEGER x)
{
	__ENTER("Dev2LnkWriteElf.Write1");
	__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)__MASK(x, -256));
	__EXIT;
}

static void Dev2LnkWriteElf_Write2 (INTEGER x)
{
	__ENTER("Dev2LnkWriteElf.Write2");
	__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)__MASK(x, -256));
	x = __ASHR(x, 8, INTEGER);
	__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)__MASK(x, -256));
	__EXIT;
}

static void Dev2LnkWriteElf_Write4 (INTEGER x)
{
	__ENTER("Dev2LnkWriteElf.Write4");
	__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)__MASK(x, -256));
	x = __ASHR(x, 8, INTEGER);
	__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)__MASK(x, -256));
	x = __ASHR(x, 8, INTEGER);
	__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)__MASK(x, -256));
	x = __ASHR(x, 8, INTEGER);
	__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)__MASK(x, -256));
	__EXIT;
}

static void Dev2LnkWriteElf_WriteStr (SHORTCHAR *s, INTEGER s__len, INTEGER len)
{
	INTEGER i;
	__ENTER("Dev2LnkWriteElf.WriteStr");
	i = 0;
	while (s[__X(i, s__len)] != 0) {
		__Files_Writer_WriteByte(Dev2LnkWriteElf_out, (BYTE)s[__X(i, s__len)]);
		i += 1;
	}
	while (i < len) {
		__Files_Writer_WriteByte(Dev2LnkWriteElf_out, 0);
		i += 1;
	}
	__EXIT;
}

static void Dev2LnkWriteElf_PadTo (INTEGER pos)
{
	__ENTER("Dev2LnkWriteElf.PadTo");
	__ASSERT(pos >= __Files_Writer_Pos(Dev2LnkWriteElf_out), 101);
	while (__Files_Writer_Pos(Dev2LnkWriteElf_out) < pos) {
		__Files_Writer_WriteByte(Dev2LnkWriteElf_out, 0);
	}
	__EXIT;
}

static INTEGER Dev2LnkWriteElf_HashStr (SHORTCHAR *name, INTEGER name__len)
{
	INTEGER i, h;
	SET g;
	__ENTER("Dev2LnkWriteElf.HashStr");
	h = 0;
	i = 0;
	while (name[__X(i, name__len)] != 0) {
		h = __ASHL(h, 4, INTEGER) + (INTEGER)name[__X(i, name__len)];
		g = (SET)h & 0xf0000000;
		h = (INTEGER)(((SET)h ^ __LSHR(g, 24, SET)) & ~g);
		i += 1;
	}
	__EXIT;
	return h;
}

static void Dev2LnkWriteElf_AddSymbol (SHORTCHAR *name, INTEGER name__len, INTEGER *idx, INTEGER *namIdx)
{
	__ENTER("Dev2LnkWriteElf.AddSymbol");
	Dev2LnkBase_AddName(&Dev2LnkWriteElf_symNames, Dev2LnkBase_StringTable__typ, name, name__len, namIdx);
	*idx = Dev2LnkWriteElf_symIdx;
	(Dev2LnkWriteElf_hashtab->data)[__X(*idx, Dev2LnkWriteElf_hashtab->len[0])] = Dev2LnkWriteElf_HashStr((void*)name, \
__STRLENS(name) + 1);
	Dev2LnkWriteElf_symIdx += 1;
	__EXIT;
}

static struct DefSegments__12 {
	struct DefSegments__12 *lnk;
} *DefSegments__12_s;

static void __13 (Dev2LnkWriteElf_Segment *seg, SYSTEM_TYPEDESC *seg__typ, INTEGER type, SET flags, INTEGER \
align);

static void __13 (Dev2LnkWriteElf_Segment *seg, SYSTEM_TYPEDESC *seg__typ, INTEGER type, SET flags, INTEGER \
align)
{
	__ENTER("Dev2LnkWriteElf.DefSeg");
	(*seg).type = type;
	(*seg).flags = (INTEGER)flags;
	(*seg).align = align;
	__EXIT;
}

static void Dev2LnkWriteElf_DefSegments (void)
{
	struct DefSegments__12 _s;
	__ENTER("Dev2LnkWriteElf.DefSegments");
	_s.lnk = DefSegments__12_s;
	DefSegments__12_s = &_s;
	__13(&Dev2LnkWriteElf_phtseg, Dev2LnkWriteElf_Segment__typ, 6, 0x05, 4);
	__13(&Dev2LnkWriteElf_intseg, Dev2LnkWriteElf_Segment__typ, 3, 0x04, 1);
	__13(&Dev2LnkWriteElf_codeseg, Dev2LnkWriteElf_Segment__typ, 1, 0x05, 4096);
	__13(&Dev2LnkWriteElf_dataseg, Dev2LnkWriteElf_Segment__typ, 1, 0x06, 4096);
	__13(&Dev2LnkWriteElf_dynaseg, Dev2LnkWriteElf_Segment__typ, 2, 0x06, 4);
	__13(&Dev2LnkWriteElf_noteobsdseg, Dev2LnkWriteElf_Segment__typ, 4, 0x04, 4);
	__13(&Dev2LnkWriteElf_obsdwxneedseg, Dev2LnkWriteElf_Segment__typ, 1705237479, 0x01, 4);
	__13(&Dev2LnkWriteElf_dsymseg, Dev2LnkWriteElf_Segment__typ, 1, 0x06, 4096);
	DefSegments__12_s = _s.lnk;
	__EXIT;
}

static struct DefSections__9 {
	struct DefSections__9 *lnk;
} *DefSections__9_s;

static void __10 (Dev2LnkWriteElf_Section *scn, SYSTEM_TYPEDESC *scn__typ, SHORTCHAR *name, INTEGER name__len, \
INTEGER type, INTEGER align, SET flags);

static void __10 (Dev2LnkWriteElf_Section *scn, SYSTEM_TYPEDESC *scn__typ, SHORTCHAR *name, INTEGER name__len, \
INTEGER type, INTEGER align, SET flags)
{
	__ENTER("Dev2LnkWriteElf.DefSection");
	Dev2LnkBase_AddName(&Dev2LnkWriteElf_secNames, Dev2LnkBase_StringTable__typ, name, name__len, &(*scn).namIdx);
	(*scn).type = type;
	(*scn).flags = (INTEGER)flags;
	(*scn).align = align;
	__EXIT;
}

static void Dev2LnkWriteElf_DefSections (void)
{
	struct DefSections__9 _s;
	__ENTER("Dev2LnkWriteElf.DefSections");
	_s.lnk = DefSections__9_s;
	DefSections__9_s = &_s;
	__10(&Dev2LnkWriteElf_empty, Dev2LnkWriteElf_Section__typ, (void*)"", 1, 0, 0, 0x0);
	__10(&Dev2LnkWriteElf_code, Dev2LnkWriteElf_Section__typ, (void*)".text", 6, 1, 4, 0x06);
	__10(&Dev2LnkWriteElf_data, Dev2LnkWriteElf_Section__typ, (void*)".data", 6, 1, 8, 0x02);
	__10(&Dev2LnkWriteElf_vars, Dev2LnkWriteElf_Section__typ, (void*)".bss", 5, 8, 4, 0x03);
	__10(&Dev2LnkWriteElf_dstr, Dev2LnkWriteElf_Section__typ, (void*)".dynstr", 8, 3, 1, 0x02);
	__10(&Dev2LnkWriteElf_dsym, Dev2LnkWriteElf_Section__typ, (void*)".dynsym", 8, 11, 4, 0x02);
	__10(&Dev2LnkWriteElf_hash, Dev2LnkWriteElf_Section__typ, (void*)".hash", 6, 5, 4, 0x02);
	__10(&Dev2LnkWriteElf_relo, Dev2LnkWriteElf_Section__typ, (void*)".relo", 6, 9, 4, 0x02);
	__10(&Dev2LnkWriteElf_dyna, Dev2LnkWriteElf_Section__typ, (void*)".dynamic", 9, 6, 4, 0x02);
	__10(&Dev2LnkWriteElf_shstr, Dev2LnkWriteElf_Section__typ, (void*)".shstrtab", 10, 3, 4, 0x0);
	__10(&Dev2LnkWriteElf_intp, Dev2LnkWriteElf_Section__typ, (void*)".interp", 8, 1, 1, 0x02);
	__10(&Dev2LnkWriteElf_noteobsd, Dev2LnkWriteElf_Section__typ, (void*)".note.openbsd.ident", 20, 7, 4, \
0x02);
	Dev2LnkWriteElf_dsym.entrySize = 16;
	Dev2LnkWriteElf_dsym.link = 4;
	Dev2LnkWriteElf_dsym.info = 1;
	Dev2LnkWriteElf_relo.entrySize = 8;
	Dev2LnkWriteElf_relo.link = 5;
	Dev2LnkWriteElf_relo.info = 1;
	Dev2LnkWriteElf_dyna.entrySize = 8;
	Dev2LnkWriteElf_dyna.link = 4;
	Dev2LnkWriteElf_hash.entrySize = 4;
	Dev2LnkWriteElf_hash.link = 5;
	Dev2LnkWriteElf_noteobsd.size = 24;
	Dev2LnkWriteElf_noteobsd.entrySize = 0;
	Dev2LnkWriteElf_noteobsd.link = 0;
	Dev2LnkWriteElf_noteobsd.info = 0;
	Dev2LnkWriteElf_dstr.link = 5;
	Dev2LnkWriteElf_idxSecNames = 9;
	Dev2LnkWriteElf_sectionCount = 12;
	DefSections__9_s = _s.lnk;
	__EXIT;
}

void Dev2LnkWriteElf_Init (void)
{
	INTEGER si, symi;
	SHORTCHAR _str__18[256];
	__ENTER("Dev2LnkWriteElf.Init");
	Dev2LnkBase_InitStringTable(&Dev2LnkWriteElf_symNames, Dev2LnkBase_StringTable__typ, 1000);
	Dev2LnkBase_InitStringTable(&Dev2LnkWriteElf_secNames, Dev2LnkBase_StringTable__typ, 100);
	Dev2LnkWriteElf_hashtab = __NEWARR(4, (Dev2LnkBase_impCount + Dev2LnkBase_expCount) + 1);
	Dev2LnkWriteElf_symIdx = 0;
	Dev2LnkWriteElf_AddSymbol((void*)"", 1, &symi, &si);
	Dev2LnkWriteElf_siOutName = 0;
	Dev2LnkWriteElf_siRPath = 0;
	if (Dev2LnkBase_opt.rpath[0] != 0) {
		Dev2LnkBase_AddName(&Dev2LnkWriteElf_symNames, Dev2LnkBase_StringTable__typ, (void*)Dev2LnkBase_opt.rpath, \
128, &Dev2LnkWriteElf_siRPath);
	}
	Dev2LnkWriteElf_DefSections();
	Dev2LnkWriteElf_DefSegments();
	if (Dev2LnkBase_outDll) {
		Dev2LnkWriteElf_elfType = 3;
		Dev2LnkBase_ImageBase = 0;
		__STRCOPYTS(Dev2LnkBase_outputName, _str__18, 256);
		Dev2LnkBase_AddName(&Dev2LnkWriteElf_symNames, Dev2LnkBase_StringTable__typ, (void*)_str__18, __STRLENS(_str__18) \
+ 1, &Dev2LnkWriteElf_siOutName);
		Dev2LnkWriteElf_intp.size = 0;
	} else {
		Dev2LnkWriteElf_elfType = 2;
		Dev2LnkBase_ImageBase = 134512640;
		__ASSERT(Dev2LnkBase_opt.elfInterpreter[0] != 0, 0);
		__STRCOPYSS(Dev2LnkBase_opt.elfInterpreter, Dev2LnkWriteElf_interpreter, 128);
		Dev2LnkWriteElf_intp.size = __STRLENS(Dev2LnkWriteElf_interpreter) + 1;
	}
	Dev2LnkWriteElf_intp.offs = 308;
	Dev2LnkWriteElf_intp.addr = Dev2LnkWriteElf_intp.offs + Dev2LnkBase_ImageBase;
	Dev2LnkWriteElf_code.size = Dev2LnkBase_codeSize;
	Dev2LnkWriteElf_data.size = Dev2LnkBase_dataSize;
	Dev2LnkWriteElf_vars.size = Dev2LnkBase_varsSize;
	Dev2LnkWriteElf_noteobsd.offs = Dev2LnkBase_Aligned(Dev2LnkWriteElf_intp.offs + Dev2LnkWriteElf_intp.size, \
Dev2LnkWriteElf_noteobsd.align);
	Dev2LnkWriteElf_noteobsd.addr = Dev2LnkWriteElf_noteobsd.offs + Dev2LnkBase_ImageBase;
	Dev2LnkWriteElf_code.offs = Dev2LnkBase_Aligned(Dev2LnkWriteElf_noteobsd.offs + Dev2LnkWriteElf_noteobsd.size, \
Dev2LnkWriteElf_code.align);
	Dev2LnkWriteElf_code.addr = Dev2LnkWriteElf_code.offs + Dev2LnkBase_ImageBase;
	Dev2LnkWriteElf_data.offs = Dev2LnkBase_Aligned(Dev2LnkWriteElf_code.offs + Dev2LnkWriteElf_code.size, \
4096);
	Dev2LnkWriteElf_data.addr = Dev2LnkBase_Aligned(Dev2LnkWriteElf_code.addr + Dev2LnkWriteElf_code.size, \
4096);
	Dev2LnkWriteElf_vars.addr = Dev2LnkBase_Aligned(Dev2LnkWriteElf_data.addr + Dev2LnkWriteElf_data.size, \
Dev2LnkWriteElf_vars.align);
	Dev2LnkWriteElf_entry_addr = Dev2LnkWriteElf_code.addr + Dev2LnkBase_initOffs;
	Dev2LnkWriteElf_init_addr = Dev2LnkWriteElf_entry_addr;
	Dev2LnkWriteElf_fini_addr = Dev2LnkWriteElf_code.addr + Dev2LnkBase_finiOffs;
	__EXIT;
}

void Dev2LnkWriteElf_GetBases (INTEGER *codeBase, INTEGER *dataBase, INTEGER *varsBase)
{
	__ENTER("Dev2LnkWriteElf.GetBases");
	*codeBase = Dev2LnkWriteElf_code.addr;
	*dataBase = Dev2LnkWriteElf_data.addr;
	*varsBase = Dev2LnkWriteElf_vars.addr;
	__EXIT;
}

static void Dev2LnkWriteElf_CollectImport (void)
{
	Dev2LnkBase_Module lib = NIL;
	Dev2LnkBase_Symbol sym = NIL;
	Dev2LnkBase_Symbol _ptr__8 = NIL;
	Dev2LnkBase_Symbol _ptr__7 = NIL;
	__ENTER("Dev2LnkWriteElf.CollectImport");
	Dev2LnkWriteElf_symImp = Dev2LnkWriteElf_symIdx;
	lib = Dev2LnkBase_dllList;
	while (lib != NIL) {
		_ptr__8 = lib->exp;
		_ptr__7 = lib->exp;
		Dev2LnkBase_AddDllName(&Dev2LnkWriteElf_symNames, Dev2LnkBase_StringTable__typ, (void*)_ptr__8->name, \
256, (void*)".so", 4, &_ptr__7->namIdx);
		sym = lib->exp->next;
		while (sym != NIL) {
			Dev2LnkWriteElf_AddSymbol((void*)sym->name, 256, &sym->symIdx, &sym->namIdx);
			sym = sym->next;
		}
		lib = lib->next;
	}
	__EXIT;
}

static void Dev2LnkWriteElf_CollectExport (void)
{
	Dev2LnkBase_Symbol sym = NIL;
	__ENTER("Dev2LnkWriteElf.CollectExport");
	if (Dev2LnkBase_expCount > 0) {
		sym = Dev2LnkBase_expList;
		while (sym != NIL) {
			Dev2LnkWriteElf_AddSymbol((void*)sym->name, 256, &sym->symIdx, &sym->namIdx);
			sym = sym->next;
		}
	}
	__EXIT;
}

static struct CalculateLayout__2 {
	struct CalculateLayout__2 *lnk;
} *CalculateLayout__2_s;

static void __3 (Dev2LnkWriteElf_Segment *seg, SYSTEM_TYPEDESC *seg__typ, INTEGER offs, INTEGER addr, \
INTEGER size);

static void __3 (Dev2LnkWriteElf_Segment *seg, SYSTEM_TYPEDESC *seg__typ, INTEGER offs, INTEGER addr, \
INTEGER size)
{
	__ENTER("Dev2LnkWriteElf.DefSeg");
	(*seg).offs = offs;
	(*seg).addr = addr;
	(*seg).msize = size;
	(*seg).fsize = size;
	__EXIT;
}

static void Dev2LnkWriteElf_CalculateLayout (void)
{
	struct CalculateLayout__2 _s;
	__ENTER("Dev2LnkWriteElf.CalculateLayout");
	_s.lnk = CalculateLayout__2_s;
	CalculateLayout__2_s = &_s;
	Dev2LnkWriteElf_CollectImport();
	Dev2LnkWriteElf_CollectExport();
	Dev2LnkWriteElf_symCount = Dev2LnkWriteElf_symIdx;
	Dev2LnkWriteElf_dyna.size = (Dev2LnkBase_impDllCount + 20) * Dev2LnkWriteElf_dyna.entrySize;
	Dev2LnkWriteElf_dsym.size = Dev2LnkWriteElf_symCount * Dev2LnkWriteElf_dsym.entrySize;
	Dev2LnkWriteElf_dstr.size = Dev2LnkWriteElf_symNames.len;
	Dev2LnkWriteElf_hash.size = 8 + __ASHL(__ASHL(Dev2LnkWriteElf_symCount, 2, INTEGER), 1, INTEGER);
	Dev2LnkWriteElf_relo.size = Dev2LnkWriteElf_relo.entrySize * (Dev2LnkBase_relCount + Dev2LnkBase_impCount);
	Dev2LnkWriteElf_dyna.offs = Dev2LnkBase_Aligned(Dev2LnkWriteElf_data.offs + Dev2LnkWriteElf_data.size, \
4096);
	Dev2LnkWriteElf_dyna.addr = Dev2LnkBase_Aligned(Dev2LnkWriteElf_vars.addr + Dev2LnkWriteElf_vars.size, \
4096);
	Dev2LnkWriteElf_dsym.offs = Dev2LnkBase_Aligned(Dev2LnkWriteElf_dyna.offs + Dev2LnkWriteElf_dyna.size, \
Dev2LnkWriteElf_dsym.align);
	Dev2LnkWriteElf_dstr.offs = Dev2LnkBase_Aligned(Dev2LnkWriteElf_dsym.offs + Dev2LnkWriteElf_dsym.size, \
Dev2LnkWriteElf_dstr.align);
	Dev2LnkWriteElf_hash.offs = Dev2LnkBase_Aligned(Dev2LnkWriteElf_dstr.offs + Dev2LnkWriteElf_dstr.size, \
Dev2LnkWriteElf_hash.align);
	Dev2LnkWriteElf_relo.offs = Dev2LnkBase_Aligned(Dev2LnkWriteElf_hash.offs + Dev2LnkWriteElf_hash.size, \
Dev2LnkWriteElf_relo.align);
	Dev2LnkWriteElf_dsym.addr = (Dev2LnkWriteElf_dsym.offs + Dev2LnkWriteElf_dyna.addr) - Dev2LnkWriteElf_dyna.offs;
	Dev2LnkWriteElf_dstr.addr = (Dev2LnkWriteElf_dstr.offs + Dev2LnkWriteElf_dsym.addr) - Dev2LnkWriteElf_dsym.offs;
	Dev2LnkWriteElf_hash.addr = (Dev2LnkWriteElf_hash.offs + Dev2LnkWriteElf_dstr.addr) - Dev2LnkWriteElf_dstr.offs;
	Dev2LnkWriteElf_relo.addr = (Dev2LnkWriteElf_relo.offs + Dev2LnkWriteElf_hash.addr) - Dev2LnkWriteElf_hash.offs;
	Dev2LnkWriteElf_shtOffset = Dev2LnkBase_Aligned(Dev2LnkWriteElf_relo.offs + Dev2LnkWriteElf_relo.size, \
4);
	Dev2LnkWriteElf_shtSize = Dev2LnkWriteElf_sectionCount * 40;
	__3(&Dev2LnkWriteElf_phtseg, Dev2LnkWriteElf_Segment__typ, 52, Dev2LnkBase_ImageBase + 52, 256);
	__3(&Dev2LnkWriteElf_intseg, Dev2LnkWriteElf_Segment__typ, Dev2LnkWriteElf_intp.offs, Dev2LnkBase_ImageBase \
+ Dev2LnkWriteElf_intp.offs, Dev2LnkWriteElf_intp.size);
	__3(&Dev2LnkWriteElf_codeseg, Dev2LnkWriteElf_Segment__typ, 0, Dev2LnkBase_ImageBase, Dev2LnkWriteElf_code.offs \
+ Dev2LnkWriteElf_code.size);
	__3(&Dev2LnkWriteElf_dataseg, Dev2LnkWriteElf_Segment__typ, Dev2LnkWriteElf_data.offs, Dev2LnkWriteElf_data.addr, \
Dev2LnkWriteElf_data.size);
	Dev2LnkWriteElf_dataseg.msize = Dev2LnkWriteElf_dataseg.fsize + Dev2LnkWriteElf_vars.size;
	__3(&Dev2LnkWriteElf_dynaseg, Dev2LnkWriteElf_Segment__typ, Dev2LnkWriteElf_dyna.offs, Dev2LnkWriteElf_dyna.addr, \
Dev2LnkWriteElf_dyna.size);
	__3(&Dev2LnkWriteElf_noteobsdseg, Dev2LnkWriteElf_Segment__typ, Dev2LnkWriteElf_noteobsd.offs, Dev2LnkWriteElf_noteobsd.addr, \
Dev2LnkWriteElf_noteobsd.size);
	__3(&Dev2LnkWriteElf_dsymseg, Dev2LnkWriteElf_Segment__typ, Dev2LnkWriteElf_dyna.offs, Dev2LnkWriteElf_dyna.addr, \
Dev2LnkWriteElf_shtOffset - Dev2LnkWriteElf_dyna.offs);
	CalculateLayout__2_s = _s.lnk;
	__EXIT;
}

static void Dev2LnkWriteElf_WriteElfHeader (void)
{
	SHORTCHAR e_ident[16];
	__ENTER("Dev2LnkWriteElf.WriteElfHeader");
	__MOVE("\x7f""ELF\x01\x01\x01", e_ident, 8);
	e_ident[7] = Dev2LnkBase_opt.OSABI;
	e_ident[8] = 0;
	Dev2LnkWriteElf_WriteStr((void*)e_ident, 16, 16);
	Dev2LnkWriteElf_Write2(Dev2LnkWriteElf_elfType);
	Dev2LnkWriteElf_Write2(3);
	Dev2LnkWriteElf_Write4(1);
	Dev2LnkWriteElf_Write4(Dev2LnkWriteElf_entry_addr);
	Dev2LnkWriteElf_Write4(52);
	Dev2LnkWriteElf_Write4(Dev2LnkWriteElf_shtOffset);
	Dev2LnkWriteElf_Write4(0);
	Dev2LnkWriteElf_Write2(52);
	Dev2LnkWriteElf_Write2(32);
	Dev2LnkWriteElf_Write2(8);
	Dev2LnkWriteElf_Write2(40);
	Dev2LnkWriteElf_Write2(Dev2LnkWriteElf_sectionCount);
	Dev2LnkWriteElf_Write2(Dev2LnkWriteElf_idxSecNames);
	__ASSERT(__Files_Writer_Pos(Dev2LnkWriteElf_out) == 52, 101);
	__EXIT;
}

static struct WriteProgramHeaderTable__42 {
	struct WriteProgramHeaderTable__42 *lnk;
} *WriteProgramHeaderTable__42_s;

static void __43 (Dev2LnkWriteElf_Segment *seg, SYSTEM_TYPEDESC *seg__typ);

static void __43 (Dev2LnkWriteElf_Segment *seg, SYSTEM_TYPEDESC *seg__typ)
{
	__ENTER("Dev2LnkWriteElf.WritePhtEntry");
	Dev2LnkWriteElf_Write4((*seg).type);
	Dev2LnkWriteElf_Write4((*seg).offs);
	Dev2LnkWriteElf_Write4((*seg).addr);
	Dev2LnkWriteElf_Write4((*seg).addr);
	Dev2LnkWriteElf_Write4((*seg).fsize);
	Dev2LnkWriteElf_Write4((*seg).msize);
	Dev2LnkWriteElf_Write4((*seg).flags);
	Dev2LnkWriteElf_Write4((*seg).align);
	__EXIT;
}

static void Dev2LnkWriteElf_WriteProgramHeaderTable (void)
{
	struct WriteProgramHeaderTable__42 _s;
	__ENTER("Dev2LnkWriteElf.WriteProgramHeaderTable");
	_s.lnk = WriteProgramHeaderTable__42_s;
	WriteProgramHeaderTable__42_s = &_s;
	__43(&Dev2LnkWriteElf_phtseg, Dev2LnkWriteElf_Segment__typ);
	__43(&Dev2LnkWriteElf_intseg, Dev2LnkWriteElf_Segment__typ);
	__43(&Dev2LnkWriteElf_codeseg, Dev2LnkWriteElf_Segment__typ);
	__43(&Dev2LnkWriteElf_dataseg, Dev2LnkWriteElf_Segment__typ);
	__43(&Dev2LnkWriteElf_dsymseg, Dev2LnkWriteElf_Segment__typ);
	__43(&Dev2LnkWriteElf_dynaseg, Dev2LnkWriteElf_Segment__typ);
	__43(&Dev2LnkWriteElf_noteobsdseg, Dev2LnkWriteElf_Segment__typ);
	__43(&Dev2LnkWriteElf_obsdwxneedseg, Dev2LnkWriteElf_Segment__typ);
	WriteProgramHeaderTable__42_s = _s.lnk;
	__EXIT;
}

static void Dev2LnkWriteElf_WriteInterpreter (void)
{
	__ENTER("Dev2LnkWriteElf.WriteInterpreter");
	if (Dev2LnkWriteElf_intp.size > 0) {
		Dev2LnkWriteElf_WriteStr((void*)Dev2LnkWriteElf_interpreter, 128, 0);
	}
	__EXIT;
}

static void Dev2LnkWriteElf_WritePlt (void)
{
	Dev2LnkBase_Module mod = NIL;
	Dev2LnkBase_Symbol sym = NIL;
	__ENTER("Dev2LnkWriteElf.WritePlt");
	mod = Dev2LnkBase_dllList;
	while (mod != NIL) {
		sym = mod->exp->next;
		while (sym != NIL) {
			Dev2LnkWriteElf_WriteCh(233);
			Dev2LnkWriteElf_Write4(-4);
			Dev2LnkWriteElf_WriteCh(144);
			sym = sym->next;
		}
		mod = mod->next;
	}
	__EXIT;
}

static void Dev2LnkWriteElf_WriteCode (void)
{
	Dev2LnkBase_Module mod = NIL;
	struct BYTE_ARRAY *_ptr__28 = NIL;
	struct BYTE_ARRAY *_ptr__27 = NIL;
	__ENTER("Dev2LnkWriteElf.WriteCode");
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_code.offs);
	_ptr__28 = Dev2LnkBase_initMod->code->bytes;
	__Files_Writer_WriteBytes(Dev2LnkWriteElf_out, (void*)_ptr__28->data, _ptr__28->len[0], 0, Dev2LnkBase_initMod->code->size);
	mod = Dev2LnkBase_modList;
	while (mod != NIL) {
		_ptr__27 = mod->code->bytes;
		__Files_Writer_WriteBytes(Dev2LnkWriteElf_out, (void*)_ptr__27->data, _ptr__27->len[0], 0, mod->code->size);
		mod = mod->next;
	}
	Dev2LnkWriteElf_WritePlt();
	__EXIT;
}

static void Dev2LnkWriteElf_WriteData (void)
{
	Dev2LnkBase_Module mod = NIL;
	struct BYTE_ARRAY *_ptr__30 = NIL;
	__ENTER("Dev2LnkWriteElf.WriteData");
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_data.offs);
	mod = Dev2LnkBase_modList;
	while (mod != NIL) {
		_ptr__30 = mod->data->bytes;
		__Files_Writer_WriteBytes(Dev2LnkWriteElf_out, (void*)_ptr__30->data, _ptr__30->len[0], 0, mod->data->size);
		mod = mod->next;
	}
	__EXIT;
}

static void Dev2LnkWriteElf_WriteSymbol (INTEGER namIdx, INTEGER val, INTEGER si, INTEGER typ)
{
	__ENTER("Dev2LnkWriteElf.WriteSymbol");
	Dev2LnkWriteElf_Write4(namIdx);
	Dev2LnkWriteElf_Write4(val);
	if (typ == 1) {
		Dev2LnkWriteElf_Write4(4);
		Dev2LnkWriteElf_Write1(17);
	} else if (typ == 0) {
		Dev2LnkWriteElf_Write4(0);
		Dev2LnkWriteElf_Write1(18);
	} else {
		__HALT(100);
	}
	Dev2LnkWriteElf_Write1(0);
	Dev2LnkWriteElf_Write2(si);
	__EXIT;
}

static void Dev2LnkWriteElf_WriteSymbolTable (void)
{
	Dev2LnkBase_Symbol sym = NIL;
	Dev2LnkBase_Module m = NIL;
	__ENTER("Dev2LnkWriteElf.WriteSymbolTable");
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_dsym.offs);
	Dev2LnkWriteElf_WriteSymbol(0, 0, 0, 0);
	m = Dev2LnkBase_dllList;
	while (m != NIL) {
		sym = m->exp->next;
		while (sym != NIL) {
			Dev2LnkWriteElf_WriteSymbol(sym->namIdx, 0, 0, sym->typ);
			sym = sym->next;
		}
		m = m->next;
	}
	sym = Dev2LnkBase_expList;
	while (sym != NIL) {
		Dev2LnkWriteElf_WriteSymbol(sym->namIdx, sym->addr, 1, sym->typ);
		sym = sym->next;
	}
	__ASSERT(Dev2LnkWriteElf_dsym.size == __Files_Writer_Pos(Dev2LnkWriteElf_out) - Dev2LnkWriteElf_dsym.offs, \
101);
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_dstr.offs);
	Dev2LnkBase_WriteStringTable(Dev2LnkWriteElf_out, &Dev2LnkWriteElf_symNames, Dev2LnkBase_StringTable__typ);
	__EXIT;
}

static void Dev2LnkWriteElf_MakeHash (struct INTEGER_ARRAY **bucket, struct INTEGER_ARRAY **chain)
{
	INTEGER nbucket, symi, hi, k, _for__20;
	__ENTER("Dev2LnkWriteElf.MakeHash");
	*bucket = NIL;
	*chain = NIL;
	nbucket = Dev2LnkWriteElf_symCount;
	*bucket = __NEWARR(4, nbucket);
	*chain = __NEWARR(4, Dev2LnkWriteElf_symCount);
	_for__20 = Dev2LnkWriteElf_symCount - 1;
	symi = 0;
	while (symi <= _for__20) {
		((*chain)->data)[__X(symi, (*chain)->len[0])] = 0;
		hi = __MODF((Dev2LnkWriteElf_hashtab->data)[__X(symi, Dev2LnkWriteElf_hashtab->len[0])], nbucket);
		if (((*bucket)->data)[__X(hi, (*bucket)->len[0])] != 0) {
			k = symi;
			while (((*chain)->data)[__X(k, (*chain)->len[0])] != 0) {
				k = ((*chain)->data)[__X(k, (*chain)->len[0])];
			}
			((*chain)->data)[__X(k, (*chain)->len[0])] = ((*bucket)->data)[__X(hi, (*bucket)->len[0])];
		}
		((*bucket)->data)[__X(hi, (*bucket)->len[0])] = symi;
		symi += 1;
	}
	__EXIT;
}

static void Dev2LnkWriteElf_WriteHash (void)
{
	INTEGER i;
	struct INTEGER_ARRAY *bucket = NIL;
	struct INTEGER_ARRAY *chain = NIL;
	INTEGER _for__37, _for__36;
	__ENTER("Dev2LnkWriteElf.WriteHash");
	Dev2LnkWriteElf_MakeHash((void*)&bucket, (void*)&chain);
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_hash.offs);
	Dev2LnkWriteElf_Write4(bucket->len[0]);
	Dev2LnkWriteElf_Write4(chain->len[0]);
	_for__37 = bucket->len[0] - 1;
	i = 0;
	while (i <= _for__37) {
		Dev2LnkWriteElf_Write4((bucket->data)[__X(i, bucket->len[0])]);
		i += 1;
	}
	_for__36 = chain->len[0] - 1;
	i = 0;
	while (i <= _for__36) {
		Dev2LnkWriteElf_Write4((chain->data)[__X(i, chain->len[0])]);
		i += 1;
	}
	__ASSERT(Dev2LnkWriteElf_hash.size == __Files_Writer_Pos(Dev2LnkWriteElf_out) - Dev2LnkWriteElf_hash.offs, \
101);
	__EXIT;
}

static void Dev2LnkWriteElf_WriteReloc (void)
{
	Dev2LnkBase_Module mod = NIL;
	Dev2LnkBase_Symbol sym = NIL;
	INTEGER i, _for__46;
	__ENTER("Dev2LnkWriteElf.WriteReloc");
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_relo.offs);
	mod = Dev2LnkBase_dllList;
	while (mod != NIL) {
		sym = mod->exp->next;
		while (sym != NIL) {
			Dev2LnkWriteElf_Write4(sym->addr + 1);
			Dev2LnkWriteElf_Write4(2 + __ASHL(sym->symIdx, 8, INTEGER));
			sym = sym->next;
		}
		mod = mod->next;
	}
	Dev2LnkBase_SortReloc();
	_for__46 = Dev2LnkBase_relCount - 1;
	i = 0;
	while (i <= _for__46) {
		Dev2LnkWriteElf_Write4((Dev2LnkBase_relTab->data)[__X(i, Dev2LnkBase_relTab->len[0])]);
		Dev2LnkWriteElf_Write4(8);
		i += 1;
	}
	__EXIT;
}

static struct WriteDynamic__31 {
	struct WriteDynamic__31 *lnk;
} *WriteDynamic__31_s;

static void __32 (INTEGER tag, INTEGER val);

static void __32 (INTEGER tag, INTEGER val)
{
	__ENTER("Dev2LnkWriteElf.DynaEntry");
	Dev2LnkWriteElf_Write4(tag);
	Dev2LnkWriteElf_Write4(val);
	__EXIT;
}

static void Dev2LnkWriteElf_WriteDynamic (void)
{
	Dev2LnkBase_Module lib = NIL;
	struct WriteDynamic__31 _s;
	__ENTER("Dev2LnkWriteElf.WriteDynamic");
	_s.lnk = WriteDynamic__31_s;
	WriteDynamic__31_s = &_s;
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_dyna.offs);
	lib = Dev2LnkBase_dllList;
	while (lib != NIL) {
		__32(1, lib->exp->namIdx);
		lib = lib->next;
	}
	if (Dev2LnkWriteElf_siRPath > 0) {
		__32(15, Dev2LnkWriteElf_siRPath);
	}
	__32(6, Dev2LnkWriteElf_dsym.addr);
	__32(11, Dev2LnkWriteElf_dsym.entrySize);
	__32(4, Dev2LnkWriteElf_hash.addr);
	__32(5, Dev2LnkWriteElf_dstr.addr);
	__32(10, Dev2LnkWriteElf_dstr.size);
	__32(22, 0);
	__32(17, Dev2LnkWriteElf_relo.addr);
	__32(18, Dev2LnkWriteElf_relo.size);
	__32(19, Dev2LnkWriteElf_relo.entrySize);
	if (Dev2LnkBase_outDll) {
		__32(14, Dev2LnkWriteElf_siOutName);
		__32(12, Dev2LnkWriteElf_init_addr);
		__32(13, Dev2LnkWriteElf_fini_addr);
	}
	__32(24, 1);
	__32(0, 0);
	WriteDynamic__31_s = _s.lnk;
	__EXIT;
}

static void Dev2LnkWriteElf_WriteObsdNote (void)
{
	__ENTER("Dev2LnkWriteElf.WriteObsdNote");
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_noteobsd.offs);
	Dev2LnkWriteElf_Write4(8);
	Dev2LnkWriteElf_Write4(4);
	Dev2LnkWriteElf_Write4(1);
	Dev2LnkWriteElf_WriteStr((void*)"OpenBSD", 8, 8);
	Dev2LnkWriteElf_Write4(0);
	__EXIT;
}

static struct WriteSectionTable__47 {
	struct WriteSectionTable__47 *lnk;
} *WriteSectionTable__47_s;

static void __48 (Dev2LnkWriteElf_Section *scn, SYSTEM_TYPEDESC *scn__typ);

static void __48 (Dev2LnkWriteElf_Section *scn, SYSTEM_TYPEDESC *scn__typ)
{
	__ENTER("Dev2LnkWriteElf.WriteSHEntry");
	Dev2LnkWriteElf_Write4((*scn).namIdx);
	Dev2LnkWriteElf_Write4((*scn).type);
	Dev2LnkWriteElf_Write4((*scn).flags);
	Dev2LnkWriteElf_Write4((*scn).addr);
	Dev2LnkWriteElf_Write4((*scn).offs);
	Dev2LnkWriteElf_Write4((*scn).size);
	Dev2LnkWriteElf_Write4((*scn).link);
	Dev2LnkWriteElf_Write4((*scn).info);
	Dev2LnkWriteElf_Write4((*scn).align);
	Dev2LnkWriteElf_Write4((*scn).entrySize);
	__EXIT;
}

static void Dev2LnkWriteElf_WriteSectionTable (void)
{
	struct WriteSectionTable__47 _s;
	__ENTER("Dev2LnkWriteElf.WriteSectionTable");
	_s.lnk = WriteSectionTable__47_s;
	WriteSectionTable__47_s = &_s;
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_shtOffset);
	Dev2LnkWriteElf_shstr.offs = Dev2LnkWriteElf_shtOffset + Dev2LnkWriteElf_shtSize;
	Dev2LnkWriteElf_shstr.size = Dev2LnkWriteElf_secNames.len;
	__48(&Dev2LnkWriteElf_empty, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_code, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_data, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_vars, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_dstr, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_dsym, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_hash, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_relo, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_dyna, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_shstr, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_intp, Dev2LnkWriteElf_Section__typ);
	__48(&Dev2LnkWriteElf_noteobsd, Dev2LnkWriteElf_Section__typ);
	Dev2LnkWriteElf_PadTo(Dev2LnkWriteElf_shstr.offs);
	Dev2LnkBase_WriteStringTable(Dev2LnkWriteElf_out, &Dev2LnkWriteElf_secNames, Dev2LnkBase_StringTable__typ);
	WriteSectionTable__47_s = _s.lnk;
	__EXIT;
}

void Dev2LnkWriteElf_WriteOut (void)
{
	INTEGER res;
	Kernel_Module m = NIL;
	Kernel_Command p = NIL;
	__ENTER("Dev2LnkWriteElf.WriteOut");
	Dev2LnkWriteElf_CalculateLayout();
	Dev2LnkWriteElf_outFile = __Files_Directory_New(Files_dir, __Files_Directory_This(Files_dir, (void*)Dev2LnkBase_outputPath, \
256), 1);
	Dev2LnkWriteElf_out = __Files_File_NewWriter(Dev2LnkWriteElf_outFile, Dev2LnkWriteElf_out);
	__Files_Writer_SetPos(Dev2LnkWriteElf_out, 0);
	Dev2LnkWriteElf_WriteElfHeader();
	Dev2LnkWriteElf_WriteProgramHeaderTable();
	Dev2LnkWriteElf_WriteInterpreter();
	Dev2LnkWriteElf_WriteObsdNote();
	Dev2LnkWriteElf_WriteCode();
	Dev2LnkWriteElf_WriteData();
	Dev2LnkWriteElf_WriteDynamic();
	Dev2LnkWriteElf_WriteSymbolTable();
	Dev2LnkWriteElf_WriteHash();
	Dev2LnkWriteElf_WriteReloc();
	Dev2LnkWriteElf_WriteSectionTable();
	__Files_Writer_SetPos(Dev2LnkWriteElf_out, 0);
	Dev2LnkWriteElf_WriteElfHeader();
	if (!Dev2LnkBase_error) {
		__Files_File_Register(Dev2LnkWriteElf_outFile, Dev2LnkBase_outputName, Dev2LnkBase_outputType, 1, &res);
		if (res != 0) {
			Dev2LnkBase_Error((CHAR*)((CHAR[]){82, 101, 103, 105, 115, 116, 101, 114, 0}), 9);
		} else {
			Dev2LnkChmod_Chmod();
		}
	}
	__EXIT;
}

static INTEGER Dev2LnkWriteElf_Section__flds[] = {
	10, 
	0, 0, 1<<8 | 0x15, 6,
	0, 4, 8<<8 | 0x15, 6,
	0, 8, 13<<8 | 0x15, 6,
	0, 12, 19<<8 | 0x15, 6,
	0, 16, 24<<8 | 0x15, 6,
	0, 20, 29<<8 | 0x15, 6,
	0, 24, 34<<8 | 0x15, 6,
	0, 28, 40<<8 | 0x15, 6,
	0, 32, 45<<8 | 0x15, 6,
	0, 36, 50<<8 | 0x15, 6,
};
export INTEGER Dev2LnkWriteElf_Section__desc[] = {
	-1, 
	0, 
	40,
	(INTEGER)&Dev2LnkWriteElf__desc,
	60<<8 | 0x01,
	(INTEGER)(Dev2LnkWriteElf_Section__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkWriteElf_Section__flds, 
	-4
};
static INTEGER Dev2LnkWriteElf_Segment__flds[] = {
	7, 
	0, 0, 8<<8 | 0x15, 6,
	0, 4, 24<<8 | 0x15, 6,
	0, 8, 29<<8 | 0x15, 6,
	0, 12, 68<<8 | 0x15, 6,
	0, 16, 74<<8 | 0x15, 6,
	0, 20, 34<<8 | 0x15, 6,
	0, 24, 13<<8 | 0x15, 6,
};
export INTEGER Dev2LnkWriteElf_Segment__desc[] = {
	-1, 
	0, 
	28,
	(INTEGER)&Dev2LnkWriteElf__desc,
	80<<8 | 0x01,
	(INTEGER)(Dev2LnkWriteElf_Segment__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkWriteElf_Segment__flds, 
	-4
};
export INTEGER Dev2LnkWriteElf__1__desc[] = {
	0,
	(INTEGER)&Dev2LnkWriteElf__desc,
	0<<8 | 0x12,
	6
};
export INTEGER Dev2LnkWriteElf__2__desc[] = {
	0,
	(INTEGER)&Dev2LnkWriteElf__desc,
	0<<8 | 0x03,
	(INTEGER)Dev2LnkWriteElf__1__desc
};
export INTEGER Dev2LnkWriteElf__3__desc[] = {
	128,
	(INTEGER)&Dev2LnkWriteElf__desc,
	0<<8 | 0x02,
	2
};
static SYSTEM_MODDESC *Dev2LnkWriteElf__imp[] = {
	&Dev2LnkChmod__desc,
	&Files__desc,
	&Kernel__desc,
	&Dev2LnkBase__desc,
};
static INTEGER Dev2LnkWriteElf__exp[] = {
	80,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_AddSymbol, 88<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_CalculateLayout, 98<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_CollectExport, 114<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_CollectImport, 128<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_DefSections, 142<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_DefSegments, 154<<8 | 0x14, 0,
	0x97d03b74, 0, 166<<8 | 0x41, 0,
	0x1d7d105b, 0, 179<<8 | 0x41, 0,
	0x32f7c68d, 0, 196<<8 | 0x41, 0,
	0x3636db3a, 0, 211<<8 | 0x41, 0,
	0x3fb4e054, 0, 227<<8 | 0x41, 0,
	0x14ff2b35, 0, 241<<8 | 0x41, 0,
	0xd22d14c8, (INTEGER)Dev2LnkWriteElf_GetBases, 258<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_HashStr, 267<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)Dev2LnkWriteElf_Init, 275<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_MakeHash, 280<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_PadTo, 289<<8 | 0x14, 0,
	0xd1032275, 0x3006d2b5, 60<<8 | 0x12, (INTEGER)(Dev2LnkWriteElf_Section__desc + 2),
	0x469e4209, 0xc3c099cb, 80<<8 | 0x12, (INTEGER)(Dev2LnkWriteElf_Segment__desc + 2),
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_Write1, 295<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_Write2, 302<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_Write4, 309<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteCh, 316<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteCode, 324<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteData, 334<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteDynamic, 344<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteElfHeader, 357<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteHash, 372<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteInterpreter, 382<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteObsdNote, 399<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)Dev2LnkWriteElf_WriteOut, 413<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WritePlt, 422<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteProgramHeaderTable, 431<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteReloc, 455<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteSectionTable, 466<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteStr, 484<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteSymbol, 493<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWriteElf_WriteSymbolTable, 505<<8 | 0x14, 0,
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_code, 522<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0x2d28f3a7, (INTEGER)&Dev2LnkWriteElf_codeseg, 527<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Segment__desc \
+ 2),
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_data, 535<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0x2d28f3a7, (INTEGER)&Dev2LnkWriteElf_dataseg, 540<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Segment__desc \
+ 2),
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_dstr, 548<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_dsym, 553<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0x2d28f3a7, (INTEGER)&Dev2LnkWriteElf_dsymseg, 558<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Segment__desc \
+ 2),
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_dyna, 566<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0x2d28f3a7, (INTEGER)&Dev2LnkWriteElf_dynaseg, 571<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Segment__desc \
+ 2),
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_elfType, 579<<8 | 0x13, 6,
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_empty, 587<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_entry_addr, 593<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_fini_addr, 604<<8 | 0x13, 6,
	0x78100336, 0, 614<<8 | 0x41, 0,
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_hash, 633<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0xe8c4a3dc, (INTEGER)&Dev2LnkWriteElf_hashtab, 638<<8 | 0x13, (INTEGER)Dev2LnkWriteElf__2__desc,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_idxSecNames, 646<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_init_addr, 658<<8 | 0x13, 6,
	0x6e41fcaa, (INTEGER)&Dev2LnkWriteElf_interpreter, 668<<8 | 0x13, (INTEGER)Dev2LnkWriteElf__3__desc,
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_intp, 680<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0x2d28f3a7, (INTEGER)&Dev2LnkWriteElf_intseg, 685<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Segment__desc \
+ 2),
	0x2b80da2c, 0, 692<<8 | 0x41, 0,
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_noteobsd, 709<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc \
+ 2),
	0x2d28f3a7, (INTEGER)&Dev2LnkWriteElf_noteobsdseg, 718<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Segment__desc \
+ 2),
	0x2d28f3a7, (INTEGER)&Dev2LnkWriteElf_obsdwxneedseg, 730<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Segment__desc \
+ 2),
	0x5763f61a, 0, 744<<8 | 0x41, 0,
	0x204427f5, (INTEGER)&Dev2LnkWriteElf_out, 763<<8 | 0x13, (INTEGER)Files_Writer__desc,
	0x5589de0a, (INTEGER)&Dev2LnkWriteElf_outFile, 767<<8 | 0x13, (INTEGER)Files_File__desc,
	0x2d28f3a7, (INTEGER)&Dev2LnkWriteElf_phtseg, 775<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Segment__desc \
+ 2),
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_relo, 782<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0xbde5f499, (INTEGER)&Dev2LnkWriteElf_secNames, 787<<8 | 0x13, (INTEGER)(Dev2LnkBase_StringTable__desc \
+ 2),
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_sectionCount, 796<<8 | 0x13, 6,
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_shstr, 809<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_shtOffset, 815<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_shtSize, 825<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_siOutName, 833<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_siRPath, 843<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_symCount, 851<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_symIdx, 860<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWriteElf_symImp, 867<<8 | 0x13, 6,
	0xbde5f499, (INTEGER)&Dev2LnkWriteElf_symNames, 874<<8 | 0x13, (INTEGER)(Dev2LnkBase_StringTable__desc \
+ 2),
	0x2da630c8, (INTEGER)&Dev2LnkWriteElf_vars, 883<<8 | 0x13, (INTEGER)(Dev2LnkWriteElf_Section__desc + \
2),
};
static char Dev2LnkWriteElf__names[] = {
	0,
	'n','a','m','I','d','x',0,
	't','y','p','e',0,
	'f','l','a','g','s',0,
	's','i','z','e',0,
	'a','d','d','r',0,
	'o','f','f','s',0,
	'a','l','i','g','n',0,
	'l','i','n','k',0,
	'i','n','f','o',0,
	'e','n','t','r','y','S','i','z','e',0,
	'S','e','c','t','i','o','n',0,
	'm','s','i','z','e',0,
	'f','s','i','z','e',0,
	'S','e','g','m','e','n','t',0,
	'A','d','d','S','y','m','b','o','l',0,
	'C','a','l','c','u','l','a','t','e','L','a','y','o','u','t',0,
	'C','o','l','l','e','c','t','E','x','p','o','r','t',0,
	'C','o','l','l','e','c','t','I','m','p','o','r','t',0,
	'D','e','f','S','e','c','t','i','o','n','s',0,
	'D','e','f','S','e','g','m','e','n','t','s',0,
	'E','L','F','O','S','A','B','I','_','A','R','M',0,
	'E','L','F','O','S','A','B','I','_','F','R','E','E','B','S','D',0,
	'E','L','F','O','S','A','B','I','_','L','I','N','U','X',0,
	'E','L','F','O','S','A','B','I','_','N','E','T','B','S','D',0,
	'E','L','F','O','S','A','B','I','_','N','O','N','E',0,
	'E','L','F','O','S','A','B','I','_','O','P','E','N','B','S','D',0,
	'G','e','t','B','a','s','e','s',0,
	'H','a','s','h','S','t','r',0,
	'I','n','i','t',0,
	'M','a','k','e','H','a','s','h',0,
	'P','a','d','T','o',0,
	'W','r','i','t','e','1',0,
	'W','r','i','t','e','2',0,
	'W','r','i','t','e','4',0,
	'W','r','i','t','e','C','h',0,
	'W','r','i','t','e','C','o','d','e',0,
	'W','r','i','t','e','D','a','t','a',0,
	'W','r','i','t','e','D','y','n','a','m','i','c',0,
	'W','r','i','t','e','E','l','f','H','e','a','d','e','r',0,
	'W','r','i','t','e','H','a','s','h',0,
	'W','r','i','t','e','I','n','t','e','r','p','r','e','t','e','r',0,
	'W','r','i','t','e','O','b','s','d','N','o','t','e',0,
	'W','r','i','t','e','O','u','t',0,
	'W','r','i','t','e','P','l','t',0,
	'W','r','i','t','e','P','r','o','g','r','a','m','H','e','a','d','e','r','T','a','b','l','e',0,
	'W','r','i','t','e','R','e','l','o','c',0,
	'W','r','i','t','e','S','e','c','t','i','o','n','T','a','b','l','e',0,
	'W','r','i','t','e','S','t','r',0,
	'W','r','i','t','e','S','y','m','b','o','l',0,
	'W','r','i','t','e','S','y','m','b','o','l','T','a','b','l','e',0,
	'c','o','d','e',0,
	'c','o','d','e','s','e','g',0,
	'd','a','t','a',0,
	'd','a','t','a','s','e','g',0,
	'd','s','t','r',0,
	'd','s','y','m',0,
	'd','s','y','m','s','e','g',0,
	'd','y','n','a',0,
	'd','y','n','a','s','e','g',0,
	'e','l','f','T','y','p','e',0,
	'e','m','p','t','y',0,
	'e','n','t','r','y','_','a','d','d','r',0,
	'f','i','n','i','_','a','d','d','r',0,
	'f','r','e','e','B','S','D','I','n','t','e','r','p','r','e','t','e','r',0,
	'h','a','s','h',0,
	'h','a','s','h','t','a','b',0,
	'i','d','x','S','e','c','N','a','m','e','s',0,
	'i','n','i','t','_','a','d','d','r',0,
	'i','n','t','e','r','p','r','e','t','e','r',0,
	'i','n','t','p',0,
	'i','n','t','s','e','g',0,
	'l','i','n','u','x','I','n','t','e','r','p','r','e','t','e','r',0,
	'n','o','t','e','o','b','s','d',0,
	'n','o','t','e','o','b','s','d','s','e','g',0,
	'o','b','s','d','w','x','n','e','e','d','s','e','g',0,
	'o','p','e','n','B','S','D','I','n','t','e','r','p','r','e','t','e','r',0,
	'o','u','t',0,
	'o','u','t','F','i','l','e',0,
	'p','h','t','s','e','g',0,
	'r','e','l','o',0,
	's','e','c','N','a','m','e','s',0,
	's','e','c','t','i','o','n','C','o','u','n','t',0,
	's','h','s','t','r',0,
	's','h','t','O','f','f','s','e','t',0,
	's','h','t','S','i','z','e',0,
	's','i','O','u','t','N','a','m','e',0,
	's','i','R','P','a','t','h',0,
	's','y','m','C','o','u','n','t',0,
	's','y','m','I','d','x',0,
	's','y','m','I','m','p',0,
	's','y','m','N','a','m','e','s',0,
	'v','a','r','s',0,
};
static INTEGER Dev2LnkWriteElf__ptrs[] = {
	(INTEGER)&Dev2LnkWriteElf_outFile + 0, 
	(INTEGER)&Dev2LnkWriteElf_out + 0, 
	(INTEGER)&Dev2LnkWriteElf_symNames + 0, 
	(INTEGER)&Dev2LnkWriteElf_secNames + 0, 
	(INTEGER)&Dev2LnkWriteElf_hashtab + 0, 
};
struct SYSTEM_MODDESC Dev2LnkWriteElf__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 16}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Dev2LnkWriteElf__body,
	0,
	4, /* nofimps */ 
	5, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Dev2LnkWriteElf__names,
	Dev2LnkWriteElf__ptrs,
	Dev2LnkWriteElf__imp,
	(SYSTEM_DIRECTORY*)Dev2LnkWriteElf__exp,
	"Dev2LnkWriteElf"
};

export void Dev2LnkWriteElf__reg()
{
	__BEGREG(Dev2LnkWriteElf__desc);
	Kernel__reg();
	Dev2LnkChmod__reg();
	Dev2LnkBase__reg();
	Files__reg();
	__REGMOD(Dev2LnkWriteElf__desc);
	__ENDREG;
}

export void Dev2LnkWriteElf__body()
{
	__BEGBODY(Dev2LnkWriteElf__desc);
	Kernel__body();
	Dev2LnkChmod__body();
	Dev2LnkBase__body();
	Files__body();
	__ENDBODY;
}
