/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Dev2LnkBase.h"
#include "Files.h"

typedef
	struct Dev2LnkWritePe_Section {
		INTEGER size, offs, addr;
	} Dev2LnkWritePe_Section;


static Files_File Dev2LnkWritePe_outFile;
static Files_Writer Dev2LnkWritePe_out;
static INTEGER Dev2LnkWritePe_subsystem, Dev2LnkWritePe_AddressOfEntryPoint, Dev2LnkWritePe_NumberOfSections, \
Dev2LnkWritePe_TimeDateStamp, Dev2LnkWritePe_SizeOfImage;
static Dev2LnkWritePe_Section Dev2LnkWritePe_code, Dev2LnkWritePe_data, Dev2LnkWritePe_vars, Dev2LnkWritePe_rsrc, \
Dev2LnkWritePe_impo, Dev2LnkWritePe_expo, Dev2LnkWritePe_relo;
static INTEGER Dev2LnkWritePe_impDirSize;
static Dev2LnkBase_StringTable Dev2LnkWritePe_expStrTable, Dev2LnkWritePe_impStrTable;
static INTEGER Dev2LnkWritePe_outNameStrIndex;
static SET Dev2LnkWritePe_exeFlags;

export INTEGER Dev2LnkWritePe_Section__desc[];
export SYSTEM_TYPEDESC *Dev2LnkWritePe_Section__typ = (SYSTEM_TYPEDESC*)(Dev2LnkWritePe_Section__desc \
+ 2);

static void Dev2LnkWritePe_CalculateLayout (void);
static void Dev2LnkWritePe_CollectExport (void);
static void Dev2LnkWritePe_CollectImp (void);
export void Dev2LnkWritePe_GetBases (INTEGER *codeBase, INTEGER *dataBase, INTEGER *varsBase);
export void Dev2LnkWritePe_Init (void);
static void Dev2LnkWritePe_PadTo (INTEGER pos);
static void Dev2LnkWritePe_Write2 (INTEGER x);
static void Dev2LnkWritePe_Write4 (INTEGER x);
static void Dev2LnkWritePe_WriteCh (SHORTCHAR ch);
static void Dev2LnkWritePe_WriteCode (void);
static void Dev2LnkWritePe_WriteData (void);
static void Dev2LnkWritePe_WriteExport (void);
static void Dev2LnkWritePe_WriteHeader (void);
static void Dev2LnkWritePe_WriteImport (void);
static void Dev2LnkWritePe_WriteInitCode (void);
export void Dev2LnkWritePe_WriteOut (void);
static void Dev2LnkWritePe_WritePlt (void);
static void Dev2LnkWritePe_WriteReloc (void);
static void Dev2LnkWritePe_WriteSectionHeaders (void);
static void Dev2LnkWritePe_WriteStr (SHORTCHAR *s, INTEGER s__len, INTEGER len);

export void Dev2LnkWritePe__reg();
export void Dev2LnkWritePe__body();
export struct SYSTEM_MODDESC Dev2LnkWritePe__desc;


static void Dev2LnkWritePe_WriteCh (SHORTCHAR ch)
{
	__ENTER("Dev2LnkWritePe.WriteCh");
	__Files_Writer_WriteByte(Dev2LnkWritePe_out, (BYTE)ch);
	__EXIT;
}

static void Dev2LnkWritePe_Write2 (INTEGER x)
{
	__ENTER("Dev2LnkWritePe.Write2");
	__Files_Writer_WriteByte(Dev2LnkWritePe_out, (BYTE)__MASK(x, -256));
	x = __ASHR(x, 8, INTEGER);
	__Files_Writer_WriteByte(Dev2LnkWritePe_out, (BYTE)__MASK(x, -256));
	__EXIT;
}

static void Dev2LnkWritePe_Write4 (INTEGER x)
{
	__ENTER("Dev2LnkWritePe.Write4");
	__Files_Writer_WriteByte(Dev2LnkWritePe_out, (BYTE)__MASK(x, -256));
	x = __ASHR(x, 8, INTEGER);
	__Files_Writer_WriteByte(Dev2LnkWritePe_out, (BYTE)__MASK(x, -256));
	x = __ASHR(x, 8, INTEGER);
	__Files_Writer_WriteByte(Dev2LnkWritePe_out, (BYTE)__MASK(x, -256));
	x = __ASHR(x, 8, INTEGER);
	__Files_Writer_WriteByte(Dev2LnkWritePe_out, (BYTE)__MASK(x, -256));
	__EXIT;
}

static void Dev2LnkWritePe_WriteStr (SHORTCHAR *s, INTEGER s__len, INTEGER len)
{
	INTEGER i;
	__ENTER("Dev2LnkWritePe.WriteStr");
	i = 0;
	while (s[__X(i, s__len)] != 0) {
		__Files_Writer_WriteByte(Dev2LnkWritePe_out, (BYTE)s[__X(i, s__len)]);
		i += 1;
	}
	while (i < len) {
		__Files_Writer_WriteByte(Dev2LnkWritePe_out, 0);
		i += 1;
	}
	__EXIT;
}

static void Dev2LnkWritePe_PadTo (INTEGER pos)
{
	__ENTER("Dev2LnkWritePe.PadTo");
	while (__Files_Writer_Pos(Dev2LnkWritePe_out) < pos) {
		__Files_Writer_WriteByte(Dev2LnkWritePe_out, 0);
	}
	__EXIT;
}

void Dev2LnkWritePe_Init (void)
{
	__ENTER("Dev2LnkWritePe.Init");
	Dev2LnkBase_InitStringTable(&Dev2LnkWritePe_impStrTable, Dev2LnkBase_StringTable__typ, 1000);
	Dev2LnkBase_InitStringTable(&Dev2LnkWritePe_expStrTable, Dev2LnkBase_StringTable__typ, 0);
	Dev2LnkWritePe_subsystem = 2;
	if (Dev2LnkBase_opt.subsystem != 0) {
		Dev2LnkWritePe_subsystem = Dev2LnkBase_opt.subsystem;
	}
	Dev2LnkWritePe_exeFlags = 0x0206;
	if (Dev2LnkBase_outDll) {
		Dev2LnkWritePe_exeFlags |= __SETOF(13);
		Dev2LnkBase_ImageBase = 268435456;
	} else {
		Dev2LnkBase_ImageBase = 4194304;
	}
	if (Dev2LnkBase_opt.imageBase > 0) {
		Dev2LnkBase_ImageBase = Dev2LnkBase_opt.imageBase;
	}
	Dev2LnkWritePe_NumberOfSections = 0;
	Dev2LnkWritePe_code.size = Dev2LnkBase_codeSize;
	Dev2LnkWritePe_data.size = Dev2LnkBase_dataSize;
	Dev2LnkWritePe_vars.size = Dev2LnkBase_varsSize;
	Dev2LnkWritePe_code.addr = 4096;
	Dev2LnkWritePe_data.addr = Dev2LnkBase_Aligned(Dev2LnkWritePe_code.addr + Dev2LnkWritePe_code.size, 4096);
	Dev2LnkWritePe_vars.addr = Dev2LnkBase_Aligned(Dev2LnkWritePe_data.addr + Dev2LnkWritePe_data.size, 4096);
	Dev2LnkWritePe_AddressOfEntryPoint = Dev2LnkWritePe_code.addr + Dev2LnkBase_initOffs;
	__EXIT;
}

void Dev2LnkWritePe_GetBases (INTEGER *codeBase, INTEGER *dataBase, INTEGER *varsBase)
{
	__ENTER("Dev2LnkWritePe.GetBases");
	*codeBase = Dev2LnkWritePe_code.addr + Dev2LnkBase_ImageBase;
	*dataBase = Dev2LnkWritePe_data.addr + Dev2LnkBase_ImageBase;
	*varsBase = Dev2LnkWritePe_vars.addr + Dev2LnkBase_ImageBase;
	__EXIT;
}

static void Dev2LnkWritePe_CollectImp (void)
{
	Dev2LnkBase_Module lib = NIL;
	Dev2LnkBase_Symbol sym = NIL;
	INTEGER symIdx;
	Dev2LnkBase_Symbol _ptr__6 = NIL;
	Dev2LnkBase_Symbol _ptr__5 = NIL;
	__ENTER("Dev2LnkWritePe.CollectImp");
	symIdx = 0;
	lib = Dev2LnkBase_dllList;
	while (lib != NIL) {
		_ptr__6 = lib->exp;
		_ptr__5 = lib->exp;
		Dev2LnkBase_AddDllName(&Dev2LnkWritePe_impStrTable, Dev2LnkBase_StringTable__typ, (void*)_ptr__6->name, \
256, (void*)".dll", 5, &_ptr__5->namIdx);
		lib->exp->symIdx = symIdx;
		sym = lib->exp->next;
		while (sym != NIL) {
			Dev2LnkBase_AddHintName(&Dev2LnkWritePe_impStrTable, Dev2LnkBase_StringTable__typ, 0, (void*)sym->name, \
256, &sym->namIdx);
			sym->symIdx = symIdx;
			symIdx += 1;
			sym = sym->next;
		}
		symIdx += 1;
		lib = lib->next;
	}
	Dev2LnkWritePe_impDirSize = 20 * (Dev2LnkBase_impDllCount + 1);
	Dev2LnkWritePe_impo.size = (Dev2LnkWritePe_impDirSize + __ASHL(Dev2LnkBase_impCount + Dev2LnkBase_impDllCount, \
3, INTEGER)) + Dev2LnkWritePe_impStrTable.len;
	__EXIT;
}

static void Dev2LnkWritePe_CollectExport (void)
{
	Dev2LnkBase_Symbol sym = NIL;
	SHORTCHAR _str__3[256];
	__ENTER("Dev2LnkWritePe.CollectExport");
	if (Dev2LnkBase_expCount > 0) {
		__STRCOPYTS(Dev2LnkBase_outputName, _str__3, 256);
		Dev2LnkBase_AddName(&Dev2LnkWritePe_expStrTable, Dev2LnkBase_StringTable__typ, (void*)_str__3, __STRLENS(_str__3) \
+ 1, &Dev2LnkWritePe_outNameStrIndex);
		sym = Dev2LnkBase_expList;
		while (sym != NIL) {
			Dev2LnkBase_AddName(&Dev2LnkWritePe_expStrTable, Dev2LnkBase_StringTable__typ, (void*)sym->name, 256, \
&sym->namIdx);
			sym = sym->next;
		}
		Dev2LnkWritePe_expo.size = (40 + 10 * Dev2LnkBase_expCount) + Dev2LnkWritePe_expStrTable.len;
	} else {
		Dev2LnkWritePe_expo.size = 0;
	}
	__EXIT;
}

static void Dev2LnkWritePe_CalculateLayout (void)
{
	__ENTER("Dev2LnkWritePe.CalculateLayout");
	Dev2LnkWritePe_CollectImp();
	Dev2LnkWritePe_CollectExport();
	Dev2LnkWritePe_impo.addr = Dev2LnkBase_Aligned(Dev2LnkWritePe_vars.addr + Dev2LnkWritePe_vars.size, 4096);
	Dev2LnkWritePe_expo.addr = Dev2LnkBase_Aligned(Dev2LnkWritePe_impo.addr + Dev2LnkWritePe_impo.size, 4096);
	Dev2LnkWritePe_rsrc.addr = Dev2LnkBase_Aligned(Dev2LnkWritePe_expo.addr + Dev2LnkWritePe_expo.size, 4096);
	Dev2LnkWritePe_relo.addr = Dev2LnkBase_Aligned(Dev2LnkWritePe_rsrc.addr + Dev2LnkWritePe_rsrc.size, 4096);
	Dev2LnkWritePe_code.offs = Dev2LnkBase_Aligned(1024, 512);
	Dev2LnkWritePe_data.offs = Dev2LnkBase_Aligned(Dev2LnkWritePe_code.offs + Dev2LnkWritePe_code.size, 512);
	Dev2LnkWritePe_vars.offs = 0;
	Dev2LnkWritePe_impo.offs = Dev2LnkBase_Aligned(Dev2LnkWritePe_data.offs + Dev2LnkWritePe_data.size, 512);
	Dev2LnkWritePe_expo.offs = Dev2LnkBase_Aligned(Dev2LnkWritePe_impo.offs + Dev2LnkWritePe_impo.size, 512);
	Dev2LnkWritePe_rsrc.offs = Dev2LnkBase_Aligned(Dev2LnkWritePe_expo.offs + Dev2LnkWritePe_expo.size, 512);
	Dev2LnkWritePe_relo.offs = Dev2LnkBase_Aligned(Dev2LnkWritePe_rsrc.offs + Dev2LnkWritePe_rsrc.size, 512);
	if (Dev2LnkWritePe_expo.size == 0) {
		Dev2LnkWritePe_expo.addr = 0;
		Dev2LnkWritePe_expo.offs = 0;
	}
	Dev2LnkWritePe_rsrc.addr = 0;
	Dev2LnkWritePe_rsrc.size = 0;
	Dev2LnkWritePe_rsrc.offs = 0;
	__EXIT;
}

typedef
	SHORTCHAR __30[8];

static struct WriteSectionHeaders__29 {
	struct WriteSectionHeaders__29 *lnk;
} *WriteSectionHeaders__29_s;

static void __31 (Dev2LnkWritePe_Section *scn, SYSTEM_TYPEDESC *scn__typ, __30 name, SET flags);

static void __31 (Dev2LnkWritePe_Section *scn, SYSTEM_TYPEDESC *scn__typ, __30 name, SET flags)
{
	__30 name__copy;
	__ENTER("Dev2LnkWritePe.SectionHeader");
	__DUPARR(name);
	if ((*scn).addr != 0) {
		Dev2LnkWritePe_WriteStr((void*)name, 8, 8);
		Dev2LnkWritePe_Write4(0);
		Dev2LnkWritePe_Write4((*scn).addr);
		Dev2LnkWritePe_Write4(Dev2LnkBase_Aligned((*scn).size, 512));
		Dev2LnkWritePe_Write4((*scn).offs);
		Dev2LnkWritePe_Write4(0);
		Dev2LnkWritePe_Write4(0);
		Dev2LnkWritePe_Write4(0);
		Dev2LnkWritePe_Write4((INTEGER)flags);
		Dev2LnkWritePe_NumberOfSections += 1;
	}
	__EXIT;
}

static void Dev2LnkWritePe_WriteSectionHeaders (void)
{
	struct WriteSectionHeaders__29 _s;
	__ENTER("Dev2LnkWritePe.WriteSectionHeaders");
	_s.lnk = WriteSectionHeaders__29_s;
	WriteSectionHeaders__29_s = &_s;
	__31(&Dev2LnkWritePe_code, Dev2LnkWritePe_Section__typ, (SHORTCHAR*)".text", 0x60000020);
	__31(&Dev2LnkWritePe_data, Dev2LnkWritePe_Section__typ, (SHORTCHAR*)".data", 0xc0000040);
	__31(&Dev2LnkWritePe_vars, Dev2LnkWritePe_Section__typ, (SHORTCHAR*)".var", 0xc0000080);
	__31(&Dev2LnkWritePe_rsrc, Dev2LnkWritePe_Section__typ, (SHORTCHAR*)".rsrc", 0xc0000040);
	__31(&Dev2LnkWritePe_impo, Dev2LnkWritePe_Section__typ, (SHORTCHAR*)".idata", 0xc0000040);
	__31(&Dev2LnkWritePe_expo, Dev2LnkWritePe_Section__typ, (SHORTCHAR*)".edata", 0xc0000040);
	__31(&Dev2LnkWritePe_relo, Dev2LnkWritePe_Section__typ, (SHORTCHAR*)".reloc", 0x42000040);
	WriteSectionHeaders__29_s = _s.lnk;
	__EXIT;
}

static struct WriteHeader__18 {
	struct WriteHeader__18 *lnk;
} *WriteHeader__18_s;

static void __19 (INTEGER rva, INTEGER Size);
static void __21 (void);

static void __21 (void)
{
	__ENTER("Dev2LnkWritePe.WriteDosStub");
	Dev2LnkWritePe_WriteStr((void*)"MZ", 3, 60);
	Dev2LnkWritePe_Write4(128);
	Dev2LnkWritePe_PadTo(128);
	__EXIT;
}

static void __19 (INTEGER rva, INTEGER Size)
{
	__ENTER("Dev2LnkWritePe.WriteDirEntry");
	Dev2LnkWritePe_Write4(rva);
	Dev2LnkWritePe_Write4(Size);
	__EXIT;
}

static void Dev2LnkWritePe_WriteHeader (void)
{
	struct WriteHeader__18 _s;
	__ENTER("Dev2LnkWritePe.WriteHeader");
	_s.lnk = WriteHeader__18_s;
	WriteHeader__18_s = &_s;
	__21();
	Dev2LnkWritePe_WriteStr((void*)"PE", 3, 4);
	Dev2LnkWritePe_Write2(332);
	Dev2LnkWritePe_Write2(Dev2LnkWritePe_NumberOfSections);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_TimeDateStamp);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write2(224);
	Dev2LnkWritePe_Write2((INTEGER)Dev2LnkWritePe_exeFlags);
	Dev2LnkWritePe_Write2(267);
	Dev2LnkWritePe_WriteCh(2);
	Dev2LnkWritePe_WriteCh(5);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_code.size);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_data.size);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_vars.size);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_AddressOfEntryPoint);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_code.addr);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_data.addr);
	Dev2LnkWritePe_Write4(Dev2LnkBase_ImageBase);
	Dev2LnkWritePe_Write4(4096);
	Dev2LnkWritePe_Write4(512);
	Dev2LnkWritePe_Write2(5);
	Dev2LnkWritePe_Write2(0);
	Dev2LnkWritePe_Write2(4);
	Dev2LnkWritePe_Write2(0);
	Dev2LnkWritePe_Write2(5);
	Dev2LnkWritePe_Write2(0);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_SizeOfImage);
	Dev2LnkWritePe_Write4(1024);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write2(Dev2LnkWritePe_subsystem);
	Dev2LnkWritePe_Write2(0);
	Dev2LnkWritePe_Write4(2097152);
	Dev2LnkWritePe_Write4(65536);
	Dev2LnkWritePe_Write4(4194304);
	Dev2LnkWritePe_Write4(65536);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(16);
	__19(Dev2LnkWritePe_expo.addr, Dev2LnkWritePe_expo.size);
	__19(Dev2LnkWritePe_impo.addr, Dev2LnkWritePe_impo.size);
	__19(Dev2LnkWritePe_rsrc.addr, Dev2LnkWritePe_rsrc.size);
	__19(0, 0);
	__19(0, 0);
	__19(Dev2LnkWritePe_relo.addr, Dev2LnkWritePe_relo.size);
	__19(0, 0);
	__19(0, 0);
	__19(0, 0);
	__19(0, 0);
	__19(0, 0);
	__19(0, 0);
	__19(0, 0);
	__19(0, 0);
	__19(0, 0);
	__19(0, 0);
	Dev2LnkWritePe_WriteSectionHeaders();
	WriteHeader__18_s = _s.lnk;
	__EXIT;
}

static void Dev2LnkWritePe_WriteInitCode (void)
{
	struct BYTE_ARRAY *_ptr__25 = NIL;
	__ENTER("Dev2LnkWritePe.WriteInitCode");
	_ptr__25 = Dev2LnkBase_initMod->code->bytes;
	__Files_Writer_WriteBytes(Dev2LnkWritePe_out, (void*)_ptr__25->data, _ptr__25->len[0], 0, Dev2LnkBase_initMod->code->size);
	__EXIT;
}

static void Dev2LnkWritePe_WritePlt (void)
{
	Dev2LnkBase_Module lib = NIL;
	Dev2LnkBase_Symbol sym = NIL;
	INTEGER thunk;
	__ENTER("Dev2LnkWritePe.WritePlt");
	thunk = (Dev2LnkBase_ImageBase + Dev2LnkWritePe_impo.addr) + Dev2LnkWritePe_impDirSize;
	lib = Dev2LnkBase_dllList;
	while (lib != NIL) {
		sym = lib->exp->next;
		while (sym != NIL) {
			Dev2LnkWritePe_WriteCh(255);
			Dev2LnkWritePe_WriteCh((SHORTCHAR)'%');
			Dev2LnkWritePe_Write4(thunk + __ASHL(sym->symIdx, 2, INTEGER));
			Dev2LnkBase_AddReloc(sym->addr + 2);
			sym = sym->next;
		}
		lib = lib->next;
	}
	__EXIT;
}

static void Dev2LnkWritePe_WriteCode (void)
{
	Dev2LnkBase_Module mod = NIL;
	struct BYTE_ARRAY *_ptr__14 = NIL;
	__ENTER("Dev2LnkWritePe.WriteCode");
	Dev2LnkWritePe_PadTo(Dev2LnkWritePe_code.offs);
	Dev2LnkWritePe_WriteInitCode();
	mod = Dev2LnkBase_modList;
	while (mod != NIL) {
		_ptr__14 = mod->code->bytes;
		__Files_Writer_WriteBytes(Dev2LnkWritePe_out, (void*)_ptr__14->data, _ptr__14->len[0], 0, mod->code->size);
		mod = mod->next;
	}
	Dev2LnkWritePe_WritePlt();
	__EXIT;
}

static void Dev2LnkWritePe_WriteData (void)
{
	Dev2LnkBase_Module mod = NIL;
	struct BYTE_ARRAY *_ptr__16 = NIL;
	__ENTER("Dev2LnkWritePe.WriteData");
	Dev2LnkWritePe_PadTo(Dev2LnkWritePe_data.offs);
	mod = Dev2LnkBase_modList;
	while (mod != NIL) {
		_ptr__16 = mod->data->bytes;
		__Files_Writer_WriteBytes(Dev2LnkWritePe_out, (void*)_ptr__16->data, _ptr__16->len[0], 0, mod->data->size);
		mod = mod->next;
	}
	__EXIT;
}

static void Dev2LnkWritePe_WriteImport (void)
{
	INTEGER i, lookup, thunk, names;
	Dev2LnkBase_Module lib = NIL;
	Dev2LnkBase_Symbol sym = NIL;
	__ENTER("Dev2LnkWritePe.WriteImport");
	Dev2LnkWritePe_PadTo(Dev2LnkWritePe_impo.offs);
	thunk = Dev2LnkWritePe_impo.addr + Dev2LnkWritePe_impDirSize;
	lookup = thunk + __ASHL(Dev2LnkBase_impCount + Dev2LnkBase_impDllCount, 2, INTEGER);
	names = lookup + __ASHL(Dev2LnkBase_impCount + Dev2LnkBase_impDllCount, 2, INTEGER);
	lib = Dev2LnkBase_dllList;
	while (lib != NIL) {
		Dev2LnkWritePe_Write4(lookup + __ASHL(lib->exp->symIdx, 2, INTEGER));
		Dev2LnkWritePe_Write4(0);
		Dev2LnkWritePe_Write4(0);
		Dev2LnkWritePe_Write4(names + lib->exp->namIdx);
		Dev2LnkWritePe_Write4(thunk + __ASHL(lib->exp->symIdx, 2, INTEGER));
		lib = lib->next;
	}
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(0);
	i = 1;
	while (i <= 2) {
		lib = Dev2LnkBase_dllList;
		while (lib != NIL) {
			sym = lib->exp->next;
			while (sym != NIL) {
				Dev2LnkWritePe_Write4(names + sym->namIdx);
				sym = sym->next;
			}
			Dev2LnkWritePe_Write4(0);
			lib = lib->next;
		}
		i += 1;
	}
	Dev2LnkBase_WriteStringTable(Dev2LnkWritePe_out, &Dev2LnkWritePe_impStrTable, Dev2LnkBase_StringTable__typ);
	__EXIT;
}

static void Dev2LnkWritePe_WriteExport (void)
{
	Dev2LnkBase_Symbol sym = NIL;
	INTEGER functions, names, ordinals, strings, i;
	__ENTER("Dev2LnkWritePe.WriteExport");
	Dev2LnkWritePe_PadTo(Dev2LnkWritePe_expo.offs);
	functions = Dev2LnkWritePe_expo.addr + 40;
	names = functions + __ASHL(Dev2LnkBase_expCount, 2, INTEGER);
	ordinals = names + __ASHL(Dev2LnkBase_expCount, 2, INTEGER);
	strings = ordinals + __ASHL(Dev2LnkBase_expCount, 1, INTEGER);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(Dev2LnkWritePe_TimeDateStamp);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(strings + Dev2LnkWritePe_outNameStrIndex);
	Dev2LnkWritePe_Write4(1);
	Dev2LnkWritePe_Write4(Dev2LnkBase_expCount);
	Dev2LnkWritePe_Write4(Dev2LnkBase_expCount);
	Dev2LnkWritePe_Write4(functions);
	Dev2LnkWritePe_Write4(names);
	Dev2LnkWritePe_Write4(ordinals);
	sym = Dev2LnkBase_expList;
	while (sym != NIL) {
		Dev2LnkWritePe_Write4(sym->addr - Dev2LnkBase_ImageBase);
		sym = sym->next;
	}
	sym = Dev2LnkBase_expList;
	while (sym != NIL) {
		Dev2LnkWritePe_Write4(strings + sym->namIdx);
		sym = sym->next;
	}
	i = 0;
	while (i < Dev2LnkBase_expCount) {
		Dev2LnkWritePe_Write2(i);
		i += 1;
	}
	Dev2LnkBase_WriteStringTable(Dev2LnkWritePe_out, &Dev2LnkWritePe_expStrTable, Dev2LnkBase_StringTable__typ);
	__EXIT;
}

static void Dev2LnkWritePe_WriteReloc (void)
{
	INTEGER i, hi, blockSize, page, limit, pad;
	__ENTER("Dev2LnkWritePe.WriteReloc");
	Dev2LnkBase_SortReloc();
	Dev2LnkWritePe_PadTo(Dev2LnkWritePe_relo.offs);
	Dev2LnkWritePe_relo.size = 0;
	i = 0;
	while (i < Dev2LnkBase_relCount) {
		page = __ASHL(__ASHR((Dev2LnkBase_relTab->data)[__X(i, Dev2LnkBase_relTab->len[0])], 12, INTEGER), 12, \
INTEGER);
		limit = page + 4096;
		hi = i;
		while (hi < Dev2LnkBase_relCount && (Dev2LnkBase_relTab->data)[__X(hi, Dev2LnkBase_relTab->len[0])] \
< limit) {
			hi += 1;
		}
		blockSize = 8 + __ASHL(hi - i, 1, INTEGER);
		pad = __MASK(blockSize, -4);
		blockSize += pad;
		Dev2LnkWritePe_Write4(page - Dev2LnkBase_ImageBase);
		Dev2LnkWritePe_Write4(blockSize);
		while (i < hi) {
			Dev2LnkWritePe_Write2(((Dev2LnkBase_relTab->data)[__X(i, Dev2LnkBase_relTab->len[0])] - page) + 12288);
			i += 1;
		}
		if (pad != 0) {
			Dev2LnkWritePe_Write2(0);
		}
		Dev2LnkWritePe_relo.size += blockSize;
	}
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_Write4(0);
	Dev2LnkWritePe_relo.size += 8;
	Dev2LnkWritePe_PadTo(Dev2LnkBase_Aligned(Dev2LnkWritePe_relo.offs + Dev2LnkWritePe_relo.size, 512));
	__EXIT;
}

void Dev2LnkWritePe_WriteOut (void)
{
	INTEGER res;
	__ENTER("Dev2LnkWritePe.WriteOut");
	Dev2LnkWritePe_CalculateLayout();
	Dev2LnkWritePe_outFile = __Files_Directory_New(Files_dir, __Files_Directory_This(Files_dir, (void*)Dev2LnkBase_outputPath, \
256), 1);
	Dev2LnkWritePe_out = __Files_File_NewWriter(Dev2LnkWritePe_outFile, Dev2LnkWritePe_out);
	__Files_Writer_SetPos(Dev2LnkWritePe_out, 0);
	Dev2LnkWritePe_WriteHeader();
	Dev2LnkWritePe_WriteCode();
	Dev2LnkWritePe_WriteData();
	Dev2LnkWritePe_WriteImport();
	if (Dev2LnkBase_expCount > 0) {
		Dev2LnkWritePe_WriteExport();
	}
	Dev2LnkWritePe_WriteReloc();
	Dev2LnkWritePe_SizeOfImage = Dev2LnkBase_Aligned(Dev2LnkWritePe_relo.addr + Dev2LnkWritePe_relo.size, \
4096);
	__Files_Writer_SetPos(Dev2LnkWritePe_out, 0);
	Dev2LnkWritePe_WriteHeader();
	if (!Dev2LnkBase_error) {
		__Files_File_Register(Dev2LnkWritePe_outFile, Dev2LnkBase_outputName, Dev2LnkBase_outputType, 1, &res);
		if (res != 0) {
			Dev2LnkBase_Error((CHAR*)((CHAR[]){82, 101, 103, 105, 115, 116, 101, 114, 0}), 9);
		}
	}
	__EXIT;
}

static INTEGER Dev2LnkWritePe_Section__flds[] = {
	3, 
	0, 0, 1<<8 | 0x15, 6,
	0, 4, 6<<8 | 0x15, 6,
	0, 8, 11<<8 | 0x15, 6,
};
export INTEGER Dev2LnkWritePe_Section__desc[] = {
	-1, 
	0, 
	12,
	(INTEGER)&Dev2LnkWritePe__desc,
	16<<8 | 0x01,
	(INTEGER)(Dev2LnkWritePe_Section__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Dev2LnkWritePe_Section__flds, 
	-4
};
static SYSTEM_MODDESC *Dev2LnkWritePe__imp[] = {
	&Files__desc,
	&Dev2LnkBase__desc,
};
static INTEGER Dev2LnkWritePe__exp[] = {
	40,
	0x1ee54c0a, (INTEGER)&Dev2LnkWritePe_AddressOfEntryPoint, 24<<8 | 0x13, 6,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_CalculateLayout, 44<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_CollectExport, 60<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_CollectImp, 74<<8 | 0x14, 0,
	0xd22d14c8, (INTEGER)Dev2LnkWritePe_GetBases, 85<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)Dev2LnkWritePe_Init, 94<<8 | 0x44, 0,
	0x1ee54c0a, (INTEGER)&Dev2LnkWritePe_NumberOfSections, 99<<8 | 0x13, 6,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_PadTo, 116<<8 | 0x14, 0,
	0xa74f40fb, 0x987af2ed, 16<<8 | 0x12, (INTEGER)(Dev2LnkWritePe_Section__desc + 2),
	0x1ee54c0a, (INTEGER)&Dev2LnkWritePe_SizeOfImage, 122<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Dev2LnkWritePe_TimeDateStamp, 134<<8 | 0x13, 6,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_Write2, 148<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_Write4, 155<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteCh, 162<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteCode, 170<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteData, 180<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteExport, 190<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteHeader, 202<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteImport, 214<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteInitCode, 226<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)Dev2LnkWritePe_WriteOut, 240<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WritePlt, 249<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteReloc, 258<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteSectionHeaders, 269<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Dev2LnkWritePe_WriteStr, 289<<8 | 0x14, 0,
	0xcabedc76, (INTEGER)&Dev2LnkWritePe_code, 298<<8 | 0x13, (INTEGER)(Dev2LnkWritePe_Section__desc + 2),
	0xcabedc76, (INTEGER)&Dev2LnkWritePe_data, 303<<8 | 0x13, (INTEGER)(Dev2LnkWritePe_Section__desc + 2),
	0x26aaf1b7, (INTEGER)&Dev2LnkWritePe_exeFlags, 308<<8 | 0x13, 9,
	0xbde5f499, (INTEGER)&Dev2LnkWritePe_expStrTable, 317<<8 | 0x13, (INTEGER)(Dev2LnkBase_StringTable__desc \
+ 2),
	0xcabedc76, (INTEGER)&Dev2LnkWritePe_expo, 329<<8 | 0x13, (INTEGER)(Dev2LnkWritePe_Section__desc + 2),
	0x1ee54c0a, (INTEGER)&Dev2LnkWritePe_impDirSize, 334<<8 | 0x13, 6,
	0xbde5f499, (INTEGER)&Dev2LnkWritePe_impStrTable, 345<<8 | 0x13, (INTEGER)(Dev2LnkBase_StringTable__desc \
+ 2),
	0xcabedc76, (INTEGER)&Dev2LnkWritePe_impo, 357<<8 | 0x13, (INTEGER)(Dev2LnkWritePe_Section__desc + 2),
	0x204427f5, (INTEGER)&Dev2LnkWritePe_out, 362<<8 | 0x13, (INTEGER)Files_Writer__desc,
	0x5589de0a, (INTEGER)&Dev2LnkWritePe_outFile, 366<<8 | 0x13, (INTEGER)Files_File__desc,
	0x1ee54c0a, (INTEGER)&Dev2LnkWritePe_outNameStrIndex, 374<<8 | 0x13, 6,
	0xcabedc76, (INTEGER)&Dev2LnkWritePe_relo, 390<<8 | 0x13, (INTEGER)(Dev2LnkWritePe_Section__desc + 2),
	0xcabedc76, (INTEGER)&Dev2LnkWritePe_rsrc, 395<<8 | 0x13, (INTEGER)(Dev2LnkWritePe_Section__desc + 2),
	0x1ee54c0a, (INTEGER)&Dev2LnkWritePe_subsystem, 400<<8 | 0x13, 6,
	0xcabedc76, (INTEGER)&Dev2LnkWritePe_vars, 410<<8 | 0x13, (INTEGER)(Dev2LnkWritePe_Section__desc + 2),
};
static char Dev2LnkWritePe__names[] = {
	0,
	's','i','z','e',0,
	'o','f','f','s',0,
	'a','d','d','r',0,
	'S','e','c','t','i','o','n',0,
	'A','d','d','r','e','s','s','O','f','E','n','t','r','y','P','o','i','n','t',0,
	'C','a','l','c','u','l','a','t','e','L','a','y','o','u','t',0,
	'C','o','l','l','e','c','t','E','x','p','o','r','t',0,
	'C','o','l','l','e','c','t','I','m','p',0,
	'G','e','t','B','a','s','e','s',0,
	'I','n','i','t',0,
	'N','u','m','b','e','r','O','f','S','e','c','t','i','o','n','s',0,
	'P','a','d','T','o',0,
	'S','i','z','e','O','f','I','m','a','g','e',0,
	'T','i','m','e','D','a','t','e','S','t','a','m','p',0,
	'W','r','i','t','e','2',0,
	'W','r','i','t','e','4',0,
	'W','r','i','t','e','C','h',0,
	'W','r','i','t','e','C','o','d','e',0,
	'W','r','i','t','e','D','a','t','a',0,
	'W','r','i','t','e','E','x','p','o','r','t',0,
	'W','r','i','t','e','H','e','a','d','e','r',0,
	'W','r','i','t','e','I','m','p','o','r','t',0,
	'W','r','i','t','e','I','n','i','t','C','o','d','e',0,
	'W','r','i','t','e','O','u','t',0,
	'W','r','i','t','e','P','l','t',0,
	'W','r','i','t','e','R','e','l','o','c',0,
	'W','r','i','t','e','S','e','c','t','i','o','n','H','e','a','d','e','r','s',0,
	'W','r','i','t','e','S','t','r',0,
	'c','o','d','e',0,
	'd','a','t','a',0,
	'e','x','e','F','l','a','g','s',0,
	'e','x','p','S','t','r','T','a','b','l','e',0,
	'e','x','p','o',0,
	'i','m','p','D','i','r','S','i','z','e',0,
	'i','m','p','S','t','r','T','a','b','l','e',0,
	'i','m','p','o',0,
	'o','u','t',0,
	'o','u','t','F','i','l','e',0,
	'o','u','t','N','a','m','e','S','t','r','I','n','d','e','x',0,
	'r','e','l','o',0,
	'r','s','r','c',0,
	's','u','b','s','y','s','t','e','m',0,
	'v','a','r','s',0,
};
static INTEGER Dev2LnkWritePe__ptrs[] = {
	(INTEGER)&Dev2LnkWritePe_outFile + 0, 
	(INTEGER)&Dev2LnkWritePe_out + 0, 
	(INTEGER)&Dev2LnkWritePe_expStrTable + 0, 
	(INTEGER)&Dev2LnkWritePe_impStrTable + 0, 
};
struct SYSTEM_MODDESC Dev2LnkWritePe__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 17}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Dev2LnkWritePe__body,
	0,
	2, /* nofimps */ 
	4, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Dev2LnkWritePe__names,
	Dev2LnkWritePe__ptrs,
	Dev2LnkWritePe__imp,
	(SYSTEM_DIRECTORY*)Dev2LnkWritePe__exp,
	"Dev2LnkWritePe"
};

export void Dev2LnkWritePe__reg()
{
	__BEGREG(Dev2LnkWritePe__desc);
	Dev2LnkBase__reg();
	Files__reg();
	__REGMOD(Dev2LnkWritePe__desc);
	__ENDREG;
}

export void Dev2LnkWritePe__body()
{
	__BEGBODY(Dev2LnkWritePe__desc);
	Dev2LnkBase__body();
	Files__body();
	__ENDBODY;
}
