/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Dates.h"
#include "Kernel.h"
#include "DevCPM.h"
#include "Files.h"
#include "DevCPT.h"

typedef
	struct DevCPE__1 (*DevCPE_CodeBlock);


typedef struct DevCPE__1 {
	INTEGER gc[3];
	SHORTCHAR data[16384];
} DevCPE__1;

export INTEGER DevCPE_pc, DevCPE_dsize;
export DevCPT_Object DevCPE_KNewRec, DevCPE_KNewArr;
export INTEGER DevCPE_closeLbl;
export DevCPT_LinkList DevCPE_CaseLinks;
static INTEGER DevCPE_processor;
static BOOLEAN DevCPE_bigEndian, DevCPE_procVarIndirect;
static INTEGER DevCPE_idx8, DevCPE_idx16, DevCPE_idx32, DevCPE_idx64, DevCPE_namex, DevCPE_nofptrs, DevCPE_headSize;
static DevCPT_Object DevCPE_Const8, DevCPE_Const16, DevCPE_Const32, DevCPE_Const64, DevCPE_Code, DevCPE_Data, \
DevCPE_Meta, DevCPE_Mod, DevCPE_Proc, DevCPE_nameList, DevCPE_descList, DevCPE_untgd;
static BOOLEAN DevCPE_outRef, DevCPE_outAllRef, DevCPE_outURef, DevCPE_outSrc, DevCPE_outObj;
static INTEGER DevCPE_codePos, DevCPE_srcPos;
static SET DevCPE_options;
static DevCPE_CodeBlock DevCPE_code[512];
static DevCPE_CodeBlock DevCPE_actual;
static INTEGER DevCPE_actIdx, DevCPE_blkIdx;
static BOOLEAN DevCPE_CodeOvF;
static SHORTCHAR DevCPE_zero[16];
static INTEGER DevCPE_imports;
static DevCPT_Object DevCPE_dllList, DevCPE_dllLast;


static void DevCPE_Align (INTEGER n);
export void DevCPE_AllocConst (DevCPT_Const con, BYTE form, DevCPT_Object *obj, INTEGER *adr);
export void DevCPE_AllocTypDesc (DevCPT_Struct typ);
export void DevCPE_Close (void);
static void DevCPE_CollectDll (DevCPT_Object obj, DevCPT_String mod);
static void DevCPE_EnumXProc (DevCPT_Object obj, INTEGER *num);
static void DevCPE_FindPtrs (DevCPT_Struct typ, INTEGER adr, BOOLEAN ip, INTEGER *num);
export void DevCPE_GenByte (INTEGER x);
export void DevCPE_GenShort (INTEGER x);
export void DevCPE_GenWord (INTEGER x);
export void DevCPE_GetLongWords (DevCPT_Const con, INTEGER *hi, INTEGER *low);
export void DevCPE_GetRealWord (DevCPT_Const con, INTEGER *x);
export void DevCPE_GetRealWords (DevCPT_Const con, INTEGER *hi, INTEGER *low);
export void DevCPE_Init (INTEGER proc, SET opt);
static BOOLEAN DevCPE_IsSame (REAL x, REAL y);
static INTEGER DevCPE_NameIdx (DevCPT_Object obj);
static DevCPT_Object DevCPE_NumMeth (DevCPT_Object root, INTEGER num);
export DevCPT_LinkList DevCPE_OffsetLink (DevCPT_Object obj, INTEGER offs);
static void DevCPE_Out2 (INTEGER x);
static void DevCPE_Out4 (INTEGER x);
static void DevCPE_OutCLinks (DevCPT_Object obj);
static void DevCPE_OutCPLinks (DevCPT_Object obj, INTEGER base);
export void DevCPE_OutCode (void);
static void DevCPE_OutConst (DevCPT_Object obj);
static void DevCPE_OutDesc (DevCPT_Struct desc);
static void DevCPE_OutExport (DevCPT_Object obj);
export void DevCPE_OutGuid (SHORTCHAR *str, INTEGER str__len);
export void DevCPE_OutHeader (void);
static void DevCPE_OutImport (DevCPT_Object obj);
static void DevCPE_OutLink (DevCPT_LinkList link);
static void DevCPE_OutModDesc (INTEGER nofptr, INTEGER refSize, INTEGER namePos, INTEGER ptrPos, INTEGER \
expPos, INTEGER impPos);
static void DevCPE_OutName (SHORTCHAR *name, INTEGER name__len);
static void DevCPE_OutNames (void);
static void DevCPE_OutObject (INTEGER mode, INTEGER fprint, INTEGER offs, DevCPT_Struct typ, DevCPT_Object \
obj);
static void DevCPE_OutPLink (DevCPT_LinkList link, INTEGER adr);
static void DevCPE_OutProcTable (DevCPT_Object obj);
export void DevCPE_OutRefName (SHORTCHAR *name, INTEGER name__len);
static void DevCPE_OutReference (DevCPT_Object obj, INTEGER offs, INTEGER typ);
export void DevCPE_OutRefs (DevCPT_Object obj);
static void DevCPE_OutSignature (DevCPT_Object par, DevCPT_Struct retTyp, INTEGER *pos);
export void DevCPE_OutSourceRef (INTEGER pos);
static void DevCPE_OutStruct (DevCPT_Struct typ, BOOLEAN unt);
static void DevCPE_OutUseBlock (void);
static void DevCPE_PrepDesc (DevCPT_Struct desc);
static void DevCPE_PrepExport (DevCPT_Object obj);
static void DevCPE_PrepObject (DevCPT_Object obj);
export void DevCPE_PutByte (INTEGER a, INTEGER x);
export void DevCPE_PutShort (INTEGER a, INTEGER x);
export void DevCPE_PutWord (INTEGER a, INTEGER x);
export INTEGER DevCPE_ThisByte (INTEGER a);
export INTEGER DevCPE_ThisShort (INTEGER a);
export INTEGER DevCPE_ThisWord (INTEGER a);
export DevCPT_Object DevCPE_TypeObj (DevCPT_Struct typ);
static void DevCPE_WriteCode (void);

export void DevCPE__reg();
export void DevCPE__body();
export struct SYSTEM_MODDESC DevCPE__desc;


void DevCPE_GetLongWords (DevCPT_Const con, INTEGER *hi, INTEGER *low)
{
	REAL rh, rl;
	__ENTER("DevCPE.GetLongWords");
	rl = con->intval;
	rh = con->realval / 4294967296.0;
	if (rh >= 2147483648.0) {
		rh = rh - (REAL)1;
		rl = rl + 4294967296.0;
	} else if (rh < -2147483648.0) {
		rh = rh + (REAL)1;
		rl = rl - 4294967296.0;
	}
	*hi = (INTEGER)__ENTIER(rh);
	rl = rl + (rh - (REAL)*hi) * 4294967296.0;
	if (rl < (REAL)0) {
		*hi = *hi - 1;
		rl = rl + 4294967296.0;
	} else if (rl >= 4294967296.0) {
		*hi = *hi + 1;
		rl = rl - 4294967296.0;
	}
	if (rl >= 2147483648.0) {
		rl = rl - 4294967296.0;
	}
	*low = (INTEGER)__ENTIER(rl);
	__EXIT;
}

void DevCPE_GetRealWord (DevCPT_Const con, INTEGER *x)
{
	SHORTREAL r;
	__ENTER("DevCPE.GetRealWord");
	r = (SHORTREAL)con->realval;
	*x = __VAL(INTEGER, r);
	__EXIT;
}

typedef
	INTEGER __14[2];

void DevCPE_GetRealWords (DevCPT_Const con, INTEGER *hi, INTEGER *low)
{
	__14 a;
	__ENTER("DevCPE.GetRealWords");
	__MOVE(__VAL(__14, con->realval), a, 8);
	if (DevCPM_LEHost) {
		*hi = a[1];
		*low = a[0];
	} else {
		*hi = a[0];
		*low = a[1];
	}
	__EXIT;
}

static BOOLEAN DevCPE_IsSame (REAL x, REAL y)
{
	__ENTER("DevCPE.IsSame");
	__EXIT;
	return x == y && (x != (REAL)0 || (REAL)1 / x == (REAL)1 / y);
}

void DevCPE_AllocConst (DevCPT_Const con, BYTE form, DevCPT_Object *obj, INTEGER *adr)
{
	DevCPT_Const c = NIL;
	__ENTER("DevCPE.AllocConst");
	con->setval |= __SETOF(form);
	switch (form) {
		case 10: 
			*obj = DevCPE_Const8;
			c = (*obj)->conval;
			while (c != NIL && ((con->setval != c->setval || con->intval2 != c->intval2) || __STRCMPSS(con->ext->data, \
c->ext->data) != 0)) {
				c = c->link;
			}
			if (c == NIL) {
				*adr = DevCPE_idx8;
				DevCPE_idx8 += __ASHL(__ASHR(con->intval2 + 3, 2, INTEGER), 2, INTEGER);
			}
			break;
		case 17: 
			*obj = DevCPE_Const16;
			c = (*obj)->conval;
			while (c != NIL && ((con->setval != c->setval || con->intval2 != c->intval2) || __STRCMPSS(con->ext->data, \
c->ext->data) != 0)) {
				c = c->link;
			}
			if (c == NIL) {
				*adr = DevCPE_idx16;
				DevCPE_idx16 += __ASHL(__ASHR(con->intval2 + 1, 1, INTEGER), 2, INTEGER);
			}
			break;
		case 18: 
			*obj = DevCPE_Const64;
			c = (*obj)->conval;
			while (c != NIL && ((con->setval != c->setval || con->intval != c->intval2) || con->realval != c->realval)) \
{
				c = c->link;
			}
			if (c == NIL) {
				con->intval2 = con->intval;
				*adr = DevCPE_idx64;
				DevCPE_idx64 += 8;
			}
			break;
		case 7: 
			*obj = DevCPE_Const32;
			c = (*obj)->conval;
			while (c != NIL && (con->setval != c->setval || !DevCPE_IsSame(con->realval, c->realval))) {
				c = c->link;
			}
			if (c == NIL) {
				*adr = DevCPE_idx32;
				DevCPE_idx32 += 4;
			}
			break;
		case 8: 
			*obj = DevCPE_Const64;
			c = (*obj)->conval;
			while (c != NIL && (con->setval != c->setval || !DevCPE_IsSame(con->realval, c->realval))) {
				c = c->link;
			}
			if (c == NIL) {
				*adr = DevCPE_idx64;
				DevCPE_idx64 += 8;
			}
			break;
		case 23: 
			*obj = DevCPE_Const32;
			c = (*obj)->conval;
			while (c != NIL && ((con->setval != c->setval || con->intval2 != c->intval2) || __STRCMPSS(con->ext->data, \
c->ext->data) != 0)) {
				c = c->link;
			}
			if (c == NIL) {
				*adr = DevCPE_idx32;
				DevCPE_idx32 += 16;
			}
			break;
		default: __CASECHK;
	}
	if (c == NIL) {
		con->link = (*obj)->conval;
		(*obj)->conval = con;
	} else {
		*adr = c->intval;
	}
	con->intval = *adr;
	__EXIT;
}

void DevCPE_AllocTypDesc (DevCPT_Struct typ)
{
	DevCPT_Object obj = NIL;
	DevCPT_Name name;
	__ENTER("DevCPE.AllocTypDesc");
	if (typ->strobj == NIL) {
		__MOVE("@", name, 2);
		DevCPT_Insert(name, &obj);
		obj->name = DevCPT_null;
		obj->mode = 5;
		obj->typ = typ;
		typ->strobj = obj;
	}
	__EXIT;
}

void DevCPE_PutByte (INTEGER a, INTEGER x)
{
	__ENTER("DevCPE.PutByte");
	(DevCPE_code[__X(__ASHR(a, 14, INTEGER), 512)]->data)[__X(__MASK(a, -16384), 16384)] = (SHORTCHAR)__MASK(x, \
-256);
	__EXIT;
}

void DevCPE_PutShort (INTEGER a, INTEGER x)
{
	__ENTER("DevCPE.PutShort");
	if (DevCPE_bigEndian) {
		DevCPE_PutByte(a, __ASHR(x, 8, INTEGER));
		DevCPE_PutByte(a + 1, x);
	} else {
		DevCPE_PutByte(a, x);
		DevCPE_PutByte(a + 1, __ASHR(x, 8, INTEGER));
	}
	__EXIT;
}

void DevCPE_PutWord (INTEGER a, INTEGER x)
{
	__ENTER("DevCPE.PutWord");
	if (DevCPE_bigEndian) {
		DevCPE_PutByte(a, __ASHR(x, 24, INTEGER));
		DevCPE_PutByte(a + 1, __ASHR(x, 16, INTEGER));
		DevCPE_PutByte(a + 2, __ASHR(x, 8, INTEGER));
		DevCPE_PutByte(a + 3, x);
	} else {
		DevCPE_PutByte(a, x);
		DevCPE_PutByte(a + 1, __ASHR(x, 8, INTEGER));
		DevCPE_PutByte(a + 2, __ASHR(x, 16, INTEGER));
		DevCPE_PutByte(a + 3, __ASHR(x, 24, INTEGER));
	}
	__EXIT;
}

INTEGER DevCPE_ThisByte (INTEGER a)
{
	__ENTER("DevCPE.ThisByte");
	__EXIT;
	return (SHORTINT)(DevCPE_code[__X(__ASHR(a, 14, INTEGER), 512)]->data)[__X(__MASK(a, -16384), 16384)];
}

INTEGER DevCPE_ThisShort (INTEGER a)
{
	__ENTER("DevCPE.ThisShort");
	if (DevCPE_bigEndian) {
		__EXIT;
		return __ASHL(DevCPE_ThisByte(a), 8, INTEGER) + DevCPE_ThisByte(a + 1);
	} else {
		__EXIT;
		return __ASHL(DevCPE_ThisByte(a + 1), 8, INTEGER) + DevCPE_ThisByte(a);
	}
	__RETCHK;
}

INTEGER DevCPE_ThisWord (INTEGER a)
{
	__ENTER("DevCPE.ThisWord");
	if (DevCPE_bigEndian) {
		__EXIT;
		return __ASHL(__ASHL(__ASHL(DevCPE_ThisByte(a), 8, INTEGER) + DevCPE_ThisByte(a + 1), 8, INTEGER) + \
DevCPE_ThisByte(a + 2), 8, INTEGER) + DevCPE_ThisByte(a + 3);
	} else {
		__EXIT;
		return __ASHL(__ASHL(__ASHL(DevCPE_ThisByte(a + 3), 8, INTEGER) + DevCPE_ThisByte(a + 2), 8, INTEGER) \
+ DevCPE_ThisByte(a + 1), 8, INTEGER) + DevCPE_ThisByte(a);
	}
	__RETCHK;
}

void DevCPE_GenByte (INTEGER x)
{
	__ENTER("DevCPE.GenByte");
	if (DevCPE_actIdx >= 16384) {
		if (DevCPE_blkIdx < 512) {
			DevCPE_actual = __NEWARR0(1, 16384);
			DevCPE_code[__X(DevCPE_blkIdx, 512)] = DevCPE_actual;
			DevCPE_blkIdx += 1;
			DevCPE_actIdx = 0;
		} else {
			if (!DevCPE_CodeOvF) {
				DevCPM_err(210);
				DevCPE_CodeOvF = 1;
			}
			DevCPE_actIdx = 0;
			DevCPE_pc = 0;
		}
	}
	(DevCPE_actual->data)[__X(DevCPE_actIdx, 16384)] = (SHORTCHAR)__MASK(x, -256);
	DevCPE_actIdx += 1;
	DevCPE_pc += 1;
	__EXIT;
}

void DevCPE_GenShort (INTEGER x)
{
	__ENTER("DevCPE.GenShort");
	if (DevCPE_bigEndian) {
		DevCPE_GenByte(__ASHR(x, 8, INTEGER));
		DevCPE_GenByte(x);
	} else {
		DevCPE_GenByte(x);
		DevCPE_GenByte(__ASHR(x, 8, INTEGER));
	}
	__EXIT;
}

void DevCPE_GenWord (INTEGER x)
{
	__ENTER("DevCPE.GenWord");
	if (DevCPE_bigEndian) {
		DevCPE_GenByte(__ASHR(x, 24, INTEGER));
		DevCPE_GenByte(__ASHR(x, 16, INTEGER));
		DevCPE_GenByte(__ASHR(x, 8, INTEGER));
		DevCPE_GenByte(x);
	} else {
		DevCPE_GenByte(x);
		DevCPE_GenByte(__ASHR(x, 8, INTEGER));
		DevCPE_GenByte(__ASHR(x, 16, INTEGER));
		DevCPE_GenByte(__ASHR(x, 24, INTEGER));
	}
	__EXIT;
}

static void DevCPE_WriteCode (void)
{
	INTEGER i, j, k, n;
	DevCPE_CodeBlock b = NIL;
	__ENTER("DevCPE.WriteCode");
	j = 0;
	k = 0;
	while (j < DevCPE_pc) {
		n = DevCPE_pc - j;
		i = 0;
		b = DevCPE_code[__X(k, 512)];
		if (n > 16384) {
			n = 16384;
		}
		while (i < n) {
			DevCPM_ObjW((b->data)[__X(i, 16384)]);
			i += 1;
		}
		j += n;
		k += 1;
	}
	__EXIT;
}

DevCPT_LinkList DevCPE_OffsetLink (DevCPT_Object obj, INTEGER offs)
{
	DevCPT_LinkList link = NIL;
	DevCPT_Object m = NIL;
	__ENTER("DevCPE.OffsetLink");
	__ASSERT((INTEGER)obj->mode != 5 || obj->typ != DevCPT_int32typ, 0);
	__ASSERT((INTEGER)obj->mode != 5 || obj->typ != DevCPT_iunktyp && obj->typ != DevCPT_guidtyp, 0);
	if ((INTEGER)obj->mnolev >= 0) {
		switch (obj->mode) {
			case 5: 
				if (obj->links == NIL) {
					obj->link = DevCPE_descList;
					DevCPE_descList = obj;
				}
				break;
			case 13: 
				if (obj->adr == -1) {
					obj = obj->nlink;
				} else {
					offs = offs + obj->adr;
					obj = DevCPE_Code;
				}
				break;
			case 1: 
				offs = offs + DevCPE_dsize;
				obj = DevCPE_Data;
				break;
			case 3: case 6: case 7: case 10: 
				break;
			default: __CASECHK;
		}
	} else if ((INTEGER)obj->mode == 5) {
		if (obj->typ->untagged) {
			if (obj->links == NIL) {
				obj->link = DevCPE_descList;
				DevCPE_descList = obj;
			}
		} else {
			m = DevCPT_GlbMod[__X(-((INTEGER)obj->mnolev), 127)];
			if (m->library != NIL) {
				__EXIT;
				return NIL;
			}
		}
	}
	link = obj->links;
	while (link != NIL && link->offset != offs) {
		link = link->next;
	}
	if (link == NIL) {
		link = __NEW(DevCPT_LinkDesc__typ);
		link->offset = offs;
		link->linkadr = 0;
		link->next = obj->links;
		obj->links = link;
	}
	__EXIT;
	return link;
}

DevCPT_Object DevCPE_TypeObj (DevCPT_Struct typ)
{
	DevCPT_Object obj = NIL;
	__ENTER("DevCPE.TypeObj");
	obj = typ->strobj;
	if (obj == NIL) {
		obj = DevCPT_NewObj();
		obj->leaf = 1;
		obj->mnolev = 0;
		obj->name = DevCPT_null;
		obj->mode = 5;
		obj->typ = typ;
		typ->strobj = obj;
	}
	__EXIT;
	return obj;
}

static void DevCPE_Align (INTEGER n)
{
	INTEGER p;
	__ENTER("DevCPE.Align");
	p = DevCPM_ObjLen();
	DevCPM_ObjWBytes((void*)DevCPE_zero, 16, __MODF(-p, n));
	__EXIT;
}

static void DevCPE_OutName (SHORTCHAR *name, INTEGER name__len)
{
	SHORTCHAR ch;
	SHORTINT i;
	__ENTER("DevCPE.OutName");
	i = 0;
	do {
		ch = name[__X(i, name__len)];
		DevCPM_ObjW(ch);
		i += 1;
	} while (!(ch == 0));
	__EXIT;
}

static void DevCPE_Out2 (INTEGER x)
{
	__ENTER("DevCPE.Out2");
	if (DevCPE_bigEndian) {
		DevCPM_ObjW((SHORTCHAR)__ASHR(x, 8, INTEGER));
		DevCPM_ObjW((SHORTCHAR)x);
	} else {
		DevCPM_ObjW((SHORTCHAR)x);
		DevCPM_ObjW((SHORTCHAR)__ASHR(x, 8, INTEGER));
	}
	__EXIT;
}

static void DevCPE_Out4 (INTEGER x)
{
	__ENTER("DevCPE.Out4");
	if (DevCPE_bigEndian) {
		DevCPM_ObjW((SHORTCHAR)__ASHR(x, 24, INTEGER));
		DevCPM_ObjW((SHORTCHAR)__ASHR(x, 16, INTEGER));
		DevCPM_ObjW((SHORTCHAR)__ASHR(x, 8, INTEGER));
		DevCPM_ObjW((SHORTCHAR)x);
	} else {
		DevCPM_ObjWLInt(x);
	}
	__EXIT;
}

static void DevCPE_OutReference (DevCPT_Object obj, INTEGER offs, INTEGER typ)
{
	DevCPT_LinkList link = NIL;
	__ENTER("DevCPE.OutReference");
	link = DevCPE_OffsetLink(obj, offs);
	if (link != NIL) {
		DevCPE_Out4(__ASHL(typ, 24, INTEGER) + __MASK(link->linkadr, -16777216));
		link->linkadr = -((DevCPM_ObjLen() - DevCPE_headSize) - 4);
	} else {
		DevCPE_Out4(0);
	}
	__EXIT;
}

static void DevCPE_FindPtrs (DevCPT_Struct typ, INTEGER adr, BOOLEAN ip, INTEGER *num)
{
	DevCPT_Object fld = NIL;
	DevCPT_Struct btyp = NIL;
	INTEGER i, n;
	__ENTER("DevCPE.FindPtrs");
	if ((INTEGER)typ->form == 13) {
		if (ip && (INTEGER)typ->sysflag == 10 || !ip && !typ->untagged) {
			DevCPE_Out4(adr);
			*num += 1;
		}
	} else if ((INTEGER)typ->comp == 4 && (INTEGER)typ->sysflag != 7) {
		btyp = typ->BaseTyp;
		if (btyp != NIL) {
			DevCPE_FindPtrs(btyp, adr, ip, num);
		}
		fld = typ->link;
		while (fld != NIL && (INTEGER)fld->mode == 4) {
			if ((ip && __STRCMPSS(fld->name->data, "@utptr") == 0) && (INTEGER)fld->sysflag == 10 || !ip && __STRCMPSS(fld->name->data, \
"@ptr") == 0) {
				DevCPE_Out4(fld->adr + adr);
				*num += 1;
			} else {
				DevCPE_FindPtrs(fld->typ, fld->adr + adr, ip, num);
			}
			fld = fld->link;
		}
	} else if ((INTEGER)typ->comp == 2) {
		btyp = typ->BaseTyp;
		n = typ->n;
		while ((INTEGER)btyp->comp == 2) {
			n = btyp->n * n;
			btyp = btyp->BaseTyp;
		}
		if ((INTEGER)btyp->form == 13 || (INTEGER)btyp->comp == 4) {
			i = *num;
			DevCPE_FindPtrs(btyp, adr, ip, num);
			if (*num != i) {
				i = 1;
				while (i < n) {
					adr += btyp->size;
					DevCPE_FindPtrs(btyp, adr, ip, num);
					i += 1;
				}
			}
		}
	}
	__EXIT;
}

void DevCPE_OutRefName (SHORTCHAR *name, INTEGER name__len)
{
	__ENTER("DevCPE.OutRefName");
	DevCPM_ObjW(252);
	DevCPM_ObjWNum(DevCPE_pc);
	DevCPE_OutName((void*)name, name__len);
	__EXIT;
}

void DevCPE_OutRefs (DevCPT_Object obj)
{
	BYTE f;
	DevCPT_String _ptr__55 = NIL;
	__ENTER("DevCPE.OutRefs");
	if (DevCPE_outRef && obj != NIL) {
		DevCPE_OutRefs(obj->left);
		if ((((INTEGER)obj->mode == 1 || (INTEGER)obj->mode == 2) && (INTEGER)obj->history != 4) && (obj->name->data)[0] \
!= (SHORTCHAR)'@') {
			f = obj->typ->form;
			if (((__IN(f, 0x0563fe) || DevCPE_outURef && (INTEGER)obj->typ->comp != 3) || DevCPE_outAllRef && !obj->typ->untagged) \
|| (INTEGER)obj->typ->comp == 2 && (INTEGER)obj->typ->BaseTyp->form == 3) {
				if ((INTEGER)obj->mode == 1) {
					DevCPM_ObjW(253);
				} else {
					DevCPM_ObjW(255);
				}
				if (obj->typ == DevCPT_anyptrtyp) {
					DevCPM_ObjW(12);
				} else if (obj->typ == DevCPT_anytyp) {
					DevCPM_ObjW(11);
				} else if (obj->typ == DevCPT_sysptrtyp) {
					DevCPM_ObjW(13);
				} else if ((INTEGER)f == 16) {
					DevCPM_ObjW(3);
				} else if ((INTEGER)f == 18) {
					DevCPM_ObjW(10);
				} else if (obj->typ == DevCPT_guidtyp) {
					DevCPM_ObjW((SHORTCHAR)'!');
				} else if (obj->typ == DevCPT_restyp) {
					DevCPM_ObjW((SHORTCHAR)'\"');
				} else if ((INTEGER)f == 13) {
					if ((INTEGER)obj->typ->sysflag == 10) {
						DevCPM_ObjW((SHORTCHAR)' ');
					} else if (obj->typ->untagged) {
						DevCPM_ObjW(13);
					} else {
						DevCPM_ObjW(16);
						DevCPE_OutReference(DevCPE_TypeObj(obj->typ), 0, 100);
					}
				} else if (((INTEGER)f == 15 && DevCPE_outAllRef) && (!obj->typ->untagged || DevCPE_outURef && (INTEGER)obj->typ->comp \
!= 3)) {
					DevCPM_ObjW(16);
					DevCPE_OutReference(DevCPE_TypeObj(obj->typ), 0, 100);
				} else if ((INTEGER)f < 4) {
					DevCPM_ObjW((SHORTCHAR)((INTEGER)f - 1));
				} else {
					DevCPM_ObjW((SHORTCHAR)f);
				}
				if ((INTEGER)obj->mnolev == 0) {
					DevCPM_ObjWNum(obj->adr + DevCPE_dsize);
				} else {
					DevCPM_ObjWNum(obj->adr);
				}
				_ptr__55 = obj->name;
				DevCPE_OutName((void*)_ptr__55->data, _ptr__55->len[0]);
			}
		}
		DevCPE_OutRefs(obj->right);
	}
	__EXIT;
}

void DevCPE_OutSourceRef (INTEGER pos)
{
	__ENTER("DevCPE.OutSourceRef");
	if (((DevCPE_outSrc && pos != 0) && pos != DevCPE_srcPos) && DevCPE_pc > DevCPE_codePos) {
		while (DevCPE_pc > DevCPE_codePos + 250) {
			DevCPM_ObjW(250);
			DevCPE_codePos += 250;
			DevCPM_ObjWNum(0);
		}
		DevCPM_ObjW((SHORTCHAR)(DevCPE_pc - DevCPE_codePos));
		DevCPE_codePos = DevCPE_pc;
		DevCPM_ObjWNum(pos - DevCPE_srcPos);
		DevCPE_srcPos = pos;
	}
	__EXIT;
}

static void DevCPE_OutPLink (DevCPT_LinkList link, INTEGER adr)
{
	__ENTER("DevCPE.OutPLink");
	while (link != NIL) {
		__ASSERT(link->linkadr != 0, 0);
		DevCPM_ObjWNum(link->linkadr);
		DevCPM_ObjWNum(adr + link->offset);
		link = link->next;
	}
	__EXIT;
}

static void DevCPE_OutLink (DevCPT_LinkList link)
{
	__ENTER("DevCPE.OutLink");
	DevCPE_OutPLink(link, 0);
	DevCPM_ObjW(0);
	__EXIT;
}

static void DevCPE_OutNames (void)
{
	DevCPT_Object a = NIL;
	DevCPT_Object b = NIL;
	DevCPT_Object c = NIL;
	DevCPT_String _ptr__48 = NIL;
	__ENTER("DevCPE.OutNames");
	a = DevCPE_nameList;
	b = NIL;
	while (a != NIL) {
		c = a;
		a = c->nlink;
		c->nlink = b;
		b = c;
	}
	DevCPM_ObjW(0);
	while (b != NIL) {
		_ptr__48 = b->name;
		DevCPE_OutName((void*)_ptr__48->data, _ptr__48->len[0]);
		b = b->nlink;
	}
	__EXIT;
}

static struct OutGuid__33 {
	SHORTCHAR *str;
	INTEGER str__len;
	struct OutGuid__33 *lnk;
} *OutGuid__33_s;

static void __34 (INTEGER n);

static void __34 (INTEGER n)
{
	INTEGER x, y;
	__ENTER("DevCPE.Copy");
	x = (SHORTINT)OutGuid__33_s->str[__X(n, OutGuid__33_s->str__len)];
	y = (SHORTINT)OutGuid__33_s->str[__X(n + 1, OutGuid__33_s->str__len)];
	if (x >= 97) {
		x -= 87;
	} else if (x >= 65) {
		x -= 55;
	} else {
		x -= 48;
	}
	if (y >= 97) {
		y -= 87;
	} else if (y >= 65) {
		y -= 55;
	} else {
		y -= 48;
	}
	DevCPM_ObjW((SHORTCHAR)(__ASHL(x, 4, INTEGER) + y));
	__EXIT;
}

void DevCPE_OutGuid (SHORTCHAR *str, INTEGER str__len)
{
	struct OutGuid__33 _s;
	__ENTER("DevCPE.OutGuid");
	_s.str = (void*)str; _s.str__len = str__len;
	_s.lnk = OutGuid__33_s;
	OutGuid__33_s = &_s;
	if (DevCPE_bigEndian) {
		__34(1);
		__34(3);
		__34(5);
		__34(7);
		__34(10);
		__34(12);
		__34(15);
		__34(17);
	} else {
		__34(7);
		__34(5);
		__34(3);
		__34(1);
		__34(12);
		__34(10);
		__34(17);
		__34(15);
	}
	__34(20);
	__34(22);
	__34(25);
	__34(27);
	__34(29);
	__34(31);
	__34(33);
	__34(35);
	OutGuid__33_s = _s.lnk;
	__EXIT;
}

typedef
	SHORTCHAR __29[4];

typedef
	SHORTCHAR __30[8];

static void DevCPE_OutConst (DevCPT_Object obj)
{
	DevCPT_Const a = NIL;
	DevCPT_Const b = NIL;
	DevCPT_Const c = NIL;
	SHORTREAL r;
	REAL lr;
	__29 a4;
	__30 a8;
	SHORTCHAR ch;
	INTEGER i, x, hi, low;
	DevCPT_String _ptr__28 = NIL;
	DevCPT_String _ptr__27 = NIL;
	DevCPT_String _ptr__26 = NIL;
	__ENTER("DevCPE.OutConst");
	a = obj->conval;
	b = NIL;
	while (a != NIL) {
		c = a;
		a = c->link;
		c->link = b;
		b = c;
	}
	while (b != NIL) {
		if (__IN(10, b->setval)) {
			_ptr__28 = b->ext;
			DevCPM_ObjWBytes((void*)_ptr__28->data, _ptr__28->len[0], b->intval2);
			DevCPE_Align(4);
		} else if (__IN(17, b->setval)) {
			i = 0;
			do {
				_ptr__27 = b->ext;
				DevCPM_GetUtf8((void*)_ptr__27->data, _ptr__27->len[0], &x, &i);
				DevCPE_Out2(x);
			} while (!(x == 0));
			DevCPE_Align(4);
		} else if (__IN(7, b->setval)) {
			r = (SHORTREAL)b->realval;
			__MOVE(__VAL(__29, r), a4, 4);
			if (DevCPM_LEHost == DevCPE_bigEndian) {
				ch = a4[0];
				a4[0] = a4[3];
				a4[3] = ch;
				ch = a4[1];
				a4[1] = a4[2];
				a4[2] = ch;
			}
			DevCPM_ObjWBytes((void*)a4, 4, 4);
		} else if (__IN(8, b->setval)) {
			__MOVE(__VAL(__30, b->realval), a8, 8);
			if (DevCPM_LEHost == DevCPE_bigEndian) {
				ch = a8[0];
				a8[0] = a8[7];
				a8[7] = ch;
				ch = a8[1];
				a8[1] = a8[6];
				a8[6] = ch;
				ch = a8[2];
				a8[2] = a8[5];
				a8[5] = ch;
				ch = a8[3];
				a8[3] = a8[4];
				a8[4] = ch;
			}
			DevCPM_ObjWBytes((void*)a8, 8, 8);
		} else if (__IN(18, b->setval)) {
			x = b->intval;
			b->intval = b->intval2;
			DevCPE_GetLongWords(b, &hi, &low);
			b->intval = x;
			if (DevCPE_bigEndian) {
				DevCPE_Out4(hi);
				DevCPE_Out4(low);
			} else {
				DevCPE_Out4(low);
				DevCPE_Out4(hi);
			}
		} else if (__IN(23, b->setval)) {
			_ptr__26 = b->ext;
			DevCPE_OutGuid((void*)_ptr__26->data, _ptr__26->len[0]);
		}
		b = b->link;
	}
	__EXIT;
}

static void DevCPE_OutStruct (DevCPT_Struct typ, BOOLEAN unt)
{
	__ENTER("DevCPE.OutStruct");
	if (typ == NIL) {
		DevCPE_Out4(0);
	} else if (typ == DevCPT_sysptrtyp) {
		DevCPE_Out4(13);
	} else if (typ == DevCPT_anytyp) {
		DevCPE_Out4(11);
	} else if (typ == DevCPT_anyptrtyp) {
		DevCPE_Out4(12);
	} else if (typ == DevCPT_guidtyp) {
		DevCPE_Out4(33);
	} else if (typ == DevCPT_restyp) {
		DevCPE_Out4(34);
	} else {
		switch (typ->form) {
			case 0: case 1: case 10: case 11: case 12: 
			case 17: 
				DevCPE_Out4(0);
				break;
			case 2: case 3: 
				DevCPE_Out4((INTEGER)typ->form - 1);
				break;
			case 4: case 5: case 6: case 7: case 8: 
			case 9: 
				DevCPE_Out4(typ->form);
				break;
			case 16: 
				DevCPE_Out4(3);
				break;
			case 18: 
				DevCPE_Out4(10);
				break;
			case 14: 
				DevCPE_OutReference(DevCPE_TypeObj(typ), 0, 100);
				break;
			case 13: 
				if ((INTEGER)typ->sysflag == 10) {
					DevCPE_Out4(32);
				} else if (typ->untagged) {
					DevCPE_Out4(13);
				} else {
					DevCPE_OutReference(DevCPE_TypeObj(typ), 0, 100);
				}
				break;
			case 15: 
				if (!typ->untagged || DevCPE_outURef && unt) {
					DevCPE_OutReference(DevCPE_TypeObj(typ), 0, 100);
				} else {
					DevCPE_Out4(0);
				}
				break;
			default: __CASECHK;
		}
	}
	__EXIT;
}

static INTEGER DevCPE_NameIdx (DevCPT_Object obj)
{
	INTEGER n;
	__ENTER("DevCPE.NameIdx");
	n = 0;
	if (obj->name != DevCPT_null) {
		if (obj->num == 0) {
			obj->num = DevCPE_namex;
			while ((obj->name->data)[__X(n, obj->name->len[0])] != 0) {
				n += 1;
			}
			DevCPE_namex += n + 1;
			obj->nlink = DevCPE_nameList;
			DevCPE_nameList = obj;
		}
		n = obj->num;
	}
	__EXIT;
	return n;
}

static void DevCPE_OutSignature (DevCPT_Object par, DevCPT_Struct retTyp, INTEGER *pos)
{
	DevCPT_Object p = NIL;
	INTEGER n, m;
	__ENTER("DevCPE.OutSignature");
	*pos = DevCPM_ObjLen() - DevCPE_headSize;
	DevCPE_OutStruct(retTyp, 1);
	p = par;
	n = 0;
	while (p != NIL) {
		n += 1;
		p = p->link;
	}
	DevCPE_Out4(n);
	p = par;
	while (p != NIL) {
		if ((INTEGER)p->mode != 2) {
			m = 10;
		} else if ((INTEGER)p->vis == 3) {
			m = 11;
		} else if ((INTEGER)p->vis == 4) {
			m = 12;
		} else {
			m = 13;
		}
		DevCPE_Out4(__ASHL(DevCPE_NameIdx(p), 8, INTEGER) + m);
		DevCPE_OutStruct(p->typ, 1);
		p = p->link;
	}
	__EXIT;
}

static void DevCPE_PrepObject (DevCPT_Object obj)
{
	DevCPT_Const _ptr__65 = NIL;
	__ENTER("DevCPE.PrepObject");
	if (__IN(obj->mode, 0x04c0)) {
		_ptr__65 = obj->conval;
		DevCPE_OutSignature(obj->link, obj->typ, &_ptr__65->intval);
	}
	__EXIT;
}

static void DevCPE_OutObject (INTEGER mode, INTEGER fprint, INTEGER offs, DevCPT_Struct typ, DevCPT_Object \
obj)
{
	INTEGER vis;
	__ENTER("DevCPE.OutObject");
	DevCPE_Out4(fprint);
	DevCPE_Out4(offs);
	if ((INTEGER)obj->vis == 0) {
		vis = 1;
	} else if ((INTEGER)obj->vis == 2) {
		vis = 2;
	} else if ((INTEGER)obj->vis == 1) {
		vis = 4;
	}
	DevCPE_Out4((mode + __ASHL(vis, 4, INTEGER)) + __ASHL(DevCPE_NameIdx(obj), 8, INTEGER));
	if (mode == 4) {
		DevCPE_OutReference(DevCPE_Meta, obj->conval->intval, 100);
	} else {
		DevCPE_OutStruct(typ, mode == 5);
	}
	__EXIT;
}

static void DevCPE_PrepDesc (DevCPT_Struct desc)
{
	DevCPT_Object fld = NIL;
	INTEGER n;
	DevCPT_LinkList l = NIL;
	DevCPT_Struct b = NIL;
	__ENTER("DevCPE.PrepDesc");
	if ((INTEGER)desc->comp == 4) {
		desc->strobj->adr = DevCPM_ObjLen() - DevCPE_headSize;
		n = 0;
		fld = desc->link;
		while (fld != NIL && (INTEGER)fld->mode == 4) {
			n += 1;
			fld = fld->link;
		}
		DevCPE_Out4(n);
		fld = desc->link;
		while (fld != NIL && (INTEGER)fld->mode == 4) {
			DevCPE_OutObject(5, 0, fld->adr, fld->typ, fld);
			fld = fld->link;
		}
	} else if ((INTEGER)desc->form == 14) {
		DevCPE_OutSignature(desc->link, desc->BaseTyp, &desc->n);
	}
	if (desc->untagged) {
		n = DevCPE_NameIdx(DevCPE_untgd);
	} else {
		n = DevCPE_NameIdx(desc->strobj);
	}
	if ((INTEGER)desc->form != 14) {
		b = desc->BaseTyp;
		if ((((((b != NIL && b != DevCPT_anytyp) && b != DevCPT_anyptrtyp) && __IN(b->form, 0xe000)) && (INTEGER)b->sysflag \
!= 10) && b != DevCPT_guidtyp) && (!b->untagged || DevCPE_outURef && (INTEGER)b->form == 15)) {
			l = DevCPE_OffsetLink(DevCPE_TypeObj(b), 0);
		}
	}
	__EXIT;
}

static DevCPT_Object DevCPE_NumMeth (DevCPT_Object root, INTEGER num)
{
	DevCPT_Object obj = NIL;
	__ENTER("DevCPE.NumMeth");
	if (root == NIL || (INTEGER)root->mode == 13 && root->num == num) {
		__EXIT;
		return root;
	}
	obj = DevCPE_NumMeth(root->left, num);
	if (obj == NIL) {
		obj = DevCPE_NumMeth(root->right, num);
	}
	__EXIT;
	return obj;
}

static void DevCPE_OutDesc (DevCPT_Struct desc)
{
	DevCPT_Object m = NIL;
	INTEGER i, nofptr, flddir, size;
	DevCPT_Struct t = NIL;
	DevCPT_Struct xb = NIL;
	BYTE form, lev, attr;
	__ENTER("DevCPE.OutDesc");
	__ASSERT(!desc->untagged, 0);
	if ((INTEGER)desc->comp == 4) {
		xb = desc;
		flddir = desc->strobj->adr;
		do {
			xb = xb->BaseTyp;
		} while (!((xb == NIL || (INTEGER)xb->mno != 0) || xb->untagged));
		DevCPE_Out4(-1);
		i = desc->n;
		while (i > 0) {
			i -= 1;
			t = desc;
			do {
				m = DevCPE_NumMeth(t->link, i);
				t = t->BaseTyp;
			} while (!(m != NIL || t == xb));
			if (m != NIL) {
				if (__IN(17, m->conval->setval)) {
					DevCPE_Out4(0);
				} else {
					DevCPE_OutReference(m, 0, 100);
				}
			} else if (xb == NIL || xb->untagged) {
				DevCPE_Out4(0);
			} else {
				DevCPE_OutReference(xb->strobj, -4 - __ASHL(i, 2, INTEGER), 102);
			}
		}
		desc->strobj->adr = DevCPM_ObjLen() - DevCPE_headSize;
		DevCPE_Out4(desc->size);
		DevCPE_OutReference(DevCPE_Mod, 0, 100);
		if (desc->untagged) {
			m = DevCPE_untgd;
		} else {
			m = desc->strobj;
		}
		if ((INTEGER)desc->attribute == 20) {
			attr = 1;
		} else if ((INTEGER)desc->attribute == 18) {
			attr = 2;
		} else if ((INTEGER)desc->attribute == 17) {
			attr = 3;
		} else {
			attr = 0;
		}
		DevCPE_Out4(((1 + __ASHL((INTEGER)attr, 2, INTEGER)) + __ASHL((INTEGER)desc->extlev, 4, INTEGER)) + \
__ASHL(DevCPE_NameIdx(m), 8, INTEGER));
		i = 0;
		while (i <= (INTEGER)desc->extlev) {
			t = desc;
			while ((INTEGER)t->extlev > i) {
				t = t->BaseTyp;
			}
			if ((INTEGER)t->sysflag == 10) {
				DevCPE_Out4(0);
			} else if (t->untagged) {
				DevCPE_OutReference(DevCPE_TypeObj(t), 0, 100);
			} else if ((INTEGER)t->mno == 0) {
				DevCPE_OutReference(t->strobj, 0, 100);
			} else if (t == xb) {
				DevCPE_OutReference(xb->strobj, 0, 100);
			} else {
				DevCPE_OutReference(xb->strobj, 12 + __ASHL(i, 2, INTEGER), 102);
			}
			i += 1;
		}
		while (i <= 15) {
			DevCPE_Out4(0);
			i += 1;
		}
		DevCPE_OutReference(DevCPE_Meta, flddir, 100);
		nofptr = 0;
		DevCPE_FindPtrs(desc, 0, 0, &nofptr);
		DevCPE_Out4(-(__ASHL(nofptr, 2, INTEGER) + 4));
		nofptr = 0;
		DevCPE_FindPtrs(desc, 0, 1, &nofptr);
		DevCPE_Out4(-1);
	} else {
		desc->strobj->adr = DevCPM_ObjLen() - DevCPE_headSize;
		lev = 0;
		size = 0;
		if ((INTEGER)desc->comp == 2) {
			size = desc->n;
			form = 2;
		} else if ((INTEGER)desc->comp == 3) {
			form = 2;
			lev = (BYTE)(desc->n + 1);
		} else if ((INTEGER)desc->form == 13) {
			form = 3;
		} else {
			__ASSERT((INTEGER)desc->form == 14, 0);
			DevCPM_FPrint(&size, 7);
			DevCPT_FPrintSign(&size, desc->BaseTyp, desc->link);
			form = 0;
		}
		DevCPE_Out4(size);
		DevCPE_OutReference(DevCPE_Mod, 0, 100);
		if (desc->untagged) {
			m = DevCPE_untgd;
		} else {
			m = desc->strobj;
		}
		DevCPE_Out4(((INTEGER)form + __ASHL((INTEGER)lev, 4, INTEGER)) + __ASHL(DevCPE_NameIdx(m), 8, INTEGER));
		if ((INTEGER)desc->form != 14) {
			DevCPE_OutStruct(desc->BaseTyp, 1);
		} else {
			DevCPE_OutReference(DevCPE_Meta, desc->n, 100);
		}
	}
	__EXIT;
}

static void DevCPE_OutModDesc (INTEGER nofptr, INTEGER refSize, INTEGER namePos, INTEGER ptrPos, INTEGER \
expPos, INTEGER impPos)
{
	INTEGER i;
	Dates_Time t;
	Dates_Date d;
	__ENTER("DevCPE.OutModDesc");
	DevCPE_Out4(0);
	DevCPE_Out4((INTEGER)DevCPE_options);
	DevCPE_Out4(0);
	Dates_GetDate(&d, Dates_Date__typ);
	Dates_GetTime(&t, Dates_Time__typ);
	DevCPE_Out2(d.year);
	DevCPE_Out2(d.month);
	DevCPE_Out2(d.day);
	DevCPE_Out2(t.hour);
	DevCPE_Out2(t.minute);
	DevCPE_Out2(t.second);
	DevCPE_Out4(0);
	DevCPE_Out4(0);
	DevCPE_Out4(0);
	DevCPE_Out4(0);
	if (DevCPE_closeLbl != 0) {
		DevCPE_OutReference(DevCPE_Code, DevCPE_closeLbl, 100);
	} else {
		DevCPE_Out4(0);
	}
	DevCPE_Out4(DevCPE_imports);
	DevCPE_Out4(nofptr);
	DevCPE_Out4(DevCPE_pc);
	DevCPE_Out4(DevCPE_dsize);
	DevCPE_Out4(refSize);
	DevCPE_OutReference(DevCPE_Code, 0, 100);
	DevCPE_OutReference(DevCPE_Data, 0, 100);
	DevCPE_OutReference(DevCPE_Meta, 0, 100);
	if (DevCPE_procVarIndirect) {
		DevCPE_OutReference(DevCPE_Proc, 0, 100);
	} else {
		DevCPE_OutReference(DevCPE_Code, 0, 100);
	}
	DevCPE_OutReference(DevCPE_Data, 0, 100);
	DevCPE_OutReference(DevCPE_Meta, namePos, 100);
	DevCPE_OutReference(DevCPE_Meta, ptrPos, 100);
	DevCPE_OutReference(DevCPE_Meta, impPos, 100);
	DevCPE_OutReference(DevCPE_Meta, expPos, 100);
	i = 0;
	while (DevCPT_SelfName[__X(i, 256)] != 0) {
		DevCPM_ObjW(DevCPT_SelfName[__X(i, 256)]);
		i += 1;
	}
	DevCPM_ObjW(0);
	DevCPE_Align(4);
	__EXIT;
}

static void DevCPE_OutProcTable (DevCPT_Object obj)
{
	__ENTER("DevCPE.OutProcTable");
	if (obj != NIL) {
		DevCPE_OutProcTable(obj->left);
		if (__IN(obj->mode, 0x0480)) {
			DevCPE_Out2(20217);
			DevCPE_OutReference(DevCPE_Code, obj->adr, 100);
			DevCPE_Out2(0);
		}
		DevCPE_OutProcTable(obj->right);
	}
	__EXIT;
}

static void DevCPE_PrepExport (DevCPT_Object obj)
{
	__ENTER("DevCPE.PrepExport");
	if (obj != NIL) {
		DevCPE_PrepExport(obj->left);
		if ((__IN(obj->mode, 0x04c0) && (INTEGER)obj->history != 4) && (INTEGER)obj->vis != 0) {
			DevCPE_PrepObject(obj);
		}
		DevCPE_PrepExport(obj->right);
	}
	__EXIT;
}

static void DevCPE_OutExport (DevCPT_Object obj)
{
	INTEGER num;
	__ENTER("DevCPE.OutExport");
	if (obj != NIL) {
		DevCPE_OutExport(obj->left);
		if ((INTEGER)obj->history != 4 && ((INTEGER)obj->vis != 0 || ((INTEGER)obj->mode == 5 && obj->typ->strobj \
== obj) && (INTEGER)obj->typ->form == 15)) {
			DevCPT_FPrintObj(obj);
			if (__IN(obj->mode, 0x04c0)) {
				if (DevCPE_procVarIndirect) {
					__ASSERT(obj->nlink == NIL, 0);
					num = obj->num;
					obj->num = 0;
					DevCPE_OutObject(4, obj->fprint, num, NIL, obj);
					obj->num = num;
				} else {
					DevCPE_OutObject(4, obj->fprint, obj->adr, NIL, obj);
				}
			} else if ((INTEGER)obj->mode == 1) {
				DevCPE_OutObject(3, obj->fprint, DevCPE_dsize + obj->adr, obj->typ, obj);
			} else if ((INTEGER)obj->mode == 5) {
				DevCPE_OutObject(2, obj->typ->pbfp, obj->typ->pvfp, obj->typ, obj);
			} else {
				__ASSERT(__IN(obj->mode, 0x0208), 0);
				DevCPE_OutObject(1, obj->fprint, 0, NIL, obj);
			}
		}
		DevCPE_OutExport(obj->right);
	}
	__EXIT;
}

static void DevCPE_OutCLinks (DevCPT_Object obj)
{
	__ENTER("DevCPE.OutCLinks");
	if (obj != NIL) {
		DevCPE_OutCLinks(obj->left);
		if (__IN(obj->mode, 0x04c0)) {
			DevCPE_OutPLink(obj->links, obj->adr);
		}
		DevCPE_OutCLinks(obj->right);
	}
	__EXIT;
}

static void DevCPE_OutCPLinks (DevCPT_Object obj, INTEGER base)
{
	__ENTER("DevCPE.OutCPLinks");
	if (obj != NIL) {
		DevCPE_OutCPLinks(obj->left, base);
		if (__IN(obj->mode, 0x04c0)) {
			DevCPE_OutPLink(obj->links, obj->num + base);
		}
		DevCPE_OutCPLinks(obj->right, base);
	}
	__EXIT;
}

static void DevCPE_OutImport (DevCPT_Object obj)
{
	DevCPT_Struct typ = NIL;
	DevCPT_Object strobj = NIL;
	INTEGER opt;
	DevCPT_String _ptr__43 = NIL;
	DevCPT_String _ptr__42 = NIL;
	DevCPT_String _ptr__41 = NIL;
	DevCPT_String _ptr__40 = NIL;
	__ENTER("DevCPE.OutImport");
	if (obj != NIL) {
		DevCPE_OutImport(obj->left);
		if ((INTEGER)obj->mode == 5) {
			typ = obj->typ;
			if (obj->used || (__IN(typ->form, 0xa000) && typ->strobj == obj) && (obj->links != NIL || obj->name \
!= DevCPT_null && (typ->pvused || typ->pbused))) {
				DevCPT_FPrintStr(typ);
				DevCPM_ObjW(2);
				_ptr__43 = obj->name;
				DevCPE_OutName((void*)_ptr__43->data, _ptr__43->len[0]);
				if (obj->used) {
					opt = 2;
				} else {
					opt = 0;
				}
				if ((INTEGER)typ->form == 15 && (typ->pvused || obj->name == DevCPT_null)) {
					DevCPM_ObjWNum(typ->pvfp);
					DevCPM_ObjW((SHORTCHAR)(opt + 1));
					if ((INTEGER)obj->history == 5) {
						DevCPT_FPrintErr(obj, 249);
					}
				} else {
					DevCPM_ObjWNum(typ->pbfp);
					DevCPM_ObjW((SHORTCHAR)opt);
				}
				DevCPE_OutLink(obj->links);
			}
		} else if (obj->used) {
			DevCPT_FPrintObj(obj);
			if ((INTEGER)obj->mode == 1) {
				DevCPM_ObjW(3);
				_ptr__42 = obj->name;
				DevCPE_OutName((void*)_ptr__42->data, _ptr__42->len[0]);
				DevCPM_ObjWNum(obj->fprint);
				DevCPE_OutLink(obj->links);
			} else if (__IN(obj->mode, 0x0480)) {
				DevCPM_ObjW(4);
				_ptr__41 = obj->name;
				DevCPE_OutName((void*)_ptr__41->data, _ptr__41->len[0]);
				DevCPM_ObjWNum(obj->fprint);
				DevCPE_OutLink(obj->links);
			} else {
				__ASSERT(__IN(obj->mode, 0x0208), 0);
				DevCPM_ObjW(1);
				_ptr__40 = obj->name;
				DevCPE_OutName((void*)_ptr__40->data, _ptr__40->len[0]);
				DevCPM_ObjWNum(obj->fprint);
			}
		}
		DevCPE_OutImport(obj->right);
	}
	__EXIT;
}

static void DevCPE_OutUseBlock (void)
{
	DevCPT_Object m = NIL;
	DevCPT_Object obj = NIL;
	INTEGER i;
	DevCPT_String _ptr__61 = NIL;
	DevCPT_String _ptr__60 = NIL;
	__ENTER("DevCPE.OutUseBlock");
	m = DevCPE_dllList;
	while (m != NIL) {
		obj = m->nlink;
		while (obj != NIL) {
			if ((INTEGER)obj->mode == 1) {
				DevCPM_ObjW(3);
			} else {
				DevCPM_ObjW(4);
			}
			if (obj->entry != NIL) {
				_ptr__61 = obj->entry;
				DevCPE_OutName((void*)_ptr__61->data, _ptr__61->len[0]);
			} else {
				_ptr__60 = obj->name;
				DevCPE_OutName((void*)_ptr__60->data, _ptr__60->len[0]);
			}
			DevCPT_FPrintObj(obj);
			DevCPM_ObjWNum(obj->fprint);
			DevCPE_OutLink(obj->links);
			obj = obj->nlink;
		}
		DevCPM_ObjW(0);
		m = m->link;
	}
	i = 1;
	while (i < (INTEGER)DevCPT_nofGmod) {
		obj = DevCPT_GlbMod[__X(i, 127)];
		if (obj->library == NIL) {
			DevCPE_OutImport(obj->right);
			DevCPM_ObjW(0);
		}
		i += 1;
	}
	__EXIT;
}

static void DevCPE_CollectDll (DevCPT_Object obj, DevCPT_String mod)
{
	DevCPT_String name = NIL;
	DevCPT_Object dll = NIL;
	__ENTER("DevCPE.CollectDll");
	if (obj != NIL) {
		DevCPE_CollectDll(obj->left, mod);
		if (obj->used && __IN(obj->mode, 0x0482)) {
			if (obj->library != NIL) {
				name = obj->library;
			} else {
				name = mod;
			}
			dll = DevCPE_dllList;
			while (dll != NIL && __STRCMPSS(dll->library->data, name->data) != 0) {
				dll = dll->link;
			}
			if (dll == NIL) {
				dll = __NEW(DevCPT_ObjDesc__typ);
				dll->library = name;
				DevCPE_imports += 1;
				if (DevCPE_dllList == NIL) {
					DevCPE_dllList = dll;
				} else {
					DevCPE_dllLast->link = dll;
				}
				DevCPE_dllLast = dll;
				dll->left = dll;
			}
			dll->left->nlink = obj;
			dll->left = obj;
		}
		DevCPE_CollectDll(obj->right, mod);
	}
	__EXIT;
}

static void DevCPE_EnumXProc (DevCPT_Object obj, INTEGER *num)
{
	__ENTER("DevCPE.EnumXProc");
	if (obj != NIL) {
		DevCPE_EnumXProc(obj->left, num);
		if (__IN(obj->mode, 0x0480)) {
			obj->num = *num;
			*num += 8;
		}
		DevCPE_EnumXProc(obj->right, num);
	}
	__EXIT;
}

void DevCPE_OutHeader (void)
{
	INTEGER i;
	DevCPT_Object m = NIL;
	DevCPT_String _ptr__38 = NIL;
	DevCPT_String _ptr__37 = NIL;
	__ENTER("DevCPE.OutHeader");
	DevCPM_ObjWLInt(DevCPE_processor);
	DevCPM_ObjWLInt(0);
	DevCPM_ObjWLInt(0);
	DevCPM_ObjWLInt(0);
	DevCPM_ObjWLInt(0);
	DevCPM_ObjWLInt(0);
	DevCPE_imports = 0;
	i = 1;
	while (i < (INTEGER)DevCPT_nofGmod) {
		m = DevCPT_GlbMod[__X(i, 127)];
		if (m->library != NIL) {
			DevCPE_CollectDll(m->right, m->library);
		} else {
			DevCPE_imports += 1;
		}
		i += 1;
	}
	DevCPM_ObjWNum(DevCPE_imports);
	DevCPE_OutName((void*)DevCPT_SelfName, 256);
	m = DevCPE_dllList;
	while (m != NIL) {
		DevCPM_ObjW((SHORTCHAR)'$');
		_ptr__38 = m->library;
		DevCPE_OutName((void*)_ptr__38->data, _ptr__38->len[0]);
		m = m->link;
	}
	i = 1;
	while (i < (INTEGER)DevCPT_nofGmod) {
		m = DevCPT_GlbMod[__X(i, 127)];
		if (m->library == NIL) {
			_ptr__37 = m->name;
			DevCPE_OutName((void*)_ptr__37->data, _ptr__37->len[0]);
		}
		i += 1;
	}
	DevCPE_Align(16);
	DevCPE_headSize = DevCPM_ObjLen();
	if (DevCPE_procVarIndirect) {
		i = 0;
		DevCPE_EnumXProc(DevCPT_topScope->right, &i);
	}
	__EXIT;
}

void DevCPE_OutCode (void)
{
	INTEGER i, refSize, expPos, ptrPos, impPos, namePos, procPos, con8Pos, con16Pos, con32Pos, con64Pos, \
modPos, codePos;
	DevCPT_Object obj = NIL;
	DevCPT_Object dlist = NIL;
	__ENTER("DevCPE.OutCode");
	DevCPM_ObjW(0);
	refSize = DevCPM_ObjLen() - DevCPE_headSize;
	DevCPE_Align(4);
	DevCPE_PrepExport(DevCPT_topScope->right);
	DevCPE_Align(8);
	expPos = DevCPM_ObjLen();
	DevCPE_Out4(0);
	DevCPE_OutExport(DevCPT_topScope->right);
	i = DevCPM_ObjLen();
	DevCPM_ObjSet(expPos);
	DevCPE_Out4(__ASHR((i - expPos) - 4, 4, INTEGER));
	DevCPM_ObjSet(i);
	ptrPos = DevCPM_ObjLen();
	obj = DevCPT_topScope->scope;
	DevCPE_nofptrs = 0;
	while (obj != NIL) {
		DevCPE_FindPtrs(obj->typ, DevCPE_dsize + obj->adr, 0, &DevCPE_nofptrs);
		obj = obj->link;
	}
	obj = DevCPT_topScope->scope;
	i = 0;
	while (obj != NIL) {
		DevCPE_FindPtrs(obj->typ, DevCPE_dsize + obj->adr, 1, &i);
		obj = obj->link;
	}
	if (i > 0) {
		DevCPE_Out4(-1);
		DevCPE_options |= __SETOF(30);
	}
	dlist = NIL;
	while (DevCPE_descList != NIL) {
		obj = DevCPE_descList;
		DevCPE_descList = DevCPE_descList->link;
		DevCPE_PrepDesc(obj->typ);
		obj->link = dlist;
		dlist = obj;
	}
	impPos = DevCPM_ObjLen();
	i = 0;
	while (i < DevCPE_imports) {
		DevCPE_Out4(0);
		i += 1;
	}
	namePos = DevCPM_ObjLen();
	DevCPE_OutNames();
	DevCPE_Align(4);
	con8Pos = DevCPM_ObjLen();
	DevCPE_OutConst(DevCPE_Const8);
	con16Pos = DevCPM_ObjLen();
	__ASSERT(__MASK(con16Pos, -4) == 0, 0);
	__ASSERT(con16Pos - con8Pos == DevCPE_idx8, 0);
	DevCPE_OutConst(DevCPE_Const16);
	con32Pos = DevCPM_ObjLen();
	__ASSERT(__MASK(con32Pos, -4) == 0, 0);
	__ASSERT(con32Pos - con16Pos == DevCPE_idx16, 0);
	DevCPE_OutConst(DevCPE_Const32);
	con64Pos = DevCPM_ObjLen();
	__ASSERT(__MASK(con64Pos, -4) == 0, 0);
	__ASSERT(con64Pos - con32Pos == DevCPE_idx32, 0);
	if (__ODD(__ASHR(con64Pos, 2, INTEGER))) {
		DevCPE_Out4(0);
		con64Pos += 4;
	}
	DevCPE_OutConst(DevCPE_Const64);
	__ASSERT(DevCPM_ObjLen() - con64Pos == DevCPE_idx64, 0);
	DevCPE_Align(16);
	modPos = DevCPM_ObjLen();
	DevCPE_OutModDesc(DevCPE_nofptrs, refSize, namePos - DevCPE_headSize, ptrPos - DevCPE_headSize, expPos \
- DevCPE_headSize, impPos - DevCPE_headSize);
	procPos = DevCPM_ObjLen();
	DevCPE_OutProcTable(DevCPT_topScope->right);
	DevCPE_Out4(0);
	DevCPE_Out4(0);
	DevCPE_Out4(0);
	obj = dlist;
	while (obj != NIL) {
		DevCPE_OutDesc(obj->typ);
		obj = obj->link;
	}
	codePos = DevCPM_ObjLen();
	DevCPE_WriteCode();
	while (__MASK(DevCPE_pc, -4) != 0) {
		DevCPM_ObjW(144);
		DevCPE_pc += 1;
	}
	DevCPE_OutLink(DevCPE_KNewRec->links);
	DevCPE_OutLink(DevCPE_KNewArr->links);
	DevCPE_OutPLink(DevCPE_Const8->links, con8Pos - DevCPE_headSize);
	DevCPE_OutPLink(DevCPE_Const16->links, con16Pos - DevCPE_headSize);
	DevCPE_OutPLink(DevCPE_Const32->links, con32Pos - DevCPE_headSize);
	DevCPE_OutPLink(DevCPE_Const64->links, con64Pos - DevCPE_headSize);
	DevCPE_OutLink(DevCPE_Meta->links);
	obj = dlist;
	i = modPos - DevCPE_headSize;
	while (obj != NIL) {
		DevCPE_OutPLink(obj->links, obj->adr - i);
		obj->links = NIL;
		obj = obj->link;
	}
	if (DevCPE_procVarIndirect) {
		DevCPE_OutPLink(DevCPE_Proc->links, procPos - modPos);
		DevCPE_OutCPLinks(DevCPT_topScope->right, procPos - modPos);
	}
	DevCPE_OutLink(DevCPE_Mod->links);
	if (!DevCPE_procVarIndirect) {
		DevCPE_OutCLinks(DevCPT_topScope->right);
	}
	DevCPE_OutPLink(DevCPE_CaseLinks, 0);
	DevCPE_OutLink(DevCPE_Code->links);
	DevCPE_OutLink(DevCPE_Data->links);
	DevCPE_OutUseBlock();
	DevCPM_ObjSet(8);
	DevCPM_ObjWLInt(DevCPE_headSize);
	DevCPM_ObjWLInt(modPos - DevCPE_headSize);
	DevCPM_ObjWLInt(codePos - modPos);
	DevCPM_ObjWLInt(DevCPE_pc);
	DevCPM_ObjWLInt(DevCPE_dsize);
	if (DevCPE_namex > 8388608) {
		DevCPM_err(242);
	}
	if (DevCPM_noerr && DevCPE_outObj) {
		DevCPM_RegisterObj();
	}
	__EXIT;
}

void DevCPE_Init (INTEGER proc, SET opt)
{
	__ENTER("DevCPE.Init");
	DevCPE_processor = proc;
	DevCPE_bigEndian = __IN(15, opt);
	DevCPE_procVarIndirect = __IN(14, opt);
	DevCPE_outRef = __IN(4, opt);
	DevCPE_outAllRef = __IN(5, opt);
	DevCPE_outObj = __IN(3, opt);
	DevCPE_outURef = 0;
	DevCPE_outSrc = __IN(6, opt);
	DevCPE_pc = 0;
	DevCPE_actIdx = 16384;
	DevCPE_blkIdx = 0;
	DevCPE_idx8 = 0;
	DevCPE_idx16 = 0;
	DevCPE_idx32 = 0;
	DevCPE_idx64 = 0;
	DevCPE_namex = 1;
	DevCPE_options = opt & 0xffff;
	DevCPE_CodeOvF = 0;
	DevCPE_KNewRec->links = NIL;
	DevCPE_KNewArr->links = NIL;
	DevCPE_CaseLinks = NIL;
	DevCPE_Const8->links = NIL;
	DevCPE_Const8->conval = NIL;
	DevCPE_Const16->links = NIL;
	DevCPE_Const16->conval = NIL;
	DevCPE_Const32->links = NIL;
	DevCPE_Const32->conval = NIL;
	DevCPE_Const64->links = NIL;
	DevCPE_Const64->conval = NIL;
	DevCPE_Code->links = NIL;
	DevCPE_Data->links = NIL;
	DevCPE_Mod->links = NIL;
	DevCPE_Proc->links = NIL;
	DevCPE_Meta->links = NIL;
	DevCPE_nameList = NIL;
	DevCPE_descList = NIL;
	DevCPE_dllList = NIL;
	DevCPE_dllLast = NIL;
	DevCPE_codePos = 0;
	DevCPE_srcPos = 0;
	DevCPE_untgd = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_untgd->name = DevCPT_NewName((void*)"!", 2);
	DevCPE_closeLbl = 0;
	__EXIT;
}

void DevCPE_Close (void)
{
	__ENTER("DevCPE.Close");
	DevCPE_KNewRec->links = NIL;
	DevCPE_KNewArr->links = NIL;
	DevCPE_CaseLinks = NIL;
	DevCPE_Const8->links = NIL;
	DevCPE_Const8->conval = NIL;
	DevCPE_Const16->links = NIL;
	DevCPE_Const16->conval = NIL;
	DevCPE_Const32->links = NIL;
	DevCPE_Const32->conval = NIL;
	DevCPE_Const64->links = NIL;
	DevCPE_Const64->conval = NIL;
	DevCPE_Code->links = NIL;
	DevCPE_Data->links = NIL;
	DevCPE_Mod->links = NIL;
	DevCPE_Proc->links = NIL;
	DevCPE_Meta->links = NIL;
	DevCPE_nameList = NIL;
	DevCPE_descList = NIL;
	DevCPE_dllList = NIL;
	DevCPE_dllLast = NIL;
	while (DevCPE_blkIdx > 0) {
		DevCPE_blkIdx -= 1;
		DevCPE_code[__X(DevCPE_blkIdx, 512)] = NIL;
	}
	DevCPE_actual = NIL;
	DevCPE_untgd = NIL;
	__EXIT;
}

export INTEGER DevCPE__1__desc[] = {
	16384,
	(INTEGER)&DevCPE__desc,
	0<<8 | 0x02,
	2
};
export INTEGER DevCPE_CodeBlock__desc[] = {
	0,
	(INTEGER)&DevCPE__desc,
	1<<8 | 0x03,
	(INTEGER)DevCPE__1__desc
};
export INTEGER DevCPE__2__desc[] = {
	512,
	(INTEGER)&DevCPE__desc,
	0<<8 | 0x02,
	(INTEGER)DevCPE_CodeBlock__desc
};
export INTEGER DevCPE__3__desc[] = {
	16,
	(INTEGER)&DevCPE__desc,
	0<<8 | 0x02,
	2
};
static SYSTEM_MODDESC *DevCPE__imp[] = {
	&Dates__desc,
	&DevCPM__desc,
	&DevCPT__desc,
};
static INTEGER DevCPE__exp[] = {
	99,
	0x227d6f36, (INTEGER)DevCPE_Align, 11<<8 | 0x14, 0,
	0x1e74cbee, (INTEGER)DevCPE_AllocConst, 17<<8 | 0x44, 0,
	0x8b95859d, (INTEGER)DevCPE_AllocTypDesc, 28<<8 | 0x44, 0,
	0x72a4af9f, (INTEGER)&DevCPE_CaseLinks, 41<<8 | 0x43, (INTEGER)DevCPT_LinkList__desc,
	0x5814f4d6, (INTEGER)DevCPE_Close, 51<<8 | 0x44, 0,
	0x229f03f2, (INTEGER)&DevCPE_Code, 57<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x0de13ad6, (INTEGER)&DevCPE_CodeOvF, 62<<8 | 0x13, 1,
	0x227d6f36, (INTEGER)DevCPE_CollectDll, 70<<8 | 0x14, 0,
	0x229f03f2, (INTEGER)&DevCPE_Const16, 81<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPE_Const32, 89<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPE_Const64, 97<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPE_Const8, 105<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPE_Data, 112<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x227d6f36, (INTEGER)DevCPE_EnumXProc, 117<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_FindPtrs, 127<<8 | 0x14, 0,
	0x20a5e209, (INTEGER)DevCPE_GenByte, 136<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)DevCPE_GenShort, 144<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)DevCPE_GenWord, 153<<8 | 0x44, 0,
	0x74835d33, (INTEGER)DevCPE_GetLongWords, 161<<8 | 0x44, 0,
	0xce99231e, (INTEGER)DevCPE_GetRealWord, 174<<8 | 0x44, 0,
	0x74835d33, (INTEGER)DevCPE_GetRealWords, 186<<8 | 0x44, 0,
	0x12c8926e, (INTEGER)DevCPE_Init, 199<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPE_IsSame, 204<<8 | 0x14, 0,
	0x6b92647f, (INTEGER)&DevCPE_KNewArr, 211<<8 | 0x43, (INTEGER)DevCPT_Object__desc,
	0x6b92647f, (INTEGER)&DevCPE_KNewRec, 219<<8 | 0x43, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPE_Meta, 227<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPE_Mod, 232<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x227d6f36, (INTEGER)DevCPE_NameIdx, 236<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_NumMeth, 244<<8 | 0x14, 0,
	0xc8ea3cfb, (INTEGER)DevCPE_OffsetLink, 252<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPE_Out2, 263<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_Out4, 268<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutCLinks, 273<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutCPLinks, 283<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)DevCPE_OutCode, 294<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPE_OutConst, 302<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutDesc, 311<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutExport, 319<<8 | 0x14, 0,
	0x7350ca4d, (INTEGER)DevCPE_OutGuid, 329<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)DevCPE_OutHeader, 337<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPE_OutImport, 347<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutLink, 357<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutModDesc, 365<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutName, 376<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutNames, 384<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutObject, 393<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutPLink, 403<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutProcTable, 412<<8 | 0x14, 0,
	0x1ebb3ba9, (INTEGER)DevCPE_OutRefName, 425<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPE_OutReference, 436<<8 | 0x14, 0,
	0x1cdfadf1, (INTEGER)DevCPE_OutRefs, 449<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPE_OutSignature, 457<<8 | 0x14, 0,
	0x20a5e209, (INTEGER)DevCPE_OutSourceRef, 470<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPE_OutStruct, 483<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_OutUseBlock, 493<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_PrepDesc, 505<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_PrepExport, 514<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPE_PrepObject, 525<<8 | 0x14, 0,
	0x229f03f2, (INTEGER)&DevCPE_Proc, 536<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x2a872fd3, (INTEGER)DevCPE_PutByte, 541<<8 | 0x44, 0,
	0x2a872fd3, (INTEGER)DevCPE_PutShort, 549<<8 | 0x44, 0,
	0x2a872fd3, (INTEGER)DevCPE_PutWord, 558<<8 | 0x44, 0,
	0x4e27a847, (INTEGER)DevCPE_ThisByte, 566<<8 | 0x44, 0,
	0x4e27a847, (INTEGER)DevCPE_ThisShort, 575<<8 | 0x44, 0,
	0x4e27a847, (INTEGER)DevCPE_ThisWord, 585<<8 | 0x44, 0,
	0x7c21890b, (INTEGER)DevCPE_TypeObj, 594<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPE_WriteCode, 602<<8 | 0x14, 0,
	0x1ee54c0a, (INTEGER)&DevCPE_actIdx, 612<<8 | 0x13, 6,
	0x74b33791, (INTEGER)&DevCPE_actual, 619<<8 | 0x13, (INTEGER)DevCPE_CodeBlock__desc,
	0x0de13ad6, (INTEGER)&DevCPE_bigEndian, 626<<8 | 0x13, 1,
	0x1ee54c0a, (INTEGER)&DevCPE_blkIdx, 636<<8 | 0x13, 6,
	0x57e82b87, (INTEGER)&DevCPE_closeLbl, 643<<8 | 0x43, 6,
	0xaa9901a1, (INTEGER)&DevCPE_code, 652<<8 | 0x13, (INTEGER)DevCPE__2__desc,
	0x1ee54c0a, (INTEGER)&DevCPE_codePos, 657<<8 | 0x13, 6,
	0x229f03f2, (INTEGER)&DevCPE_descList, 665<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPE_dllLast, 674<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPE_dllList, 682<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x57e82b87, (INTEGER)&DevCPE_dsize, 690<<8 | 0x43, 6,
	0x1ee54c0a, (INTEGER)&DevCPE_headSize, 696<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&DevCPE_idx16, 705<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&DevCPE_idx32, 711<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&DevCPE_idx64, 717<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&DevCPE_idx8, 723<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&DevCPE_imports, 728<<8 | 0x13, 6,
	0x229f03f2, (INTEGER)&DevCPE_nameList, 736<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x1ee54c0a, (INTEGER)&DevCPE_namex, 745<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&DevCPE_nofptrs, 751<<8 | 0x13, 6,
	0x26aaf1b7, (INTEGER)&DevCPE_options, 759<<8 | 0x13, 9,
	0x0de13ad6, (INTEGER)&DevCPE_outAllRef, 767<<8 | 0x13, 1,
	0x0de13ad6, (INTEGER)&DevCPE_outObj, 777<<8 | 0x13, 1,
	0x0de13ad6, (INTEGER)&DevCPE_outRef, 784<<8 | 0x13, 1,
	0x0de13ad6, (INTEGER)&DevCPE_outSrc, 791<<8 | 0x13, 1,
	0x0de13ad6, (INTEGER)&DevCPE_outURef, 798<<8 | 0x13, 1,
	0x57e82b87, (INTEGER)&DevCPE_pc, 806<<8 | 0x43, 6,
	0x0de13ad6, (INTEGER)&DevCPE_procVarIndirect, 809<<8 | 0x13, 1,
	0x1ee54c0a, (INTEGER)&DevCPE_processor, 825<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&DevCPE_srcPos, 835<<8 | 0x13, 6,
	0x229f03f2, (INTEGER)&DevCPE_untgd, 842<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x3ac914f0, (INTEGER)&DevCPE_zero, 848<<8 | 0x13, (INTEGER)DevCPE__3__desc,
};
static char DevCPE__names[] = {
	0,
	'C','o','d','e','B','l','o','c','k',0,
	'A','l','i','g','n',0,
	'A','l','l','o','c','C','o','n','s','t',0,
	'A','l','l','o','c','T','y','p','D','e','s','c',0,
	'C','a','s','e','L','i','n','k','s',0,
	'C','l','o','s','e',0,
	'C','o','d','e',0,
	'C','o','d','e','O','v','F',0,
	'C','o','l','l','e','c','t','D','l','l',0,
	'C','o','n','s','t','1','6',0,
	'C','o','n','s','t','3','2',0,
	'C','o','n','s','t','6','4',0,
	'C','o','n','s','t','8',0,
	'D','a','t','a',0,
	'E','n','u','m','X','P','r','o','c',0,
	'F','i','n','d','P','t','r','s',0,
	'G','e','n','B','y','t','e',0,
	'G','e','n','S','h','o','r','t',0,
	'G','e','n','W','o','r','d',0,
	'G','e','t','L','o','n','g','W','o','r','d','s',0,
	'G','e','t','R','e','a','l','W','o','r','d',0,
	'G','e','t','R','e','a','l','W','o','r','d','s',0,
	'I','n','i','t',0,
	'I','s','S','a','m','e',0,
	'K','N','e','w','A','r','r',0,
	'K','N','e','w','R','e','c',0,
	'M','e','t','a',0,
	'M','o','d',0,
	'N','a','m','e','I','d','x',0,
	'N','u','m','M','e','t','h',0,
	'O','f','f','s','e','t','L','i','n','k',0,
	'O','u','t','2',0,
	'O','u','t','4',0,
	'O','u','t','C','L','i','n','k','s',0,
	'O','u','t','C','P','L','i','n','k','s',0,
	'O','u','t','C','o','d','e',0,
	'O','u','t','C','o','n','s','t',0,
	'O','u','t','D','e','s','c',0,
	'O','u','t','E','x','p','o','r','t',0,
	'O','u','t','G','u','i','d',0,
	'O','u','t','H','e','a','d','e','r',0,
	'O','u','t','I','m','p','o','r','t',0,
	'O','u','t','L','i','n','k',0,
	'O','u','t','M','o','d','D','e','s','c',0,
	'O','u','t','N','a','m','e',0,
	'O','u','t','N','a','m','e','s',0,
	'O','u','t','O','b','j','e','c','t',0,
	'O','u','t','P','L','i','n','k',0,
	'O','u','t','P','r','o','c','T','a','b','l','e',0,
	'O','u','t','R','e','f','N','a','m','e',0,
	'O','u','t','R','e','f','e','r','e','n','c','e',0,
	'O','u','t','R','e','f','s',0,
	'O','u','t','S','i','g','n','a','t','u','r','e',0,
	'O','u','t','S','o','u','r','c','e','R','e','f',0,
	'O','u','t','S','t','r','u','c','t',0,
	'O','u','t','U','s','e','B','l','o','c','k',0,
	'P','r','e','p','D','e','s','c',0,
	'P','r','e','p','E','x','p','o','r','t',0,
	'P','r','e','p','O','b','j','e','c','t',0,
	'P','r','o','c',0,
	'P','u','t','B','y','t','e',0,
	'P','u','t','S','h','o','r','t',0,
	'P','u','t','W','o','r','d',0,
	'T','h','i','s','B','y','t','e',0,
	'T','h','i','s','S','h','o','r','t',0,
	'T','h','i','s','W','o','r','d',0,
	'T','y','p','e','O','b','j',0,
	'W','r','i','t','e','C','o','d','e',0,
	'a','c','t','I','d','x',0,
	'a','c','t','u','a','l',0,
	'b','i','g','E','n','d','i','a','n',0,
	'b','l','k','I','d','x',0,
	'c','l','o','s','e','L','b','l',0,
	'c','o','d','e',0,
	'c','o','d','e','P','o','s',0,
	'd','e','s','c','L','i','s','t',0,
	'd','l','l','L','a','s','t',0,
	'd','l','l','L','i','s','t',0,
	'd','s','i','z','e',0,
	'h','e','a','d','S','i','z','e',0,
	'i','d','x','1','6',0,
	'i','d','x','3','2',0,
	'i','d','x','6','4',0,
	'i','d','x','8',0,
	'i','m','p','o','r','t','s',0,
	'n','a','m','e','L','i','s','t',0,
	'n','a','m','e','x',0,
	'n','o','f','p','t','r','s',0,
	'o','p','t','i','o','n','s',0,
	'o','u','t','A','l','l','R','e','f',0,
	'o','u','t','O','b','j',0,
	'o','u','t','R','e','f',0,
	'o','u','t','S','r','c',0,
	'o','u','t','U','R','e','f',0,
	'p','c',0,
	'p','r','o','c','V','a','r','I','n','d','i','r','e','c','t',0,
	'p','r','o','c','e','s','s','o','r',0,
	's','r','c','P','o','s',0,
	'u','n','t','g','d',0,
	'z','e','r','o',0,
};
static INTEGER DevCPE__ptrs[] = {
	(INTEGER)&DevCPE_KNewRec + 0, 
	(INTEGER)&DevCPE_KNewArr + 0, 
	(INTEGER)&DevCPE_CaseLinks + 0, 
	(INTEGER)&DevCPE_Const8 + 0, 
	(INTEGER)&DevCPE_Const16 + 0, 
	(INTEGER)&DevCPE_Const32 + 0, 
	(INTEGER)&DevCPE_Const64 + 0, 
	(INTEGER)&DevCPE_Code + 0, 
	(INTEGER)&DevCPE_Data + 0, 
	(INTEGER)&DevCPE_Meta + 0, 
	(INTEGER)&DevCPE_Mod + 0, 
	(INTEGER)&DevCPE_Proc + 0, 
	(INTEGER)&DevCPE_nameList + 0, 
	(INTEGER)&DevCPE_descList + 0, 
	(INTEGER)&DevCPE_untgd + 0, 
	(INTEGER)&DevCPE_code + 0, 
	(INTEGER)&DevCPE_code + 4, 
	(INTEGER)&DevCPE_code + 8, 
	(INTEGER)&DevCPE_code + 12, 
	(INTEGER)&DevCPE_code + 16, 
	(INTEGER)&DevCPE_code + 20, 
	(INTEGER)&DevCPE_code + 24, 
	(INTEGER)&DevCPE_code + 28, 
	(INTEGER)&DevCPE_code + 32, 
	(INTEGER)&DevCPE_code + 36, 
	(INTEGER)&DevCPE_code + 40, 
	(INTEGER)&DevCPE_code + 44, 
	(INTEGER)&DevCPE_code + 48, 
	(INTEGER)&DevCPE_code + 52, 
	(INTEGER)&DevCPE_code + 56, 
	(INTEGER)&DevCPE_code + 60, 
	(INTEGER)&DevCPE_code + 64, 
	(INTEGER)&DevCPE_code + 68, 
	(INTEGER)&DevCPE_code + 72, 
	(INTEGER)&DevCPE_code + 76, 
	(INTEGER)&DevCPE_code + 80, 
	(INTEGER)&DevCPE_code + 84, 
	(INTEGER)&DevCPE_code + 88, 
	(INTEGER)&DevCPE_code + 92, 
	(INTEGER)&DevCPE_code + 96, 
	(INTEGER)&DevCPE_code + 100, 
	(INTEGER)&DevCPE_code + 104, 
	(INTEGER)&DevCPE_code + 108, 
	(INTEGER)&DevCPE_code + 112, 
	(INTEGER)&DevCPE_code + 116, 
	(INTEGER)&DevCPE_code + 120, 
	(INTEGER)&DevCPE_code + 124, 
	(INTEGER)&DevCPE_code + 128, 
	(INTEGER)&DevCPE_code + 132, 
	(INTEGER)&DevCPE_code + 136, 
	(INTEGER)&DevCPE_code + 140, 
	(INTEGER)&DevCPE_code + 144, 
	(INTEGER)&DevCPE_code + 148, 
	(INTEGER)&DevCPE_code + 152, 
	(INTEGER)&DevCPE_code + 156, 
	(INTEGER)&DevCPE_code + 160, 
	(INTEGER)&DevCPE_code + 164, 
	(INTEGER)&DevCPE_code + 168, 
	(INTEGER)&DevCPE_code + 172, 
	(INTEGER)&DevCPE_code + 176, 
	(INTEGER)&DevCPE_code + 180, 
	(INTEGER)&DevCPE_code + 184, 
	(INTEGER)&DevCPE_code + 188, 
	(INTEGER)&DevCPE_code + 192, 
	(INTEGER)&DevCPE_code + 196, 
	(INTEGER)&DevCPE_code + 200, 
	(INTEGER)&DevCPE_code + 204, 
	(INTEGER)&DevCPE_code + 208, 
	(INTEGER)&DevCPE_code + 212, 
	(INTEGER)&DevCPE_code + 216, 
	(INTEGER)&DevCPE_code + 220, 
	(INTEGER)&DevCPE_code + 224, 
	(INTEGER)&DevCPE_code + 228, 
	(INTEGER)&DevCPE_code + 232, 
	(INTEGER)&DevCPE_code + 236, 
	(INTEGER)&DevCPE_code + 240, 
	(INTEGER)&DevCPE_code + 244, 
	(INTEGER)&DevCPE_code + 248, 
	(INTEGER)&DevCPE_code + 252, 
	(INTEGER)&DevCPE_code + 256, 
	(INTEGER)&DevCPE_code + 260, 
	(INTEGER)&DevCPE_code + 264, 
	(INTEGER)&DevCPE_code + 268, 
	(INTEGER)&DevCPE_code + 272, 
	(INTEGER)&DevCPE_code + 276, 
	(INTEGER)&DevCPE_code + 280, 
	(INTEGER)&DevCPE_code + 284, 
	(INTEGER)&DevCPE_code + 288, 
	(INTEGER)&DevCPE_code + 292, 
	(INTEGER)&DevCPE_code + 296, 
	(INTEGER)&DevCPE_code + 300, 
	(INTEGER)&DevCPE_code + 304, 
	(INTEGER)&DevCPE_code + 308, 
	(INTEGER)&DevCPE_code + 312, 
	(INTEGER)&DevCPE_code + 316, 
	(INTEGER)&DevCPE_code + 320, 
	(INTEGER)&DevCPE_code + 324, 
	(INTEGER)&DevCPE_code + 328, 
	(INTEGER)&DevCPE_code + 332, 
	(INTEGER)&DevCPE_code + 336, 
	(INTEGER)&DevCPE_code + 340, 
	(INTEGER)&DevCPE_code + 344, 
	(INTEGER)&DevCPE_code + 348, 
	(INTEGER)&DevCPE_code + 352, 
	(INTEGER)&DevCPE_code + 356, 
	(INTEGER)&DevCPE_code + 360, 
	(INTEGER)&DevCPE_code + 364, 
	(INTEGER)&DevCPE_code + 368, 
	(INTEGER)&DevCPE_code + 372, 
	(INTEGER)&DevCPE_code + 376, 
	(INTEGER)&DevCPE_code + 380, 
	(INTEGER)&DevCPE_code + 384, 
	(INTEGER)&DevCPE_code + 388, 
	(INTEGER)&DevCPE_code + 392, 
	(INTEGER)&DevCPE_code + 396, 
	(INTEGER)&DevCPE_code + 400, 
	(INTEGER)&DevCPE_code + 404, 
	(INTEGER)&DevCPE_code + 408, 
	(INTEGER)&DevCPE_code + 412, 
	(INTEGER)&DevCPE_code + 416, 
	(INTEGER)&DevCPE_code + 420, 
	(INTEGER)&DevCPE_code + 424, 
	(INTEGER)&DevCPE_code + 428, 
	(INTEGER)&DevCPE_code + 432, 
	(INTEGER)&DevCPE_code + 436, 
	(INTEGER)&DevCPE_code + 440, 
	(INTEGER)&DevCPE_code + 444, 
	(INTEGER)&DevCPE_code + 448, 
	(INTEGER)&DevCPE_code + 452, 
	(INTEGER)&DevCPE_code + 456, 
	(INTEGER)&DevCPE_code + 460, 
	(INTEGER)&DevCPE_code + 464, 
	(INTEGER)&DevCPE_code + 468, 
	(INTEGER)&DevCPE_code + 472, 
	(INTEGER)&DevCPE_code + 476, 
	(INTEGER)&DevCPE_code + 480, 
	(INTEGER)&DevCPE_code + 484, 
	(INTEGER)&DevCPE_code + 488, 
	(INTEGER)&DevCPE_code + 492, 
	(INTEGER)&DevCPE_code + 496, 
	(INTEGER)&DevCPE_code + 500, 
	(INTEGER)&DevCPE_code + 504, 
	(INTEGER)&DevCPE_code + 508, 
	(INTEGER)&DevCPE_code + 512, 
	(INTEGER)&DevCPE_code + 516, 
	(INTEGER)&DevCPE_code + 520, 
	(INTEGER)&DevCPE_code + 524, 
	(INTEGER)&DevCPE_code + 528, 
	(INTEGER)&DevCPE_code + 532, 
	(INTEGER)&DevCPE_code + 536, 
	(INTEGER)&DevCPE_code + 540, 
	(INTEGER)&DevCPE_code + 544, 
	(INTEGER)&DevCPE_code + 548, 
	(INTEGER)&DevCPE_code + 552, 
	(INTEGER)&DevCPE_code + 556, 
	(INTEGER)&DevCPE_code + 560, 
	(INTEGER)&DevCPE_code + 564, 
	(INTEGER)&DevCPE_code + 568, 
	(INTEGER)&DevCPE_code + 572, 
	(INTEGER)&DevCPE_code + 576, 
	(INTEGER)&DevCPE_code + 580, 
	(INTEGER)&DevCPE_code + 584, 
	(INTEGER)&DevCPE_code + 588, 
	(INTEGER)&DevCPE_code + 592, 
	(INTEGER)&DevCPE_code + 596, 
	(INTEGER)&DevCPE_code + 600, 
	(INTEGER)&DevCPE_code + 604, 
	(INTEGER)&DevCPE_code + 608, 
	(INTEGER)&DevCPE_code + 612, 
	(INTEGER)&DevCPE_code + 616, 
	(INTEGER)&DevCPE_code + 620, 
	(INTEGER)&DevCPE_code + 624, 
	(INTEGER)&DevCPE_code + 628, 
	(INTEGER)&DevCPE_code + 632, 
	(INTEGER)&DevCPE_code + 636, 
	(INTEGER)&DevCPE_code + 640, 
	(INTEGER)&DevCPE_code + 644, 
	(INTEGER)&DevCPE_code + 648, 
	(INTEGER)&DevCPE_code + 652, 
	(INTEGER)&DevCPE_code + 656, 
	(INTEGER)&DevCPE_code + 660, 
	(INTEGER)&DevCPE_code + 664, 
	(INTEGER)&DevCPE_code + 668, 
	(INTEGER)&DevCPE_code + 672, 
	(INTEGER)&DevCPE_code + 676, 
	(INTEGER)&DevCPE_code + 680, 
	(INTEGER)&DevCPE_code + 684, 
	(INTEGER)&DevCPE_code + 688, 
	(INTEGER)&DevCPE_code + 692, 
	(INTEGER)&DevCPE_code + 696, 
	(INTEGER)&DevCPE_code + 700, 
	(INTEGER)&DevCPE_code + 704, 
	(INTEGER)&DevCPE_code + 708, 
	(INTEGER)&DevCPE_code + 712, 
	(INTEGER)&DevCPE_code + 716, 
	(INTEGER)&DevCPE_code + 720, 
	(INTEGER)&DevCPE_code + 724, 
	(INTEGER)&DevCPE_code + 728, 
	(INTEGER)&DevCPE_code + 732, 
	(INTEGER)&DevCPE_code + 736, 
	(INTEGER)&DevCPE_code + 740, 
	(INTEGER)&DevCPE_code + 744, 
	(INTEGER)&DevCPE_code + 748, 
	(INTEGER)&DevCPE_code + 752, 
	(INTEGER)&DevCPE_code + 756, 
	(INTEGER)&DevCPE_code + 760, 
	(INTEGER)&DevCPE_code + 764, 
	(INTEGER)&DevCPE_code + 768, 
	(INTEGER)&DevCPE_code + 772, 
	(INTEGER)&DevCPE_code + 776, 
	(INTEGER)&DevCPE_code + 780, 
	(INTEGER)&DevCPE_code + 784, 
	(INTEGER)&DevCPE_code + 788, 
	(INTEGER)&DevCPE_code + 792, 
	(INTEGER)&DevCPE_code + 796, 
	(INTEGER)&DevCPE_code + 800, 
	(INTEGER)&DevCPE_code + 804, 
	(INTEGER)&DevCPE_code + 808, 
	(INTEGER)&DevCPE_code + 812, 
	(INTEGER)&DevCPE_code + 816, 
	(INTEGER)&DevCPE_code + 820, 
	(INTEGER)&DevCPE_code + 824, 
	(INTEGER)&DevCPE_code + 828, 
	(INTEGER)&DevCPE_code + 832, 
	(INTEGER)&DevCPE_code + 836, 
	(INTEGER)&DevCPE_code + 840, 
	(INTEGER)&DevCPE_code + 844, 
	(INTEGER)&DevCPE_code + 848, 
	(INTEGER)&DevCPE_code + 852, 
	(INTEGER)&DevCPE_code + 856, 
	(INTEGER)&DevCPE_code + 860, 
	(INTEGER)&DevCPE_code + 864, 
	(INTEGER)&DevCPE_code + 868, 
	(INTEGER)&DevCPE_code + 872, 
	(INTEGER)&DevCPE_code + 876, 
	(INTEGER)&DevCPE_code + 880, 
	(INTEGER)&DevCPE_code + 884, 
	(INTEGER)&DevCPE_code + 888, 
	(INTEGER)&DevCPE_code + 892, 
	(INTEGER)&DevCPE_code + 896, 
	(INTEGER)&DevCPE_code + 900, 
	(INTEGER)&DevCPE_code + 904, 
	(INTEGER)&DevCPE_code + 908, 
	(INTEGER)&DevCPE_code + 912, 
	(INTEGER)&DevCPE_code + 916, 
	(INTEGER)&DevCPE_code + 920, 
	(INTEGER)&DevCPE_code + 924, 
	(INTEGER)&DevCPE_code + 928, 
	(INTEGER)&DevCPE_code + 932, 
	(INTEGER)&DevCPE_code + 936, 
	(INTEGER)&DevCPE_code + 940, 
	(INTEGER)&DevCPE_code + 944, 
	(INTEGER)&DevCPE_code + 948, 
	(INTEGER)&DevCPE_code + 952, 
	(INTEGER)&DevCPE_code + 956, 
	(INTEGER)&DevCPE_code + 960, 
	(INTEGER)&DevCPE_code + 964, 
	(INTEGER)&DevCPE_code + 968, 
	(INTEGER)&DevCPE_code + 972, 
	(INTEGER)&DevCPE_code + 976, 
	(INTEGER)&DevCPE_code + 980, 
	(INTEGER)&DevCPE_code + 984, 
	(INTEGER)&DevCPE_code + 988, 
	(INTEGER)&DevCPE_code + 992, 
	(INTEGER)&DevCPE_code + 996, 
	(INTEGER)&DevCPE_code + 1000, 
	(INTEGER)&DevCPE_code + 1004, 
	(INTEGER)&DevCPE_code + 1008, 
	(INTEGER)&DevCPE_code + 1012, 
	(INTEGER)&DevCPE_code + 1016, 
	(INTEGER)&DevCPE_code + 1020, 
	(INTEGER)&DevCPE_code + 1024, 
	(INTEGER)&DevCPE_code + 1028, 
	(INTEGER)&DevCPE_code + 1032, 
	(INTEGER)&DevCPE_code + 1036, 
	(INTEGER)&DevCPE_code + 1040, 
	(INTEGER)&DevCPE_code + 1044, 
	(INTEGER)&DevCPE_code + 1048, 
	(INTEGER)&DevCPE_code + 1052, 
	(INTEGER)&DevCPE_code + 1056, 
	(INTEGER)&DevCPE_code + 1060, 
	(INTEGER)&DevCPE_code + 1064, 
	(INTEGER)&DevCPE_code + 1068, 
	(INTEGER)&DevCPE_code + 1072, 
	(INTEGER)&DevCPE_code + 1076, 
	(INTEGER)&DevCPE_code + 1080, 
	(INTEGER)&DevCPE_code + 1084, 
	(INTEGER)&DevCPE_code + 1088, 
	(INTEGER)&DevCPE_code + 1092, 
	(INTEGER)&DevCPE_code + 1096, 
	(INTEGER)&DevCPE_code + 1100, 
	(INTEGER)&DevCPE_code + 1104, 
	(INTEGER)&DevCPE_code + 1108, 
	(INTEGER)&DevCPE_code + 1112, 
	(INTEGER)&DevCPE_code + 1116, 
	(INTEGER)&DevCPE_code + 1120, 
	(INTEGER)&DevCPE_code + 1124, 
	(INTEGER)&DevCPE_code + 1128, 
	(INTEGER)&DevCPE_code + 1132, 
	(INTEGER)&DevCPE_code + 1136, 
	(INTEGER)&DevCPE_code + 1140, 
	(INTEGER)&DevCPE_code + 1144, 
	(INTEGER)&DevCPE_code + 1148, 
	(INTEGER)&DevCPE_code + 1152, 
	(INTEGER)&DevCPE_code + 1156, 
	(INTEGER)&DevCPE_code + 1160, 
	(INTEGER)&DevCPE_code + 1164, 
	(INTEGER)&DevCPE_code + 1168, 
	(INTEGER)&DevCPE_code + 1172, 
	(INTEGER)&DevCPE_code + 1176, 
	(INTEGER)&DevCPE_code + 1180, 
	(INTEGER)&DevCPE_code + 1184, 
	(INTEGER)&DevCPE_code + 1188, 
	(INTEGER)&DevCPE_code + 1192, 
	(INTEGER)&DevCPE_code + 1196, 
	(INTEGER)&DevCPE_code + 1200, 
	(INTEGER)&DevCPE_code + 1204, 
	(INTEGER)&DevCPE_code + 1208, 
	(INTEGER)&DevCPE_code + 1212, 
	(INTEGER)&DevCPE_code + 1216, 
	(INTEGER)&DevCPE_code + 1220, 
	(INTEGER)&DevCPE_code + 1224, 
	(INTEGER)&DevCPE_code + 1228, 
	(INTEGER)&DevCPE_code + 1232, 
	(INTEGER)&DevCPE_code + 1236, 
	(INTEGER)&DevCPE_code + 1240, 
	(INTEGER)&DevCPE_code + 1244, 
	(INTEGER)&DevCPE_code + 1248, 
	(INTEGER)&DevCPE_code + 1252, 
	(INTEGER)&DevCPE_code + 1256, 
	(INTEGER)&DevCPE_code + 1260, 
	(INTEGER)&DevCPE_code + 1264, 
	(INTEGER)&DevCPE_code + 1268, 
	(INTEGER)&DevCPE_code + 1272, 
	(INTEGER)&DevCPE_code + 1276, 
	(INTEGER)&DevCPE_code + 1280, 
	(INTEGER)&DevCPE_code + 1284, 
	(INTEGER)&DevCPE_code + 1288, 
	(INTEGER)&DevCPE_code + 1292, 
	(INTEGER)&DevCPE_code + 1296, 
	(INTEGER)&DevCPE_code + 1300, 
	(INTEGER)&DevCPE_code + 1304, 
	(INTEGER)&DevCPE_code + 1308, 
	(INTEGER)&DevCPE_code + 1312, 
	(INTEGER)&DevCPE_code + 1316, 
	(INTEGER)&DevCPE_code + 1320, 
	(INTEGER)&DevCPE_code + 1324, 
	(INTEGER)&DevCPE_code + 1328, 
	(INTEGER)&DevCPE_code + 1332, 
	(INTEGER)&DevCPE_code + 1336, 
	(INTEGER)&DevCPE_code + 1340, 
	(INTEGER)&DevCPE_code + 1344, 
	(INTEGER)&DevCPE_code + 1348, 
	(INTEGER)&DevCPE_code + 1352, 
	(INTEGER)&DevCPE_code + 1356, 
	(INTEGER)&DevCPE_code + 1360, 
	(INTEGER)&DevCPE_code + 1364, 
	(INTEGER)&DevCPE_code + 1368, 
	(INTEGER)&DevCPE_code + 1372, 
	(INTEGER)&DevCPE_code + 1376, 
	(INTEGER)&DevCPE_code + 1380, 
	(INTEGER)&DevCPE_code + 1384, 
	(INTEGER)&DevCPE_code + 1388, 
	(INTEGER)&DevCPE_code + 1392, 
	(INTEGER)&DevCPE_code + 1396, 
	(INTEGER)&DevCPE_code + 1400, 
	(INTEGER)&DevCPE_code + 1404, 
	(INTEGER)&DevCPE_code + 1408, 
	(INTEGER)&DevCPE_code + 1412, 
	(INTEGER)&DevCPE_code + 1416, 
	(INTEGER)&DevCPE_code + 1420, 
	(INTEGER)&DevCPE_code + 1424, 
	(INTEGER)&DevCPE_code + 1428, 
	(INTEGER)&DevCPE_code + 1432, 
	(INTEGER)&DevCPE_code + 1436, 
	(INTEGER)&DevCPE_code + 1440, 
	(INTEGER)&DevCPE_code + 1444, 
	(INTEGER)&DevCPE_code + 1448, 
	(INTEGER)&DevCPE_code + 1452, 
	(INTEGER)&DevCPE_code + 1456, 
	(INTEGER)&DevCPE_code + 1460, 
	(INTEGER)&DevCPE_code + 1464, 
	(INTEGER)&DevCPE_code + 1468, 
	(INTEGER)&DevCPE_code + 1472, 
	(INTEGER)&DevCPE_code + 1476, 
	(INTEGER)&DevCPE_code + 1480, 
	(INTEGER)&DevCPE_code + 1484, 
	(INTEGER)&DevCPE_code + 1488, 
	(INTEGER)&DevCPE_code + 1492, 
	(INTEGER)&DevCPE_code + 1496, 
	(INTEGER)&DevCPE_code + 1500, 
	(INTEGER)&DevCPE_code + 1504, 
	(INTEGER)&DevCPE_code + 1508, 
	(INTEGER)&DevCPE_code + 1512, 
	(INTEGER)&DevCPE_code + 1516, 
	(INTEGER)&DevCPE_code + 1520, 
	(INTEGER)&DevCPE_code + 1524, 
	(INTEGER)&DevCPE_code + 1528, 
	(INTEGER)&DevCPE_code + 1532, 
	(INTEGER)&DevCPE_code + 1536, 
	(INTEGER)&DevCPE_code + 1540, 
	(INTEGER)&DevCPE_code + 1544, 
	(INTEGER)&DevCPE_code + 1548, 
	(INTEGER)&DevCPE_code + 1552, 
	(INTEGER)&DevCPE_code + 1556, 
	(INTEGER)&DevCPE_code + 1560, 
	(INTEGER)&DevCPE_code + 1564, 
	(INTEGER)&DevCPE_code + 1568, 
	(INTEGER)&DevCPE_code + 1572, 
	(INTEGER)&DevCPE_code + 1576, 
	(INTEGER)&DevCPE_code + 1580, 
	(INTEGER)&DevCPE_code + 1584, 
	(INTEGER)&DevCPE_code + 1588, 
	(INTEGER)&DevCPE_code + 1592, 
	(INTEGER)&DevCPE_code + 1596, 
	(INTEGER)&DevCPE_code + 1600, 
	(INTEGER)&DevCPE_code + 1604, 
	(INTEGER)&DevCPE_code + 1608, 
	(INTEGER)&DevCPE_code + 1612, 
	(INTEGER)&DevCPE_code + 1616, 
	(INTEGER)&DevCPE_code + 1620, 
	(INTEGER)&DevCPE_code + 1624, 
	(INTEGER)&DevCPE_code + 1628, 
	(INTEGER)&DevCPE_code + 1632, 
	(INTEGER)&DevCPE_code + 1636, 
	(INTEGER)&DevCPE_code + 1640, 
	(INTEGER)&DevCPE_code + 1644, 
	(INTEGER)&DevCPE_code + 1648, 
	(INTEGER)&DevCPE_code + 1652, 
	(INTEGER)&DevCPE_code + 1656, 
	(INTEGER)&DevCPE_code + 1660, 
	(INTEGER)&DevCPE_code + 1664, 
	(INTEGER)&DevCPE_code + 1668, 
	(INTEGER)&DevCPE_code + 1672, 
	(INTEGER)&DevCPE_code + 1676, 
	(INTEGER)&DevCPE_code + 1680, 
	(INTEGER)&DevCPE_code + 1684, 
	(INTEGER)&DevCPE_code + 1688, 
	(INTEGER)&DevCPE_code + 1692, 
	(INTEGER)&DevCPE_code + 1696, 
	(INTEGER)&DevCPE_code + 1700, 
	(INTEGER)&DevCPE_code + 1704, 
	(INTEGER)&DevCPE_code + 1708, 
	(INTEGER)&DevCPE_code + 1712, 
	(INTEGER)&DevCPE_code + 1716, 
	(INTEGER)&DevCPE_code + 1720, 
	(INTEGER)&DevCPE_code + 1724, 
	(INTEGER)&DevCPE_code + 1728, 
	(INTEGER)&DevCPE_code + 1732, 
	(INTEGER)&DevCPE_code + 1736, 
	(INTEGER)&DevCPE_code + 1740, 
	(INTEGER)&DevCPE_code + 1744, 
	(INTEGER)&DevCPE_code + 1748, 
	(INTEGER)&DevCPE_code + 1752, 
	(INTEGER)&DevCPE_code + 1756, 
	(INTEGER)&DevCPE_code + 1760, 
	(INTEGER)&DevCPE_code + 1764, 
	(INTEGER)&DevCPE_code + 1768, 
	(INTEGER)&DevCPE_code + 1772, 
	(INTEGER)&DevCPE_code + 1776, 
	(INTEGER)&DevCPE_code + 1780, 
	(INTEGER)&DevCPE_code + 1784, 
	(INTEGER)&DevCPE_code + 1788, 
	(INTEGER)&DevCPE_code + 1792, 
	(INTEGER)&DevCPE_code + 1796, 
	(INTEGER)&DevCPE_code + 1800, 
	(INTEGER)&DevCPE_code + 1804, 
	(INTEGER)&DevCPE_code + 1808, 
	(INTEGER)&DevCPE_code + 1812, 
	(INTEGER)&DevCPE_code + 1816, 
	(INTEGER)&DevCPE_code + 1820, 
	(INTEGER)&DevCPE_code + 1824, 
	(INTEGER)&DevCPE_code + 1828, 
	(INTEGER)&DevCPE_code + 1832, 
	(INTEGER)&DevCPE_code + 1836, 
	(INTEGER)&DevCPE_code + 1840, 
	(INTEGER)&DevCPE_code + 1844, 
	(INTEGER)&DevCPE_code + 1848, 
	(INTEGER)&DevCPE_code + 1852, 
	(INTEGER)&DevCPE_code + 1856, 
	(INTEGER)&DevCPE_code + 1860, 
	(INTEGER)&DevCPE_code + 1864, 
	(INTEGER)&DevCPE_code + 1868, 
	(INTEGER)&DevCPE_code + 1872, 
	(INTEGER)&DevCPE_code + 1876, 
	(INTEGER)&DevCPE_code + 1880, 
	(INTEGER)&DevCPE_code + 1884, 
	(INTEGER)&DevCPE_code + 1888, 
	(INTEGER)&DevCPE_code + 1892, 
	(INTEGER)&DevCPE_code + 1896, 
	(INTEGER)&DevCPE_code + 1900, 
	(INTEGER)&DevCPE_code + 1904, 
	(INTEGER)&DevCPE_code + 1908, 
	(INTEGER)&DevCPE_code + 1912, 
	(INTEGER)&DevCPE_code + 1916, 
	(INTEGER)&DevCPE_code + 1920, 
	(INTEGER)&DevCPE_code + 1924, 
	(INTEGER)&DevCPE_code + 1928, 
	(INTEGER)&DevCPE_code + 1932, 
	(INTEGER)&DevCPE_code + 1936, 
	(INTEGER)&DevCPE_code + 1940, 
	(INTEGER)&DevCPE_code + 1944, 
	(INTEGER)&DevCPE_code + 1948, 
	(INTEGER)&DevCPE_code + 1952, 
	(INTEGER)&DevCPE_code + 1956, 
	(INTEGER)&DevCPE_code + 1960, 
	(INTEGER)&DevCPE_code + 1964, 
	(INTEGER)&DevCPE_code + 1968, 
	(INTEGER)&DevCPE_code + 1972, 
	(INTEGER)&DevCPE_code + 1976, 
	(INTEGER)&DevCPE_code + 1980, 
	(INTEGER)&DevCPE_code + 1984, 
	(INTEGER)&DevCPE_code + 1988, 
	(INTEGER)&DevCPE_code + 1992, 
	(INTEGER)&DevCPE_code + 1996, 
	(INTEGER)&DevCPE_code + 2000, 
	(INTEGER)&DevCPE_code + 2004, 
	(INTEGER)&DevCPE_code + 2008, 
	(INTEGER)&DevCPE_code + 2012, 
	(INTEGER)&DevCPE_code + 2016, 
	(INTEGER)&DevCPE_code + 2020, 
	(INTEGER)&DevCPE_code + 2024, 
	(INTEGER)&DevCPE_code + 2028, 
	(INTEGER)&DevCPE_code + 2032, 
	(INTEGER)&DevCPE_code + 2036, 
	(INTEGER)&DevCPE_code + 2040, 
	(INTEGER)&DevCPE_code + 2044, 
	(INTEGER)&DevCPE_actual + 0, 
	(INTEGER)&DevCPE_dllList + 0, 
	(INTEGER)&DevCPE_dllLast + 0, 
};
struct SYSTEM_MODDESC DevCPE__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 12}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	DevCPE__body,
	0,
	3, /* nofimps */ 
	530, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	DevCPE__names,
	DevCPE__ptrs,
	DevCPE__imp,
	(SYSTEM_DIRECTORY*)DevCPE__exp,
	"DevCPE"
};

export void DevCPE__reg()
{
	__BEGREG(DevCPE__desc);
	Dates__reg();
	DevCPM__reg();
	DevCPT__reg();
	__REGMOD(DevCPE__desc);
	__ENDREG;
}

export void DevCPE__body()
{
	__BEGBODY(DevCPE__desc);
	Dates__body();
	DevCPM__body();
	DevCPT__body();
	DevCPE_KNewRec = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_KNewRec->mnolev = -128;
	DevCPE_KNewArr = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_KNewArr->mnolev = -128;
	DevCPE_Const8 = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Const8->mode = 3;
	DevCPE_Const8->mnolev = 0;
	DevCPE_Const16 = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Const16->mode = 3;
	DevCPE_Const16->mnolev = 0;
	DevCPE_Const32 = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Const32->mode = 3;
	DevCPE_Const32->mnolev = 0;
	DevCPE_Const64 = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Const64->mode = 3;
	DevCPE_Const64->mnolev = 0;
	DevCPE_Code = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Code->mode = 3;
	DevCPE_Code->mnolev = 0;
	DevCPE_Data = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Data->mode = 3;
	DevCPE_Data->mnolev = 0;
	DevCPE_Mod = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Mod->mode = 3;
	DevCPE_Mod->mnolev = 0;
	DevCPE_Proc = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Proc->mode = 3;
	DevCPE_Proc->mnolev = 0;
	DevCPE_Meta = __NEW(DevCPT_ObjDesc__typ);
	DevCPE_Meta->mode = 3;
	DevCPE_Mod->mnolev = 0;
	__ENDBODY;
}
