/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "DevCPT.h"




static void DevCPH_Convert (DevCPT_Node n, DevCPT_Struct typ);
static void DevCPH_UseCallForAssign (DevCPT_Node n, SET opts);
static void DevCPH_UseCallForComp (DevCPT_Node n);
static void DevCPH_UseCallForConv (DevCPT_Node n, SET opts);
static void DevCPH_UseCallForDop (DevCPT_Node n, SET opts);
static void DevCPH_UseCallForMop (DevCPT_Node n, SET opts);
static void DevCPH_UseCallForMove (DevCPT_Node n, DevCPT_Struct typ, SET opts);
static void DevCPH_UseCallForParam (DevCPT_Node n, DevCPT_Object fp, SET opts);
static void DevCPH_UseCallForReturn (DevCPT_Node n, SET opts);
export void DevCPH_UseCalls (DevCPT_Node n, SET opts);
export void DevCPH_UseReals (DevCPT_Node n, SET opts);
static void DevCPH_UseThisCall (DevCPT_Node n, SHORTCHAR *name, INTEGER name__len);

export void DevCPH__reg();
export void DevCPH__body();
export struct SYSTEM_MODDESC DevCPH__desc;


static void DevCPH_UseThisCall (DevCPT_Node n, SHORTCHAR *name, INTEGER name__len)
{
	DevCPT_Name mod, nm, moda;
	DevCPT_Object mobj = NIL;
	DevCPT_Object obj = NIL;
	BOOLEAN done;
	__ENTER("DevCPH.UseThisCall");
	if ((INTEGER)n->typ->form == 8 || (INTEGER)n->left->typ->form == 8) {
		__MOVE("Real", mod, 5);
	} else if ((INTEGER)n->typ->form == 7 || (INTEGER)n->left->typ->form == 7) {
		__MOVE("SReal", mod, 6);
	} else if ((INTEGER)n->typ->form == 18 || (INTEGER)n->left->typ->form == 18) {
		__MOVE("Long", mod, 5);
	} else {
		__MOVE("Int", mod, 4);
	}
	__STRCOPYSS(mod, moda, 256);
	__STRAPNDSS("%", moda, 256);
	DevCPT_Find(moda, &mobj);
	if (mobj == NIL) {
		DevCPT_Import(moda, mod, &done);
		if (done) {
			DevCPT_Find(moda, &mobj);
		}
	}
	__STRCOPYSS(name, nm, 256);
	DevCPT_FindImport(nm, mobj, &obj);
	n->class = 13;
	n->subcl = 0;
	n->obj = obj->link;
	n->left->link = n->right;
	n->right = n->left;
	n->left = DevCPT_NewNode(9);
	n->left->obj = obj;
	n->left->typ = obj->typ;
	__ASSERT((INTEGER)n->typ->form == (INTEGER)obj->typ->form, 0);
	__EXIT;
}

static void DevCPH_Convert (DevCPT_Node n, DevCPT_Struct typ)
{
	DevCPT_Node new = NIL;
	REAL r;
	__ENTER("DevCPH.Convert");
	if ((INTEGER)n->class == 7) {
		__ASSERT(__IN(n->typ->form, 0x040040) && typ == DevCPT_intrealtyp, 0);
		r = n->conval->realval + (REAL)n->conval->intval;
		if (r == n->conval->realval + (REAL)n->conval->intval) {
			n->conval->realval = r;
			n->conval->intval = -1;
			n->typ = typ;
			n->obj = NIL;
		}
	}
	if (n->typ != typ && (((INTEGER)n->class != 11 || (INTEGER)n->subcl != 20) || !DevCPT_Includes(n->typ->form, \
n->left->typ->form) && !DevCPT_Includes(n->typ->form, typ->form))) {
		new = DevCPT_NewNode(0);
		*new = *n;
		n->class = 11;
		n->subcl = 20;
		n->left = new;
		n->right = NIL;
		n->obj = NIL;
	}
	n->typ = typ;
	__EXIT;
}

static void DevCPH_UseCallForComp (DevCPT_Node n)
{
	DevCPT_Node new = NIL;
	__ENTER("DevCPH.UseCallForComp");
	new = DevCPT_NewNode(0);
	new->left = n->left;
	new->right = n->right;
	new->typ = DevCPT_int32typ;
	DevCPH_UseThisCall(new, (void*)"Comp", 5);
	n->left = new;
	n->right = DevCPT_NewNode(7);
	n->right->conval = DevCPT_NewConst();
	n->right->conval->intval = 0;
	n->right->conval->realval = (REAL)0;
	n->right->typ = DevCPT_int32typ;
	__EXIT;
}

static void DevCPH_UseCallForConv (DevCPT_Node n, SET opts)
{
	INTEGER f, g;
	DevCPT_Struct typ = NIL;
	__ENTER("DevCPH.UseCallForConv");
	typ = n->typ;
	f = typ->form;
	g = n->left->typ->form;
	if (__IN(10, opts)) {
		if (__IN(f, 0x0180)) {
			if (g == 7) {
				DevCPH_UseThisCall(n, (void*)"Long", 5);
			} else if (g == 8) {
				DevCPH_UseThisCall(n, (void*)"Short", 6);
			} else if (g == 18) {
				DevCPH_UseThisCall(n, (void*)"LFloat", 7);
			} else if (g == 6) {
				DevCPH_UseThisCall(n, (void*)"Float", 6);
			} else {
				DevCPH_Convert(n->left, DevCPT_int32typ);
				DevCPH_UseThisCall(n, (void*)"Float", 6);
			}
		} else if (__IN(g, 0x0180)) {
			if (f == 18) {
				DevCPH_UseThisCall(n, (void*)"LFloor", 7);
			} else if (f == 6) {
				DevCPH_UseThisCall(n, (void*)"Floor", 6);
			} else {
				n->typ = DevCPT_int32typ;
				DevCPH_UseThisCall(n, (void*)"Floor", 6);
				DevCPH_Convert(n, typ);
			}
		}
	}
	if (__IN(2, opts)) {
		if (f == 18) {
			if (g == 6) {
				DevCPH_UseThisCall(n, (void*)"Long", 5);
			} else if (!__IN(g, 0x0180)) {
				DevCPH_Convert(n->left, DevCPT_int32typ);
				DevCPH_UseThisCall(n, (void*)"IntToLong", 10);
			}
		} else if (g == 18) {
			if (f == 6) {
				DevCPH_UseThisCall(n, (void*)"Short", 6);
			} else if (!__IN(f, 0x0180)) {
				n->typ = DevCPT_int32typ;
				DevCPH_UseThisCall(n, (void*)"LongToInt", 10);
				DevCPH_Convert(n, typ);
			}
		}
	}
	__EXIT;
}

static void DevCPH_UseCallForMop (DevCPT_Node n, SET opts)
{
	__ENTER("DevCPH.UseCallForMop");
	switch (n->subcl) {
		case 7: 
			if (__IN(8, opts) && __IN(n->typ->form, 0x0180) || __IN(0, opts) && (INTEGER)n->typ->form == 18) {
				DevCPH_UseThisCall(n, (void*)"Neg", 4);
			}
			break;
		case 21: 
			if (__IN(8, opts) && __IN(n->typ->form, 0x0180) || __IN(0, opts) && (INTEGER)n->typ->form == 18) {
				DevCPH_UseThisCall(n, (void*)"Abs", 4);
			}
			break;
		case 23: 
			if (__IN(3, opts) && (INTEGER)n->left->typ->form == 18) {
				DevCPH_UseThisCall(n, (void*)"Odd", 4);
			}
			break;
		case 20: 
			DevCPH_UseCallForConv(n, opts);
			break;
		default: 
			break;
	}
	__EXIT;
}

static void DevCPH_UseCallForDop (DevCPT_Node n, SET opts)
{
	__ENTER("DevCPH.UseCallForDop");
	if ((__IN(9, opts) && __IN(n->left->typ->form, 0x0180) || __IN(1, opts) && (INTEGER)n->left->typ->form \
== 18) || (__IN(11, opts) && __IN(n->subcl, 0x1a)) && (INTEGER)n->typ->form == 6) {
		switch (n->subcl) {
			case 1: 
				DevCPH_UseThisCall(n, (void*)"Mul", 4);
				break;
			case 2: 
				DevCPH_UseThisCall(n, (void*)"Div", 4);
				break;
			case 3: 
				DevCPH_UseThisCall(n, (void*)"Div", 4);
				break;
			case 4: 
				DevCPH_UseThisCall(n, (void*)"Mod", 4);
				break;
			case 6: 
				DevCPH_UseThisCall(n, (void*)"Add", 4);
				break;
			case 7: 
				DevCPH_UseThisCall(n, (void*)"Sub", 4);
				break;
			case 17: 
				DevCPH_UseThisCall(n, (void*)"Ash", 4);
				break;
			case 34: 
				DevCPH_UseThisCall(n, (void*)"Min", 4);
				break;
			case 35: 
				DevCPH_UseThisCall(n, (void*)"Max", 4);
				break;
			case 9: case 10: case 11: case 12: case 13: 
			case 14: 
				DevCPH_UseCallForComp(n);
				break;
			default: 
				break;
		}
	}
	__EXIT;
}

static void DevCPH_UseCallForMove (DevCPT_Node n, DevCPT_Struct typ, SET opts)
{
	INTEGER f, g;
	__ENTER("DevCPH.UseCallForMove");
	f = n->typ->form;
	g = typ->form;
	if (f != g) {
		if (__IN(10, opts) && (__IN(f, 0x0180) || __IN(g, 0x0180)) || __IN(2, opts) && (f == 18 || g == 18)) \
{
			DevCPH_Convert(n, typ);
			DevCPH_UseCallForConv(n, opts);
		}
	}
	__EXIT;
}

static void DevCPH_UseCallForAssign (DevCPT_Node n, SET opts)
{
	__ENTER("DevCPH.UseCallForAssign");
	if ((INTEGER)n->subcl == 0) {
		DevCPH_UseCallForMove(n->right, n->left->typ, opts);
	}
	__EXIT;
}

static void DevCPH_UseCallForReturn (DevCPT_Node n, SET opts)
{
	__ENTER("DevCPH.UseCallForReturn");
	if (n->left != NIL && n->obj != NIL) {
		DevCPH_UseCallForMove(n->left, n->obj->typ, opts);
	}
	__EXIT;
}

static void DevCPH_UseCallForParam (DevCPT_Node n, DevCPT_Object fp, SET opts)
{
	__ENTER("DevCPH.UseCallForParam");
	while (n != NIL) {
		DevCPH_UseCallForMove(n, fp->typ, opts);
		n = n->link;
		fp = fp->link;
	}
	__EXIT;
}

void DevCPH_UseCalls (DevCPT_Node n, SET opts)
{
	__ENTER("DevCPH.UseCalls");
	while (n != NIL) {
		switch (n->class) {
			case 11: 
				DevCPH_UseCalls(n->left, opts);
				DevCPH_UseCallForMop(n, opts);
				break;
			case 12: 
				DevCPH_UseCalls(n->left, opts);
				DevCPH_UseCalls(n->right, opts);
				DevCPH_UseCallForDop(n, opts);
				break;
			case 21: 
				DevCPH_UseCalls(n->left, opts);
				DevCPH_UseCalls(n->right->left, opts);
				DevCPH_UseCalls(n->right->right, opts);
				break;
			case 19: 
				DevCPH_UseCalls(n->left, opts);
				DevCPH_UseCalls(n->right, opts);
				DevCPH_UseCallForAssign(n, opts);
				break;
			case 13: 
				DevCPH_UseCalls(n->left, opts);
				DevCPH_UseCalls(n->right, opts);
				DevCPH_UseCallForParam(n->right, n->obj, opts);
				break;
			case 26: 
				DevCPH_UseCalls(n->left, opts);
				DevCPH_UseCallForReturn(n, opts);
				break;
			case 17: 
				DevCPH_UseCalls(n->right, opts);
				break;
			case 2: case 3: case 5: case 24: case 50: 
			case 52: 
				DevCPH_UseCalls(n->left, opts);
				break;
			case 4: case 10: case 15: case 18: case 20: 
			case 22: case 23: case 27: case 30: 
				DevCPH_UseCalls(n->left, opts);
				DevCPH_UseCalls(n->right, opts);
				break;
			case 0: case 1: case 7: case 8: case 9: 
			case 14: case 25: case 28: case 51: case 53: 
			case 54: 
				break;
			default: __CASECHK;
		}
		n = n->link;
	}
	__EXIT;
}

void DevCPH_UseReals (DevCPT_Node n, SET opts)
{
	__ENTER("DevCPH.UseReals");
	while (n != NIL) {
		switch (n->class) {
			case 11: 
				if ((__IN(0, opts) && (INTEGER)n->typ->form == 18) && ((INTEGER)n->subcl == 21 || (INTEGER)n->subcl \
== 7)) {
					DevCPH_UseReals(n->left, opts & ~0x020000 | 0x010000);
					n->typ = DevCPT_intrealtyp;
				} else if ((INTEGER)n->subcl == 20) {
					DevCPH_UseReals(n->left, opts & ~0x010000 | 0x020000);
				} else {
					DevCPH_UseReals(n->left, opts & ~0x030000);
				}
				break;
			case 12: 
				if (__IN(1, opts) && (INTEGER)n->left->typ->form == 18) {
					DevCPH_UseReals(n->left, opts & ~0x020000 | 0x010000);
					DevCPH_UseReals(n->right, opts & ~0x020000 | 0x010000);
					if ((INTEGER)n->typ->form == 18) {
						n->typ = DevCPT_intrealtyp;
					}
				} else {
					DevCPH_UseReals(n->left, opts & ~0x030000);
					DevCPH_UseReals(n->right, opts & ~0x030000);
				}
				break;
			case 21: 
				DevCPH_UseReals(n->left, opts & ~0x030000);
				DevCPH_UseReals(n->right->left, opts & ~0x030000);
				DevCPH_UseReals(n->right->right, opts & ~0x030000);
				break;
			case 17: 
				DevCPH_UseReals(n->right, opts & ~0x030000);
				break;
			case 2: case 3: case 5: case 24: case 26: 
			case 50: case 52: 
				DevCPH_UseReals(n->left, opts & ~0x030000);
				break;
			case 4: case 10: case 13: case 15: case 18: 
			case 19: case 20: case 22: case 23: case 27: 
			case 30: 
				DevCPH_UseReals(n->left, opts & ~0x030000);
				DevCPH_UseReals(n->right, opts & ~0x030000);
				break;
			case 0: case 1: case 7: case 8: case 9: 
			case 14: case 25: case 28: case 51: case 53: 
			case 54: 
				break;
			default: __CASECHK;
		}
		if (__IN(16, opts)) {
			DevCPH_Convert(n, DevCPT_intrealtyp);
		} else if (!__IN(17, opts) && n->typ == DevCPT_intrealtyp) {
			DevCPH_Convert(n, DevCPT_int64typ);
		}
		n = n->link;
	}
	__EXIT;
}

static SYSTEM_MODDESC *DevCPH__imp[] = {
	&DevCPT__desc,
};
static INTEGER DevCPH__exp[] = {
	20,
	0x227d6f36, (INTEGER)DevCPH_Convert, 1<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPH_UseCallForAssign, 9<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPH_UseCallForComp, 26<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPH_UseCallForConv, 41<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPH_UseCallForDop, 56<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPH_UseCallForMop, 70<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPH_UseCallForMove, 84<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPH_UseCallForParam, 99<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPH_UseCallForReturn, 115<<8 | 0x14, 0,
	0x75a5e142, (INTEGER)DevCPH_UseCalls, 132<<8 | 0x44, 0,
	0x75a5e142, (INTEGER)DevCPH_UseReals, 141<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPH_UseThisCall, 150<<8 | 0x14, 0,
	0x7d06cf3b, 0, 162<<8 | 0x41, 0,
	0x5fcf3f34, 0, 172<<8 | 0x41, 0,
	0x528c19ed, 0, 181<<8 | 0x41, 0,
	0x564d045a, 0, 189<<8 | 0x41, 0,
	0x5b0e2283, 0, 197<<8 | 0x41, 0,
	0x79c7d28c, 0, 205<<8 | 0x41, 0,
	0x7484f455, 0, 214<<8 | 0x41, 0,
	0x7045e9e2, 0, 222<<8 | 0x41, 0,
};
static char DevCPH__names[] = {
	0,
	'C','o','n','v','e','r','t',0,
	'U','s','e','C','a','l','l','F','o','r','A','s','s','i','g','n',0,
	'U','s','e','C','a','l','l','F','o','r','C','o','m','p',0,
	'U','s','e','C','a','l','l','F','o','r','C','o','n','v',0,
	'U','s','e','C','a','l','l','F','o','r','D','o','p',0,
	'U','s','e','C','a','l','l','F','o','r','M','o','p',0,
	'U','s','e','C','a','l','l','F','o','r','M','o','v','e',0,
	'U','s','e','C','a','l','l','F','o','r','P','a','r','a','m',0,
	'U','s','e','C','a','l','l','F','o','r','R','e','t','u','r','n',0,
	'U','s','e','C','a','l','l','s',0,
	'U','s','e','R','e','a','l','s',0,
	'U','s','e','T','h','i','s','C','a','l','l',0,
	'i','n','t','M','u','l','D','i','v',0,
	'l','o','n','g','C','o','n','v',0,
	'l','o','n','g','D','o','p',0,
	'l','o','n','g','M','o','p',0,
	'l','o','n','g','O','d','d',0,
	'r','e','a','l','C','o','n','v',0,
	'r','e','a','l','D','o','p',0,
	'r','e','a','l','M','o','p',0,
};
static INTEGER DevCPH__ptrs[] = {
	0
};
struct SYSTEM_MODDESC DevCPH__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 12}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	DevCPH__body,
	0,
	1, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	DevCPH__names,
	DevCPH__ptrs,
	DevCPH__imp,
	(SYSTEM_DIRECTORY*)DevCPH__exp,
	"DevCPH"
};

export void DevCPH__reg()
{
	__BEGREG(DevCPH__desc);
	DevCPT__reg();
	__REGMOD(DevCPH__desc);
	__ENDREG;
}

export void DevCPH__body()
{
	__BEGBODY(DevCPH__desc);
	DevCPT__body();
	__ENDBODY;
}
