/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"
#include "Files.h"
#include "Console.h"
#include "Strings.h"

typedef
	struct DevCPM_Directory__rec *DevCPM_Directory;

typedef
	struct DevCPM_Directory__rec {
		Files_Name path;
		BOOLEAN legacy;
		DevCPM_Directory next;
	} DevCPM_Directory__rec;


export BOOLEAN DevCPM_LEHost;
export REAL DevCPM_MinReal32, DevCPM_MaxReal32, DevCPM_InfReal, DevCPM_MinReal64, DevCPM_MaxReal64;
export BOOLEAN DevCPM_noerr;
export INTEGER DevCPM_curpos, DevCPM_startpos, DevCPM_errpos, DevCPM_searchpos, DevCPM_errors, DevCPM_breakpc;
export SET DevCPM_options;
export Files_File DevCPM_file;
export BOOLEAN DevCPM_legacy;
export DevCPM_Directory DevCPM_symList;
export Files_Name DevCPM_codePath, DevCPM_symPath;
export CHAR DevCPM_codeDir[16];
export CHAR DevCPM_symDir[16];
export Files_Name DevCPM_name;
export INTEGER DevCPM_checksum, DevCPM_verbose;
static INTEGER DevCPM_lastpos;
static Files_Name DevCPM_ObjFName;
static struct CHAR_ARRAY *DevCPM_in;
static Files_File DevCPM_oldSymFile, DevCPM_symFile, DevCPM_objFile;
static Files_Reader DevCPM_inSym;
static Files_Writer DevCPM_outSym, DevCPM_outObj;
static INTEGER DevCPM_errNo[64], DevCPM_errPos[64];
static INTEGER DevCPM_crc32tab[256];

export INTEGER DevCPM_Directory__rec__desc[];
export SYSTEM_TYPEDESC *DevCPM_Directory__rec__typ = (SYSTEM_TYPEDESC*)(DevCPM_Directory__rec__desc + \
2);
export INTEGER DevCPM_Directory__desc[];
export SYSTEM_TYPEDESC *DevCPM_Directory__typ = (SYSTEM_TYPEDESC*)DevCPM_Directory__desc;
export INTEGER DevCPM__1__desc[];
export SYSTEM_TYPEDESC *DevCPM__1__typ = (SYSTEM_TYPEDESC*)DevCPM__1__desc;
export INTEGER DevCPM__6__desc[];
export SYSTEM_TYPEDESC *DevCPM__6__typ = (SYSTEM_TYPEDESC*)DevCPM__6__desc;

static void DevCPM_ChkSum (INTEGER *fp, INTEGER val);
export void DevCPM_Close (void);
export void DevCPM_CloseOldSym (void);
static REAL DevCPM_Compound (INTEGER lo, INTEGER hi);
export void DevCPM_DeleteNewSym (void);
export void DevCPM_DeleteObj (void);
export void DevCPM_FPrint (INTEGER *fp, INTEGER val);
export void DevCPM_FPrintLReal (INTEGER *fp, REAL lr);
export void DevCPM_FPrintReal (INTEGER *fp, SHORTREAL real);
export void DevCPM_FPrintSet (INTEGER *fp, SET set);
export void DevCPM_Get (CHAR *ch);
export void DevCPM_GetArraySysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag);
static void DevCPM_GetErrorMsg (INTEGER err, CHAR *msg, INTEGER msg__len);
export void DevCPM_GetPointerSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag);
export void DevCPM_GetProcSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag);
export void DevCPM_GetProcTypSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag);
export void DevCPM_GetRecordSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag);
export void DevCPM_GetUtf8 (SHORTCHAR *str, INTEGER str__len, INTEGER *val, INTEGER *idx);
export void DevCPM_GetVarParSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag);
static INTEGER DevCPM_HiWord (REAL r);
export void DevCPM_Init (struct CHAR_ARRAY *source);
static void DevCPM_InitCrcTab (void);
static void DevCPM_InitHost (void);
export void DevCPM_InsertMarks (void);
static void DevCPM_LineColOf (INTEGER pos, INTEGER *line, INTEGER *col, INTEGER *beg, INTEGER *end);
export INTEGER DevCPM_LineOf (INTEGER pos);
static INTEGER DevCPM_LoWord (REAL r);
export void DevCPM_LogW (CHAR ch);
export void DevCPM_LogWLn (void);
export void DevCPM_LogWNum (INTEGER i, INTEGER len);
export void DevCPM_LogWPar (CHAR *key, INTEGER key__len, SHORTCHAR *p0, INTEGER p0__len, SHORTCHAR *p1, \
INTEGER p1__len);
export void DevCPM_LogWStr (CHAR *s, INTEGER s__len);
export void DevCPM_Mark (INTEGER n, INTEGER pos);
export void DevCPM_NewObj (SHORTCHAR *modName, INTEGER modName__len);
export void DevCPM_NewSym (SHORTCHAR *modName, INTEGER modName__len);
export INTEGER DevCPM_ObjLen (void);
export void DevCPM_ObjSet (INTEGER pos);
export void DevCPM_ObjW (SHORTCHAR ch);
export void DevCPM_ObjWBytes (SHORTCHAR *bytes, INTEGER bytes__len, INTEGER n);
static void DevCPM_ObjWInt (SHORTINT i);
export void DevCPM_ObjWLInt (INTEGER i);
export void DevCPM_ObjWNum (INTEGER i);
export void DevCPM_OldSym (SHORTCHAR *modName, INTEGER modName__len, BOOLEAN *done);
export void DevCPM_PropagateArrPtrSysFlag (SHORTINT baseFlag, SHORTINT *flag);
export void DevCPM_PropagateRecPtrSysFlag (SHORTINT baseFlag, SHORTINT *flag);
export void DevCPM_PropagateRecordSysFlag (SHORTINT baseFlag, SHORTINT *flag);
export void DevCPM_PutUtf8 (SHORTCHAR *str, INTEGER str__len, INTEGER val, INTEGER *idx);
static void DevCPM_ReadLInt (Files_Reader r, INTEGER *i);
static void DevCPM_ReadLReal (Files_Reader r, REAL *x);
static void DevCPM_ReadNum (Files_Reader r, INTEGER *i);
static void DevCPM_ReadNumSet (Files_Reader r, SET *x);
static void DevCPM_ReadReal (Files_Reader r, SHORTREAL *x);
export void DevCPM_RegisterNewSym (void);
export void DevCPM_RegisterObj (void);
export void DevCPM_SymRCh (SHORTCHAR *ch);
export INTEGER DevCPM_SymRInt (void);
export void DevCPM_SymRLReal (REAL *lr);
export void DevCPM_SymRReal (SHORTREAL *r);
export void DevCPM_SymRSet (SET *s);
export void DevCPM_SymReset (void);
export void DevCPM_SymWCh (SHORTCHAR ch);
export void DevCPM_SymWInt (INTEGER i);
export void DevCPM_SymWLReal (REAL r);
export void DevCPM_SymWReal (SHORTREAL r);
export void DevCPM_SymWSet (SET s);
export BOOLEAN DevCPM_ValidGuid (SHORTCHAR *str, INTEGER str__len);
static void DevCPM_WriteLInt (Files_Writer w, INTEGER i);
static void DevCPM_WriteLReal (Files_Writer w, REAL x);
static void DevCPM_WriteNum (Files_Writer w, INTEGER i);
static void DevCPM_WriteNumSet (Files_Writer w, SET x);
static void DevCPM_WriteReal (Files_Writer w, SHORTREAL x);
export BOOLEAN DevCPM_eofSF (void);
export void DevCPM_err (INTEGER n);

export void DevCPM__reg();
export void DevCPM__body();
export struct SYSTEM_MODDESC DevCPM__desc;


void DevCPM_Init (struct CHAR_ARRAY *source)
{
	__ENTER("DevCPM.Init");
	DevCPM_in = source;
	DevCPM_noerr = 1;
	DevCPM_options = 0x0;
	DevCPM_curpos = 0;
	DevCPM_errpos = DevCPM_curpos;
	DevCPM_lastpos = DevCPM_curpos - 11;
	DevCPM_errors = 0;
	DevCPM_codePath[0] = 0;
	DevCPM_symPath[0] = 0;
	DevCPM_name[0] = 0;
	__MOVE(((CHAR[]){67, 111, 100, 101, 0}), DevCPM_codeDir, 10);
	__MOVE(((CHAR[]){83, 121, 109, 0}), DevCPM_symDir, 8);
	__EXIT;
}

void DevCPM_Close (void)
{
	__ENTER("DevCPM.Close");
	DevCPM_oldSymFile = NIL;
	DevCPM_inSym = NIL;
	DevCPM_symFile = NIL;
	DevCPM_outSym = NIL;
	DevCPM_objFile = NIL;
	DevCPM_outObj = NIL;
	DevCPM_in = NIL;
	__EXIT;
}

void DevCPM_Get (CHAR *ch)
{
	__ENTER("DevCPM.Get");
	*ch = (DevCPM_in->data)[__X(DevCPM_curpos, DevCPM_in->len[0])];
	DevCPM_curpos += 1;
	__EXIT;
}

static void DevCPM_LineColOf (INTEGER pos, INTEGER *line, INTEGER *col, INTEGER *beg, INTEGER *end)
{
	INTEGER i;
	__ENTER("DevCPM.LineColOf");
	i = 0;
	*line = 1;
	*col = 1;
	*beg = 0;
	*end = 0;
	while (i < pos) {
		if ((DevCPM_in->data)[__X(i, DevCPM_in->len[0])] == 13) {
			i += 1;
			if ((DevCPM_in->data)[__X(i, DevCPM_in->len[0])] == 10) {
				i += 1;
			}
			*line += 1;
			*beg = i;
			*col = 1;
		} else if ((DevCPM_in->data)[__X(i, DevCPM_in->len[0])] == 10) {
			i += 1;
			*line += 1;
			*beg = i;
			*col = 1;
		} else if ((DevCPM_in->data)[__X(i, DevCPM_in->len[0])] == 9) {
			i += 1;
			*col += 2;
		} else {
			i += 1;
			*col += 1;
		}
	}
	while (((DevCPM_in->data)[__X(i, DevCPM_in->len[0])] != 13 && (DevCPM_in->data)[__X(i, DevCPM_in->len[0])] \
!= 10) && (DevCPM_in->data)[__X(i, DevCPM_in->len[0])] != 0) {
		i += 1;
	}
	*end = i - 1;
	__EXIT;
}

INTEGER DevCPM_LineOf (INTEGER pos)
{
	INTEGER line, col, beg, end;
	__ENTER("DevCPM.LineOf");
	DevCPM_LineColOf(pos, &line, &col, &beg, &end);
	__EXIT;
	return line;
}

static INTEGER DevCPM_LoWord (REAL r)
{
	INTEGER x;
	__ENTER("DevCPM.LoWord");
	x = (INTEGER)&r;
	if (!DevCPM_LEHost) {
		x += 4;
	}
	__GET(x, x, INTEGER);
	__EXIT;
	return x;
}

static INTEGER DevCPM_HiWord (REAL r)
{
	INTEGER x;
	__ENTER("DevCPM.HiWord");
	x = (INTEGER)&r;
	if (DevCPM_LEHost) {
		x += 4;
	}
	__GET(x, x, INTEGER);
	__EXIT;
	return x;
}

static REAL DevCPM_Compound (INTEGER lo, INTEGER hi)
{
	REAL r;
	__ENTER("DevCPM.Compound");
	if (DevCPM_LEHost) {
		__PUT((INTEGER)&r, lo, INTEGER);
		__PUT((INTEGER)&r + 4, hi, INTEGER);
	} else {
		__PUT((INTEGER)&r + 4, lo, INTEGER);
		__PUT((INTEGER)&r, hi, INTEGER);
	}
	__EXIT;
	return r;
}

BOOLEAN DevCPM_ValidGuid (SHORTCHAR *str, INTEGER str__len)
{
	INTEGER i;
	SHORTCHAR ch;
	__ENTER("DevCPM.ValidGuid");
	if (__STRLENS(str) != 38 || str[0] != (SHORTCHAR)'{' && str[__X(37, str__len)] != (SHORTCHAR)'}') {
		__EXIT;
		return 0;
	}
	i = 1;
	while (i < 37) {
		ch = str[__X(i, str__len)];
		if (((i == 9 || i == 14) || i == 19) || i == 24) {
			if (ch != (SHORTCHAR)'-') {
				__EXIT;
				return 0;
			}
		} else {
			if ((ch < (SHORTCHAR)'0' || ch > (SHORTCHAR)'9' && __CAP(ch) < (SHORTCHAR)'A') || __CAP(ch) > (SHORTCHAR)'Z') \
{
				__EXIT;
				return 0;
			}
		}
		i += 1;
	}
	__EXIT;
	return 1;
}

void DevCPM_GetProcSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag)
{
	__ENTER("DevCPM.GetProcSysFlag");
	if (id[0] != 0) {
		if (__STRCMPSS(id, "code") == 0) {
			num = 1;
		} else if (__STRCMPSS(id, "callback") == 0) {
			num = 2;
		} else if (__STRCMPSS(id, "nostkchk") == 0) {
			num = 4;
		} else if (__STRCMPSS(id, "ccall") == 0) {
			num = -10;
		} else if (__STRCMPSS(id, "ccall16") == 0) {
			num = -12;
		} else if (__STRCMPSS(id, "guarded") == 0) {
			num = 8;
		} else if (__STRCMPSS(id, "noframe") == 0) {
			num = 16;
		} else if (__STRCMPSS(id, "native") == 0) {
			num = -33;
		} else if (__STRCMPSS(id, "bytecode") == 0) {
			num = -35;
		}
	}
	if ((DevCPM_options & 0x108400) != 0x0 && ((INTEGER)num == 1 || (INTEGER)num == 2)) {
		*flag += num;
	} else if (__IN(20, DevCPM_options) && (INTEGER)num == 4) {
		*flag += num;
	} else if (((DevCPM_options & 0x0402) != 0x0 && (INTEGER)num == -10) && (INTEGER)*flag == 0) {
		*flag = -10;
	} else if (((DevCPM_options & 0x0402) != 0x0 && (INTEGER)num == -12) && (INTEGER)*flag == 0) {
		*flag = -12;
	} else if (((DevCPM_options & 0x0404) != 0x0 && (INTEGER)num == 8) && (INTEGER)*flag == 0) {
		*flag = 8;
	} else if (((DevCPM_options & 0x8400) != 0x0 && (INTEGER)num == 16) && (INTEGER)*flag == 0) {
		*flag = 16;
	} else if (((0x8080 & ~DevCPM_options) == 0x0 && ((INTEGER)num == -33 || (INTEGER)num == -35)) && (INTEGER)*flag \
== 0) {
		*flag = num;
	} else {
		DevCPM_err(225);
		*flag = 0;
	}
	__EXIT;
}

void DevCPM_GetVarParSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag)
{
	SHORTINT old;
	__ENTER("DevCPM.GetVarParSysFlag");
	old = *flag;
	*flag = 0;
	if ((DevCPM_options & 0x100406) != 0x0) {
		if ((INTEGER)num == 1 || __STRCMPSS(id, "nil") == 0) {
			if (!__ODD(old)) {
				*flag = (SHORTINT)((INTEGER)old + 1);
			}
		} else if (((INTEGER)num == 2 || __STRCMPSS(id, "in") == 0) && __IN(6, DevCPM_options)) {
			if ((INTEGER)old <= 1) {
				*flag = (SHORTINT)((INTEGER)old + 2);
			}
		} else if (((INTEGER)num == 4 || __STRCMPSS(id, "out") == 0) && __IN(6, DevCPM_options)) {
			if ((INTEGER)old <= 1) {
				*flag = (SHORTINT)((INTEGER)old + 4);
			}
		} else if (((INTEGER)num == 8 || __STRCMPSS(id, "new") == 0) && (DevCPM_options & 0x06) != 0x0) {
			if ((INTEGER)old <= 1) {
				*flag = (SHORTINT)((INTEGER)old + 8);
			}
		} else if (((INTEGER)num == 16 || __STRCMPSS(id, "iid") == 0) && __IN(2, DevCPM_options)) {
			if ((INTEGER)old <= 1) {
				*flag = (SHORTINT)((INTEGER)old + 16);
			}
		}
	}
	if ((INTEGER)*flag == 0) {
		DevCPM_err(225);
	}
	__EXIT;
}

void DevCPM_GetRecordSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag)
{
	SHORTINT old;
	__ENTER("DevCPM.GetRecordSysFlag");
	old = *flag;
	*flag = 0;
	if ((INTEGER)num == 1 || __STRCMPSS(id, "untagged") == 0) {
		if ((DevCPM_options & 0x108416) != 0x0 && (INTEGER)old == 0) {
			*flag = 1;
		}
	} else if ((INTEGER)num == 3 || __STRCMPSS(id, "noalign") == 0) {
		if ((DevCPM_options & 0x100416) != 0x0 && (INTEGER)old == 0) {
			*flag = 3;
		}
	} else if ((INTEGER)num == 4 || __STRCMPSS(id, "align2") == 0) {
		if ((DevCPM_options & 0x0406) != 0x0 && (INTEGER)old == 0) {
			*flag = 4;
		}
	} else if ((INTEGER)num == 5 || __STRCMPSS(id, "align4") == 0) {
		if ((DevCPM_options & 0x0406) != 0x0 && (INTEGER)old == 0) {
			*flag = 5;
		}
	} else if ((INTEGER)num == 6 || __STRCMPSS(id, "align8") == 0) {
		if ((DevCPM_options & 0x0406) != 0x0 && (INTEGER)old == 0) {
			*flag = 6;
		}
	} else if ((INTEGER)num == 7 || __STRCMPSS(id, "union") == 0) {
		if ((DevCPM_options & 0x100406) != 0x0 && (INTEGER)old == 0) {
			*flag = 7;
		}
	} else if (((INTEGER)num == 10 || __STRCMPSS(id, "interface") == 0) || DevCPM_ValidGuid((void*)id, id__len)) \
{
		if (__IN(2, DevCPM_options) && (INTEGER)old == 0) {
			*flag = 10;
		}
	} else if ((INTEGER)num == -11 || __STRCMPSS(id, "jint") == 0) {
		if (__IN(7, DevCPM_options) && (INTEGER)old == 0) {
			*flag = -11;
		}
	} else if ((INTEGER)num == -13 || __STRCMPSS(id, "jstr") == 0) {
		if (__IN(7, DevCPM_options) && (INTEGER)old == 0) {
			*flag = -13;
		}
	} else if ((INTEGER)num == 20 || __STRCMPSS(id, "som") == 0) {
		if (__IN(4, DevCPM_options) && (INTEGER)old == 0) {
			*flag = 20;
		}
	}
	if ((INTEGER)*flag == 0) {
		DevCPM_err(225);
	}
	__EXIT;
}

void DevCPM_GetArraySysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag)
{
	SHORTINT old;
	__ENTER("DevCPM.GetArraySysFlag");
	old = *flag;
	*flag = 0;
	if ((INTEGER)num == 1 || __STRCMPSS(id, "untagged") == 0) {
		if ((DevCPM_options & 0x108416) != 0x0 && (INTEGER)old == 0) {
			*flag = 1;
		}
	} else if ((INTEGER)num == -12 || __STRCMPSS(id, "jarr") == 0) {
		if (__IN(7, DevCPM_options) && (INTEGER)old == 0) {
			*flag = -12;
		}
	} else if ((INTEGER)num == -13 || __STRCMPSS(id, "jstr") == 0) {
		if (__IN(7, DevCPM_options) && (INTEGER)old == 0) {
			*flag = -13;
		}
	}
	if ((INTEGER)*flag == 0) {
		DevCPM_err(225);
	}
	__EXIT;
}

void DevCPM_GetPointerSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag)
{
	SHORTINT old;
	__ENTER("DevCPM.GetPointerSysFlag");
	old = *flag;
	*flag = 0;
	if ((INTEGER)num == 1 || __STRCMPSS(id, "untagged") == 0) {
		if ((DevCPM_options & 0x100416) != 0x0 && (INTEGER)old == 0) {
			*flag = 1;
		}
	} else if ((INTEGER)num == 2 || __STRCMPSS(id, "handle") == 0) {
		if (__IN(20, DevCPM_options) && (INTEGER)old == 0) {
			*flag = 2;
		}
	} else if ((INTEGER)num == 10 || __STRCMPSS(id, "interface") == 0) {
		if (__IN(2, DevCPM_options) && (INTEGER)old == 0) {
			*flag = 10;
		}
	} else if ((INTEGER)num == 20 || __STRCMPSS(id, "som") == 0) {
		if (__IN(4, DevCPM_options) && (INTEGER)old == 0) {
			*flag = 20;
		}
	}
	if ((INTEGER)*flag == 0) {
		DevCPM_err(225);
	}
	__EXIT;
}

void DevCPM_GetProcTypSysFlag (SHORTCHAR *id, INTEGER id__len, SHORTINT num, SHORTINT *flag)
{
	__ENTER("DevCPM.GetProcTypSysFlag");
	if (((INTEGER)num == -10 || __STRCMPSS(id, "ccall") == 0) && (DevCPM_options & 0x0402) != 0x0) {
		*flag = -10;
	} else if (((INTEGER)num == -12 || __STRCMPSS(id, "ccall16") == 0) && (DevCPM_options & 0x0402) != 0x0) \
{
		*flag = -12;
	} else {
		DevCPM_err(225);
		*flag = 0;
	}
	__EXIT;
}

void DevCPM_PropagateRecordSysFlag (SHORTINT baseFlag, SHORTINT *flag)
{
	__ENTER("DevCPM.PropagateRecordSysFlag");
	if ((INTEGER)baseFlag == 1 || (INTEGER)baseFlag >= 3 && (INTEGER)baseFlag <= 7) {
		if ((INTEGER)*flag == 0) {
			*flag = baseFlag;
		} else if ((INTEGER)*flag == 6 && (INTEGER)baseFlag < 6) {
		} else if ((INTEGER)*flag != (INTEGER)baseFlag) {
			DevCPM_err(225);
			*flag = 0;
		}
	} else if ((INTEGER)baseFlag != 10 && (INTEGER)*flag == 10) {
		DevCPM_err(225);
	}
	__EXIT;
}

void DevCPM_PropagateRecPtrSysFlag (SHORTINT baseFlag, SHORTINT *flag)
{
	__ENTER("DevCPM.PropagateRecPtrSysFlag");
	if ((INTEGER)baseFlag == 1 || (INTEGER)baseFlag >= 3 && (INTEGER)baseFlag <= 7) {
		if ((INTEGER)*flag == 0) {
			*flag = 1;
		} else if ((INTEGER)*flag != 1 && (INTEGER)*flag != 2) {
			DevCPM_err(225);
			*flag = 0;
		}
	} else if ((INTEGER)baseFlag == 10) {
		if ((INTEGER)*flag == 0) {
			*flag = 10;
		} else if ((INTEGER)*flag != 10) {
			DevCPM_err(225);
			*flag = 0;
		}
	} else if ((INTEGER)baseFlag == -11) {
		if ((INTEGER)*flag != 0) {
			DevCPM_err(225);
		}
		*flag = -11;
	} else if ((INTEGER)baseFlag == -13) {
		if ((INTEGER)*flag != 0) {
			DevCPM_err(225);
		}
		*flag = -13;
	}
	__EXIT;
}

void DevCPM_PropagateArrPtrSysFlag (SHORTINT baseFlag, SHORTINT *flag)
{
	__ENTER("DevCPM.PropagateArrPtrSysFlag");
	if ((INTEGER)baseFlag == 1) {
		if ((INTEGER)*flag == 0) {
			*flag = 1;
		} else if ((INTEGER)*flag != 1 && (INTEGER)*flag != 2) {
			DevCPM_err(225);
			*flag = 0;
		}
	} else if ((INTEGER)baseFlag == -12) {
		if ((INTEGER)*flag != 0) {
			DevCPM_err(225);
		}
		*flag = -12;
	} else if ((INTEGER)baseFlag == -13) {
		if ((INTEGER)*flag != 0) {
			DevCPM_err(225);
		}
		*flag = -13;
	}
	__EXIT;
}

void DevCPM_PutUtf8 (SHORTCHAR *str, INTEGER str__len, INTEGER val, INTEGER *idx)
{
	__ENTER("DevCPM.PutUtf8");
	__ASSERT(val >= 0 && val < 65536, 0);
	if (val < 128) {
		str[__X(*idx, str__len)] = (SHORTCHAR)val;
		*idx += 1;
	} else if (val < 2048) {
		str[__X(*idx, str__len)] = (SHORTCHAR)(__ASHR(val, 6, INTEGER) + 192);
		*idx += 1;
		str[__X(*idx, str__len)] = (SHORTCHAR)(__MASK(val, -64) + 128);
		*idx += 1;
	} else {
		str[__X(*idx, str__len)] = (SHORTCHAR)(__ASHR(val, 12, INTEGER) + 224);
		*idx += 1;
		str[__X(*idx, str__len)] = (SHORTCHAR)(__MASK(__ASHR(val, 6, INTEGER), -64) + 128);
		*idx += 1;
		str[__X(*idx, str__len)] = (SHORTCHAR)(__MASK(val, -64) + 128);
		*idx += 1;
	}
	__EXIT;
}

void DevCPM_GetUtf8 (SHORTCHAR *str, INTEGER str__len, INTEGER *val, INTEGER *idx)
{
	SHORTCHAR ch;
	__ENTER("DevCPM.GetUtf8");
	ch = str[__X(*idx, str__len)];
	*idx += 1;
	if (ch < 128) {
		*val = (SHORTINT)ch;
	} else if (ch < 224) {
		*val = (INTEGER)ch - 192;
		ch = str[__X(*idx, str__len)];
		*idx += 1;
		*val = (__ASHL(*val, 6, INTEGER) + (INTEGER)ch) - 128;
	} else {
		*val = (INTEGER)ch - 224;
		ch = str[__X(*idx, str__len)];
		*idx += 1;
		*val = (__ASHL(*val, 6, INTEGER) + (INTEGER)ch) - 128;
		ch = str[__X(*idx, str__len)];
		*idx += 1;
		*val = (__ASHL(*val, 6, INTEGER) + (INTEGER)ch) - 128;
	}
	__EXIT;
}

void DevCPM_LogW (CHAR ch)
{
	__ENTER("DevCPM.LogW");
	Console_WriteChar(ch);
	__EXIT;
}

void DevCPM_LogWStr (CHAR *s, INTEGER s__len)
{
	__ENTER("DevCPM.LogWStr");
	Console_WriteStr((void*)s, s__len);
	__EXIT;
}

void DevCPM_LogWPar (CHAR *key, INTEGER key__len, SHORTCHAR *p0, INTEGER p0__len, SHORTCHAR *p1, INTEGER \
p1__len)
{
	CHAR s[256], s0[256], s1[256];
	INTEGER i, res;
	__ENTER("DevCPM.LogWPar");
	Kernel_Utf8ToString((void*)p0, p0__len, (void*)s0, 256, &res);
	Kernel_Utf8ToString((void*)p1, p1__len, (void*)s1, 256, &res);
	if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 78, 111, 116, 73, 109, 112, 108, 101, 109, 101, 110, \
116, 101, 100, 73, 110, 0})) == 0) {
		__MOVE(((CHAR[]){94, 48, 32, 110, 111, 116, 32, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, \
32, 105, 110, 32, 94, 49, 0}), s, 50);
	} else if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 78, 111, 116, 73, 109, 112, 108, 101, 109, \
101, 110, 116, 101, 100, 0})) == 0) {
		__MOVE(((CHAR[]){94, 48, 32, 110, 111, 116, 32, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, \
0}), s, 38);
	} else if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 73, 110, 99, 111, 110, 115, 105, 115, 116, \
101, 110, 116, 73, 109, 112, 111, 114, 116, 0})) == 0) {
		__MOVE(((CHAR[]){94, 48, 46, 94, 49, 32, 105, 115, 32, 110, 111, 116, 32, 99, 111, 110, 115, 105, 115, \
116, 101, 110, 116, 108, 121, 32, 105, 109, 112, 111, 114, 116, 101, 100, 0}), s, 70);
	} else if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 67, 104, 97, 110, 103, 101, 100, 76, 105, \
98, 70, 108, 97, 103, 0})) == 0) {
		__MOVE(((CHAR[]){99, 104, 97, 110, 103, 101, 100, 32, 108, 105, 98, 114, 97, 114, 121, 32, 102, 108, \
97, 103, 0}), s, 42);
	} else if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 73, 115, 78, 111, 76, 111, 110, 103, 101, \
114, 73, 110, 83, 121, 109, 70, 105, 108, 101, 0})) == 0) {
		__MOVE(((CHAR[]){94, 48, 32, 105, 115, 32, 110, 111, 32, 108, 111, 110, 103, 101, 114, 32, 105, 110, \
32, 115, 121, 109, 98, 111, 108, 32, 102, 105, 108, 101, 0}), s, 62);
	} else if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 73, 115, 82, 101, 100, 101, 102, 105, 110, \
101, 100, 73, 110, 116, 101, 114, 110, 97, 108, 108, 121, 0})) == 0) {
		__MOVE(((CHAR[]){94, 48, 32, 105, 115, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 32, 105, 110, \
116, 101, 114, 110, 97, 108, 108, 121, 0}), s, 54);
	} else if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 73, 115, 82, 101, 100, 101, 102, 105, 110, \
101, 100, 0})) == 0) {
		__MOVE(((CHAR[]){94, 48, 32, 105, 115, 32, 114, 101, 100, 101, 102, 105, 110, 101, 100, 0}), s, 32);
	} else if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 73, 115, 78, 101, 119, 73, 110, 83, 121, 109, \
70, 105, 108, 101, 0})) == 0) {
		__MOVE(((CHAR[]){94, 48, 32, 105, 115, 32, 110, 101, 119, 32, 105, 110, 32, 115, 121, 109, 98, 111, \
108, 32, 102, 105, 108, 101, 0}), s, 50);
	} else if (__STRCMPLL(key, ((CHAR[]){35, 68, 101, 118, 58, 78, 101, 119, 83, 121, 109, 70, 105, 108, \
101, 0})) == 0) {
		__MOVE(((CHAR[]){110, 101, 119, 32, 115, 121, 109, 98, 111, 108, 32, 102, 105, 108, 101, 0}), s, 32);
	} else {
		__STRCOPYLL(key, s, 256);
	}
	i = 0;
	while (s[__X(i, 256)] != 0) {
		if (s[__X(i, 256)] == (CHAR)L'^') {
			switch (s[__X(i + 1, 256)]) {
				case (CHAR)'0': 
					Console_WriteStr((void*)s0, 256);
					break;
				case (CHAR)'1': 
					Console_WriteStr((void*)s1, 256);
					break;
				case (CHAR)'2': 
					break;
				default: 
					Console_WriteChar((CHAR)L'^');
					break;
			}
			i += 2;
		} else {
			Console_WriteChar(s[__X(i, 256)]);
			i += 1;
		}
	}
	__EXIT;
}

void DevCPM_LogWNum (INTEGER i, INTEGER len)
{
	CHAR s[32];
	__ENTER("DevCPM.LogWNum");
	Strings_IntToStringForm(i, 10, len, (CHAR)L' ', 0, (void*)s, 32);
	Console_WriteStr((void*)s, 32);
	__EXIT;
}

void DevCPM_LogWLn (void)
{
	__ENTER("DevCPM.LogWLn");
	Console_WriteLn();
	__EXIT;
}

void DevCPM_Mark (INTEGER n, INTEGER pos)
{
	__ENTER("DevCPM.Mark");
	if (n >= 0 && !((__IN(6, DevCPM_options) && n >= 181) && n <= 190)) {
		DevCPM_noerr = 0;
		if (pos < 0) {
			pos = 0;
		}
		if (pos < DevCPM_lastpos || DevCPM_lastpos + 9 < pos) {
			DevCPM_lastpos = pos;
			if (DevCPM_errors < 64) {
				DevCPM_errNo[__X(DevCPM_errors, 64)] = n;
				DevCPM_errPos[__X(DevCPM_errors, 64)] = pos;
			}
			DevCPM_errors += 1;
		}
		if (__IN(31, DevCPM_options)) {
			__HALT(100);
		}
	} else if (n <= -700 && DevCPM_errors < 64) {
		DevCPM_errNo[__X(DevCPM_errors, 64)] = -n;
		DevCPM_errPos[__X(DevCPM_errors, 64)] = pos;
		DevCPM_errors += 1;
	}
	__EXIT;
}

void DevCPM_err (INTEGER n)
{
	__ENTER("DevCPM.err");
	DevCPM_Mark(n, DevCPM_errpos);
	__EXIT;
}

static void DevCPM_GetErrorMsg (INTEGER err, CHAR *msg, INTEGER msg__len)
{
	__ENTER("DevCPM.GetErrorMsg");
	switch (err) {
		case 0: 
			__MOVE(((CHAR[]){117, 110, 100, 101, 99, 108, 97, 114, 101, 100, 32, 105, 100, 101, 110, 116, 105, \
102, 105, 101, 114, 0}), msg, 44);
			break;
		case 1: 
			__MOVE(((CHAR[]){109, 117, 108, 116, 105, 112, 108, 121, 32, 100, 101, 102, 105, 110, 101, 100, 32, \
105, 100, 101, 110, 116, 105, 102, 105, 101, 114, 0}), msg, 56);
			break;
		case 2: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, \
105, 110, 32, 110, 117, 109, 98, 101, 114, 0}), msg, 56);
			break;
		case 3: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 32, \
105, 110, 32, 115, 116, 114, 105, 110, 103, 0}), msg, 56);
			break;
		case 4: 
			__MOVE(((CHAR[]){105, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 100, 111, 101, 115, 32, 110, \
111, 116, 32, 109, 97, 116, 99, 104, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 32, 110, 97, 109, \
101, 0}), msg, 82);
			break;
		case 5: 
			__MOVE(((CHAR[]){99, 111, 109, 109, 101, 110, 116, 32, 110, 111, 116, 32, 99, 108, 111, 115, 101, 100, \
0}), msg, 38);
			break;
		case 9: 
			__MOVE(((CHAR[]){34, 61, 34, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0}), msg, 26);
			break;
		case 12: 
			__MOVE(((CHAR[]){116, 121, 112, 101, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 115, \
116, 97, 114, 116, 115, 32, 119, 105, 116, 104, 32, 105, 110, 99, 111, 114, 114, 101, 99, 116, 32, 115, \
121, 109, 98, 111, 108, 0}), msg, 90);
			break;
		case 13: 
			__MOVE(((CHAR[]){102, 97, 99, 116, 111, 114, 32, 115, 116, 97, 114, 116, 115, 32, 119, 105, 116, 104, \
32, 105, 110, 99, 111, 114, 114, 101, 99, 116, 32, 115, 121, 109, 98, 111, 108, 0}), msg, 72);
			break;
		case 14: 
			__MOVE(((CHAR[]){115, 116, 97, 116, 101, 109, 101, 110, 116, 32, 115, 116, 97, 114, 116, 115, 32, 119, \
105, 116, 104, 32, 105, 110, 99, 111, 114, 114, 101, 99, 116, 32, 115, 121, 109, 98, 111, 108, 0}), msg, \
78);
			break;
		case 15: 
			__MOVE(((CHAR[]){100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 32, 102, 111, 108, 108, 111, 119, \
101, 100, 32, 98, 121, 32, 105, 110, 99, 111, 114, 114, 101, 99, 116, 32, 115, 121, 109, 98, 111, 108, \
0}), msg, 82);
			break;
		case 16: 
			__MOVE(((CHAR[]){77, 79, 68, 85, 76, 69, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0}), msg, 32);
			break;
		case 19: 
			__MOVE(((CHAR[]){34, 46, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 20: 
			__MOVE(((CHAR[]){34, 44, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 21: 
			__MOVE(((CHAR[]){34, 58, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 23: 
			__MOVE(((CHAR[]){34, 41, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 24: 
			__MOVE(((CHAR[]){34, 93, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 25: 
			__MOVE(((CHAR[]){34, 125, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 26: 
			__MOVE(((CHAR[]){79, 70, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 22);
			break;
		case 27: 
			__MOVE(((CHAR[]){84, 72, 69, 78, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 26);
			break;
		case 28: 
			__MOVE(((CHAR[]){68, 79, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 22);
			break;
		case 29: 
			__MOVE(((CHAR[]){84, 79, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 22);
			break;
		case 35: 
			__MOVE(((CHAR[]){34, 44, 34, 32, 111, 114, 32, 79, 70, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0}), \
msg, 38);
			break;
		case 36: 
			__MOVE(((CHAR[]){67, 79, 78, 83, 84, 44, 32, 84, 89, 80, 69, 44, 32, 86, 65, 82, 44, 32, 80, 82, 79, \
67, 69, 68, 85, 82, 69, 44, 32, 66, 69, 71, 73, 78, 44, 32, 111, 114, 32, 69, 78, 68, 32, 109, 105, 115, \
115, 105, 110, 103, 0}), msg, 102);
			break;
		case 37: 
			__MOVE(((CHAR[]){80, 82, 79, 67, 69, 68, 85, 82, 69, 44, 32, 66, 69, 71, 73, 78, 44, 32, 111, 114, \
32, 69, 78, 68, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 66);
			break;
		case 38: 
			__MOVE(((CHAR[]){66, 69, 71, 73, 78, 32, 111, 114, 32, 69, 78, 68, 32, 109, 105, 115, 115, 105, 110, \
103, 0}), msg, 42);
			break;
		case 40: 
			__MOVE(((CHAR[]){34, 40, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 41: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 108, 121, 32, 109, 97, 114, 107, 101, 100, 32, 105, \
100, 101, 110, 116, 105, 102, 105, 101, 114, 0}), msg, 56);
			break;
		case 42: 
			__MOVE(((CHAR[]){99, 111, 110, 115, 116, 97, 110, 116, 32, 110, 111, 116, 32, 97, 110, 32, 105, 110, \
116, 101, 103, 101, 114, 0}), msg, 48);
			break;
		case 43: 
			__MOVE(((CHAR[]){85, 78, 84, 73, 76, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 28);
			break;
		case 44: 
			__MOVE(((CHAR[]){34, 58, 61, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 26);
			break;
		case 46: 
			__MOVE(((CHAR[]){69, 88, 73, 84, 32, 110, 111, 116, 32, 119, 105, 116, 104, 105, 110, 32, 108, 111, \
111, 112, 32, 115, 116, 97, 116, 101, 109, 101, 110, 116, 0}), msg, 62);
			break;
		case 47: 
			__MOVE(((CHAR[]){115, 116, 114, 105, 110, 103, 32, 101, 120, 112, 101, 99, 116, 101, 100, 0}), msg, \
32);
			break;
		case 48: 
			__MOVE(((CHAR[]){105, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 101, 120, 112, 101, 99, 116, \
101, 100, 0}), msg, 40);
			break;
		case 49: 
			__MOVE(((CHAR[]){34, 59, 34, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 50: 
			__MOVE(((CHAR[]){101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 115, 104, 111, 117, 108, 100, \
32, 98, 101, 32, 99, 111, 110, 115, 116, 97, 110, 116, 0}), msg, 60);
			break;
		case 51: 
			__MOVE(((CHAR[]){69, 78, 68, 32, 109, 105, 115, 115, 105, 110, 103, 0}), msg, 24);
			break;
		case 52: 
			__MOVE(((CHAR[]){105, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 100, 111, 101, 115, 32, 110, \
111, 116, 32, 100, 101, 110, 111, 116, 101, 32, 97, 32, 116, 121, 112, 101, 0}), msg, 68);
			break;
		case 53: 
			__MOVE(((CHAR[]){105, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 100, 111, 101, 115, 32, 110, \
111, 116, 32, 100, 101, 110, 111, 116, 101, 32, 97, 32, 114, 101, 99, 111, 114, 100, 32, 116, 121, 112, \
101, 0}), msg, 82);
			break;
		case 54: 
			__MOVE(((CHAR[]){114, 101, 115, 117, 108, 116, 32, 116, 121, 112, 101, 32, 111, 102, 32, 112, 114, \
111, 99, 101, 100, 117, 114, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 98, 97, 115, 105, 99, 32, \
116, 121, 112, 101, 0}), msg, 90);
			break;
		case 55: 
			__MOVE(((CHAR[]){112, 114, 111, 99, 101, 100, 117, 114, 101, 32, 99, 97, 108, 108, 32, 111, 102, 32, \
97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 0}), msg, 58);
			break;
		case 56: 
			__MOVE(((CHAR[]){97, 115, 115, 105, 103, 110, 109, 101, 110, 116, 32, 116, 111, 32, 110, 111, 110, \
45, 118, 97, 114, 105, 97, 98, 108, 101, 0}), msg, 54);
			break;
		case 57: 
			__MOVE(((CHAR[]){112, 111, 105, 110, 116, 101, 114, 32, 110, 111, 116, 32, 98, 111, 117, 110, 100, \
32, 116, 111, 32, 114, 101, 99, 111, 114, 100, 32, 111, 114, 32, 97, 114, 114, 97, 121, 32, 116, 121, \
112, 101, 0}), msg, 84);
			break;
		case 58: 
			__MOVE(((CHAR[]){114, 101, 99, 117, 114, 115, 105, 118, 101, 32, 116, 121, 112, 101, 32, 100, 101, \
102, 105, 110, 105, 116, 105, 111, 110, 0}), msg, 52);
			break;
		case 59: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 111, 112, 101, 110, 32, 97, 114, 114, 97, 121, \
32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 0}), msg, 58);
			break;
		case 60: 
			__MOVE(((CHAR[]){119, 114, 111, 110, 103, 32, 116, 121, 112, 101, 32, 111, 102, 32, 99, 97, 115, 101, \
32, 108, 97, 98, 101, 108, 0}), msg, 50);
			break;
		case 61: 
			__MOVE(((CHAR[]){105, 110, 97, 100, 109, 105, 115, 115, 105, 98, 108, 101, 32, 116, 121, 112, 101, \
32, 111, 102, 32, 99, 97, 115, 101, 32, 108, 97, 98, 101, 108, 0}), msg, 64);
			break;
		case 62: 
			__MOVE(((CHAR[]){99, 97, 115, 101, 32, 108, 97, 98, 101, 108, 32, 100, 101, 102, 105, 110, 101, 100, \
32, 109, 111, 114, 101, 32, 116, 104, 97, 110, 32, 111, 110, 99, 101, 0}), msg, 68);
			break;
		case 63: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 99, \
111, 110, 115, 116, 97, 110, 116, 0}), msg, 52);
			break;
		case 64: 
			__MOVE(((CHAR[]){109, 111, 114, 101, 32, 97, 99, 116, 117, 97, 108, 32, 116, 104, 97, 110, 32, 102, \
111, 114, 109, 97, 108, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 0}), msg, 70);
			break;
		case 65: 
			__MOVE(((CHAR[]){102, 101, 119, 101, 114, 32, 97, 99, 116, 117, 97, 108, 32, 116, 104, 97, 110, 32, \
102, 111, 114, 109, 97, 108, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 0}), msg, 72);
			break;
		case 66: 
			__MOVE(((CHAR[]){101, 108, 101, 109, 101, 110, 116, 32, 116, 121, 112, 101, 115, 32, 111, 102, 32, \
97, 99, 116, 117, 97, 108, 32, 97, 114, 114, 97, 121, 32, 97, 110, 100, 32, 102, 111, 114, 109, 97, 108, \
32, 111, 112, 101, 110, 32, 97, 114, 114, 97, 121, 32, 100, 105, 102, 102, 101, 114, 0}), msg, 118);
			break;
		case 67: 
			__MOVE(((CHAR[]){97, 99, 116, 117, 97, 108, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 99, \
111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32, 116, 111, 32, 111, 112, 101, 110, 32, \
97, 114, 114, 97, 121, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 97, 114, 114, 97, 121, 0}), msg, \
122);
			break;
		case 68: 
			__MOVE(((CHAR[]){99, 111, 110, 116, 114, 111, 108, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 109, \
117, 115, 116, 32, 98, 101, 32, 105, 110, 116, 101, 103, 101, 114, 0}), msg, 66);
			break;
		case 69: 
			__MOVE(((CHAR[]){112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 109, 117, 115, 116, 32, 98, 101, 32, \
97, 110, 32, 105, 110, 116, 101, 103, 101, 114, 32, 99, 111, 110, 115, 116, 97, 110, 116, 0}), msg, 76);
			break;
		case 70: 
			__MOVE(((CHAR[]){112, 111, 105, 110, 116, 101, 114, 32, 111, 114, 32, 86, 65, 82, 32, 47, 32, 73, 78, \
32, 114, 101, 99, 111, 114, 100, 32, 114, 101, 113, 117, 105, 114, 101, 100, 32, 97, 115, 32, 102, 111, \
114, 109, 97, 108, 32, 114, 101, 99, 101, 105, 118, 101, 114, 0}), msg, 110);
			break;
		case 71: 
			__MOVE(((CHAR[]){112, 111, 105, 110, 116, 101, 114, 32, 101, 120, 112, 101, 99, 116, 101, 100, 32, \
97, 115, 32, 97, 99, 116, 117, 97, 108, 32, 114, 101, 99, 101, 105, 118, 101, 114, 0}), msg, 72);
			break;
		case 72: 
			__MOVE(((CHAR[]){112, 114, 111, 99, 101, 100, 117, 114, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, \
98, 111, 117, 110, 100, 32, 116, 111, 32, 97, 32, 114, 101, 99, 111, 114, 100, 32, 111, 102, 32, 116, \
104, 101, 32, 115, 97, 109, 101, 32, 115, 99, 111, 112, 101, 0}), msg, 108);
			break;
		case 73: 
			__MOVE(((CHAR[]){112, 114, 111, 99, 101, 100, 117, 114, 101, 32, 109, 117, 115, 116, 32, 104, 97, 118, \
101, 32, 108, 101, 118, 101, 108, 32, 48, 0}), msg, 56);
			break;
		case 74: 
			__MOVE(((CHAR[]){112, 114, 111, 99, 101, 100, 117, 114, 101, 32, 117, 110, 107, 110, 111, 119, 110, \
32, 105, 110, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0}), msg, 62);
			break;
		case 75: 
			__MOVE(((CHAR[]){105, 110, 118, 97, 108, 105, 100, 32, 99, 97, 108, 108, 32, 111, 102, 32, 98, 97, \
115, 101, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 0}), msg, 62);
			break;
		case 76: 
			__MOVE(((CHAR[]){116, 104, 105, 115, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 40, 102, 105, 101, \
108, 100, 41, 32, 105, 115, 32, 114, 101, 97, 100, 32, 111, 110, 108, 121, 0}), msg, 70);
			break;
		case 77: 
			__MOVE(((CHAR[]){111, 98, 106, 101, 99, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 114, 101, \
99, 111, 114, 100, 0}), msg, 46);
			break;
		case 78: 
			__MOVE(((CHAR[]){100, 101, 114, 101, 102, 101, 114, 101, 110, 99, 101, 100, 32, 111, 98, 106, 101, \
99, 116, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, 97, 114, 105, 97, 98, 108, 101, 0}), msg, 76);
			break;
		case 79: 
			__MOVE(((CHAR[]){105, 110, 100, 101, 120, 101, 100, 32, 111, 98, 106, 101, 99, 116, 32, 105, 115, 32, \
110, 111, 116, 32, 97, 32, 118, 97, 114, 105, 97, 98, 108, 101, 0}), msg, 66);
			break;
		case 80: 
			__MOVE(((CHAR[]){105, 110, 100, 101, 120, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, \
105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 105, 110, 116, 101, 103, 101, 114, 0}), msg, 70);
			break;
		case 81: 
			__MOVE(((CHAR[]){105, 110, 100, 101, 120, 32, 111, 117, 116, 32, 111, 102, 32, 115, 112, 101, 99, 105, \
102, 105, 101, 100, 32, 98, 111, 117, 110, 100, 115, 0}), msg, 60);
			break;
		case 82: 
			__MOVE(((CHAR[]){105, 110, 100, 101, 120, 101, 100, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 105, \
115, 32, 110, 111, 116, 32, 97, 110, 32, 97, 114, 114, 97, 121, 0}), msg, 66);
			break;
		case 83: 
			__MOVE(((CHAR[]){117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 114, 101, 99, 111, 114, 100, 32, \
102, 105, 101, 108, 100, 0}), msg, 46);
			break;
		case 84: 
			__MOVE(((CHAR[]){100, 101, 114, 101, 102, 101, 114, 101, 110, 99, 101, 100, 32, 118, 97, 114, 105, \
97, 98, 108, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 112, 111, 105, 110, 116, 101, 114, 0}), \
msg, 78);
			break;
		case 85: 
			__MOVE(((CHAR[]){103, 117, 97, 114, 100, 32, 111, 114, 32, 116, 101, 115, 116, 32, 116, 121, 112, 101, \
32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 101, 120, 116, 101, 110, 115, 105, 111, 110, 32, 111, \
102, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 116, 121, 112, 101, 0}), msg, 112);
			break;
		case 86: 
			__MOVE(((CHAR[]){103, 117, 97, 114, 100, 32, 111, 114, 32, 116, 101, 115, 116, 116, 121, 112, 101, \
32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 112, 111, 105, 110, 116, 101, 114, 0}), msg, 70);
			break;
		case 87: 
			__MOVE(((CHAR[]){103, 117, 97, 114, 100, 101, 100, 32, 111, 114, 32, 116, 101, 115, 116, 101, 100, \
32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 105, 115, 32, 110, 101, 105, 116, 104, 101, 114, 32, 97, \
32, 112, 111, 105, 110, 116, 101, 114, 32, 110, 111, 114, 32, 97, 32, 86, 65, 82, 45, 32, 111, 114, 32, \
73, 78, 45, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 114, 101, 99, 111, 114, 100, 0}), msg, 164);
			break;
		case 88: 
			__MOVE(((CHAR[]){111, 112, 101, 110, 32, 97, 114, 114, 97, 121, 32, 110, 111, 116, 32, 97, 108, 108, \
111, 119, 101, 100, 32, 97, 115, 32, 118, 97, 114, 105, 97, 98, 108, 101, 44, 32, 114, 101, 99, 111, 114, \
100, 32, 102, 105, 101, 108, 100, 32, 111, 114, 32, 97, 114, 114, 97, 121, 32, 101, 108, 101, 109, 101, \
110, 116, 0}), msg, 132);
			break;
		case 89: 
			__MOVE(((CHAR[]){65, 78, 89, 82, 69, 67, 79, 82, 68, 32, 109, 97, 121, 32, 110, 111, 116, 32, 98, 101, \
32, 97, 108, 108, 111, 99, 97, 116, 101, 100, 0}), msg, 62);
			break;
		case 90: 
			__MOVE(((CHAR[]){100, 101, 114, 101, 102, 101, 114, 101, 110, 99, 101, 100, 32, 118, 97, 114, 105, \
97, 98, 108, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, \
32, 97, 114, 114, 97, 121, 0}), msg, 94);
			break;
		case 92: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 111, 102, 32, 73, 78, 32, 110, 111, 116, 32, \
97, 110, 32, 105, 110, 116, 101, 103, 101, 114, 44, 32, 111, 114, 32, 110, 111, 116, 32, 97, 32, 115, \
101, 116, 0}), msg, 86);
			break;
		case 93: 
			__MOVE(((CHAR[]){115, 101, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 116, 121, 112, 101, 32, \
105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 105, 110, 116, 101, 103, 101, 114, 0}), msg, 70);
			break;
		case 94: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 111, 102, 32, 38, 32, 105, 115, 32, 110, 111, \
116, 32, 111, 102, 32, 116, 121, 112, 101, 32, 66, 79, 79, 76, 69, 65, 78, 0}), msg, 72);
			break;
		case 95: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 111, 102, 32, 79, 82, 32, 105, 115, 32, 110, \
111, 116, 32, 111, 102, 32, 116, 121, 112, 101, 32, 66, 79, 79, 76, 69, 65, 78, 0}), msg, 74);
			break;
		case 96: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 110, 111, 116, 32, 97, 112, 112, 108, 105, 99, \
97, 98, 108, 101, 32, 116, 111, 32, 40, 117, 110, 97, 114, 121, 41, 32, 43, 0}), msg, 72);
			break;
		case 97: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 110, 111, 116, 32, 97, 112, 112, 108, 105, 99, \
97, 98, 108, 101, 32, 116, 111, 32, 40, 117, 110, 97, 114, 121, 41, 32, 45, 0}), msg, 72);
			break;
		case 98: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 111, 102, 32, 126, 32, 105, 115, 32, 110, 111, \
116, 32, 111, 102, 32, 116, 121, 112, 101, 32, 66, 79, 79, 76, 69, 65, 78, 0}), msg, 72);
			break;
		case 99: 
			__MOVE(((CHAR[]){65, 83, 83, 69, 82, 84, 32, 102, 97, 117, 108, 116, 0}), msg, 26);
			break;
		case 100: 
			__MOVE(((CHAR[]){105, 110, 99, 111, 109, 112, 97, 116, 105, 98, 108, 101, 32, 111, 112, 101, 114, 97, \
110, 100, 115, 32, 111, 102, 32, 100, 121, 97, 100, 105, 99, 32, 111, 112, 101, 114, 97, 116, 111, 114, \
0}), msg, 82);
			break;
		case 101: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 116, 121, 112, 101, 32, 105, 110, 97, 112, 112, \
108, 105, 99, 97, 98, 108, 101, 32, 116, 111, 32, 42, 0}), msg, 62);
			break;
		case 102: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 116, 121, 112, 101, 32, 105, 110, 97, 112, 112, \
108, 105, 99, 97, 98, 108, 101, 32, 116, 111, 32, 47, 0}), msg, 62);
			break;
		case 103: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 116, 121, 112, 101, 32, 105, 110, 97, 112, 112, \
108, 105, 99, 97, 98, 108, 101, 32, 116, 111, 32, 68, 73, 86, 0}), msg, 66);
			break;
		case 104: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 116, 121, 112, 101, 32, 105, 110, 97, 112, 112, \
108, 105, 99, 97, 98, 108, 101, 32, 116, 111, 32, 77, 79, 68, 0}), msg, 66);
			break;
		case 105: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 116, 121, 112, 101, 32, 105, 110, 97, 112, 112, \
108, 105, 99, 97, 98, 108, 101, 32, 116, 111, 32, 43, 0}), msg, 62);
			break;
		case 106: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 116, 121, 112, 101, 32, 105, 110, 97, 112, 112, \
108, 105, 99, 97, 98, 108, 101, 32, 116, 111, 32, 45, 0}), msg, 62);
			break;
		case 107: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 116, 121, 112, 101, 32, 105, 110, 97, 112, 112, \
108, 105, 99, 97, 98, 108, 101, 32, 116, 111, 32, 61, 32, 111, 114, 32, 35, 0}), msg, 72);
			break;
		case 108: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 116, 121, 112, 101, 32, 105, 110, 97, 112, 112, \
108, 105, 99, 97, 98, 108, 101, 32, 116, 111, 32, 114, 101, 108, 97, 116, 105, 111, 110, 0}), msg, 76);
			break;
		case 109: 
			__MOVE(((CHAR[]){111, 118, 101, 114, 114, 105, 100, 105, 110, 103, 32, 109, 101, 116, 104, 111, 100, \
32, 109, 117, 115, 116, 32, 98, 101, 32, 101, 120, 112, 111, 114, 116, 101, 100, 0}), msg, 70);
			break;
		case 110: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 116, \
121, 112, 101, 0}), msg, 44);
			break;
		case 111: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 105, 110, 97, 112, 112, 108, 105, 99, 97, 98, \
108, 101, 32, 116, 111, 32, 40, 116, 104, 105, 115, 41, 32, 102, 117, 110, 99, 116, 105, 111, 110, 0}), \
msg, 80);
			break;
		case 112: 
			__MOVE(((CHAR[]){111, 112, 101, 114, 97, 110, 100, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 118, \
97, 114, 105, 97, 98, 108, 101, 0}), msg, 52);
			break;
		case 113: 
			__MOVE(((CHAR[]){105, 110, 99, 111, 109, 112, 97, 116, 105, 98, 108, 101, 32, 97, 115, 115, 105, 103, \
110, 109, 101, 110, 116, 0}), msg, 48);
			break;
		case 114: 
			__MOVE(((CHAR[]){115, 116, 114, 105, 110, 103, 32, 116, 111, 111, 32, 108, 111, 110, 103, 32, 116, \
111, 32, 98, 101, 32, 97, 115, 115, 105, 103, 110, 101, 100, 0}), msg, 62);
			break;
		case 115: 
			__MOVE(((CHAR[]){112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 100, 111, 101, 115, 32, 110, 111, 116, \
32, 109, 97, 116, 99, 104, 0}), msg, 50);
			break;
		case 116: 
			__MOVE(((CHAR[]){110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 112, 97, 114, 97, 109, 101, 116, 101, \
114, 115, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 109, 97, 116, 99, 104, 0}), msg, 72);
			break;
		case 117: 
			__MOVE(((CHAR[]){114, 101, 115, 117, 108, 116, 32, 116, 121, 112, 101, 32, 100, 111, 101, 115, 32, \
110, 111, 116, 32, 109, 97, 116, 99, 104, 0}), msg, 54);
			break;
		case 118: 
			__MOVE(((CHAR[]){101, 120, 112, 111, 114, 116, 32, 109, 97, 114, 107, 32, 100, 111, 101, 115, 32, 110, \
111, 116, 32, 109, 97, 116, 99, 104, 32, 119, 105, 116, 104, 32, 102, 111, 114, 119, 97, 114, 100, 32, \
100, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 0}), msg, 104);
			break;
		case 119: 
			__MOVE(((CHAR[]){114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 32, 116, 101, 120, 116, \
117, 97, 108, 108, 121, 32, 112, 114, 101, 99, 101, 100, 101, 115, 32, 112, 114, 111, 99, 101, 100, 117, \
114, 101, 32, 98, 111, 117, 110, 100, 32, 116, 111, 32, 98, 97, 115, 101, 32, 116, 121, 112, 101, 0}), \
msg, 122);
			break;
		case 120: 
			__MOVE(((CHAR[]){116, 121, 112, 101, 32, 111, 102, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, \
110, 32, 102, 111, 108, 108, 111, 119, 105, 110, 103, 32, 73, 70, 44, 32, 87, 72, 73, 76, 69, 44, 32, \
85, 78, 84, 73, 76, 32, 111, 114, 32, 65, 83, 83, 69, 82, 84, 32, 105, 115, 32, 110, 111, 116, 32, 66, \
79, 79, 76, 69, 65, 78, 0}), msg, 142);
			break;
		case 121: 
			__MOVE(((CHAR[]){99, 97, 108, 108, 101, 100, 32, 111, 98, 106, 101, 99, 116, 32, 105, 115, 32, 110, \
111, 116, 32, 97, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 0}), msg, 66);
			break;
		case 122: 
			__MOVE(((CHAR[]){97, 99, 116, 117, 97, 108, 32, 86, 65, 82, 45, 44, 32, 73, 78, 45, 44, 32, 111, 114, \
32, 79, 85, 84, 45, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, \
32, 118, 97, 114, 105, 97, 98, 108, 101, 0}), msg, 106);
			break;
		case 123: 
			__MOVE(((CHAR[]){116, 121, 112, 101, 32, 105, 115, 32, 110, 111, 116, 32, 105, 100, 101, 110, 116, \
105, 99, 97, 108, 32, 119, 105, 116, 104, 32, 116, 104, 97, 116, 32, 111, 102, 32, 102, 111, 114, 109, \
97, 108, 32, 86, 65, 82, 45, 44, 32, 73, 78, 45, 44, 32, 111, 114, 32, 79, 85, 84, 45, 112, 97, 114, 97, \
109, 101, 116, 101, 114, 0}), msg, 140);
			break;
		case 124: 
			__MOVE(((CHAR[]){116, 121, 112, 101, 32, 111, 102, 32, 114, 101, 115, 117, 108, 116, 32, 101, 120, \
112, 114, 101, 115, 115, 105, 111, 110, 32, 100, 105, 102, 102, 101, 114, 115, 32, 102, 114, 111, 109, \
32, 116, 104, 97, 116, 32, 111, 102, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 0}), msg, 114);
			break;
		case 125: 
			__MOVE(((CHAR[]){116, 121, 112, 101, 32, 111, 102, 32, 99, 97, 115, 101, 32, 101, 120, 112, 114, 101, \
115, 115, 105, 111, 110, 32, 105, 115, 32, 110, 101, 105, 116, 104, 101, 114, 32, 73, 78, 84, 69, 71, \
69, 82, 32, 110, 111, 114, 32, 67, 72, 65, 82, 0}), msg, 104);
			break;
		case 126: 
			__MOVE(((CHAR[]){116, 104, 105, 115, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 32, 99, \
97, 110, 110, 111, 116, 32, 98, 101, 32, 97, 32, 116, 121, 112, 101, 32, 111, 114, 32, 97, 32, 112, 114, \
111, 99, 101, 100, 117, 114, 101, 0}), msg, 96);
			break;
		case 127: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 117, 115, 101, 32, 111, 102, 32, 111, 98, 106, \
101, 99, 116, 0}), msg, 44);
			break;
		case 128: 
			__MOVE(((CHAR[]){117, 110, 115, 97, 116, 105, 115, 102, 105, 101, 100, 32, 102, 111, 114, 119, 97, \
114, 100, 32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 0}), msg, 60);
			break;
		case 129: 
			__MOVE(((CHAR[]){117, 110, 115, 97, 116, 105, 115, 102, 105, 101, 100, 32, 102, 111, 114, 119, 97, \
114, 100, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 0}), msg, 60);
			break;
		case 130: 
			__MOVE(((CHAR[]){87, 73, 84, 72, 32, 99, 108, 97, 117, 115, 101, 32, 100, 111, 101, 115, 32, 110, 111, \
116, 32, 115, 112, 101, 99, 105, 102, 121, 32, 97, 32, 118, 97, 114, 105, 97, 98, 108, 101, 0}), msg, \
80);
			break;
		case 131: 
			__MOVE(((CHAR[]){76, 69, 78, 32, 110, 111, 116, 32, 97, 112, 112, 108, 105, 101, 100, 32, 116, 111, \
32, 97, 114, 114, 97, 121, 0}), msg, 50);
			break;
		case 132: 
			__MOVE(((CHAR[]){100, 105, 109, 101, 110, 115, 105, 111, 110, 32, 105, 110, 32, 76, 69, 78, 32, 116, \
111, 111, 32, 108, 97, 114, 103, 101, 32, 111, 114, 32, 110, 101, 103, 97, 116, 105, 118, 101, 0}), msg, \
78);
			break;
		case 133: 
			__MOVE(((CHAR[]){102, 117, 110, 99, 116, 105, 111, 110, 32, 119, 105, 116, 104, 111, 117, 116, 32, \
82, 69, 84, 85, 82, 78, 0}), msg, 48);
			break;
		case 135: 
			__MOVE(((CHAR[]){83, 89, 83, 84, 69, 77, 32, 110, 111, 116, 32, 105, 109, 112, 111, 114, 116, 101, \
100, 0}), msg, 40);
			break;
		case 136: 
			__MOVE(((CHAR[]){76, 69, 78, 32, 97, 112, 112, 108, 105, 101, 100, 32, 116, 111, 32, 117, 110, 116, \
97, 103, 103, 101, 100, 32, 97, 114, 114, 97, 121, 0}), msg, 60);
			break;
		case 137: 
			__MOVE(((CHAR[]){117, 110, 107, 110, 111, 119, 110, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, \
116, 104, 0}), msg, 42);
			break;
		case 138: 
			__MOVE(((CHAR[]){78, 69, 87, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 102, 111, \
114, 32, 117, 110, 116, 97, 103, 103, 101, 100, 32, 115, 116, 114, 117, 99, 116, 117, 114, 101, 115, 0}), \
msg, 80);
			break;
		case 139: 
			__MOVE(((CHAR[]){84, 101, 115, 116, 32, 97, 112, 112, 108, 105, 101, 100, 32, 116, 111, 32, 117, 110, \
116, 97, 103, 103, 101, 100, 32, 114, 101, 99, 111, 114, 100, 0}), msg, 64);
			break;
		case 140: 
			__MOVE(((CHAR[]){117, 110, 116, 97, 103, 103, 101, 100, 32, 114, 101, 99, 101, 105, 118, 101, 114, \
0}), msg, 36);
			break;
		case 141: 
			__MOVE(((CHAR[]){83, 89, 83, 84, 69, 77, 46, 78, 69, 87, 32, 110, 111, 116, 32, 105, 109, 112, 108, \
101, 109, 101, 110, 116, 101, 100, 0}), msg, 54);
			break;
		case 142: 
			__MOVE(((CHAR[]){116, 97, 103, 103, 101, 100, 32, 115, 116, 114, 117, 99, 116, 117, 114, 101, 115, \
32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 102, 111, 114, 32, 78, 73, 76, 32, 99, 111, \
109, 112, 97, 116, 105, 98, 108, 101, 32, 118, 97, 114, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, \
115, 0}), msg, 128);
			break;
		case 143: 
			__MOVE(((CHAR[]){116, 97, 103, 103, 101, 100, 32, 112, 111, 105, 110, 116, 101, 114, 32, 110, 111, \
116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 105, 110, 32, 117, 110, 116, 97, 103, 103, 101, 100, 32, \
115, 116, 114, 117, 99, 116, 117, 114, 101, 0}), msg, 98);
			break;
		case 144: 
			__MOVE(((CHAR[]){110, 111, 32, 112, 111, 105, 110, 116, 101, 114, 115, 32, 97, 108, 108, 111, 119, \
101, 100, 32, 105, 110, 32, 66, 89, 84, 69, 83, 32, 97, 114, 103, 117, 109, 101, 110, 116, 0}), msg, 76);
			break;
		case 145: 
			__MOVE(((CHAR[]){117, 110, 116, 97, 103, 103, 101, 100, 32, 111, 112, 101, 110, 32, 97, 114, 114, 97, \
121, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 32, 97, 115, 32, 118, 97, 108, 117, 101, \
32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 0}), msg, 102);
			break;
		case 150: 
			__MOVE(((CHAR[]){107, 101, 121, 32, 105, 110, 99, 111, 110, 115, 105, 115, 116, 101, 110, 99, 121, \
32, 111, 102, 32, 105, 109, 112, 111, 114, 116, 101, 100, 32, 109, 111, 100, 117, 108, 101, 0}), msg, \
74);
			break;
		case 151: 
			__MOVE(((CHAR[]){105, 110, 99, 111, 114, 114, 101, 99, 116, 32, 115, 121, 109, 98, 111, 108, 32, 102, \
105, 108, 101, 0}), msg, 44);
			break;
		case 152: 
			__MOVE(((CHAR[]){115, 121, 109, 98, 111, 108, 32, 102, 105, 108, 101, 32, 111, 102, 32, 105, 109, 112, \
111, 114, 116, 101, 100, 32, 109, 111, 100, 117, 108, 101, 32, 110, 111, 116, 32, 102, 111, 117, 110, \
100, 0}), msg, 82);
			break;
		case 153: 
			__MOVE(((CHAR[]){111, 98, 106, 101, 99, 116, 32, 111, 114, 32, 115, 121, 109, 98, 111, 108, 32, 102, \
105, 108, 101, 32, 110, 111, 116, 32, 111, 112, 101, 110, 101, 100, 32, 40, 100, 105, 115, 107, 32, 102, \
117, 108, 108, 63, 41, 0}), msg, 92);
			break;
		case 154: 
			__MOVE(((CHAR[]){114, 101, 99, 117, 114, 115, 105, 118, 101, 32, 105, 109, 112, 111, 114, 116, 32, \
110, 111, 116, 32, 97, 108, 108, 111, 119, 101, 100, 0}), msg, 58);
			break;
		case 155: 
			__MOVE(((CHAR[]){103, 101, 110, 101, 114, 97, 116, 105, 111, 110, 32, 111, 102, 32, 110, 101, 119, \
32, 115, 121, 109, 98, 111, 108, 32, 102, 105, 108, 101, 32, 110, 111, 116, 32, 97, 108, 108, 111, 119, \
101, 100, 0}), msg, 84);
			break;
		case 160: 
			__MOVE(((CHAR[]){105, 110, 116, 101, 114, 102, 97, 99, 101, 115, 32, 109, 117, 115, 116, 32, 98, 101, \
32, 101, 120, 116, 101, 110, 115, 105, 111, 110, 115, 32, 111, 102, 32, 73, 85, 110, 107, 110, 111, 119, \
110, 0}), msg, 84);
			break;
		case 161: 
			__MOVE(((CHAR[]){105, 110, 116, 101, 114, 102, 97, 99, 101, 115, 32, 109, 117, 115, 116, 32, 110, 111, \
116, 32, 104, 97, 118, 101, 32, 102, 105, 101, 108, 100, 115, 0}), msg, 64);
			break;
		case 162: 
			__MOVE(((CHAR[]){105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 112, 114, 111, 99, 101, 100, 117, 114, \
101, 115, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 98, 115, 116, 114, 97, 99, 116, 0}), msg, 76);
			break;
		case 163: 
			__MOVE(((CHAR[]){105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 114, 101, 99, 111, 114, 100, 115, 32, \
109, 117, 115, 116, 32, 98, 101, 32, 97, 98, 115, 116, 114, 97, 99, 116, 0}), msg, 70);
			break;
		case 164: 
			__MOVE(((CHAR[]){112, 111, 105, 110, 116, 101, 114, 32, 109, 117, 115, 116, 32, 98, 101, 32, 101, 120, \
116, 101, 110, 115, 105, 111, 110, 32, 111, 102, 32, 113, 117, 101, 114, 105, 101, 100, 32, 105, 110, \
116, 101, 114, 102, 97, 99, 101, 32, 116, 121, 112, 101, 0}), msg, 104);
			break;
		case 165: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 103, 117, 105, 100, 32, 99, 111, 110, 115, 116, \
97, 110, 116, 0}), msg, 44);
			break;
		case 166: 
			__MOVE(((CHAR[]){65, 100, 100, 82, 101, 102, 32, 38, 32, 82, 101, 108, 101, 97, 115, 101, 32, 109, \
97, 121, 32, 110, 111, 116, 32, 98, 101, 32, 117, 115, 101, 100, 0}), msg, 66);
			break;
		case 167: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 97, 115, 115, 105, 103, 110, 109, 101, 110, \
116, 32, 116, 111, 32, 91, 110, 101, 119, 93, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 0}), msg, \
76);
			break;
		case 168: 
			__MOVE(((CHAR[]){119, 114, 111, 110, 103, 32, 91, 105, 105, 100, 93, 32, 45, 32, 91, 110, 101, 119, \
93, 32, 112, 97, 105, 114, 0}), msg, 50);
			break;
		case 169: 
			__MOVE(((CHAR[]){109, 117, 115, 116, 32, 98, 101, 32, 97, 110, 32, 105, 110, 116, 101, 114, 102, 97, \
99, 101, 32, 112, 111, 105, 110, 116, 101, 114, 0}), msg, 58);
			break;
		case 177: 
			__MOVE(((CHAR[]){73, 78, 32, 111, 110, 108, 121, 32, 97, 108, 108, 111, 119, 101, 100, 32, 102, 111, \
114, 32, 114, 101, 99, 111, 114, 100, 115, 32, 97, 110, 100, 32, 97, 114, 114, 97, 121, 115, 0}), msg, \
78);
			break;
		case 178: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 0}), \
msg, 36);
			break;
		case 179: 
			__MOVE(((CHAR[]){97, 98, 115, 116, 114, 97, 99, 116, 32, 109, 101, 116, 104, 111, 100, 115, 32, 111, \
102, 32, 101, 120, 112, 111, 114, 116, 101, 100, 32, 114, 101, 99, 111, 114, 100, 115, 32, 109, 117, 115, \
116, 32, 98, 101, 32, 101, 120, 112, 111, 114, 116, 101, 100, 0}), msg, 108);
			break;
		case 180: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 114, 101, 99, 101, 105, 118, 101, 114, 32, 116, \
121, 112, 101, 0}), msg, 44);
			break;
		case 181: 
			__MOVE(((CHAR[]){98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 105, 115, 32, 110, 111, 116, 32, 101, \
120, 116, 101, 110, 115, 105, 98, 108, 101, 0}), msg, 56);
			break;
		case 182: 
			__MOVE(((CHAR[]){98, 97, 115, 101, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 32, 105, 115, 32, \
110, 111, 116, 32, 101, 120, 116, 101, 110, 115, 105, 98, 108, 101, 0}), msg, 66);
			break;
		case 183: 
			__MOVE(((CHAR[]){110, 111, 110, 45, 109, 97, 116, 99, 104, 105, 110, 103, 32, 101, 120, 112, 111, 114, \
116, 0}), msg, 40);
			break;
		case 184: 
			__MOVE(((CHAR[]){65, 116, 116, 114, 105, 98, 117, 116, 101, 32, 100, 111, 101, 115, 32, 110, 111, 116, \
32, 109, 97, 116, 99, 104, 32, 119, 105, 116, 104, 32, 102, 111, 114, 119, 97, 114, 100, 32, 100, 101, \
99, 108, 97, 114, 97, 116, 105, 111, 110, 0}), msg, 100);
			break;
		case 185: 
			__MOVE(((CHAR[]){109, 105, 115, 115, 105, 110, 103, 32, 78, 69, 87, 32, 97, 116, 116, 114, 105, 98, \
117, 116, 101, 0}), msg, 44);
			break;
		case 186: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 78, 69, 87, 32, 97, 116, 116, 114, 105, 98, \
117, 116, 101, 0}), msg, 44);
			break;
		case 187: 
			__MOVE(((CHAR[]){110, 101, 119, 32, 101, 109, 112, 116, 121, 32, 112, 114, 111, 99, 101, 100, 117, \
114, 101, 32, 105, 110, 32, 110, 111, 110, 32, 101, 120, 116, 101, 110, 115, 105, 98, 108, 101, 32, 114, \
101, 99, 111, 114, 100, 0}), msg, 90);
			break;
		case 188: 
			__MOVE(((CHAR[]){101, 120, 116, 101, 110, 115, 105, 98, 108, 101, 32, 112, 114, 111, 99, 101, 100, \
117, 114, 101, 32, 105, 110, 32, 110, 111, 110, 32, 101, 120, 116, 101, 110, 115, 105, 98, 108, 101, 32, \
114, 101, 99, 111, 114, 100, 0}), msg, 92);
			break;
		case 189: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 32, \
99, 104, 97, 110, 103, 101, 0}), msg, 50);
			break;
		case 190: 
			__MOVE(((CHAR[]){114, 101, 99, 111, 114, 100, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 98, 115, \
116, 114, 97, 99, 116, 0}), msg, 48);
			break;
		case 191: 
			__MOVE(((CHAR[]){98, 97, 115, 101, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, \
97, 98, 115, 116, 114, 97, 99, 116, 0}), msg, 54);
			break;
		case 192: 
			__MOVE(((CHAR[]){117, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 97, 98, 115, \
116, 114, 97, 99, 116, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 115, 32, 105, 110, 32, 98, 97, \
115, 101, 32, 116, 121, 112, 101, 115, 0}), msg, 96);
			break;
		case 193: 
			__MOVE(((CHAR[]){97, 98, 115, 116, 114, 97, 99, 116, 32, 111, 114, 32, 108, 105, 109, 105, 116, 101, \
100, 32, 114, 101, 99, 111, 114, 100, 115, 32, 109, 97, 121, 32, 110, 111, 116, 32, 98, 101, 32, 97, 108, \
108, 111, 99, 97, 116, 101, 100, 0}), msg, 98);
			break;
		case 194: 
			__MOVE(((CHAR[]){110, 111, 32, 115, 117, 112, 101, 114, 99, 97, 108, 108, 32, 97, 108, 108, 111, 119, \
101, 100, 32, 116, 111, 32, 97, 98, 115, 116, 114, 97, 99, 116, 32, 111, 114, 32, 101, 109, 112, 116, \
121, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 115, 0}), msg, 106);
			break;
		case 195: 
			__MOVE(((CHAR[]){101, 109, 112, 116, 121, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 115, 32, \
109, 97, 121, 32, 110, 111, 116, 32, 104, 97, 118, 101, 32, 111, 117, 116, 32, 112, 97, 114, 97, 109, \
101, 116, 101, 114, 115, 32, 111, 114, 32, 114, 101, 116, 117, 114, 110, 32, 97, 32, 118, 97, 108, 117, \
101, 0}), msg, 126);
			break;
		case 196: 
			__MOVE(((CHAR[]){112, 114, 111, 99, 101, 100, 117, 114, 101, 32, 105, 115, 32, 105, 109, 112, 108, \
101, 109, 101, 110, 116, 45, 111, 110, 108, 121, 32, 101, 120, 112, 111, 114, 116, 101, 100, 0}), msg, \
74);
			break;
		case 197: 
			__MOVE(((CHAR[]){101, 120, 116, 101, 110, 115, 105, 111, 110, 32, 111, 102, 32, 108, 105, 109, 105, \
116, 101, 100, 32, 116, 121, 112, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 108, 105, 109, 105, 116, \
101, 100, 0}), msg, 84);
			break;
		case 198: 
			__MOVE(((CHAR[]){111, 98, 115, 111, 108, 101, 116, 101, 32, 111, 98, 101, 114, 111, 110, 32, 116, 121, \
112, 101, 0}), msg, 42);
			break;
		case 199: 
			__MOVE(((CHAR[]){111, 98, 115, 111, 108, 101, 116, 101, 32, 111, 98, 101, 114, 111, 110, 32, 102, 117, \
110, 99, 116, 105, 111, 110, 0}), msg, 50);
			break;
		case 200: 
			__MOVE(((CHAR[]){110, 111, 116, 32, 121, 101, 116, 32, 105, 109, 112, 108, 101, 109, 101, 110, 116, \
101, 100, 0}), msg, 40);
			break;
		case 201: 
			__MOVE(((CHAR[]){108, 111, 119, 101, 114, 32, 98, 111, 117, 110, 100, 32, 111, 102, 32, 115, 101, 116, \
32, 114, 97, 110, 103, 101, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 32, 104, 105, \
103, 104, 101, 114, 32, 98, 111, 117, 110, 100, 0}), msg, 102);
			break;
		case 202: 
			__MOVE(((CHAR[]){115, 101, 116, 32, 101, 108, 101, 109, 101, 110, 116, 32, 103, 114, 101, 97, 116, \
101, 114, 32, 116, 104, 97, 110, 32, 77, 65, 88, 40, 83, 69, 84, 41, 32, 111, 114, 32, 108, 101, 115, \
115, 32, 116, 104, 97, 110, 32, 48, 0}), msg, 98);
			break;
		case 203: 
			__MOVE(((CHAR[]){110, 117, 109, 98, 101, 114, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0}), msg, \
34);
			break;
		case 204: 
			__MOVE(((CHAR[]){112, 114, 111, 100, 117, 99, 116, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0}), \
msg, 36);
			break;
		case 205: 
			__MOVE(((CHAR[]){100, 105, 118, 105, 115, 105, 111, 110, 32, 98, 121, 32, 122, 101, 114, 111, 0}), \
msg, 34);
			break;
		case 206: 
			__MOVE(((CHAR[]){115, 117, 109, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0}), msg, 28);
			break;
		case 207: 
			__MOVE(((CHAR[]){100, 105, 102, 102, 101, 114, 101, 110, 99, 101, 32, 116, 111, 111, 32, 108, 97, 114, \
103, 101, 0}), msg, 42);
			break;
		case 208: 
			__MOVE(((CHAR[]){111, 118, 101, 114, 102, 108, 111, 119, 32, 105, 110, 32, 97, 114, 105, 116, 104, \
109, 101, 116, 105, 99, 32, 115, 104, 105, 102, 116, 0}), msg, 58);
			break;
		case 209: 
			__MOVE(((CHAR[]){99, 97, 115, 101, 32, 114, 97, 110, 103, 101, 32, 116, 111, 111, 32, 108, 97, 114, \
103, 101, 0}), msg, 42);
			break;
		case 210: 
			__MOVE(((CHAR[]){99, 111, 100, 101, 32, 116, 111, 111, 32, 108, 111, 110, 103, 0}), msg, 28);
			break;
		case 211: 
			__MOVE(((CHAR[]){106, 117, 109, 112, 32, 100, 105, 115, 116, 97, 110, 99, 101, 32, 116, 111, 111, 32, \
108, 97, 114, 103, 101, 0}), msg, 48);
			break;
		case 212: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 114, 101, 97, 108, 32, 111, 112, 101, 114, 97, \
116, 105, 111, 110, 0}), msg, 46);
			break;
		case 213: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 99, 97, 115, 101, 115, 32, 105, 110, 32, \
99, 97, 115, 101, 32, 115, 116, 97, 116, 101, 109, 101, 110, 116, 0}), msg, 66);
			break;
		case 214: 
			__MOVE(((CHAR[]){115, 116, 114, 117, 99, 116, 117, 114, 101, 32, 116, 111, 111, 32, 108, 97, 114, 103, \
101, 0}), msg, 40);
			break;
		case 215: 
			__MOVE(((CHAR[]){110, 111, 116, 32, 101, 110, 111, 117, 103, 104, 32, 114, 101, 103, 105, 115, 116, \
101, 114, 115, 58, 32, 115, 105, 109, 112, 108, 105, 102, 121, 32, 101, 120, 112, 114, 101, 115, 115, \
105, 111, 110, 0}), msg, 84);
			break;
		case 216: 
			__MOVE(((CHAR[]){110, 111, 116, 32, 101, 110, 111, 117, 103, 104, 32, 102, 108, 111, 97, 116, 105, \
110, 103, 45, 112, 111, 105, 110, 116, 32, 114, 101, 103, 105, 115, 116, 101, 114, 115, 58, 32, 115, 105, \
109, 112, 108, 105, 102, 121, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 0}), msg, 114);
			break;
		case 217: 
			__MOVE(((CHAR[]){117, 110, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 32, 83, 89, 83, 84, \
69, 77, 32, 102, 117, 110, 99, 116, 105, 111, 110, 0}), msg, 60);
			break;
		case 218: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 112, \
97, 114, 97, 109, 101, 116, 101, 114, 32, 32, 40, 48, 32, 60, 61, 32, 112, 32, 60, 32, 49, 50, 56, 41, \
0}), msg, 86);
			break;
		case 219: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 112, \
97, 114, 97, 109, 101, 116, 101, 114, 32, 32, 40, 48, 32, 60, 61, 32, 112, 32, 60, 32, 49, 54, 41, 0}), \
msg, 84);
			break;
		case 220: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 112, \
97, 114, 97, 109, 101, 116, 101, 114, 0}), msg, 54);
			break;
		case 221: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 112, 111, 105, 110, 116, 101, 114, 115, \
32, 105, 110, 32, 97, 32, 114, 101, 99, 111, 114, 100, 0}), msg, 60);
			break;
		case 222: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 103, 108, 111, 98, 97, 108, 32, 112, 111, \
105, 110, 116, 101, 114, 115, 0}), msg, 50);
			break;
		case 223: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 114, 101, 99, 111, 114, 100, 32, 116, 121, \
112, 101, 115, 0}), msg, 44);
			break;
		case 224: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 112, 111, 105, 110, 116, 101, 114, 32, 116, \
121, 112, 101, 115, 0}), msg, 46);
			break;
		case 225: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 115, 121, 115, 32, 102, 108, 97, 103, 0}), msg, \
34);
			break;
		case 226: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 101, 120, 112, 111, 114, 116, 101, 100, \
32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 115, 0}), msg, 58);
			break;
		case 227: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 105, 109, 112, 111, 114, 116, 101, 100, \
32, 109, 111, 100, 117, 108, 101, 115, 0}), msg, 52);
			break;
		case 228: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 101, 120, 112, 111, 114, 116, 101, 100, \
32, 115, 116, 114, 117, 99, 116, 117, 114, 101, 115, 0}), msg, 58);
			break;
		case 229: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 110, 101, 115, 116, 101, 100, 32, 114, 101, \
99, 111, 114, 100, 115, 32, 102, 111, 114, 32, 105, 109, 112, 111, 114, 116, 0}), msg, 70);
			break;
		case 230: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 99, 111, 110, 115, 116, 97, 110, 116, 115, \
32, 40, 115, 116, 114, 105, 110, 103, 115, 41, 32, 105, 110, 32, 109, 111, 100, 117, 108, 101, 0}), msg, \
78);
			break;
		case 231: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 108, 105, 110, 107, 32, 116, 97, 98, 108, \
101, 32, 101, 110, 116, 114, 105, 101, 115, 32, 40, 101, 120, 116, 101, 114, 110, 97, 108, 32, 112, 114, \
111, 99, 101, 100, 117, 114, 101, 115, 41, 0}), msg, 100);
			break;
		case 232: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 99, 111, 109, 109, 97, 110, 100, 115, 32, \
105, 110, 32, 109, 111, 100, 117, 108, 101, 0}), msg, 56);
			break;
		case 233: 
			__MOVE(((CHAR[]){114, 101, 99, 111, 114, 100, 32, 101, 120, 116, 101, 110, 115, 105, 111, 110, 32, \
104, 105, 101, 114, 97, 114, 99, 104, 121, 32, 116, 111, 111, 32, 104, 105, 103, 104, 0}), msg, 72);
			break;
		case 235: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 109, 111, 100, 105, 102, 105, 101, 114, \
115, 9, 0}), msg, 40);
			break;
		case 240: 
			__MOVE(((CHAR[]){105, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 116, 111, 111, 32, 108, 111, \
110, 103, 0}), msg, 40);
			break;
		case 241: 
			__MOVE(((CHAR[]){115, 116, 114, 105, 110, 103, 32, 116, 111, 111, 32, 108, 111, 110, 103, 0}), msg, \
32);
			break;
		case 242: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 109, 101, 116, 97, 32, 110, 97, 109, 101, \
115, 0}), msg, 40);
			break;
		case 243: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 105, 109, 112, 111, 114, 116, 101, 100, \
32, 118, 97, 114, 105, 97, 98, 108, 101, 115, 0}), msg, 56);
			break;
		case 249: 
			__MOVE(((CHAR[]){105, 110, 99, 111, 110, 115, 105, 115, 116, 101, 110, 116, 32, 105, 109, 112, 111, \
114, 116, 0}), msg, 40);
			break;
		case 250: 
			__MOVE(((CHAR[]){99, 111, 100, 101, 32, 112, 114, 111, 99, 32, 109, 117, 115, 116, 32, 110, 111, 116, \
32, 98, 101, 32, 101, 120, 112, 111, 114, 116, 101, 100, 0}), msg, 62);
			break;
		case 251: 
			__MOVE(((CHAR[]){116, 111, 111, 32, 109, 97, 110, 121, 32, 110, 101, 115, 116, 101, 100, 32, 102, 117, \
110, 99, 116, 105, 111, 110, 32, 99, 97, 108, 108, 115, 0}), msg, 62);
			break;
		case 254: 
			__MOVE(((CHAR[]){100, 101, 98, 117, 103, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 110, 111, \
116, 32, 102, 111, 117, 110, 100, 0}), msg, 50);
			break;
		case 255: 
			__MOVE(((CHAR[]){100, 101, 98, 117, 103, 32, 112, 111, 115, 105, 116, 105, 111, 110, 0}), msg, 30);
			break;
		case 260: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 76, 79, 78, 71, 73, 78, 84, 32, 111, 112, 101, \
114, 97, 116, 105, 111, 110, 0}), msg, 52);
			break;
		case 261: 
			__MOVE(((CHAR[]){117, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 109, 111, 100, 101, 32, \
111, 114, 32, 115, 105, 122, 101, 32, 111, 102, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, \
109, 101, 110, 116, 32, 111, 102, 32, 83, 89, 83, 84, 69, 77, 46, 86, 65, 76, 0}), msg, 116);
			break;
		case 265: 
			__MOVE(((CHAR[]){117, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 115, 116, 114, 105, 110, \
103, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 0}), msg, 58);
			break;
		case 270: 
			__MOVE(((CHAR[]){105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 112, 111, 105, 110, 116, 101, 114, \
32, 114, 101, 102, 101, 114, 101, 110, 99, 101, 32, 99, 111, 117, 110, 116, 105, 110, 103, 32, 114, 101, \
115, 116, 114, 105, 99, 116, 105, 111, 110, 32, 118, 105, 111, 108, 97, 116, 101, 100, 0}), msg, 116);
			break;
		case 301: 
			__MOVE(((CHAR[]){105, 109, 112, 108, 105, 99, 105, 116, 32, 116, 121, 112, 101, 32, 99, 97, 115, 116, \
0}), msg, 38);
			break;
		case 302: 
			__MOVE(((CHAR[]){103, 117, 97, 114, 100, 101, 100, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, 99, \
97, 110, 32, 98, 101, 32, 115, 105, 100, 101, 45, 101, 102, 102, 101, 99, 116, 101, 100, 0}), msg, 76);
			break;
		case 303: 
			__MOVE(((CHAR[]){111, 112, 101, 110, 32, 97, 114, 114, 97, 121, 32, 40, 111, 114, 32, 112, 111, 105, \
110, 116, 101, 114, 32, 116, 111, 32, 97, 114, 114, 97, 121, 41, 32, 99, 111, 110, 116, 97, 105, 110, \
105, 110, 103, 32, 112, 111, 105, 110, 116, 101, 114, 115, 0}), msg, 106);
			break;
		case 900: 
			__MOVE(((CHAR[]){110, 101, 118, 101, 114, 32, 117, 115, 101, 100, 0}), msg, 22);
			break;
		case 901: 
			__MOVE(((CHAR[]){110, 101, 118, 101, 114, 32, 115, 101, 116, 0}), msg, 20);
			break;
		case 902: 
			__MOVE(((CHAR[]){117, 115, 101, 100, 32, 98, 101, 102, 111, 114, 101, 32, 115, 101, 116, 0}), msg, \
32);
			break;
		case 903: 
			__MOVE(((CHAR[]){115, 101, 116, 32, 98, 117, 116, 32, 110, 101, 118, 101, 114, 32, 117, 115, 101, 100, \
0}), msg, 38);
			break;
		case 904: 
			__MOVE(((CHAR[]){117, 115, 101, 100, 32, 97, 115, 32, 118, 97, 114, 112, 97, 114, 44, 32, 112, 111, \
115, 115, 105, 98, 108, 121, 32, 110, 111, 116, 32, 115, 101, 116, 0}), msg, 66);
			break;
		case 905: 
			__MOVE(((CHAR[]){97, 108, 115, 111, 32, 100, 101, 99, 108, 97, 114, 101, 100, 32, 105, 110, 32, 111, \
117, 116, 101, 114, 32, 115, 99, 111, 112, 101, 0}), msg, 58);
			break;
		case 906: 
			__MOVE(((CHAR[]){97, 99, 99, 101, 115, 115, 47, 97, 115, 115, 105, 103, 110, 109, 101, 110, 116, 32, \
116, 111, 32, 105, 110, 116, 101, 114, 109, 101, 100, 105, 97, 116, 101, 0}), msg, 68);
			break;
		case 907: 
			__MOVE(((CHAR[]){114, 101, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0}), msg, 26);
			break;
		case 908: 
			__MOVE(((CHAR[]){110, 101, 119, 32, 100, 101, 102, 105, 110, 105, 116, 105, 111, 110, 0}), msg, 30);
			break;
		case 909: 
			__MOVE(((CHAR[]){115, 116, 97, 116, 101, 109, 101, 110, 116, 32, 97, 102, 116, 101, 114, 32, 82, 69, \
84, 85, 82, 78, 47, 69, 88, 73, 84, 0}), msg, 56);
			break;
		case 910: 
			__MOVE(((CHAR[]){102, 111, 114, 32, 108, 111, 111, 112, 32, 118, 97, 114, 105, 97, 98, 108, 101, 32, \
115, 101, 116, 0}), msg, 44);
			break;
		case 911: 
			__MOVE(((CHAR[]){105, 109, 112, 108, 105, 101, 100, 32, 116, 121, 112, 101, 32, 103, 117, 97, 114, \
100, 0}), msg, 38);
			break;
		case 912: 
			__MOVE(((CHAR[]){115, 117, 112, 101, 114, 102, 108, 117, 111, 117, 115, 32, 116, 121, 112, 101, 32, \
103, 117, 97, 114, 100, 0}), msg, 46);
			break;
		case 913: 
			__MOVE(((CHAR[]){99, 97, 108, 108, 32, 109, 105, 103, 104, 116, 32, 100, 101, 112, 101, 110, 100, 32, \
111, 110, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 115, 101, 113, 117, 101, 110, 99, 101, \
32, 111, 102, 32, 112, 97, 114, 97, 109, 115, 46, 0}), msg, 104);
			break;
		case 930: 
			__MOVE(((CHAR[]){115, 117, 112, 101, 114, 102, 108, 117, 111, 117, 115, 32, 115, 101, 109, 105, 99, \
111, 108, 111, 110, 0}), msg, 44);
			break;
		case 401: 
			__MOVE(((CHAR[]){98, 121, 116, 101, 99, 111, 100, 101, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, \
111, 110, 58, 32, 110, 111, 32, 115, 116, 114, 117, 99, 116, 117, 114, 101, 100, 32, 97, 115, 115, 105, \
103, 110, 109, 101, 110, 116, 0}), msg, 94);
			break;
		case 402: 
			__MOVE(((CHAR[]){98, 121, 116, 101, 99, 111, 100, 101, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, \
111, 110, 58, 32, 110, 111, 32, 112, 114, 111, 99, 101, 100, 117, 114, 101, 32, 116, 121, 112, 101, 115, \
0}), msg, 82);
			break;
		case 403: 
			__MOVE(((CHAR[]){98, 121, 116, 101, 99, 111, 100, 101, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, \
111, 110, 58, 32, 110, 111, 32, 110, 101, 115, 116, 101, 100, 32, 112, 114, 111, 99, 101, 100, 117, 114, \
101, 115, 0}), msg, 86);
			break;
		case 404: 
			__MOVE(((CHAR[]){98, 121, 116, 101, 99, 111, 100, 101, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, \
111, 110, 58, 32, 105, 108, 108, 101, 103, 97, 108, 32, 83, 89, 83, 84, 69, 77, 32, 102, 117, 110, 99, \
116, 105, 111, 110, 0}), msg, 92);
			break;
		case 410: 
			__MOVE(((CHAR[]){118, 97, 114, 105, 97, 98, 108, 101, 32, 109, 97, 121, 32, 110, 111, 116, 32, 104, \
97, 118, 101, 32, 98, 101, 101, 110, 32, 97, 115, 115, 105, 103, 110, 101, 100, 0}), msg, 72);
			break;
		case 411: 
			__MOVE(((CHAR[]){110, 111, 32, 112, 114, 111, 111, 102, 97, 98, 108, 101, 32, 114, 101, 116, 117, 114, \
110, 0}), msg, 40);
			break;
		case 412: 
			__MOVE(((CHAR[]){105, 108, 108, 101, 103, 97, 108, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, \
114, 32, 99, 97, 108, 108, 0}), msg, 50);
			break;
		case 413: 
			__MOVE(((CHAR[]){109, 105, 115, 115, 105, 110, 103, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, \
111, 114, 32, 99, 97, 108, 108, 0}), msg, 50);
			break;
		default: 
			Strings_IntToString(err, (void*)msg, msg__len);
			break;
	}
	__EXIT;
}

void DevCPM_InsertMarks (void)
{
	INTEGER i, j, x, y, n, line, col, beg, end;
	CHAR s[128];
	INTEGER _for__26, _for__25;
	__ENTER("DevCPM.InsertMarks");
	n = DevCPM_errors;
	if (n > 64) {
		n = 64;
	}
	i = 1;
	while (i < n) {
		x = DevCPM_errPos[__X(i, 64)];
		y = DevCPM_errNo[__X(i, 64)];
		j = i - 1;
		while (j >= 0 && DevCPM_errPos[__X(j, 64)] < x) {
			DevCPM_errPos[__X(j + 1, 64)] = DevCPM_errPos[__X(j, 64)];
			DevCPM_errNo[__X(j + 1, 64)] = DevCPM_errNo[__X(j, 64)];
			j -= 1;
		}
		DevCPM_errPos[__X(j + 1, 64)] = x;
		DevCPM_errNo[__X(j + 1, 64)] = y;
		i += 1;
	}
	if (n > 0) {
		while (n > 0) {
			n -= 1;
			DevCPM_LineColOf(DevCPM_errPos[__X(n, 64)], &line, &col, &beg, &end);
			if (DevCPM_name[0] == 0) {
				Console_WriteStr((void*)((CHAR[]){63, 63, 63, 0}), 4);
			} else {
				Console_WriteStr((void*)DevCPM_name, 256);
			}
			Console_WriteChar((CHAR)L':');
			Strings_IntToString(line, (void*)s, 128);
			Console_WriteStr((void*)s, 128);
			Console_WriteChar((CHAR)L':');
			Strings_IntToString(col, (void*)s, 128);
			Console_WriteStr((void*)s, 128);
			Console_WriteChar((CHAR)L':');
			Strings_IntToString(DevCPM_errPos[__X(n, 64)], (void*)s, 128);
			Console_WriteStr((void*)s, 128);
			Console_WriteStr((void*)((CHAR[]){58, 32, 0}), 3);
			DevCPM_GetErrorMsg(DevCPM_errNo[__X(n, 64)], (void*)s, 128);
			Console_WriteStr((void*)s, 128);
			Console_WriteLn();
			Console_WriteStr((void*)((CHAR[]){32, 32, 0}), 3);
			_for__26 = end;
			i = beg;
			while (i <= _for__26) {
				if ((DevCPM_in->data)[__X(i, DevCPM_in->len[0])] == 9) {
					Console_WriteStr((void*)((CHAR[]){32, 32, 0}), 3);
				} else {
					Console_WriteChar((DevCPM_in->data)[__X(i, DevCPM_in->len[0])]);
				}
				i += 1;
			}
			Console_WriteLn();
			Console_WriteStr((void*)((CHAR[]){32, 32, 0}), 3);
			_for__25 = col - 2;
			i = 1;
			while (i <= _for__25) {
				Console_WriteChar((CHAR)L' ');
				i += 1;
			}
			Console_WriteChar((CHAR)L'^');
			Console_WriteLn();
			Console_WriteLn();
		}
	}
	__EXIT;
}

static void DevCPM_InitCrcTab (void)
{
	INTEGER x, c, i;
	__ENTER("DevCPM.InitCrcTab");
	x = 0;
	while (x < 256) {
		c = __ASHL(x, 24, INTEGER);
		i = 0;
		while (i < 8) {
			if (c < 0) {
				c = (INTEGER)((SET)__ASHL(c, 1, INTEGER) ^ 0x04c11db7);
			} else {
				c = __ASHL(c, 1, INTEGER);
			}
			i += 1;
		}
		DevCPM_crc32tab[__X((INTEGER)((SET)x ^ 0xff), 256)] = (INTEGER)((SET)c ^ 0xff);
		x += 1;
	}
	__EXIT;
}

void DevCPM_FPrint (INTEGER *fp, INTEGER val)
{
	INTEGER c;
	__ENTER("DevCPM.FPrint");
	c = (INTEGER)((SET)__ASHL(*fp, 8, INTEGER) ^ (SET)DevCPM_crc32tab[__X(__MASK((INTEGER)((SET)__ASHR(*fp, \
24, INTEGER) ^ (SET)__ASHR(val, 24, INTEGER)), -256), 256)]);
	c = (INTEGER)((SET)__ASHL(c, 8, INTEGER) ^ (SET)DevCPM_crc32tab[__X(__MASK((INTEGER)((SET)__ASHR(c, 24, \
INTEGER) ^ (SET)__ASHR(val, 16, INTEGER)), -256), 256)]);
	c = (INTEGER)((SET)__ASHL(c, 8, INTEGER) ^ (SET)DevCPM_crc32tab[__X(__MASK((INTEGER)((SET)__ASHR(c, 24, \
INTEGER) ^ (SET)__ASHR(val, 8, INTEGER)), -256), 256)]);
	*fp = (INTEGER)((SET)__ASHL(c, 8, INTEGER) ^ (SET)DevCPM_crc32tab[__X(__MASK((INTEGER)((SET)__ASHR(c, \
24, INTEGER) ^ (SET)val), -256), 256)]);
	__EXIT;
}

void DevCPM_FPrintSet (INTEGER *fp, SET set)
{
	__ENTER("DevCPM.FPrintSet");
	DevCPM_FPrint(fp, (INTEGER)set);
	__EXIT;
}

void DevCPM_FPrintReal (INTEGER *fp, SHORTREAL real)
{
	__ENTER("DevCPM.FPrintReal");
	DevCPM_FPrint(fp, __VAL(INTEGER, real));
	__EXIT;
}

void DevCPM_FPrintLReal (INTEGER *fp, REAL lr)
{
	__ENTER("DevCPM.FPrintLReal");
	DevCPM_FPrint(fp, DevCPM_LoWord(lr));
	DevCPM_FPrint(fp, DevCPM_HiWord(lr));
	__EXIT;
}

static void DevCPM_ChkSum (INTEGER *fp, INTEGER val)
{
	__ENTER("DevCPM.ChkSum");
	*fp = (INTEGER)((SET)__ASHL(*fp, 8, INTEGER) ^ (SET)DevCPM_crc32tab[__X(__MASK((INTEGER)((SET)__ASHR(*fp, \
24, INTEGER) ^ (SET)val), -256), 256)]);
	__EXIT;
}

static void DevCPM_WriteLInt (Files_Writer w, INTEGER i)
{
	__ENTER("DevCPM.WriteLInt");
	DevCPM_ChkSum(&DevCPM_checksum, i);
	__Files_Writer_WriteByte(w, (BYTE)__MASK(i, -256));
	i = __ASHR(i, 8, INTEGER);
	DevCPM_ChkSum(&DevCPM_checksum, i);
	__Files_Writer_WriteByte(w, (BYTE)__MASK(i, -256));
	i = __ASHR(i, 8, INTEGER);
	DevCPM_ChkSum(&DevCPM_checksum, i);
	__Files_Writer_WriteByte(w, (BYTE)__MASK(i, -256));
	i = __ASHR(i, 8, INTEGER);
	DevCPM_ChkSum(&DevCPM_checksum, i);
	__Files_Writer_WriteByte(w, (BYTE)__MASK(i, -256));
	__EXIT;
}

static void DevCPM_ReadLInt (Files_Reader r, INTEGER *i)
{
	BYTE b;
	INTEGER x;
	__ENTER("DevCPM.ReadLInt");
	__Files_Reader_ReadByte(r, &b);
	x = __MASK((INTEGER)b, -256);
	DevCPM_ChkSum(&DevCPM_checksum, b);
	__Files_Reader_ReadByte(r, &b);
	x = x + __ASHL(__MASK((INTEGER)b, -256), 8, INTEGER);
	DevCPM_ChkSum(&DevCPM_checksum, b);
	__Files_Reader_ReadByte(r, &b);
	x = x + __ASHL(__MASK((INTEGER)b, -256), 16, INTEGER);
	DevCPM_ChkSum(&DevCPM_checksum, b);
	__Files_Reader_ReadByte(r, &b);
	*i = x + __ASHL((INTEGER)b, 24, INTEGER);
	DevCPM_ChkSum(&DevCPM_checksum, b);
	__EXIT;
}

static void DevCPM_WriteNum (Files_Writer w, INTEGER i)
{
	__ENTER("DevCPM.WriteNum");
	while (i < -64 || i > 63) {
		DevCPM_ChkSum(&DevCPM_checksum, __MASK(i, -128) - 128);
		__Files_Writer_WriteByte(w, (BYTE)(__MASK(i, -128) - 128));
		i = __ASHR(i, 7, INTEGER);
	}
	DevCPM_ChkSum(&DevCPM_checksum, __MASK(i, -128));
	__Files_Writer_WriteByte(w, (BYTE)__MASK(i, -128));
	__EXIT;
}

static void DevCPM_ReadNum (Files_Reader r, INTEGER *i)
{
	BYTE b;
	INTEGER s, y;
	__ENTER("DevCPM.ReadNum");
	s = 0;
	y = 0;
	__Files_Reader_ReadByte(r, &b);
	if (!r->eof) {
		DevCPM_ChkSum(&DevCPM_checksum, b);
	}
	while ((INTEGER)b < 0) {
		y += __ASH((INTEGER)b + 128, s, INTEGER);
		s += 7;
		__Files_Reader_ReadByte(r, &b);
		DevCPM_ChkSum(&DevCPM_checksum, b);
	}
	*i = __ASH(__MASK((INTEGER)b + 64, -128) - 64, s, INTEGER) + y;
	__EXIT;
}

static void DevCPM_WriteNumSet (Files_Writer w, SET x)
{
	__ENTER("DevCPM.WriteNumSet");
	DevCPM_WriteNum(w, (INTEGER)x);
	__EXIT;
}

static void DevCPM_ReadNumSet (Files_Reader r, SET *x)
{
	INTEGER i;
	__ENTER("DevCPM.ReadNumSet");
	DevCPM_ReadNum(r, &i);
	*x = (SET)i;
	__EXIT;
}

static void DevCPM_WriteReal (Files_Writer w, SHORTREAL x)
{
	__ENTER("DevCPM.WriteReal");
	DevCPM_WriteLInt(w, __VAL(INTEGER, x));
	__EXIT;
}

static void DevCPM_ReadReal (Files_Reader r, SHORTREAL *x)
{
	INTEGER i;
	__ENTER("DevCPM.ReadReal");
	DevCPM_ReadLInt(r, &i);
	*x = __VAL(SHORTREAL, i);
	__EXIT;
}

static void DevCPM_WriteLReal (Files_Writer w, REAL x)
{
	__ENTER("DevCPM.WriteLReal");
	DevCPM_WriteLInt(w, DevCPM_LoWord(x));
	DevCPM_WriteLInt(w, DevCPM_HiWord(x));
	__EXIT;
}

static void DevCPM_ReadLReal (Files_Reader r, REAL *x)
{
	INTEGER h, l;
	__ENTER("DevCPM.ReadLReal");
	DevCPM_ReadLInt(r, &l);
	DevCPM_ReadLInt(r, &h);
	*x = DevCPM_Compound(l, h);
	__EXIT;
}

void DevCPM_SymRCh (SHORTCHAR *ch)
{
	BYTE b;
	__ENTER("DevCPM.SymRCh");
	__Files_Reader_ReadByte(DevCPM_inSym, &b);
	*ch = (SHORTCHAR)b;
	DevCPM_ChkSum(&DevCPM_checksum, b);
	__EXIT;
}

INTEGER DevCPM_SymRInt (void)
{
	INTEGER k;
	__ENTER("DevCPM.SymRInt");
	DevCPM_ReadNum(DevCPM_inSym, &k);
	__EXIT;
	return k;
}

void DevCPM_SymRSet (SET *s)
{
	__ENTER("DevCPM.SymRSet");
	DevCPM_ReadNumSet(DevCPM_inSym, s);
	__EXIT;
}

void DevCPM_SymRReal (SHORTREAL *r)
{
	__ENTER("DevCPM.SymRReal");
	DevCPM_ReadReal(DevCPM_inSym, r);
	__EXIT;
}

void DevCPM_SymRLReal (REAL *lr)
{
	__ENTER("DevCPM.SymRLReal");
	DevCPM_ReadLReal(DevCPM_inSym, lr);
	__EXIT;
}

BOOLEAN DevCPM_eofSF (void)
{
	__ENTER("DevCPM.eofSF");
	__EXIT;
	return DevCPM_inSym->eof;
}

static struct OldSym__46 {
	INTEGER *tag;
	struct OldSym__46 *lnk;
} *OldSym__46_s;

static Files_File __47 (Files_Name path, SHORTCHAR *modName, INTEGER modName__len, BOOLEAN legacy);

static Files_File __47 (Files_Name path, SHORTCHAR *modName, INTEGER modName__len, BOOLEAN legacy)
{
	Files_File f = NIL;
	INTEGER res;
	Files_Locator loc = NIL;
	Files_Name dir, name;
	__ENTER("DevCPM.Old");
	Kernel_Utf8ToString((void*)modName, modName__len, (void*)name, 256, &res);
	loc = __Files_Directory_This(Files_dir, (void*)path, 256);
	if (legacy) {
		Kernel_SplitName(name, 256, (void*)dir, 256, (void*)name, 256);
		Kernel_MakeFileName((void*)name, 256, (CHAR*)((CHAR[]){111, 115, 102, 0}), 4);
		loc = __Files_Locator_This(__Files_Locator_This(loc, (void*)dir, 256), (void*)DevCPM_symDir, 16);
		f = __Files_Directory_Old(Files_dir, loc, name, 1);
		if (f == NIL && dir[0] == 0) {
			loc = __Files_Locator_This(__Files_Locator_This(__Files_Directory_This(Files_dir, (void*)path, 256), \
(void*)((CHAR[]){83, 121, 115, 116, 101, 109, 0}), 7), (void*)DevCPM_symDir, 16);
			f = __Files_Directory_Old(Files_dir, loc, name, 1);
		}
	} else {
		Kernel_MakeFileName((void*)name, 256, (CHAR*)((CHAR[]){111, 115, 102, 0}), 4);
		f = __Files_Directory_Old(Files_dir, loc, name, 1);
	}
	__EXIT;
	return f;
}

void DevCPM_OldSym (SHORTCHAR *modName, INTEGER modName__len, BOOLEAN *done)
{
	INTEGER tag;
	DevCPM_Directory d = NIL;
	struct OldSym__46 _s;
	__ENTER("DevCPM.OldSym");
	_s.tag = &tag;
	_s.lnk = OldSym__46_s;
	OldSym__46_s = &_s;
	*done = 0;
	if (__STRCMPSS(modName, "@file") == 0) {
		DevCPM_oldSymFile = DevCPM_file;
	} else {
		DevCPM_oldSymFile = __47(DevCPM_symPath, (void*)modName, modName__len, DevCPM_legacy);
		d = DevCPM_symList;
		while (DevCPM_oldSymFile == NIL && d != NIL) {
			DevCPM_oldSymFile = __47(d->path, (void*)modName, modName__len, d->legacy);
			d = d->next;
		}
	}
	if (DevCPM_oldSymFile != NIL) {
		DevCPM_inSym = __Files_File_NewReader(DevCPM_oldSymFile, DevCPM_inSym);
		if (DevCPM_inSym != NIL) {
			DevCPM_ReadLInt(DevCPM_inSym, &tag);
			if (tag == 1867469638) {
				*done = 1;
			} else {
				DevCPM_err(151);
			}
		}
	}
	OldSym__46_s = _s.lnk;
	__EXIT;
}

void DevCPM_CloseOldSym (void)
{
	__ENTER("DevCPM.CloseOldSym");
	if (DevCPM_oldSymFile != NIL) {
		__Files_File_Close(DevCPM_oldSymFile);
		DevCPM_oldSymFile = NIL;
	}
	__EXIT;
}

void DevCPM_SymWCh (SHORTCHAR ch)
{
	__ENTER("DevCPM.SymWCh");
	DevCPM_ChkSum(&DevCPM_checksum, (SHORTINT)ch);
	__Files_Writer_WriteByte(DevCPM_outSym, (BYTE)ch);
	__EXIT;
}

void DevCPM_SymWInt (INTEGER i)
{
	__ENTER("DevCPM.SymWInt");
	DevCPM_WriteNum(DevCPM_outSym, i);
	__EXIT;
}

void DevCPM_SymWSet (SET s)
{
	__ENTER("DevCPM.SymWSet");
	DevCPM_WriteNumSet(DevCPM_outSym, s);
	__EXIT;
}

void DevCPM_SymWReal (SHORTREAL r)
{
	__ENTER("DevCPM.SymWReal");
	DevCPM_WriteReal(DevCPM_outSym, r);
	__EXIT;
}

void DevCPM_SymWLReal (REAL r)
{
	__ENTER("DevCPM.SymWLReal");
	DevCPM_WriteLReal(DevCPM_outSym, r);
	__EXIT;
}

void DevCPM_SymReset (void)
{
	__ENTER("DevCPM.SymReset");
	__Files_Writer_SetPos(DevCPM_outSym, 4);
	__EXIT;
}

void DevCPM_NewSym (SHORTCHAR *modName, INTEGER modName__len)
{
	INTEGER res;
	Files_Locator loc = NIL;
	Files_Name dir;
	__ENTER("DevCPM.NewSym");
	Kernel_Utf8ToString((void*)modName, modName__len, (void*)DevCPM_ObjFName, 256, &res);
	loc = __Files_Directory_This(Files_dir, (void*)DevCPM_symPath, 256);
	if (DevCPM_legacy) {
		Kernel_SplitName(DevCPM_ObjFName, 256, (void*)dir, 256, (void*)DevCPM_ObjFName, 256);
		loc = __Files_Locator_This(__Files_Locator_This(loc, (void*)dir, 256), (void*)DevCPM_symDir, 16);
	}
	DevCPM_symFile = __Files_Directory_New(Files_dir, loc, 1);
	if (DevCPM_symFile != NIL) {
		DevCPM_outSym = __Files_File_NewWriter(DevCPM_symFile, NIL);
		DevCPM_WriteLInt(DevCPM_outSym, 1867469638);
	} else {
		DevCPM_err(153);
	}
	__EXIT;
}

void DevCPM_RegisterNewSym (void)
{
	INTEGER res;
	Files_Name name;
	__ENTER("DevCPM.RegisterNewSym");
	if (DevCPM_symFile != NIL) {
		__STRCOPYLL(DevCPM_ObjFName, name, 256);
		Kernel_MakeFileName((void*)name, 256, (CHAR*)((CHAR[]){111, 115, 102, 0}), 4);
		__Files_File_Register(DevCPM_symFile, name, (CHAR*)((CHAR[]){111, 115, 102, 0}), 1, &res);
		DevCPM_symFile = NIL;
	}
	__EXIT;
}

void DevCPM_DeleteNewSym (void)
{
	__ENTER("DevCPM.DeleteNewSym");
	if (DevCPM_symFile != NIL) {
		__Files_File_Close(DevCPM_symFile);
		DevCPM_symFile = NIL;
	}
	__EXIT;
}

void DevCPM_ObjW (SHORTCHAR ch)
{
	__ENTER("DevCPM.ObjW");
	__Files_Writer_WriteByte(DevCPM_outObj, (BYTE)ch);
	__EXIT;
}

void DevCPM_ObjWNum (INTEGER i)
{
	__ENTER("DevCPM.ObjWNum");
	DevCPM_WriteNum(DevCPM_outObj, i);
	__EXIT;
}

static void DevCPM_ObjWInt (SHORTINT i)
{
	__ENTER("DevCPM.ObjWInt");
	__Files_Writer_WriteByte(DevCPM_outObj, (BYTE)__MASK((INTEGER)i, -256));
	__Files_Writer_WriteByte(DevCPM_outObj, (BYTE)__ASHR((INTEGER)i, 8, INTEGER));
	__EXIT;
}

void DevCPM_ObjWLInt (INTEGER i)
{
	__ENTER("DevCPM.ObjWLInt");
	DevCPM_ObjWInt((SHORTINT)__MASK(i, -65536));
	DevCPM_ObjWInt((SHORTINT)__ASHR(i, 16, INTEGER));
	__EXIT;
}

typedef
	BYTE (*__42);

void DevCPM_ObjWBytes (SHORTCHAR *bytes, INTEGER bytes__len, INTEGER n)
{
	__42 p = NIL;
	__ENTER("DevCPM.ObjWBytes");
	p = (__42)((INTEGER)bytes);
	__Files_Writer_WriteBytes(DevCPM_outObj, (void*)p, 1048576, 0, n);
	__EXIT;
}

INTEGER DevCPM_ObjLen (void)
{
	__ENTER("DevCPM.ObjLen");
	__EXIT;
	return __Files_Writer_Pos(DevCPM_outObj);
}

void DevCPM_ObjSet (INTEGER pos)
{
	__ENTER("DevCPM.ObjSet");
	__Files_Writer_SetPos(DevCPM_outObj, pos);
	__EXIT;
}

void DevCPM_NewObj (SHORTCHAR *modName, INTEGER modName__len)
{
	INTEGER res;
	Files_Locator loc = NIL;
	Files_Name dir;
	__ENTER("DevCPM.NewObj");
	DevCPM_errpos = 0;
	Kernel_Utf8ToString((void*)modName, modName__len, (void*)DevCPM_ObjFName, 256, &res);
	loc = __Files_Directory_This(Files_dir, (void*)DevCPM_codePath, 256);
	if (DevCPM_legacy) {
		Kernel_SplitName(DevCPM_ObjFName, 256, (void*)dir, 256, (void*)DevCPM_ObjFName, 256);
		loc = __Files_Locator_This(__Files_Locator_This(loc, (void*)dir, 256), (void*)DevCPM_codeDir, 16);
	}
	DevCPM_objFile = __Files_Directory_New(Files_dir, loc, 1);
	if (DevCPM_objFile != NIL) {
		DevCPM_outObj = __Files_File_NewWriter(DevCPM_objFile, NIL);
		DevCPM_WriteLInt(DevCPM_outObj, 1867465542);
	} else {
		DevCPM_err(153);
	}
	__EXIT;
}

void DevCPM_RegisterObj (void)
{
	INTEGER res;
	Files_Name name;
	__ENTER("DevCPM.RegisterObj");
	if (DevCPM_objFile != NIL) {
		__STRCOPYLL(DevCPM_ObjFName, name, 256);
		Kernel_MakeFileName((void*)name, 256, (CHAR*)((CHAR[]){111, 99, 102, 0}), 4);
		__Files_File_Register(DevCPM_objFile, name, (CHAR*)((CHAR[]){111, 99, 102, 0}), 1, &res);
		DevCPM_objFile = NIL;
		DevCPM_outObj = NIL;
	}
	__EXIT;
}

void DevCPM_DeleteObj (void)
{
	__ENTER("DevCPM.DeleteObj");
	if (DevCPM_objFile != NIL) {
		__Files_File_Close(DevCPM_objFile);
		DevCPM_objFile = NIL;
	}
	__EXIT;
}

static void DevCPM_InitHost (void)
{
	SHORTINT test;
	SHORTCHAR lo;
	__ENTER("DevCPM.InitHost");
	test = 1;
	__GET((INTEGER)&test, lo, SHORTCHAR);
	DevCPM_LEHost = lo == 1;
	DevCPM_InfReal = __VALSR((INTEGER)2139095040);
	DevCPM_MinReal32 = __VALSR((INTEGER)-8388609);
	DevCPM_MaxReal32 = __VALSR((INTEGER)2139095039);
	DevCPM_MinReal64 = DevCPM_Compound(-1, -1048577);
	DevCPM_MaxReal64 = DevCPM_Compound(-1, 2146435071);
	__EXIT;
}

static INTEGER DevCPM_Directory__rec__flds[] = {
	3, 
	0, 0, 1<<8 | 0x45, (INTEGER)Files_Name__desc,
	0, 512, 6<<8 | 0x45, 1,
	0, 516, 13<<8 | 0x45, (INTEGER)DevCPM_Directory__desc,
};
export INTEGER DevCPM_Directory__rec__desc[] = {
	-1, 
	0, 
	520,
	(INTEGER)&DevCPM__desc,
	18<<8 | 0x01,
	(INTEGER)(DevCPM_Directory__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)DevCPM_Directory__rec__flds, 
	516, -8
};
export INTEGER DevCPM_Directory__desc[] = {
	0,
	(INTEGER)&DevCPM__desc,
	29<<8 | 0x03,
	(INTEGER)(DevCPM_Directory__rec__desc + 2)
};
export INTEGER DevCPM__1__desc[] = {
	16,
	(INTEGER)&DevCPM__desc,
	0<<8 | 0x02,
	3
};
export INTEGER DevCPM__2__desc[] = {
	256,
	(INTEGER)&DevCPM__desc,
	0<<8 | 0x02,
	6
};
export INTEGER DevCPM__3__desc[] = {
	64,
	(INTEGER)&DevCPM__desc,
	0<<8 | 0x02,
	6
};
export INTEGER DevCPM__4__desc[] = {
	0,
	(INTEGER)&DevCPM__desc,
	0<<8 | 0x12,
	3
};
export INTEGER DevCPM__5__desc[] = {
	0,
	(INTEGER)&DevCPM__desc,
	0<<8 | 0x03,
	(INTEGER)DevCPM__4__desc
};
export INTEGER DevCPM__6__desc[] = {
	16,
	(INTEGER)&DevCPM__desc,
	0<<8 | 0x02,
	3
};
static SYSTEM_MODDESC *DevCPM__imp[] = {
	&Console__desc,
	&Files__desc,
	&Kernel__desc,
	&Strings__desc,
};
static INTEGER DevCPM__exp[] = {
	157,
	0x528c19ed, 0, 39<<8 | 0x41, 0,
	0x227d6f36, (INTEGER)DevCPM_ChkSum, 49<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)DevCPM_Close, 56<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)DevCPM_CloseOldSym, 62<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPM_Compound, 74<<8 | 0x14, 0,
	0x9149d921, 0, 83<<8 | 0x41, 0,
	0x7045e9e2, 0, 97<<8 | 0x41, 0,
	0x45497286, 0, 107<<8 | 0x41, 0,
	0x5814f4d6, (INTEGER)DevCPM_DeleteNewSym, 117<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)DevCPM_DeleteObj, 130<<8 | 0x44, 0,
	0xf420a263, 0xf420a263, 29<<8 | 0x42, (INTEGER)DevCPM_Directory__desc,
	0x776ee3f7, 0xedbad967, 18<<8 | 0x12, (INTEGER)(DevCPM_Directory__rec__desc + 2),
	0x3fb4e054, 0, 140<<8 | 0x41, 0,
	0x72789a6e, 0, 144<<8 | 0x41, 0,
	0x72789a6e, 0, 157<<8 | 0x41, 0,
	0x76b987d9, 0, 169<<8 | 0x41, 0,
	0x72789a6e, 0, 180<<8 | 0x41, 0,
	0x17aac86b, (INTEGER)DevCPM_FPrint, 194<<8 | 0x44, 0,
	0x2b246861, (INTEGER)DevCPM_FPrintLReal, 201<<8 | 0x44, 0,
	0x136bd5dc, (INTEGER)DevCPM_FPrintReal, 213<<8 | 0x44, 0,
	0x2fe575d6, (INTEGER)DevCPM_FPrintSet, 224<<8 | 0x44, 0,
	0xad25dc5c, (INTEGER)DevCPM_Get, 234<<8 | 0x44, 0,
	0x0a1b5f8c, (INTEGER)DevCPM_GetArraySysFlag, 238<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPM_GetErrorMsg, 254<<8 | 0x14, 0,
	0x0a1b5f8c, (INTEGER)DevCPM_GetPointerSysFlag, 266<<8 | 0x44, 0,
	0x0a1b5f8c, (INTEGER)DevCPM_GetProcSysFlag, 284<<8 | 0x44, 0,
	0x0a1b5f8c, (INTEGER)DevCPM_GetProcTypSysFlag, 299<<8 | 0x44, 0,
	0x0a1b5f8c, (INTEGER)DevCPM_GetRecordSysFlag, 317<<8 | 0x44, 0,
	0x28b57df0, (INTEGER)DevCPM_GetUtf8, 334<<8 | 0x44, 0,
	0x0a1b5f8c, (INTEGER)DevCPM_GetVarParSysFlag, 342<<8 | 0x44, 0,
	0x1b968b00, 0, 359<<8 | 0x41, 0,
	0x0b851a55, 0, 370<<8 | 0x41, 0,
	0xd233de46, 0, 380<<8 | 0x41, 0,
	0xd357f5b7, 0, 392<<8 | 0x41, 0,
	0x227d6f36, (INTEGER)DevCPM_HiWord, 404<<8 | 0x14, 0,
	0x6b668b8d, (INTEGER)&DevCPM_InfReal, 411<<8 | 0x43, 8,
	0x9df33dc3, (INTEGER)DevCPM_Init, 419<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPM_InitCrcTab, 424<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_InitHost, 435<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)DevCPM_InsertMarks, 444<<8 | 0x44, 0,
	0x44ec5d5b, (INTEGER)&DevCPM_LEHost, 456<<8 | 0x43, 1,
	0x227d6f36, (INTEGER)DevCPM_LineColOf, 463<<8 | 0x14, 0,
	0x4e27a847, (INTEGER)DevCPM_LineOf, 473<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPM_LoWord, 480<<8 | 0x14, 0,
	0x763274cb, (INTEGER)DevCPM_LogW, 487<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)DevCPM_LogWLn, 492<<8 | 0x44, 0,
	0x2a872fd3, (INTEGER)DevCPM_LogWNum, 499<<8 | 0x44, 0,
	0x5029be50, (INTEGER)DevCPM_LogWPar, 507<<8 | 0x44, 0,
	0x143ec369, (INTEGER)DevCPM_LogWStr, 515<<8 | 0x44, 0,
	0x2a872fd3, (INTEGER)DevCPM_Mark, 523<<8 | 0x44, 0,
	0x6e02b9e7, 0, 528<<8 | 0x41, 0,
	0x6e02b9e7, 0, 534<<8 | 0x41, 0,
	0x3f41e4b4, 0, 542<<8 | 0x41, 0,
	0x37afe43c, 0, 552<<8 | 0x41, 0,
	0x6b668b8d, (INTEGER)&DevCPM_MaxReal32, 561<<8 | 0x43, 8,
	0x6b668b8d, (INTEGER)&DevCPM_MaxReal64, 571<<8 | 0x43, 8,
	0x22136297, 0, 581<<8 | 0x41, 0,
	0x22136297, 0, 590<<8 | 0x41, 0,
	0x602db575, 0, 597<<8 | 0x41, 0,
	0x8eb6a400, 0, 607<<8 | 0x41, 0,
	0x564d045a, 0, 618<<8 | 0x41, 0,
	0x6b668b8d, (INTEGER)&DevCPM_MinReal32, 628<<8 | 0x43, 8,
	0x6b668b8d, (INTEGER)&DevCPM_MinReal64, 638<<8 | 0x43, 8,
	0x564d045a, 0, 648<<8 | 0x41, 0,
	0x76b987d9, 0, 657<<8 | 0x41, 0,
	0x1ebb3ba9, (INTEGER)DevCPM_NewObj, 669<<8 | 0x44, 0,
	0x1ebb3ba9, (INTEGER)DevCPM_NewSym, 676<<8 | 0x44, 0,
	0x95f06a08, (INTEGER)&DevCPM_ObjFName, 683<<8 | 0x13, (INTEGER)Files_Name__desc,
	0x779e2200, (INTEGER)DevCPM_ObjLen, 692<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)DevCPM_ObjSet, 699<<8 | 0x44, 0,
	0x37608962, (INTEGER)DevCPM_ObjW, 706<<8 | 0x44, 0,
	0xec49b30a, (INTEGER)DevCPM_ObjWBytes, 711<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPM_ObjWInt, 721<<8 | 0x14, 0,
	0x20a5e209, (INTEGER)DevCPM_ObjWLInt, 729<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)DevCPM_ObjWNum, 738<<8 | 0x44, 0,
	0x245a6d41, (INTEGER)DevCPM_OldSym, 746<<8 | 0x44, 0,
	0x45497286, 0, 753<<8 | 0x41, 0,
	0x45497286, 0, 765<<8 | 0x41, 0,
	0xee134280, (INTEGER)DevCPM_PropagateArrPtrSysFlag, 774<<8 | 0x44, 0,
	0xee134280, (INTEGER)DevCPM_PropagateRecPtrSysFlag, 797<<8 | 0x44, 0,
	0xee134280, (INTEGER)DevCPM_PropagateRecordSysFlag, 820<<8 | 0x44, 0,
	0x8eab1b35, (INTEGER)DevCPM_PutUtf8, 843<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPM_ReadLInt, 851<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_ReadLReal, 860<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_ReadNum, 870<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_ReadNumSet, 878<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_ReadReal, 889<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)DevCPM_RegisterNewSym, 898<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)DevCPM_RegisterObj, 913<<8 | 0x44, 0,
	0xec7721f5, (INTEGER)DevCPM_SymRCh, 925<<8 | 0x44, 0,
	0x779e2200, (INTEGER)DevCPM_SymRInt, 932<<8 | 0x44, 0,
	0xc73cea94, (INTEGER)DevCPM_SymRLReal, 940<<8 | 0x44, 0,
	0xff735729, (INTEGER)DevCPM_SymRReal, 950<<8 | 0x44, 0,
	0xc3fdf723, (INTEGER)DevCPM_SymRSet, 959<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)DevCPM_SymReset, 967<<8 | 0x44, 0,
	0x37608962, (INTEGER)DevCPM_SymWCh, 976<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)DevCPM_SymWInt, 983<<8 | 0x44, 0,
	0x1c2b4203, (INTEGER)DevCPM_SymWLReal, 991<<8 | 0x44, 0,
	0x2464ffbe, (INTEGER)DevCPM_SymWReal, 1001<<8 | 0x44, 0,
	0x18ea5fb4, (INTEGER)DevCPM_SymWSet, 1010<<8 | 0x44, 0,
	0x3f8514f4, (INTEGER)DevCPM_ValidGuid, 1018<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPM_WriteLInt, 1028<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_WriteLReal, 1038<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_WriteNum, 1049<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_WriteNumSet, 1058<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPM_WriteReal, 1070<<8 | 0x14, 0,
	0x6ac3a450, 0, 1080<<8 | 0x41, 0,
	0x57e82b87, (INTEGER)&DevCPM_breakpc, 1090<<8 | 0x43, 6,
	0x57e82b87, (INTEGER)&DevCPM_checksum, 1098<<8 | 0x43, 6,
	0xae0db1f2, (INTEGER)&DevCPM_codeDir, 1107<<8 | 0x43, (INTEGER)DevCPM__1__desc,
	0xdcfd0d85, (INTEGER)&DevCPM_codePath, 1115<<8 | 0x43, (INTEGER)Files_Name__desc,
	0x5fcf3f34, 0, 1124<<8 | 0x41, 0,
	0x5b0e2283, 0, 1128<<8 | 0x41, 0,
	0x5b0e2283, 0, 1137<<8 | 0x41, 0,
	0x5a68ca61, (INTEGER)&DevCPM_crc32tab, 1142<<8 | 0x13, (INTEGER)DevCPM__2__desc,
	0x57e82b87, (INTEGER)&DevCPM_curpos, 1151<<8 | 0x43, 6,
	0x649a54dc, (INTEGER)DevCPM_eofSF, 1158<<8 | 0x44, 0,
	0x20a5e209, (INTEGER)DevCPM_err, 1164<<8 | 0x44, 0,
	0xa73feeb8, (INTEGER)&DevCPM_errNo, 1168<<8 | 0x13, (INTEGER)DevCPM__3__desc,
	0xa73feeb8, (INTEGER)&DevCPM_errPos, 1174<<8 | 0x13, (INTEGER)DevCPM__3__desc,
	0x57e82b87, (INTEGER)&DevCPM_errors, 1181<<8 | 0x43, 6,
	0x57e82b87, (INTEGER)&DevCPM_errpos, 1188<<8 | 0x43, 6,
	0x1c84b987, (INTEGER)&DevCPM_file, 1195<<8 | 0x43, (INTEGER)Files_File__desc,
	0xd5007e3b, (INTEGER)&DevCPM_in, 1200<<8 | 0x13, (INTEGER)DevCPM__5__desc,
	0xb87bb061, (INTEGER)&DevCPM_inSym, 1203<<8 | 0x13, (INTEGER)Files_Reader__desc,
	0x528c19ed, 0, 1209<<8 | 0x41, 0,
	0x4ccb49e8, 0, 1219<<8 | 0x41, 0,
	0x480a545f, 0, 1225<<8 | 0x41, 0,
	0x7045e9e2, 0, 1230<<8 | 0x41, 0,
	0x528c19ed, 0, 1240<<8 | 0x41, 0,
	0x1ee54c0a, (INTEGER)&DevCPM_lastpos, 1249<<8 | 0x13, 6,
	0x45497286, 0, 1257<<8 | 0x41, 0,
	0x44ec5d5b, (INTEGER)&DevCPM_legacy, 6<<8 | 0x43, 1,
	0x41886f31, 0, 1262<<8 | 0x41, 0,
	0x564d045a, 0, 1270<<8 | 0x41, 0,
	0xdcfd0d85, (INTEGER)&DevCPM_name, 1279<<8 | 0x43, (INTEGER)Files_Name__desc,
	0x7484f455, 0, 1284<<8 | 0x41, 0,
	0x44ec5d5b, (INTEGER)&DevCPM_noerr, 1291<<8 | 0x43, 1,
	0x4ccb49e8, 0, 1297<<8 | 0x41, 0,
	0x5589de0a, (INTEGER)&DevCPM_objFile, 1304<<8 | 0x13, (INTEGER)Files_File__desc,
	0x5589de0a, (INTEGER)&DevCPM_oldSymFile, 1312<<8 | 0x13, (INTEGER)Files_File__desc,
	0x6fa7963a, (INTEGER)&DevCPM_options, 1323<<8 | 0x43, 9,
	0x204427f5, (INTEGER)&DevCPM_outObj, 1331<<8 | 0x13, (INTEGER)Files_Writer__desc,
	0x204427f5, (INTEGER)&DevCPM_outSym, 1338<<8 | 0x13, (INTEGER)Files_Writer__desc,
	0x480a545f, 0, 1345<<8 | 0x41, 0,
	0x5fcf3f34, 0, 1352<<8 | 0x41, 0,
	0x57e82b87, (INTEGER)&DevCPM_searchpos, 1362<<8 | 0x43, 6,
	0x45497286, 0, 1372<<8 | 0x41, 0,
	0x41886f31, 0, 1376<<8 | 0x41, 0,
	0x57e82b87, (INTEGER)&DevCPM_startpos, 1385<<8 | 0x43, 6,
	0xae0db1f2, (INTEGER)&DevCPM_symDir, 1394<<8 | 0x43, (INTEGER)DevCPM__6__desc,
	0x5589de0a, (INTEGER)&DevCPM_symFile, 1401<<8 | 0x13, (INTEGER)Files_File__desc,
	0xc3bdec35, (INTEGER)&DevCPM_symList, 1409<<8 | 0x43, (INTEGER)DevCPM_Directory__desc,
	0xdcfd0d85, (INTEGER)&DevCPM_symPath, 1417<<8 | 0x43, (INTEGER)Files_Name__desc,
	0x6e02b9e7, 0, 1425<<8 | 0x41, 0,
	0x22136297, 0, 1432<<8 | 0x41, 0,
	0x57e82b87, (INTEGER)&DevCPM_verbose, 1437<<8 | 0x43, 6,
};
static char DevCPM__names[] = {
	0,
	'p','a','t','h',0,
	'l','e','g','a','c','y',0,
	'n','e','x','t',0,
	'D','i','r','e','c','t','o','r','y','^',0,
	'D','i','r','e','c','t','o','r','y',0,
	'C','P','r','o','c','F','l','a','g',0,
	'C','h','k','S','u','m',0,
	'C','l','o','s','e',0,
	'C','l','o','s','e','O','l','d','S','y','m',0,
	'C','o','m','p','o','u','n','d',0,
	'C','o','n','s','t','N','o','t','A','l','l','o','c',0,
	'D','A','r','r','S','i','z','e','A',0,
	'D','A','r','r','S','i','z','e','B',0,
	'D','e','l','e','t','e','N','e','w','S','y','m',0,
	'D','e','l','e','t','e','O','b','j',0,
	'E','o','t',0,
	'E','x','p','H','d','P','r','o','c','F','l','d',0,
	'E','x','p','H','d','P','t','r','F','l','d',0,
	'E','x','p','H','d','T','P','r','o','c',0,
	'E','x','p','H','d','U','t','P','t','r','F','l','d',0,
	'F','P','r','i','n','t',0,
	'F','P','r','i','n','t','L','R','e','a','l',0,
	'F','P','r','i','n','t','R','e','a','l',0,
	'F','P','r','i','n','t','S','e','t',0,
	'G','e','t',0,
	'G','e','t','A','r','r','a','y','S','y','s','F','l','a','g',0,
	'G','e','t','E','r','r','o','r','M','s','g',0,
	'G','e','t','P','o','i','n','t','e','r','S','y','s','F','l','a','g',0,
	'G','e','t','P','r','o','c','S','y','s','F','l','a','g',0,
	'G','e','t','P','r','o','c','T','y','p','S','y','s','F','l','a','g',0,
	'G','e','t','R','e','c','o','r','d','S','y','s','F','l','a','g',0,
	'G','e','t','U','t','f','8',0,
	'G','e','t','V','a','r','P','a','r','S','y','s','F','l','a','g',0,
	'H','d','P','r','o','c','N','a','m','e',0,
	'H','d','P','t','r','N','a','m','e',0,
	'H','d','T','P','r','o','c','N','a','m','e',0,
	'H','d','U','t','P','t','r','N','a','m','e',0,
	'H','i','W','o','r','d',0,
	'I','n','f','R','e','a','l',0,
	'I','n','i','t',0,
	'I','n','i','t','C','r','c','T','a','b',0,
	'I','n','i','t','H','o','s','t',0,
	'I','n','s','e','r','t','M','a','r','k','s',0,
	'L','E','H','o','s','t',0,
	'L','i','n','e','C','o','l','O','f',0,
	'L','i','n','e','O','f',0,
	'L','o','W','o','r','d',0,
	'L','o','g','W',0,
	'L','o','g','W','L','n',0,
	'L','o','g','W','N','u','m',0,
	'L','o','g','W','P','a','r',0,
	'L','o','g','W','S','t','r',0,
	'M','a','r','k',0,
	'M','a','x','C','C',0,
	'M','a','x','E','x','t','s',0,
	'M','a','x','H','a','l','t','N','r',0,
	'M','a','x','I','n','d','e','x',0,
	'M','a','x','R','e','a','l','3','2',0,
	'M','a','x','R','e','a','l','6','4',0,
	'M','a','x','R','e','g','N','r',0,
	'M','a','x','S','e','t',0,
	'M','a','x','S','t','r','u','c','t',0,
	'M','a','x','S','y','s','F','l','a','g',0,
	'M','i','n','H','a','l','t','N','r',0,
	'M','i','n','R','e','a','l','3','2',0,
	'M','i','n','R','e','a','l','6','4',0,
	'M','i','n','R','e','g','N','r',0,
	'N','E','W','u','s','i','n','g','A','d','r',0,
	'N','e','w','O','b','j',0,
	'N','e','w','S','y','m',0,
	'O','b','j','F','N','a','m','e',0,
	'O','b','j','L','e','n',0,
	'O','b','j','S','e','t',0,
	'O','b','j','W',0,
	'O','b','j','W','B','y','t','e','s',0,
	'O','b','j','W','I','n','t',0,
	'O','b','j','W','L','I','n','t',0,
	'O','b','j','W','N','u','m',0,
	'O','l','d','S','y','m',0,
	'P','o','i','n','t','e','r','S','i','z','e',0,
	'P','r','o','c','S','i','z','e',0,
	'P','r','o','p','a','g','a','t','e','A','r','r','P','t','r','S','y','s','F','l','a','g',0,
	'P','r','o','p','a','g','a','t','e','R','e','c','P','t','r','S','y','s','F','l','a','g',0,
	'P','r','o','p','a','g','a','t','e','R','e','c','o','r','d','S','y','s','F','l','a','g',0,
	'P','u','t','U','t','f','8',0,
	'R','e','a','d','L','I','n','t',0,
	'R','e','a','d','L','R','e','a','l',0,
	'R','e','a','d','N','u','m',0,
	'R','e','a','d','N','u','m','S','e','t',0,
	'R','e','a','d','R','e','a','l',0,
	'R','e','g','i','s','t','e','r','N','e','w','S','y','m',0,
	'R','e','g','i','s','t','e','r','O','b','j',0,
	'S','y','m','R','C','h',0,
	'S','y','m','R','I','n','t',0,
	'S','y','m','R','L','R','e','a','l',0,
	'S','y','m','R','R','e','a','l',0,
	'S','y','m','R','S','e','t',0,
	'S','y','m','R','e','s','e','t',0,
	'S','y','m','W','C','h',0,
	'S','y','m','W','I','n','t',0,
	'S','y','m','W','L','R','e','a','l',0,
	'S','y','m','W','R','e','a','l',0,
	'S','y','m','W','S','e','t',0,
	'V','a','l','i','d','G','u','i','d',0,
	'W','r','i','t','e','L','I','n','t',0,
	'W','r','i','t','e','L','R','e','a','l',0,
	'W','r','i','t','e','N','u','m',0,
	'W','r','i','t','e','N','u','m','S','e','t',0,
	'W','r','i','t','e','R','e','a','l',0,
	'a','l','l','S','y','s','V','a','l',0,
	'b','r','e','a','k','p','c',0,
	'c','h','e','c','k','s','u','m',0,
	'c','o','d','e','D','i','r',0,
	'c','o','d','e','P','a','t','h',0,
	'c','o','m',0,
	'c','o','m','A','w','a','r','e',0,
	'c','o','p','y',0,
	'c','r','c','3','2','t','a','b',0,
	'c','u','r','p','o','s',0,
	'e','o','f','S','F',0,
	'e','r','r',0,
	'e','r','r','N','o',0,
	'e','r','r','P','o','s',0,
	'e','r','r','o','r','s',0,
	'e','r','r','p','o','s',0,
	'f','i','l','e',0,
	'i','n',0,
	'i','n','S','y','m',0,
	'i','n','t','e','r','f','a','c','e',0,
	'i','n','v','a','r',0,
	'j','a','v','a',0,
	'j','a','v','a','A','w','a','r','e',0,
	'l','a','r','g','e','i','n','t',0,
	'l','a','s','t','p','o','s',0,
	'l','c','h','r',0,
	'l','e','n','t','i','e','r',0,
	'l','o','n','g','r','e','a','l',0,
	'n','a','m','e',0,
	'n','o','C','o','d','e',0,
	'n','o','e','r','r',0,
	'o','b','e','r','o','n',0,
	'o','b','j','F','i','l','e',0,
	'o','l','d','S','y','m','F','i','l','e',0,
	'o','p','t','i','o','n','s',0,
	'o','u','t','O','b','j',0,
	'o','u','t','S','y','m',0,
	'o','u','t','v','a','r',0,
	'r','e','a','l','C','o','n','s','t',0,
	's','e','a','r','c','h','p','o','s',0,
	's','o','m',0,
	's','o','m','A','w','a','r','e',0,
	's','t','a','r','t','p','o','s',0,
	's','y','m','D','i','r',0,
	's','y','m','F','i','l','e',0,
	's','y','m','L','i','s','t',0,
	's','y','m','P','a','t','h',0,
	's','y','s','I','m','p',0,
	't','r','a','p',0,
	'v','e','r','b','o','s','e',0,
};
static INTEGER DevCPM__ptrs[] = {
	(INTEGER)&DevCPM_file + 0, 
	(INTEGER)&DevCPM_symList + 0, 
	(INTEGER)&DevCPM_in + 0, 
	(INTEGER)&DevCPM_oldSymFile + 0, 
	(INTEGER)&DevCPM_symFile + 0, 
	(INTEGER)&DevCPM_objFile + 0, 
	(INTEGER)&DevCPM_inSym + 0, 
	(INTEGER)&DevCPM_outSym + 0, 
	(INTEGER)&DevCPM_outObj + 0, 
};
struct SYSTEM_MODDESC DevCPM__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 5}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	DevCPM__body,
	0,
	4, /* nofimps */ 
	9, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	DevCPM__names,
	DevCPM__ptrs,
	DevCPM__imp,
	(SYSTEM_DIRECTORY*)DevCPM__exp,
	"DevCPM"
};

export void DevCPM__reg()
{
	__BEGREG(DevCPM__desc);
	Kernel__reg();
	Files__reg();
	Console__reg();
	Strings__reg();
	__REGMOD(DevCPM__desc);
	__ENDREG;
}

export void DevCPM__body()
{
	__BEGBODY(DevCPM__desc);
	Kernel__body();
	Files__body();
	Console__body();
	Strings__body();
	DevCPM_InitCrcTab();
	DevCPM_InitHost();
	__ENDBODY;
}
