/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "DevCPM.h"
#include "Files.h"
#include "DevCPT.h"
#include "DevCPB.h"
#include "DevCPS.h"

typedef
	struct DevCPP_Elem__rec *DevCPP_Elem;

typedef
	struct DevCPP_Elem__rec {
		DevCPP_Elem next;
		DevCPT_Struct struct_;
		DevCPT_Object obj, base;
		INTEGER pos;
		DevCPT_String name;
	} DevCPP_Elem__rec;


static BYTE DevCPP_sym, DevCPP_level;
static SHORTINT DevCPP_LoopLevel;
static DevCPT_Node DevCPP_TDinit, DevCPP_lastTDinit;
static DevCPP_Elem DevCPP_userList, DevCPP_recList;
static BOOLEAN DevCPP_hasReturn;

export INTEGER DevCPP_Elem__rec__desc[];
export SYSTEM_TYPEDESC *DevCPP_Elem__rec__typ = (SYSTEM_TYPEDESC*)(DevCPP_Elem__rec__desc + 2);
export INTEGER DevCPP_Elem__desc[];
export SYSTEM_TYPEDESC *DevCPP_Elem__typ = (SYSTEM_TYPEDESC*)DevCPP_Elem__desc;

static void DevCPP_ActualParameters (DevCPT_Node *aparlist, DevCPT_Object fpar, DevCPT_Node *pre, DevCPT_Node \
*lastp);
static void DevCPP_ArrayType (DevCPT_Struct *typ);
static void DevCPP_Block (DevCPT_Node *procdec, DevCPT_Node *statseq);
static void DevCPP_CaseLabelList (DevCPT_Node *lab, DevCPT_Node *root, SHORTINT LabelForm, INTEGER *min, \
INTEGER *max);
static void DevCPP_CheckAlloc (DevCPT_Struct *typ, BOOLEAN dynAllowed, INTEGER pos);
static void DevCPP_CheckForwardTypes (void);
static void DevCPP_CheckMark (DevCPT_Object obj);
static void DevCPP_CheckOverwrite (DevCPT_Object proc, DevCPT_Object base, DevCPT_Struct rec);
static void DevCPP_CheckRecords (DevCPP_Elem rec);
static void DevCPP_CheckRecursiveType (DevCPT_Struct outer, DevCPT_Struct inner, INTEGER pos);
static void DevCPP_CheckSym (SHORTINT s);
static void DevCPP_CheckSysFlag (SHORTINT *sysflag, void (*GetSF)(SHORTCHAR*, INTEGER , SHORTINT, SHORTINT*));
static void DevCPP_CheckUnimpl (DevCPT_Object m, DevCPT_Struct typ, INTEGER pos);
static void DevCPP_ConstExpression (DevCPT_Node *x);
static void DevCPP_Element (DevCPT_Node *x);
static void DevCPP_Expression (DevCPT_Node *x);
static void DevCPP_Factor (DevCPT_Node *x);
static void DevCPP_FixType (DevCPT_Struct struct_, DevCPT_Object obj, DevCPT_Struct typ, INTEGER pos);
static void DevCPP_FormalParameters (DevCPT_Object *firstPar, DevCPT_Struct *resTyp, DevCPT_String *name);
static void DevCPP_GetAttributes (DevCPT_Object proc, DevCPT_Object base, DevCPT_Struct owner);
static BOOLEAN DevCPP_IncompleteType (DevCPT_Struct typ);
export void DevCPP_Module (DevCPT_Node *prog);
static void DevCPP_PointerType (DevCPT_Struct *typ);
static void DevCPP_ProcedureDeclaration (DevCPT_Node *x);
static void DevCPP_Receiver (BYTE *mode, BYTE *vis, DevCPT_Name name, DevCPT_Struct *typ, DevCPT_Struct \
*rec);
static void DevCPP_RecordType (DevCPT_Struct *typ, DevCPT_Object attr);
static void DevCPP_SetType (DevCPT_Struct struct_, DevCPT_Object obj, DevCPT_Struct typ, DevCPT_String \
name);
static void DevCPP_Sets (DevCPT_Node *x);
static void DevCPP_SimpleExpression (DevCPT_Node *x);
static void DevCPP_StandProcCall (DevCPT_Node *x);
static void DevCPP_StatSeq (DevCPT_Node *stat);
static void DevCPP_Term (DevCPT_Node *x);
static void DevCPP_Type (DevCPT_Struct *typ, DevCPT_String *name);
static void DevCPP_err (SHORTINT n);
static void DevCPP_qualident (DevCPT_Object *id);
static void DevCPP_selector (DevCPT_Node *x);

export void DevCPP__reg();
export void DevCPP__body();
export struct SYSTEM_MODDESC DevCPP__desc;


static BOOLEAN DevCPP_IncompleteType (DevCPT_Struct typ)
{
	__ENTER("DevCPP.IncompleteType");
	if ((INTEGER)typ->form == 13) {
		if (typ == DevCPT_sysptrtyp) {
			__EXIT;
			return 0;
		}
		typ = typ->BaseTyp;
	}
	__EXIT;
	return typ == DevCPT_undftyp || (INTEGER)typ->comp == 4 && typ->BaseTyp == DevCPT_undftyp;
}

static void DevCPP_SetType (DevCPT_Struct struct_, DevCPT_Object obj, DevCPT_Struct typ, DevCPT_String \
name)
{
	DevCPP_Elem u = NIL;
	__ENTER("DevCPP.SetType");
	if (obj != NIL) {
		obj->typ = typ;
	} else {
		struct_->BaseTyp = typ;
	}
	if (name != NIL) {
		u = __NEW(DevCPP_Elem__rec__typ);
		u->struct_ = struct_;
		u->obj = obj;
		u->pos = DevCPM_errpos;
		u->name = name;
		u->next = DevCPP_userList;
		DevCPP_userList = u;
	}
	__EXIT;
}

static void DevCPP_CheckAlloc (DevCPT_Struct *typ, BOOLEAN dynAllowed, INTEGER pos)
{
	__ENTER("DevCPP.CheckAlloc");
	(*typ)->pvused = 1;
	if ((INTEGER)(*typ)->comp == 3) {
		if (!dynAllowed) {
			DevCPM_Mark(88, pos);
			*typ = DevCPT_undftyp;
		}
	} else if ((INTEGER)(*typ)->comp == 4) {
		if ((INTEGER)(*typ)->attribute == 17 || (INTEGER)(*typ)->attribute == 18 && (INTEGER)(*typ)->mno != \
0) {
			DevCPM_Mark(193, pos);
			*typ = DevCPT_undftyp;
		}
	}
	__EXIT;
}

static void DevCPP_CheckRecursiveType (DevCPT_Struct outer, DevCPT_Struct inner, INTEGER pos)
{
	DevCPT_Object fld = NIL;
	__ENTER("DevCPP.CheckRecursiveType");
	if (outer == inner) {
		DevCPM_Mark(58, pos);
	} else if (__IN(inner->comp, 0x0c)) {
		DevCPP_CheckRecursiveType(outer, inner->BaseTyp, pos);
	} else if ((INTEGER)inner->comp == 4) {
		fld = inner->link;
		while (fld != NIL && (INTEGER)fld->mode == 4) {
			DevCPP_CheckRecursiveType(outer, fld->typ, pos);
			fld = fld->link;
		}
		if (inner->BaseTyp != NIL) {
			DevCPP_CheckRecursiveType(outer, inner->BaseTyp, pos);
		}
	}
	__EXIT;
}

static void DevCPP_FixType (DevCPT_Struct struct_, DevCPT_Object obj, DevCPT_Struct typ, INTEGER pos)
{
	DevCPT_Struct t = NIL;
	DevCPT_Object f = NIL;
	DevCPT_Object bf = NIL;
	SHORTINT i;
	DevCPT_String _ptr__33 = NIL;
	__ENTER("DevCPP.FixType");
	if (obj != NIL) {
		if ((INTEGER)obj->mode == 1) {
			if (struct_ != NIL) {
				if ((INTEGER)typ->form != 13 || typ->BaseTyp != struct_) {
					DevCPM_Mark(180, pos);
				}
			} else {
				DevCPP_CheckAlloc(&typ, (INTEGER)obj->mnolev > (INTEGER)DevCPP_level, pos);
			}
		} else if ((INTEGER)obj->mode == 2) {
			if (struct_ != NIL) {
				if (typ != struct_) {
					DevCPM_Mark(180, pos);
				}
			}
		} else if ((INTEGER)obj->mode == 4) {
			DevCPP_CheckAlloc(&typ, 0, pos);
			DevCPP_CheckRecursiveType(struct_, typ, pos);
		} else if ((INTEGER)obj->mode == 13) {
			if ((INTEGER)typ->form == 15) {
				typ = DevCPT_undftyp;
				DevCPM_Mark(54, pos);
			}
		} else if ((INTEGER)obj->mode == 5) {
			if (__IN(typ->form, 0x0503fe)) {
				t = DevCPT_NewStr(typ->form, 1);
				i = t->ref;
				*t = *typ;
				t->ref = i;
				t->strobj = obj;
				t->mno = 0;
				t->BaseTyp = typ;
				typ = t;
			}
			if ((INTEGER)obj->vis != 0) {
				if ((INTEGER)typ->comp == 4) {
					typ->exp = 1;
				} else if ((INTEGER)typ->form == 13) {
					typ->BaseTyp->exp = 1;
				}
			}
		} else {
			__HALT(100);
		}
		obj->typ = typ;
	} else {
		if ((INTEGER)struct_->form == 13) {
			if ((INTEGER)typ->comp == 4) {
				DevCPM_PropagateRecPtrSysFlag(typ->sysflag, &struct_->sysflag);
			} else if (__IN(typ->comp, 0x0c)) {
				DevCPM_PropagateArrPtrSysFlag(typ->sysflag, &struct_->sysflag);
			} else {
				typ = DevCPT_undftyp;
				DevCPM_Mark(57, pos);
			}
			struct_->untagged = (INTEGER)struct_->sysflag > 0;
			if (struct_->strobj != NIL && (INTEGER)struct_->strobj->vis != 0) {
				typ->exp = 1;
			}
		} else if ((INTEGER)struct_->comp == 2) {
			DevCPP_CheckAlloc(&typ, 0, pos);
			DevCPP_CheckRecursiveType(struct_, typ, pos);
		} else if ((INTEGER)struct_->comp == 3) {
			DevCPP_CheckAlloc(&typ, 1, pos);
			DevCPP_CheckRecursiveType(struct_, typ, pos);
		} else if ((INTEGER)struct_->comp == 4) {
			if ((INTEGER)typ->form == 13) {
				typ = typ->BaseTyp;
			}
			typ->pvused = 1;
			struct_->extlev = (BYTE)((INTEGER)typ->extlev + 1);
			DevCPM_PropagateRecordSysFlag(typ->sysflag, &struct_->sysflag);
			if ((INTEGER)typ->attribute == 0 || (INTEGER)typ->attribute == 18 && (INTEGER)typ->mno != 0) {
				DevCPM_Mark(181, pos);
			} else if ((INTEGER)struct_->attribute == 17 && (INTEGER)typ->attribute != 17) {
				DevCPM_Mark(191, pos);
			} else if ((INTEGER)typ->attribute == 18 && (INTEGER)struct_->attribute != 18) {
				DevCPM_Mark(197, pos);
			}
			f = struct_->link;
			while (f != NIL) {
				_ptr__33 = f->name;
				DevCPT_FindField((void*)_ptr__33->data, _ptr__33->len[0], typ, &bf);
				if (bf != NIL) {
					DevCPM_Mark(1, pos);
				}
				f = f->link;
			}
			DevCPP_CheckRecursiveType(struct_, typ, pos);
			struct_->untagged = (INTEGER)struct_->sysflag > 0;
		} else if ((INTEGER)struct_->form == 14) {
			if ((INTEGER)typ->form == 15) {
				typ = DevCPT_undftyp;
				DevCPM_Mark(54, pos);
			}
		} else {
			__HALT(100);
		}
		struct_->BaseTyp = typ;
	}
	__EXIT;
}

static void DevCPP_CheckForwardTypes (void)
{
	DevCPP_Elem u = NIL;
	DevCPP_Elem next = NIL;
	BOOLEAN progress;
	__ENTER("DevCPP.CheckForwardTypes");
	u = DevCPP_userList;
	DevCPP_userList = NIL;
	while (u != NIL) {
		next = u->next;
		__STRCOPYSS(u->name->data, DevCPS_name, 256);
		DevCPT_Find(DevCPS_name, &u->base);
		if (u->base == NIL) {
			DevCPM_Mark(0, u->pos);
		} else if ((INTEGER)u->base->mode != 5) {
			DevCPM_Mark(72, u->pos);
		} else {
			u->next = DevCPP_userList;
			DevCPP_userList = u;
		}
		u = next;
	}
	do {
		u = DevCPP_userList;
		DevCPP_userList = NIL;
		progress = 0;
		while (u != NIL) {
			next = u->next;
			if (DevCPP_IncompleteType(u->base->typ)) {
				u->next = DevCPP_userList;
				DevCPP_userList = u;
			} else {
				progress = 1;
				DevCPP_FixType(u->struct_, u->obj, u->base->typ, u->pos);
			}
			u = next;
		}
	} while (!(DevCPP_userList == NIL || !progress));
	u = DevCPP_userList;
	while (u != NIL) {
		if (u->obj == NIL || (INTEGER)u->obj->mode == 5) {
			DevCPM_Mark(58, u->pos);
		}
		u = u->next;
	}
	__EXIT;
}

static void DevCPP_CheckUnimpl (DevCPT_Object m, DevCPT_Struct typ, INTEGER pos)
{
	DevCPT_Object obj = NIL;
	DevCPT_String _ptr__27 = NIL;
	DevCPT_String _ptr__26 = NIL;
	DevCPT_String _ptr__25 = NIL;
	DevCPT_String _ptr__24 = NIL;
	__ENTER("DevCPP.CheckUnimpl");
	if (m != NIL) {
		if ((INTEGER)m->mode == 13 && __IN(17, m->conval->setval)) {
			_ptr__27 = m->name;
			DevCPT_FindField((void*)_ptr__27->data, _ptr__27->len[0], typ, &obj);
			if ((obj == NIL || (INTEGER)obj->mode != 13) || __IN(17, obj->conval->setval)) {
				DevCPM_Mark(192, pos);
				if (typ->strobj != NIL) {
					_ptr__26 = m->name;
					_ptr__25 = typ->strobj->name;
					DevCPM_LogWPar((void*)((CHAR[]){35, 68, 101, 118, 58, 78, 111, 116, 73, 109, 112, 108, 101, 109, \
101, 110, 116, 101, 100, 73, 110, 0}), 22, (void*)_ptr__26->data, _ptr__26->len[0], (void*)_ptr__25->data, \
_ptr__25->len[0]);
					DevCPM_LogWLn();
				} else {
					_ptr__24 = m->name;
					DevCPM_LogWPar((void*)((CHAR[]){35, 68, 101, 118, 58, 78, 111, 116, 73, 109, 112, 108, 101, 109, \
101, 110, 116, 101, 100, 0}), 20, (void*)_ptr__24->data, _ptr__24->len[0], (void*)"", 1);
					DevCPM_LogWLn();
				}
			}
		}
		DevCPP_CheckUnimpl(m->left, typ, pos);
		DevCPP_CheckUnimpl(m->right, typ, pos);
	}
	__EXIT;
}

static void DevCPP_CheckRecords (DevCPP_Elem rec)
{
	DevCPT_Struct b = NIL;
	__ENTER("DevCPP.CheckRecords");
	while (rec != NIL) {
		b = rec->struct_->BaseTyp;
		while (b != NIL && b != DevCPT_undftyp) {
			DevCPP_CheckUnimpl(b->link, rec->struct_, rec->pos);
			b = b->BaseTyp;
		}
		rec = rec->next;
	}
	__EXIT;
}

static void DevCPP_err (SHORTINT n)
{
	__ENTER("DevCPP.err");
	DevCPM_err(n);
	__EXIT;
}

static void DevCPP_CheckSym (SHORTINT s)
{
	__ENTER("DevCPP.CheckSym");
	if ((INTEGER)DevCPP_sym == (INTEGER)s) {
		DevCPS_Get(&DevCPP_sym);
	} else {
		DevCPM_err(s);
	}
	__EXIT;
}

static void DevCPP_qualident (DevCPT_Object *id)
{
	DevCPT_Object obj = NIL;
	BYTE lev;
	__ENTER("DevCPP.qualident");
	DevCPT_Find(DevCPS_name, &obj);
	DevCPS_Get(&DevCPP_sym);
	if (((INTEGER)DevCPP_sym == 19 && obj != NIL) && (INTEGER)obj->mode == 11) {
		DevCPS_Get(&DevCPP_sym);
		if ((INTEGER)DevCPP_sym == 48) {
			DevCPT_FindImport(DevCPS_name, obj, &obj);
			DevCPS_Get(&DevCPP_sym);
		} else {
			DevCPP_err(48);
			obj = NIL;
		}
	}
	if (obj == NIL) {
		DevCPP_err(0);
		obj = DevCPT_NewObj();
		obj->mode = 1;
		obj->typ = DevCPT_undftyp;
		obj->adr = 0;
	} else {
		lev = obj->mnolev;
		if (__IN(obj->mode, 0x06) && (INTEGER)lev != (INTEGER)DevCPP_level) {
			obj->leaf = 0;
			if ((INTEGER)lev > 0) {
				DevCPB_StaticLink((BYTE)((INTEGER)DevCPP_level - (INTEGER)lev), 1);
			}
		}
	}
	*id = obj;
	__EXIT;
}

static void DevCPP_ConstExpression (DevCPT_Node *x)
{
	__ENTER("DevCPP.ConstExpression");
	DevCPP_Expression(x);
	if ((INTEGER)(*x)->class != 7) {
		DevCPP_err(50);
		*x = DevCPB_NewIntConst(1);
	}
	__EXIT;
}

static void DevCPP_CheckMark (DevCPT_Object obj)
{
	INTEGER n;
	DevCPT_String mod[256] = {0};
	__ENTER("DevCPP.CheckMark");
	DevCPS_Get(&DevCPP_sym);
	if ((INTEGER)DevCPP_sym == 1 || (INTEGER)DevCPP_sym == 7) {
		if ((INTEGER)DevCPP_level > 0 || !__IN(obj->mode, 0x2012) && (INTEGER)DevCPP_sym == 7) {
			DevCPP_err(41);
		}
		if ((INTEGER)DevCPP_sym == 1) {
			obj->vis = 1;
		} else {
			obj->vis = 2;
		}
		DevCPS_Get(&DevCPP_sym);
	} else {
		obj->vis = 0;
	}
	if (__IN(obj->mode, 0x22fa) && (INTEGER)DevCPP_sym == 41) {
		DevCPS_Get(&DevCPP_sym);
		if ((INTEGER)DevCPP_sym == 45 && (INTEGER)DevCPS_numtyp == 1) {
			DevCPS_str = __NEWARR(1, 2);
			(DevCPS_str->data)[0] = (SHORTCHAR)DevCPS_intval;
			(DevCPS_str->data)[__X(1, DevCPS_str->len[0])] = 0;
			DevCPP_sym = 47;
		}
		if ((INTEGER)DevCPP_sym == 47) {
			if ((DevCPS_str->data)[0] != 0) {
				obj->entry = DevCPS_str;
			}
			DevCPS_Get(&DevCPP_sym);
			n = 0;
			if ((INTEGER)DevCPP_sym == 20 && __IN(obj->mode, 0x02ca)) {
				DevCPS_Get(&DevCPP_sym);
				if ((INTEGER)DevCPP_sym == 45 && (INTEGER)DevCPS_numtyp == 1) {
					DevCPS_str = __NEWARR(1, 2);
					(DevCPS_str->data)[0] = (SHORTCHAR)DevCPS_intval;
					(DevCPS_str->data)[__X(1, DevCPS_str->len[0])] = 0;
					DevCPP_sym = 47;
				}
				if ((INTEGER)DevCPP_sym == 47) {
					obj->library = obj->entry;
					obj->entry = NIL;
					if ((DevCPS_str->data)[0] != 0) {
						obj->entry = DevCPS_str;
					}
					DevCPS_Get(&DevCPP_sym);
				} else {
					DevCPP_err(47);
				}
			}
			while ((INTEGER)DevCPP_sym == 20) {
				DevCPS_Get(&DevCPP_sym);
				if ((INTEGER)DevCPP_sym == 45 && (INTEGER)DevCPS_numtyp == 1) {
					DevCPS_str = __NEWARR(1, 2);
					(DevCPS_str->data)[0] = (SHORTCHAR)DevCPS_intval;
					(DevCPS_str->data)[__X(1, DevCPS_str->len[0])] = 0;
					DevCPP_sym = 47;
				}
				if ((INTEGER)DevCPP_sym == 47) {
					if (n < 256) {
						mod[__X(n, 256)] = DevCPS_str;
						n += 1;
					} else {
						DevCPP_err(235);
					}
					DevCPS_Get(&DevCPP_sym);
				} else {
					DevCPP_err(47);
				}
			}
			if (n > 0) {
				obj->modifiers = __NEWARR(0, n);
				while (n > 0) {
					n -= 1;
					(obj->modifiers->data)[__X(n, obj->modifiers->len[0])] = mod[__X(n, 256)];
				}
			}
		} else {
			DevCPP_err(47);
		}
		DevCPP_CheckSym(24);
		if ((DevCPM_options & 0x82) == 0x0) {
			DevCPP_err(225);
		}
	}
	__EXIT;
}

static void DevCPP_CheckSysFlag (SHORTINT *sysflag, void (*GetSF)(SHORTCHAR*, INTEGER , SHORTINT, SHORTINT*))
{
	DevCPT_Object x = NIL;
	SHORTINT i;
	DevCPT_String _ptr__22 = NIL;
	__ENTER("DevCPP.CheckSysFlag");
	*sysflag = 0;
	if ((INTEGER)DevCPP_sym == 41) {
		DevCPS_Get(&DevCPP_sym);
		while (((INTEGER)DevCPP_sym == 45 || (INTEGER)DevCPP_sym == 48) || (INTEGER)DevCPP_sym == 47) {
			if ((INTEGER)DevCPP_sym == 45) {
				if ((INTEGER)DevCPS_numtyp == 2) {
					i = (SHORTINT)DevCPS_intval;
					(*GetSF)((void*)"", 1, i, sysflag);
				} else {
					DevCPP_err(225);
				}
			} else if ((INTEGER)DevCPP_sym == 48) {
				DevCPT_Find(DevCPS_name, &x);
				if ((x != NIL && (INTEGER)x->mode == 3) && __IN(x->typ->form, 0x70)) {
					i = (SHORTINT)x->conval->intval;
					(*GetSF)((void*)"", 1, i, sysflag);
				} else {
					(*GetSF)((void*)DevCPS_name, 256, 0, sysflag);
				}
			} else {
				_ptr__22 = DevCPS_str;
				(*GetSF)((void*)_ptr__22->data, _ptr__22->len[0], 0, sysflag);
			}
			DevCPS_Get(&DevCPP_sym);
			if ((INTEGER)DevCPP_sym == 20 || (INTEGER)DevCPP_sym == 6) {
				DevCPS_Get(&DevCPP_sym);
			}
		}
		DevCPP_CheckSym(24);
	}
	__EXIT;
}

static void DevCPP_Receiver (BYTE *mode, BYTE *vis, DevCPT_Name name, DevCPT_Struct *typ, DevCPT_Struct \
*rec)
{
	DevCPT_String tname = NIL;
	__ENTER("DevCPP.Receiver");
	*typ = DevCPT_undftyp;
	*rec = NIL;
	*vis = 0;
	if ((INTEGER)DevCPP_sym == 70) {
		DevCPS_Get(&DevCPP_sym);
		*mode = 2;
	} else if ((INTEGER)DevCPP_sym == 15) {
		DevCPS_Get(&DevCPP_sym);
		*mode = 2;
		*vis = 3;
	} else {
		*mode = 1;
	}
	__MOVE(DevCPS_name, name, 256);
	DevCPP_CheckSym(48);
	DevCPP_CheckSym(21);
	if ((INTEGER)DevCPP_sym != 48) {
		DevCPP_err(48);
	}
	DevCPP_Type(typ, &tname);
	if (tname == NIL) {
		if ((INTEGER)(*typ)->form == 13) {
			*rec = (*typ)->BaseTyp;
		} else {
			*rec = *typ;
		}
		if (!(((INTEGER)*mode == 1 && (INTEGER)(*typ)->form == 13) && (INTEGER)(*rec)->comp == 4 || (INTEGER)*mode \
== 2 && (INTEGER)(*typ)->comp == 4)) {
			DevCPP_err(70);
			*rec = NIL;
		}
		if (*rec != NIL && (INTEGER)(*rec)->mno != (INTEGER)DevCPP_level) {
			DevCPP_err(72);
			*rec = NIL;
		}
	} else {
		DevCPP_err(0);
	}
	DevCPP_CheckSym(23);
	if (*rec == NIL) {
		*rec = DevCPT_NewStr(15, 4);
		(*rec)->BaseTyp = NIL;
	}
	__EXIT;
}

static void DevCPP_FormalParameters (DevCPT_Object *firstPar, DevCPT_Struct *resTyp, DevCPT_String *name)
{
	BYTE mode, vis;
	SHORTINT sys;
	DevCPT_Object par = NIL;
	DevCPT_Object first = NIL;
	DevCPT_Object last = NIL;
	DevCPT_Object newPar = NIL;
	DevCPT_Object iidPar = NIL;
	DevCPT_Struct typ = NIL;
	__ENTER("DevCPP.FormalParameters");
	first = NIL;
	last = *firstPar;
	newPar = NIL;
	iidPar = NIL;
	if ((((INTEGER)DevCPP_sym == 48 || (INTEGER)DevCPP_sym == 70) || (INTEGER)DevCPP_sym == 15) || (INTEGER)DevCPP_sym \
== 71) {
		for (;;) {
			sys = 0;
			vis = 0;
			if ((INTEGER)DevCPP_sym == 70) {
				DevCPS_Get(&DevCPP_sym);
				mode = 2;
			} else if ((INTEGER)DevCPP_sym == 15) {
				DevCPS_Get(&DevCPP_sym);
				mode = 2;
				vis = 3;
			} else if ((INTEGER)DevCPP_sym == 71) {
				DevCPS_Get(&DevCPP_sym);
				mode = 2;
				vis = 4;
			} else {
				mode = 1;
			}
			if ((INTEGER)mode == 2) {
				DevCPP_CheckSysFlag(&sys, DevCPM_GetVarParSysFlag);
			}
			if (__ODD(__ASHR((INTEGER)sys, 1, INTEGER))) {
				vis = 3;
			} else if (__ODD(__ASHR((INTEGER)sys, 2, INTEGER))) {
				vis = 4;
			}
			if (__ODD(__ASHR((INTEGER)sys, 3, INTEGER)) && (INTEGER)vis != 4) {
				DevCPP_err(225);
			} else if (__ODD(__ASHR((INTEGER)sys, 4, INTEGER)) && (INTEGER)vis != 3) {
				DevCPP_err(225);
			}
			for (;;) {
				if ((INTEGER)DevCPP_sym == 48) {
					DevCPT_Insert(DevCPS_name, &par);
					DevCPS_Get(&DevCPP_sym);
					par->mode = mode;
					par->link = NIL;
					par->vis = vis;
					par->sysflag = (BYTE)sys;
					if (first == NIL) {
						first = par;
					}
					if (*firstPar == NIL) {
						*firstPar = par;
					} else {
						last->link = par;
					}
					last = par;
				} else {
					DevCPP_err(48);
				}
				if ((INTEGER)DevCPP_sym == 20) {
					DevCPS_Get(&DevCPP_sym);
				} else if ((INTEGER)DevCPP_sym == 48) {
					DevCPP_err(20);
				} else if ((INTEGER)DevCPP_sym == 70) {
					DevCPP_err(20);
					DevCPS_Get(&DevCPP_sym);
				} else {
					break;
				}
			}
			DevCPP_CheckSym(21);
			DevCPP_Type(&typ, name);
			if ((INTEGER)mode != 2) {
				DevCPP_CheckAlloc(&typ, 1, DevCPM_errpos);
			}
			if (((((INTEGER)mode == 2 && (INTEGER)vis == 3) && (INTEGER)typ->form != 0) && (INTEGER)typ->form != \
15) && (INTEGER)typ->sysflag == 0) {
				DevCPP_err(177);
			}
			while (first != NIL) {
				DevCPP_SetType(NIL, first, typ, *name);
				if (__IN(2, DevCPM_options)) {
					if (__ODD(__ASHR((INTEGER)sys, 3, INTEGER))) {
						if ((newPar != NIL || (INTEGER)typ->form != 13) || (INTEGER)typ->sysflag != 10) {
							DevCPP_err(168);
						}
						newPar = first;
					} else if (__ODD(__ASHR((INTEGER)sys, 4, INTEGER))) {
						if (iidPar != NIL || typ != DevCPT_guidtyp) {
							DevCPP_err(168);
						}
						iidPar = first;
					}
				}
				first = first->link;
			}
			if ((INTEGER)DevCPP_sym == 49) {
				DevCPS_Get(&DevCPP_sym);
			} else if ((INTEGER)DevCPP_sym == 48) {
				DevCPP_err(49);
			} else {
				break;
			}
		}
	}
	DevCPP_CheckSym(23);
	if ((newPar == NIL) != (iidPar == NIL)) {
		DevCPP_err(168);
	}
	*name = NIL;
	if ((INTEGER)DevCPP_sym == 21) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Type(resTyp, name);
		if ((INTEGER)(*resTyp)->form == 15) {
			*resTyp = DevCPT_undftyp;
			DevCPP_err(54);
		}
	} else {
		*resTyp = DevCPT_notyp;
	}
	__EXIT;
}

static void DevCPP_CheckOverwrite (DevCPT_Object proc, DevCPT_Object base, DevCPT_Struct rec)
{
	DevCPT_Object o = NIL;
	DevCPT_Object bo = NIL;
	__ENTER("DevCPP.CheckOverwrite");
	if (base != NIL) {
		if ((base->conval->setval & 0x1a0000) == 0x0) {
			DevCPP_err(182);
		}
		if (((INTEGER)proc->link->mode != (INTEGER)base->link->mode || (INTEGER)proc->link->vis != (INTEGER)base->link->vis) \
|| !DevCPT_Extends(proc->link->typ, base->link->typ)) {
			DevCPP_err(115);
		}
		o = proc->link;
		bo = base->link;
		while (o != NIL && bo != NIL) {
			if ((INTEGER)bo->sysflag != 0 && (INTEGER)o->sysflag == 0) {
				o->sysflag = bo->sysflag;
			}
			o = o->link;
			bo = bo->link;
		}
		DevCPB_CheckParameters(proc->link->link, base->link->link, 0);
		if (!DevCPT_Extends(proc->typ, base->typ)) {
			DevCPP_err(117);
		}
		if ((INTEGER)base->vis != (INTEGER)proc->vis && ((INTEGER)proc->vis != 0 || rec->exp)) {
			DevCPP_err(183);
		}
		proc->conval->setval |= __SETOF(2);
	}
	__EXIT;
}

static void DevCPP_GetAttributes (DevCPT_Object proc, DevCPT_Object base, DevCPT_Struct owner)
{
	SET attr, battr;
	DevCPT_Object o = NIL;
	__ENTER("DevCPP.GetAttributes");
	attr = 0x0;
	if ((INTEGER)DevCPP_sym == 20) {
		DevCPS_Get(&DevCPP_sym);
		if ((INTEGER)DevCPP_sym == 48) {
			DevCPT_Find(DevCPS_name, &o);
			if ((o != NIL && (INTEGER)o->mode == 8) && o->adr == 1) {
				if (!__IN(6, DevCPM_options)) {
					attr |= __SETOF(16);
				} else {
					DevCPP_err(178);
				}
				DevCPS_Get(&DevCPP_sym);
				if ((INTEGER)DevCPP_sym == 20) {
					DevCPS_Get(&DevCPP_sym);
					if ((INTEGER)DevCPP_sym == 48) {
						DevCPT_Find(DevCPS_name, &o);
					} else {
						o = NIL;
						DevCPP_err(48);
					}
				} else {
					o = NIL;
				}
			}
			if (o != NIL) {
				if (((INTEGER)o->mode != 20 || o->adr == 18) || __IN(6, DevCPM_options)) {
					DevCPP_err(178);
				} else {
					attr |= __SETOF(o->adr);
				}
				DevCPS_Get(&DevCPP_sym);
			}
		} else {
			DevCPP_err(48);
		}
	}
	if (base == NIL && !__IN(16, attr)) {
		DevCPP_err(185);
		attr |= __SETOF(16);
	} else if (base != NIL && __IN(16, attr)) {
		DevCPP_err(186);
	}
	if (__IN(17, attr)) {
		if ((INTEGER)owner->attribute != 17) {
			DevCPP_err(190);
		}
		if ((INTEGER)proc->vis == 0 && owner->exp) {
			DevCPP_err(179);
		}
	}
	if ((INTEGER)owner->attribute == 0 || (INTEGER)owner->attribute == 18) {
		if (__IN(19, attr) && __IN(16, attr)) {
			DevCPP_err(187);
		}
	}
	if (base != NIL) {
		battr = base->conval->setval;
		if (__IN(19, battr)) {
			if (__IN(17, attr)) {
				DevCPP_err(189);
			}
		} else if (!__IN(17, battr)) {
			if (__IN(17, attr) || __IN(19, attr)) {
				DevCPP_err(189);
			}
		}
	}
	if (__IN(19, attr)) {
		if (proc->typ != DevCPT_notyp) {
			DevCPP_err(195);
		} else {
			o = proc->link;
			while (o != NIL && (INTEGER)o->vis != 4) {
				o = o->link;
			}
			if (o != NIL) {
				DevCPP_err(195);
			}
		}
	}
	if ((INTEGER)owner->sysflag == 10 && !__IN(17, attr)) {
		DevCPP_err(162);
	}
	proc->conval->setval = attr;
	__EXIT;
}

static void DevCPP_RecordType (DevCPT_Struct *typ, DevCPT_Object attr)
{
	DevCPT_Object fld = NIL;
	DevCPT_Object first = NIL;
	DevCPT_Object last = NIL;
	DevCPP_Elem r = NIL;
	DevCPT_Struct ftyp = NIL;
	DevCPT_String name = NIL;
	DevCPT_Struct _ptr__60 = NIL;
	DevCPT_Struct _ptr__59 = NIL;
	__ENTER("DevCPP.RecordType");
	*typ = DevCPT_NewStr(15, 4);
	(*typ)->BaseTyp = NIL;
	_ptr__60 = *typ;
	DevCPP_CheckSysFlag(&_ptr__60->sysflag, DevCPM_GetRecordSysFlag);
	if (attr != NIL) {
		if (!__IN(6, DevCPM_options) && attr->adr != 19) {
			(*typ)->attribute = (BYTE)attr->adr;
		} else {
			DevCPP_err(178);
		}
	}
	if ((INTEGER)(*typ)->sysflag == 10) {
		if (DevCPS_str != NIL && (DevCPS_str->data)[0] == (SHORTCHAR)'{') {
			(*typ)->ext = DevCPS_str;
		}
		if ((INTEGER)(*typ)->attribute != 17) {
			DevCPP_err(163);
		}
		if ((INTEGER)DevCPP_sym != 40) {
			DevCPP_err(160);
		}
	}
	if ((INTEGER)DevCPP_sym == 40) {
		DevCPS_Get(&DevCPP_sym);
		if ((INTEGER)DevCPP_sym == 48) {
			DevCPP_Type(&ftyp, &name);
			if ((INTEGER)ftyp->form == 13) {
				ftyp = ftyp->BaseTyp;
			}
			DevCPP_SetType(*typ, NIL, ftyp, name);
			if ((INTEGER)ftyp->comp == 4 && ftyp != DevCPT_anytyp) {
				ftyp->pvused = 1;
				(*typ)->extlev = (BYTE)((INTEGER)ftyp->extlev + 1);
				_ptr__59 = *typ;
				DevCPM_PropagateRecordSysFlag(ftyp->sysflag, &_ptr__59->sysflag);
				if ((INTEGER)ftyp->attribute == 0 || (INTEGER)ftyp->attribute == 18 && (INTEGER)ftyp->mno != 0) {
					DevCPP_err(181);
				} else if (((INTEGER)(*typ)->attribute == 17 && (INTEGER)ftyp->attribute != 17) && !__IN(7, DevCPM_options)) \
{
					DevCPP_err(191);
				} else if ((INTEGER)ftyp->attribute == 18 && (INTEGER)(*typ)->attribute != 18) {
					DevCPP_err(197);
				}
			} else if (ftyp != DevCPT_undftyp) {
				DevCPP_err(53);
			}
		} else {
			DevCPP_err(48);
		}
		if ((INTEGER)(*typ)->attribute != 17) {
			r = __NEW(DevCPP_Elem__rec__typ);
			r->struct_ = *typ;
			r->pos = DevCPM_errpos;
			r->next = DevCPP_recList;
			DevCPP_recList = r;
		}
		DevCPP_CheckSym(23);
	}
	first = NIL;
	last = NIL;
	for (;;) {
		if ((INTEGER)DevCPP_sym == 48) {
			for (;;) {
				if ((INTEGER)DevCPP_sym == 48) {
					if ((*typ)->BaseTyp != NIL && (*typ)->BaseTyp != DevCPT_undftyp) {
						DevCPT_FindBaseField((void*)DevCPS_name, 256, *typ, &fld);
						if (fld != NIL) {
							DevCPP_err(1);
						}
					}
					DevCPT_InsertField(DevCPS_name, *typ, &fld);
					fld->mode = 4;
					fld->link = NIL;
					fld->typ = DevCPT_undftyp;
					DevCPP_CheckMark(fld);
					if (first == NIL) {
						first = fld;
					}
					if (last == NIL) {
						(*typ)->link = fld;
					} else {
						last->link = fld;
					}
					last = fld;
				} else {
					DevCPP_err(48);
				}
				if ((INTEGER)DevCPP_sym == 20) {
					DevCPS_Get(&DevCPP_sym);
				} else if ((INTEGER)DevCPP_sym == 48) {
					DevCPP_err(20);
				} else {
					break;
				}
			}
			DevCPP_CheckSym(21);
			DevCPP_Type(&ftyp, &name);
			DevCPP_CheckAlloc(&ftyp, 0, DevCPM_errpos);
			while (first != NIL) {
				DevCPP_SetType(*typ, first, ftyp, name);
				first = first->link;
			}
			if ((INTEGER)(*typ)->sysflag == 10) {
				DevCPP_err(161);
			}
		}
		if ((INTEGER)DevCPP_sym == 49) {
			DevCPS_Get(&DevCPP_sym);
		} else if ((INTEGER)DevCPP_sym == 48) {
			DevCPP_err(49);
		} else {
			break;
		}
	}
	(*typ)->untagged = (INTEGER)(*typ)->sysflag > 0;
	DevCPB_Inittd(&DevCPP_TDinit, &DevCPP_lastTDinit, *typ);
	DevCPP_CheckSym(51);
	__EXIT;
}

static void DevCPP_ArrayType (DevCPT_Struct *typ)
{
	DevCPT_Node x = NIL;
	INTEGER n;
	SHORTINT sysflag;
	DevCPT_String name = NIL;
	DevCPT_Struct _ptr__7 = NIL;
	DevCPT_Struct _ptr__6 = NIL;
	DevCPT_Struct _ptr__5 = NIL;
	DevCPT_Struct _ptr__4 = NIL;
	DevCPT_Struct _ptr__3 = NIL;
	__ENTER("DevCPP.ArrayType");
	DevCPP_CheckSysFlag(&sysflag, DevCPM_GetArraySysFlag);
	if ((INTEGER)DevCPP_sym == 26) {
		*typ = DevCPT_NewStr(15, 3);
		(*typ)->mno = 0;
		(*typ)->sysflag = sysflag;
		DevCPS_Get(&DevCPP_sym);
		_ptr__7 = *typ;
		DevCPP_Type(&_ptr__7->BaseTyp, &name);
		DevCPP_SetType(*typ, NIL, (*typ)->BaseTyp, name);
		_ptr__6 = *typ;
		DevCPP_CheckAlloc(&_ptr__6->BaseTyp, 1, DevCPM_errpos);
		if ((INTEGER)(*typ)->BaseTyp->comp == 3) {
			(*typ)->n = (*typ)->BaseTyp->n + 1;
		} else {
			(*typ)->n = 0;
		}
	} else {
		*typ = DevCPT_NewStr(15, 2);
		(*typ)->sysflag = sysflag;
		DevCPP_ConstExpression(&x);
		if (__IN(x->typ->form, 0x70)) {
			n = x->conval->intval;
			if (n <= 0 || n > 2147483647) {
				DevCPP_err(63);
				n = 1;
			}
		} else {
			DevCPP_err(42);
			n = 1;
		}
		(*typ)->n = n;
		if ((INTEGER)DevCPP_sym == 26) {
			DevCPS_Get(&DevCPP_sym);
			_ptr__5 = *typ;
			DevCPP_Type(&_ptr__5->BaseTyp, &name);
			DevCPP_SetType(*typ, NIL, (*typ)->BaseTyp, name);
			_ptr__4 = *typ;
			DevCPP_CheckAlloc(&_ptr__4->BaseTyp, 0, DevCPM_errpos);
		} else if ((INTEGER)DevCPP_sym == 20) {
			DevCPS_Get(&DevCPP_sym);
			if ((INTEGER)DevCPP_sym != 26) {
				_ptr__3 = *typ;
				DevCPP_ArrayType(&_ptr__3->BaseTyp);
			}
		} else {
			DevCPP_err(35);
		}
	}
	(*typ)->untagged = (INTEGER)(*typ)->sysflag > 0;
	__EXIT;
}

static void DevCPP_PointerType (DevCPT_Struct *typ)
{
	DevCPT_String name = NIL;
	DevCPT_Struct _ptr__43 = NIL;
	DevCPT_Struct _ptr__42 = NIL;
	DevCPT_Struct _ptr__41 = NIL;
	DevCPT_Struct _ptr__40 = NIL;
	__ENTER("DevCPP.PointerType");
	*typ = DevCPT_NewStr(13, 1);
	_ptr__43 = *typ;
	DevCPP_CheckSysFlag(&_ptr__43->sysflag, DevCPM_GetPointerSysFlag);
	DevCPP_CheckSym(29);
	_ptr__42 = *typ;
	DevCPP_Type(&_ptr__42->BaseTyp, &name);
	DevCPP_SetType(*typ, NIL, (*typ)->BaseTyp, name);
	if ((*typ)->BaseTyp != DevCPT_undftyp && (INTEGER)(*typ)->BaseTyp->comp == 1) {
		(*typ)->BaseTyp = DevCPT_undftyp;
		DevCPP_err(57);
	}
	if ((INTEGER)(*typ)->BaseTyp->comp == 4) {
		_ptr__41 = *typ;
		DevCPM_PropagateRecPtrSysFlag((*typ)->BaseTyp->sysflag, &_ptr__41->sysflag);
	} else if (__IN((*typ)->BaseTyp->comp, 0x0c)) {
		_ptr__40 = *typ;
		DevCPM_PropagateArrPtrSysFlag((*typ)->BaseTyp->sysflag, &_ptr__40->sysflag);
	}
	(*typ)->untagged = (INTEGER)(*typ)->sysflag > 0;
	__EXIT;
}

static void DevCPP_Type (DevCPT_Struct *typ, DevCPT_String *name)
{
	DevCPT_Object id = NIL;
	DevCPT_String tname = NIL;
	DevCPT_Struct _ptr__76 = NIL;
	DevCPT_Struct _ptr__75 = NIL;
	DevCPT_Struct _ptr__74 = NIL;
	__ENTER("DevCPP.Type");
	*typ = DevCPT_undftyp;
	*name = NIL;
	if ((INTEGER)DevCPP_sym < 40) {
		DevCPP_err(12);
		do {
			DevCPS_Get(&DevCPP_sym);
		} while (!((INTEGER)DevCPP_sym >= 40));
	}
	if ((INTEGER)DevCPP_sym == 48) {
		DevCPT_Find(DevCPS_name, &id);
		if ((id == NIL || (INTEGER)id->mode == -1) || (INTEGER)id->mode == 5 && DevCPP_IncompleteType(id->typ)) \
{
			*name = DevCPT_NewName((void*)DevCPS_name, 256);
			DevCPS_Get(&DevCPP_sym);
			if (id == NIL && (INTEGER)DevCPP_sym == 19) {
				DevCPP_err(0);
				DevCPS_Get(&DevCPP_sym);
				*name = NIL;
				if ((INTEGER)DevCPP_sym == 48) {
					DevCPS_Get(&DevCPP_sym);
				}
			} else if ((INTEGER)DevCPP_sym == 65) {
				DevCPP_err(178);
				DevCPS_Get(&DevCPP_sym);
				*name = NIL;
				DevCPP_RecordType(typ, NIL);
			}
		} else {
			DevCPP_qualident(&id);
			if ((INTEGER)id->mode == 5) {
				if (!__IN(6, DevCPM_options) && ((id->typ == DevCPT_lreal64typ || id->typ == DevCPT_lint64typ) || \
id->typ == DevCPT_lchar16typ)) {
					DevCPP_err(198);
				}
				*typ = id->typ;
			} else if ((INTEGER)id->mode == 20) {
				if ((INTEGER)DevCPP_sym == 65) {
					DevCPS_Get(&DevCPP_sym);
					DevCPP_RecordType(typ, id);
				} else {
					DevCPP_err(12);
				}
			} else {
				DevCPP_err(52);
			}
		}
	} else if ((INTEGER)DevCPP_sym == 64) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_ArrayType(typ);
	} else if ((INTEGER)DevCPP_sym == 65) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_RecordType(typ, NIL);
	} else if ((INTEGER)DevCPP_sym == 66) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_PointerType(typ);
	} else if ((INTEGER)DevCPP_sym == 72) {
		DevCPS_Get(&DevCPP_sym);
		*typ = DevCPT_NewStr(14, 1);
		_ptr__76 = *typ;
		DevCPP_CheckSysFlag(&_ptr__76->sysflag, DevCPM_GetProcTypSysFlag);
		(*typ)->untagged = (INTEGER)(*typ)->sysflag > 0;
		if ((INTEGER)DevCPP_sym == 40) {
			DevCPS_Get(&DevCPP_sym);
			DevCPT_OpenScope(DevCPP_level, NIL);
			_ptr__75 = *typ;
			_ptr__74 = *typ;
			DevCPP_FormalParameters(&_ptr__75->link, &_ptr__74->BaseTyp, &tname);
			DevCPP_SetType(*typ, NIL, (*typ)->BaseTyp, tname);
			DevCPT_CloseScope();
		} else {
			(*typ)->BaseTyp = DevCPT_notyp;
			(*typ)->link = NIL;
		}
	} else {
		DevCPP_err(12);
	}
	for (;;) {
		if ((((((INTEGER)DevCPP_sym >= 49 && (INTEGER)DevCPP_sym <= 52 || (INTEGER)DevCPP_sym == 23) || (INTEGER)DevCPP_sym \
== 76) || (INTEGER)DevCPP_sym == 45) || (INTEGER)DevCPP_sym == 20) || (INTEGER)DevCPP_sym == 47) {
			break;
		}
		DevCPP_err(15);
		if ((INTEGER)DevCPP_sym == 48) {
			break;
		}
		DevCPS_Get(&DevCPP_sym);
	}
	__EXIT;
}

static void DevCPP_ActualParameters (DevCPT_Node *aparlist, DevCPT_Object fpar, DevCPT_Node *pre, DevCPT_Node \
*lastp)
{
	DevCPT_Node apar = NIL;
	DevCPT_Node last = NIL;
	DevCPT_Node newPar = NIL;
	DevCPT_Node iidPar = NIL;
	DevCPT_Node n = NIL;
	__ENTER("DevCPP.ActualParameters");
	*aparlist = NIL;
	last = NIL;
	if ((INTEGER)DevCPP_sym != 23) {
		newPar = NIL;
		iidPar = NIL;
		for (;;) {
			DevCPP_Expression(&apar);
			if (fpar != NIL) {
				if ((INTEGER)apar->typ->form == 13 && (INTEGER)fpar->typ->form == 15) {
					DevCPB_DeRef(&apar);
				}
				DevCPB_Param(&apar, fpar);
				if ((INTEGER)fpar->mode == 1 || (INTEGER)fpar->vis == 3) {
					DevCPB_CheckBuffering(&apar, NIL, fpar, pre, lastp);
				}
				DevCPB_Link(aparlist, &last, apar);
				if (__ODD(__ASHR((INTEGER)fpar->sysflag, 3, INTEGER))) {
					newPar = apar;
				} else if (__ODD(__ASHR((INTEGER)fpar->sysflag, 4, INTEGER))) {
					iidPar = apar;
				}
				if (newPar != NIL && iidPar != NIL) {
					DevCPB_CheckNewParamPair(newPar, iidPar);
				}
				if ((INTEGER)fpar->mode == 2 && !__IN(7, DevCPM_options) || __IN(14, DevCPM_options) && (((INTEGER)fpar->mode \
== 2 && (INTEGER)fpar->typ->comp == 4) && !fpar->typ->untagged || (INTEGER)fpar->typ->comp == 3 && !fpar->typ->untagged)) \
{
					n = apar;
					while (__IN(n->class, 0x34)) {
						n = n->left;
					}
					if ((INTEGER)n->class == 3 && (INTEGER)n->subcl == 0) {
						if ((INTEGER)n->left->class == 5) {
							n = n->left;
						}
						DevCPB_CheckVarParBuffering(&n->left, pre, lastp);
					}
				}
				fpar = fpar->link;
			} else {
				DevCPP_err(64);
			}
			if ((INTEGER)DevCPP_sym == 20) {
				DevCPS_Get(&DevCPP_sym);
			} else if (40 <= (INTEGER)DevCPP_sym && (INTEGER)DevCPP_sym <= 48) {
				DevCPP_err(20);
			} else {
				break;
			}
		}
	}
	if (fpar != NIL) {
		DevCPP_err(65);
	}
	__EXIT;
}

static void DevCPP_selector (DevCPT_Node *x)
{
	DevCPT_Object obj = NIL;
	DevCPT_Object proc = NIL;
	DevCPT_Object p = NIL;
	DevCPT_Object fpar = NIL;
	DevCPT_Node y = NIL;
	DevCPT_Node apar = NIL;
	DevCPT_Node pre = NIL;
	DevCPT_Node lastp = NIL;
	DevCPT_Struct typ = NIL;
	DevCPT_Name name;
	DevCPT_String _ptr__81 = NIL;
	DevCPT_Node _ptr__80 = NIL;
	__ENTER("DevCPP.selector");
	for (;;) {
		if ((INTEGER)DevCPP_sym == 41) {
			DevCPS_Get(&DevCPP_sym);
			for (;;) {
				if ((*x)->typ != NIL && (INTEGER)(*x)->typ->form == 13) {
					DevCPB_DeRef(x);
				}
				DevCPP_Expression(&y);
				DevCPB_Index(x, y);
				if ((INTEGER)DevCPP_sym == 20) {
					DevCPS_Get(&DevCPP_sym);
				} else {
					break;
				}
			}
			DevCPP_CheckSym(24);
		} else if ((INTEGER)DevCPP_sym == 19) {
			DevCPS_Get(&DevCPP_sym);
			if ((INTEGER)DevCPP_sym == 48) {
				__MOVE(DevCPS_name, name, 256);
				DevCPS_Get(&DevCPP_sym);
				if ((*x)->typ != NIL) {
					if ((INTEGER)(*x)->typ->form == 13) {
						DevCPB_DeRef(x);
					}
					if ((INTEGER)(*x)->typ->comp == 4) {
						typ = (*x)->typ;
						DevCPT_FindField((void*)name, 256, typ, &obj);
						DevCPB_Field(x, obj);
						if (obj != NIL && (INTEGER)obj->mode == 13) {
							if ((INTEGER)DevCPP_sym == 17) {
								DevCPS_Get(&DevCPP_sym);
								y = (*x)->left;
								if ((INTEGER)y->class == 3) {
									y = y->left;
								}
								if (y->obj != NIL) {
									proc = DevCPT_topScope;
									while (proc->link != NIL && (INTEGER)proc->link->mode != 13) {
										proc = proc->left;
									}
									if (proc->link == NIL || proc->link->link != y->obj) {
										DevCPP_err(75);
									}
									typ = y->obj->typ;
									if ((INTEGER)typ->form == 13) {
										typ = typ->BaseTyp;
									}
									_ptr__81 = (*x)->obj->name;
									DevCPT_FindBaseField((void*)_ptr__81->data, _ptr__81->len[0], typ, &p);
									if (p != NIL) {
										(*x)->subcl = 1;
										(*x)->typ = p->typ;
										if ((p->conval->setval & 0x0a0000) != 0x0) {
											DevCPP_err(194);
										}
										if (((INTEGER)p->vis == 2 && (INTEGER)p->mnolev < 0) && __STRCMPSS(proc->link->name->data, name) \
!= 0) {
											DevCPP_err(196);
										}
									} else {
										DevCPP_err(74);
									}
								} else {
									DevCPP_err(75);
								}
							} else {
								proc = obj;
								if (((*x)->left->readonly && (INTEGER)proc->link->mode == 2) && (INTEGER)proc->link->vis == 0) \
{
									DevCPP_err(76);
								}
								while (((INTEGER)proc->mnolev >= 0 && !__IN(16, proc->conval->setval)) && typ->BaseTyp != NIL) \
{
									typ = typ->BaseTyp;
									DevCPT_FindField((void*)name, 256, typ, &proc);
								}
								if ((INTEGER)proc->vis == 2 && (INTEGER)proc->mnolev < 0) {
									DevCPP_err(196);
								}
							}
							if (obj->typ != DevCPT_notyp && (INTEGER)DevCPP_sym != 40) {
								DevCPP_err(40);
							}
						}
					} else {
						DevCPP_err(53);
					}
				} else {
					DevCPP_err(52);
				}
			} else {
				DevCPP_err(48);
			}
		} else if ((INTEGER)DevCPP_sym == 17) {
			DevCPS_Get(&DevCPP_sym);
			DevCPB_DeRef(x);
		} else if ((INTEGER)DevCPP_sym == 18) {
			if ((INTEGER)(*x)->typ->form == 13) {
				DevCPB_DeRef(x);
			}
			DevCPS_Get(&DevCPP_sym);
			DevCPB_StrDeref(x);
		} else if ((INTEGER)DevCPP_sym == 40) {
			if ((*x)->obj != NIL && __IN((*x)->obj->mode, 0x22c0)) {
				typ = (*x)->obj->typ;
			} else if ((INTEGER)(*x)->typ->form == 14) {
				typ = (*x)->typ->BaseTyp;
			} else if ((INTEGER)(*x)->class == 9) {
				break;
			} else {
				typ = NIL;
			}
			if (typ != DevCPT_notyp) {
				DevCPS_Get(&DevCPP_sym);
				if (typ == NIL) {
					if ((INTEGER)DevCPP_sym == 48) {
						DevCPP_qualident(&obj);
						if ((INTEGER)obj->mode == 5) {
							DevCPB_TypTest(x, obj, 1);
						} else {
							DevCPP_err(52);
						}
					} else {
						DevCPP_err(48);
					}
				} else {
					pre = NIL;
					lastp = NIL;
					DevCPB_PrepCall(x, &fpar);
					if ((*x)->obj != NIL && (INTEGER)(*x)->obj->mode == 13) {
						_ptr__80 = *x;
						DevCPB_CheckBuffering(&_ptr__80->left, NIL, (*x)->obj->link, &pre, &lastp);
					}
					DevCPP_ActualParameters(&apar, fpar, &pre, &lastp);
					DevCPB_Call(x, apar, fpar);
					if (pre != NIL) {
						DevCPB_Construct(30, &pre, *x);
						pre->typ = (*x)->typ;
						*x = pre;
					}
					if ((INTEGER)DevCPP_level > 0) {
						DevCPT_topScope->link->leaf = 0;
					}
				}
				DevCPP_CheckSym(23);
			} else {
				break;
			}
		} else {
			break;
		}
	}
	__EXIT;
}

static void DevCPP_StandProcCall (DevCPT_Node *x)
{
	DevCPT_Node y = NIL;
	BYTE m;
	SHORTINT n;
	__ENTER("DevCPP.StandProcCall");
	m = (BYTE)(*x)->obj->adr;
	n = 0;
	if ((INTEGER)DevCPP_sym == 40) {
		DevCPS_Get(&DevCPP_sym);
		if ((INTEGER)DevCPP_sym != 23) {
			for (;;) {
				if ((INTEGER)n == 0) {
					DevCPP_Expression(x);
					DevCPB_StPar0(x, m);
					n = 1;
				} else if ((INTEGER)n == 1) {
					DevCPP_Expression(&y);
					DevCPB_StPar1(x, y, m);
					n = 2;
				} else {
					DevCPP_Expression(&y);
					DevCPB_StParN(x, y, m, n);
					n += 1;
				}
				if ((INTEGER)DevCPP_sym == 20) {
					DevCPS_Get(&DevCPP_sym);
				} else if (40 <= (INTEGER)DevCPP_sym && (INTEGER)DevCPP_sym <= 48) {
					DevCPP_err(20);
				} else {
					break;
				}
			}
			DevCPP_CheckSym(23);
		} else {
			DevCPS_Get(&DevCPP_sym);
		}
		DevCPB_StFct(x, m, n);
	} else {
		DevCPP_err(40);
	}
	if ((INTEGER)DevCPP_level > 0 && ((INTEGER)m == 1 || (INTEGER)m == 30)) {
		DevCPT_topScope->link->leaf = 0;
	}
	__EXIT;
}

static void DevCPP_Element (DevCPT_Node *x)
{
	DevCPT_Node y = NIL;
	__ENTER("DevCPP.Element");
	DevCPP_Expression(x);
	if ((INTEGER)DevCPP_sym == 22) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Expression(&y);
		DevCPB_SetRange(x, y);
	} else {
		DevCPB_SetElem(x);
	}
	__EXIT;
}

static void DevCPP_Sets (DevCPT_Node *x)
{
	DevCPT_Node y = NIL;
	__ENTER("DevCPP.Sets");
	if ((INTEGER)DevCPP_sym != 25) {
		DevCPP_Element(x);
		for (;;) {
			if ((INTEGER)DevCPP_sym == 20) {
				DevCPS_Get(&DevCPP_sym);
			} else if (40 <= (INTEGER)DevCPP_sym && (INTEGER)DevCPP_sym <= 48) {
				DevCPP_err(20);
			} else {
				break;
			}
			DevCPP_Element(&y);
			DevCPB_Op(6, x, y);
		}
	} else {
		*x = DevCPB_EmptySet();
	}
	DevCPP_CheckSym(25);
	__EXIT;
}

static void DevCPP_Factor (DevCPT_Node *x)
{
	DevCPT_Object id = NIL;
	__ENTER("DevCPP.Factor");
	if ((INTEGER)DevCPP_sym < 33) {
		DevCPP_err(13);
		do {
			DevCPS_Get(&DevCPP_sym);
		} while (!((INTEGER)DevCPP_sym >= 40));
	}
	if ((INTEGER)DevCPP_sym == 48) {
		DevCPP_qualident(&id);
		*x = DevCPB_NewLeaf(id);
		DevCPP_selector(x);
		if ((INTEGER)(*x)->class == 9 && (INTEGER)(*x)->obj->mode == 8) {
			DevCPP_StandProcCall(x);
		}
	} else if ((INTEGER)DevCPP_sym == 45) {
		switch (DevCPS_numtyp) {
			case 1: 
				*x = DevCPB_NewIntConst(DevCPS_intval);
				(*x)->typ = DevCPT_char8typ;
				if (DevCPS_intval > 255) {
					(*x)->typ = DevCPT_char16typ;
				}
				break;
			case 2: 
				*x = DevCPB_NewIntConst(DevCPS_intval);
				break;
			case 5: 
				*x = DevCPB_NewLargeIntConst(DevCPS_intval, DevCPS_realval);
				break;
			case 4: 
				*x = DevCPB_NewRealConst(DevCPS_realval, NIL);
				break;
			case 6: 
				*x = DevCPB_NewRealConst(DevCPS_realval, DevCPT_real32typ);
				break;
			case 7: 
				*x = DevCPB_NewRealConst(DevCPS_realval, DevCPT_real64typ);
				break;
			default: __CASECHK;
		}
		DevCPS_Get(&DevCPP_sym);
	} else if ((INTEGER)DevCPP_sym == 47) {
		*x = DevCPB_NewString(DevCPS_str, (void*)DevCPS_lstr, DevCPS_intval);
		DevCPS_Get(&DevCPP_sym);
	} else if ((INTEGER)DevCPP_sym == 46) {
		*x = DevCPB_Nil();
		DevCPS_Get(&DevCPP_sym);
	} else if ((INTEGER)DevCPP_sym == 40) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Expression(x);
		DevCPP_CheckSym(23);
	} else if ((INTEGER)DevCPP_sym == 41) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_err(40);
		DevCPP_Expression(x);
		DevCPP_CheckSym(23);
	} else if ((INTEGER)DevCPP_sym == 42) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Sets(x);
	} else if ((INTEGER)DevCPP_sym == 33) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Factor(x);
		DevCPB_MOp(33, x);
	} else {
		DevCPP_err(13);
		DevCPS_Get(&DevCPP_sym);
		*x = NIL;
	}
	if (*x == NIL) {
		*x = DevCPB_NewIntConst(1);
		(*x)->typ = DevCPT_undftyp;
	}
	__EXIT;
}

static void DevCPP_Term (DevCPT_Node *x)
{
	DevCPT_Node y = NIL;
	BYTE mulop;
	__ENTER("DevCPP.Term");
	DevCPP_Factor(x);
	while (1 <= (INTEGER)DevCPP_sym && (INTEGER)DevCPP_sym <= 5) {
		mulop = DevCPP_sym;
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Factor(&y);
		DevCPB_Op(mulop, x, y);
	}
	__EXIT;
}

static void DevCPP_SimpleExpression (DevCPT_Node *x)
{
	DevCPT_Node y = NIL;
	BYTE addop;
	__ENTER("DevCPP.SimpleExpression");
	if ((INTEGER)DevCPP_sym == 7) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Term(x);
		DevCPB_MOp(7, x);
	} else if ((INTEGER)DevCPP_sym == 6) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Term(x);
		DevCPB_MOp(6, x);
	} else {
		DevCPP_Term(x);
	}
	while (6 <= (INTEGER)DevCPP_sym && (INTEGER)DevCPP_sym <= 8) {
		addop = DevCPP_sym;
		DevCPS_Get(&DevCPP_sym);
		DevCPP_Term(&y);
		if ((INTEGER)(*x)->typ->form == 13) {
			DevCPB_DeRef(x);
		}
		if (__IN((*x)->typ->comp, 0x0c) && __IN((*x)->typ->BaseTyp->form, 0x010008)) {
			DevCPB_StrDeref(x);
		}
		if ((INTEGER)y->typ->form == 13) {
			DevCPB_DeRef(&y);
		}
		if (__IN(y->typ->comp, 0x0c) && __IN(y->typ->BaseTyp->form, 0x010008)) {
			DevCPB_StrDeref(&y);
		}
		DevCPB_Op(addop, x, y);
	}
	__EXIT;
}

static void DevCPP_Expression (DevCPT_Node *x)
{
	DevCPT_Node y = NIL;
	DevCPT_Node pre = NIL;
	DevCPT_Node last = NIL;
	DevCPT_Object obj = NIL;
	BYTE relation;
	__ENTER("DevCPP.Expression");
	DevCPP_SimpleExpression(x);
	if (9 <= (INTEGER)DevCPP_sym && (INTEGER)DevCPP_sym <= 14) {
		relation = DevCPP_sym;
		DevCPS_Get(&DevCPP_sym);
		DevCPP_SimpleExpression(&y);
		pre = NIL;
		last = NIL;
		if (__IN((*x)->typ->comp, 0x0c) && __IN((*x)->typ->BaseTyp->form, 0x010008)) {
			DevCPB_StrDeref(x);
		}
		if (__IN(y->typ->comp, 0x0c) && __IN(y->typ->BaseTyp->form, 0x010008)) {
			DevCPB_StrDeref(&y);
		}
		DevCPB_CheckBuffering(x, NIL, NIL, &pre, &last);
		DevCPB_CheckBuffering(&y, NIL, NIL, &pre, &last);
		DevCPB_Op(relation, x, y);
		if (pre != NIL) {
			DevCPB_Construct(30, &pre, *x);
			pre->typ = (*x)->typ;
			*x = pre;
		}
	} else if ((INTEGER)DevCPP_sym == 15) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_SimpleExpression(&y);
		DevCPB_In(x, y);
	} else if ((INTEGER)DevCPP_sym == 16) {
		DevCPS_Get(&DevCPP_sym);
		if ((INTEGER)DevCPP_sym == 48) {
			DevCPP_qualident(&obj);
			if ((INTEGER)obj->mode == 5) {
				DevCPB_TypTest(x, obj, 0);
			} else {
				DevCPP_err(52);
			}
		} else {
			DevCPP_err(48);
		}
	}
	__EXIT;
}

static struct ProcedureDeclaration__44 {
	DevCPT_Node *x;
	DevCPT_Object *proc, *fwd;
	DevCPT_Name *name;
	BYTE *mode;
	BOOLEAN *forward;
	SHORTINT *sys;
	struct ProcedureDeclaration__44 *lnk;
} *ProcedureDeclaration__44_s;

static void __45 (void);
static void __47 (void);
static void __53 (void);
static void __55 (void);

static struct __47__48 {
	INTEGER *n;
	struct SHORTCHAR_ARRAY **s;
	DevCPT_Node *cx;
	struct __47__48 *lnk;
} *__47__48_s;

static void __50 (INTEGER len);

static void __50 (INTEGER len)
{
	INTEGER j;
	struct SHORTCHAR_ARRAY *s2 = NIL;
	INTEGER _for__52;
	__ENTER("DevCPP.EnsureLen");
	if (len > ((*__47__48_s->s))->len[0]) {
		s2 = __NEWARR(1, __ASHL(((*__47__48_s->s))->len[0], 1, INTEGER));
		_for__52 = (*__47__48_s->n) - 1;
		j = 0;
		while (j <= _for__52) {
			(s2->data)[__X(j, s2->len[0])] = (((*__47__48_s->s))->data)[__X(j, ((*__47__48_s->s))->len[0])];
			j += 1;
		}
		(*__47__48_s->s) = s2;
	}
	__EXIT;
}

static void __47 (void)
{
	DevCPT_String ext = NIL;
	INTEGER n, c, i;
	struct SHORTCHAR_ARRAY *s = NIL;
	DevCPT_Node cx = NIL;
	INTEGER _for__49;
	struct __47__48 _s;
	__ENTER("DevCPP.GetCode");
	_s.n = &n;
	_s.s = &s;
	_s.cx = &cx;
	_s.lnk = __47__48_s;
	__47__48_s = &_s;
	n = 0;
	s = __NEWARR(1, 64);
	while ((INTEGER)DevCPP_sym != 49 && (INTEGER)DevCPP_sym != 76) {
		DevCPP_ConstExpression(&cx);
		if (__IN(cx->typ->form, 0x010078)) {
			c = cx->conval->intval;
			__50(n + 1);
			if (0 <= c && c <= 255) {
				(s->data)[__X(n, s->len[0])] = (SHORTCHAR)c;
				n += 1;
			} else {
				DevCPP_err(63);
			}
		} else if ((INTEGER)cx->typ->form == 10) {
			c = cx->conval->intval2 - 1;
			__50(n + c);
			_for__49 = c - 1;
			i = 0;
			while (i <= _for__49) {
				(s->data)[__X(n + i, s->len[0])] = (cx->conval->ext->data)[__X(i, cx->conval->ext->len[0])];
				i += 1;
			}
			n += c;
		} else {
			DevCPP_err(63);
		}
		if ((INTEGER)DevCPP_sym == 20) {
			DevCPS_Get(&DevCPP_sym);
			if ((INTEGER)DevCPP_sym == 49) {
				DevCPP_err(13);
			}
		} else if ((INTEGER)DevCPP_sym != 49) {
			DevCPP_err(20);
		}
	}
	if (n != 0) {
		ext = __NEWARR(1, n);
		i = 0;
		while (i < n) {
			(ext->data)[__X(i, ext->len[0])] = (s->data)[__X(i, s->len[0])];
			i += 1;
		}
	} else {
		ext = NIL;
	}
	((*ProcedureDeclaration__44_s->proc))->conval->ext = ext;
	((*ProcedureDeclaration__44_s->proc))->conval->setval |= __SETOF(1);
	__47__48_s = _s.lnk;
	__EXIT;
}

static void __53 (void)
{
	DevCPT_String name = NIL;
	__ENTER("DevCPP.GetParams");
	((*ProcedureDeclaration__44_s->proc))->mode = (*ProcedureDeclaration__44_s->mode);
	((*ProcedureDeclaration__44_s->proc))->typ = DevCPT_notyp;
	((*ProcedureDeclaration__44_s->proc))->sysflag = (BYTE)(*ProcedureDeclaration__44_s->sys);
	((*ProcedureDeclaration__44_s->proc))->conval->setval = 0x0;
	if ((INTEGER)DevCPP_sym == 40) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_FormalParameters(&((*ProcedureDeclaration__44_s->proc))->link, &((*ProcedureDeclaration__44_s->proc))->typ, \
&name);
		if (name != NIL) {
			DevCPP_err(0);
		}
	}
	DevCPP_CheckForwardTypes();
	DevCPP_userList = NIL;
	if ((*ProcedureDeclaration__44_s->fwd) != NIL) {
		DevCPB_CheckParameters(((*ProcedureDeclaration__44_s->proc))->link, ((*ProcedureDeclaration__44_s->fwd))->link, \
1);
		if (!DevCPT_EqualType(((*ProcedureDeclaration__44_s->proc))->typ, ((*ProcedureDeclaration__44_s->fwd))->typ)) \
{
			DevCPP_err(117);
		}
		(*ProcedureDeclaration__44_s->proc) = (*ProcedureDeclaration__44_s->fwd);
		DevCPT_topScope = ((*ProcedureDeclaration__44_s->proc))->scope;
		if ((INTEGER)(*ProcedureDeclaration__44_s->mode) == 10) {
			((*ProcedureDeclaration__44_s->proc))->mode = 10;
		}
	}
	__EXIT;
}

static void __45 (void)
{
	DevCPT_Node procdec = NIL;
	DevCPT_Node statseq = NIL;
	INTEGER c;
	__ENTER("DevCPP.Body");
	c = DevCPM_errpos;
	((*ProcedureDeclaration__44_s->proc))->conval->setval |= __SETOF(1);
	DevCPP_CheckSym(49);
	DevCPP_Block(&procdec, &statseq);
	DevCPB_Enter(&procdec, statseq, (*ProcedureDeclaration__44_s->proc));
	*ProcedureDeclaration__44_s->x = procdec;
	(*ProcedureDeclaration__44_s->x)->conval = DevCPT_NewConst();
	(*ProcedureDeclaration__44_s->x)->conval->intval = c;
	(*ProcedureDeclaration__44_s->x)->conval->intval2 = DevCPM_startpos;
	DevCPP_CheckSym(51);
	if ((INTEGER)DevCPP_sym == 48) {
		if (__STRCMPSS(DevCPS_name, ((*ProcedureDeclaration__44_s->proc))->name->data) != 0) {
			DevCPP_err(4);
		}
		DevCPS_Get(&DevCPP_sym);
	} else {
		DevCPP_err(48);
	}
	__EXIT;
}

static void __55 (void)
{
	DevCPT_Object baseProc = NIL;
	DevCPT_Object o = NIL;
	DevCPT_Struct objTyp = NIL;
	DevCPT_Struct recTyp = NIL;
	BYTE objMode, objVis;
	DevCPT_Name objName;
	DevCPT_Node pnode = NIL;
	SET fwdAttr;
	__ENTER("DevCPP.TProcDecl");
	DevCPS_Get(&DevCPP_sym);
	(*ProcedureDeclaration__44_s->mode) = 13;
	if ((INTEGER)DevCPP_level > 0) {
		DevCPP_err(73);
	}
	DevCPP_Receiver(&objMode, &objVis, objName, &objTyp, &recTyp);
	if ((INTEGER)DevCPP_sym == 48) {
		__MOVE(DevCPS_name, (*ProcedureDeclaration__44_s->name), 256);
		DevCPT_FindField((void*)(*ProcedureDeclaration__44_s->name), 256, recTyp, &(*ProcedureDeclaration__44_s->fwd));
		DevCPT_FindBaseField((void*)(*ProcedureDeclaration__44_s->name), 256, recTyp, &baseProc);
		if (baseProc != NIL && (INTEGER)baseProc->mode != 13) {
			baseProc = NIL;
			DevCPP_err(1);
		}
		if ((*ProcedureDeclaration__44_s->fwd) == baseProc) {
			(*ProcedureDeclaration__44_s->fwd) = NIL;
		}
		if ((*ProcedureDeclaration__44_s->fwd) != NIL && (INTEGER)((*ProcedureDeclaration__44_s->fwd))->mnolev \
!= (INTEGER)DevCPP_level) {
			(*ProcedureDeclaration__44_s->fwd) = NIL;
		}
		if (((*ProcedureDeclaration__44_s->fwd) != NIL && (INTEGER)((*ProcedureDeclaration__44_s->fwd))->mode \
== 13) && (((*ProcedureDeclaration__44_s->fwd))->conval->setval & 0x0a0002) == 0x0) {
			(*ProcedureDeclaration__44_s->proc) = DevCPT_NewObj();
			((*ProcedureDeclaration__44_s->proc))->leaf = 1;
			((*ProcedureDeclaration__44_s->proc))->mode = 13;
			((*ProcedureDeclaration__44_s->proc))->conval = DevCPT_NewConst();
			DevCPP_CheckMark((*ProcedureDeclaration__44_s->proc));
			if ((INTEGER)((*ProcedureDeclaration__44_s->fwd))->vis != (INTEGER)((*ProcedureDeclaration__44_s->proc))->vis) \
{
				DevCPP_err(118);
			}
			fwdAttr = ((*ProcedureDeclaration__44_s->fwd))->conval->setval;
		} else {
			if ((*ProcedureDeclaration__44_s->fwd) != NIL) {
				DevCPP_err(1);
				(*ProcedureDeclaration__44_s->fwd) = NIL;
			}
			DevCPT_InsertField((*ProcedureDeclaration__44_s->name), recTyp, &(*ProcedureDeclaration__44_s->proc));
			((*ProcedureDeclaration__44_s->proc))->mode = 13;
			((*ProcedureDeclaration__44_s->proc))->conval = DevCPT_NewConst();
			DevCPP_CheckMark((*ProcedureDeclaration__44_s->proc));
			if (recTyp->strobj != NIL) {
				o = recTyp->strobj->link;
				if (o == NIL) {
					recTyp->strobj->link = (*ProcedureDeclaration__44_s->proc);
				} else {
					while (o->nlink != NIL) {
						o = o->nlink;
					}
					o->nlink = (*ProcedureDeclaration__44_s->proc);
				}
			}
		}
		DevCPP_level += 1;
		DevCPT_OpenScope(DevCPP_level, (*ProcedureDeclaration__44_s->proc));
		DevCPT_Insert(objName, &((*ProcedureDeclaration__44_s->proc))->link);
		((*ProcedureDeclaration__44_s->proc))->link->mode = objMode;
		((*ProcedureDeclaration__44_s->proc))->link->vis = objVis;
		((*ProcedureDeclaration__44_s->proc))->link->typ = objTyp;
		__ASSERT(DevCPT_topScope != NIL, 0);
		__53();
		__ASSERT(DevCPT_topScope != NIL, 0);
		DevCPP_GetAttributes((*ProcedureDeclaration__44_s->proc), baseProc, recTyp);
		if ((*ProcedureDeclaration__44_s->fwd) != NIL && ((fwdAttr ^ ((*ProcedureDeclaration__44_s->proc))->conval->setval) \
& 0x1a0000) != 0x0) {
			DevCPP_err(184);
		}
		DevCPP_CheckOverwrite((*ProcedureDeclaration__44_s->proc), baseProc, recTyp);
		if (!(*ProcedureDeclaration__44_s->forward)) {
			if (__IN(19, ((*ProcedureDeclaration__44_s->proc))->conval->setval)) {
				pnode = NIL;
				DevCPB_Enter(&pnode, NIL, (*ProcedureDeclaration__44_s->proc));
				pnode->conval = DevCPT_NewConst();
				pnode->conval->intval = DevCPM_errpos;
				pnode->conval->intval2 = DevCPM_errpos;
				*ProcedureDeclaration__44_s->x = pnode;
			} else if (__IN(9, DevCPM_options)) {
				((*ProcedureDeclaration__44_s->proc))->conval->setval |= __SETOF(1);
			} else if (!__IN(17, ((*ProcedureDeclaration__44_s->proc))->conval->setval)) {
				__45();
			}
			((*ProcedureDeclaration__44_s->proc))->adr = 0;
		} else {
			((*ProcedureDeclaration__44_s->proc))->adr = DevCPM_errpos;
			if ((((*ProcedureDeclaration__44_s->proc))->conval->setval & 0x0a0000) != 0x0) {
				DevCPP_err(184);
			}
		}
		DevCPP_level -= 1;
		DevCPT_CloseScope();
	} else {
		DevCPP_err(48);
	}
	__EXIT;
}

static void DevCPP_ProcedureDeclaration (DevCPT_Node *x)
{
	DevCPT_Object proc = NIL;
	DevCPT_Object fwd = NIL;
	DevCPT_Name name;
	BYTE mode;
	BOOLEAN forward;
	SHORTINT sys;
	struct ProcedureDeclaration__44 _s;
	__ENTER("DevCPP.ProcedureDeclaration");
	_s.x = x;
	_s.proc = &proc;
	_s.fwd = &fwd;
	_s.name = (void*)name;
	_s.mode = &mode;
	_s.forward = &forward;
	_s.sys = &sys;
	_s.lnk = ProcedureDeclaration__44_s;
	ProcedureDeclaration__44_s = &_s;
	proc = NIL;
	forward = 0;
	*x = NIL;
	mode = 6;
	sys = 0;
	if ((INTEGER)DevCPP_sym != 48 && (INTEGER)DevCPP_sym != 40) {
		DevCPP_CheckSysFlag(&sys, DevCPM_GetProcSysFlag);
		if ((INTEGER)sys != 0) {
			if (__ODD((INTEGER)sys)) {
				mode = 9;
			}
		} else {
			if ((INTEGER)DevCPP_sym == 1) {
			} else if ((INTEGER)DevCPP_sym == 17) {
				forward = 1;
			} else {
				DevCPP_err(48);
			}
			DevCPS_Get(&DevCPP_sym);
		}
	}
	if ((INTEGER)DevCPP_sym == 40) {
		__55();
	} else if ((INTEGER)DevCPP_sym == 48) {
		DevCPT_Find(DevCPS_name, &fwd);
		__MOVE(DevCPS_name, name, 256);
		if (fwd != NIL && ((INTEGER)fwd->mnolev != (INTEGER)DevCPP_level || (INTEGER)fwd->mode == 8)) {
			fwd = NIL;
		}
		if ((fwd != NIL && __IN(fwd->mode, 0xc0)) && !__IN(1, fwd->conval->setval)) {
			proc = DevCPT_NewObj();
			proc->leaf = 1;
			proc->mode = mode;
			proc->conval = DevCPT_NewConst();
			DevCPP_CheckMark(proc);
			if ((INTEGER)fwd->vis != (INTEGER)proc->vis) {
				DevCPP_err(118);
			}
		} else {
			if (fwd != NIL) {
				DevCPP_err(1);
				fwd = NIL;
			}
			DevCPT_Insert(name, &proc);
			proc->mode = mode;
			proc->conval = DevCPT_NewConst();
			DevCPP_CheckMark(proc);
		}
		if ((INTEGER)proc->vis != 0 && (INTEGER)mode == 6) {
			mode = 7;
		}
		if ((INTEGER)mode != 6 && (INTEGER)DevCPP_level > 0) {
			DevCPP_err(73);
		}
		DevCPP_level += 1;
		DevCPT_OpenScope(DevCPP_level, proc);
		proc->link = NIL;
		__53();
		if ((INTEGER)mode == 9) {
			__47();
		} else if (__IN(9, DevCPM_options)) {
			proc->conval->setval |= __SETOF(1);
		} else if (!forward) {
			__45();
			proc->adr = 0;
		} else {
			proc->adr = DevCPM_errpos;
		}
		DevCPP_level -= 1;
		DevCPT_CloseScope();
	} else {
		DevCPP_err(48);
	}
	ProcedureDeclaration__44_s = _s.lnk;
	__EXIT;
}

static struct CaseLabelList__9 {
	DevCPT_Node *x, *y;
	INTEGER *xval, *yval;
	struct CaseLabelList__9 *lnk;
} *CaseLabelList__9_s;

static void __10 (DevCPT_Node *n);

static void __10 (DevCPT_Node *n)
{
	DevCPT_Node _ptr__13 = NIL;
	DevCPT_Node _ptr__12 = NIL;
	__ENTER("DevCPP.Insert");
	if (*n == NIL) {
		if ((INTEGER)((*CaseLabelList__9_s->x))->hint != 1) {
			*n = (*CaseLabelList__9_s->x);
		}
	} else if ((*CaseLabelList__9_s->yval) < (*n)->conval->intval) {
		_ptr__13 = *n;
		__10(&_ptr__13->left);
	} else if ((*CaseLabelList__9_s->xval) > (*n)->conval->intval2) {
		_ptr__12 = *n;
		__10(&_ptr__12->right);
	} else {
		DevCPP_err(63);
	}
	__EXIT;
}

static void DevCPP_CaseLabelList (DevCPT_Node *lab, DevCPT_Node *root, SHORTINT LabelForm, INTEGER *min, \
INTEGER *max)
{
	DevCPT_Node x = NIL;
	DevCPT_Node y = NIL;
	SHORTINT f;
	INTEGER xval, yval;
	struct CaseLabelList__9 _s;
	__ENTER("DevCPP.CaseLabelList");
	_s.x = &x;
	_s.y = &y;
	_s.xval = &xval;
	_s.yval = &yval;
	_s.lnk = CaseLabelList__9_s;
	CaseLabelList__9_s = &_s;
	*lab = NIL;
	for (;;) {
		DevCPP_ConstExpression(&x);
		f = x->typ->form;
		if (__IN(f, 0x010078)) {
			xval = x->conval->intval;
		} else {
			DevCPP_err(61);
			xval = 1;
		}
		if (__IN(f, 0x70) != __IN(LabelForm, 0x70)) {
			DevCPP_err(60);
		}
		if ((INTEGER)DevCPP_sym == 22) {
			DevCPS_Get(&DevCPP_sym);
			DevCPP_ConstExpression(&y);
			yval = y->conval->intval;
			if (__IN(y->typ->form, 0x70) != __IN(LabelForm, 0x70)) {
				DevCPP_err(60);
			}
			if (yval < xval) {
				DevCPP_err(63);
				yval = xval;
			}
		} else {
			yval = xval;
		}
		x->conval->intval2 = yval;
		if (xval < *min) {
			*min = xval;
		}
		if (yval > *max) {
			*max = yval;
		}
		if (*lab == NIL) {
			*lab = x;
			__10(root);
		} else if (yval < (*lab)->conval->intval - 1) {
			x->link = *lab;
			*lab = x;
			__10(root);
		} else if (yval == (*lab)->conval->intval - 1) {
			x->hint = 1;
			__10(root);
			(*lab)->conval->intval = xval;
		} else if (xval == (*lab)->conval->intval2 + 1) {
			x->hint = 1;
			__10(root);
			(*lab)->conval->intval2 = yval;
		} else {
			y = *lab;
			while (y->link != NIL && xval > y->link->conval->intval2 + 1) {
				y = y->link;
			}
			if (y->link == NIL) {
				y->link = x;
				__10(root);
			} else if (yval < y->link->conval->intval - 1) {
				x->link = y->link;
				y->link = x;
				__10(root);
			} else if (yval == y->link->conval->intval - 1) {
				x->hint = 1;
				__10(root);
				y->link->conval->intval = xval;
			} else if (xval == y->link->conval->intval2 + 1) {
				x->hint = 1;
				__10(root);
				y->link->conval->intval2 = yval;
			}
		}
		if ((INTEGER)DevCPP_sym == 20) {
			DevCPS_Get(&DevCPP_sym);
		} else if ((INTEGER)DevCPP_sym == 45 || (INTEGER)DevCPP_sym == 48) {
			DevCPP_err(20);
		} else {
			break;
		}
	}
	CaseLabelList__9_s = _s.lnk;
	__EXIT;
}

static struct StatSeq__65 {
	DevCPT_Object *fpar, *id, *t;
	DevCPT_Node *s, *x, *y, *z, *apar, *last, *lastif, *pre, *lastp;
	INTEGER *pos;
	struct StatSeq__65 *lnk;
} *StatSeq__65_s;

static void __66 (DevCPT_Node *x);
static void __68 (DevCPT_Node *x);
static void __70 (DevCPT_Node x);

static void __66 (DevCPT_Node *x)
{
	INTEGER low, high;
	BOOLEAN e;
	DevCPT_Node cases = NIL;
	DevCPT_Node lab = NIL;
	DevCPT_Node y = NIL;
	DevCPT_Node lastcase = NIL;
	DevCPT_Node root = NIL;
	__ENTER("DevCPP.CasePart");
	DevCPP_Expression(x);
	if ((INTEGER)(*x)->class == 8 || (INTEGER)(*x)->class == 9) {
		DevCPP_err(126);
	} else if ((INTEGER)(*x)->typ->form == 18) {
		DevCPP_err(260);
	} else if (!__IN((*x)->typ->form, 0x010078)) {
		DevCPP_err(125);
	}
	DevCPP_CheckSym(26);
	cases = NIL;
	lastcase = NIL;
	root = NIL;
	low = 2147483647;
	high = (-2147483647-1);
	for (;;) {
		if ((INTEGER)DevCPP_sym < 50) {
			DevCPP_CaseLabelList(&lab, &root, (*x)->typ->form, &low, &high);
			DevCPP_CheckSym(21);
			DevCPP_StatSeq(&y);
			DevCPB_Construct(17, &lab, y);
			DevCPB_Link(&cases, &lastcase, lab);
		}
		if ((INTEGER)DevCPP_sym == 50) {
			DevCPS_Get(&DevCPP_sym);
		} else {
			break;
		}
	}
	e = (INTEGER)DevCPP_sym == 52;
	if (e) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_StatSeq(&y);
	} else {
		y = NIL;
	}
	DevCPB_Construct(16, &cases, y);
	DevCPB_Construct(21, x, cases);
	cases->conval = DevCPT_NewConst();
	cases->conval->intval = low;
	cases->conval->intval2 = high;
	if (e) {
		cases->conval->setval = 0x02;
	} else {
		cases->conval->setval = 0x0;
	}
	DevCPB_OptimizeCase(&root);
	cases->link = root;
	__EXIT;
}

static void __70 (DevCPT_Node x)
{
	__ENTER("DevCPP.SetPos");
	x->conval = DevCPT_NewConst();
	x->conval->intval = (*StatSeq__65_s->pos);
	__EXIT;
}

static void __68 (DevCPT_Node *x)
{
	__ENTER("DevCPP.CheckBool");
	if ((INTEGER)(*x)->class == 8 || (INTEGER)(*x)->class == 9) {
		DevCPP_err(126);
		*x = DevCPB_NewBoolConst(0);
	} else if ((INTEGER)(*x)->typ->form != 2) {
		DevCPP_err(120);
		*x = DevCPB_NewBoolConst(0);
	}
	__EXIT;
}

static void DevCPP_StatSeq (DevCPT_Node *stat)
{
	DevCPT_Object fpar = NIL;
	DevCPT_Object id = NIL;
	DevCPT_Object t = NIL;
	DevCPT_Struct idtyp = NIL;
	BOOLEAN e;
	DevCPT_Node s = NIL;
	DevCPT_Node x = NIL;
	DevCPT_Node y = NIL;
	DevCPT_Node z = NIL;
	DevCPT_Node apar = NIL;
	DevCPT_Node last = NIL;
	DevCPT_Node lastif = NIL;
	DevCPT_Node pre = NIL;
	DevCPT_Node lastp = NIL;
	INTEGER pos, p;
	struct StatSeq__65 _s;
	__ENTER("DevCPP.StatSeq");
	_s.fpar = &fpar;
	_s.id = &id;
	_s.t = &t;
	_s.s = &s;
	_s.x = &x;
	_s.y = &y;
	_s.z = &z;
	_s.apar = &apar;
	_s.last = &last;
	_s.lastif = &lastif;
	_s.pre = &pre;
	_s.lastp = &lastp;
	_s.pos = &pos;
	_s.lnk = StatSeq__65_s;
	StatSeq__65_s = &_s;
	*stat = NIL;
	last = NIL;
	for (;;) {
		x = NIL;
		if ((INTEGER)DevCPP_sym < 48) {
			DevCPP_err(14);
			do {
				DevCPS_Get(&DevCPP_sym);
			} while (!((INTEGER)DevCPP_sym >= 48));
		}
		pos = DevCPM_startpos;
		if ((INTEGER)DevCPP_sym == 48) {
			DevCPP_qualident(&id);
			x = DevCPB_NewLeaf(id);
			DevCPP_selector(&x);
			if ((INTEGER)DevCPP_sym == 44) {
				DevCPS_Get(&DevCPP_sym);
				DevCPP_Expression(&y);
				if ((INTEGER)y->typ->form == 13 && (INTEGER)x->typ->form == 15) {
					DevCPB_DeRef(&y);
				}
				pre = NIL;
				lastp = NIL;
				DevCPB_CheckBuffering(&y, x, NIL, &pre, &lastp);
				DevCPB_Assign(&x, y);
				if (pre != NIL) {
					__70(x);
					DevCPB_Construct(30, &pre, x);
					x = pre;
				}
			} else if ((INTEGER)DevCPP_sym == 9) {
				DevCPP_err(44);
				DevCPS_Get(&DevCPP_sym);
				DevCPP_Expression(&y);
				DevCPB_Assign(&x, y);
			} else if ((INTEGER)x->class == 9 && (INTEGER)x->obj->mode == 8) {
				DevCPP_StandProcCall(&x);
				if (x != NIL && x->typ != DevCPT_notyp) {
					DevCPP_err(55);
				}
				if (x != NIL && (INTEGER)x->class == 20) {
					__70(x->left);
					__70(x->left->right);
				}
			} else if ((INTEGER)x->class == 13) {
				DevCPP_err(55);
			} else {
				pre = NIL;
				lastp = NIL;
				DevCPB_PrepCall(&x, &fpar);
				if (x->obj != NIL && (INTEGER)x->obj->mode == 13) {
					DevCPB_CheckBuffering(&x->left, NIL, x->obj->link, &pre, &lastp);
				}
				if ((INTEGER)DevCPP_sym == 40) {
					DevCPS_Get(&DevCPP_sym);
					DevCPP_ActualParameters(&apar, fpar, &pre, &lastp);
					DevCPP_CheckSym(23);
				} else {
					apar = NIL;
					if (fpar != NIL) {
						DevCPP_err(65);
					}
				}
				DevCPB_Call(&x, apar, fpar);
				if (x->typ != DevCPT_notyp) {
					DevCPP_err(55);
				}
				if (pre != NIL) {
					__70(x);
					DevCPB_Construct(30, &pre, x);
					x = pre;
				}
				if ((INTEGER)DevCPP_level > 0) {
					DevCPT_topScope->link->leaf = 0;
				}
			}
		} else if ((INTEGER)DevCPP_sym == 55) {
			DevCPS_Get(&DevCPP_sym);
			pos = DevCPM_startpos;
			DevCPP_Expression(&x);
			__68(&x);
			DevCPP_CheckSym(27);
			DevCPP_StatSeq(&y);
			DevCPB_Construct(15, &x, y);
			__70(x);
			lastif = x;
			while ((INTEGER)DevCPP_sym == 53) {
				DevCPS_Get(&DevCPP_sym);
				pos = DevCPM_startpos;
				DevCPP_Expression(&y);
				__68(&y);
				DevCPP_CheckSym(27);
				DevCPP_StatSeq(&z);
				DevCPB_Construct(15, &y, z);
				__70(y);
				DevCPB_Link(&x, &lastif, y);
			}
			pos = DevCPM_startpos;
			if ((INTEGER)DevCPP_sym == 52) {
				DevCPS_Get(&DevCPP_sym);
				DevCPP_StatSeq(&y);
			} else {
				y = NIL;
			}
			DevCPB_Construct(20, &x, y);
			DevCPP_CheckSym(51);
			DevCPB_OptIf(&x);
		} else if ((INTEGER)DevCPP_sym == 56) {
			DevCPS_Get(&DevCPP_sym);
			pos = DevCPM_startpos;
			__66(&x);
			DevCPP_CheckSym(51);
		} else if ((INTEGER)DevCPP_sym == 57) {
			DevCPS_Get(&DevCPP_sym);
			pos = DevCPM_startpos;
			DevCPP_Expression(&x);
			__68(&x);
			DevCPP_CheckSym(28);
			DevCPP_StatSeq(&y);
			DevCPB_Construct(22, &x, y);
			DevCPP_CheckSym(51);
		} else if ((INTEGER)DevCPP_sym == 58) {
			DevCPS_Get(&DevCPP_sym);
			DevCPP_StatSeq(&x);
			if ((INTEGER)DevCPP_sym == 54) {
				DevCPS_Get(&DevCPP_sym);
				pos = DevCPM_startpos;
				DevCPP_Expression(&y);
				__68(&y);
			} else {
				DevCPP_err(43);
			}
			DevCPB_Construct(23, &x, y);
		} else if ((INTEGER)DevCPP_sym == 59) {
			DevCPS_Get(&DevCPP_sym);
			pos = DevCPM_startpos;
			if ((INTEGER)DevCPP_sym == 48) {
				DevCPP_qualident(&id);
				if (!__IN(id->typ->form, 0x040070)) {
					DevCPP_err(68);
				}
				DevCPP_CheckSym(44);
				DevCPP_Expression(&y);
				x = DevCPB_NewLeaf(id);
				DevCPB_Assign(&x, y);
				__70(x);
				DevCPP_CheckSym(29);
				pos = DevCPM_startpos;
				DevCPP_Expression(&y);
				if ((INTEGER)y->class != 7) {
					DevCPB_GetTempVar((void*)"@for", 5, x->left->typ, &t);
					z = DevCPB_NewLeaf(t);
					DevCPB_Assign(&z, y);
					__70(z);
					DevCPB_Link(stat, &last, z);
					y = DevCPB_NewLeaf(t);
				} else {
					DevCPB_CheckAssign(x->left->typ, &y);
				}
				DevCPB_Link(stat, &last, x);
				p = DevCPM_startpos;
				if ((INTEGER)DevCPP_sym == 30) {
					DevCPS_Get(&DevCPP_sym);
					DevCPP_ConstExpression(&z);
				} else {
					z = DevCPB_NewIntConst(1);
				}
				x = DevCPB_NewLeaf(id);
				if (z->conval->intval > 0) {
					DevCPB_Op(12, &x, y);
				} else if (z->conval->intval < 0) {
					DevCPB_Op(14, &x, y);
				} else {
					DevCPP_err(63);
					DevCPB_Op(14, &x, y);
				}
				DevCPP_CheckSym(28);
				DevCPP_StatSeq(&s);
				y = DevCPB_NewLeaf(id);
				DevCPB_StPar1(&y, z, 13);
				pos = DevCPM_startpos;
				__70(y);
				if (s == NIL) {
					s = y;
				} else {
					z = s;
					while (z->link != NIL) {
						z = z->link;
					}
					z->link = y;
				}
				DevCPP_CheckSym(51);
				DevCPB_Construct(22, &x, s);
				pos = p;
			} else {
				DevCPP_err(48);
			}
		} else if ((INTEGER)DevCPP_sym == 60) {
			DevCPS_Get(&DevCPP_sym);
			DevCPP_LoopLevel += 1;
			DevCPP_StatSeq(&x);
			DevCPP_LoopLevel -= 1;
			DevCPB_Construct(24, &x, NIL);
			DevCPP_CheckSym(51);
		} else if ((INTEGER)DevCPP_sym == 61) {
			DevCPS_Get(&DevCPP_sym);
			idtyp = NIL;
			x = NIL;
			for (;;) {
				if ((INTEGER)DevCPP_sym < 50) {
					pos = DevCPM_startpos;
					if ((INTEGER)DevCPP_sym == 48) {
						DevCPP_qualident(&id);
						y = DevCPB_NewLeaf(id);
						if ((id != NIL && (INTEGER)id->typ->form == 13) && ((INTEGER)id->mode == 2 || !id->leaf)) {
							DevCPP_err(-302);
						}
						DevCPP_CheckSym(21);
						if ((INTEGER)DevCPP_sym == 48) {
							DevCPP_qualident(&t);
							if ((INTEGER)t->mode == 5) {
								if (id != NIL) {
									idtyp = id->typ;
									DevCPB_TypTest(&y, t, 0);
									id->typ = t->typ;
									if (id->ptyp == NIL) {
										id->ptyp = idtyp;
									}
								} else {
									DevCPP_err(130);
								}
							} else {
								DevCPP_err(52);
							}
						} else {
							DevCPP_err(48);
						}
					} else {
						DevCPP_err(48);
					}
					DevCPP_CheckSym(28);
					DevCPP_StatSeq(&s);
					DevCPB_Construct(15, &y, s);
					__70(y);
					if (idtyp != NIL) {
						if (id->ptyp == idtyp) {
							id->ptyp = NIL;
						}
						id->typ = idtyp;
						idtyp = NIL;
					}
					if (x == NIL) {
						x = y;
						lastif = x;
					} else {
						DevCPB_Link(&x, &lastif, y);
					}
				}
				if ((INTEGER)DevCPP_sym == 50) {
					DevCPS_Get(&DevCPP_sym);
				} else {
					break;
				}
			}
			e = (INTEGER)DevCPP_sym == 52;
			pos = DevCPM_startpos;
			if (e) {
				DevCPS_Get(&DevCPP_sym);
				DevCPP_StatSeq(&s);
			} else {
				s = NIL;
			}
			DevCPB_Construct(27, &x, s);
			DevCPP_CheckSym(51);
			if (e) {
				x->subcl = 1;
			}
		} else if ((INTEGER)DevCPP_sym == 62) {
			DevCPS_Get(&DevCPP_sym);
			if ((INTEGER)DevCPP_LoopLevel == 0) {
				DevCPP_err(46);
			}
			DevCPB_Construct(25, &x, NIL);
		} else if ((INTEGER)DevCPP_sym == 63) {
			DevCPS_Get(&DevCPP_sym);
			if ((INTEGER)DevCPP_sym < 49) {
				DevCPP_Expression(&x);
			}
			if ((INTEGER)DevCPP_level > 0) {
				DevCPB_Return(&x, DevCPT_topScope->link);
			} else {
				DevCPB_Return(&x, NIL);
			}
			DevCPP_hasReturn = 1;
		}
		if (x != NIL) {
			__70(x);
			DevCPB_Link(stat, &last, x);
		}
		if ((INTEGER)DevCPP_sym == 49) {
			DevCPS_Get(&DevCPP_sym);
		} else if ((INTEGER)DevCPP_sym <= 48 || 55 <= (INTEGER)DevCPP_sym && (INTEGER)DevCPP_sym <= 63) {
			DevCPP_err(49);
		} else {
			break;
		}
	}
	StatSeq__65_s = _s.lnk;
	__EXIT;
}

static void DevCPP_Block (DevCPT_Node *procdec, DevCPT_Node *statseq)
{
	DevCPT_Struct typ = NIL;
	DevCPT_Object obj = NIL;
	DevCPT_Object first = NIL;
	DevCPT_Object last = NIL;
	DevCPT_Object o = NIL;
	DevCPT_Node x = NIL;
	DevCPT_Node lastdec = NIL;
	SHORTINT i;
	DevCPT_Name rname;
	DevCPT_String name = NIL;
	DevCPP_Elem rec = NIL;
	__ENTER("DevCPP.Block");
	if (((((INTEGER)DevCPP_sym < 67 || (INTEGER)DevCPP_sym > 70) && (INTEGER)DevCPP_sym != 72) && (INTEGER)DevCPP_sym \
!= 51) && (INTEGER)DevCPP_sym != 73) {
		DevCPP_err(36);
	}
	first = NIL;
	last = NIL;
	DevCPP_userList = NIL;
	DevCPP_recList = NIL;
	for (;;) {
		if ((INTEGER)DevCPP_sym == 68) {
			DevCPS_Get(&DevCPP_sym);
			while ((INTEGER)DevCPP_sym == 48) {
				DevCPT_Insert(DevCPS_name, &obj);
				obj->mode = 3;
				DevCPP_CheckMark(obj);
				obj->typ = DevCPT_int8typ;
				obj->mode = 1;
				if ((INTEGER)DevCPP_sym == 9) {
					DevCPS_Get(&DevCPP_sym);
					DevCPP_ConstExpression(&x);
				} else if ((INTEGER)DevCPP_sym == 44) {
					DevCPP_err(9);
					DevCPS_Get(&DevCPP_sym);
					DevCPP_ConstExpression(&x);
				} else {
					DevCPP_err(9);
					x = DevCPB_NewIntConst(1);
				}
				obj->mode = 3;
				obj->typ = x->typ;
				obj->conval = x->conval;
				DevCPP_CheckSym(49);
			}
		}
		if ((INTEGER)DevCPP_sym == 69) {
			DevCPS_Get(&DevCPP_sym);
			while ((INTEGER)DevCPP_sym == 48) {
				DevCPT_Insert(DevCPS_name, &obj);
				obj->mode = 5;
				obj->typ = DevCPT_undftyp;
				DevCPP_CheckMark(obj);
				obj->mode = -1;
				if ((INTEGER)DevCPP_sym != 9) {
					DevCPP_err(9);
				}
				if (((INTEGER)DevCPP_sym == 9 || (INTEGER)DevCPP_sym == 44) || (INTEGER)DevCPP_sym == 21) {
					DevCPS_Get(&DevCPP_sym);
					DevCPP_Type(&obj->typ, &name);
					DevCPP_SetType(NIL, obj, obj->typ, name);
				}
				obj->mode = 5;
				if (__IN(obj->typ->form, 0x0503fe)) {
					typ = DevCPT_NewStr(obj->typ->form, 1);
					i = typ->ref;
					*typ = *obj->typ;
					typ->ref = i;
					typ->strobj = NIL;
					typ->mno = 0;
					typ->txtpos = DevCPM_errpos;
					typ->BaseTyp = obj->typ;
					obj->typ = typ;
				}
				if (obj->typ->strobj == NIL) {
					obj->typ->strobj = obj;
				}
				if ((INTEGER)obj->typ->form == 13) {
					typ = obj->typ->BaseTyp;
					if ((typ != NIL && (INTEGER)typ->comp == 4) && typ->strobj == NIL) {
						__STRCOPYSS(obj->name->data, rname, 256);
						i = 0;
						while (rname[__X(i, 256)] != 0) {
							i += 1;
						}
						rname[__X(i, 256)] = (SHORTCHAR)'^';
						rname[__X((INTEGER)i + 1, 256)] = 0;
						DevCPT_Insert(rname, &o);
						o->mode = 5;
						o->typ = typ;
						typ->strobj = o;
					}
				}
				if ((INTEGER)obj->vis != 0) {
					typ = obj->typ;
					if ((INTEGER)typ->form == 13) {
						typ = typ->BaseTyp;
					}
					if ((INTEGER)typ->comp == 4) {
						typ->exp = 1;
					}
				}
				DevCPP_CheckSym(49);
			}
		}
		if ((INTEGER)DevCPP_sym == 70) {
			DevCPS_Get(&DevCPP_sym);
			while ((INTEGER)DevCPP_sym == 48) {
				for (;;) {
					if ((INTEGER)DevCPP_sym == 48) {
						DevCPT_Insert(DevCPS_name, &obj);
						obj->mode = 1;
						obj->link = NIL;
						obj->leaf = (INTEGER)obj->vis == 0;
						obj->typ = DevCPT_undftyp;
						DevCPP_CheckMark(obj);
						if (first == NIL) {
							first = obj;
						}
						if (last == NIL) {
							DevCPT_topScope->scope = obj;
						} else {
							last->link = obj;
						}
						last = obj;
					} else {
						DevCPP_err(48);
					}
					if ((INTEGER)DevCPP_sym == 20) {
						DevCPS_Get(&DevCPP_sym);
					} else if ((INTEGER)DevCPP_sym == 48) {
						DevCPP_err(20);
					} else {
						break;
					}
				}
				DevCPP_CheckSym(21);
				DevCPP_Type(&typ, &name);
				DevCPP_CheckAlloc(&typ, 0, DevCPM_errpos);
				while (first != NIL) {
					DevCPP_SetType(NIL, first, typ, name);
					first = first->link;
				}
				DevCPP_CheckSym(49);
			}
		}
		if ((INTEGER)DevCPP_sym < 68 || (INTEGER)DevCPP_sym > 70) {
			break;
		}
	}
	DevCPP_CheckForwardTypes();
	DevCPP_userList = NIL;
	rec = DevCPP_recList;
	DevCPP_recList = NIL;
	DevCPT_topScope->adr = DevCPM_errpos;
	*procdec = NIL;
	lastdec = NIL;
	if ((((INTEGER)DevCPP_sym != 72 && (INTEGER)DevCPP_sym != 67) && (INTEGER)DevCPP_sym != 51) && (INTEGER)DevCPP_sym \
!= 73) {
		DevCPP_err(37);
	}
	while ((INTEGER)DevCPP_sym == 72) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_ProcedureDeclaration(&x);
		if (x != NIL) {
			if (lastdec == NIL) {
				*procdec = x;
			} else {
				lastdec->link = x;
			}
			lastdec = x;
		}
		DevCPP_CheckSym(49);
	}
	if (DevCPM_noerr && !__IN(6, DevCPM_options)) {
		DevCPP_CheckRecords(rec);
	}
	DevCPP_hasReturn = 0;
	if (((INTEGER)DevCPP_sym != 67 && (INTEGER)DevCPP_sym != 51) && (INTEGER)DevCPP_sym != 73) {
		DevCPP_err(38);
	}
	if ((INTEGER)DevCPP_sym == 67) {
		DevCPS_Get(&DevCPP_sym);
		DevCPP_StatSeq(statseq);
	} else {
		*statseq = NIL;
	}
	if (((DevCPT_topScope->link != NIL && DevCPT_topScope->link->typ != DevCPT_notyp) && !DevCPP_hasReturn) \
&& (INTEGER)DevCPT_topScope->link->sysflag == 0) {
		DevCPP_err(133);
	}
	if ((INTEGER)DevCPP_level == 0 && DevCPP_TDinit != NIL) {
		DevCPP_lastTDinit->link = *statseq;
		*statseq = DevCPP_TDinit;
	}
	__EXIT;
}

void DevCPP_Module (DevCPT_Node *prog)
{
	DevCPT_Name impName, aliasName;
	DevCPT_Node procdec = NIL;
	DevCPT_Node statseq = NIL;
	INTEGER c;
	BOOLEAN done;
	DevCPT_Node _ptr__38 = NIL;
	__ENTER("DevCPP.Module");
	DevCPS_Init();
	DevCPP_LoopLevel = 0;
	DevCPP_level = 0;
	DevCPS_Get(&DevCPP_sym);
	if ((INTEGER)DevCPP_sym == 75) {
		DevCPS_Get(&DevCPP_sym);
	} else {
		DevCPP_err(16);
	}
	if ((INTEGER)DevCPP_sym == 48) {
		DevCPT_Open(DevCPS_name);
		DevCPS_Get(&DevCPP_sym);
		DevCPT_libName[0] = 0;
		if ((INTEGER)DevCPP_sym == 41) {
			DevCPM_options |= __SETOF(1);
			DevCPS_Get(&DevCPP_sym);
			if ((INTEGER)DevCPP_sym == 9) {
				DevCPS_Get(&DevCPP_sym);
			} else {
				DevCPM_options |= __SETOF(9);
			}
			if ((INTEGER)DevCPP_sym == 47) {
				__STRCOPYSS(DevCPS_str->data, DevCPT_libName, 256);
				DevCPS_Get(&DevCPP_sym);
			} else {
				DevCPP_err(47);
			}
			DevCPP_CheckSym(24);
		}
		DevCPP_CheckSym(49);
		if ((INTEGER)DevCPP_sym == 74) {
			DevCPS_Get(&DevCPP_sym);
			for (;;) {
				if ((INTEGER)DevCPP_sym == 48) {
					__STRCOPYSS(DevCPS_name, aliasName, 256);
					__STRCOPYSS(aliasName, impName, 256);
					DevCPS_Get(&DevCPP_sym);
					if ((INTEGER)DevCPP_sym == 44) {
						DevCPS_Get(&DevCPP_sym);
						if ((INTEGER)DevCPP_sym == 48) {
							__STRCOPYSS(DevCPS_name, impName, 256);
							DevCPS_Get(&DevCPP_sym);
						} else {
							DevCPP_err(48);
						}
					}
					DevCPT_Import(aliasName, impName, &done);
				} else {
					DevCPP_err(48);
				}
				if ((INTEGER)DevCPP_sym == 20) {
					DevCPS_Get(&DevCPP_sym);
				} else if ((INTEGER)DevCPP_sym == 48) {
					DevCPP_err(20);
				} else {
					break;
				}
			}
			DevCPP_CheckSym(49);
		}
		if (DevCPM_noerr) {
			DevCPP_TDinit = NIL;
			DevCPP_lastTDinit = NIL;
			c = DevCPM_errpos;
			DevCPP_Block(&procdec, &statseq);
			DevCPB_Enter(&procdec, statseq, NIL);
			*prog = procdec;
			(*prog)->conval = DevCPT_NewConst();
			(*prog)->conval->intval = c;
			(*prog)->conval->intval2 = DevCPM_startpos;
			if ((INTEGER)DevCPP_sym == 73) {
				DevCPS_Get(&DevCPP_sym);
				_ptr__38 = *prog;
				DevCPP_StatSeq(&_ptr__38->link);
			}
			(*prog)->conval->realval = DevCPM_startpos;
			DevCPP_CheckSym(51);
			if ((INTEGER)DevCPP_sym == 48) {
				if (__STRCMPSS(DevCPS_name, DevCPT_SelfName) != 0) {
					DevCPP_err(4);
				}
				DevCPS_Get(&DevCPP_sym);
			} else {
				DevCPP_err(48);
			}
			if ((INTEGER)DevCPP_sym != 19) {
				DevCPP_err(19);
			}
		}
	} else {
		DevCPP_err(48);
	}
	DevCPP_TDinit = NIL;
	DevCPP_lastTDinit = NIL;
	DevCPS_str = NIL;
	__EXIT;
}

static INTEGER DevCPP_Elem__rec__flds[] = {
	6, 
	0, 0, 1<<8 | 0x15, (INTEGER)DevCPP_Elem__desc,
	0, 4, 6<<8 | 0x15, (INTEGER)DevCPT_Struct__desc,
	0, 8, 13<<8 | 0x15, (INTEGER)DevCPT_Object__desc,
	0, 12, 17<<8 | 0x15, (INTEGER)DevCPT_Object__desc,
	0, 16, 22<<8 | 0x15, 6,
	0, 20, 26<<8 | 0x15, (INTEGER)DevCPT_String__desc,
};
export INTEGER DevCPP_Elem__rec__desc[] = {
	-1, 
	0, 
	24,
	(INTEGER)&DevCPP__desc,
	31<<8 | 0x01,
	(INTEGER)(DevCPP_Elem__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)DevCPP_Elem__rec__flds, 
	0, 4, 8, 12, 20, -24
};
export INTEGER DevCPP_Elem__desc[] = {
	0,
	(INTEGER)&DevCPP__desc,
	37<<8 | 0x03,
	(INTEGER)(DevCPP_Elem__rec__desc + 2)
};
static SYSTEM_MODDESC *DevCPP__imp[] = {
	&DevCPB__desc,
	&DevCPM__desc,
	&DevCPS__desc,
	&DevCPT__desc,
};
static INTEGER DevCPP__exp[] = {
	45,
	0x227d6f36, (INTEGER)DevCPP_ActualParameters, 42<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_ArrayType, 59<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_Block, 69<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CaseLabelList, 75<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckAlloc, 89<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckForwardTypes, 100<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckMark, 118<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckOverwrite, 128<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckRecords, 143<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckRecursiveType, 156<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckSym, 175<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckSysFlag, 184<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_CheckUnimpl, 197<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_ConstExpression, 209<<8 | 0x14, 0,
	0xfa1d2a5f, 0x5d5f9a42, 31<<8 | 0x12, (INTEGER)(DevCPP_Elem__rec__desc + 2),
	0x227d6f36, (INTEGER)DevCPP_Element, 225<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_Expression, 233<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_Factor, 244<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_FixType, 251<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_FormalParameters, 259<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_GetAttributes, 276<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_IncompleteType, 290<<8 | 0x14, 0,
	0x13a66ad3, (INTEGER)&DevCPP_LoopLevel, 305<<8 | 0x13, 5,
	0x81925877, (INTEGER)DevCPP_Module, 315<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPP_PointerType, 322<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_ProcedureDeclaration, 334<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_Receiver, 355<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_RecordType, 364<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_SetType, 375<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_Sets, 383<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_SimpleExpression, 388<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_StandProcCall, 405<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_StatSeq, 419<<8 | 0x14, 0,
	0x64c55ee3, (INTEGER)&DevCPP_TDinit, 427<<8 | 0x13, (INTEGER)DevCPT_Node__desc,
	0x227d6f36, (INTEGER)DevCPP_Term, 434<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_Type, 439<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPP_err, 444<<8 | 0x14, 0,
	0x0de13ad6, (INTEGER)&DevCPP_hasReturn, 448<<8 | 0x13, 1,
	0x64c55ee3, (INTEGER)&DevCPP_lastTDinit, 458<<8 | 0x13, (INTEGER)DevCPT_Node__desc,
	0x17677764, (INTEGER)&DevCPP_level, 469<<8 | 0x13, 4,
	0x227d6f36, (INTEGER)DevCPP_qualident, 475<<8 | 0x14, 0,
	0x94ea784b, (INTEGER)&DevCPP_recList, 485<<8 | 0x13, (INTEGER)DevCPP_Elem__desc,
	0x227d6f36, (INTEGER)DevCPP_selector, 493<<8 | 0x14, 0,
	0x17677764, (INTEGER)&DevCPP_sym, 502<<8 | 0x13, 4,
	0x94ea784b, (INTEGER)&DevCPP_userList, 506<<8 | 0x13, (INTEGER)DevCPP_Elem__desc,
};
static char DevCPP__names[] = {
	0,
	'n','e','x','t',0,
	's','t','r','u','c','t',0,
	'o','b','j',0,
	'b','a','s','e',0,
	'p','o','s',0,
	'n','a','m','e',0,
	'E','l','e','m','^',0,
	'E','l','e','m',0,
	'A','c','t','u','a','l','P','a','r','a','m','e','t','e','r','s',0,
	'A','r','r','a','y','T','y','p','e',0,
	'B','l','o','c','k',0,
	'C','a','s','e','L','a','b','e','l','L','i','s','t',0,
	'C','h','e','c','k','A','l','l','o','c',0,
	'C','h','e','c','k','F','o','r','w','a','r','d','T','y','p','e','s',0,
	'C','h','e','c','k','M','a','r','k',0,
	'C','h','e','c','k','O','v','e','r','w','r','i','t','e',0,
	'C','h','e','c','k','R','e','c','o','r','d','s',0,
	'C','h','e','c','k','R','e','c','u','r','s','i','v','e','T','y','p','e',0,
	'C','h','e','c','k','S','y','m',0,
	'C','h','e','c','k','S','y','s','F','l','a','g',0,
	'C','h','e','c','k','U','n','i','m','p','l',0,
	'C','o','n','s','t','E','x','p','r','e','s','s','i','o','n',0,
	'E','l','e','m','e','n','t',0,
	'E','x','p','r','e','s','s','i','o','n',0,
	'F','a','c','t','o','r',0,
	'F','i','x','T','y','p','e',0,
	'F','o','r','m','a','l','P','a','r','a','m','e','t','e','r','s',0,
	'G','e','t','A','t','t','r','i','b','u','t','e','s',0,
	'I','n','c','o','m','p','l','e','t','e','T','y','p','e',0,
	'L','o','o','p','L','e','v','e','l',0,
	'M','o','d','u','l','e',0,
	'P','o','i','n','t','e','r','T','y','p','e',0,
	'P','r','o','c','e','d','u','r','e','D','e','c','l','a','r','a','t','i','o','n',0,
	'R','e','c','e','i','v','e','r',0,
	'R','e','c','o','r','d','T','y','p','e',0,
	'S','e','t','T','y','p','e',0,
	'S','e','t','s',0,
	'S','i','m','p','l','e','E','x','p','r','e','s','s','i','o','n',0,
	'S','t','a','n','d','P','r','o','c','C','a','l','l',0,
	'S','t','a','t','S','e','q',0,
	'T','D','i','n','i','t',0,
	'T','e','r','m',0,
	'T','y','p','e',0,
	'e','r','r',0,
	'h','a','s','R','e','t','u','r','n',0,
	'l','a','s','t','T','D','i','n','i','t',0,
	'l','e','v','e','l',0,
	'q','u','a','l','i','d','e','n','t',0,
	'r','e','c','L','i','s','t',0,
	's','e','l','e','c','t','o','r',0,
	's','y','m',0,
	'u','s','e','r','L','i','s','t',0,
};
static INTEGER DevCPP__ptrs[] = {
	(INTEGER)&DevCPP_TDinit + 0, 
	(INTEGER)&DevCPP_lastTDinit + 0, 
	(INTEGER)&DevCPP_userList + 0, 
	(INTEGER)&DevCPP_recList + 0, 
};
struct SYSTEM_MODDESC DevCPP__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 11}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	DevCPP__body,
	0,
	4, /* nofimps */ 
	4, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	DevCPP__names,
	DevCPP__ptrs,
	DevCPP__imp,
	(SYSTEM_DIRECTORY*)DevCPP__exp,
	"DevCPP"
};

export void DevCPP__reg()
{
	__BEGREG(DevCPP__desc);
	DevCPM__reg();
	DevCPT__reg();
	DevCPB__reg();
	DevCPS__reg();
	__REGMOD(DevCPP__desc);
	__ENDREG;
}

export void DevCPP__body()
{
	__BEGBODY(DevCPP__desc);
	DevCPM__body();
	DevCPT__body();
	DevCPB__body();
	DevCPS__body();
	__ENDBODY;
}
