/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Math.h"
#include "Strings.h"
#include "DevCPM.h"
#include "Files.h"
#include "DevCPT.h"


export DevCPT_Name DevCPS_name;
export DevCPT_String DevCPS_str;
export struct CHAR_ARRAY *DevCPS_lstr;
export SHORTINT DevCPS_numtyp;
export INTEGER DevCPS_intval;
export REAL DevCPS_realval;
static CHAR DevCPS_ch;

export INTEGER DevCPS__2__desc[];
export SYSTEM_TYPEDESC *DevCPS__2__typ = (SYSTEM_TYPEDESC*)DevCPS__2__desc;

export void DevCPS_Get (BYTE *sym);
static void DevCPS_Identifier (BYTE *sym);
export void DevCPS_Init (void);
static void DevCPS_Number (void);
static void DevCPS_Str (BYTE *sym);
static void DevCPS_err (SHORTINT n);

export void DevCPS__reg();
export void DevCPS__body();
export struct SYSTEM_MODDESC DevCPS__desc;


static void DevCPS_err (SHORTINT n)
{
	__ENTER("DevCPS.err");
	DevCPM_err(n);
	__EXIT;
}

static void DevCPS_Str (BYTE *sym)
{
	INTEGER i;
	CHAR och, lch;
	BOOLEAN long_;
	CHAR s[256];
	struct CHAR_ARRAY *t = NIL;
	__ENTER("DevCPS.Str");
	i = 0;
	och = DevCPS_ch;
	long_ = 0;
	for (;;) {
		DevCPM_Get(&lch);
		if (lch == och) {
			break;
		}
		if (lch < (CHAR)L' ' && lch != 9) {
			DevCPS_err(3);
			break;
		}
		if (lch > 255) {
			long_ = 1;
		}
		if (i < 255) {
			s[__X(i, 256)] = lch;
		} else if (i == 255) {
			s[__X(i, 256)] = 0;
			DevCPS_lstr = __NEWARR(9, 512);
			__STRCOPYLL(s, DevCPS_lstr->data, DevCPS_lstr->len[0]);
			(DevCPS_lstr->data)[__X(i, DevCPS_lstr->len[0])] = lch;
		} else if (i < DevCPS_lstr->len[0] - 1) {
			(DevCPS_lstr->data)[__X(i, DevCPS_lstr->len[0])] = lch;
		} else {
			t = DevCPS_lstr;
			(t->data)[__X(i, t->len[0])] = 0;
			DevCPS_lstr = __NEWARR(9, __ASHL(t->len[0], 1, INTEGER));
			__STRCOPYLL(t->data, DevCPS_lstr->data, DevCPS_lstr->len[0]);
			(DevCPS_lstr->data)[__X(i, DevCPS_lstr->len[0])] = lch;
		}
		i += 1;
	}
	if (i == 1) {
		*sym = 45;
		DevCPS_numtyp = 1;
		DevCPS_intval = (INTEGER)s[0];
	} else {
		*sym = 47;
		DevCPS_numtyp = 0;
		DevCPS_intval = i + 1;
		DevCPS_str = __NEWARR(1, DevCPS_intval);
		if (long_) {
			if (i < 256) {
				s[__X(i, 256)] = 0;
				DevCPS_lstr = __NEWARR(9, DevCPS_intval);
				__STRCOPYLL(s, DevCPS_lstr->data, DevCPS_lstr->len[0]);
			} else {
				(DevCPS_lstr->data)[__X(i, DevCPS_lstr->len[0])] = 0;
			}
			__STRCOPYTS(DevCPS_lstr->data, DevCPS_str->data, DevCPS_str->len[0]);
		} else {
			if (i < 256) {
				s[__X(i, 256)] = 0;
				__STRCOPYTS(s, DevCPS_str->data, DevCPS_str->len[0]);
			} else {
				(DevCPS_lstr->data)[__X(i, DevCPS_lstr->len[0])] = 0;
				__STRCOPYTS(DevCPS_lstr->data, DevCPS_str->data, DevCPS_str->len[0]);
			}
			DevCPS_lstr = NIL;
		}
	}
	DevCPM_Get(&DevCPS_ch);
	__EXIT;
}

static void DevCPS_Identifier (BYTE *sym)
{
	INTEGER i, res;
	CHAR n[256];
	__ENTER("DevCPS.Identifier");
	i = 0;
	do {
		n[__X(i, 256)] = DevCPS_ch;
		i += 1;
		DevCPM_Get(&DevCPS_ch);
	} while (!(!Strings_IsIdent(DevCPS_ch) || i == 256));
	if (i == 256) {
		DevCPS_err(240);
		i -= 1;
	}
	n[__X(i, 256)] = 0;
	Strings_StringToUtf8((void*)n, 256, (void*)DevCPS_name, 256, &res);
	*sym = 48;
	if (res == 1) {
		DevCPS_err(240);
	}
	__EXIT;
}

static struct Number__6 {
	struct Number__6 *lnk;
} *Number__6_s;

static INTEGER __7 (CHAR ch, BOOLEAN hex);

static INTEGER __7 (CHAR ch, BOOLEAN hex)
{
	__ENTER("DevCPS.Ord");
	if (ch <= (CHAR)L'9') {
		__EXIT;
		return (INTEGER)ch - 48;
	} else if (hex) {
		__EXIT;
		return ((INTEGER)ch - 65) + 10;
	} else {
		DevCPS_err(2);
		__EXIT;
		return 0;
	}
	__RETCHK;
}

static void DevCPS_Number (void)
{
	INTEGER i, j, m, n, d, e, a;
	REAL f, g;
	CHAR tch;
	BOOLEAN neg;
	SHORTREAL r;
	CHAR dig[30];
	INTEGER arr[2];
	struct Number__6 _s;
	__ENTER("DevCPS.Number");
	_s.lnk = Number__6_s;
	Number__6_s = &_s;
	i = 0;
	m = 0;
	n = 0;
	d = 0;
	for (;;) {
		if ((CHAR)L'0' <= DevCPS_ch && DevCPS_ch <= (CHAR)L'9' || (d == 0 && (CHAR)L'A' <= DevCPS_ch) && DevCPS_ch \
<= (CHAR)L'F') {
			if (m > 0 || DevCPS_ch != (CHAR)L'0') {
				if (n < 30) {
					dig[__X(n, 30)] = DevCPS_ch;
					n += 1;
				}
				m += 1;
			}
			DevCPM_Get(&DevCPS_ch);
			i += 1;
		} else if (DevCPS_ch == (CHAR)L'.') {
			DevCPM_Get(&DevCPS_ch);
			if (DevCPS_ch == (CHAR)L'.') {
				DevCPS_ch = 127;
				break;
			} else if (d == 0) {
				d = i;
			} else {
				DevCPS_err(2);
			}
		} else {
			break;
		}
	}
	if (d == 0) {
		DevCPS_realval = (REAL)0;
		DevCPS_numtyp = 2;
		if (n == m) {
			DevCPS_intval = 0;
			i = 0;
			if (DevCPS_ch == (CHAR)L'X') {
				DevCPM_Get(&DevCPS_ch);
				DevCPS_numtyp = 1;
				if (n <= 4) {
					while (i < n) {
						DevCPS_intval = __ASHL(DevCPS_intval, 4, INTEGER) + __7(dig[__X(i, 30)], 1);
						i += 1;
					}
				} else {
					DevCPS_err(203);
				}
			} else if (DevCPS_ch == (CHAR)L'H' || DevCPS_ch == (CHAR)L'S') {
				tch = DevCPS_ch;
				DevCPM_Get(&DevCPS_ch);
				if (DevCPS_ch == (CHAR)L'L' && __IN(6, DevCPM_options)) {
					DevCPM_searchpos = DevCPM_curpos - 2;
					DevCPM_Get(&DevCPS_ch);
					if (n <= 16) {
						if (n == 16 && dig[0] > (CHAR)L'7') {
							DevCPS_realval = (REAL)-1;
						}
						while (i < n && i < 10) {
							DevCPS_realval = DevCPS_realval * (REAL)16 + (REAL)__7(dig[__X(i, 30)], 1);
							i += 1;
						}
						while (i < n) {
							DevCPS_realval = DevCPS_realval * (REAL)16;
							DevCPS_intval = __ASHL(DevCPS_intval, 4, INTEGER) + __7(dig[__X(i, 30)], 1);
							i += 1;
						}
						DevCPS_numtyp = 5;
					} else {
						DevCPS_err(203);
					}
				} else if (n <= 8) {
					if (n == 8 && dig[0] > (CHAR)L'7') {
						DevCPS_intval = -1;
					}
					while (i < n) {
						DevCPS_intval = __ASHL(DevCPS_intval, 4, INTEGER) + __7(dig[__X(i, 30)], 1);
						i += 1;
					}
					if (tch == (CHAR)L'S') {
						r = __VAL(SHORTREAL, DevCPS_intval);
						DevCPS_realval = r;
						DevCPS_intval = 0;
						DevCPS_numtyp = 6;
					}
				} else {
					DevCPS_err(203);
				}
			} else if (DevCPS_ch == (CHAR)L'L') {
				DevCPM_searchpos = DevCPM_curpos - 1;
				DevCPM_Get(&DevCPS_ch);
				if (n <= 16) {
					if (n == 16 && dig[0] > (CHAR)L'7') {
						DevCPS_realval = (REAL)-1;
					}
					while (i < n && i < 10) {
						DevCPS_realval = DevCPS_realval * (REAL)16 + (REAL)__7(dig[__X(i, 30)], 1);
						i += 1;
					}
					while (i < n) {
						DevCPS_realval = DevCPS_realval * (REAL)16;
						DevCPS_intval = __ASHL(DevCPS_intval, 4, INTEGER) + __7(dig[__X(i, 30)], 1);
						i += 1;
					}
					DevCPS_numtyp = 5;
				} else {
					DevCPS_err(203);
				}
			} else if (DevCPS_ch == (CHAR)L'R') {
				DevCPM_searchpos = DevCPM_curpos - 1;
				DevCPM_Get(&DevCPS_ch);
				if (n <= 16) {
					a = 0;
					if (n == 16 && dig[0] > (CHAR)L'7') {
						a = -1;
					}
					while (i < n - 8) {
						a = __ASHL(a, 4, INTEGER) + __7(dig[__X(i, 30)], 1);
						i += 1;
					}
					if (DevCPM_LEHost) {
						arr[1] = a;
					} else {
						arr[0] = a;
					}
					a = 0;
					if (n >= 8 && dig[__X(i, 30)] > (CHAR)L'7') {
						a = -1;
					}
					while (i < n) {
						a = __ASHL(a, 4, INTEGER) + __7(dig[__X(i, 30)], 1);
						i += 1;
					}
					if (DevCPM_LEHost) {
						arr[0] = a;
					} else {
						arr[1] = a;
					}
					DevCPS_realval = __VAL(REAL, arr);
					DevCPS_intval = 0;
					DevCPS_numtyp = 7;
				} else {
					DevCPS_err(203);
				}
			} else {
				while (i < n) {
					d = __7(dig[__X(i, 30)], 0);
					i += 1;
					a = __DIV(2147483647 - d, 10);
					if (DevCPS_intval > a) {
						a = __ASHL(__ASHR((DevCPS_intval - a) + 65535, 16, INTEGER), 16, INTEGER);
						DevCPS_realval = DevCPS_realval + (REAL)a;
						DevCPS_intval = DevCPS_intval - a;
					}
					DevCPS_realval = DevCPS_realval * (REAL)10;
					DevCPS_intval = DevCPS_intval * 10 + d;
				}
				if (DevCPS_realval == (REAL)0) {
					DevCPS_numtyp = 2;
				} else if ((REAL)DevCPS_intval < 9.223372036854776E+18 - DevCPS_realval) {
					DevCPS_numtyp = 5;
				} else {
					DevCPS_intval = 0;
					DevCPS_err(203);
				}
			}
		} else {
			DevCPS_err(203);
		}
	} else {
		f = (REAL)0;
		g = (REAL)0;
		e = 0;
		j = 0;
		while (j < 15 && j < n) {
			g = g * (REAL)10 + (REAL)__7(dig[__X(j, 30)], 0);
			j += 1;
		}
		while (n > j) {
			n -= 1;
			f = ((REAL)__7(dig[__X(n, 30)], 0) + f) / (REAL)(REAL)10;
		}
		if (DevCPS_ch == (CHAR)L'E' || DevCPS_ch == (CHAR)L'D' && __IN(6, DevCPM_options)) {
			DevCPM_searchpos = DevCPM_curpos - 1;
			DevCPM_Get(&DevCPS_ch);
			neg = 0;
			if (DevCPS_ch == (CHAR)L'-') {
				neg = 1;
				DevCPM_Get(&DevCPS_ch);
			} else if (DevCPS_ch == (CHAR)L'+') {
				DevCPM_Get(&DevCPS_ch);
			}
			if ((CHAR)L'0' <= DevCPS_ch && DevCPS_ch <= (CHAR)L'9') {
				do {
					n = __7(DevCPS_ch, 0);
					DevCPM_Get(&DevCPS_ch);
					if (e <= __DIV(32767 - n, 10)) {
						e = (SHORTINT)(e * 10 + n);
					} else {
						DevCPS_err(203);
					}
				} while (!(DevCPS_ch < (CHAR)L'0' || (CHAR)L'9' < DevCPS_ch));
				if (neg) {
					e = -e;
				}
			} else {
				DevCPS_err(2);
			}
		}
		e -= (i - d) - m;
		if (e < -324) {
			DevCPS_realval = (REAL)0;
		} else if (e < -294) {
			DevCPS_realval = (((f + g) / Math_IntPower((REAL)10, (j - e) - 30)) / (REAL)1.0E+15) / (REAL)1.0E+15;
		} else if (e < j) {
			DevCPS_realval = (f + g) / Math_IntPower((REAL)10, j - e);
		} else if (e <= 308) {
			DevCPS_realval = (f + g) * Math_IntPower((REAL)10, e - j);
		} else if (e == 309) {
			DevCPS_realval = (f + g) * (Math_IntPower((REAL)10, e - j) / (REAL)(REAL)16);
			if (DevCPS_realval <= DevCPM_MaxReal64 / (REAL)(REAL)16) {
				DevCPS_realval = DevCPS_realval * (REAL)16;
			} else {
				DevCPS_err(203);
			}
		} else {
			DevCPS_err(203);
		}
		DevCPS_numtyp = 4;
	}
	Number__6_s = _s.lnk;
	__EXIT;
}

static struct Get__1 {
	BYTE *s;
	struct Get__1 *lnk;
} *Get__1_s;

static void __2 (void);

static void __2 (void)
{
	__ENTER("DevCPS.Comment");
	DevCPM_Get(&DevCPS_ch);
	for (;;) {
		for (;;) {
			while (DevCPS_ch == (CHAR)L'(') {
				DevCPM_Get(&DevCPS_ch);
				if (DevCPS_ch == (CHAR)L'*') {
					__2();
				}
			}
			if (DevCPS_ch == (CHAR)L'*') {
				DevCPM_Get(&DevCPS_ch);
				break;
			}
			if (DevCPS_ch == 0) {
				break;
			}
			DevCPM_Get(&DevCPS_ch);
		}
		if (DevCPS_ch == (CHAR)L')') {
			DevCPM_Get(&DevCPS_ch);
			break;
		}
		if (DevCPS_ch == 0) {
			DevCPS_err(5);
			break;
		}
	}
	__EXIT;
}

void DevCPS_Get (BYTE *sym)
{
	BYTE s;
	INTEGER old;
	struct Get__1 _s;
	__ENTER("DevCPS.Get");
	_s.s = &s;
	_s.lnk = Get__1_s;
	Get__1_s = &_s;
	DevCPM_errpos = DevCPM_curpos - 1;
	while (DevCPS_ch <= (CHAR)L' ' || DevCPS_ch == 160) {
		if (DevCPS_ch == 0) {
			*sym = 76;
			Get__1_s = _s.lnk;
			__EXIT;
			return;
		} else {
			DevCPM_Get(&DevCPS_ch);
		}
	}
	DevCPM_startpos = DevCPM_curpos - 1;
	switch (DevCPS_ch) {
		case (CHAR)'\"': case (CHAR)'\'': 
			DevCPS_Str(&s);
			break;
		case (CHAR)'#': 
			s = 10;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'&': 
			s = 5;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'(': 
			DevCPM_Get(&DevCPS_ch);
			if (DevCPS_ch == (CHAR)L'*') {
				__2();
				old = DevCPM_errpos;
				DevCPS_Get(&s);
				DevCPM_errpos = old;
			} else {
				s = 40;
			}
			break;
		case (CHAR)')': 
			s = 23;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'*': 
			s = 1;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'+': 
			s = 6;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)',': 
			s = 20;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'-': 
			s = 7;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'.': 
			DevCPM_Get(&DevCPS_ch);
			if (DevCPS_ch == (CHAR)L'.') {
				DevCPM_Get(&DevCPS_ch);
				s = 22;
			} else {
				s = 19;
			}
			break;
		case (CHAR)'/': 
			s = 2;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'0': case (CHAR)'1': case (CHAR)'2': case (CHAR)'3': case (CHAR)'4': 
		case (CHAR)'5': case (CHAR)'6': case (CHAR)'7': case (CHAR)'8': case (CHAR)'9': 
			DevCPS_Number();
			s = 45;
			break;
		case (CHAR)':': 
			DevCPM_Get(&DevCPS_ch);
			if (DevCPS_ch == (CHAR)L'=') {
				DevCPM_Get(&DevCPS_ch);
				s = 44;
			} else {
				s = 21;
			}
			break;
		case (CHAR)';': 
			s = 49;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'<': 
			DevCPM_Get(&DevCPS_ch);
			if (DevCPS_ch == (CHAR)L'=') {
				DevCPM_Get(&DevCPS_ch);
				s = 12;
			} else {
				s = 11;
			}
			break;
		case (CHAR)'=': 
			s = 9;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'>': 
			DevCPM_Get(&DevCPS_ch);
			if (DevCPS_ch == (CHAR)L'=') {
				DevCPM_Get(&DevCPS_ch);
				s = 14;
			} else {
				s = 13;
			}
			break;
		case (CHAR)'A': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "ARRAY") == 0) {
				s = 64;
			}
			break;
		case (CHAR)'B': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "BEGIN") == 0) {
				s = 67;
			} else if (__STRCMPSS(DevCPS_name, "BY") == 0) {
				s = 30;
			}
			break;
		case (CHAR)'C': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "CASE") == 0) {
				s = 56;
			} else if (__STRCMPSS(DevCPS_name, "CONST") == 0) {
				s = 68;
			} else if (__STRCMPSS(DevCPS_name, "CLOSE") == 0) {
				s = 73;
			}
			break;
		case (CHAR)'D': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "DO") == 0) {
				s = 28;
			} else if (__STRCMPSS(DevCPS_name, "DIV") == 0) {
				s = 3;
			}
			break;
		case (CHAR)'E': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "END") == 0) {
				s = 51;
			} else if (__STRCMPSS(DevCPS_name, "ELSE") == 0) {
				s = 52;
			} else if (__STRCMPSS(DevCPS_name, "ELSIF") == 0) {
				s = 53;
			} else if (__STRCMPSS(DevCPS_name, "EXIT") == 0) {
				s = 62;
			}
			break;
		case (CHAR)'F': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "FOR") == 0) {
				s = 59;
			}
			break;
		case (CHAR)'I': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "IF") == 0) {
				s = 55;
			} else if (__STRCMPSS(DevCPS_name, "IN") == 0) {
				s = 15;
			} else if (__STRCMPSS(DevCPS_name, "IS") == 0) {
				s = 16;
			} else if (__STRCMPSS(DevCPS_name, "IMPORT") == 0) {
				s = 74;
			}
			break;
		case (CHAR)'L': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "LOOP") == 0) {
				s = 60;
			}
			break;
		case (CHAR)'M': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "MOD") == 0) {
				s = 4;
			} else if (__STRCMPSS(DevCPS_name, "MODULE") == 0) {
				s = 75;
			}
			break;
		case (CHAR)'N': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "NIL") == 0) {
				s = 46;
			}
			break;
		case (CHAR)'O': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "OR") == 0) {
				s = 8;
			} else if (__STRCMPSS(DevCPS_name, "OF") == 0) {
				s = 26;
			} else if (__STRCMPSS(DevCPS_name, "OUT") == 0) {
				s = 71;
			}
			break;
		case (CHAR)'P': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "PROCEDURE") == 0) {
				s = 72;
			} else if (__STRCMPSS(DevCPS_name, "POINTER") == 0) {
				s = 66;
			}
			break;
		case (CHAR)'R': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "RECORD") == 0) {
				s = 65;
			} else if (__STRCMPSS(DevCPS_name, "REPEAT") == 0) {
				s = 58;
			} else if (__STRCMPSS(DevCPS_name, "RETURN") == 0) {
				s = 63;
			}
			break;
		case (CHAR)'T': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "THEN") == 0) {
				s = 27;
			} else if (__STRCMPSS(DevCPS_name, "TO") == 0) {
				s = 29;
			} else if (__STRCMPSS(DevCPS_name, "TYPE") == 0) {
				s = 69;
			}
			break;
		case (CHAR)'U': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "UNTIL") == 0) {
				s = 54;
			}
			break;
		case (CHAR)'V': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "VAR") == 0) {
				s = 70;
			}
			break;
		case (CHAR)'W': 
			DevCPS_Identifier(&s);
			if (__STRCMPSS(DevCPS_name, "WHILE") == 0) {
				s = 57;
			} else if (__STRCMPSS(DevCPS_name, "WITH") == 0) {
				s = 61;
			}
			break;
		case (CHAR)'G': case (CHAR)'H': case (CHAR)'J': case (CHAR)'K': case (CHAR)'Q': 
		case (CHAR)'S': case (CHAR)'X': case (CHAR)'Y': case (CHAR)'Z': case (CHAR)'_': 
		case (CHAR)'a': case (CHAR)'b': case (CHAR)'c': case (CHAR)'d': case (CHAR)'e': 
		case (CHAR)'f': case (CHAR)'g': case (CHAR)'h': case (CHAR)'i': case (CHAR)'j': 
		case (CHAR)'k': case (CHAR)'l': case (CHAR)'m': case (CHAR)'n': case (CHAR)'o': 
		case (CHAR)'p': case (CHAR)'q': case (CHAR)'r': case (CHAR)'s': case (CHAR)'t': 
		case (CHAR)'u': case (CHAR)'v': case (CHAR)'w': case (CHAR)'x': case (CHAR)'y': 
		case (CHAR)'z': 
			DevCPS_Identifier(&s);
			break;
		case (CHAR)'[': 
			s = 41;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)']': 
			s = 24;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'^': 
			s = 17;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'$': 
			s = 18;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'{': 
			s = 42;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'|': 
			s = 50;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'}': 
			s = 25;
			DevCPM_Get(&DevCPS_ch);
			break;
		case (CHAR)'~': 
			s = 33;
			DevCPM_Get(&DevCPS_ch);
			break;
		case 0x007f: 
			s = 22;
			DevCPM_Get(&DevCPS_ch);
			break;
		default: 
			if (Strings_IsIdent(DevCPS_ch)) {
				DevCPS_Identifier(&s);
			} else {
				s = 0;
				DevCPM_Get(&DevCPS_ch);
			}
			break;
	}
	*sym = s;
	Get__1_s = _s.lnk;
	__EXIT;
}

void DevCPS_Init (void)
{
	__ENTER("DevCPS.Init");
	DevCPS_ch = (CHAR)L' ';
	__EXIT;
}

export INTEGER DevCPS__1__desc[] = {
	0,
	(INTEGER)&DevCPS__desc,
	0<<8 | 0x12,
	3
};
export INTEGER DevCPS__2__desc[] = {
	0,
	(INTEGER)&DevCPS__desc,
	0<<8 | 0x03,
	(INTEGER)DevCPS__1__desc
};
static SYSTEM_MODDESC *DevCPS__imp[] = {
	&DevCPM__desc,
	&DevCPT__desc,
	&Math__desc,
	&Strings__desc,
};
static INTEGER DevCPS__exp[] = {
	13,
	0xf23071f0, (INTEGER)DevCPS_Get, 1<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPS_Identifier, 5<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)DevCPS_Init, 16<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPS_Number, 21<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPS_Str, 28<<8 | 0x14, 0,
	0x4872dac8, (INTEGER)&DevCPS_ch, 32<<8 | 0x13, 3,
	0x227d6f36, (INTEGER)DevCPS_err, 35<<8 | 0x14, 0,
	0x57e82b87, (INTEGER)&DevCPS_intval, 39<<8 | 0x43, 6,
	0x9c0d19b6, (INTEGER)&DevCPS_lstr, 46<<8 | 0x43, (INTEGER)DevCPS__2__desc,
	0x086d492f, (INTEGER)&DevCPS_name, 51<<8 | 0x43, (INTEGER)DevCPT_Name__desc,
	0x5aab0d5e, (INTEGER)&DevCPS_numtyp, 56<<8 | 0x43, 5,
	0x6b668b8d, (INTEGER)&DevCPS_realval, 63<<8 | 0x43, 8,
	0x46066d01, (INTEGER)&DevCPS_str, 71<<8 | 0x43, (INTEGER)DevCPT_String__desc,
};
static char DevCPS__names[] = {
	0,
	'G','e','t',0,
	'I','d','e','n','t','i','f','i','e','r',0,
	'I','n','i','t',0,
	'N','u','m','b','e','r',0,
	'S','t','r',0,
	'c','h',0,
	'e','r','r',0,
	'i','n','t','v','a','l',0,
	'l','s','t','r',0,
	'n','a','m','e',0,
	'n','u','m','t','y','p',0,
	'r','e','a','l','v','a','l',0,
	's','t','r',0,
};
static INTEGER DevCPS__ptrs[] = {
	(INTEGER)&DevCPS_str + 0, 
	(INTEGER)&DevCPS_lstr + 0, 
};
struct SYSTEM_MODDESC DevCPS__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 10}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	DevCPS__body,
	0,
	4, /* nofimps */ 
	2, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	DevCPS__names,
	DevCPS__ptrs,
	DevCPS__imp,
	(SYSTEM_DIRECTORY*)DevCPS__exp,
	"DevCPS"
};

export void DevCPS__reg()
{
	__BEGREG(DevCPS__desc);
	Math__reg();
	Strings__reg();
	DevCPM__reg();
	DevCPT__reg();
	__REGMOD(DevCPS__desc);
	__ENDREG;
}

export void DevCPS__body()
{
	__BEGBODY(DevCPS__desc);
	Math__body();
	Strings__body();
	DevCPM__body();
	DevCPT__body();
	__ENDBODY;
}
