/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "DevCPM.h"
#include "Files.h"
#include "DevCPT.h"
#include "DevCPE.h"
#include "DevCPH.h"
#include "DevCPL486.h"
#include "DevCPC486.h"


static DevCPL486_Label DevCPV486_Exit, DevCPV486_Return;
static BOOLEAN DevCPV486_assert, DevCPV486_sequential;
static INTEGER DevCPV486_nesting, DevCPV486_actual;
static DevCPT_Object DevCPV486_query, DevCPV486_addRef, DevCPV486_release, DevCPV486_release2;


static void DevCPV486_ActualPar (DevCPT_Node n, DevCPT_Object fp, BOOLEAN rec, DevCPL486_Item *tag, SYSTEM_TYPEDESC \
*tag__typ);
static void DevCPV486_AddCopy (DevCPT_Node n, DevCPL486_Item *dest, SYSTEM_TYPEDESC *dest__typ, DevCPL486_Item \
*dadr, SYSTEM_TYPEDESC *dadr__typ, DevCPL486_Item *len, SYSTEM_TYPEDESC *len__typ, BOOLEAN last);
static void DevCPV486_AdrExpr (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, SET hint, SET \
stop);
static void DevCPV486_Align (INTEGER *offset, INTEGER align);
export void DevCPV486_Allocate (void);
static void DevCPV486_Assign (DevCPT_Node n, SET ux);
static INTEGER DevCPV486_Base (DevCPT_Struct typ, INTEGER limit);
static void DevCPV486_Call (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ);
static void DevCPV486_CasePart (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPL486_Label \
*else_, BOOLEAN last);
static void DevCPV486_CaseStat (DevCPT_Node n, DevCPL486_Label *end);
static void DevCPV486_Check (DevCPT_Node n, SET *used, INTEGER *size);
static void DevCPV486_CheckFpu (DevCPT_Node n, BOOLEAN *useFpu);
static void DevCPV486_Checkpc (void);
export void DevCPV486_Close (void);
static void DevCPV486_CompRelease (DevCPT_Node n, DevCPL486_Item *res, SYSTEM_TYPEDESC *res__typ);
static void DevCPV486_CompStat (DevCPT_Node n);
static void DevCPV486_CompareIntTypes (DevCPT_Struct typ, DevCPL486_Item *id, SYSTEM_TYPEDESC *id__typ, \
DevCPL486_Label *exit, INTEGER *num);
static void DevCPV486_CondStat (DevCPT_Node if_, DevCPT_Node last, INTEGER *hint, DevCPL486_Label *else_, \
DevCPL486_Label *end);
static void DevCPV486_CountTProcs (DevCPT_Struct rec);
static BOOLEAN DevCPV486_CountedPtr (DevCPT_Node n);
static void DevCPV486_Dim (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPL486_Item *nofel, \
SYSTEM_TYPEDESC *nofel__typ, INTEGER *fact, DevCPT_Struct dimtyp);
static void DevCPV486_DualExp (DevCPT_Node left, DevCPT_Node right, DevCPL486_Item *x, SYSTEM_TYPEDESC \
*x__typ, DevCPL486_Item *y, SYSTEM_TYPEDESC *y__typ, SET hx, SET hy, SET stpx, SET stpy);
static void DevCPV486_EnumTProcs (DevCPT_Struct rec);
static void DevCPV486_FloatDOp (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ);
static void DevCPV486_GTypeSize (DevCPT_Struct typ, BOOLEAN guarded);
static void DevCPV486_GetComKernel (void);
static void DevCPV486_HandleIPtrs (DevCPT_Struct typ, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPL486_Item \
*y, SYSTEM_TYPEDESC *y__typ, BOOLEAN add, BOOLEAN rel, BOOLEAN init);
static void DevCPV486_IPAssign (DevCPT_Node nx, DevCPT_Node ny, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, \
DevCPL486_Item *y, SYSTEM_TYPEDESC *y__typ, SET ux);
static void DevCPV486_IPFree (DevCPT_Node nx, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ);
static void DevCPV486_IPStructAssign (DevCPT_Struct typ);
static void DevCPV486_IfStat (DevCPT_Node n, BOOLEAN withtrap, DevCPL486_Label *end);
export void DevCPV486_Init (SET opt);
static void DevCPV486_InitializeIPVars (DevCPT_Object proc);
static void DevCPV486_InstallQueryInterface (DevCPT_Struct typ, DevCPT_Object proc);
static void DevCPV486_IntDOp (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, SET hint);
static BOOLEAN DevCPV486_IsAllocDynArr (DevCPT_Node x);
static void DevCPV486_Mem (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPT_Struct typ, \
SET hint, SET stop);
export void DevCPV486_Module (DevCPT_Node prog);
static void DevCPV486_NegAlign (INTEGER *offset, INTEGER align);
static INTEGER DevCPV486_NumOfIntProc (DevCPT_Struct typ);
static void DevCPV486_Objects (DevCPT_Object obj);
static void DevCPV486_Parameters (DevCPT_Object firstPar, DevCPT_Object proc);
static void DevCPV486_Procedure (DevCPT_Object obj);
static void DevCPV486_ReleaseIPVars (DevCPT_Object proc);
static BOOLEAN DevCPV486_SameExp (DevCPT_Node n1, DevCPT_Node n2);
static void DevCPV486_StringCopy (DevCPT_Node left, DevCPT_Node right);
static void DevCPV486_StringOp (DevCPT_Node left, DevCPT_Node right, DevCPL486_Item *x, SYSTEM_TYPEDESC \
*x__typ, DevCPL486_Item *y, SYSTEM_TYPEDESC *y__typ, BOOLEAN useLen);
static void DevCPV486_TProcedures (DevCPT_Object obj);
static void DevCPV486_TypeAlloc (DevCPT_Struct typ);
export void DevCPV486_TypeSize (DevCPT_Struct typ);
static void DevCPV486_Variables (DevCPT_Object var, INTEGER *varSize);
static void DevCPV486_condition (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPL486_Label \
*false, DevCPL486_Label *true);
static void DevCPV486_design (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, SET hint, SET \
stop);
static void DevCPV486_expr (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, SET hint, SET stop);
static void DevCPV486_procs (DevCPT_Node n);
static void DevCPV486_stat (DevCPT_Node n, DevCPL486_Label *end);

export void DevCPV486__reg();
export void DevCPV486__body();
export struct SYSTEM_MODDESC DevCPV486__desc;


void DevCPV486_Init (SET opt)
{
	__ENTER("DevCPV486.Init");
	DevCPL486_Init(opt);
	DevCPC486_Init(opt);
	DevCPV486_assert = __IN(2, opt);
	DevCPM_breakpc = 2147483647;
	DevCPV486_query = NIL;
	DevCPV486_addRef = NIL;
	DevCPV486_release = NIL;
	DevCPV486_release2 = NIL;
	DevCPC486_intHandler = NIL;
	__EXIT;
}

void DevCPV486_Close (void)
{
	__ENTER("DevCPV486.Close");
	DevCPL486_Close();
	__EXIT;
}

static void DevCPV486_Align (INTEGER *offset, INTEGER align)
{
	__ENTER("DevCPV486.Align");
	switch (align) {
		case 1: 
			break;
		case 2: 
			*offset += __MASK(*offset, -2);
			break;
		case 4: 
			*offset += __MASK(-*offset, -4);
			break;
		case 8: 
			*offset += __MASK(-*offset, -8);
			break;
		default: __CASECHK;
	}
	__EXIT;
}

static void DevCPV486_NegAlign (INTEGER *offset, INTEGER align)
{
	__ENTER("DevCPV486.NegAlign");
	switch (align) {
		case 1: 
			break;
		case 2: 
			*offset -= __MASK(*offset, -2);
			break;
		case 4: 
			*offset -= __MASK(*offset, -4);
			break;
		case 8: 
			*offset -= __MASK(*offset, -8);
			break;
		default: __CASECHK;
	}
	__EXIT;
}

static INTEGER DevCPV486_Base (DevCPT_Struct typ, INTEGER limit)
{
	INTEGER align;
	__ENTER("DevCPV486.Base");
	while ((INTEGER)typ->comp == 2) {
		typ = typ->BaseTyp;
	}
	if ((INTEGER)typ->comp == 4) {
		align = typ->align;
	} else {
		align = typ->size;
	}
	if (align > limit) {
		__EXIT;
		return limit;
	} else {
		__EXIT;
		return align;
	}
	__RETCHK;
}

static void DevCPV486_GTypeSize (DevCPT_Struct typ, BOOLEAN guarded)
{
	BYTE f, c;
	INTEGER offset, align, falign, alignLimit;
	DevCPT_Object fld = NIL;
	DevCPT_Struct btyp = NIL;
	__ENTER("DevCPV486.GTypeSize");
	if (typ->untagged) {
		guarded = 1;
	}
	if (typ == DevCPT_undftyp) {
		DevCPM_err(58);
	} else if (typ->size == -1) {
		f = typ->form;
		c = typ->comp;
		btyp = typ->BaseTyp;
		if ((INTEGER)c == 4) {
			if (btyp == NIL) {
				offset = 0;
				align = 1;
			} else {
				DevCPV486_GTypeSize(btyp, guarded);
				offset = btyp->size;
				align = btyp->align;
			}
			if ((INTEGER)typ->sysflag == 3) {
				alignLimit = 1;
			} else if ((INTEGER)typ->sysflag == 4) {
				alignLimit = 2;
			} else if ((INTEGER)typ->sysflag == 6) {
				alignLimit = 8;
			} else {
				alignLimit = 4;
			}
			fld = typ->link;
			while (fld != NIL && (INTEGER)fld->mode == 4) {
				btyp = fld->typ;
				DevCPV486_GTypeSize(btyp, guarded);
				if ((INTEGER)typ->sysflag > 0) {
					falign = DevCPV486_Base(btyp, alignLimit);
				} else if (btyp->size >= 4) {
					falign = 4;
				} else if (btyp->size >= 2) {
					falign = 2;
				} else {
					falign = 1;
				}
				if ((INTEGER)typ->sysflag == 7) {
					fld->adr = 0;
					if (btyp->size > offset) {
						offset = btyp->size;
					}
				} else {
					DevCPV486_Align(&offset, falign);
					fld->adr = offset;
					if (offset <= 2147483643 - btyp->size) {
						offset += btyp->size;
					} else {
						offset = 4;
						DevCPM_Mark(214, typ->txtpos);
					}
				}
				if (falign > align) {
					align = falign;
				}
				fld = fld->link;
			}
			if ((INTEGER)typ->sysflag <= 0) {
				align = 4;
			}
			typ->align = align;
			if ((INTEGER)typ->sysflag > 0 || offset > 2) {
				DevCPV486_Align(&offset, align);
			}
			typ->size = offset;
			typ->n = -1;
		} else if ((INTEGER)c == 2) {
			DevCPV486_GTypeSize(btyp, guarded);
			if (btyp->size == 0 || typ->n <= __DIVF(2147483647, btyp->size)) {
				typ->size = typ->n * btyp->size;
			} else {
				typ->size = 4;
				DevCPM_Mark(214, typ->txtpos);
			}
		} else if ((INTEGER)f == 13) {
			typ->size = 4;
			if (guarded && !typ->untagged) {
				DevCPM_Mark(143, typ->txtpos);
			}
		} else if ((INTEGER)f == 14) {
			typ->size = 4;
		} else {
			DevCPV486_GTypeSize(btyp, guarded);
			if ((INTEGER)typ->sysflag == 1 || typ->untagged) {
				typ->size = 4;
			} else {
				if ((INTEGER)btyp->comp == 3) {
					typ->size = btyp->size + 4;
				} else {
					typ->size = 8;
				}
			}
		}
	}
	__EXIT;
}

void DevCPV486_TypeSize (DevCPT_Struct typ)
{
	__ENTER("DevCPV486.TypeSize");
	DevCPV486_GTypeSize(typ, 0);
	__EXIT;
}

static void DevCPV486_GetComKernel (void)
{
	SHORTCHAR _str__34[256];
	SHORTCHAR _str__33[256];
	SHORTCHAR _str__32[256];
	SHORTCHAR _str__31[256];
	__ENTER("DevCPV486.GetComKernel");
	if (DevCPV486_addRef == NIL) {
		DevCPT_OpenScope((BYTE)(-((INTEGER)DevCPT_nofGmod)), NIL);
		DevCPT_topScope->name = DevCPT_NewName((void*)"$$", 3);
		__MOVE("AddRef", _str__34, 7);
		DevCPT_Insert((void*)_str__34, &DevCPV486_addRef);
		DevCPV486_addRef->mode = 7;
		DevCPV486_addRef->fprint = 1311221831;
		DevCPV486_addRef->fpdone = 1;
		__MOVE("Release", _str__33, 8);
		DevCPT_Insert((void*)_str__33, &DevCPV486_release);
		DevCPV486_release->mode = 7;
		DevCPV486_release->fprint = 1311221831;
		DevCPV486_release->fpdone = 1;
		__MOVE("Release2", _str__32, 9);
		DevCPT_Insert((void*)_str__32, &DevCPV486_release2);
		DevCPV486_release2->mode = 7;
		DevCPV486_release2->fprint = 1311221831;
		DevCPV486_release2->fpdone = 1;
		__MOVE("InterfaceTrapHandler", _str__31, 21);
		DevCPT_Insert((void*)_str__31, &DevCPC486_intHandler);
		DevCPC486_intHandler->mode = 7;
		DevCPC486_intHandler->fprint = 615574243;
		DevCPC486_intHandler->fpdone = 1;
		DevCPT_GlbMod[__X(DevCPT_nofGmod, 127)] = DevCPT_topScope;
		DevCPT_nofGmod += 1;
		DevCPT_CloseScope();
	}
	__EXIT;
}

static void DevCPV486_EnumTProcs (DevCPT_Struct rec)
{
	DevCPT_Struct btyp = NIL;
	DevCPT_Object obj = NIL;
	DevCPT_Object redef = NIL;
	DevCPT_String _ptr__27 = NIL;
	__ENTER("DevCPV486.EnumTProcs");
	if (rec->n == -1) {
		rec->n = 0;
		btyp = rec->BaseTyp;
		if (btyp != NIL) {
			DevCPV486_EnumTProcs(btyp);
			rec->n = btyp->n;
		}
		obj = rec->strobj->link;
		while (obj != NIL) {
			_ptr__27 = obj->name;
			DevCPT_FindBaseField((void*)_ptr__27->data, _ptr__27->len[0], rec, &redef);
			if (redef != NIL) {
				obj->num = redef->num;
				if (!__IN(2, obj->conval->setval) || (redef->conval->setval & 0x1a0000) == 0x0) {
					DevCPM_Mark(119, rec->txtpos);
				}
			} else {
				obj->num = rec->n;
				rec->n += 1;
			}
			if ((obj->conval->setval & 0x0a0002) == 0x0) {
				DevCPM_Mark(129, obj->adr);
			}
			obj = obj->nlink;
		}
	}
	__EXIT;
}

static struct CountTProcs__19 {
	DevCPT_Struct *rec;
	INTEGER *comProc;
	DevCPT_Object *m, *rel;
	DevCPT_Name *name;
	struct CountTProcs__19 *lnk;
} *CountTProcs__19_s;

static void __20 (DevCPT_Object obj);

static void __20 (DevCPT_Object obj)
{
	DevCPT_Object redef = NIL;
	DevCPT_String _ptr__22 = NIL;
	__ENTER("DevCPV486.TProcs");
	if (obj != NIL) {
		__20(obj->left);
		if ((INTEGER)obj->mode == 13) {
			_ptr__22 = obj->name;
			DevCPT_FindBaseField((void*)_ptr__22->data, _ptr__22->len[0], (*CountTProcs__19_s->rec), &redef);
			if (redef != NIL) {
				obj->num = redef->num;
				if (redef->link != NIL && (INTEGER)redef->link->typ->sysflag == 10) {
					obj->num = ((2 + (*CountTProcs__19_s->comProc)) - 1) - obj->num;
				}
				if (!__IN(2, obj->conval->setval) || (redef->conval->setval & 0x1a0000) == 0x0) {
					DevCPM_Mark(119, ((*CountTProcs__19_s->rec))->txtpos);
				}
			} else {
				obj->num = ((*CountTProcs__19_s->rec))->n;
				((*CountTProcs__19_s->rec))->n += 1;
			}
			if ((obj->conval->setval & 0x0a0002) == 0x0) {
				DevCPM_Mark(129, obj->adr);
			}
		}
		__20(obj->right);
	}
	__EXIT;
}

static void DevCPV486_CountTProcs (DevCPT_Struct rec)
{
	DevCPT_Struct btyp = NIL;
	INTEGER comProc;
	DevCPT_Object m = NIL;
	DevCPT_Object rel = NIL;
	DevCPT_Name name;
	struct CountTProcs__19 _s;
	__ENTER("DevCPV486.CountTProcs");
	_s.rec = &rec;
	_s.comProc = &comProc;
	_s.m = &m;
	_s.rel = &rel;
	_s.name = (void*)name;
	_s.lnk = CountTProcs__19_s;
	CountTProcs__19_s = &_s;
	if (rec->n == -1) {
		comProc = 0;
		if (rec->untagged) {
			rec->n = 0;
		} else {
			rec->n = DevCPT_anytyp->n;
		}
		btyp = rec->BaseTyp;
		if (btyp != NIL) {
			if ((INTEGER)btyp->sysflag == 10) {
				DevCPV486_EnumTProcs(btyp);
				rec->n = btyp->n + 2;
				comProc = btyp->n;
			} else {
				DevCPV486_CountTProcs(btyp);
				rec->n = btyp->n;
			}
		}
		while ((btyp != NIL && btyp != DevCPT_undftyp) && (INTEGER)btyp->sysflag != 10) {
			btyp = btyp->BaseTyp;
		}
		if (btyp != NIL && (INTEGER)btyp->sysflag == 10) {
			if (comProc > 0) {
				__MOVE("QueryInterface", name, 15);
				DevCPT_FindField((void*)name, 256, rec, &m);
				if ((INTEGER)m->link->typ->sysflag == 10) {
					DevCPT_InsertField(name, rec, &m);
					m->mode = 13;
					m->typ = rec;
					m->conval = DevCPT_NewConst();
					m->conval->setval = 0x80100006;
					m->nlink = DevCPV486_query;
					DevCPV486_query = m;
				}
				__MOVE("AddRef", name, 7);
				DevCPT_InsertField(name, rec, &m);
				m->mode = 13;
				m->mnolev = 0;
				m->conval = DevCPT_NewConst();
				m->conval->setval = 0xa0100006;
				DevCPV486_GetComKernel();
				DevCPV486_addRef->used = 1;
				m->adr = -1;
				m->nlink = DevCPV486_addRef;
			}
			__MOVE("RELEASE", name, 8);
			DevCPT_FindField((void*)name, 256, rec, &rel);
			if (rel != NIL && rel->link->typ == DevCPT_anyptrtyp) {
				rel = NIL;
			}
			if (comProc > 0 || rel != NIL) {
				__MOVE("Release", name, 8);
				DevCPT_InsertField(name, rec, &m);
				m->mode = 13;
				m->mnolev = 0;
				m->conval = DevCPT_NewConst();
				m->conval->setval = 0xa0100006;
				DevCPV486_GetComKernel();
				m->adr = -1;
				if (rel != NIL) {
					DevCPV486_release2->used = 1;
					m->nlink = DevCPV486_release2;
				} else {
					DevCPV486_release->used = 1;
					m->nlink = DevCPV486_release;
				}
			}
		}
		__20(rec->link);
	}
	CountTProcs__19_s = _s.lnk;
	__EXIT;
}

static void DevCPV486_TypeAlloc (DevCPT_Struct typ)
{
	SHORTINT f, c;
	DevCPT_Object fld = NIL;
	DevCPT_Struct btyp = NIL;
	__ENTER("DevCPV486.TypeAlloc");
	if (!typ->allocated) {
		typ->allocated = 1;
		DevCPV486_TypeSize(typ);
		f = typ->form;
		c = typ->comp;
		btyp = typ->BaseTyp;
		if ((INTEGER)c == 4) {
			if ((INTEGER)typ->sysflag == 10) {
				DevCPV486_EnumTProcs(typ);
			} else {
				DevCPV486_CountTProcs(typ);
			}
			if ((INTEGER)typ->extlev > 14) {
				DevCPM_Mark(233, typ->txtpos);
			}
			if (btyp != NIL) {
				DevCPV486_TypeAlloc(btyp);
			}
			if (!typ->untagged) {
				DevCPE_AllocTypDesc(typ);
			}
			fld = typ->link;
			while (fld != NIL && (INTEGER)fld->mode == 4) {
				DevCPV486_TypeAlloc(fld->typ);
				fld = fld->link;
			}
			DevCPV486_TProcedures(typ->link);
		} else if ((INTEGER)f == 13) {
			if (btyp == DevCPT_undftyp) {
				DevCPM_Mark(128, typ->txtpos);
			} else {
				DevCPV486_TypeAlloc(btyp);
			}
		} else if ((INTEGER)f == 14) {
			DevCPV486_TypeAlloc(btyp);
			DevCPV486_Parameters(typ->link, NIL);
		} else {
			DevCPV486_TypeAlloc(btyp);
			if (((INTEGER)btyp->comp == 3 && btyp->untagged) && !typ->untagged) {
				DevCPM_Mark(225, typ->txtpos);
			}
		}
	}
	__EXIT;
}

static INTEGER DevCPV486_NumOfIntProc (DevCPT_Struct typ)
{
	__ENTER("DevCPV486.NumOfIntProc");
	while (typ != NIL && (INTEGER)typ->sysflag != 10) {
		typ = typ->BaseTyp;
	}
	if (typ != NIL) {
		__EXIT;
		return typ->n;
	} else {
		__EXIT;
		return 0;
	}
	__RETCHK;
}

static void DevCPV486_Parameters (DevCPT_Object firstPar, DevCPT_Object proc)
{
	DevCPT_Object par = NIL;
	DevCPT_Struct typ = NIL;
	INTEGER padr, vadr;
	__ENTER("DevCPV486.Parameters");
	padr = 8;
	par = firstPar;
	while (par != NIL) {
		typ = par->typ;
		DevCPV486_TypeAlloc(typ);
		par->adr = padr;
		if ((INTEGER)par->mode == 2 && (INTEGER)typ->comp != 3) {
			if ((INTEGER)typ->comp == 4 && !typ->untagged) {
				padr += 8;
			} else {
				padr += 4;
			}
		} else {
			if (((INTEGER)par->mode == 1 && (INTEGER)typ->comp == 3) && typ->untagged) {
				DevCPM_err(145);
			}
			padr += typ->size;
			DevCPV486_Align(&padr, 4);
		}
		par = par->link;
	}
	if (proc != NIL) {
		if ((INTEGER)proc->mode == 7) {
			proc->conval->setval |= __SETOF(31);
		} else if (((INTEGER)proc->mode == 13 && proc->num >= 2) && proc->num < 2 + DevCPV486_NumOfIntProc(proc->link->typ)) \
{
			proc->conval->setval |= __SETOF(31);
			proc->conval->setval |= __SETOF(30);
		}
		if ((INTEGER)proc->sysflag == 8) {
			proc->conval->setval |= __SETOF(30);
		}
		if (__IN(30, proc->conval->setval)) {
			DevCPV486_GetComKernel();
			vadr = -24;
		} else {
			vadr = 0;
			if (__IN(4, proc->conval->setval)) {
				vadr -= 4;
			}
			if (__IN(31, proc->conval->setval)) {
				vadr -= 8;
			}
		}
		proc->conval->intval = padr;
		proc->conval->intval2 = vadr;
	}
	__EXIT;
}

static void DevCPV486_Variables (DevCPT_Object var, INTEGER *varSize)
{
	INTEGER adr;
	DevCPT_Struct typ = NIL;
	__ENTER("DevCPV486.Variables");
	adr = *varSize;
	while (var != NIL) {
		typ = var->typ;
		DevCPV486_TypeAlloc(typ);
		adr -= typ->size;
		DevCPV486_NegAlign(&adr, DevCPV486_Base(typ, 4));
		var->adr = adr;
		var = var->link;
	}
	DevCPV486_NegAlign(&adr, 4);
	*varSize = adr;
	__EXIT;
}

static void DevCPV486_Procedure (DevCPT_Object obj)
{
	INTEGER oldPos;
	DevCPT_Const _ptr__54 = NIL;
	__ENTER("DevCPV486.Procedure");
	oldPos = DevCPM_errpos;
	DevCPM_errpos = obj->scope->adr;
	DevCPV486_TypeAlloc(obj->typ);
	DevCPV486_Parameters(obj->link, obj);
	if (!__IN(1, obj->conval->setval)) {
		DevCPM_Mark(129, obj->adr);
	}
	_ptr__54 = obj->conval;
	DevCPV486_Variables(obj->scope->scope, &_ptr__54->intval2);
	DevCPV486_Objects(obj->scope->right);
	DevCPM_errpos = oldPos;
	__EXIT;
}

static void DevCPV486_TProcedures (DevCPT_Object obj)
{
	DevCPT_Const _ptr__60 = NIL;
	__ENTER("DevCPV486.TProcedures");
	if (obj != NIL) {
		DevCPV486_TProcedures(obj->left);
		if ((INTEGER)obj->mode == 13 && obj->scope != NIL) {
			DevCPV486_TypeAlloc(obj->typ);
			DevCPV486_Parameters(obj->link, obj);
			_ptr__60 = obj->conval;
			DevCPV486_Variables(obj->scope->scope, &_ptr__60->intval2);
			DevCPV486_Objects(obj->scope->right);
		}
		DevCPV486_TProcedures(obj->right);
	}
	__EXIT;
}

static void DevCPV486_Objects (DevCPT_Object obj)
{
	__ENTER("DevCPV486.Objects");
	if (obj != NIL) {
		DevCPV486_Objects(obj->left);
		if (__IN(obj->mode, 0x06e8)) {
			if (__IN(obj->mode, 0x28)) {
				DevCPV486_TypeAlloc(obj->typ);
			} else {
				DevCPV486_Procedure(obj);
			}
		}
		DevCPV486_Objects(obj->right);
	}
	__EXIT;
}

void DevCPV486_Allocate (void)
{
	INTEGER gvarSize;
	__ENTER("DevCPV486.Allocate");
	DevCPM_errpos = DevCPT_topScope->adr;
	gvarSize = 0;
	DevCPV486_Variables(DevCPT_topScope->scope, &gvarSize);
	DevCPE_dsize = -gvarSize;
	DevCPV486_Objects(DevCPT_topScope->right);
	__EXIT;
}

static BOOLEAN DevCPV486_SameExp (DevCPT_Node n1, DevCPT_Node n2)
{
	__ENTER("DevCPV486.SameExp");
	while ((INTEGER)n1->class == (INTEGER)n2->class && n1->typ == n2->typ) {
		switch (n1->class) {
			case 0: case 1: case 9: 
				__EXIT;
				return n1->obj == n2->obj;
				break;
			case 7: 
				__EXIT;
				return __IN(n1->typ->form, 0x70) && n1->conval->intval == n2->conval->intval;
				break;
			case 2: 
				if (n1->obj != n2->obj) {
					__EXIT;
					return 0;
				}
				break;
			case 3: case 5: 
				break;
			case 4: 
				if (!DevCPV486_SameExp(n1->right, n2->right)) {
					__EXIT;
					return 0;
				}
				break;
			case 11: 
				if ((INTEGER)n1->subcl != (INTEGER)n2->subcl || (INTEGER)n1->subcl == 16) {
					__EXIT;
					return 0;
				}
				break;
			case 12: 
				if ((INTEGER)n1->subcl != (INTEGER)n2->subcl || !DevCPV486_SameExp(n1->right, n2->right)) {
					__EXIT;
					return 0;
				}
				break;
			default: 
				__EXIT;
				return 0;
				break;
		}
		n1 = n1->left;
		n2 = n2->left;
	}
	__EXIT;
	return 0;
}

static void DevCPV486_Check (DevCPT_Node n, SET *used, INTEGER *size)
{
	SET ux, uy;
	INTEGER sx, sy, sf;
	BYTE f;
	__ENTER("DevCPV486.Check");
	*used = 0x0;
	*size = 0;
	while (n != NIL) {
		if ((INTEGER)n->class != 30) {
			DevCPV486_Check(n->left, &ux, &sx);
			DevCPV486_Check(n->right, &uy, &sy);
		}
		ux = ux | uy;
		sf = 0;
		switch (n->class) {
			case 0: case 1: 
				if (((INTEGER)n->class == 1 || (INTEGER)n->typ->comp == 3) || (INTEGER)n->obj->mnolev > 0 && (INTEGER)DevCPC486_imLevel[__X(n->obj->mnolev, \
64)] < (INTEGER)DevCPC486_imLevel[__X(DevCPL486_level, 64)]) {
					sf = 1;
				}
				break;
			case 5: 
				sf = 2;
				break;
			case 3: case 6: 
				sf = 1;
				break;
			case 4: 
				if ((INTEGER)n->right->class != 7 || (INTEGER)n->left->typ->comp == 3) {
					sf = 1;
				}
				if (sx > 0) {
					sy += 1;
				}
				break;
			case 11: 
				switch (n->subcl) {
					case 7: case 16: case 21: case 22: case 24: 
					case 29: case 36: 
						sf = 1;
						break;
					case 26: 
						sf = 2;
						ux |= __SETOF(1);
						break;
					case 20: 
						if ((INTEGER)n->typ->form == 18) {
							sf = 2;
						} else if (!__IN(n->typ->form, 0x0180)) {
							sf = 1;
							if (__IN(n->left->typ->form, 0x0180)) {
								ux |= __SETOF(0);
							}
						}
						break;
					case 23: case 25: case 33: 
						break;
					default: __CASECHK;
				}
				break;
			case 12: 
				f = n->left->typ->form;
				if ((INTEGER)f != 2) {
					switch (n->subcl) {
						case 1: 
							sf = 1;
							if ((INTEGER)f == 4) {
								ux |= __SETOF(0);
							}
							break;
						case 3: case 4: 
							sf = 3;
							ux |= __SETOF(0);
							if ((INTEGER)f > 4) {
								ux |= __SETOF(2);
							}
							break;
						case 9: case 10: case 11: case 12: case 13: 
						case 14: 
							if (__IN(f, 0x028400)) {
								ux = ux | 0xc3;
								sf = 4;
							} else if (__IN(f, 0x0180)) {
								ux |= __SETOF(0);
								sf = 1;
							} else {
								sf = 1;
							}
							break;
						case 17: case 27: case 28: 
							if ((INTEGER)n->right->class == 7) {
								sf = 1;
							} else {
								sf = 2;
								ux |= __SETOF(1);
							}
							break;
						case 2: case 6: case 7: case 15: case 18: 
						case 26: 
							sf = 1;
							break;
						case 19: 
							if (__IN(f, 0x020400)) {
								ux = ux | 0x83;
								sf = 3;
							} else {
								sf = 1;
							}
							break;
						case 34: case 35: 
							sf = 1;
							if (__IN(f, 0x0180)) {
								ux |= __SETOF(0);
							}
							break;
						case 42: 
							ux = ux | 0xc2;
							sf = 4;
							break;
						default: __CASECHK;
					}
					if (sy > sx) {
						sx += 1;
					} else {
						sy += 1;
					}
				}
				break;
			case 10: 
				if ((INTEGER)n->right->class == 7 || (INTEGER)n->left->class == 7) {
					sf = 2;
				} else {
					sf = 3;
				}
				ux |= __SETOF(1);
				sx += 1;
				break;
			case 13: case 30: 
				sf = 10;
				ux = 0x100000cf;
				break;
			case 2: case 7: case 8: case 9: 
				break;
			default: __CASECHK;
		}
		*used = *used | ux;
		if (sx > *size) {
			*size = sx;
		}
		if (sy > *size) {
			*size = sy;
		}
		if (sf > *size) {
			*size = sf;
		}
		n = n->link;
	}
	if (*size > 10) {
		*size = 10;
	}
	__EXIT;
}

static void DevCPV486_DualExp (DevCPT_Node left, DevCPT_Node right, DevCPL486_Item *x, SYSTEM_TYPEDESC \
*x__typ, DevCPL486_Item *y, SYSTEM_TYPEDESC *y__typ, SET hx, SET hy, SET stpx, SET stpy)
{
	SET ux, uy;
	INTEGER sx, sy;
	__ENTER("DevCPV486.DualExp");
	DevCPV486_Check(left, &ux, &sx);
	DevCPV486_Check(right, &uy, &sy);
	if (sy > sx) {
		DevCPV486_expr(right, y, y__typ, hy | stpy, ux | stpy & 0x03);
		DevCPV486_expr(left, x, x__typ, hx, stpx);
		DevCPC486_Assert(y, y__typ, hy, stpy);
	} else {
		DevCPV486_expr(left, x, x__typ, hx | stpx, uy);
		DevCPV486_expr(right, y, y__typ, hy, stpy);
		DevCPC486_Assert(x, x__typ, hx, stpx);
	}
	__EXIT;
}

static void DevCPV486_IntDOp (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, SET hint)
{
	DevCPL486_Item y = {0};
	__ENTER("DevCPV486.IntDOp");
	DevCPV486_DualExp(n->left, n->right, x, x__typ, &y, DevCPL486_Item__typ, hint, hint, 0x80000000, 0x80000000);
	if ((INTEGER)(*x).mode == 18 && DevCPC486_Fits(x, x__typ, hint)) {
		DevCPC486_IntDOp(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 0);
	} else if ((INTEGER)y.mode == 18 && DevCPC486_Fits(&y, DevCPL486_Item__typ, hint)) {
		DevCPC486_IntDOp(&y, DevCPL486_Item__typ, x, x__typ, n->subcl, 1);
		*x = y;
	} else if ((INTEGER)(*x).mode != 18) {
		DevCPC486_Load(x, x__typ, hint, 0x20000000);
		DevCPC486_IntDOp(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 0);
	} else if ((INTEGER)y.mode != 18) {
		DevCPC486_Load(&y, DevCPL486_Item__typ, hint, 0x20000000);
		DevCPC486_IntDOp(&y, DevCPL486_Item__typ, x, x__typ, n->subcl, 1);
		*x = y;
	} else {
		DevCPC486_IntDOp(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 0);
	}
	__EXIT;
}

static void DevCPV486_FloatDOp (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ)
{
	DevCPL486_Item y = {0};
	SET ux, uy, uf;
	INTEGER sx, sy;
	__ENTER("DevCPV486.FloatDOp");
	DevCPV486_Check(n->left, &ux, &sx);
	DevCPV486_Check(n->right, &uy, &sy);
	if ((INTEGER)n->subcl == 34 || (INTEGER)n->subcl == 35) {
		uf = 0x01;
	} else {
		uf = 0x0;
	}
	if (sy > sx || sy == sx && ((INTEGER)n->subcl == 4 || (INTEGER)n->subcl == 17)) {
		DevCPV486_expr(n->right, x, x__typ, 0x0, ux | 0xc0000000);
		DevCPV486_expr(n->left, &y, DevCPL486_Item__typ, 0x0, uf);
		DevCPC486_FloatDOp(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 1);
	} else if (__IN(28, uy)) {
		DevCPV486_expr(n->left, &y, DevCPL486_Item__typ, 0x0, uy | 0x40000000);
		DevCPV486_expr(n->right, x, x__typ, 0x0, 0xc0000000);
		DevCPC486_FloatDOp(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 1);
	} else {
		DevCPV486_expr(n->left, x, x__typ, 0x0, uy | 0xc0000000);
		DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, uf);
		DevCPC486_FloatDOp(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 0);
	}
	__EXIT;
}

static void DevCPV486_design (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, SET hint, SET \
stop)
{
	DevCPT_Object obj = NIL;
	DevCPL486_Item y = {0};
	SET ux, uy;
	INTEGER sx, sy;
	__ENTER("DevCPV486.design");
	switch (n->class) {
		case 0: case 1: 
			obj = n->obj;
			(*x).mode = obj->mode;
			(*x).obj = obj;
			(*x).scale = 0;
			if ((INTEGER)obj->typ->comp == 3) {
				(*x).mode = 2;
			}
			if ((INTEGER)obj->mnolev < 0) {
				(*x).offset = 0;
				(*x).tmode = 3;
			} else if ((INTEGER)(*x).mode == 1) {
				(*x).offset = obj->adr;
				(*x).tmode = 3;
			} else {
				(*x).offset = 0;
				(*x).tmode = 2;
			}
			break;
		case 2: 
			DevCPV486_design(n->left, x, x__typ, hint, stop);
			DevCPC486_Field(x, x__typ, n->obj);
			break;
		case 3: 
			if ((INTEGER)n->subcl != 0) {
				DevCPV486_expr(n->left, x, x__typ, hint, stop);
				if ((INTEGER)n->typ->form == 10) {
					(*x).form = 30;
				} else {
					(*x).form = 31;
				}
			} else {
				DevCPV486_expr(n->left, x, x__typ, hint, (stop | 0x40000000) & ~0x01000000);
				DevCPC486_DeRef(x, x__typ);
			}
			break;
		case 4: 
			DevCPV486_Check(n->left, &ux, &sx);
			DevCPV486_Check(n->right, &uy, &sy);
			if ((0xcf & ~uy) == 0x0) {
				DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, hint | stop, ux);
				DevCPV486_design(n->left, x, x__typ, hint, stop);
				if ((*x).scale != 0) {
					DevCPC486_Index(x, x__typ, &y, DevCPL486_Item__typ, 0x0, 0x0);
				} else {
					DevCPC486_Index(x, x__typ, &y, DevCPL486_Item__typ, hint, stop);
				}
			} else {
				DevCPV486_design(n->left, x, x__typ, hint, stop | uy);
				if ((*x).scale != 0) {
					DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0x0);
					DevCPC486_Index(x, x__typ, &y, DevCPL486_Item__typ, 0x0, 0x0);
				} else {
					DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, hint, stop);
					DevCPC486_Index(x, x__typ, &y, DevCPL486_Item__typ, hint, stop);
				}
			}
			break;
		case 5: case 6: 
			if ((INTEGER)n->typ->form == 13) {
				if (__IN(24, stop)) {
					DevCPV486_expr(n->left, x, x__typ, hint, stop);
				} else {
					DevCPV486_expr(n->left, x, x__typ, hint, stop | 0x40000000);
				}
			} else {
				DevCPV486_design(n->left, x, x__typ, hint, stop);
			}
			DevCPC486_TypTest(x, x__typ, n->typ, 1, (INTEGER)n->class == 6);
			break;
		case 9: 
			obj = n->obj;
			(*x).mode = obj->mode;
			(*x).obj = obj;
			if ((INTEGER)(*x).mode == 13) {
				(*x).offset = obj->num;
				(*x).scale = n->subcl;
			}
			break;
		default: __CASECHK;
	}
	(*x).typ = n->typ;
	__EXIT;
}

static BOOLEAN DevCPV486_IsAllocDynArr (DevCPT_Node x)
{
	__ENTER("DevCPV486.IsAllocDynArr");
	if ((INTEGER)x->typ->comp == 3 && !x->typ->untagged) {
		while ((INTEGER)x->class == 4) {
			x = x->left;
		}
		if ((INTEGER)x->class == 3) {
			__EXIT;
			return 1;
		}
	}
	__EXIT;
	return 0;
}

static void DevCPV486_StringOp (DevCPT_Node left, DevCPT_Node right, DevCPL486_Item *x, SYSTEM_TYPEDESC \
*x__typ, DevCPL486_Item *y, SYSTEM_TYPEDESC *y__typ, BOOLEAN useLen)
{
	DevCPL486_Item ax = {0}, ay = {0};
	SET ux;
	INTEGER sx;
	__ENTER("DevCPV486.StringOp");
	DevCPV486_Check(left, &ux, &sx);
	DevCPV486_expr(right, y, y__typ, 0x8f | ux, 0x0);
	ay = *y;
	DevCPC486_GetAdr(&ay, DevCPL486_Item__typ, 0x8f | ux, 0x0);
	DevCPC486_Assert(&ay, DevCPL486_Item__typ, 0x8f, ux);
	if (useLen && DevCPV486_IsAllocDynArr(left)) {
		DevCPV486_design(left, x, x__typ, 0xcd, 0x01000000);
		DevCPC486_Prepare(x, x__typ, 0x020000cd, 0x80);
	} else {
		DevCPV486_expr(left, x, x__typ, 0x4f, 0x0);
	}
	ax = *x;
	DevCPC486_GetAdr(&ax, DevCPL486_Item__typ, 0x0, 0xa000004f);
	DevCPC486_Load(&ay, DevCPL486_Item__typ, 0x0, 0x2000008f);
	DevCPC486_Free(&ax, DevCPL486_Item__typ);
	DevCPC486_Free(&ay, DevCPL486_Item__typ);
	__EXIT;
}

static void DevCPV486_AdrExpr (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, SET hint, SET \
stop)
{
	__ENTER("DevCPV486.AdrExpr");
	if ((INTEGER)n->class < 7) {
		DevCPV486_design(n, x, x__typ, hint | stop, 0x01000000);
		DevCPC486_Prepare(x, x__typ, hint | 0x02000000, stop);
	} else {
		DevCPV486_expr(n, x, x__typ, hint, stop);
	}
	__EXIT;
}

static struct HandleIPtrs__35 {
	DevCPL486_Item *x;
	SYSTEM_TYPEDESC *x__typ;
	DevCPL486_Item *y;
	SYSTEM_TYPEDESC *y__typ;
	BOOLEAN *add, *rel, *init;
	struct HandleIPtrs__35 *lnk;
} *HandleIPtrs__35_s;

static void __36 (DevCPT_Struct typ, INTEGER adr);

static void __36 (DevCPT_Struct typ, INTEGER adr)
{
	DevCPT_Object fld = NIL;
	DevCPT_Struct btyp = NIL;
	INTEGER i, n;
	__ENTER("DevCPV486.FindPtrs");
	if ((INTEGER)typ->form == 13 && (INTEGER)typ->sysflag == 10) {
		if ((*HandleIPtrs__35_s->add)) {
			DevCPC486_IPAddRef(HandleIPtrs__35_s->y, HandleIPtrs__35_s->y__typ, adr, 1);
		}
		if ((*HandleIPtrs__35_s->rel)) {
			DevCPC486_IPRelease(HandleIPtrs__35_s->x, HandleIPtrs__35_s->x__typ, adr, 1, (*HandleIPtrs__35_s->init));
		}
	} else if ((INTEGER)typ->comp == 4 && (INTEGER)typ->sysflag != 7) {
		btyp = typ->BaseTyp;
		if (btyp != NIL) {
			__36(btyp, adr);
		}
		fld = typ->link;
		while (fld != NIL && (INTEGER)fld->mode == 4) {
			if ((INTEGER)fld->sysflag == 10 && __STRCMPSS(fld->name->data, "@utptr") == 0) {
				if ((*HandleIPtrs__35_s->add)) {
					DevCPC486_IPAddRef(HandleIPtrs__35_s->y, HandleIPtrs__35_s->y__typ, fld->adr + adr, 1);
				}
				if ((*HandleIPtrs__35_s->rel)) {
					DevCPC486_IPRelease(HandleIPtrs__35_s->x, HandleIPtrs__35_s->x__typ, fld->adr + adr, 1, (*HandleIPtrs__35_s->init));
				}
			} else {
				__36(fld->typ, fld->adr + adr);
			}
			fld = fld->link;
		}
	} else if ((INTEGER)typ->comp == 2) {
		btyp = typ->BaseTyp;
		n = typ->n;
		while ((INTEGER)btyp->comp == 2) {
			n = btyp->n * n;
			btyp = btyp->BaseTyp;
		}
		if (DevCPC486_ContainsIPtrs(btyp)) {
			i = 0;
			while (i < n) {
				__36(btyp, adr);
				adr += btyp->size;
				i += 1;
			}
		}
	} else if ((INTEGER)typ->comp == 3) {
		if (DevCPC486_ContainsIPtrs(typ)) {
			DevCPM_err(221);
		}
	}
	__EXIT;
}

static void DevCPV486_HandleIPtrs (DevCPT_Struct typ, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPL486_Item \
*y, SYSTEM_TYPEDESC *y__typ, BOOLEAN add, BOOLEAN rel, BOOLEAN init)
{
	struct HandleIPtrs__35 _s;
	__ENTER("DevCPV486.HandleIPtrs");
	_s.x = x; _s.x__typ = x__typ;
	_s.y = y; _s.y__typ = y__typ;
	_s.add = &add;
	_s.rel = &rel;
	_s.init = &init;
	_s.lnk = HandleIPtrs__35_s;
	HandleIPtrs__35_s = &_s;
	__36(typ, 0);
	HandleIPtrs__35_s = _s.lnk;
	__EXIT;
}

static BOOLEAN DevCPV486_CountedPtr (DevCPT_Node n)
{
	__ENTER("DevCPV486.CountedPtr");
	__EXIT;
	return ((INTEGER)n->typ->form == 13 && (INTEGER)n->typ->sysflag == 10) && ((INTEGER)n->class == 13 || \
(INTEGER)n->class == 30 && (INTEGER)n->right->class == 13);
}

static void DevCPV486_IPAssign (DevCPT_Node nx, DevCPT_Node ny, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, \
DevCPL486_Item *y, SYSTEM_TYPEDESC *y__typ, SET ux)
{
	__ENTER("DevCPV486.IPAssign");
	DevCPV486_expr(ny, y, y__typ, 0x0, 0xc000008f);
	if ((INTEGER)ny->class != 7 && !DevCPV486_CountedPtr(ny)) {
		DevCPC486_IPAddRef(y, y__typ, 0, 1);
	}
	if (nx != NIL) {
		DevCPC486_Assert(y, y__typ, 0x0, 0x8f | ux);
		DevCPV486_expr(nx, x, x__typ, 0x4f, 0x01000000);
		if ((INTEGER)(*x).mode == 14 && __IN((*x).reg, 0x0f) || (*x).scale != 0) {
			DevCPC486_GetAdr(x, x__typ, 0x0, 0x2000004f);
			(*x).mode = 14;
			(*x).offset = 0;
			(*x).scale = 0;
		}
		DevCPC486_IPRelease(x, x__typ, 0, 1, 0);
	}
	__EXIT;
}

static void DevCPV486_IPStructAssign (DevCPT_Struct typ)
{
	DevCPL486_Item x = {0}, y = {0};
	__ENTER("DevCPV486.IPStructAssign");
	if ((INTEGER)typ->comp == 3) {
		DevCPM_err(270);
	}
	x.mode = 14;
	x.reg = 7;
	x.offset = 0;
	x.scale = 0;
	y.mode = 14;
	y.reg = 6;
	y.offset = 0;
	y.scale = 0;
	DevCPV486_HandleIPtrs(typ, &x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 1, 1, 0);
	__EXIT;
}

static void DevCPV486_IPFree (DevCPT_Node nx, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ)
{
	__ENTER("DevCPV486.IPFree");
	DevCPV486_expr(nx, x, x__typ, 0x4f, 0x01000000);
	DevCPC486_GetAdr(x, x__typ, 0x0, 0x2000004f);
	(*x).mode = 14;
	(*x).offset = 0;
	(*x).scale = 0;
	if ((INTEGER)nx->typ->form == 15) {
		DevCPV486_HandleIPtrs(nx->typ, x, x__typ, x, x__typ, 0, 1, 1);
	} else {
		DevCPC486_IPRelease(x, x__typ, 0, 1, 1);
	}
	__EXIT;
}

static void DevCPV486_InitializeIPVars (DevCPT_Object proc)
{
	DevCPL486_Item x = {0};
	DevCPT_Object obj = NIL;
	__ENTER("DevCPV486.InitializeIPVars");
	x.mode = 14;
	x.reg = 5;
	x.scale = 0;
	x.form = 13;
	obj = proc->link;
	while (obj != NIL) {
		if ((INTEGER)obj->mode == 1 && obj->used) {
			x.offset = obj->adr;
			DevCPV486_HandleIPtrs(obj->typ, &x, DevCPL486_Item__typ, &x, DevCPL486_Item__typ, 1, 0, 0);
		}
		obj = obj->link;
	}
	__EXIT;
}

static void DevCPV486_ReleaseIPVars (DevCPT_Object proc)
{
	DevCPL486_Item x = {0}, ax = {0}, dx = {0}, si = {0}, di = {0};
	DevCPT_Object obj = NIL;
	__ENTER("DevCPV486.ReleaseIPVars");
	obj = proc->link;
	while (obj != NIL && (((INTEGER)obj->mode != 1 || !obj->used) || !DevCPC486_ContainsIPtrs(obj->typ))) \
{
		obj = obj->link;
	}
	if (obj == NIL) {
		obj = proc->scope->scope;
		while (obj != NIL && !DevCPC486_ContainsIPtrs(obj->typ)) {
			obj = obj->link;
		}
		if (obj == NIL) {
			__EXIT;
			return;
		}
	}
	DevCPL486_MakeReg(&ax, DevCPL486_Item__typ, 0, 6);
	DevCPL486_MakeReg(&si, DevCPL486_Item__typ, 6, 6);
	DevCPL486_MakeReg(&dx, DevCPL486_Item__typ, 2, 6);
	DevCPL486_MakeReg(&di, DevCPL486_Item__typ, 7, 6);
	if (!__IN(proc->typ->form, 0x1180)) {
		DevCPL486_GenMove(&ax, DevCPL486_Item__typ, &si, DevCPL486_Item__typ);
	}
	if ((INTEGER)proc->typ->form == 18) {
		DevCPL486_GenMove(&dx, DevCPL486_Item__typ, &di, DevCPL486_Item__typ);
	}
	x.mode = 14;
	x.reg = 5;
	x.scale = 0;
	x.form = 13;
	obj = proc->link;
	while (obj != NIL) {
		if ((INTEGER)obj->mode == 1 && obj->used) {
			x.offset = obj->adr;
			DevCPV486_HandleIPtrs(obj->typ, &x, DevCPL486_Item__typ, &x, DevCPL486_Item__typ, 0, 1, 0);
		}
		obj = obj->link;
	}
	obj = proc->scope->scope;
	while (obj != NIL) {
		if (obj->used) {
			x.offset = obj->adr;
			DevCPV486_HandleIPtrs(obj->typ, &x, DevCPL486_Item__typ, &x, DevCPL486_Item__typ, 0, 1, 0);
		}
		obj = obj->link;
	}
	if (!__IN(proc->typ->form, 0x1180)) {
		DevCPL486_GenMove(&si, DevCPL486_Item__typ, &ax, DevCPL486_Item__typ);
	}
	if ((INTEGER)proc->typ->form == 18) {
		DevCPL486_GenMove(&di, DevCPL486_Item__typ, &dx, DevCPL486_Item__typ);
	}
	__EXIT;
}

static void DevCPV486_CompareIntTypes (DevCPT_Struct typ, DevCPL486_Item *id, SYSTEM_TYPEDESC *id__typ, \
DevCPL486_Label *exit, INTEGER *num)
{
	DevCPL486_Item x = {0}, y = {0};
	DevCPL486_Label local;
	__ENTER("DevCPV486.CompareIntTypes");
	local = 0;
	typ = typ->BaseTyp;
	*num = 0;
	while (typ != NIL && typ != DevCPT_undftyp) {
		if ((INTEGER)typ->sysflag == 10 && typ->ext != NIL) {
			if (*num > 0) {
				DevCPC486_JumpT(&x, DevCPL486_Item__typ, &local);
			}
			DevCPC486_GuidFromString(typ->ext, &y, DevCPL486_Item__typ);
			x = *id;
			DevCPC486_GetAdr(&x, DevCPL486_Item__typ, 0x8f, 0x40000000);
			x = y;
			DevCPC486_GetAdr(&x, DevCPL486_Item__typ, 0x4f, 0x0);
			x = *id;
			DevCPC486_CmpString(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 9, 0);
			*num += 1;
		}
		typ = typ->BaseTyp;
	}
	if (*num > 0) {
		DevCPC486_JumpF(&x, DevCPL486_Item__typ, exit);
	}
	if (*num > 1) {
		DevCPL486_SetLabel(&local);
	}
	__EXIT;
}

static void DevCPV486_InstallQueryInterface (DevCPT_Struct typ, DevCPT_Object proc)
{
	DevCPL486_Item this = {0}, id = {0}, int_ = {0}, unk = {0}, c = {0};
	DevCPL486_Label nil, end;
	INTEGER num;
	__ENTER("DevCPV486.InstallQueryInterface");
	nil = 0;
	end = 0;
	this.mode = 14;
	this.reg = 5;
	this.offset = 8;
	this.scale = 0;
	this.form = 13;
	this.typ = DevCPT_anyptrtyp;
	id.mode = 19;
	id.reg = 5;
	id.offset = 12;
	id.scale = 0;
	id.form = 13;
	int_.mode = 19;
	int_.reg = 5;
	int_.offset = 16;
	int_.scale = 0;
	int_.form = 13;
	DevCPC486_GetAdr(&int_, DevCPL486_Item__typ, 0x0, 0x400000c3);
	int_.mode = 14;
	int_.offset = 0;
	DevCPL486_MakeConst(&c, DevCPL486_Item__typ, 0, 13);
	DevCPC486_Assign(&int_, DevCPL486_Item__typ, &c, DevCPL486_Item__typ);
	unk.mode = 14;
	unk.reg = 5;
	unk.offset = 8;
	unk.scale = 0;
	unk.form = 13;
	unk.typ = DevCPT_punktyp;
	DevCPC486_Load(&unk, DevCPL486_Item__typ, 0x0, 0x0);
	unk.mode = 14;
	unk.offset = 8;
	DevCPC486_Load(&unk, DevCPL486_Item__typ, 0x0, 0x0);
	DevCPL486_GenComp(&c, DevCPL486_Item__typ, &unk, DevCPL486_Item__typ);
	DevCPL486_GenJump(4, &nil, 1);
	DevCPL486_MakeReg(&c, DevCPL486_Item__typ, int_.reg, 13);
	DevCPL486_GenPush(&c, DevCPL486_Item__typ);
	c.mode = 14;
	c.reg = 5;
	c.offset = 12;
	c.scale = 0;
	c.form = 13;
	DevCPL486_GenPush(&c, DevCPL486_Item__typ);
	DevCPL486_GenPush(&unk, DevCPL486_Item__typ);
	c.mode = 14;
	c.reg = unk.reg;
	c.offset = 0;
	c.scale = 0;
	c.form = 13;
	DevCPL486_GenMove(&c, DevCPL486_Item__typ, &unk, DevCPL486_Item__typ);
	unk.mode = 14;
	unk.offset = 0;
	unk.scale = 0;
	unk.form = 13;
	DevCPL486_GenCall(&unk, DevCPL486_Item__typ);
	DevCPC486_Free(&unk, DevCPL486_Item__typ);
	DevCPL486_GenJump(-1, &end, 0);
	DevCPL486_SetLabel(&nil);
	DevCPL486_MakeConst(&c, DevCPL486_Item__typ, -2147467262, 6);
	DevCPC486_Result(proc, &c, DevCPL486_Item__typ);
	DevCPV486_CompareIntTypes(typ, &id, DevCPL486_Item__typ, &end, &num);
	if (num > 0) {
		DevCPC486_Load(&this, DevCPL486_Item__typ, 0x0, 0x0);
		DevCPC486_Assign(&int_, DevCPL486_Item__typ, &this, DevCPL486_Item__typ);
		DevCPC486_IPAddRef(&this, DevCPL486_Item__typ, 0, 0);
		DevCPL486_MakeConst(&c, DevCPL486_Item__typ, 0, 6);
		DevCPC486_Result(proc, &c, DevCPL486_Item__typ);
	}
	DevCPL486_SetLabel(&end);
	__EXIT;
}

static void DevCPV486_ActualPar (DevCPT_Node n, DevCPT_Object fp, BOOLEAN rec, DevCPL486_Item *tag, SYSTEM_TYPEDESC \
*tag__typ)
{
	DevCPL486_Item ap = {0};
	DevCPT_Node x = NIL;
	BOOLEAN niltest;
	__ENTER("DevCPV486.ActualPar");
	if (n != NIL) {
		DevCPV486_ActualPar(n->link, fp->link, 0, &ap, DevCPL486_Item__typ);
		niltest = 0;
		if ((INTEGER)fp->mode == 2) {
			if ((INTEGER)n->class == 12 && ((INTEGER)n->subcl == 46 || (INTEGER)n->subcl == 45)) {
				DevCPV486_expr(n->right, &ap, DevCPL486_Item__typ, 0x0, 0x0);
				DevCPC486_Push(&ap, DevCPL486_Item__typ);
				DevCPV486_expr(n->left, &ap, DevCPL486_Item__typ, 0x0, 0x0);
				DevCPC486_Push(&ap, DevCPL486_Item__typ);
				__EXIT;
				return;
			} else if (((INTEGER)fp->vis == 4 && DevCPC486_ContainsIPtrs(fp->typ)) && ap.typ != DevCPT_niltyp) \
{
				DevCPV486_IPFree(n, &ap, DevCPL486_Item__typ);
			} else {
				x = n;
				while ((INTEGER)x->class == 2 || (INTEGER)x->class == 4) {
					x = x->left;
				}
				niltest = (INTEGER)x->class == 3;
				DevCPV486_AdrExpr(n, &ap, DevCPL486_Item__typ, 0x0, 0x0);
			}
		} else if ((INTEGER)n->class == 11 && (INTEGER)n->subcl == 20) {
			if (__IN(n->typ->form, 0x020400)) {
				DevCPV486_expr(n, &ap, DevCPL486_Item__typ, 0x0, 0x0);
				DevCPM_err(265);
			} else if (((DevCPT_Includes(n->typ->form, n->left->typ->form) || DevCPT_Includes(n->typ->form, fp->typ->form)) \
&& (INTEGER)n->typ->form != 9) && fp->typ != DevCPT_bytetyp) {
				DevCPV486_expr(n->left, &ap, DevCPL486_Item__typ, 0x0, 0x08000000);
			} else {
				DevCPV486_expr(n, &ap, DevCPL486_Item__typ, 0x0, 0x08000000);
			}
		} else {
			DevCPV486_expr(n, &ap, DevCPL486_Item__typ, 0x0, 0x08000000);
			if (DevCPV486_CountedPtr(n)) {
				DevCPM_err(270);
			}
		}
		DevCPC486_Param(fp, rec, niltest, &ap, DevCPL486_Item__typ, tag, tag__typ);
	}
	__EXIT;
}

static void DevCPV486_Call (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ)
{
	DevCPL486_Item tag = {0};
	DevCPT_Object proc = NIL;
	BYTE m;
	DevCPT_Object p = NIL;
	INTEGER val;
	BOOLEAN c16;
	__ENTER("DevCPV486.Call");
	c16 = 0;
	val = 0;
	if ((INTEGER)n->left->class == 9) {
		proc = n->left->obj;
		m = proc->mode;
		if ((INTEGER)proc->sysflag == -12) {
			val = DevCPC486_CCallParSize(proc, NIL);
			c16 = 1;
		}
	} else {
		proc = NIL;
		m = 0;
		if ((INTEGER)n->left->typ->sysflag == -12) {
			val = DevCPC486_CCallParSize(NIL, n->left->typ);
			c16 = 1;
		}
	}
	if ((INTEGER)m == 9 && n->right != NIL) {
		DevCPV486_ActualPar(n->right->link, n->obj->link, 0, &tag, DevCPL486_Item__typ);
		DevCPV486_expr(n->right, &tag, DevCPL486_Item__typ, 0xce, 0x0);
	} else {
		if (proc != NIL) {
			DevCPC486_PrepCall(proc);
		}
		if (c16) {
			DevCPC486_PreCcall16(val);
		}
		DevCPV486_ActualPar(n->right, n->obj, (INTEGER)m == 13 && (INTEGER)n->left->subcl == 0, &tag, DevCPL486_Item__typ);
	}
	if (proc != NIL) {
		DevCPV486_design(n->left, x, x__typ, 0x0, 0x0);
	} else {
		DevCPV486_expr(n->left, x, x__typ, 0x0, 0x0);
	}
	DevCPC486_Call(x, x__typ, &tag, DevCPL486_Item__typ);
	__EXIT;
}

static void DevCPV486_Mem (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPT_Struct typ, \
SET hint, SET stop)
{
	INTEGER offset;
	__ENTER("DevCPV486.Mem");
	if (((INTEGER)n->class == 12 && __IN(n->subcl, 0xc0)) && (INTEGER)n->right->class == 7) {
		DevCPV486_expr(n->left, x, x__typ, hint, stop | 0x40000000);
		offset = n->right->conval->intval;
		if ((INTEGER)n->subcl == 7) {
			offset = -offset;
		}
	} else {
		DevCPV486_expr(n, x, x__typ, hint, stop | 0x40000000);
		offset = 0;
	}
	DevCPC486_Mem(x, x__typ, offset, typ);
	__EXIT;
}

static void DevCPV486_condition (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPL486_Label \
*false, DevCPL486_Label *true)
{
	DevCPL486_Label local;
	DevCPL486_Item y = {0};
	SET ux;
	INTEGER sx, num;
	BYTE f;
	__ENTER("DevCPV486.condition");
	if ((INTEGER)n->class == 11) {
		switch (n->subcl) {
			case 33: 
				DevCPV486_condition(n->left, x, x__typ, true, false);
				DevCPC486_Not(x, x__typ);
				break;
			case 16: 
				if ((INTEGER)n->left->typ->form == 13) {
					DevCPV486_expr(n->left, x, x__typ, 0x0, 0x40000000);
				} else {
					DevCPV486_design(n->left, x, x__typ, 0x0, 0x0);
				}
				DevCPC486_TypTest(x, x__typ, n->obj->typ, 0, 0);
				break;
			case 23: 
				DevCPV486_expr(n->left, x, x__typ, 0x0, 0x0);
				DevCPC486_Odd(x, x__typ);
				break;
			case 25: 
				DevCPV486_expr(n->left, x, x__typ, 0x0, 0x0);
				(*x).mode = 17;
				(*x).form = 2;
				break;
			case 29: 
				DevCPM_err(220);
				break;
			default: __CASECHK;
		}
	} else if ((INTEGER)n->class == 12) {
		switch (n->subcl) {
			case 5: 
				local = 0;
				DevCPV486_condition(n->left, &y, DevCPL486_Item__typ, false, &local);
				DevCPC486_JumpF(&y, DevCPL486_Item__typ, false);
				if (local != 0) {
					DevCPL486_SetLabel(&local);
				}
				DevCPV486_condition(n->right, x, x__typ, false, true);
				break;
			case 8: 
				local = 0;
				DevCPV486_condition(n->left, &y, DevCPL486_Item__typ, &local, true);
				DevCPC486_JumpT(&y, DevCPL486_Item__typ, true);
				if (local != 0) {
					DevCPL486_SetLabel(&local);
				}
				DevCPV486_condition(n->right, x, x__typ, false, true);
				break;
			case 9: case 10: case 11: case 12: case 13: 
			case 14: 
				f = n->left->typ->form;
				if ((INTEGER)f == 18) {
					DevCPM_err(260);
				} else if (__IN(f, 0x028400)) {
					if ((INTEGER)n->left->class == 11 && (INTEGER)n->left->subcl == 20) {
						DevCPV486_StringOp(n->right, n->left, x, x__typ, &y, DevCPL486_Item__typ, 0);
						DevCPC486_CmpString(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 1);
					} else {
						DevCPV486_StringOp(n->left, n->right, x, x__typ, &y, DevCPL486_Item__typ, 0);
						DevCPC486_CmpString(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 0);
					}
				} else if (__IN(f, 0x0180)) {
					DevCPV486_FloatDOp(n, x, x__typ);
				} else {
					if (DevCPV486_CountedPtr(n->left) || DevCPV486_CountedPtr(n->right)) {
						DevCPM_err(270);
					}
					DevCPV486_DualExp(n->left, n->right, x, x__typ, &y, DevCPL486_Item__typ, 0x0, 0x0, 0x80000000, 0x80000000);
					if ((INTEGER)(*x).mode == 18 || (INTEGER)y.mode == 3) {
						DevCPC486_IntDOp(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 0);
					} else if ((INTEGER)y.mode == 18 || (INTEGER)(*x).mode == 3) {
						DevCPC486_IntDOp(&y, DevCPL486_Item__typ, x, x__typ, n->subcl, 1);
						*x = y;
					} else {
						DevCPC486_Load(x, x__typ, 0x0, 0x0);
						DevCPC486_IntDOp(x, x__typ, &y, DevCPL486_Item__typ, n->subcl, 0);
					}
				}
				break;
			case 15: 
				DevCPV486_DualExp(n->left, n->right, x, x__typ, &y, DevCPL486_Item__typ, 0x0, 0x0, 0xc4000000, 0xa0000000);
				DevCPC486_In(x, x__typ, &y, DevCPL486_Item__typ);
				break;
			case 26: 
				DevCPV486_Check(n->left, &ux, &sx);
				DevCPV486_expr(n->right, x, x__typ, 0x0, ux | 0x04000000);
				DevCPV486_Mem(n->left, &y, DevCPL486_Item__typ, DevCPT_notyp, 0x0, 0x0);
				DevCPC486_Load(x, x__typ, 0x0, 0x04000000);
				DevCPC486_In(x, x__typ, &y, DevCPL486_Item__typ);
				break;
			case 42: 
				DevCPV486_AdrExpr(n->right, x, x__typ, 0x0, 0xc2);
				DevCPV486_CompareIntTypes(n->left->typ, x, x__typ, false, &num);
				if (num > 0) {
					DevCPV486_Check(n->right->link, &ux, &sx);
					DevCPV486_IPAssign(n->right->link, n->left, x, x__typ, &y, DevCPL486_Item__typ, ux);
					DevCPC486_Assign(x, x__typ, &y, DevCPL486_Item__typ);
					(*x).offset = 1;
				} else {
					(*x).offset = 0;
				}
				(*x).mode = 3;
				DevCPC486_MakeCond(x, x__typ);
				break;
			default: __CASECHK;
		}
	} else if ((INTEGER)n->class == 30) {
		DevCPV486_CompStat(n->left);
		DevCPV486_condition(n->right, x, x__typ, false, true);
		DevCPV486_CompRelease(n->left, x, x__typ);
		if ((INTEGER)(*x).mode == 16) {
			DevCPL486_GenCode(157);
			(*x).mode = 17;
		}
	} else {
		DevCPV486_expr(n, x, x__typ, 0x0, 0x0);
		DevCPC486_MakeCond(x, x__typ);
	}
	__EXIT;
}

static void DevCPV486_expr (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, SET hint, SET stop)
{
	DevCPL486_Item y = {0}, z = {0};
	BYTE f, g;
	DevCPT_Const cval = NIL;
	DevCPL486_Label false, true;
	SET uy;
	INTEGER sy;
	__ENTER("DevCPV486.expr");
	f = n->typ->form;
	if ((INTEGER)f == 2 && __IN(n->class, 0x1800)) {
		false = 0;
		true = 0;
		DevCPV486_condition(n, &y, DevCPL486_Item__typ, &false, &true);
		DevCPC486_LoadCond(x, x__typ, &y, DevCPL486_Item__typ, false, true, hint, stop | 0x40000000);
	} else {
		switch (n->class) {
			case 7: 
				if (n->obj == NIL) {
					cval = n->conval;
				} else {
					cval = n->obj->conval;
				}
				switch (f) {
					case 1: case 2: case 3: case 4: case 5: 
					case 6: case 11: case 13: case 16: 
						DevCPL486_MakeConst(x, x__typ, cval->intval, f);
						break;
					case 18: 
						DevCPL486_MakeConst(x, x__typ, cval->intval, f);
						DevCPE_GetLongWords(cval, &(*x).scale, &(*x).offset);
						break;
					case 9: 
						DevCPL486_MakeConst(x, x__typ, (INTEGER)cval->setval, 9);
						break;
					case 7: case 8: case 10: case 17: 
						DevCPL486_AllocConst(x, x__typ, cval, f);
						break;
					case 15: 
						__ASSERT(n->typ == DevCPT_guidtyp, 0);
						if (n->conval != NIL) {
							DevCPC486_GuidFromString(n->conval->ext, x, x__typ);
						} else {
							DevCPC486_GuidFromString(n->obj->typ->ext, x, x__typ);
						}
						break;
					default: __CASECHK;
				}
				break;
			case 10: 
				DevCPV486_Check(n->right, &uy, &sy);
				DevCPV486_expr(n->left, x, x__typ, 0x0, 0xc80000cd);
				DevCPC486_MakeSet(x, x__typ, 1, 0, (hint | stop) | uy, 0x0);
				DevCPC486_Assert(x, x__typ, 0x0, uy);
				DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0xc80000cd);
				DevCPC486_MakeSet(&y, DevCPL486_Item__typ, 1, 1, hint | stop, 0x0);
				DevCPC486_Load(x, x__typ, hint | stop, 0x0);
				if ((INTEGER)(*x).mode == 3) {
					DevCPC486_IntDOp(&y, DevCPL486_Item__typ, x, x__typ, 18, 1);
					*x = y;
				} else {
					DevCPC486_IntDOp(x, x__typ, &y, DevCPL486_Item__typ, 18, 0);
				}
				break;
			case 11: 
				switch (n->subcl) {
					case 26: 
						DevCPV486_expr(n->left, x, x__typ, 0x0, 0xc80000cd);
						DevCPC486_MakeSet(x, x__typ, 0, 0, hint | stop, 0x0);
						break;
					case 20: 
						if (__IN(f, 0x020400)) {
							DevCPV486_expr(n->left, x, x__typ, hint, stop);
							if ((INTEGER)f == 10) {
								(*x).form = 29;
							}
						} else {
							if ((INTEGER)n->left->class == 7) {
								__ASSERT((INTEGER)n->left->typ->form == 18 && (INTEGER)f == 8, 0);
								DevCPL486_AllocConst(x, x__typ, n->left->conval, n->left->typ->form);
							} else {
								DevCPV486_expr(n->left, x, x__typ, hint | stop, 0x08000000);
							}
							DevCPC486_Convert(x, x__typ, f, -1, hint | stop, 0x0);
						}
						break;
					case 29: 
						DevCPV486_expr(n->left, x, x__typ, hint | stop, 0x28000000);
						DevCPC486_Convert(x, x__typ, f, n->typ->size, hint, stop);
						break;
					case 24: 
						if ((INTEGER)n->left->class == 8) {
							(*x).mode = 3;
							(*x).offset = 0;
							(*x).obj = n->left->obj;
							(*x).form = 6;
							(*x).typ = n->left->typ;
						} else {
							DevCPV486_AdrExpr(n->left, x, x__typ, hint | stop, 0x0);
						}
						DevCPC486_GetAdr(x, x__typ, hint | stop, 0x0);
						break;
					case 36: 
						if ((INTEGER)n->left->class == 8) {
							(*x).mode = 3;
							(*x).offset = 0;
							(*x).obj = n->left->obj;
							(*x).form = 6;
							(*x).typ = n->left->typ;
							if ((*x).obj->typ->untagged) {
								DevCPM_err(111);
							}
						} else {
							DevCPV486_expr(n->left, x, x__typ, hint | stop, 0x0);
							DevCPC486_Tag(x, x__typ, &y, DevCPL486_Item__typ);
							DevCPC486_Free(x, x__typ);
							*x = y;
						}
						DevCPC486_Load(x, x__typ, hint | stop, 0x0);
						break;
					case 7: case 21: case 22: 
						DevCPV486_expr(n->left, x, x__typ, hint | stop, 0xc0000000);
						if ((INTEGER)f == 18) {
							DevCPM_err(260);
						} else if (__IN(f, 0x0180)) {
							DevCPC486_FloatMOp(x, x__typ, n->subcl);
						} else {
							DevCPC486_IntMOp(x, x__typ, n->subcl);
						}
						break;
					default: __CASECHK;
				}
				break;
			case 12: 
				if ((__IN(f, 0x0180) && (INTEGER)n->subcl != 27) && (INTEGER)n->subcl != 28) {
					if (((INTEGER)n->subcl == 17 && (INTEGER)n->right->class == 7) && n->right->conval->realval >= (REAL)0) \
{
						DevCPV486_expr(n->left, x, x__typ, 0x0, 0xc0000000);
						cval = n->right->conval;
						sy = (INTEGER)__ENTIER(cval->realval);
						cval->realval = (REAL)1;
						while (sy > 0) {
							cval->realval = cval->realval * (REAL)2;
							sy -= 1;
						}
						DevCPL486_AllocConst(&y, DevCPL486_Item__typ, cval, 7);
						DevCPC486_FloatDOp(x, x__typ, &y, DevCPL486_Item__typ, 1, 0);
					} else {
						DevCPV486_FloatDOp(n, x, x__typ);
					}
				} else if ((INTEGER)f == 18 || n->typ == DevCPT_intrealtyp) {
					DevCPM_err(260);
					DevCPV486_expr(n->left, x, x__typ, 0x0, 0x0);
				} else {
					switch (n->subcl) {
						case 1: 
							if ((INTEGER)f == 4) {
								DevCPV486_DualExp(n->left, n->right, x, x__typ, &y, DevCPL486_Item__typ, 0x0, 0x0, 0xe80000ce, \
0xa0000001);
								DevCPC486_IntDOp(x, x__typ, &y, DevCPL486_Item__typ, 1, 0);
							} else {
								DevCPV486_IntDOp(n, x, x__typ, hint | stop);
							}
							break;
						case 3: case 4: 
							DevCPV486_DualExp(n->left, n->right, x, x__typ, &y, DevCPL486_Item__typ, 0x0, 0x0, 0xe80000ce, \
0xc0000005);
							DevCPC486_DivMod(x, x__typ, &y, DevCPL486_Item__typ, (INTEGER)n->subcl == 4);
							break;
						case 6: 
							if (__IN(n->typ->form, 0x020400)) {
								DevCPM_err(265);
								DevCPV486_expr(n->left, x, x__typ, 0x0, 0x0);
							} else {
								DevCPV486_IntDOp(n, x, x__typ, hint | stop);
							}
							break;
						case 2: case 7: case 18: case 34: case 35: 
							DevCPV486_IntDOp(n, x, x__typ, hint | stop);
							break;
						case 17: case 27: case 28: 
							uy = 0x0;
							if ((INTEGER)n->right->class != 7) {
								uy = 0x02;
							}
							DevCPV486_DualExp(n->right, n->left, &y, DevCPL486_Item__typ, x, x__typ, 0x0, hint | stop, 0xc80000cd, \
uy | 0xe0000000);
							DevCPC486_Shift(x, x__typ, &y, DevCPL486_Item__typ, n->subcl);
							break;
						case 19: 
							if (__IN(n->left->typ->form, 0x020400)) {
								DevCPV486_expr(n->left, x, x__typ, 0x4f, 0x0);
								DevCPC486_GetAdr(x, x__typ, 0x0, 0x2000004f);
								DevCPC486_StrLen(x, x__typ, n->left->typ, 0);
							} else {
								DevCPV486_design(n->left, x, x__typ, hint | stop, 0x0);
								DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0x0);
								DevCPC486_Len(x, x__typ, &y, DevCPL486_Item__typ);
							}
							break;
						default: __CASECHK;
					}
				}
				break;
			case 13: 
				DevCPV486_Call(n, x, x__typ);
				break;
			case 30: 
				DevCPV486_CompStat(n->left);
				DevCPV486_expr(n->right, x, x__typ, hint, stop);
				DevCPV486_CompRelease(n->left, x, x__typ);
				if ((INTEGER)(*x).mode == 16) {
					DevCPC486_Pop(x, x__typ, (*x).form, hint, stop);
				}
				break;
			default: 
				DevCPV486_design(n, x, x__typ, hint | stop, stop & 0x01000000);
				DevCPC486_Prepare(x, x__typ, hint | stop, 0x0);
				break;
		}
	}
	(*x).typ = n->typ;
	DevCPC486_Assert(x, x__typ, hint, stop);
	__EXIT;
}

static void DevCPV486_AddCopy (DevCPT_Node n, DevCPL486_Item *dest, SYSTEM_TYPEDESC *dest__typ, DevCPL486_Item \
*dadr, SYSTEM_TYPEDESC *dadr__typ, DevCPL486_Item *len, SYSTEM_TYPEDESC *len__typ, BOOLEAN last)
{
	DevCPL486_Item adr = {0}, src = {0};
	SET u;
	INTEGER s;
	__ENTER("DevCPV486.AddCopy");
	DevCPV486_Check(n, &u, &s);
	DevCPC486_Assert(dadr, dadr__typ, 0x4f, u | 0x42);
	if ((INTEGER)(*len).mode != 3) {
		DevCPC486_Assert(len, len__typ, 0xcd, u | 0xc0);
	}
	DevCPV486_expr(n, &src, DevCPL486_Item__typ, 0x8f, 0x0);
	adr = src;
	DevCPC486_GetAdr(&adr, DevCPL486_Item__typ, 0x0, 0x2000008f);
	if ((INTEGER)(*len).mode != 3) {
		DevCPC486_Load(len, len__typ, 0x0, 0x200000cd);
	}
	DevCPC486_Load(dadr, dadr__typ, 0x0, 0x2000004f);
	DevCPC486_AddCopy(dest, dest__typ, &src, DevCPL486_Item__typ, last);
	__EXIT;
}

static void DevCPV486_StringCopy (DevCPT_Node left, DevCPT_Node right)
{
	DevCPL486_Item x = {0}, y = {0}, ax = {0}, ay = {0}, len = {0};
	__ENTER("DevCPV486.StringCopy");
	if (DevCPV486_IsAllocDynArr(left)) {
		DevCPV486_expr(left, &x, DevCPL486_Item__typ, 0xcd, 0x80);
	} else {
		DevCPV486_expr(left, &x, DevCPL486_Item__typ, 0x4f, 0x0);
	}
	ax = x;
	DevCPC486_GetAdr(&ax, DevCPL486_Item__typ, 0x0, 0x4f);
	DevCPC486_Free(&x, DevCPL486_Item__typ);
	DevCPC486_ArrayLen(&x, DevCPL486_Item__typ, &len, DevCPL486_Item__typ, 0xcd, 0x0);
	while ((INTEGER)right->class == 12) {
		__ASSERT((INTEGER)right->subcl == 6, 0);
		DevCPV486_AddCopy(right->left, &x, DevCPL486_Item__typ, &ax, DevCPL486_Item__typ, &len, DevCPL486_Item__typ, \
0);
		right = right->right;
	}
	DevCPV486_AddCopy(right, &x, DevCPL486_Item__typ, &ax, DevCPL486_Item__typ, &len, DevCPL486_Item__typ, \
1);
	DevCPC486_Free(&len, DevCPL486_Item__typ);
	__EXIT;
}

static void DevCPV486_Checkpc (void)
{
	__ENTER("DevCPV486.Checkpc");
	DevCPE_OutSourceRef(DevCPM_errpos);
	__EXIT;
}

static void DevCPV486_CondStat (DevCPT_Node if_, DevCPT_Node last, INTEGER *hint, DevCPL486_Label *else_, \
DevCPL486_Label *end)
{
	DevCPL486_Label local;
	DevCPL486_Item x = {0};
	DevCPT_Node cond = NIL;
	DevCPT_Node lcond = NIL;
	__ENTER("DevCPV486.CondStat");
	local = 0;
	DevCPM_errpos = if_->conval->intval;
	DevCPV486_Checkpc();
	cond = if_->left;
	if ((((((((last != NIL && (INTEGER)cond->class == 12) && (INTEGER)cond->subcl >= 9) && (INTEGER)cond->subcl \
<= 14) && (INTEGER)last->class == 12) && (INTEGER)last->subcl >= 9) && (INTEGER)last->subcl <= 14) && \
DevCPV486_SameExp(cond->left, last->left)) && DevCPV486_SameExp(cond->right, last->right)) {
		DevCPC486_setCC(&x, DevCPL486_Item__typ, cond->subcl, __ODD(*hint), *hint >= 2);
	} else if (((((last != NIL && (INTEGER)cond->class == 11) && (INTEGER)cond->subcl == 16) && (INTEGER)last->class \
== 11) && (INTEGER)last->subcl == 16) && DevCPV486_SameExp(cond->left, last->left)) {
		DevCPC486_ShortTypTest(&x, DevCPL486_Item__typ, cond->obj->typ);
	} else {
		DevCPV486_condition(cond, &x, DevCPL486_Item__typ, else_, &local);
	}
	*hint = x.reg;
	DevCPC486_JumpF(&x, DevCPL486_Item__typ, else_);
	if (local != 0) {
		DevCPL486_SetLabel(&local);
	}
	DevCPV486_stat(if_->right, end);
	__EXIT;
}

static void DevCPV486_IfStat (DevCPT_Node n, BOOLEAN withtrap, DevCPL486_Label *end)
{
	DevCPL486_Label else_;
	DevCPT_Node if_ = NIL;
	DevCPT_Node last = NIL;
	INTEGER hint;
	__ENTER("DevCPV486.IfStat");
	if_ = n->left;
	last = NIL;
	while (if_ != NIL && ((if_->link != NIL || n->right != NIL) || withtrap)) {
		else_ = 0;
		DevCPV486_CondStat(if_, last, &hint, &else_, end);
		if (DevCPV486_sequential) {
			DevCPC486_Jump(end);
		}
		DevCPL486_SetLabel(&else_);
		last = if_->left;
		if_ = if_->link;
	}
	if (n->right != NIL) {
		DevCPV486_stat(n->right, end);
	} else if (withtrap) {
		DevCPM_errpos = n->conval->intval;
		DevCPV486_Checkpc();
		DevCPC486_Trap(-1);
		DevCPV486_sequential = 0;
	} else {
		DevCPV486_CondStat(if_, last, &hint, end, end);
	}
	__EXIT;
}

static void DevCPV486_CasePart (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPL486_Label \
*else_, BOOLEAN last)
{
	DevCPL486_Label this, higher;
	DevCPT_Node m = NIL;
	INTEGER low, high;
	__ENTER("DevCPV486.CasePart");
	if (n != NIL) {
		this = (INTEGER)__ENTIER(n->conval->realval);
		if (__IN(2, n->conval->setval)) {
			if (n->left != NIL) {
				if (n->right != NIL) {
					higher = 0;
					DevCPC486_CaseJump(x, x__typ, n->conval->intval, n->conval->intval2, &this, &higher, 1, 0);
					DevCPV486_CasePart(n->left, x, x__typ, else_, 0);
					DevCPL486_SetLabel(&higher);
					DevCPV486_CasePart(n->right, x, x__typ, else_, last);
				} else {
					DevCPC486_CaseJump(x, x__typ, n->conval->intval, n->conval->intval2, &this, else_, 0, 0);
					DevCPV486_CasePart(n->left, x, x__typ, else_, last);
				}
			} else {
				DevCPC486_CaseJump(x, x__typ, n->conval->intval, n->conval->intval2, &this, else_, 0, 1);
				if (n->right != NIL) {
					DevCPV486_CasePart(n->right, x, x__typ, else_, last);
				} else if (!last) {
					DevCPC486_Jump(else_);
				}
			}
		} else {
			if (__IN(1, n->conval->setval)) {
				m = n;
				while (m->left != NIL) {
					m = m->left;
				}
				low = m->conval->intval;
				m = n;
				while (m->right != NIL) {
					m = m->right;
				}
				high = m->conval->intval2;
				DevCPC486_CaseTableJump(x, x__typ, low, high, else_);
				DevCPV486_actual = low;
				last = 1;
			}
			DevCPV486_CasePart(n->left, x, x__typ, else_, 0);
			while (DevCPV486_actual < n->conval->intval) {
				DevCPL486_GenCaseEntry(else_, 0);
				DevCPV486_actual += 1;
			}
			while (DevCPV486_actual < n->conval->intval2) {
				DevCPL486_GenCaseEntry(&this, 0);
				DevCPV486_actual += 1;
			}
			DevCPL486_GenCaseEntry(&this, last && n->right == NIL);
			DevCPV486_actual += 1;
			DevCPV486_CasePart(n->right, x, x__typ, else_, last);
		}
		n->conval->realval = this;
	}
	__EXIT;
}

static void DevCPV486_CaseStat (DevCPT_Node n, DevCPL486_Label *end)
{
	DevCPL486_Item x = {0};
	DevCPT_Node case_ = NIL;
	DevCPT_Node lab = NIL;
	INTEGER low, high, tab;
	DevCPL486_Label else_, this;
	__ENTER("DevCPV486.CaseStat");
	DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0xf4000000);
	else_ = 0;
	if (n->right->right != NIL && (INTEGER)n->right->right->class == 52) {
		DevCPV486_CasePart(n->right->link, &x, DevCPL486_Item__typ, &else_, 0);
		DevCPC486_Free(&x, DevCPL486_Item__typ);
		n->right->right->right->conval->intval2 = else_;
		DevCPV486_sequential = 0;
	} else {
		DevCPV486_CasePart(n->right->link, &x, DevCPL486_Item__typ, &else_, 1);
		DevCPC486_Free(&x, DevCPL486_Item__typ);
		DevCPL486_SetLabel(&else_);
		if (n->right->conval->setval != 0x0) {
			DevCPV486_stat(n->right->right, end);
		} else {
			DevCPC486_Trap(-2);
			DevCPV486_sequential = 0;
		}
	}
	case_ = n->right->left;
	while (case_ != NIL) {
		if (DevCPV486_sequential) {
			DevCPC486_Jump(end);
		}
		lab = case_->left;
		if (case_->right != NIL && (INTEGER)case_->right->class == 52) {
			case_->right->right->conval->intval2 = (INTEGER)__ENTIER(lab->conval->realval);
			__ASSERT(lab->link == NIL, 0);
			DevCPV486_sequential = 0;
		} else {
			while (lab != NIL) {
				this = (INTEGER)__ENTIER(lab->conval->realval);
				DevCPL486_SetLabel(&this);
				lab = lab->link;
			}
			DevCPV486_stat(case_->right, end);
		}
		case_ = case_->link;
	}
	__EXIT;
}

static void DevCPV486_Dim (DevCPT_Node n, DevCPL486_Item *x, SYSTEM_TYPEDESC *x__typ, DevCPL486_Item *nofel, \
SYSTEM_TYPEDESC *nofel__typ, INTEGER *fact, DevCPT_Struct dimtyp)
{
	DevCPL486_Item len = {0};
	SET u;
	INTEGER s;
	__ENTER("DevCPV486.Dim");
	DevCPV486_Check(n, &u, &s);
	if ((INTEGER)(*nofel).mode == 18 && __IN((*nofel).reg, u)) {
		DevCPC486_Push(nofel, nofel__typ);
	}
	DevCPV486_expr(n, &len, DevCPL486_Item__typ, 0x0, 0x44000000);
	if ((INTEGER)(*nofel).mode == 16) {
		DevCPC486_Pop(nofel, nofel__typ, 6, 0x0, 0x0);
	}
	if ((INTEGER)len.mode == 16) {
		DevCPC486_Pop(&len, DevCPL486_Item__typ, 6, 0x0, 0x0);
	}
	DevCPC486_MulDim(&len, DevCPL486_Item__typ, nofel, nofel__typ, fact, dimtyp);
	if (n->link != NIL) {
		DevCPV486_Dim(n->link, x, x__typ, nofel, nofel__typ, fact, dimtyp->BaseTyp);
	} else {
		DevCPC486_New(x, x__typ, nofel, nofel__typ, *fact);
	}
	DevCPC486_SetDim(x, x__typ, &len, DevCPL486_Item__typ, dimtyp);
	__EXIT;
}

static void DevCPV486_CompStat (DevCPT_Node n)
{
	DevCPL486_Item x = {0}, y = {0}, sp = {0}, old = {0}, len = {0};
	DevCPT_Struct typ = NIL;
	__ENTER("DevCPV486.CompStat");
	DevCPV486_Checkpc();
	while (n != NIL && DevCPM_noerr) {
		__ASSERT((INTEGER)n->class == 19, 0);
		if ((INTEGER)n->subcl == 0) {
			if (__IN(n->right->typ->form, 0x020400)) {
				DevCPV486_StringCopy(n->left, n->right);
			} else {
				if ((INTEGER)n->left->typ->sysflag == 10 && !DevCPV486_CountedPtr(n->right)) {
					DevCPV486_IPAssign(NIL, n->right, &x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 0x0);
				} else {
					DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0x0);
				}
				DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
				DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
			}
		} else {
			__ASSERT((INTEGER)n->subcl == 1, 0);
			typ = n->left->typ->BaseTyp;
			__ASSERT((INTEGER)typ->comp == 3, 0);
			__ASSERT(n->right->link == NIL, 0);
			DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0xc00000cd);
			DevCPL486_MakeReg(&sp, DevCPL486_Item__typ, 4, 6);
			DevCPC486_CopyReg(&sp, DevCPL486_Item__typ, &old, DevCPL486_Item__typ, 0x0, 0x02);
			DevCPC486_CopyReg(&y, DevCPL486_Item__typ, &len, DevCPL486_Item__typ, 0x0, 0x02);
			if ((INTEGER)typ->BaseTyp->form == 16) {
				DevCPL486_MakeConst(&x, DevCPL486_Item__typ, 2, 6);
				DevCPL486_GenMul(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 0);
			}
			DevCPC486_StackAlloc();
			DevCPC486_Free(&y, DevCPL486_Item__typ);
			DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
			DevCPC486_Assign(&x, DevCPL486_Item__typ, &sp, DevCPL486_Item__typ);
			DevCPC486_Push(&len, DevCPL486_Item__typ);
			DevCPC486_Push(&old, DevCPL486_Item__typ);
			typ->sysflag = 120;
		}
		n = n->link;
	}
	__EXIT;
}

static void DevCPV486_CompRelease (DevCPT_Node n, DevCPL486_Item *res, SYSTEM_TYPEDESC *res__typ)
{
	DevCPL486_Item x = {0}, y = {0}, sp = {0};
	__ENTER("DevCPV486.CompRelease");
	if (n->link != NIL) {
		DevCPV486_CompRelease(n->link, res, res__typ);
	}
	__ASSERT((INTEGER)n->class == 19, 0);
	if ((INTEGER)n->subcl == 0) {
		if ((INTEGER)n->left->typ->form == 13 && (INTEGER)n->left->typ->sysflag == 10) {
			if ((INTEGER)(*res).mode == 17) {
				DevCPL486_GenCode(156);
				(*res).mode = 16;
			} else if ((INTEGER)(*res).mode == 18) {
				if ((INTEGER)(*res).form < 5) {
					DevCPC486_Push(res, res__typ);
				} else {
					DevCPC486_Assert(res, res__typ, 0x0, 0x07);
				}
			}
			DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x4f, 0x01000000);
			DevCPC486_IPRelease(&x, DevCPL486_Item__typ, 0, 1, 1);
			n->left->obj->used = 0;
		}
	} else {
		__ASSERT((INTEGER)n->subcl == 1, 0);
		DevCPL486_MakeReg(&sp, DevCPL486_Item__typ, 4, 6);
		DevCPL486_GenPop(&sp, DevCPL486_Item__typ);
		DevCPL486_MakeConst(&y, DevCPL486_Item__typ, 0, 13);
		DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
		DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
	}
	__EXIT;
}

static void DevCPV486_Assign (DevCPT_Node n, SET ux)
{
	DevCPT_Node r = NIL;
	BYTE f;
	DevCPL486_Label false, true;
	DevCPL486_Item x = {0}, y = {0}, z = {0};
	SET uf, uy;
	__ENTER("DevCPV486.Assign");
	r = n->right;
	f = r->typ->form;
	uf = 0x0;
	if (__IN(r->class, 0x1800)) {
		if ((((INTEGER)r->subcl == 20 && (INTEGER)f != 9) && (DevCPT_Includes(f, r->left->typ->form) || DevCPT_Includes(f, \
n->left->typ->form))) && (__IN(f, 0x0180) || !__IN(r->left->typ->form, 0x0180))) {
			r = r->left;
		} else if (__IN(f, 0x030678) && DevCPV486_SameExp(n->left, r->left)) {
			if ((INTEGER)r->class == 12) {
				if (__IN(r->subcl, 0x0400c4) || (INTEGER)r->subcl == 1 && (INTEGER)f == 9) {
					DevCPV486_expr(r->right, &y, DevCPL486_Item__typ, 0x0, ux);
					DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
					DevCPC486_Load(&y, DevCPL486_Item__typ, 0x0, 0x0);
					DevCPC486_IntDOp(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, r->subcl, 0);
					__EXIT;
					return;
				} else if (__IN(r->subcl, 0x18020000)) {
					DevCPV486_expr(r->right, &y, DevCPL486_Item__typ, 0x480000cd, ux);
					DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
					DevCPC486_Load(&y, DevCPL486_Item__typ, 0x0, 0x080000cd);
					DevCPC486_Shift(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, r->subcl);
					__EXIT;
					return;
				}
			} else {
				if (__IN(r->subcl, 0x600080)) {
					DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
					DevCPC486_IntMOp(&x, DevCPL486_Item__typ, r->subcl);
					__EXIT;
					return;
				}
			}
		} else if ((INTEGER)f == 2) {
			if ((INTEGER)r->subcl == 33 && DevCPV486_SameExp(n->left, r->left)) {
				DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
				DevCPC486_IntMOp(&x, DevCPL486_Item__typ, 33);
				__EXIT;
				return;
			}
		}
	}
	if ((INTEGER)n->left->typ->sysflag == 10 && (INTEGER)n->left->typ->form == 13) {
		DevCPV486_IPAssign(n->left, r, &x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, ux);
	} else {
		DevCPV486_expr(r, &y, DevCPL486_Item__typ, 0x08000000, ux);
		DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, uf | 0x01000000);
	}
	DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
	__EXIT;
}

static void DevCPV486_stat (DevCPT_Node n, DevCPL486_Label *end)
{
	DevCPL486_Item x = {0}, y = {0}, nofel = {0};
	DevCPL486_Label local, next, loop, prevExit;
	INTEGER fact, sx, sz;
	SET ux, uz;
	DevCPT_Const _ptr__73 = NIL;
	DevCPT_Const _ptr__72 = NIL;
	DevCPT_Const _ptr__71 = NIL;
	DevCPT_Const _ptr__70 = NIL;
	DevCPT_Const _ptr__69 = NIL;
	__ENTER("DevCPV486.stat");
	DevCPV486_sequential = 1;
	DevCPV486_nesting += 1;
	while (n != NIL && DevCPM_noerr) {
		if (n->link == NIL) {
			next = *end;
		} else {
			next = 0;
		}
		DevCPM_errpos = n->conval->intval;
		DevCPL486_BegStat();
		switch (n->class) {
			case 14: 
				break;
			case 19: 
				DevCPV486_Checkpc();
				DevCPV486_Check(n->left, &ux, &sx);
				switch (n->subcl) {
					case 0: 
						if ((INTEGER)n->left->typ->form == 15) {
							if ((INTEGER)n->right->class == 12 && __IN(n->right->typ->form, 0x020400)) {
								DevCPV486_StringCopy(n->left, n->right);
							} else {
								DevCPV486_StringOp(n->left, n->right, &x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 1);
								if (DevCPC486_ContainsIPtrs(n->left->typ)) {
									DevCPV486_IPStructAssign(n->left->typ);
								}
								DevCPC486_Copy(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 0);
							}
						} else {
							DevCPV486_Assign(n, ux);
						}
						break;
					case 24: 
						DevCPV486_Mem(n->right, &y, DevCPL486_Item__typ, n->left->typ, 0x0, ux);
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x01000000);
						DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
						break;
					case 25: 
						DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, ux);
						DevCPV486_Mem(n->left, &x, DevCPL486_Item__typ, n->right->typ, 0x0, 0x0);
						DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
						break;
					case 13: case 14: 
						DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, ux);
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
						if ((INTEGER)n->left->typ->form == 18) {
							DevCPC486_LargeInc(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, (INTEGER)n->subcl == 14);
						} else {
							DevCPC486_Load(&y, DevCPL486_Item__typ, 0x0, 0x0);
							DevCPC486_IntDOp(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, (BYTE)(-7 + (INTEGER)n->subcl), \
0);
						}
						break;
					case 15: 
						DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0xc80000cd);
						DevCPC486_MakeSet(&y, DevCPL486_Item__typ, 0, 0, ux, 0x0);
						DevCPC486_Assert(&y, DevCPL486_Item__typ, 0x0, ux);
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
						DevCPC486_Load(&y, DevCPL486_Item__typ, 0x0, 0x0);
						DevCPC486_IntDOp(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 6, 0);
						break;
					case 16: 
						DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0xc80000cd);
						DevCPC486_MakeSet(&y, DevCPL486_Item__typ, 0, 1, ux, 0x0);
						DevCPC486_Assert(&y, DevCPL486_Item__typ, 0x0, ux);
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
						DevCPC486_Load(&y, DevCPL486_Item__typ, 0x0, 0x0);
						DevCPC486_IntDOp(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 1, 0);
						break;
					case 26: 
						DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0x0);
						if (y.offset < 8) {
							DevCPL486_MakeReg(&y, DevCPL486_Item__typ, y.offset, n->left->typ->form);
							DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x01000000);
							DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
						} else {
							DevCPM_err(220);
						}
						break;
					case 27: 
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
						if (x.offset < 8) {
							DevCPL486_MakeReg(&x, DevCPL486_Item__typ, x.offset, n->right->typ->form);
							DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0xcf & ~__SETOF(x.reg), 0x0);
							DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
						} else {
							DevCPM_err(220);
						}
						break;
					case 1: 
						y.typ = n->left->typ;
						if (n->right != NIL) {
							if ((INTEGER)y.typ->BaseTyp->comp == 4) {
								DevCPV486_expr(n->right, &nofel, DevCPL486_Item__typ, 0x0, 0xc0000007);
								DevCPC486_New(&y, DevCPL486_Item__typ, &nofel, DevCPL486_Item__typ, 1);
							} else {
								nofel.mode = 3;
								nofel.form = 6;
								fact = 1;
								DevCPV486_Dim(n->right, &y, DevCPL486_Item__typ, &nofel, DevCPL486_Item__typ, &fact, y.typ->BaseTyp);
							}
						} else {
							DevCPL486_MakeConst(&nofel, DevCPL486_Item__typ, 0, 6);
							DevCPC486_New(&y, DevCPL486_Item__typ, &nofel, DevCPL486_Item__typ, 1);
						}
						DevCPC486_Assert(&y, DevCPL486_Item__typ, 0x0, ux);
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x01000000);
						DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
						break;
					case 30: 
						DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, 0x44000000);
						DevCPC486_SysNew(&y, DevCPL486_Item__typ);
						DevCPC486_Assert(&y, DevCPL486_Item__typ, 0x0, ux);
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
						DevCPC486_Assign(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ);
						break;
					case 18: 
						DevCPV486_StringOp(n->left, n->right, &x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 1);
						DevCPC486_Copy(&x, DevCPL486_Item__typ, &y, DevCPL486_Item__typ, 1);
						break;
					case 31: 
						DevCPV486_Check(n->right->link, &uz, &sz);
						DevCPV486_expr(n->right, &y, DevCPL486_Item__typ, 0x0, (0x0400008f | ux) | uz);
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0400004f | uz);
						DevCPV486_expr(n->right->link, &nofel, DevCPL486_Item__typ, 0x0, 0xc40000cd);
						DevCPC486_Load(&x, DevCPL486_Item__typ, 0x0, 0x2000004f);
						DevCPC486_Load(&y, DevCPL486_Item__typ, 0x0, 0x2000008f);
						DevCPC486_SysMove(&nofel, DevCPL486_Item__typ);
						break;
					default: __CASECHK;
				}
				DevCPV486_sequential = 1;
				break;
			case 13: 
				DevCPV486_Checkpc();
				DevCPV486_Call(n, &x, DevCPL486_Item__typ);
				DevCPV486_sequential = 1;
				break;
			case 20: 
				if ((INTEGER)n->subcl != 32 || DevCPV486_assert) {
					DevCPV486_IfStat(n, 0, &next);
				}
				break;
			case 21: 
				DevCPV486_Checkpc();
				DevCPV486_CaseStat(n, &next);
				break;
			case 22: 
				local = 0;
				if (n->right != NIL) {
					DevCPC486_Jump(&local);
				}
				loop = 0;
				DevCPL486_SetLabel(&loop);
				DevCPV486_stat(n->right, &local);
				DevCPL486_SetLabel(&local);
				DevCPM_errpos = n->conval->intval;
				DevCPV486_Checkpc();
				DevCPV486_condition(n->left, &x, DevCPL486_Item__typ, &next, &loop);
				DevCPC486_JumpT(&x, DevCPL486_Item__typ, &loop);
				DevCPV486_sequential = 1;
				break;
			case 23: 
				loop = 0;
				DevCPL486_SetLabel(&loop);
				local = 0;
				DevCPV486_stat(n->left, &local);
				DevCPL486_SetLabel(&local);
				DevCPM_errpos = n->conval->intval;
				DevCPV486_Checkpc();
				DevCPV486_condition(n->right, &x, DevCPL486_Item__typ, &loop, &next);
				DevCPC486_JumpF(&x, DevCPL486_Item__typ, &loop);
				DevCPV486_sequential = 1;
				break;
			case 24: 
				prevExit = DevCPV486_Exit;
				DevCPV486_Exit = next;
				loop = 0;
				DevCPL486_SetLabel(&loop);
				DevCPV486_stat(n->left, &loop);
				if (DevCPV486_sequential) {
					DevCPC486_Jump(&loop);
				}
				next = DevCPV486_Exit;
				DevCPV486_Exit = prevExit;
				DevCPV486_sequential = 0;
				break;
			case 25: 
				DevCPV486_Checkpc();
				DevCPC486_Jump(&DevCPV486_Exit);
				DevCPV486_sequential = 0;
				break;
			case 26: 
				if (n->left != NIL) {
					DevCPV486_Checkpc();
					if ((((INTEGER)n->obj->typ->sysflag == 10 && (INTEGER)n->obj->typ->form == 13) && (INTEGER)n->left->class \
!= 7) && !DevCPV486_CountedPtr(n->left)) {
						DevCPV486_IPAssign(NIL, n->left, &y, DevCPL486_Item__typ, &x, DevCPL486_Item__typ, 0x0);
					} else {
						DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0xce, 0x0);
					}
					DevCPC486_Result(n->obj, &x, DevCPL486_Item__typ);
				}
				if (DevCPV486_nesting > 1 || n->link != NIL) {
					DevCPC486_Jump(&DevCPV486_Return);
				}
				DevCPV486_sequential = 0;
				break;
			case 27: 
				if ((n->left != NIL || n->right != NIL) || (INTEGER)n->subcl == 0) {
					DevCPV486_IfStat(n, (INTEGER)n->subcl == 0, &next);
				}
				break;
			case 28: 
				DevCPV486_Checkpc();
				DevCPC486_Trap(n->right->conval->intval);
				DevCPV486_sequential = 1;
				break;
			case 30: 
				DevCPV486_CompStat(n->left);
				DevCPV486_stat(n->right, &next);
				x.mode = 0;
				DevCPV486_CompRelease(n->left, &x, DevCPL486_Item__typ);
				break;
			case 50: 
				DevCPV486_Checkpc();
				DevCPV486_expr(n->left, &x, DevCPL486_Item__typ, 0x0, 0x0);
				DevCPC486_Free(&x, DevCPL486_Item__typ);
				break;
			case 52: 
				if (n->left != NIL) {
					DevCPV486_Checkpc();
					_ptr__73 = n->right->conval;
					DevCPV486_condition(n->left, &x, DevCPL486_Item__typ, &next, (void*)&_ptr__73->intval2);
					_ptr__72 = n->right->conval;
					DevCPC486_JumpT(&x, DevCPL486_Item__typ, (void*)&_ptr__72->intval2);
				} else {
					_ptr__71 = n->right->conval;
					DevCPC486_Jump((void*)&_ptr__71->intval2);
					DevCPV486_sequential = 0;
				}
				break;
			case 53: 
				_ptr__70 = n->right->conval;
				DevCPL486_GenJump(-3, (void*)&_ptr__70->intval2, 0);
				break;
			case 54: 
				DevCPL486_GenReturn(0);
				DevCPV486_sequential = 0;
				break;
			case 51: 
				_ptr__69 = n->conval;
				DevCPL486_SetLabel((void*)&_ptr__69->intval2);
				break;
			default: __CASECHK;
		}
		DevCPC486_CheckReg();
		DevCPL486_EndStat();
		n = n->link;
		if (n == NIL) {
			*end = next;
		} else if (next != 0) {
			DevCPL486_SetLabel(&next);
		}
	}
	DevCPV486_nesting -= 1;
	__EXIT;
}

static void DevCPV486_CheckFpu (DevCPT_Node n, BOOLEAN *useFpu)
{
	__ENTER("DevCPV486.CheckFpu");
	while (n != NIL) {
		if (__IN(n->typ->form, 0x0180)) {
			*useFpu = 1;
		}
		switch (n->class) {
			case 21: 
				DevCPV486_CheckFpu(n->left, useFpu);
				DevCPV486_CheckFpu(n->right->left, useFpu);
				DevCPV486_CheckFpu(n->right->right, useFpu);
				break;
			case 17: 
				DevCPV486_CheckFpu(n->right, useFpu);
				break;
			case 2: case 3: case 5: case 11: case 24: 
			case 26: case 50: case 52: 
				DevCPV486_CheckFpu(n->left, useFpu);
				break;
			case 4: case 10: case 12: case 13: case 15: 
			case 19: case 20: case 22: case 23: case 27: 
			case 30: 
				DevCPV486_CheckFpu(n->left, useFpu);
				DevCPV486_CheckFpu(n->right, useFpu);
				break;
			case 0: case 1: case 7: case 8: case 9: 
			case 14: case 25: case 28: case 51: case 53: 
			case 54: 
				break;
			default: __CASECHK;
		}
		n = n->link;
	}
	__EXIT;
}

static void DevCPV486_procs (DevCPT_Node n)
{
	DevCPT_Object proc = NIL;
	DevCPT_Object obj = NIL;
	INTEGER i, j;
	DevCPL486_Label end;
	SHORTCHAR ch;
	DevCPT_Name name;
	BOOLEAN useFpu;
	__ENTER("DevCPV486.procs");
	DevCPL486_level += 1;
	DevCPV486_nesting = 0;
	while (n != NIL && DevCPM_noerr) {
		DevCPC486_imLevel[__X(DevCPL486_level, 64)] = DevCPC486_imLevel[__X((INTEGER)DevCPL486_level - 1, 64)];
		proc = n->obj;
		if (__IN(4, proc->conval->setval)) {
			DevCPC486_imLevel[__X(DevCPL486_level, 64)] += 1;
		}
		DevCPV486_procs(n->left);
		DevCPM_errpos = n->conval->intval;
		useFpu = 0;
		DevCPV486_CheckFpu(n->right, &useFpu);
		DevCPC486_Enter(proc, n->right == NIL, useFpu);
		DevCPV486_InitializeIPVars(proc);
		end = 0;
		DevCPV486_Return = 0;
		DevCPV486_stat(n->right, &end);
		DevCPM_errpos = n->conval->intval2;
		DevCPV486_Checkpc();
		if (DevCPV486_sequential || end != 0) {
			DevCPL486_SetLabel(&end);
			if (proc->typ != DevCPT_notyp && (INTEGER)proc->sysflag != 16) {
				DevCPC486_Trap(-3);
			}
		}
		DevCPL486_SetLabel(&DevCPV486_Return);
		DevCPV486_ReleaseIPVars(proc);
		DevCPC486_Exit(proc, n->right == NIL);
		if ((INTEGER)proc->mode == 13) {
			__STRCOPYSS(proc->link->typ->strobj->name->data, name, 256);
			i = 0;
			while (name[__X(i, 256)] != 0) {
				i += 1;
			}
			name[__X(i, 256)] = (SHORTCHAR)'.';
			i += 1;
			j = 0;
			ch = (proc->name->data)[0];
			while (ch != 0 && i < 255) {
				name[__X(i, 256)] = ch;
				i += 1;
				j += 1;
				ch = (proc->name->data)[__X(j, proc->name->len[0])];
			}
			name[__X(i, 256)] = 0;
		} else {
			__STRCOPYSS(proc->name->data, name, 256);
		}
		DevCPE_OutRefName((void*)name, 256);
		DevCPE_OutRefs(proc->scope->right);
		n = n->link;
	}
	DevCPL486_level -= 1;
	__EXIT;
}

void DevCPV486_Module (DevCPT_Node prog)
{
	DevCPL486_Label end;
	DevCPT_Name name;
	DevCPT_Object obj = NIL;
	DevCPT_Object p = NIL;
	DevCPT_Node n = NIL;
	INTEGER aAd, rAd;
	DevCPT_Struct typ = NIL;
	BOOLEAN useFpu;
	__ENTER("DevCPV486.Module");
	DevCPH_UseReals(prog, 0x03);
	DevCPM_NewObj((void*)DevCPT_SelfName, 256);
	if (DevCPM_noerr) {
		DevCPE_OutHeader();
		n = prog->right;
		while (n != NIL && (INTEGER)n->class == 14) {
			n = n->link;
		}
		useFpu = 0;
		DevCPV486_CheckFpu(n, &useFpu);
		DevCPC486_Enter(NIL, n == NIL, useFpu);
		end = 0;
		DevCPV486_stat(n, &end);
		DevCPL486_SetLabel(&end);
		DevCPM_errpos = prog->conval->intval2;
		DevCPV486_Checkpc();
		DevCPC486_Exit(NIL, n == NIL);
		if (prog->link != NIL) {
			DevCPL486_SetLabel((void*)&DevCPE_closeLbl);
			useFpu = 0;
			DevCPV486_CheckFpu(prog->link, &useFpu);
			DevCPC486_Enter(NIL, 0, useFpu);
			end = 0;
			DevCPV486_stat(prog->link, &end);
			DevCPL486_SetLabel(&end);
			DevCPM_errpos = (INTEGER)__ENTIER(prog->conval->realval);
			DevCPV486_Checkpc();
			DevCPC486_Exit(NIL, 0);
		}
		__MOVE("$$", name, 3);
		DevCPE_OutRefName((void*)name, 256);
		DevCPE_OutRefs(DevCPT_topScope->right);
		DevCPM_errpos = prog->conval->intval;
		while (DevCPV486_query != NIL) {
			typ = DevCPV486_query->typ;
			DevCPV486_query->typ = DevCPT_int32typ;
			DevCPV486_query->conval->intval = 20;
			DevCPV486_query->conval->intval2 = -8;
			DevCPC486_Enter(DevCPV486_query, 0, 0);
			DevCPV486_InstallQueryInterface(typ, DevCPV486_query);
			DevCPC486_Exit(DevCPV486_query, 0);
			__MOVE("QueryInterface", name, 15);
			DevCPE_OutRefName((void*)name, 256);
			DevCPV486_query = DevCPV486_query->nlink;
		}
		DevCPV486_procs(prog->left);
		DevCPC486_InstallStackAlloc();
		DevCPV486_addRef = NIL;
		DevCPV486_release = NIL;
		DevCPV486_release2 = NIL;
		DevCPC486_intHandler = NIL;
		if (DevCPM_noerr) {
			DevCPE_OutCode();
		}
		if (!DevCPM_noerr) {
			DevCPM_DeleteObj();
		}
	}
	__EXIT;
}

static SYSTEM_MODDESC *DevCPV486__imp[] = {
	&DevCPC486__desc,
	&DevCPE__desc,
	&DevCPH__desc,
	&DevCPL486__desc,
	&DevCPM__desc,
	&DevCPT__desc,
};
static INTEGER DevCPV486__exp[] = {
	67,
	0x227d6f36, (INTEGER)DevCPV486_ActualPar, 1<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_AddCopy, 11<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_AdrExpr, 19<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Align, 27<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)DevCPV486_Allocate, 33<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPV486_Assign, 42<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Base, 49<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Call, 54<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_CasePart, 59<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_CaseStat, 68<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Check, 77<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_CheckFpu, 83<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Checkpc, 92<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)DevCPV486_Close, 100<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPV486_CompRelease, 106<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_CompStat, 118<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_CompareIntTypes, 127<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_CondStat, 143<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_CountTProcs, 152<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_CountedPtr, 164<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Dim, 175<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_DualExp, 179<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_EnumTProcs, 187<<8 | 0x14, 0,
	0x1ee54c0a, (INTEGER)&DevCPV486_Exit, 198<<8 | 0x13, 6,
	0x227d6f36, (INTEGER)DevCPV486_FloatDOp, 203<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_GTypeSize, 212<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_GetComKernel, 222<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_HandleIPtrs, 235<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_IPAssign, 247<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_IPFree, 256<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_IPStructAssign, 263<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_IfStat, 278<<8 | 0x14, 0,
	0x18ea5fb4, (INTEGER)DevCPV486_Init, 285<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPV486_InitializeIPVars, 290<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_InstallQueryInterface, 307<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_IntDOp, 329<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_IsAllocDynArr, 336<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Mem, 350<<8 | 0x14, 0,
	0x5a85f0e0, (INTEGER)DevCPV486_Module, 354<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPV486_NegAlign, 361<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_NumOfIntProc, 370<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Objects, 383<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Parameters, 391<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_Procedure, 402<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_ReleaseIPVars, 412<<8 | 0x14, 0,
	0x1ee54c0a, (INTEGER)&DevCPV486_Return, 426<<8 | 0x13, 6,
	0x227d6f36, (INTEGER)DevCPV486_SameExp, 433<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_StringCopy, 441<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_StringOp, 452<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_TProcedures, 461<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_TypeAlloc, 473<<8 | 0x14, 0,
	0x8b95859d, (INTEGER)DevCPV486_TypeSize, 483<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)DevCPV486_Variables, 492<<8 | 0x14, 0,
	0x1ee54c0a, (INTEGER)&DevCPV486_actual, 502<<8 | 0x13, 6,
	0x229f03f2, (INTEGER)&DevCPV486_addRef, 509<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x0de13ad6, (INTEGER)&DevCPV486_assert, 516<<8 | 0x13, 1,
	0x227d6f36, (INTEGER)DevCPV486_condition, 523<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_design, 533<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DevCPV486_expr, 540<<8 | 0x14, 0,
	0x1ee54c0a, (INTEGER)&DevCPV486_nesting, 545<<8 | 0x13, 6,
	0x79c7d28c, 0, 553<<8 | 0x41, 0,
	0x227d6f36, (INTEGER)DevCPV486_procs, 563<<8 | 0x14, 0,
	0x229f03f2, (INTEGER)&DevCPV486_query, 569<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPV486_release, 575<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x229f03f2, (INTEGER)&DevCPV486_release2, 583<<8 | 0x13, (INTEGER)DevCPT_Object__desc,
	0x0de13ad6, (INTEGER)&DevCPV486_sequential, 592<<8 | 0x13, 1,
	0x227d6f36, (INTEGER)DevCPV486_stat, 603<<8 | 0x14, 0,
};
static char DevCPV486__names[] = {
	0,
	'A','c','t','u','a','l','P','a','r',0,
	'A','d','d','C','o','p','y',0,
	'A','d','r','E','x','p','r',0,
	'A','l','i','g','n',0,
	'A','l','l','o','c','a','t','e',0,
	'A','s','s','i','g','n',0,
	'B','a','s','e',0,
	'C','a','l','l',0,
	'C','a','s','e','P','a','r','t',0,
	'C','a','s','e','S','t','a','t',0,
	'C','h','e','c','k',0,
	'C','h','e','c','k','F','p','u',0,
	'C','h','e','c','k','p','c',0,
	'C','l','o','s','e',0,
	'C','o','m','p','R','e','l','e','a','s','e',0,
	'C','o','m','p','S','t','a','t',0,
	'C','o','m','p','a','r','e','I','n','t','T','y','p','e','s',0,
	'C','o','n','d','S','t','a','t',0,
	'C','o','u','n','t','T','P','r','o','c','s',0,
	'C','o','u','n','t','e','d','P','t','r',0,
	'D','i','m',0,
	'D','u','a','l','E','x','p',0,
	'E','n','u','m','T','P','r','o','c','s',0,
	'E','x','i','t',0,
	'F','l','o','a','t','D','O','p',0,
	'G','T','y','p','e','S','i','z','e',0,
	'G','e','t','C','o','m','K','e','r','n','e','l',0,
	'H','a','n','d','l','e','I','P','t','r','s',0,
	'I','P','A','s','s','i','g','n',0,
	'I','P','F','r','e','e',0,
	'I','P','S','t','r','u','c','t','A','s','s','i','g','n',0,
	'I','f','S','t','a','t',0,
	'I','n','i','t',0,
	'I','n','i','t','i','a','l','i','z','e','I','P','V','a','r','s',0,
	'I','n','s','t','a','l','l','Q','u','e','r','y','I','n','t','e','r','f','a','c','e',0,
	'I','n','t','D','O','p',0,
	'I','s','A','l','l','o','c','D','y','n','A','r','r',0,
	'M','e','m',0,
	'M','o','d','u','l','e',0,
	'N','e','g','A','l','i','g','n',0,
	'N','u','m','O','f','I','n','t','P','r','o','c',0,
	'O','b','j','e','c','t','s',0,
	'P','a','r','a','m','e','t','e','r','s',0,
	'P','r','o','c','e','d','u','r','e',0,
	'R','e','l','e','a','s','e','I','P','V','a','r','s',0,
	'R','e','t','u','r','n',0,
	'S','a','m','e','E','x','p',0,
	'S','t','r','i','n','g','C','o','p','y',0,
	'S','t','r','i','n','g','O','p',0,
	'T','P','r','o','c','e','d','u','r','e','s',0,
	'T','y','p','e','A','l','l','o','c',0,
	'T','y','p','e','S','i','z','e',0,
	'V','a','r','i','a','b','l','e','s',0,
	'a','c','t','u','a','l',0,
	'a','d','d','R','e','f',0,
	'a','s','s','e','r','t',0,
	'c','o','n','d','i','t','i','o','n',0,
	'd','e','s','i','g','n',0,
	'e','x','p','r',0,
	'n','e','s','t','i','n','g',0,
	'p','r','o','c','e','s','s','o','r',0,
	'p','r','o','c','s',0,
	'q','u','e','r','y',0,
	'r','e','l','e','a','s','e',0,
	'r','e','l','e','a','s','e','2',0,
	's','e','q','u','e','n','t','i','a','l',0,
	's','t','a','t',0,
};
static INTEGER DevCPV486__ptrs[] = {
	(INTEGER)&DevCPV486_query + 0, 
	(INTEGER)&DevCPV486_addRef + 0, 
	(INTEGER)&DevCPV486_release + 0, 
	(INTEGER)&DevCPV486_release2 + 0, 
};
struct SYSTEM_MODDESC DevCPV486__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 15}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	DevCPV486__body,
	0,
	6, /* nofimps */ 
	4, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	DevCPV486__names,
	DevCPV486__ptrs,
	DevCPV486__imp,
	(SYSTEM_DIRECTORY*)DevCPV486__exp,
	"DevCPV486"
};

export void DevCPV486__reg()
{
	__BEGREG(DevCPV486__desc);
	DevCPM__reg();
	DevCPT__reg();
	DevCPE__reg();
	DevCPH__reg();
	DevCPL486__reg();
	DevCPC486__reg();
	__REGMOD(DevCPV486__desc);
	__ENDREG;
}

export void DevCPV486__body()
{
	__BEGBODY(DevCPV486__desc);
	DevCPM__body();
	DevCPT__body();
	DevCPE__body();
	DevCPH__body();
	DevCPL486__body();
	DevCPC486__body();
	__ENDBODY;
}
