/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"
#include "HostFiles.h"
#include "Files.h"
#include "Console.h"
#include "Strings.h"
#include "DswDocuments.h"
#include "DevCPM.h"
#include "DevCPT.h"
#include "DevCPB.h"
#include "DevCPP.h"
#include "DevCPE.h"
#include "DevCPH.h"
#include "CPfrontCPV.h"
#include "CPfrontCPG.h"

typedef
	struct DswCompilerCPfrontMain_Elem__rec *DswCompilerCPfrontMain_Elem;

typedef
	struct DswCompilerCPfrontMain_Elem__rec {
		Files_Name dir, name, path, outsym, outcode;
		DevCPM_Directory insym;
		BOOLEAN found;
		SET opts, opts2;
		DswCompilerCPfrontMain_Elem next;
	} DswCompilerCPfrontMain_Elem__rec;


static DswCompilerCPfrontMain_Elem DswCompilerCPfrontMain_u;

export INTEGER DswCompilerCPfrontMain_Elem__rec__desc[];
export SYSTEM_TYPEDESC *DswCompilerCPfrontMain_Elem__rec__typ = (SYSTEM_TYPEDESC*)(DswCompilerCPfrontMain_Elem__rec__desc \
+ 2);
export INTEGER DswCompilerCPfrontMain_Elem__desc[];
export SYSTEM_TYPEDESC *DswCompilerCPfrontMain_Elem__typ = (SYSTEM_TYPEDESC*)DswCompilerCPfrontMain_Elem__desc;

static void DswCompilerCPfrontMain_CompileAll (void);
static void DswCompilerCPfrontMain_GetPath (CHAR *path, INTEGER path__len, Files_Name dir, Files_Name \
name);
static void DswCompilerCPfrontMain_Init (void);
static void DswCompilerCPfrontMain_InitOptions (void);
static void DswCompilerCPfrontMain_Module (struct CHAR_ARRAY *source, DswCompilerCPfrontMain_Elem m, BOOLEAN \
*error);
static struct CHAR_ARRAY *DswCompilerCPfrontMain_ReadText (DswCompilerCPfrontMain_Elem s);

export void DswCompilerCPfrontMain__reg();
export void DswCompilerCPfrontMain__body();
export struct SYSTEM_MODDESC DswCompilerCPfrontMain__desc;


static void DswCompilerCPfrontMain_GetPath (CHAR *path, INTEGER path__len, Files_Name dir, Files_Name \
name)
{
	INTEGER i, j, len, _for__3;
	__ENTER("DswCompilerCPfrontMain.GetPath");
	len = __STRLEN(path);
	i = len - 1;
	while (i >= 0 && path[__X(i, path__len)] != (CHAR)L'/') {
		i -= 1;
	}
	if (i >= 0) {
		_for__3 = i - 1;
		i = 0;
		while (i <= _for__3) {
			dir[__X(i, 256)] = path[__X(i, path__len)];
			i += 1;
		}
		dir[__X(i, 256)] = 0;
	} else {
		dir[0] = 0;
	}
	j = i + 1;
	i = 0;
	while (path[__X(j, path__len)] != 0) {
		name[__X(i, 256)] = path[__X(j, path__len)];
		i += 1;
		j += 1;
	}
	name[__X(i, 256)] = 0;
	__EXIT;
}

static struct InitOptions__5 {
	INTEGER *i;
	CHAR (*p)[256];
	struct InitOptions__5 *lnk;
} *InitOptions__5_s;

static void __6 (void);

static void __6 (void)
{
	__ENTER("DswCompilerCPfrontMain.Check");
	if ((*InitOptions__5_s->i) >= Kernel_argc) {
		Console_WriteStr((void*)((CHAR[]){114, 101, 113, 117, 105, 114, 101, 100, 32, 109, 111, 114, 101, 32, \
112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 32, 102, 111, 114, 32, 0}), 30);
		Console_WriteStr((void*)(*InitOptions__5_s->p), 256);
		Console_WriteLn();
		Kernel_Quit(1);
	}
	__EXIT;
}

static void DswCompilerCPfrontMain_InitOptions (void)
{
	INTEGER i;
	BOOLEAN found;
	DevCPM_Directory insym = NIL;
	DevCPM_Directory sym = NIL;
	Files_Name outsym, outcode;
	CHAR p[256];
	DswCompilerCPfrontMain_Elem h = NIL;
	DswCompilerCPfrontMain_Elem t = NIL;
	SET opts, opts2;
	struct InitOptions__5 _s;
	__ENTER("DswCompilerCPfrontMain.InitOptions");
	_s.i = &i;
	_s.p = (void*)p;
	_s.lnk = InitOptions__5_s;
	InitOptions__5_s = &_s;
	outsym[0] = 0;
	outcode[0] = 0;
	opts = 0x0d;
	opts2 = 0x0;
	found = 0;
	h = NIL;
	t = NIL;
	insym = NIL;
	i = 1;
	while (i < Kernel_argc) {
		if (((Kernel_argv)[i])[0] == (SHORTCHAR)'-') {
			__STRCOPYSL((Kernel_argv)[i], p, 256);
			i += 1;
			if (__STRCMPLL(p, ((CHAR[]){45, 108, 101, 103, 97, 99, 121, 0})) == 0) {
				DevCPM_legacy = 1;
			} else if (__STRCMPLL(p, ((CHAR[]){45, 111, 117, 116, 115, 121, 109, 0})) == 0) {
				__6();
				__STRCOPYSL((Kernel_argv)[i], outsym, 256);
				i += 1;
			} else if (__STRCMPLL(p, ((CHAR[]){45, 111, 117, 116, 99, 111, 100, 101, 0})) == 0) {
				__6();
				__STRCOPYSL((Kernel_argv)[i], outcode, 256);
				i += 1;
			} else if (__STRCMPLL(p, ((CHAR[]){45, 115, 121, 109, 100, 105, 114, 0})) == 0) {
				__6();
				sym = insym;
				insym = __NEW(DevCPM_Directory__rec__typ);
				__STRCOPYSL((Kernel_argv)[i], insym->path, 256);
				insym->legacy = 0;
				insym->next = sym;
				i += 1;
			} else if (__STRCMPLL(p, ((CHAR[]){45, 108, 101, 103, 97, 99, 121, 115, 121, 109, 100, 105, 114, 0})) \
== 0) {
				__6();
				sym = insym;
				insym = __NEW(DevCPM_Directory__rec__typ);
				__STRCOPYSL((Kernel_argv)[i], insym->path, 256);
				insym->legacy = 1;
				insym->next = sym;
				i += 1;
			} else if (__STRCMPLL(p, ((CHAR[]){45, 97, 108, 108, 99, 104, 101, 99, 107, 115, 0})) == 0) {
				opts |= __SETOF(1);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 97, 108, 108, 99, 104, 101, 99, 107, 115, 0})) \
== 0) {
				opts &= ~__SETOF(1);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 115, 114, 99, 112, 111, 115, 0})) == 0) {
				opts |= __SETOF(6);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 115, 114, 99, 112, 111, 115, 0})) == 0) {
				opts &= ~__SETOF(6);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 115, 116, 114, 117, 99, 116, 114, 101, 102, 0})) == 0) {
				opts |= __SETOF(5);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 115, 116, 114, 117, 99, 116, 114, 101, 102, 0})) \
== 0) {
				opts &= ~__SETOF(5);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 114, 101, 102, 0})) == 0) {
				opts |= __SETOF(4);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 114, 101, 102, 0})) == 0) {
				opts &= ~__SETOF(4);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 111, 98, 106, 0})) == 0) {
				opts |= __SETOF(3);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 111, 98, 106, 0})) == 0) {
				opts &= ~__SETOF(3);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 97, 115, 115, 101, 114, 116, 0})) == 0) {
				opts |= __SETOF(2);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 97, 115, 115, 101, 114, 116, 0})) == 0) {
				opts &= ~__SETOF(2);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 99, 104, 101, 99, 107, 115, 0})) == 0) {
				opts |= __SETOF(0);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 99, 104, 101, 99, 107, 115, 0})) == 0) {
				opts &= ~__SETOF(0);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 104, 105, 110, 116, 115, 0})) == 0) {
				opts |= __SETOF(29);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 104, 105, 110, 116, 115, 0})) == 0) {
				opts &= ~__SETOF(29);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 116, 114, 97, 112, 0})) == 0) {
				opts |= __SETOF(31);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 116, 114, 97, 112, 0})) == 0) {
				opts &= ~__SETOF(31);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 111, 98, 101, 114, 111, 110, 0})) == 0) {
				opts |= __SETOF(30);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 111, 98, 101, 114, 111, 110, 0})) == 0) {
				opts &= ~__SETOF(30);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 99, 111, 109, 45, 97, 119, 97, 114, 101, 0})) == 0) {
				found = 1;
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 99, 111, 109, 45, 97, 119, 97, 114, 101, 0})) \
== 0) {
				found = 0;
			} else if (__STRCMPLL(p, ((CHAR[]){45, 118, 0})) == 0 || __STRCMPLL(p, ((CHAR[]){45, 118, 101, 114, \
98, 111, 115, 101, 0})) == 0) {
				DevCPM_verbose = __MIN(DevCPM_verbose + 1, 3);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 109, 97, 105, 110, 0})) == 0) {
				opts |= __SETOF(20);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 109, 97, 105, 110, 0})) == 0) {
				opts &= ~__SETOF(20);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 105, 110, 99, 108, 117, 100, 101, 48, 0})) == 0) {
				opts |= __SETOF(21);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 105, 110, 99, 108, 117, 100, 101, 48, 0})) == \
0) {
				opts &= ~__SETOF(21);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 105, 110, 99, 108, 117, 100, 101, 100, 105, 114, 0})) == 0) \
{
				__6();
				__STRCOPYSL((Kernel_argv)[i], CPfrontCPG_includePath, 256);
				i += 1;
			} else if (__STRCMPLL(p, ((CHAR[]){45, 108, 111, 110, 103, 45, 99, 97, 108, 108, 115, 0})) == 0) {
				opts2 |= __SETOF(0);
			} else if (__STRCMPLL(p, ((CHAR[]){45, 110, 111, 45, 108, 111, 110, 103, 45, 99, 97, 108, 108, 115, \
0})) == 0) {
				opts2 &= ~__SETOF(0);
			} else {
				Console_WriteStr((void*)((CHAR[]){117, 110, 107, 110, 111, 119, 110, 32, 111, 112, 116, 105, 111, \
110, 32, 0}), 16);
				Console_WriteStr((void*)p, 256);
				Console_WriteLn();
				Kernel_Quit(1);
			}
		} else {
			if (h == NIL) {
				h = __NEW(DswCompilerCPfrontMain_Elem__rec__typ);
				t = h;
			} else {
				t->next = __NEW(DswCompilerCPfrontMain_Elem__rec__typ);
				t = t->next;
			}
			__STRCOPYSL((Kernel_argv)[i], t->path, 256);
			__MOVE(outcode, t->outcode, 512);
			__MOVE(outsym, t->outsym, 512);
			t->insym = insym;
			t->found = found;
			t->opts = opts;
			t->opts2 = opts2;
			DswCompilerCPfrontMain_GetPath((void*)t->path, 256, t->dir, t->name);
			if (t->name[0] == 0) {
				Console_WriteStr((void*)((CHAR[]){115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 112, 97, 116, 104, \
32, 116, 111, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0}), 28);
				Console_WriteLn();
				Kernel_Quit(1);
			}
			i += 1;
		}
	}
	DswCompilerCPfrontMain_u = h;
	InitOptions__5_s = _s.lnk;
	__EXIT;
}

static void DswCompilerCPfrontMain_Module (struct CHAR_ARRAY *source, DswCompilerCPfrontMain_Elem m, BOOLEAN \
*error)
{
	BOOLEAN ext, new;
	DevCPT_Node p = NIL;
	__ENTER("DswCompilerCPfrontMain.Module");
	CPfrontCPG_opt = 0x0;
	DevCPM_Init((void*)source);
	DevCPM_symList = m->insym;
	__MOVE(m->outcode, DevCPM_codePath, 512);
	__MOVE(m->outsym, DevCPM_symPath, 512);
	__MOVE(m->path, DevCPM_name, 512);
	DevCPM_options |= __SETOF(10);
	DevCPM_options |= __SETOF(14);
	CPfrontCPG_opt |= __SETOF(6);
	if (m->found) {
		DevCPM_options |= __SETOF(3);
	}
	if (__IN(31, m->opts)) {
		DevCPM_options |= __SETOF(31);
	}
	if (__IN(30, m->opts)) {
		DevCPM_options |= __SETOF(6);
	}
	if (__IN(20, m->opts)) {
		CPfrontCPG_opt |= __SETOF(10);
	}
	if (__IN(21, m->opts)) {
		CPfrontCPG_opt |= __SETOF(8);
	}
	DevCPT_Init(m->opts);
	DevCPB_typSize = CPfrontCPV_TypSize;
	DevCPT_processor = 1;
	DevCPP_Module(&p);
	if (DevCPM_noerr) {
		if (DevCPT_libName[0] != 0) {
			m->opts &= ~__SETOF(3);
		}
		CPfrontCPV_Init(m->opts);
		CPfrontCPV_AdrAndSize(DevCPT_topScope);
		DevCPT_Export(&ext, &new);
		if (DevCPM_noerr && __IN(3, m->opts)) {
			CPfrontCPG_OpenFiles((void*)DevCPT_SelfName, 256);
			if (__IN(0, m->opts2)) {
				DevCPH_UseCalls(p, 0x0f);
			}
			CPfrontCPV_Module(p);
		}
	}
	if ((DevCPM_noerr && __IN(10, CPfrontCPG_opt)) && __STRCMPSS(CPfrontCPG_modName, "SYSTEM") != 0) {
		DevCPM_DeleteNewSym();
		if (DevCPM_verbose > 0) {
			DevCPM_LogWStr((void*)((CHAR[]){32, 32, 109, 97, 105, 110, 32, 112, 114, 111, 103, 114, 97, 109, 0}), \
15);
			DevCPM_LogWLn();
		}
	} else if (DevCPM_noerr && (new || ext)) {
		DevCPM_RegisterNewSym();
	} else {
		DevCPM_DeleteNewSym();
	}
	if (__IN(3, m->opts)) {
		CPfrontCPG_CloseFiles();
	}
	DevCPT_Close();
	*error = !DevCPM_noerr;
	if (*error) {
		DevCPM_InsertMarks();
		if (DevCPM_verbose > 0) {
			DevCPM_LogWStr((void*)((CHAR[]){32, 0}), 2);
		}
		if (DevCPM_errors == 1) {
			DevCPM_LogWStr((void*)((CHAR[]){111, 110, 101, 32, 101, 114, 114, 111, 114, 32, 100, 101, 116, 101, \
99, 116, 101, 100, 0}), 19);
		} else {
			DevCPM_LogWNum(DevCPM_errors, 0);
			DevCPM_LogWStr((void*)((CHAR[]){32, 101, 114, 114, 111, 114, 115, 32, 100, 101, 116, 101, 99, 116, \
101, 100, 0}), 17);
		}
		DevCPM_LogWLn();
	} else {
		if (__IN(29, m->opts)) {
			DevCPM_InsertMarks();
		}
	}
	DevCPM_Close();
	p = NIL;
	Kernel_FastCollect();
	__EXIT;
}

static struct CHAR_ARRAY *DswCompilerCPfrontMain_ReadText (DswCompilerCPfrontMain_Elem s)
{
	INTEGER i, len, res;
	DswDocuments_Text text = NIL;
	Files_Locator loc = NIL;
	Files_File f = NIL;
	Files_Reader r = NIL;
	struct SHORTCHAR_ARRAY *ssrc = NIL;
	struct CHAR_ARRAY *src = NIL;
	struct BYTE_ARRAY *x = NIL;
	CHAR num[32];
	INTEGER _for__10;
	__ENTER("DswCompilerCPfrontMain.ReadText");
	src = NIL;
	loc = __Files_Directory_This(Files_dir, (void*)s->dir, 256);
	DswDocuments_Import(loc, s->name, &text, &res);
	Strings_IntToString(res, (void*)num, 32);
	if (res == 0) {
		src = text->t;
	} else if (res == 2) {
		f = __Files_Directory_Old(Files_dir, loc, s->name, 1);
		if (f != NIL) {
			len = __Files_File_Length(f);
			r = __Files_File_NewReader(f, NIL);
			x = __NEWARR(3, len + 1);
			__Files_Reader_ReadBytes(r, (void*)x->data, x->len[0], 0, len);
			ssrc = __NEWARR(1, len + 1);
			_for__10 = len - 1;
			i = 0;
			while (i <= _for__10) {
				(ssrc->data)[__X(i, ssrc->len[0])] = (SHORTCHAR)(x->data)[__X(i, x->len[0])];
				i += 1;
			}
			(ssrc->data)[__X(i, ssrc->len[0])] = 0;
			x = NIL;
			src = __NEWARR(9, len + 1);
			Kernel_Utf8ToString((void*)ssrc->data, ssrc->len[0], (void*)src->data, src->len[0], &res);
			ssrc = NIL;
			__Files_File_Close(f);
		}
	} else {
		if (DevCPM_verbose > 0) {
			Console_WriteStr((void*)((CHAR[]){100, 111, 99, 117, 109, 101, 110, 116, 32, 101, 114, 114, 111, 114, \
32, 0}), 16);
			Console_WriteStr((void*)num, 32);
			Console_WriteLn();
		}
	}
	if (src == NIL) {
		Console_WriteStr((void*)((CHAR[]){117, 110, 97, 98, 108, 101, 32, 116, 111, 32, 111, 112, 101, 110, \
32, 102, 105, 108, 101, 32, 0}), 21);
		Console_WriteStr((void*)s->path, 256);
		Console_WriteLn();
		Kernel_Quit(1);
	}
	__EXIT;
	return (void*)src;
}

static void DswCompilerCPfrontMain_CompileAll (void)
{
	Files_Locator loc = NIL;
	DswCompilerCPfrontMain_Elem m = NIL;
	BOOLEAN error;
	struct CHAR_ARRAY *src = NIL;
	__ENTER("DswCompilerCPfrontMain.CompileAll");
	m = DswCompilerCPfrontMain_u;
	while (m != NIL) {
		if (DevCPM_verbose > 0) {
			Console_WriteStr((void*)((CHAR[]){99, 111, 109, 112, 105, 108, 105, 110, 103, 32, 0}), 11);
			Console_WriteStr((void*)m->path, 256);
			Console_WriteLn();
		}
		src = DswCompilerCPfrontMain_ReadText(m);
		DswCompilerCPfrontMain_Module((void*)src, m, &error);
		if (error) {
			Kernel_Quit(1);
		}
		m = m->next;
	}
	__EXIT;
}

static void DswCompilerCPfrontMain_Init (void)
{
	__ENTER("DswCompilerCPfrontMain.Init");
	if (Kernel_trapCount != 0) {
		Kernel_Quit(1);
	}
	HostFiles_SetRootDir((CHAR*)((CHAR[]){46, 0}), 2);
	DswCompilerCPfrontMain_InitOptions();
	DswCompilerCPfrontMain_CompileAll();
	Kernel_Quit(0);
	__EXIT;
}

static INTEGER DswCompilerCPfrontMain_Elem__rec__flds[] = {
	10, 
	0, 0, 1<<8 | 0x15, (INTEGER)Files_Name__desc,
	0, 512, 5<<8 | 0x15, (INTEGER)Files_Name__desc,
	0, 1024, 10<<8 | 0x15, (INTEGER)Files_Name__desc,
	0, 1536, 15<<8 | 0x15, (INTEGER)Files_Name__desc,
	0, 2048, 22<<8 | 0x15, (INTEGER)Files_Name__desc,
	0, 2560, 30<<8 | 0x15, (INTEGER)DevCPM_Directory__desc,
	0, 2564, 36<<8 | 0x15, 1,
	0, 2568, 42<<8 | 0x15, 9,
	0, 2572, 47<<8 | 0x15, 9,
	0, 2576, 53<<8 | 0x15, (INTEGER)DswCompilerCPfrontMain_Elem__desc,
};
export INTEGER DswCompilerCPfrontMain_Elem__rec__desc[] = {
	-1, 
	0, 
	2580,
	(INTEGER)&DswCompilerCPfrontMain__desc,
	58<<8 | 0x01,
	(INTEGER)(DswCompilerCPfrontMain_Elem__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)DswCompilerCPfrontMain_Elem__rec__flds, 
	2560, 2576, -12
};
export INTEGER DswCompilerCPfrontMain_Elem__desc[] = {
	0,
	(INTEGER)&DswCompilerCPfrontMain__desc,
	64<<8 | 0x03,
	(INTEGER)(DswCompilerCPfrontMain_Elem__rec__desc + 2)
};
static SYSTEM_MODDESC *DswCompilerCPfrontMain__imp[] = {
	&Console__desc,
	&DevCPB__desc,
	&DevCPE__desc,
	&CPfrontCPG__desc,
	&DevCPH__desc,
	&DevCPM__desc,
	&DevCPP__desc,
	&DevCPT__desc,
	&CPfrontCPV__desc,
	&DswDocuments__desc,
	&Files__desc,
	&HostFiles__desc,
	&Kernel__desc,
	&Strings__desc,
};
static INTEGER DswCompilerCPfrontMain__exp[] = {
	8,
	0x227d6f36, (INTEGER)DswCompilerCPfrontMain_CompileAll, 69<<8 | 0x14, 0,
	0xdf79fcba, 0x86e15bef, 58<<8 | 0x12, (INTEGER)(DswCompilerCPfrontMain_Elem__rec__desc + 2),
	0x227d6f36, (INTEGER)DswCompilerCPfrontMain_GetPath, 80<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)DswCompilerCPfrontMain_Init, 88<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DswCompilerCPfrontMain_InitOptions, 93<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DswCompilerCPfrontMain_Module, 105<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)DswCompilerCPfrontMain_ReadText, 112<<8 | 0x14, 0,
	0xab6a0365, (INTEGER)&DswCompilerCPfrontMain_u, 121<<8 | 0x13, (INTEGER)DswCompilerCPfrontMain_Elem__desc,
};
static char DswCompilerCPfrontMain__names[] = {
	0,
	'd','i','r',0,
	'n','a','m','e',0,
	'p','a','t','h',0,
	'o','u','t','s','y','m',0,
	'o','u','t','c','o','d','e',0,
	'i','n','s','y','m',0,
	'f','o','u','n','d',0,
	'o','p','t','s',0,
	'o','p','t','s','2',0,
	'n','e','x','t',0,
	'E','l','e','m','^',0,
	'E','l','e','m',0,
	'C','o','m','p','i','l','e','A','l','l',0,
	'G','e','t','P','a','t','h',0,
	'I','n','i','t',0,
	'I','n','i','t','O','p','t','i','o','n','s',0,
	'M','o','d','u','l','e',0,
	'R','e','a','d','T','e','x','t',0,
	'u',0,
};
static INTEGER DswCompilerCPfrontMain__ptrs[] = {
	(INTEGER)&DswCompilerCPfrontMain_u + 0, 
};
struct SYSTEM_MODDESC DswCompilerCPfrontMain__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 20}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	DswCompilerCPfrontMain__body,
	0,
	14, /* nofimps */ 
	1, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	DswCompilerCPfrontMain__names,
	DswCompilerCPfrontMain__ptrs,
	DswCompilerCPfrontMain__imp,
	(SYSTEM_DIRECTORY*)DswCompilerCPfrontMain__exp,
	"DswCompilerCPfrontMain"
};

export void DswCompilerCPfrontMain__reg()
{
	__BEGREG(DswCompilerCPfrontMain__desc);
	Kernel__reg();
	HostFiles__reg();
	Files__reg();
	Console__reg();
	Strings__reg();
	DswDocuments__reg();
	DevCPM__reg();
	DevCPT__reg();
	DevCPB__reg();
	DevCPP__reg();
	DevCPE__reg();
	DevCPH__reg();
	CPfrontCPV__reg();
	CPfrontCPG__reg();
	__REGMOD(DswCompilerCPfrontMain__desc);
	__ENDREG;
}

export void DswCompilerCPfrontMain__body()
{
	__BEGBODY(DswCompilerCPfrontMain__desc);
	Kernel__body();
	HostFiles__body();
	Files__body();
	Console__body();
	Strings__body();
	DswDocuments__body();
	DevCPM__body();
	DevCPT__body();
	DevCPB__body();
	DevCPP__body();
	DevCPE__body();
	DevCPH__body();
	CPfrontCPV__body();
	CPfrontCPG__body();
	Kernel_Start(DswCompilerCPfrontMain_Init);
	__ENDBODY;
}
