/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"

struct Files__2 {
	INTEGER year, month, day, hour, minute, second;
};

typedef
	struct Files_Directory__rec *Files_Directory;

typedef
	struct Files_Directory__rec {
		char _prvt0[1];
	} Files_Directory__rec;

typedef
	struct Files_Locator__rec *Files_Locator;

typedef
	CHAR Files_Name[256];

export void Files_Directory_Delete (Files_Directory d, Files_Locator loc, Files_Name name);
typedef
	struct Files_FileInfo__rec *Files_FileInfo;

export Files_FileInfo Files_Directory_FileList (Files_Directory d, Files_Locator loc);
typedef
	CHAR Files_Type[16];

export void Files_Directory_GetFileName (Files_Directory d, Files_Name name, Files_Type type, Files_Name \
filename);
typedef
	struct Files_LocInfo__rec *Files_LocInfo;

export Files_LocInfo Files_Directory_LocList (Files_Directory d, Files_Locator loc);
typedef
	struct Files_File__rec *Files_File;

export Files_File Files_Directory_New (Files_Directory d, Files_Locator loc, BOOLEAN ask);
export Files_File Files_Directory_Old (Files_Directory d, Files_Locator loc, Files_Name name, BOOLEAN \
shared);
export void Files_Directory_Rename (Files_Directory d, Files_Locator loc, Files_Name old, Files_Name new, \
BOOLEAN ask);
export BOOLEAN Files_Directory_SameFile (Files_Directory d, Files_Locator loc0, Files_Name name0, Files_Locator \
loc1, Files_Name name1);
export Files_File Files_Directory_Temp (Files_Directory d);
export Files_Locator Files_Directory_This (Files_Directory d, CHAR *path, INTEGER path__len);
#define __Files_Directory_Delete(d, loc, name) __SEND(__TYPEOF(d), 1, void(*)(Files_Directory, Files_Locator, \
Files_Name), (d, loc, name))
#define __Files_Directory_FileList(d, loc) __SEND(__TYPEOF(d), 2, Files_FileInfo(*)(Files_Directory, Files_Locator), \
(d, loc))
#define __Files_Directory_GetFileName(d, name, type, filename) __SEND(__TYPEOF(d), 3, void(*)(Files_Directory, \
Files_Name, Files_Type, Files_Name), (d, name, type, filename))
#define __Files_Directory_LocList(d, loc) __SEND(__TYPEOF(d), 4, Files_LocInfo(*)(Files_Directory, Files_Locator), \
(d, loc))
#define __Files_Directory_New(d, loc, ask) __SEND(__TYPEOF(d), 5, Files_File(*)(Files_Directory, Files_Locator, \
BOOLEAN), (d, loc, ask))
#define __Files_Directory_Old(d, loc, name, shared) __SEND(__TYPEOF(d), 6, Files_File(*)(Files_Directory, \
Files_Locator, Files_Name, BOOLEAN), (d, loc, name, shared))
#define __Files_Directory_Rename(d, loc, old, new, ask) __SEND(__TYPEOF(d), 7, void(*)(Files_Directory, \
Files_Locator, Files_Name, Files_Name, BOOLEAN), (d, loc, old, new, ask))
#define __Files_Directory_SameFile(d, loc0, name0, loc1, name1) __SEND(__TYPEOF(d), 8, BOOLEAN(*)(Files_Directory, \
Files_Locator, Files_Name, Files_Locator, Files_Name), (d, loc0, name0, loc1, name1))
#define __Files_Directory_Temp(d) __SEND(__TYPEOF(d), 9, Files_File(*)(Files_Directory), (d))
#define __Files_Directory_This(d, path, path__len) __SEND(__TYPEOF(d), 10, Files_Locator(*)(Files_Directory, \
CHAR*, INTEGER ), (d, path, path__len))

typedef
	struct Files_FileInfo__rec {
		Files_FileInfo next;
		Files_Name name;
		INTEGER length;
		Files_Type type;
		struct Files__2 modified;
		SET attr;
	} Files_FileInfo__rec;

typedef
	struct Files_File__rec {
		Files_Type type;
		BOOLEAN init;
	} Files_File__rec;

export void Files_File_Close (Files_File f);
export BOOLEAN Files_File_Closed (Files_File f);
export void Files_File_Flush (Files_File f);
export void Files_File_InitType (Files_File f, Files_Type type);
export INTEGER Files_File_Length (Files_File f);
typedef
	struct Files_Reader__rec *Files_Reader;

export Files_Reader Files_File_NewReader (Files_File f, Files_Reader old);
typedef
	struct Files_Writer__rec *Files_Writer;

export Files_Writer Files_File_NewWriter (Files_File f, Files_Writer old);
export void Files_File_Register (Files_File f, Files_Name name, Files_Type type, BOOLEAN ask, INTEGER \
*res);
export BOOLEAN Files_File_Shared (Files_File f);
#define __Files_File_Close(f) __SEND(__TYPEOF(f), 1, void(*)(Files_File), (f))
#define __Files_File_Closed(f) __SEND(__TYPEOF(f), 2, BOOLEAN(*)(Files_File), (f))
#define __Files_File_Flush(f) __SEND(__TYPEOF(f), 3, void(*)(Files_File), (f))
#define __Files_File_InitType(f, type) __SEND(__TYPEOF(f), 4, void(*)(Files_File, Files_Type), (f, type))
#define __Files_File_Length(f) __SEND(__TYPEOF(f), 5, INTEGER(*)(Files_File), (f))
#define __Files_File_NewReader(f, old) __SEND(__TYPEOF(f), 6, Files_Reader(*)(Files_File, Files_Reader), \
(f, old))
#define __Files_File_NewWriter(f, old) __SEND(__TYPEOF(f), 7, Files_Writer(*)(Files_File, Files_Writer), \
(f, old))
#define __Files_File_Register(f, name, type, ask, res) __SEND(__TYPEOF(f), 8, void(*)(Files_File, Files_Name, \
Files_Type, BOOLEAN, INTEGER*), (f, name, type, ask, res))
#define __Files_File_Shared(f) __SEND(__TYPEOF(f), 9, BOOLEAN(*)(Files_File), (f))

typedef
	struct Files_LocInfo__rec {
		Files_LocInfo next;
		Files_Name name;
		SET attr;
	} Files_LocInfo__rec;

typedef
	struct Files_Locator__rec {
		INTEGER res;
	} Files_Locator__rec;

export Files_Locator Files_Locator_This (Files_Locator l, CHAR *path, INTEGER path__len);
#define __Files_Locator_This(l, path, path__len) __SEND(__TYPEOF(l), 1, Files_Locator(*)(Files_Locator, \
CHAR*, INTEGER ), (l, path, path__len))

typedef
	struct Files_Reader__rec {
		BOOLEAN eof;
	} Files_Reader__rec;

export Files_File Files_Reader_Base (Files_Reader r);
export INTEGER Files_Reader_Pos (Files_Reader r);
export void Files_Reader_ReadByte (Files_Reader r, BYTE *x);
export void Files_Reader_ReadBytes (Files_Reader r, BYTE *x, INTEGER x__len, INTEGER beg, INTEGER len);
export void Files_Reader_SetPos (Files_Reader r, INTEGER pos);
#define __Files_Reader_Base(r) __SEND(__TYPEOF(r), 1, Files_File(*)(Files_Reader), (r))
#define __Files_Reader_Pos(r) __SEND(__TYPEOF(r), 2, INTEGER(*)(Files_Reader), (r))
#define __Files_Reader_ReadByte(r, x) __SEND(__TYPEOF(r), 3, void(*)(Files_Reader, BYTE*), (r, x))
#define __Files_Reader_ReadBytes(r, x, x__len, beg, len) __SEND(__TYPEOF(r), 4, void(*)(Files_Reader, \
BYTE*, INTEGER , INTEGER, INTEGER), (r, x, x__len, beg, len))
#define __Files_Reader_SetPos(r, pos) __SEND(__TYPEOF(r), 5, void(*)(Files_Reader, INTEGER), (r, pos))

typedef
	struct Files_Writer__rec {
		char _prvt0[1];
	} Files_Writer__rec;

export Files_File Files_Writer_Base (Files_Writer w);
export INTEGER Files_Writer_Pos (Files_Writer w);
export void Files_Writer_SetPos (Files_Writer w, INTEGER pos);
export void Files_Writer_WriteByte (Files_Writer w, BYTE x);
export void Files_Writer_WriteBytes (Files_Writer w, BYTE *x, INTEGER x__len, INTEGER beg, INTEGER len);
#define __Files_Writer_Base(w) __SEND(__TYPEOF(w), 1, Files_File(*)(Files_Writer), (w))
#define __Files_Writer_Pos(w) __SEND(__TYPEOF(w), 2, INTEGER(*)(Files_Writer), (w))
#define __Files_Writer_SetPos(w, pos) __SEND(__TYPEOF(w), 3, void(*)(Files_Writer, INTEGER), (w, pos))
#define __Files_Writer_WriteByte(w, x) __SEND(__TYPEOF(w), 4, void(*)(Files_Writer, BYTE), (w, x))
#define __Files_Writer_WriteBytes(w, x, x__len, beg, len) __SEND(__TYPEOF(w), 5, void(*)(Files_Writer, \
BYTE*, INTEGER , INTEGER, INTEGER), (w, x, x__len, beg, len))


export Files_Directory Files_dir, Files_stdDir;
export Files_Type Files_objType, Files_symType, Files_docType;

export INTEGER Files__2__desc[];
export SYSTEM_TYPEDESC *Files__2__typ = (SYSTEM_TYPEDESC*)(Files__2__desc + 2);
export INTEGER Files_FileInfo__rec__desc[];
export SYSTEM_TYPEDESC *Files_FileInfo__rec__typ = (SYSTEM_TYPEDESC*)(Files_FileInfo__rec__desc + 2);
export INTEGER Files_FileInfo__desc[];
export SYSTEM_TYPEDESC *Files_FileInfo__typ = (SYSTEM_TYPEDESC*)Files_FileInfo__desc;
export INTEGER Files_Name__desc[];
export SYSTEM_TYPEDESC *Files_Name__typ = (SYSTEM_TYPEDESC*)Files_Name__desc;
export INTEGER Files_Type__desc[];
export SYSTEM_TYPEDESC *Files_Type__typ = (SYSTEM_TYPEDESC*)Files_Type__desc;
export INTEGER Files_LocInfo__rec__desc[];
export SYSTEM_TYPEDESC *Files_LocInfo__rec__typ = (SYSTEM_TYPEDESC*)(Files_LocInfo__rec__desc + 2);
export INTEGER Files_LocInfo__desc[];
export SYSTEM_TYPEDESC *Files_LocInfo__typ = (SYSTEM_TYPEDESC*)Files_LocInfo__desc;
export INTEGER Files_Locator__rec__desc[];
export SYSTEM_TYPEDESC *Files_Locator__rec__typ = (SYSTEM_TYPEDESC*)(Files_Locator__rec__desc + 3);
export INTEGER Files_File__rec__desc[];
export SYSTEM_TYPEDESC *Files_File__rec__typ = (SYSTEM_TYPEDESC*)(Files_File__rec__desc + 11);
export INTEGER Files_Reader__rec__desc[];
export SYSTEM_TYPEDESC *Files_Reader__rec__typ = (SYSTEM_TYPEDESC*)(Files_Reader__rec__desc + 7);
export INTEGER Files_Writer__rec__desc[];
export SYSTEM_TYPEDESC *Files_Writer__rec__typ = (SYSTEM_TYPEDESC*)(Files_Writer__rec__desc + 7);
export INTEGER Files_Directory__rec__desc[];
export SYSTEM_TYPEDESC *Files_Directory__rec__typ = (SYSTEM_TYPEDESC*)(Files_Directory__rec__desc + 12);
export INTEGER Files_Directory__desc[];
export SYSTEM_TYPEDESC *Files_Directory__typ = (SYSTEM_TYPEDESC*)Files_Directory__desc;
export INTEGER Files_File__desc[];
export SYSTEM_TYPEDESC *Files_File__typ = (SYSTEM_TYPEDESC*)Files_File__desc;
export INTEGER Files_Locator__desc[];
export SYSTEM_TYPEDESC *Files_Locator__typ = (SYSTEM_TYPEDESC*)Files_Locator__desc;
export INTEGER Files_Reader__desc[];
export SYSTEM_TYPEDESC *Files_Reader__typ = (SYSTEM_TYPEDESC*)Files_Reader__desc;
export INTEGER Files_Writer__desc[];
export SYSTEM_TYPEDESC *Files_Writer__typ = (SYSTEM_TYPEDESC*)Files_Writer__desc;

export void Files_SetDir (Files_Directory d);

export void Files__reg();
export void Files__body();
export struct SYSTEM_MODDESC Files__desc;


void Files_File_InitType (Files_File f, Files_Type type)
{
	Files_Type type__copy;
	__ENTER("Files.File.InitType");
	__DUPARR(type);
	__ASSERT(!f->init, 20);
	__STRCOPYLL(type, f->type, 16);
	f->init = 1;
	__EXIT;
}

void Files_SetDir (Files_Directory d)
{
	__ENTER("Files.SetDir");
	__ASSERT(d != NIL, 20);
	Files_dir = d;
	if (Files_stdDir == NIL) {
		Files_stdDir = d;
	}
	__EXIT;
}

static INTEGER Files__2__flds[] = {
	6, 
	0, 0, 1<<8 | 0x45, 6,
	0, 4, 6<<8 | 0x45, 6,
	0, 8, 12<<8 | 0x45, 6,
	0, 12, 16<<8 | 0x45, 6,
	0, 16, 21<<8 | 0x45, 6,
	0, 20, 28<<8 | 0x45, 6,
};
export INTEGER Files__2__desc[] = {
	-1, 
	0, 
	24,
	(INTEGER)&Files__desc,
	0<<8 | 0x01,
	(INTEGER)(Files__2__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Files__2__flds, 
	-4
};
static INTEGER Files_FileInfo__rec__flds[] = {
	6, 
	0, 0, 35<<8 | 0x45, (INTEGER)Files_FileInfo__desc,
	0, 4, 40<<8 | 0x45, (INTEGER)Files_Name__desc,
	0, 516, 45<<8 | 0x45, 6,
	0, 520, 52<<8 | 0x45, (INTEGER)Files_Type__desc,
	0, 552, 57<<8 | 0x45, (INTEGER)(Files__2__desc + 2),
	0, 576, 66<<8 | 0x45, 9,
};
export INTEGER Files_FileInfo__rec__desc[] = {
	-1, 
	0, 
	580,
	(INTEGER)&Files__desc,
	71<<8 | 0x01,
	(INTEGER)(Files_FileInfo__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Files_FileInfo__rec__flds, 
	0, -8
};
export INTEGER Files_FileInfo__desc[] = {
	0,
	(INTEGER)&Files__desc,
	81<<8 | 0x03,
	(INTEGER)(Files_FileInfo__rec__desc + 2)
};
export INTEGER Files_Name__desc[] = {
	256,
	(INTEGER)&Files__desc,
	90<<8 | 0x02,
	3
};
export INTEGER Files_Type__desc[] = {
	16,
	(INTEGER)&Files__desc,
	95<<8 | 0x02,
	3
};
static INTEGER Files_LocInfo__rec__flds[] = {
	3, 
	0, 0, 35<<8 | 0x45, (INTEGER)Files_LocInfo__desc,
	0, 4, 40<<8 | 0x45, (INTEGER)Files_Name__desc,
	0, 516, 66<<8 | 0x45, 9,
};
export INTEGER Files_LocInfo__rec__desc[] = {
	-1, 
	0, 
	520,
	(INTEGER)&Files__desc,
	100<<8 | 0x01,
	(INTEGER)(Files_LocInfo__rec__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Files_LocInfo__rec__flds, 
	0, -8
};
export INTEGER Files_LocInfo__desc[] = {
	0,
	(INTEGER)&Files__desc,
	109<<8 | 0x03,
	(INTEGER)(Files_LocInfo__rec__desc + 2)
};
static INTEGER Files_Locator__rec__flds[] = {
	1, 
	0, 0, 117<<8 | 0x45, 6,
};
export INTEGER Files_Locator__rec__desc[] = {
	-1, 
	0, 
	0, 
	4,
	(INTEGER)&Files__desc,
	121<<8 | 0x0d,
	(INTEGER)(Files_Locator__rec__desc + 3),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Files_Locator__rec__flds, 
	-4
};
static INTEGER Files_File__rec__flds[] = {
	2, 
	0, 0, 52<<8 | 0x25, (INTEGER)Files_Type__desc,
	0, 32, 130<<8 | 0x15, 1,
};
export INTEGER Files_File__rec__desc[] = {
	-1, 
	0, 
	0, 
	0, 
	0, 
	0, 
	(INTEGER)Files_File_InitType, 
	0, 
	0, 
	0, 
	0, 
	34,
	(INTEGER)&Files__desc,
	135<<8 | 0x0d,
	(INTEGER)(Files_File__rec__desc + 11),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Files_File__rec__flds, 
	-4
};
static INTEGER Files_Reader__rec__flds[] = {
	1, 
	0, 0, 141<<8 | 0x45, 1,
};
export INTEGER Files_Reader__rec__desc[] = {
	-1, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	1,
	(INTEGER)&Files__desc,
	145<<8 | 0x0d,
	(INTEGER)(Files_Reader__rec__desc + 7),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Files_Reader__rec__flds, 
	-4
};
static INTEGER Files_Writer__rec__flds[] = {
	0, 
};
export INTEGER Files_Writer__rec__desc[] = {
	-1, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	1,
	(INTEGER)&Files__desc,
	153<<8 | 0x0d,
	(INTEGER)(Files_Writer__rec__desc + 7),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Files_Writer__rec__flds, 
	-4
};
static INTEGER Files_Directory__rec__flds[] = {
	0, 
};
export INTEGER Files_Directory__rec__desc[] = {
	-1, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	0, 
	1,
	(INTEGER)&Files__desc,
	161<<8 | 0x0d,
	(INTEGER)(Files_Directory__rec__desc + 12),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Files_Directory__rec__flds, 
	-4
};
export INTEGER Files_Directory__desc[] = {
	0,
	(INTEGER)&Files__desc,
	172<<8 | 0x03,
	(INTEGER)(Files_Directory__rec__desc + 12)
};
export INTEGER Files_File__desc[] = {
	0,
	(INTEGER)&Files__desc,
	182<<8 | 0x03,
	(INTEGER)(Files_File__rec__desc + 11)
};
export INTEGER Files_Locator__desc[] = {
	0,
	(INTEGER)&Files__desc,
	187<<8 | 0x03,
	(INTEGER)(Files_Locator__rec__desc + 3)
};
export INTEGER Files_Reader__desc[] = {
	0,
	(INTEGER)&Files__desc,
	195<<8 | 0x03,
	(INTEGER)(Files_Reader__rec__desc + 7)
};
export INTEGER Files_Writer__desc[] = {
	0,
	(INTEGER)&Files__desc,
	202<<8 | 0x03,
	(INTEGER)(Files_Writer__rec__desc + 7)
};
static SYSTEM_MODDESC *Files__imp[] = {
	&Kernel__desc,
};
static INTEGER Files__exp[] = {
	31,
	0x57e542ab, 0x57e542ab, 172<<8 | 0x42, (INTEGER)Files_Directory__desc,
	0x31ad93ae, 0xe58af4f7, 161<<8 | 0x12, (INTEGER)(Files_Directory__rec__desc + 12),
	0x4e7e73e7, 0x4e7e73e7, 182<<8 | 0x42, (INTEGER)Files_File__desc,
	0x5923c0ef, 0x5923c0ef, 81<<8 | 0x42, (INTEGER)Files_FileInfo__desc,
	0xa21533c2, 0x1a3ff08d, 71<<8 | 0x12, (INTEGER)(Files_FileInfo__rec__desc + 2),
	0xeb81559d, 0xbc9430f5, 135<<8 | 0x12, (INTEGER)(Files_File__rec__desc + 11),
	0xeb9afe8b, 0xeb9afe8b, 109<<8 | 0x42, (INTEGER)Files_LocInfo__desc,
	0x38abe1f7, 0x9df5607f, 100<<8 | 0x12, (INTEGER)(Files_LocInfo__rec__desc + 2),
	0x1f8680d9, 0x1f8680d9, 187<<8 | 0x42, (INTEGER)Files_Locator__desc,
	0xe322afcf, 0x329c758d, 121<<8 | 0x12, (INTEGER)(Files_Locator__rec__desc + 3),
	0x2e1fad24, 0x2e1fad24, 90<<8 | 0x42, (INTEGER)Files_Name__desc,
	0x858db690, 0x858db690, 195<<8 | 0x42, (INTEGER)Files_Reader__desc,
	0x382f12f1, 0x5a3bfd11, 145<<8 | 0x12, (INTEGER)(Files_Reader__rec__desc + 7),
	0x5462340a, (INTEGER)Files_SetDir, 209<<8 | 0x44, 0,
	0x76a44bb6, 0x76a44bb6, 95<<8 | 0x42, (INTEGER)Files_Type__desc,
	0x5678edb7, 0x5678edb7, 202<<8 | 0x42, (INTEGER)Files_Writer__desc,
	0xaf276d47, 0x8378c45a, 153<<8 | 0x12, (INTEGER)(Files_Writer__rec__desc + 7),
	0x5b0e2283, 0, 216<<8 | 0x41, 0,
	0x72789a6e, 0, 224<<8 | 0x41, 0,
	0x30fe0e28, (INTEGER)&Files_dir, 228<<8 | 0x23, (INTEGER)Files_Directory__desc,
	0x54048004, (INTEGER)&Files_docType, 232<<8 | 0x23, (INTEGER)Files_Type__desc,
	0x76b987d9, 0, 240<<8 | 0x41, 0,
	0x76b987d9, 0, 248<<8 | 0x41, 0,
	0x528c19ed, 0, 258<<8 | 0x41, 0,
	0x54048004, (INTEGER)&Files_objType, 265<<8 | 0x23, (INTEGER)Files_Type__desc,
	0x564d045a, 0, 273<<8 | 0x41, 0,
	0x72789a6e, 0, 282<<8 | 0x41, 0,
	0x45497286, 0, 289<<8 | 0x41, 0,
	0x30fe0e28, (INTEGER)&Files_stdDir, 300<<8 | 0x23, (INTEGER)Files_Directory__desc,
	0x54048004, (INTEGER)&Files_symType, 307<<8 | 0x23, (INTEGER)Files_Type__desc,
	0x5fcf3f34, 0, 315<<8 | 0x41, 0,
};
static char Files__names[] = {
	0,
	'y','e','a','r',0,
	'm','o','n','t','h',0,
	'd','a','y',0,
	'h','o','u','r',0,
	'm','i','n','u','t','e',0,
	's','e','c','o','n','d',0,
	'n','e','x','t',0,
	'n','a','m','e',0,
	'l','e','n','g','t','h',0,
	't','y','p','e',0,
	'm','o','d','i','f','i','e','d',0,
	'a','t','t','r',0,
	'F','i','l','e','I','n','f','o','^',0,
	'F','i','l','e','I','n','f','o',0,
	'N','a','m','e',0,
	'T','y','p','e',0,
	'L','o','c','I','n','f','o','^',0,
	'L','o','c','I','n','f','o',0,
	'r','e','s',0,
	'L','o','c','a','t','o','r','^',0,
	'i','n','i','t',0,
	'F','i','l','e','^',0,
	'e','o','f',0,
	'R','e','a','d','e','r','^',0,
	'W','r','i','t','e','r','^',0,
	'D','i','r','e','c','t','o','r','y','^',0,
	'D','i','r','e','c','t','o','r','y',0,
	'F','i','l','e',0,
	'L','o','c','a','t','o','r',0,
	'R','e','a','d','e','r',0,
	'W','r','i','t','e','r',0,
	'S','e','t','D','i','r',0,
	'a','r','c','h','i','v','e',0,
	'a','s','k',0,
	'd','i','r',0,
	'd','o','c','T','y','p','e',0,
	'd','o','n','t','A','s','k',0,
	'e','x','c','l','u','s','i','v','e',0,
	'h','i','d','d','e','n',0,
	'o','b','j','T','y','p','e',0,
	'r','e','a','d','O','n','l','y',0,
	's','h','a','r','e','d',0,
	's','t','a','t','i','o','n','e','r','y',0,
	's','t','d','D','i','r',0,
	's','y','m','T','y','p','e',0,
	's','y','s','t','e','m',0,
};
static INTEGER Files__ptrs[] = {
	(INTEGER)&Files_dir + 0, 
	(INTEGER)&Files_stdDir + 0, 
};
struct SYSTEM_MODDESC Files__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 0}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Files__body,
	0,
	1, /* nofimps */ 
	2, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Files__names,
	Files__ptrs,
	Files__imp,
	(SYSTEM_DIRECTORY*)Files__exp,
	"Files"
};

export void Files__reg()
{
	__BEGREG(Files__desc);
	Kernel__reg();
	__REGMOD(Files__desc);
	__ENDREG;
}

export void Files__body()
{
	__BEGBODY(Files__desc);
	Kernel__body();
	__MOVE(((CHAR[]){111, 99, 102, 0}), Files_objType, 8);
	__MOVE(((CHAR[]){111, 115, 102, 0}), Files_symType, 8);
	__MOVE(((CHAR[]){111, 100, 99, 0}), Files_docType, 8);
	__ENDBODY;
}
