/*  CPfront 1.0 -48 */

#ifndef Files__h
#define Files__h

#include "SYSTEM.h"

struct Files__2 {
	INTEGER year, month, day, hour, minute, second;
};

typedef
	struct Files_Directory__rec *Files_Directory;

typedef
	struct Files_Directory__rec {
		char _prvt0[1];
	} Files_Directory__rec;

typedef
	struct Files_Locator__rec *Files_Locator;

typedef
	CHAR Files_Name[256];

import void Files_Directory_Delete (Files_Directory d, Files_Locator loc, Files_Name name);
typedef
	struct Files_FileInfo__rec *Files_FileInfo;

import Files_FileInfo Files_Directory_FileList (Files_Directory d, Files_Locator loc);
typedef
	CHAR Files_Type[16];

import void Files_Directory_GetFileName (Files_Directory d, Files_Name name, Files_Type type, Files_Name \
filename);
typedef
	struct Files_LocInfo__rec *Files_LocInfo;

import Files_LocInfo Files_Directory_LocList (Files_Directory d, Files_Locator loc);
typedef
	struct Files_File__rec *Files_File;

import Files_File Files_Directory_New (Files_Directory d, Files_Locator loc, BOOLEAN ask);
import Files_File Files_Directory_Old (Files_Directory d, Files_Locator loc, Files_Name name, BOOLEAN \
shared);
import void Files_Directory_Rename (Files_Directory d, Files_Locator loc, Files_Name old, Files_Name new, \
BOOLEAN ask);
import BOOLEAN Files_Directory_SameFile (Files_Directory d, Files_Locator loc0, Files_Name name0, Files_Locator \
loc1, Files_Name name1);
import Files_File Files_Directory_Temp (Files_Directory d);
import Files_Locator Files_Directory_This (Files_Directory d, CHAR *path, INTEGER path__len);
#define __Files_Directory_Delete(d, loc, name) __SEND(__TYPEOF(d), 1, void(*)(Files_Directory, Files_Locator, \
Files_Name), (d, loc, name))
#define __Files_Directory_FileList(d, loc) __SEND(__TYPEOF(d), 2, Files_FileInfo(*)(Files_Directory, Files_Locator), \
(d, loc))
#define __Files_Directory_GetFileName(d, name, type, filename) __SEND(__TYPEOF(d), 3, void(*)(Files_Directory, \
Files_Name, Files_Type, Files_Name), (d, name, type, filename))
#define __Files_Directory_LocList(d, loc) __SEND(__TYPEOF(d), 4, Files_LocInfo(*)(Files_Directory, Files_Locator), \
(d, loc))
#define __Files_Directory_New(d, loc, ask) __SEND(__TYPEOF(d), 5, Files_File(*)(Files_Directory, Files_Locator, \
BOOLEAN), (d, loc, ask))
#define __Files_Directory_Old(d, loc, name, shared) __SEND(__TYPEOF(d), 6, Files_File(*)(Files_Directory, \
Files_Locator, Files_Name, BOOLEAN), (d, loc, name, shared))
#define __Files_Directory_Rename(d, loc, old, new, ask) __SEND(__TYPEOF(d), 7, void(*)(Files_Directory, \
Files_Locator, Files_Name, Files_Name, BOOLEAN), (d, loc, old, new, ask))
#define __Files_Directory_SameFile(d, loc0, name0, loc1, name1) __SEND(__TYPEOF(d), 8, BOOLEAN(*)(Files_Directory, \
Files_Locator, Files_Name, Files_Locator, Files_Name), (d, loc0, name0, loc1, name1))
#define __Files_Directory_Temp(d) __SEND(__TYPEOF(d), 9, Files_File(*)(Files_Directory), (d))
#define __Files_Directory_This(d, path, path__len) __SEND(__TYPEOF(d), 10, Files_Locator(*)(Files_Directory, \
CHAR*, INTEGER ), (d, path, path__len))

typedef
	struct Files_FileInfo__rec {
		Files_FileInfo next;
		Files_Name name;
		INTEGER length;
		Files_Type type;
		struct Files__2 modified;
		SET attr;
	} Files_FileInfo__rec;

typedef
	struct Files_File__rec {
		Files_Type type;
		char _prvt0[1];
	} Files_File__rec;

import void Files_File_Close (Files_File f);
import BOOLEAN Files_File_Closed (Files_File f);
import void Files_File_Flush (Files_File f);
import void Files_File_InitType (Files_File f, Files_Type type);
import INTEGER Files_File_Length (Files_File f);
typedef
	struct Files_Reader__rec *Files_Reader;

import Files_Reader Files_File_NewReader (Files_File f, Files_Reader old);
typedef
	struct Files_Writer__rec *Files_Writer;

import Files_Writer Files_File_NewWriter (Files_File f, Files_Writer old);
import void Files_File_Register (Files_File f, Files_Name name, Files_Type type, BOOLEAN ask, INTEGER \
*res);
import BOOLEAN Files_File_Shared (Files_File f);
#define __Files_File_Close(f) __SEND(__TYPEOF(f), 1, void(*)(Files_File), (f))
#define __Files_File_Closed(f) __SEND(__TYPEOF(f), 2, BOOLEAN(*)(Files_File), (f))
#define __Files_File_Flush(f) __SEND(__TYPEOF(f), 3, void(*)(Files_File), (f))
#define __Files_File_InitType(f, type) __SEND(__TYPEOF(f), 4, void(*)(Files_File, Files_Type), (f, type))
#define __Files_File_Length(f) __SEND(__TYPEOF(f), 5, INTEGER(*)(Files_File), (f))
#define __Files_File_NewReader(f, old) __SEND(__TYPEOF(f), 6, Files_Reader(*)(Files_File, Files_Reader), \
(f, old))
#define __Files_File_NewWriter(f, old) __SEND(__TYPEOF(f), 7, Files_Writer(*)(Files_File, Files_Writer), \
(f, old))
#define __Files_File_Register(f, name, type, ask, res) __SEND(__TYPEOF(f), 8, void(*)(Files_File, Files_Name, \
Files_Type, BOOLEAN, INTEGER*), (f, name, type, ask, res))
#define __Files_File_Shared(f) __SEND(__TYPEOF(f), 9, BOOLEAN(*)(Files_File), (f))

typedef
	struct Files_LocInfo__rec {
		Files_LocInfo next;
		Files_Name name;
		SET attr;
	} Files_LocInfo__rec;

typedef
	struct Files_Locator__rec {
		INTEGER res;
	} Files_Locator__rec;

import Files_Locator Files_Locator_This (Files_Locator l, CHAR *path, INTEGER path__len);
#define __Files_Locator_This(l, path, path__len) __SEND(__TYPEOF(l), 1, Files_Locator(*)(Files_Locator, \
CHAR*, INTEGER ), (l, path, path__len))

typedef
	struct Files_Reader__rec {
		BOOLEAN eof;
	} Files_Reader__rec;

import Files_File Files_Reader_Base (Files_Reader r);
import INTEGER Files_Reader_Pos (Files_Reader r);
import void Files_Reader_ReadByte (Files_Reader r, BYTE *x);
import void Files_Reader_ReadBytes (Files_Reader r, BYTE *x, INTEGER x__len, INTEGER beg, INTEGER len);
import void Files_Reader_SetPos (Files_Reader r, INTEGER pos);
#define __Files_Reader_Base(r) __SEND(__TYPEOF(r), 1, Files_File(*)(Files_Reader), (r))
#define __Files_Reader_Pos(r) __SEND(__TYPEOF(r), 2, INTEGER(*)(Files_Reader), (r))
#define __Files_Reader_ReadByte(r, x) __SEND(__TYPEOF(r), 3, void(*)(Files_Reader, BYTE*), (r, x))
#define __Files_Reader_ReadBytes(r, x, x__len, beg, len) __SEND(__TYPEOF(r), 4, void(*)(Files_Reader, \
BYTE*, INTEGER , INTEGER, INTEGER), (r, x, x__len, beg, len))
#define __Files_Reader_SetPos(r, pos) __SEND(__TYPEOF(r), 5, void(*)(Files_Reader, INTEGER), (r, pos))

typedef
	struct Files_Writer__rec {
		char _prvt0[1];
	} Files_Writer__rec;

import Files_File Files_Writer_Base (Files_Writer w);
import INTEGER Files_Writer_Pos (Files_Writer w);
import void Files_Writer_SetPos (Files_Writer w, INTEGER pos);
import void Files_Writer_WriteByte (Files_Writer w, BYTE x);
import void Files_Writer_WriteBytes (Files_Writer w, BYTE *x, INTEGER x__len, INTEGER beg, INTEGER len);
#define __Files_Writer_Base(w) __SEND(__TYPEOF(w), 1, Files_File(*)(Files_Writer), (w))
#define __Files_Writer_Pos(w) __SEND(__TYPEOF(w), 2, INTEGER(*)(Files_Writer), (w))
#define __Files_Writer_SetPos(w, pos) __SEND(__TYPEOF(w), 3, void(*)(Files_Writer, INTEGER), (w, pos))
#define __Files_Writer_WriteByte(w, x) __SEND(__TYPEOF(w), 4, void(*)(Files_Writer, BYTE), (w, x))
#define __Files_Writer_WriteBytes(w, x, x__len, beg, len) __SEND(__TYPEOF(w), 5, void(*)(Files_Writer, \
BYTE*, INTEGER , INTEGER, INTEGER), (w, x, x__len, beg, len))


import Files_Directory Files_dir, Files_stdDir;
import Files_Type Files_objType, Files_symType, Files_docType;

import INTEGER Files__2__desc[];
import SYSTEM_TYPEDESC *Files__2__typ;
import INTEGER Files_FileInfo__rec__desc[];
import SYSTEM_TYPEDESC *Files_FileInfo__rec__typ;
import INTEGER Files_FileInfo__desc[];
import SYSTEM_TYPEDESC *Files_FileInfo__typ;
import INTEGER Files_Name__desc[];
import SYSTEM_TYPEDESC *Files_Name__typ;
import INTEGER Files_Type__desc[];
import SYSTEM_TYPEDESC *Files_Type__typ;
import INTEGER Files_LocInfo__rec__desc[];
import SYSTEM_TYPEDESC *Files_LocInfo__rec__typ;
import INTEGER Files_LocInfo__desc[];
import SYSTEM_TYPEDESC *Files_LocInfo__typ;
import INTEGER Files_Locator__rec__desc[];
import SYSTEM_TYPEDESC *Files_Locator__rec__typ;
import INTEGER Files_File__rec__desc[];
import SYSTEM_TYPEDESC *Files_File__rec__typ;
import INTEGER Files_Reader__rec__desc[];
import SYSTEM_TYPEDESC *Files_Reader__rec__typ;
import INTEGER Files_Writer__rec__desc[];
import SYSTEM_TYPEDESC *Files_Writer__rec__typ;
import INTEGER Files_Directory__rec__desc[];
import SYSTEM_TYPEDESC *Files_Directory__rec__typ;
import INTEGER Files_Directory__desc[];
import SYSTEM_TYPEDESC *Files_Directory__typ;
import INTEGER Files_File__desc[];
import SYSTEM_TYPEDESC *Files_File__typ;
import INTEGER Files_Locator__desc[];
import SYSTEM_TYPEDESC *Files_Locator__typ;
import INTEGER Files_Reader__desc[];
import SYSTEM_TYPEDESC *Files_Reader__typ;
import INTEGER Files_Writer__desc[];
import SYSTEM_TYPEDESC *Files_Writer__typ;

import void Files_SetDir (Files_Directory d);

import void Files__reg();
import void Files__body();
import struct SYSTEM_MODDESC Files__desc;

#endif
