/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Console.h"
#include "HostLang.h"
#include "unistd.h"
#include "C99types.h"
#include "sys/types.h"

typedef
	struct HostConsole_Directory__rec *HostConsole_Directory;

typedef
	struct HostConsole_Directory__rec {
		char _prvt0[1];
	} HostConsole_Directory__rec;

static void HostConsole_Directory_WriteChar (HostConsole_Directory d, CHAR ch);
static void HostConsole_Directory_WriteLn (HostConsole_Directory d);
static void HostConsole_Directory_WriteString (HostConsole_Directory d, CHAR *s, INTEGER s__len);



export INTEGER HostConsole_Directory__rec__desc[];
export SYSTEM_TYPEDESC *HostConsole_Directory__rec__typ = (SYSTEM_TYPEDESC*)(HostConsole_Directory__rec__desc \
+ 5);

static void HostConsole_Init (void);

export void HostConsole__reg();
export void HostConsole__body();
export struct SYSTEM_MODDESC HostConsole__desc;


static void HostConsole_Directory_WriteChar (HostConsole_Directory d, CHAR ch)
{
	INTEGER res;
	CHAR s[2];
	SHORTCHAR ss[12];
	__ENTER("HostConsole.Directory.WriteChar");
	s[0] = ch;
	s[1] = 0;
	HostLang_StringToHost((void*)s, 2, (void*)ss, 12, 1, &res);
	__ASSERT(res == 0, 100);
	res = write(1, (INTEGER)&ss[0], __STRLENS(ss));
	res = fsync(1);
	__EXIT;
}

static void HostConsole_Directory_WriteString (HostConsole_Directory d, CHAR *s, INTEGER s__len)
{
	struct SHORTCHAR_ARRAY *ss = NIL;
	INTEGER res;
	__ENTER("HostConsole.Directory.WriteString");
	ss = __NEWARR(1, __ASHL(__STRLEN(s), 2, INTEGER) + 1);
	HostLang_StringToHost((void*)s, s__len, (void*)ss->data, ss->len[0], 1, &res);
	__ASSERT(res == 0, 100);
	res = write(1, (INTEGER)&(ss->data)[0], __STRLENS(ss->data));
	res = fsync(1);
	__EXIT;
}

static void HostConsole_Directory_WriteLn (HostConsole_Directory d)
{
	__ENTER("HostConsole.Directory.WriteLn");
	__Console_Directory_WriteChar((void*)d, 10);
	__EXIT;
}

static void HostConsole_Init (void)
{
	HostConsole_Directory d = NIL;
	__ENTER("HostConsole.Init");
	d = __NEW(HostConsole_Directory__rec__typ);
	Console_SetDir((void*)d);
	__EXIT;
}

static INTEGER HostConsole_Directory__rec__flds[] = {
	0, 
};
export INTEGER HostConsole_Directory__rec__desc[] = {
	-1, 
	(INTEGER)HostConsole_Directory_WriteString, 
	(INTEGER)HostConsole_Directory_WriteLn, 
	(INTEGER)HostConsole_Directory_WriteChar, 
	0, 
	1,
	(INTEGER)&HostConsole__desc,
	1<<8 | 0x11,
	(INTEGER)(Console_Directory__rec__desc + 5),
	(INTEGER)(HostConsole_Directory__rec__desc + 5),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)HostConsole_Directory__rec__flds, 
	-4
};
static SYSTEM_MODDESC *HostConsole__imp[] = {
	&Console__desc,
	&HostLang__desc,
};
static INTEGER HostConsole__exp[] = {
	2,
	0x81dfbbc7, 0x5a886fd5, 1<<8 | 0x12, (INTEGER)(HostConsole_Directory__rec__desc + 5),
	0x227d6f36, (INTEGER)HostConsole_Init, 12<<8 | 0x14, 0,
};
static char HostConsole__names[] = {
	0,
	'D','i','r','e','c','t','o','r','y','^',0,
	'I','n','i','t',0,
};
static INTEGER HostConsole__ptrs[] = {
	0
};
struct SYSTEM_MODDESC HostConsole__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 4}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	HostConsole__body,
	0,
	2, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	HostConsole__names,
	HostConsole__ptrs,
	HostConsole__imp,
	(SYSTEM_DIRECTORY*)HostConsole__exp,
	"HostConsole"
};

export void HostConsole__reg()
{
	__BEGREG(HostConsole__desc);
	Console__reg();
	HostLang__reg();
	__REGMOD(HostConsole__desc);
	HostConsole_Directory__rec__desc[4] = Console_Directory__rec__desc[4];
	__ENDREG;
}

export void HostConsole__body()
{
	__BEGBODY(HostConsole__desc);
	Console__body();
	HostLang__body();
	HostConsole_Init();
	__ENDBODY;
}
