/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Dates.h"
#include "Kernel.h"
#include "Strings.h"
#include "time.h"
#include "sys/types.h"
#include "C99types.h"
#include "locale.h"

typedef
	struct HostDates_Hook__rec *HostDates_Hook;

typedef
	struct HostDates_Hook__rec {
		char _prvt0[1];
	} HostDates_Hook__rec;

static void HostDates_Hook_DateToString (HostDates_Hook h, Dates_Date d, INTEGER format, CHAR *str, INTEGER \
str__len);
static void HostDates_Hook_GetTime (HostDates_Hook h, Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time \
*t, SYSTEM_TYPEDESC *t__typ);
static void HostDates_Hook_GetUTCBias (HostDates_Hook h, INTEGER *bias);
static void HostDates_Hook_GetUTCTime (HostDates_Hook h, Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time \
*t, SYSTEM_TYPEDESC *t__typ);
static void HostDates_Hook_TimeToString (HostDates_Hook h, Dates_Time t, CHAR *str, INTEGER str__len);


static CHAR HostDates_day[7][10];
static CHAR HostDates_month[12][10];

export INTEGER HostDates_Hook__rec__desc[];
export SYSTEM_TYPEDESC *HostDates_Hook__rec__typ = (SYSTEM_TYPEDESC*)(HostDates_Hook__rec__desc + 7);

static void HostDates_Init (void);

export void HostDates__reg();
export void HostDates__body();
export struct SYSTEM_MODDESC HostDates__desc;


static void HostDates_Hook_GetTime (HostDates_Hook h, Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time \
*t, SYSTEM_TYPEDESC *t__typ)
{
	time_t epoch;
	struct tm tm;
	struct tm* ptm = NIL;
	__ENTER("HostDates.Hook.GetTime");
	epoch = time(0);
	ptm = localtime_r(&epoch, &tm);
	if (ptm != NIL) {
		(*d).year = tm.tm_year + 1900;
		(*d).month = tm.tm_mon + 1;
		(*d).day = tm.tm_mday;
		(*t).hour = tm.tm_hour;
		(*t).minute = tm.tm_min;
		(*t).second = tm.tm_sec;
	} else {
		(*d).year = 0;
		(*d).month = 0;
		(*d).day = 0;
		(*t).hour = 0;
		(*t).minute = 0;
		(*t).second = 0;
	}
	__EXIT;
}

static void HostDates_Hook_GetUTCTime (HostDates_Hook h, Dates_Date *d, SYSTEM_TYPEDESC *d__typ, Dates_Time \
*t, SYSTEM_TYPEDESC *t__typ)
{
	time_t epoch;
	struct tm tm;
	struct tm* ptm = NIL;
	__ENTER("HostDates.Hook.GetUTCTime");
	epoch = time(0);
	ptm = gmtime_r(&epoch, &tm);
	if (ptm != NIL) {
		(*d).year = tm.tm_year + 1900;
		(*d).month = tm.tm_mon + 1;
		(*d).day = tm.tm_mday;
		(*t).hour = tm.tm_hour;
		(*t).minute = tm.tm_min;
		(*t).second = tm.tm_sec;
	} else {
		(*d).year = 0;
		(*d).month = 0;
		(*d).day = 0;
		(*t).hour = 0;
		(*t).minute = 0;
		(*t).second = 0;
	}
	__EXIT;
}

static void HostDates_Hook_GetUTCBias (HostDates_Hook h, INTEGER *bias)
{
	__ENTER("HostDates.Hook.GetUTCBias");
	tzset();
	*bias = 0;
	__EXIT;
}

static struct DateToString__1 {
	CHAR (*s)[20];
	struct DateToString__1 *lnk;
} *DateToString__1_s;

static void __3 (CHAR *s, INTEGER s__len, INTEGER n, CHAR *str, INTEGER str__len);

static void __3 (CHAR *s, INTEGER s__len, INTEGER n, CHAR *str, INTEGER str__len)
{
	INTEGER i, _for__5;
	__ENTER("HostDates.Copy");
	_for__5 = n - 1;
	i = 0;
	while (i <= _for__5) {
		str[__X(i, str__len)] = s[__X(i, s__len)];
		i += 1;
	}
	str[__X(i, str__len)] = 0;
	__EXIT;
}

static void HostDates_Hook_DateToString (HostDates_Hook h, Dates_Date d, INTEGER format, CHAR *str, INTEGER \
str__len)
{
	CHAR s[20];
	CHAR _str__2[21];
	struct DateToString__1 _s;
	__ENTER("HostDates.Hook.DateToString");
	_s.s = (void*)s;
	_s.lnk = DateToString__1_s;
	DateToString__1_s = &_s;
	switch (format) {
		case 0: 
			str[0] = (CHAR)(__MOD(__DIV(d.day, 10), 10) + 48);
			str[__X(1, str__len)] = (CHAR)(__MOD(d.day, 10) + 48);
			str[__X(2, str__len)] = (CHAR)L'/';
			str[__X(3, str__len)] = (CHAR)(__MOD(__DIV(d.month, 10), 10) + 48);
			str[__X(4, str__len)] = (CHAR)(__MOD(d.month, 10) + 48);
			str[__X(5, str__len)] = (CHAR)L'/';
			str[__X(6, str__len)] = (CHAR)(__MOD(__DIV(d.year, 10), 10) + 48);
			str[__X(7, str__len)] = (CHAR)(__MOD(d.year, 10) + 48);
			str[__X(8, str__len)] = 0;
			break;
		case 2: 
			__3((void*)HostDates_day[__X(d.day - 1, 7)], 10, 3, (void*)str, str__len);
			__3((void*)HostDates_month[__X(d.month - 1, 12)], 10, 3, (void*)s, 20);
			__STRCOPYLL(str, str, str__len);
			__STRAPNDLL(((CHAR[]){44, 32, 0}), str, str__len);
			__STRAPNDLL(s, str, str__len);
			Strings_IntToString(d.year, (void*)s, 20);
			__STRCOPYLL(str, str, str__len);
			__STRAPNDLL(((CHAR[]){44, 32, 0}), str, str__len);
			__STRAPNDLL(s, str, str__len);
			break;
		case 1: 
			__STRCOPYLL(HostDates_day[__X(d.day - 1, 7)], _str__2, 21);
			__STRAPNDLL(((CHAR[]){44, 32, 0}), _str__2, 21);
			__STRAPNDLL(HostDates_month[__X(d.month - 1, 12)], _str__2, 21);
			__STRCOPYLL(_str__2, str, str__len);
			Strings_IntToString(d.year, (void*)s, 20);
			__STRCOPYLL(str, str, str__len);
			__STRAPNDLL(((CHAR[]){44, 32, 0}), str, str__len);
			__STRAPNDLL(s, str, str__len);
			break;
		case 4: 
			__3((void*)HostDates_month[__X(d.month - 1, 12)], 10, 3, (void*)str, str__len);
			Strings_IntToString(d.day, (void*)s, 20);
			__STRCOPYLL(str, str, str__len);
			__STRAPNDLL(((CHAR[]){32, 0}), str, str__len);
			__STRAPNDLL(s, str, str__len);
			Strings_IntToString(d.year, (void*)s, 20);
			__STRCOPYLL(str, str, str__len);
			__STRAPNDLL(((CHAR[]){44, 32, 0}), str, str__len);
			__STRAPNDLL(s, str, str__len);
			break;
		case 3: 
			Strings_IntToString(d.day, (void*)s, 20);
			__STRCOPYLL(HostDates_month[__X(d.month - 1, 12)], str, str__len);
			__STRAPNDLL(((CHAR[]){32, 0}), str, str__len);
			__STRAPNDLL(s, str, str__len);
			Strings_IntToString(d.year, (void*)s, 20);
			__STRCOPYLL(str, str, str__len);
			__STRAPNDLL(((CHAR[]){44, 32, 0}), str, str__len);
			__STRAPNDLL(s, str, str__len);
			break;
		default: __CASECHK;
	}
	DateToString__1_s = _s.lnk;
	__EXIT;
}

static void HostDates_Hook_TimeToString (HostDates_Hook h, Dates_Time t, CHAR *str, INTEGER str__len)
{
	CHAR s[12];
	__ENTER("HostDates.Hook.TimeToString");
	Strings_IntToString(t.hour, (void*)str, str__len);
	Strings_IntToString(t.minute, (void*)s, 12);
	__STRCOPYLL(str, str, str__len);
	__STRAPNDLL(((CHAR[]){58, 0}), str, str__len);
	__STRAPNDLL(s, str, str__len);
	Strings_IntToString(t.second, (void*)s, 12);
	__STRCOPYLL(str, str, str__len);
	__STRAPNDLL(((CHAR[]){58, 0}), str, str__len);
	__STRAPNDLL(s, str, str__len);
	__EXIT;
}

static void HostDates_Init (void)
{
	HostDates_Hook h = NIL;
	__ENTER("HostDates.Init");
	__MOVE(((CHAR[]){77, 111, 110, 100, 97, 121, 0}), HostDates_day[0], 14);
	__MOVE(((CHAR[]){84, 117, 101, 115, 100, 97, 121, 0}), HostDates_day[1], 16);
	__MOVE(((CHAR[]){87, 101, 100, 110, 101, 115, 100, 97, 121, 0}), HostDates_day[2], 20);
	__MOVE(((CHAR[]){84, 104, 117, 114, 115, 100, 97, 121, 0}), HostDates_day[3], 18);
	__MOVE(((CHAR[]){70, 114, 105, 100, 97, 121, 0}), HostDates_day[4], 14);
	__MOVE(((CHAR[]){83, 97, 116, 117, 114, 100, 97, 121, 0}), HostDates_day[5], 18);
	__MOVE(((CHAR[]){83, 117, 110, 100, 97, 121, 0}), HostDates_day[6], 14);
	__MOVE(((CHAR[]){74, 97, 110, 117, 97, 114, 121, 0}), HostDates_month[0], 16);
	__MOVE(((CHAR[]){70, 101, 98, 114, 117, 97, 114, 121, 0}), HostDates_month[1], 18);
	__MOVE(((CHAR[]){77, 97, 114, 99, 104, 0}), HostDates_month[2], 12);
	__MOVE(((CHAR[]){65, 112, 114, 105, 108, 0}), HostDates_month[3], 12);
	__MOVE(((CHAR[]){77, 97, 121, 0}), HostDates_month[4], 8);
	__MOVE(((CHAR[]){74, 117, 110, 101, 0}), HostDates_month[5], 10);
	__MOVE(((CHAR[]){74, 117, 108, 121, 0}), HostDates_month[6], 10);
	__MOVE(((CHAR[]){65, 117, 103, 117, 115, 116, 0}), HostDates_month[7], 14);
	__MOVE(((CHAR[]){83, 101, 112, 116, 101, 109, 98, 101, 114, 0}), HostDates_month[8], 20);
	__MOVE(((CHAR[]){79, 99, 116, 111, 98, 101, 114, 0}), HostDates_month[9], 16);
	__MOVE(((CHAR[]){78, 111, 118, 101, 109, 98, 101, 114, 0}), HostDates_month[10], 18);
	__MOVE(((CHAR[]){68, 101, 99, 101, 109, 98, 101, 114, 0}), HostDates_month[11], 18);
	h = __NEW(HostDates_Hook__rec__typ);
	Dates_SetHook((void*)h);
	__EXIT;
}

static INTEGER HostDates_Hook__rec__flds[] = {
	0, 
};
export INTEGER HostDates_Hook__rec__desc[] = {
	-1, 
	(INTEGER)HostDates_Hook_TimeToString, 
	(INTEGER)HostDates_Hook_GetUTCTime, 
	(INTEGER)HostDates_Hook_GetUTCBias, 
	(INTEGER)HostDates_Hook_GetTime, 
	(INTEGER)HostDates_Hook_DateToString, 
	0, 
	1,
	(INTEGER)&HostDates__desc,
	1<<8 | 0x21,
	(INTEGER)(Kernel_Hook__rec__desc + 2),
	(INTEGER)(Dates_Hook__rec__desc + 7),
	(INTEGER)(HostDates_Hook__rec__desc + 7),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)HostDates_Hook__rec__flds, 
	-4
};
export INTEGER HostDates__1__desc[] = {
	10,
	(INTEGER)&HostDates__desc,
	0<<8 | 0x02,
	3
};
export INTEGER HostDates__2__desc[] = {
	7,
	(INTEGER)&HostDates__desc,
	0<<8 | 0x02,
	(INTEGER)HostDates__1__desc
};
export INTEGER HostDates__3__desc[] = {
	10,
	(INTEGER)&HostDates__desc,
	0<<8 | 0x02,
	3
};
export INTEGER HostDates__4__desc[] = {
	12,
	(INTEGER)&HostDates__desc,
	0<<8 | 0x02,
	(INTEGER)HostDates__3__desc
};
static SYSTEM_MODDESC *HostDates__imp[] = {
	&Dates__desc,
	&Strings__desc,
};
static INTEGER HostDates__exp[] = {
	4,
	0x6616d58c, 0xb8861b4b, 1<<8 | 0x12, (INTEGER)(HostDates_Hook__rec__desc + 7),
	0x227d6f36, (INTEGER)HostDates_Init, 7<<8 | 0x14, 0,
	0x3e1130a1, (INTEGER)&HostDates_day, 12<<8 | 0x13, (INTEGER)HostDates__2__desc,
	0x8ad127af, (INTEGER)&HostDates_month, 16<<8 | 0x13, (INTEGER)HostDates__4__desc,
};
static char HostDates__names[] = {
	0,
	'H','o','o','k','^',0,
	'I','n','i','t',0,
	'd','a','y',0,
	'm','o','n','t','h',0,
};
static INTEGER HostDates__ptrs[] = {
	0
};
struct SYSTEM_MODDESC HostDates__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 4}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	HostDates__body,
	0,
	2, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	HostDates__names,
	HostDates__ptrs,
	HostDates__imp,
	(SYSTEM_DIRECTORY*)HostDates__exp,
	"HostDates"
};

export void HostDates__reg()
{
	__BEGREG(HostDates__desc);
	Dates__reg();
	Strings__reg();
	__REGMOD(HostDates__desc);
	HostDates_Hook__rec__desc[6] = Dates_Hook__rec__desc[6];
	__ENDREG;
}

export void HostDates__body()
{
	__BEGBODY(HostDates__desc);
	Dates__body();
	Strings__body();
	HostDates_Init();
	__ENDBODY;
}
