/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"
#include "HostLang.h"
#include "Files.h"
#include "Log.h"
#include "stdlib.h"
#include "unistd.h"
#include "sys/types.h"
#include "dirent.h"
#include "fcntl.h"
#include "sys/stat.h"
#include "time.h"
#include "stdio.h"
#include "errno.h"
#include "C99macro.h"
#include "libgen.h"
#include "locale.h"

typedef
	struct HostFiles_Directory__rec *HostFiles_Directory;

typedef
	struct HostFiles_Directory__rec {
		char _prvt0[1];
	} HostFiles_Directory__rec;

static void HostFiles_Directory_Delete (HostFiles_Directory d, Files_Locator loc, Files_Name name);
static Files_FileInfo HostFiles_Directory_FileList (HostFiles_Directory d, Files_Locator loc);
static void HostFiles_Directory_GetFileName (HostFiles_Directory d, Files_Name name, Files_Type type, \
Files_Name filename);
static Files_LocInfo HostFiles_Directory_LocList (HostFiles_Directory d, Files_Locator loc);
typedef
	struct HostFiles_File__rec *HostFiles_File;

static HostFiles_File HostFiles_Directory_New (HostFiles_Directory d, Files_Locator loc, BOOLEAN ask);
static HostFiles_File HostFiles_Directory_Old (HostFiles_Directory d, Files_Locator loc, Files_Name name, \
BOOLEAN isShared);
static void HostFiles_Directory_Rename (HostFiles_Directory d, Files_Locator loc, Files_Name old, Files_Name \
new, BOOLEAN ask);
static BOOLEAN HostFiles_Directory_SameFile (HostFiles_Directory d, Files_Locator loc0, Files_Name name0, \
Files_Locator loc1, Files_Name name1);
static HostFiles_File HostFiles_Directory_Temp (HostFiles_Directory d);
typedef
	struct HostFiles_Locator__rec *HostFiles_Locator;

static HostFiles_Locator HostFiles_Directory_This (HostFiles_Directory d, CHAR *path, INTEGER path__len);
#define __HostFiles_Directory_New(d, loc, ask) __SEND(__TYPEOF(d), 5, HostFiles_File(*)(HostFiles_Directory, \
Files_Locator, BOOLEAN), (d, loc, ask))
#define __HostFiles_Directory_Old(d, loc, name, isShared) __SEND(__TYPEOF(d), 6, HostFiles_File(*)(HostFiles_Directory, \
Files_Locator, Files_Name, BOOLEAN), (d, loc, name, isShared))
#define __HostFiles_Directory_Temp(d) __SEND(__TYPEOF(d), 9, HostFiles_File(*)(HostFiles_Directory), (d))
#define __HostFiles_Directory_This(d, path, path__len) __SEND(__TYPEOF(d), 10, HostFiles_Locator(*)(HostFiles_Directory, \
CHAR*, INTEGER ), (d, path, path__len))

typedef
	struct HostFiles_File__rec {
		Files_Type type;
		char _prvt0[4];
		INTEGER state, len;
		int fd;
		ino_t ino;
		Files_Name pathname;
	} HostFiles_File__rec;

static void HostFiles_File_Close (HostFiles_File f);
static BOOLEAN HostFiles_File_Closed (HostFiles_File f);
static void HostFiles_File_FINALIZE (HostFiles_File f);
static void HostFiles_File_Flush (HostFiles_File f);
static INTEGER HostFiles_File_Length (HostFiles_File f);
typedef
	struct HostFiles_Reader__rec *HostFiles_Reader;

static HostFiles_Reader HostFiles_File_NewReader (HostFiles_File f, Files_Reader old);
typedef
	struct HostFiles_Writer__rec *HostFiles_Writer;

static HostFiles_Writer HostFiles_File_NewWriter (HostFiles_File f, Files_Writer old);
static void HostFiles_File_Register (HostFiles_File f, Files_Name name, Files_Type type, BOOLEAN ask, \
INTEGER *res);
static BOOLEAN HostFiles_File_Shared (HostFiles_File f);
#define __HostFiles_File_NewReader(f, old) __SEND(__TYPEOF(f), 6, HostFiles_Reader(*)(HostFiles_File, \
Files_Reader), (f, old))
#define __HostFiles_File_NewWriter(f, old) __SEND(__TYPEOF(f), 7, HostFiles_Writer(*)(HostFiles_File, \
Files_Writer), (f, old))

typedef
	struct HostFiles_InodeIdentifier { /* Kernel_Identifier */
		INTEGER typ;
		ANYPTR obj;
		ino_t ino;
	} HostFiles_InodeIdentifier;

static BOOLEAN HostFiles_InodeIdentifier_Identified (HostFiles_InodeIdentifier *id, SYSTEM_TYPEDESC *id__typ);

typedef
	struct HostFiles_Locator__rec {
		INTEGER res;
		Files_Name path;
	} HostFiles_Locator__rec;

static HostFiles_Locator HostFiles_Locator_This (HostFiles_Locator l, CHAR *path, INTEGER path__len);
#define __HostFiles_Locator_This(l, path, path__len) __SEND(__TYPEOF(l), 1, HostFiles_Locator(*)(HostFiles_Locator, \
CHAR*, INTEGER ), (l, path, path__len))

typedef
	SHORTCHAR HostFiles_NativeName[1024];

typedef
	struct HostFiles_Reader__rec {
		BOOLEAN eof;
		HostFiles_File f;
		INTEGER pos;
	} HostFiles_Reader__rec;

static HostFiles_File HostFiles_Reader_Base (HostFiles_Reader r);
static INTEGER HostFiles_Reader_Pos (HostFiles_Reader r);
static void HostFiles_Reader_ReadByte (HostFiles_Reader r, BYTE *x);
static void HostFiles_Reader_ReadBytes (HostFiles_Reader r, BYTE *x, INTEGER x__len, INTEGER beg, INTEGER \
len);
static void HostFiles_Reader_SetPos (HostFiles_Reader r, INTEGER pos);
#define __HostFiles_Reader_Base(r) __SEND(__TYPEOF(r), 1, HostFiles_File(*)(HostFiles_Reader), (r))

typedef
	struct HostFiles_Writer__rec {
		HostFiles_File f;
		INTEGER pos;
	} HostFiles_Writer__rec;

static HostFiles_File HostFiles_Writer_Base (HostFiles_Writer w);
static INTEGER HostFiles_Writer_Pos (HostFiles_Writer w);
static void HostFiles_Writer_SetPos (HostFiles_Writer w, INTEGER pos);
static void HostFiles_Writer_WriteByte (HostFiles_Writer w, BYTE x);
static void HostFiles_Writer_WriteBytes (HostFiles_Writer w, BYTE *x, INTEGER x__len, INTEGER beg, INTEGER \
len);
#define __HostFiles_Writer_Base(w) __SEND(__TYPEOF(w), 1, HostFiles_File(*)(HostFiles_Writer), (w))


export BOOLEAN HostFiles_ignoreAsk;
static HostFiles_Locator HostFiles_root;

export INTEGER HostFiles_Locator__rec__desc[];
export SYSTEM_TYPEDESC *HostFiles_Locator__rec__typ = (SYSTEM_TYPEDESC*)(HostFiles_Locator__rec__desc \
+ 3);
export INTEGER HostFiles_Directory__rec__desc[];
export SYSTEM_TYPEDESC *HostFiles_Directory__rec__typ = (SYSTEM_TYPEDESC*)(HostFiles_Directory__rec__desc \
+ 12);
export INTEGER HostFiles_File__rec__desc[];
export SYSTEM_TYPEDESC *HostFiles_File__rec__typ = (SYSTEM_TYPEDESC*)(HostFiles_File__rec__desc + 11);
export INTEGER HostFiles_Reader__rec__desc[];
export SYSTEM_TYPEDESC *HostFiles_Reader__rec__typ = (SYSTEM_TYPEDESC*)(HostFiles_Reader__rec__desc + \
7);
export INTEGER HostFiles_File__desc[];
export SYSTEM_TYPEDESC *HostFiles_File__typ = (SYSTEM_TYPEDESC*)HostFiles_File__desc;
export INTEGER HostFiles_Writer__rec__desc[];
export SYSTEM_TYPEDESC *HostFiles_Writer__rec__typ = (SYSTEM_TYPEDESC*)(HostFiles_Writer__rec__desc + \
7);
export INTEGER HostFiles_InodeIdentifier__desc[];
export SYSTEM_TYPEDESC *HostFiles_InodeIdentifier__typ = (SYSTEM_TYPEDESC*)(HostFiles_InodeIdentifier__desc \
+ 3);
export INTEGER HostFiles_NativeName__desc[];
export SYSTEM_TYPEDESC *HostFiles_NativeName__typ = (SYSTEM_TYPEDESC*)HostFiles_NativeName__desc;

static void HostFiles_DirName (CHAR *path, INTEGER path__len);
static SET HostFiles_GetAttr (HostFiles_NativeName path, Files_Name name, struct stat s);
static void HostFiles_GetError (INTEGER *res);
static HostFiles_File HostFiles_GetFileByInode (ino_t ino);
export void HostFiles_IgnoreAsk (void);
static void HostFiles_Init (void);
static BOOLEAN HostFiles_IsDir (struct stat *s);
static BOOLEAN HostFiles_IsName (Files_Name name);
static BOOLEAN HostFiles_IsRegFile (struct stat *s);
static void HostFiles_MakeDir (SHORTCHAR *path, INTEGER path__len, int *res);
export HostFiles_Locator HostFiles_NewLocator (CHAR *path, INTEGER path__len);
export void HostFiles_SetRootDir (CHAR *x, INTEGER x__len);
export void HostFiles_UseAsk (void);

export void HostFiles__reg();
export void HostFiles__body();
export struct SYSTEM_MODDESC HostFiles__desc;


static BOOLEAN HostFiles_InodeIdentifier_Identified (HostFiles_InodeIdentifier *id, SYSTEM_TYPEDESC *id__typ)
{
	HostFiles_File f = NIL;
	__ENTER("HostFiles.InodeIdentifier.Identified");
	f = (HostFiles_File)(*id).obj;
	__EXIT;
	return f->state != 0 && f->ino == (*id).ino;
}

static HostFiles_File HostFiles_GetFileByInode (ino_t ino)
{
	HostFiles_InodeIdentifier id = {0};
	ANYPTR obj = NIL;
	HostFiles_File f = NIL;
	__ENTER("HostFiles.GetFileByInode");
	__ASSERT(ino != 0, 20);
	id.typ = (INTEGER)HostFiles_File__rec__typ;
	id.ino = ino;
	obj = Kernel_ThisFinObj((void*)&id, HostFiles_InodeIdentifier__typ);
	if (obj != NIL) {
		f = (HostFiles_File)obj;
	} else {
		f = NIL;
	}
	__EXIT;
	return f;
}

static void HostFiles_GetError (INTEGER *res)
{
	INTEGER err;
	__ENTER("HostFiles.GetError");
	err = C99macro_errno();
	switch (err) {
		case 20: case 36: 
			*res = 1;
			break;
		case 2: 
			*res = 2;
			break;
		case 17: 
			*res = 3;
			break;
		case 30: 
			*res = 4;
			break;
		case 5: 
			*res = 5;
			break;
		case 1: case 13: 
			*res = 6;
			break;
		case 12: 
			*res = 80;
			break;
		case 23: case 28: case 105: 
			*res = 81;
			break;
		default: 
			*res = -err;
			break;
	}
	__EXIT;
}

HostFiles_Locator HostFiles_NewLocator (CHAR *path, INTEGER path__len)
{
	HostFiles_Locator l = NIL;
	SHORTCHAR ch;
	__ENTER("HostFiles.NewLocator");
	l = __NEW(HostFiles_Locator__rec__typ);
	if (path[0] == 0) {
		__MOVE(((CHAR[]){46, 0}), l->path, 4);
	} else {
		__STRCOPYLL(path, l->path, 256);
	}
	__EXIT;
	return l;
}

static HostFiles_Locator HostFiles_Locator_This (HostFiles_Locator l, CHAR *path, INTEGER path__len)
{
	HostFiles_Locator loc = NIL;
	struct CHAR_ARRAY *_ptr__2 = NIL;
	__ENTER("HostFiles.Locator.This");
	if (path[0] == 0) {
		loc = __NEW(HostFiles_Locator__rec__typ);
		*loc = *l;
	} else if (path[0] == (CHAR)L'/') {
		loc = HostFiles_NewLocator((void*)path, path__len);
	} else {
		loc = (_ptr__2 = __NEWARR(9, 255 + (1 + path__len)), 
			__STRCOPYLL(l->path, _ptr__2->data, _ptr__2->len[0]), __STRAPNDLL(((CHAR[]){47, 0}), _ptr__2->data, \
_ptr__2->len[0]), __STRAPNDLL(path, _ptr__2->data, _ptr__2->len[0]), 
			HostFiles_NewLocator((void*)_ptr__2->data, __STRLEN(_ptr__2->data) + 1));
	}
	__EXIT;
	return loc;
}

static INTEGER HostFiles_File_Length (HostFiles_File f)
{
	__ENTER("HostFiles.File.Length");
	__EXIT;
	return f->len;
}

static HostFiles_Reader HostFiles_File_NewReader (HostFiles_File f, Files_Reader old)
{
	HostFiles_Reader r = NIL;
	__ENTER("HostFiles.File.NewReader");
	__ASSERT(f->state != 0, 20);
	if (old != NIL && __Files_Reader_Base(old) == (void *) f) {
		r = (HostFiles_Reader)old;
		if (r->pos > f->len) {
			r->pos = 0;
		}
		r->eof = 0;
	} else {
		r = __NEW(HostFiles_Reader__rec__typ);
		r->f = f;
		r->pos = 0;
	}
	__EXIT;
	return r;
}

static HostFiles_Writer HostFiles_File_NewWriter (HostFiles_File f, Files_Writer old)
{
	HostFiles_Writer w = NIL;
	__ENTER("HostFiles.File.NewWriter");
	__ASSERT(f->state != 0, 20);
	__ASSERT(f->state != 3, 21);
	if (old != NIL && __Files_Writer_Base(old) == (void *) f) {
		w = (HostFiles_Writer)old;
		if (w->pos > f->len) {
			w->pos = 0;
		}
	} else {
		w = __NEW(HostFiles_Writer__rec__typ);
		w->f = f;
		w->pos = 0;
	}
	__EXIT;
	return w;
}

static void HostFiles_File_Flush (HostFiles_File f)
{
	int res;
	__ENTER("HostFiles.File.Flush");
	if (f->state != 0) {
		res = fsync(f->fd);
		__ASSERT(res == 0, 100);
	}
	__EXIT;
}

static BOOLEAN HostFiles_IsName (Files_Name name)
{
	INTEGER i;
	__ENTER("HostFiles.IsName");
	i = 0;
	while (name[__X(i, 256)] != (CHAR)L'/' && name[__X(i, 256)] != 0) {
		i += 1;
	}
	__EXIT;
	return name[__X(i, 256)] == 0;
}

static void HostFiles_DirName (CHAR *path, INTEGER path__len)
{
	INTEGER i, j, k;
	__ENTER("HostFiles.DirName");
	if (path[0] == (CHAR)L'/') {
		i = 1;
		j = 1;
		k = 1;
	} else {
		i = 0;
		j = 0;
		k = 0;
	}
	while (path[__X(i, path__len)] != 0) {
		if (path[__X(i, path__len)] == (CHAR)L'/') {
			k = j;
			j = i;
			i += 1;
			while (path[__X(i, path__len)] != 0 && path[__X(i, path__len)] == (CHAR)L'/') {
				i += 1;
			}
			if (path[__X(i, path__len)] == 0) {
				j = k;
			}
		} else {
			i += 1;
		}
	}
	path[__X(j, path__len)] = 0;
	__EXIT;
}

static void HostFiles_File_Register (HostFiles_File f, Files_Name name, Files_Type type, BOOLEAN ask, \
INTEGER *res)
{
	INTEGER i, err;
	Files_Name dir;
	HostFiles_NativeName p0, p1;
	struct stat s;
	int x;
	CHAR _str__29[512];
	Files_Name name__copy;
	Files_Type type__copy;
	__ENTER("HostFiles.File.Register");
	__DUPARR(name);
	__DUPARR(type);
	__ASSERT(f->state == 1, 20);
	__ASSERT(name[0] != 0, 21);
	__ASSERT(HostFiles_IsName(name), 22);
	HostLang_StringToHost((void*)f->pathname, 256, (void*)p0, 1024, 0, &err);
	if (err == 0) {
		__STRCOPYLL(f->pathname, dir, 256);
		HostFiles_DirName((void*)dir, 256);
		__STRCOPYLL(dir, _str__29, 512);
		__STRAPNDLL(((CHAR[]){47, 0}), _str__29, 512);
		__STRAPNDLL(name, _str__29, 512);
		HostLang_StringToHost((void*)_str__29, __STRLEN(_str__29) + 1, (void*)p1, 1024, 0, &err);
		if (err == 0) {
			x = rename((void*)p0, (void*)p1);
			if (x == 0) {
				*res = 0;
			} else {
				HostFiles_GetError(res);
			}
			f->state = 4;
			__Files_File_Close((void*)f);
		} else {
			*res = 1;
		}
	} else {
		*res = 1;
	}
	__EXIT;
}

static void HostFiles_File_Close (HostFiles_File f)
{
	int res;
	HostFiles_NativeName path;
	INTEGER err;
	__ENTER("HostFiles.File.Close");
	if (f->state != 0) {
		__Files_File_Flush((void*)f);
		if (f->state == 1) {
			HostLang_StringToHost((void*)f->pathname, 256, (void*)path, 1024, 0, &err);
			__ASSERT(err == 0, 100);
			res = unlink((void*)path);
			__ASSERT(res == 0, 101);
			f->state = 2;
		}
		res = close(f->fd);
		__ASSERT(res == 0, 102);
		f->state = 0;
	}
	__EXIT;
}

static BOOLEAN HostFiles_File_Closed (HostFiles_File f)
{
	__ENTER("HostFiles.File.Closed");
	__EXIT;
	return f->state == 0;
}

static BOOLEAN HostFiles_File_Shared (HostFiles_File f)
{
	__ENTER("HostFiles.File.Shared");
	__EXIT;
	return f->state == 3;
}

static void HostFiles_File_FINALIZE (HostFiles_File f)
{
	__ENTER("HostFiles.File.FINALIZE");
	__Files_File_Close((void*)f);
	__EXIT;
}

static HostFiles_File HostFiles_Reader_Base (HostFiles_Reader r)
{
	__ENTER("HostFiles.Reader.Base");
	__EXIT;
	return r->f;
}

static INTEGER HostFiles_Reader_Pos (HostFiles_Reader r)
{
	__ENTER("HostFiles.Reader.Pos");
	__EXIT;
	return r->pos;
}

static void HostFiles_Reader_SetPos (HostFiles_Reader r, INTEGER pos)
{
	__ENTER("HostFiles.Reader.SetPos");
	__ASSERT(pos >= 0, 20);
	__ASSERT(pos <= r->f->len, 21);
	r->pos = pos;
	r->eof = 0;
	__EXIT;
}

static void HostFiles_Reader_ReadByte (HostFiles_Reader r, BYTE *x)
{
	int res;
	off_t offset;
	__ENTER("HostFiles.Reader.ReadByte");
	__ASSERT(r->f->state != 0, 20);
	offset = lseek(r->f->fd, r->pos, 0);
	__ASSERT(offset == r->pos, 100);
	res = read(r->f->fd, (INTEGER)x, 1);
	__ASSERT(res != -1, 101);
	if (res == 0) {
		*x = 0;
	}
	r->pos = r->pos + res;
	r->eof = res == 0;
	__EXIT;
}

static void HostFiles_Reader_ReadBytes (HostFiles_Reader r, BYTE *x, INTEGER x__len, INTEGER beg, INTEGER \
len)
{
	int res;
	off_t offset;
	__ENTER("HostFiles.Reader.ReadBytes");
	__ASSERT(beg >= 0, 20);
	__ASSERT(len >= 0, 2);
	__ASSERT(beg + len <= x__len, 22);
	__ASSERT(r->f->state != 0, 23);
	offset = lseek(r->f->fd, r->pos, 0);
	__ASSERT(offset == r->pos, 100);
	res = read(r->f->fd, (INTEGER)&x[__X(beg, x__len)], len);
	__ASSERT(res != -1, 101);
	r->pos = r->pos + res;
	r->eof = res == 0;
	__EXIT;
}

static HostFiles_File HostFiles_Writer_Base (HostFiles_Writer w)
{
	__ENTER("HostFiles.Writer.Base");
	__EXIT;
	return w->f;
}

static INTEGER HostFiles_Writer_Pos (HostFiles_Writer w)
{
	__ENTER("HostFiles.Writer.Pos");
	__EXIT;
	return w->pos;
}

static void HostFiles_Writer_SetPos (HostFiles_Writer w, INTEGER pos)
{
	__ENTER("HostFiles.Writer.SetPos");
	__ASSERT(pos >= 0, 20);
	__ASSERT(pos <= w->f->len, 21);
	w->pos = pos;
	__EXIT;
}

static void HostFiles_Writer_WriteByte (HostFiles_Writer w, BYTE x)
{
	int res;
	off_t offset;
	__ENTER("HostFiles.Writer.WriteByte");
	__ASSERT(w->f->state != 0, 20);
	offset = lseek(w->f->fd, w->pos, 0);
	__ASSERT(offset == w->pos, 100);
	res = write(w->f->fd, (INTEGER)&x, 1);
	__ASSERT(res != -1, 101);
	w->pos = w->pos + res;
	w->f->len = __MAX(w->f->len, w->pos);
	__ASSERT(res == 1, 60);
	__EXIT;
}

static void HostFiles_Writer_WriteBytes (HostFiles_Writer w, BYTE *x, INTEGER x__len, INTEGER beg, INTEGER \
len)
{
	int res;
	off_t offset;
	__ENTER("HostFiles.Writer.WriteBytes");
	__ASSERT(beg >= 0, 20);
	__ASSERT(len >= 0, 21);
	__ASSERT(beg + len <= x__len, 22);
	__ASSERT(w->f->state != 0, 23);
	offset = lseek(w->f->fd, w->pos, 0);
	__ASSERT(offset == w->pos, 100);
	res = write(w->f->fd, (INTEGER)&x[__X(beg, x__len)], len);
	__ASSERT(res != -1, 101);
	w->pos = w->pos + res;
	w->f->len = __MAX(w->f->len, w->pos);
	__ASSERT(res == len, 60);
	__EXIT;
}

static HostFiles_Locator HostFiles_Directory_This (HostFiles_Directory d, CHAR *path, INTEGER path__len)
{
	__ENTER("HostFiles.Directory.This");
	__EXIT;
	return __HostFiles_Locator_This(HostFiles_root, (void*)path, path__len);
}

static void HostFiles_MakeDir (SHORTCHAR *path, INTEGER path__len, int *res)
{
	INTEGER i;
	BOOLEAN sep;
	int err;
	struct stat s;
	mode_t mode;
	__ENTER("HostFiles.MakeDir");
	__DUP(path, path__len);
	i = 0;
	err = 0;
	mode = (INTEGER)(0x01ff & ~(SET)umask(0));
	while (err == 0 && path[__X(i, path__len)] != 0) {
		while (path[__X(i, path__len)] != (SHORTCHAR)'/' && path[__X(i, path__len)] != 0) {
			i += 1;
		}
		sep = path[__X(i, path__len)] == (SHORTCHAR)'/';
		if (sep) {
			path[__X(i, path__len)] = 0;
		}
		err = mkdir((void*)path, mode);
		if (err == -1) {
			HostFiles_GetError((void*)&err);
			if (err == 3) {
				err = 0;
			}
		}
		if (sep) {
			path[__X(i, path__len)] = (SHORTCHAR)'/';
		}
		i += 1;
	}
	*res = err;
	__DEL(path);
	__EXIT;
}

static HostFiles_File HostFiles_Directory_New (HostFiles_Directory d, Files_Locator loc, BOOLEAN ask)
{
	INTEGER err;
	HostFiles_File f = NIL;
	struct stat s;
	int fd, res;
	HostFiles_NativeName pathname;
	__ENTER("HostFiles.Directory.New");
	__ASSERT(loc != NIL, 20);
	if (__ISP(loc, HostFiles_Locator__rec__typ, 1)) {
		HostLang_StringToHost((void*)((HostFiles_Locator)loc)->path, 256, (void*)pathname, 1024, 0, &err);
		if (err == 0) {
			HostFiles_MakeDir(pathname, 1024, &res);
			if (res == 0) {
				__STRCOPYSS(pathname, pathname, 1024);
				__STRAPNDSS("/.newXXXXXX", pathname, 1024);
				fd = mkstemp((void*)pathname);
				if (fd != -1) {
					f = __NEW(HostFiles_File__rec__typ);
					HostLang_HostToString((void*)pathname, 1024, (void*)f->pathname, 256, 0, &err);
					if (err == 0) {
						f->fd = fd;
						f->len = 0;
						f->state = 1;
						f->ino = 0;
						((HostFiles_Locator)loc)->res = 0;
					} else {
						f = NIL;
						res = close(fd);
						__ASSERT(res == 0, 100);
						res = unlink((void*)pathname);
						__ASSERT(res == 0, 101);
						((HostFiles_Locator)loc)->res = 1;
					}
				} else {
					HostFiles_GetError(&((HostFiles_Locator)loc)->res);
				}
			} else {
				((HostFiles_Locator)loc)->res = res;
			}
		} else {
			((HostFiles_Locator)loc)->res = 1;
		}
	} else {
		loc->res = 1;
	}
	__EXIT;
	return f;
}

static BOOLEAN HostFiles_IsRegFile (struct stat *s)
{
	__ENTER("HostFiles.IsRegFile");
	__EXIT;
	return ((SET)(*s).st_mode & 0xf000) == 0x8000;
}

static struct Old__32 {
	Files_Name *name;
	INTEGER *err;
	HostFiles_File *f;
	struct stat *s;
	int *fd, *res;
	HostFiles_NativeName *pathname;
	struct flock *lock;
	struct Old__32 *lnk;
} *Old__32_s;

static void __34 (void);

static void __34 (void)
{
	__ENTER("HostFiles.Cleanup");
	(*Old__32_s->f) = NIL;
	(*Old__32_s->res) = close((*Old__32_s->fd));
	__ASSERT((*Old__32_s->res) == 0, 100);
	__EXIT;
}

static HostFiles_File HostFiles_Directory_Old (HostFiles_Directory d, Files_Locator loc, Files_Name name, \
BOOLEAN isShared)
{
	INTEGER err;
	HostFiles_File f = NIL;
	HostFiles_File if_ = NIL;
	struct stat s;
	int fd, flags, res;
	HostFiles_NativeName pathname;
	mode_t mode;
	struct flock lock;
	CHAR _str__33[512];
	struct Old__32 _s;
	Files_Name name__copy;
	__ENTER("HostFiles.Directory.Old");
	__DUPARR(name);
	_s.name = (void*)name;
	_s.err = &err;
	_s.f = &f;
	_s.s = &s;
	_s.fd = &fd;
	_s.res = &res;
	_s.pathname = (void*)pathname;
	_s.lock = &lock;
	_s.lnk = Old__32_s;
	Old__32_s = &_s;
	__ASSERT(loc != NIL, 20);
	__ASSERT(name[0] != 0, 21);
	if (__ISP(loc, HostFiles_Locator__rec__typ, 1)) {
		if (HostFiles_IsName(name)) {
			__STRCOPYLL(((HostFiles_Locator)loc)->path, _str__33, 512);
			__STRAPNDLL(((CHAR[]){47, 0}), _str__33, 512);
			__STRAPNDLL(name, _str__33, 512);
			HostLang_StringToHost((void*)_str__33, __STRLEN(_str__33) + 1, (void*)pathname, 1024, 0, &err);
			if (err == 0) {
				res = C99macro_stat((void*)pathname, &s);
				if (res == 0) {
					if (HostFiles_IsRegFile(&s)) {
						if_ = HostFiles_GetFileByInode(s.st_ino);
						if (if_ == NIL || isShared && if_->state == 3) {
							mode = (INTEGER)(0x01b6 & ~(SET)umask(0));
							if (isShared) {
								flags = 0;
							} else {
								flags = 2;
							}
							fd = open((void*)pathname, flags, mode);
							if (fd != -1) {
								if (isShared) {
									lock.l_type = 0;
								} else {
									lock.l_type = 1;
								}
								lock.l_whence = 0;
								lock.l_start = 0;
								lock.l_len = 0;
								lock.l_pid = 0;
								res = fcntl(fd, 6, (INTEGER)&lock);
								if (res != -1) {
									f = __NEW(HostFiles_File__rec__typ);
									HostLang_HostToString((void*)pathname, 1024, (void*)f->pathname, 256, 0, &err);
									if (err == 0) {
										f->fd = fd;
										f->len = s.st_size;
										f->ino = s.st_ino;
										if (isShared) {
											f->state = 3;
										} else {
											f->state = 4;
										}
										((HostFiles_Locator)loc)->res = 0;
									} else {
										((HostFiles_Locator)loc)->res = 1;
										__34();
									}
								} else {
									HostFiles_GetError(&((HostFiles_Locator)loc)->res);
									__34();
								}
							} else {
								HostFiles_GetError(&((HostFiles_Locator)loc)->res);
							}
						} else {
							((HostFiles_Locator)loc)->res = 6;
						}
					} else {
						((HostFiles_Locator)loc)->res = 6;
					}
				} else {
					((HostFiles_Locator)loc)->res = 2;
				}
			} else {
				((HostFiles_Locator)loc)->res = 1;
			}
		} else {
			((HostFiles_Locator)loc)->res = 1;
		}
	} else {
		loc->res = 1;
	}
	Old__32_s = _s.lnk;
	__EXIT;
	return f;
}

static HostFiles_File HostFiles_Directory_Temp (HostFiles_Directory d)
{
	HostFiles_File f = NIL;
	int fd;
	SHORTCHAR name[12];
	__ENTER("HostFiles.Directory.Temp");
	__MOVE(".tmpXXXXXX", name, 11);
	fd = mkstemp((void*)name);
	__ASSERT(fd != -1, 100);
	f = __NEW(HostFiles_File__rec__typ);
	f->fd = fd;
	f->pathname[0] = 0;
	f->len = 0;
	f->ino = 0;
	f->state = 2;
	__EXIT;
	return f;
}

static void HostFiles_Directory_Delete (HostFiles_Directory d, Files_Locator loc, Files_Name name)
{
	HostFiles_NativeName pathname;
	INTEGER err;
	int res;
	CHAR _str__5[512];
	Files_Name name__copy;
	__ENTER("HostFiles.Directory.Delete");
	__DUPARR(name);
	__ASSERT(loc != NIL, 20);
	__ASSERT(HostFiles_IsName(name), 21);
	if (__ISP(loc, HostFiles_Locator__rec__typ, 1)) {
		if (HostFiles_IsName(name)) {
			__STRCOPYLL(((HostFiles_Locator)loc)->path, _str__5, 512);
			__STRAPNDLL(((CHAR[]){47, 0}), _str__5, 512);
			__STRAPNDLL(name, _str__5, 512);
			HostLang_StringToHost((void*)_str__5, __STRLEN(_str__5) + 1, (void*)pathname, 1024, 0, &err);
			if (err == 0) {
				res = unlink((void*)pathname);
				if (res == 0) {
					((HostFiles_Locator)loc)->res = 0;
				} else {
					HostFiles_GetError(&((HostFiles_Locator)loc)->res);
				}
			} else {
				((HostFiles_Locator)loc)->res = 1;
			}
		} else {
			((HostFiles_Locator)loc)->res = 1;
		}
	} else {
		loc->res = 1;
	}
	__EXIT;
}

static void HostFiles_Directory_Rename (HostFiles_Directory d, Files_Locator loc, Files_Name old, Files_Name \
new, BOOLEAN ask)
{
	HostFiles_NativeName p0, p1;
	int res;
	INTEGER err;
	CHAR _str__38[512];
	CHAR _str__37[512];
	Files_Name old__copy, new__copy;
	__ENTER("HostFiles.Directory.Rename");
	__DUPARR(old);
	__DUPARR(new);
	__ASSERT(loc != NIL, 20);
	__ASSERT(old[0] != 0, 21);
	__ASSERT(new[0] != 0, 22);
	if (__ISP(loc, HostFiles_Locator__rec__typ, 1)) {
		if (HostFiles_IsName(old) && HostFiles_IsName(new)) {
			__STRCOPYLL(((HostFiles_Locator)loc)->path, _str__38, 512);
			__STRAPNDLL(((CHAR[]){47, 0}), _str__38, 512);
			__STRAPNDLL(old, _str__38, 512);
			HostLang_StringToHost((void*)_str__38, __STRLEN(_str__38) + 1, (void*)p0, 1024, 0, &err);
			if (err == 0) {
				__STRCOPYLL(((HostFiles_Locator)loc)->path, _str__37, 512);
				__STRAPNDLL(((CHAR[]){47, 0}), _str__37, 512);
				__STRAPNDLL(new, _str__37, 512);
				HostLang_StringToHost((void*)_str__37, __STRLEN(_str__37) + 1, (void*)p1, 1024, 0, &err);
				if (err == 0) {
					res = rename((void*)p0, (void*)p1);
					if (res == 0) {
						((HostFiles_Locator)loc)->res = 0;
					} else {
						HostFiles_GetError(&((HostFiles_Locator)loc)->res);
					}
				} else {
					((HostFiles_Locator)loc)->res = 1;
				}
			} else {
				((HostFiles_Locator)loc)->res = 1;
			}
		} else {
			((HostFiles_Locator)loc)->res = 1;
		}
	} else {
		loc->res = 1;
	}
	__EXIT;
}

static BOOLEAN HostFiles_Directory_SameFile (HostFiles_Directory d, Files_Locator loc0, Files_Name name0, \
Files_Locator loc1, Files_Name name1)
{
	BOOLEAN ok;
	HostFiles_NativeName a0, a1;
	struct stat s0, s1;
	INTEGER err;
	CHAR _str__41[512];
	CHAR _str__40[512];
	Files_Name name0__copy, name1__copy;
	__ENTER("HostFiles.Directory.SameFile");
	__DUPARR(name0);
	__DUPARR(name1);
	__ASSERT(loc0 != NIL, 20);
	__ASSERT(name0[0] != 0, 21);
	__ASSERT(loc1 != NIL, 22);
	__ASSERT(name1[0] != 0, 23);
	ok = 0;
	if (__ISP(loc0, HostFiles_Locator__rec__typ, 1)) {
		if (__ISP(loc1, HostFiles_Locator__rec__typ, 1)) {
			if (HostFiles_IsName(name0) && HostFiles_IsName(name1)) {
				__STRCOPYLL(((HostFiles_Locator)loc0)->path, _str__41, 512);
				__STRAPNDLL(((CHAR[]){47, 0}), _str__41, 512);
				__STRAPNDLL(name0, _str__41, 512);
				HostLang_StringToHost((void*)_str__41, __STRLEN(_str__41) + 1, (void*)a0, 1024, 0, &err);
				if (err == 0) {
					err = C99macro_stat((void*)a0, &s0);
					if (err == 0) {
						__STRCOPYLL(((HostFiles_Locator)loc1)->path, _str__40, 512);
						__STRAPNDLL(((CHAR[]){47, 0}), _str__40, 512);
						__STRAPNDLL(name1, _str__40, 512);
						HostLang_StringToHost((void*)_str__40, __STRLEN(_str__40) + 1, (void*)a1, 1024, 0, &err);
						if (err == 0) {
							err = C99macro_stat((void*)a1, &s1);
							if (err == 0) {
								ok = s0.st_ino == s1.st_ino;
							}
						}
					}
				}
			}
		}
	}
	__EXIT;
	return ok;
}

static BOOLEAN HostFiles_IsDir (struct stat *s)
{
	__ENTER("HostFiles.IsDir");
	__EXIT;
	return ((SET)(*s).st_mode & 0xf000) == 0x4000;
}

static SET HostFiles_GetAttr (HostFiles_NativeName path, Files_Name name, struct stat s)
{
	SET attr;
	__ENTER("HostFiles.GetAttr");
	attr = 0x0;
	if (name[0] == (CHAR)L'.') {
		attr |= __SETOF(1);
	}
	if (((SET)s.st_mode & 0x01) != 0x0) {
		attr |= __SETOF(16);
	}
	if (((SET)s.st_mode & 0x02) != 0x0) {
		attr |= __SETOF(17);
	}
	if (((SET)s.st_mode & 0x04) != 0x0) {
		attr |= __SETOF(18);
	}
	if (((SET)s.st_mode & 0x08) != 0x0) {
		attr |= __SETOF(19);
	}
	if (((SET)s.st_mode & 0x10) != 0x0) {
		attr |= __SETOF(20);
	}
	if (((SET)s.st_mode & 0x20) != 0x0) {
		attr |= __SETOF(21);
	}
	if (((SET)s.st_mode & 0x40) != 0x0) {
		attr |= __SETOF(22);
	}
	if (((SET)s.st_mode & 0x80) != 0x0) {
		attr |= __SETOF(23);
	}
	if (((SET)s.st_mode & 0x0100) != 0x0) {
		attr |= __SETOF(24);
	}
	if (((SET)s.st_mode & 0x0200) != 0x0) {
		attr |= __SETOF(25);
	}
	if (((SET)s.st_mode & 0x0400) != 0x0) {
		attr |= __SETOF(26);
	}
	if (((SET)s.st_mode & 0x0800) != 0x0) {
		attr |= __SETOF(27);
	}
	if (((SET)s.st_mode & 0x0100) != 0x0) {
		attr |= __SETOF(0);
	}
	__EXIT;
	return attr;
}

static Files_FileInfo HostFiles_Directory_FileList (HostFiles_Directory d, Files_Locator loc)
{
	HostFiles_NativeName pathname;
	Files_Name name;
	INTEGER err;
	DIR* p = NIL;
	struct dirent* ent = NIL;
	struct stat s;
	int res;
	struct tm* tm = NIL;
	Files_FileInfo h = NIL;
	Files_FileInfo t = NIL;
	CHAR _str__7[512];
	__ENTER("HostFiles.Directory.FileList");
	__ASSERT(loc != NIL, 20);
	if (__ISP(loc, HostFiles_Locator__rec__typ, 1)) {
		HostLang_StringToHost((void*)((HostFiles_Locator)loc)->path, 256, (void*)pathname, 1024, 0, &err);
		if (err == 0) {
			p = opendir((void*)pathname);
			if (p != NIL) {
				ent = readdir(p);
				while (ent != NIL) {
					HostLang_HostToString((void*)ent->d_name, 256, (void*)name, 256, 0, &err);
					if (err == 0) {
						__STRCOPYLL(((HostFiles_Locator)loc)->path, _str__7, 512);
						__STRAPNDLL(((CHAR[]){47, 0}), _str__7, 512);
						__STRAPNDLL(name, _str__7, 512);
						HostLang_StringToHost((void*)_str__7, __STRLEN(_str__7) + 1, (void*)pathname, 1024, 0, &err);
						if (err == 0) {
							res = C99macro_stat((void*)pathname, &s);
							if (res == 0 && !HostFiles_IsDir(&s)) {
								if (h == NIL) {
									h = __NEW(Files_FileInfo__rec__typ);
									t = h;
								} else {
									t->next = __NEW(Files_FileInfo__rec__typ);
									t = t->next;
								}
								__STRCOPYLL(name, t->name, 256);
								t->type[0] = 0;
								t->length = s.st_size;
								tm = localtime(&s.st_mtim.tv_sec);
								if (tm != NIL) {
									t->modified.year = tm->tm_year + 1900;
									t->modified.month = tm->tm_mon + 1;
									t->modified.day = tm->tm_mday;
									t->modified.hour = tm->tm_hour;
									t->modified.minute = tm->tm_min;
									t->modified.second = tm->tm_sec;
								}
								t->attr = HostFiles_GetAttr(pathname, name, s);
							}
						}
					}
					ent = readdir(p);
				}
				res = closedir(p);
				__ASSERT(res == 0, 100);
				((HostFiles_Locator)loc)->res = 0;
			} else {
				HostFiles_GetError(&((HostFiles_Locator)loc)->res);
			}
		} else {
			((HostFiles_Locator)loc)->res = 1;
		}
	} else {
		loc->res = 1;
	}
	__EXIT;
	return h;
}

static Files_LocInfo HostFiles_Directory_LocList (HostFiles_Directory d, Files_Locator loc)
{
	HostFiles_NativeName pathname;
	Files_Name name;
	INTEGER err;
	DIR* p = NIL;
	struct dirent* ent = NIL;
	struct stat s;
	int res;
	struct tm* tm = NIL;
	Files_LocInfo h = NIL;
	Files_LocInfo t = NIL;
	CHAR _str__10[512];
	__ENTER("HostFiles.Directory.LocList");
	__ASSERT(loc != NIL, 20);
	if (__ISP(loc, HostFiles_Locator__rec__typ, 1)) {
		HostLang_StringToHost((void*)((HostFiles_Locator)loc)->path, 256, (void*)pathname, 1024, 0, &err);
		if (err == 0) {
			p = opendir((void*)pathname);
			if (p != NIL) {
				ent = readdir(p);
				while (ent != NIL) {
					HostLang_HostToString((void*)ent->d_name, 256, (void*)name, 256, 0, &err);
					if (err == 0) {
						__STRCOPYLL(((HostFiles_Locator)loc)->path, _str__10, 512);
						__STRAPNDLL(((CHAR[]){47, 0}), _str__10, 512);
						__STRAPNDLL(name, _str__10, 512);
						HostLang_StringToHost((void*)_str__10, __STRLEN(_str__10) + 1, (void*)pathname, 1024, 0, &err);
						if (err == 0) {
							res = C99macro_stat((void*)pathname, &s);
							if (((res == 0 && HostFiles_IsDir(&s)) && __STRCMPLL(name, ((CHAR[]){46, 0})) != 0) && __STRCMPLL(name, \
((CHAR[]){46, 46, 0})) != 0) {
								if (h == NIL) {
									h = __NEW(Files_LocInfo__rec__typ);
									t = h;
								} else {
									t->next = __NEW(Files_LocInfo__rec__typ);
									t = t->next;
								}
								__STRCOPYLL(name, t->name, 256);
								t->attr = HostFiles_GetAttr(pathname, name, s);
							}
						}
					}
					ent = readdir(p);
				}
				res = closedir(p);
				__ASSERT(res == 0, 100);
				((HostFiles_Locator)loc)->res = 0;
			} else {
				HostFiles_GetError(&((HostFiles_Locator)loc)->res);
			}
		} else {
			((HostFiles_Locator)loc)->res = 1;
		}
	} else {
		loc->res = 1;
	}
	__EXIT;
	return h;
}

static void HostFiles_Directory_GetFileName (HostFiles_Directory d, Files_Name name, Files_Type type, \
Files_Name filename)
{
	Files_Name name__copy;
	Files_Type type__copy;
	__ENTER("HostFiles.Directory.GetFileName");
	__DUPARR(name);
	__DUPARR(type);
	__STRCOPYLL(name, filename, 256);
	__STRAPNDLL(((CHAR[]){46, 0}), filename, 256);
	__STRAPNDLL(type, filename, 256);
	__EXIT;
}

void HostFiles_SetRootDir (CHAR *x, INTEGER x__len)
{
	__ENTER("HostFiles.SetRootDir");
	__DUP(x, x__len);
	HostFiles_root = HostFiles_NewLocator((void*)x, x__len);
	__DEL(x);
	__EXIT;
}

void HostFiles_UseAsk (void)
{
	__ENTER("HostFiles.UseAsk");
	HostFiles_ignoreAsk = 0;
	__EXIT;
}

void HostFiles_IgnoreAsk (void)
{
	__ENTER("HostFiles.IgnoreAsk");
	HostFiles_ignoreAsk = 1;
	__EXIT;
}

static void HostFiles_Init (void)
{
	HostFiles_Directory d = NIL;
	__ENTER("HostFiles.Init");
	HostFiles_SetRootDir((CHAR*)((CHAR[]){46, 0}), 2);
	d = __NEW(HostFiles_Directory__rec__typ);
	Files_SetDir((void*)d);
	__EXIT;
}

static INTEGER HostFiles_Locator__rec__flds[] = {
	1, 
	0, 4, 1<<8 | 0x25, (INTEGER)Files_Name__desc,
};
export INTEGER HostFiles_Locator__rec__desc[] = {
	-1, 
	(INTEGER)HostFiles_Locator_This, 
	0, 
	516,
	(INTEGER)&HostFiles__desc,
	6<<8 | 0x11,
	(INTEGER)(Files_Locator__rec__desc + 3),
	(INTEGER)(HostFiles_Locator__rec__desc + 3),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)HostFiles_Locator__rec__flds, 
	-4
};
static INTEGER HostFiles_Directory__rec__flds[] = {
	0, 
};
export INTEGER HostFiles_Directory__rec__desc[] = {
	-1, 
	(INTEGER)HostFiles_Directory_This, 
	(INTEGER)HostFiles_Directory_Temp, 
	(INTEGER)HostFiles_Directory_SameFile, 
	(INTEGER)HostFiles_Directory_Rename, 
	(INTEGER)HostFiles_Directory_Old, 
	(INTEGER)HostFiles_Directory_New, 
	(INTEGER)HostFiles_Directory_LocList, 
	(INTEGER)HostFiles_Directory_GetFileName, 
	(INTEGER)HostFiles_Directory_FileList, 
	(INTEGER)HostFiles_Directory_Delete, 
	0, 
	1,
	(INTEGER)&HostFiles__desc,
	15<<8 | 0x11,
	(INTEGER)(Files_Directory__rec__desc + 12),
	(INTEGER)(HostFiles_Directory__rec__desc + 12),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)HostFiles_Directory__rec__flds, 
	-4
};
static INTEGER HostFiles_File__rec__flds[] = {
	5, 
	0, 36, 26<<8 | 0x15, 6,
	0, 40, 32<<8 | 0x15, 6,
	0, 44, 36<<8 | 0x15, 6,
	0, 48, 39<<8 | 0x15, 6,
	0, 52, 43<<8 | 0x15, (INTEGER)Files_Name__desc,
};
export INTEGER HostFiles_File__rec__desc[] = {
	-1, 
	(INTEGER)HostFiles_File_Shared, 
	(INTEGER)HostFiles_File_Register, 
	(INTEGER)HostFiles_File_NewWriter, 
	(INTEGER)HostFiles_File_NewReader, 
	(INTEGER)HostFiles_File_Length, 
	0, 
	(INTEGER)HostFiles_File_Flush, 
	(INTEGER)HostFiles_File_Closed, 
	(INTEGER)HostFiles_File_Close, 
	(INTEGER)HostFiles_File_FINALIZE, 
	564,
	(INTEGER)&HostFiles__desc,
	52<<8 | 0x11,
	(INTEGER)(Files_File__rec__desc + 11),
	(INTEGER)(HostFiles_File__rec__desc + 11),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)HostFiles_File__rec__flds, 
	-4
};
static INTEGER HostFiles_Reader__rec__flds[] = {
	2, 
	0, 4, 58<<8 | 0x15, (INTEGER)HostFiles_File__desc,
	0, 8, 60<<8 | 0x15, 6,
};
export INTEGER HostFiles_Reader__rec__desc[] = {
	-1, 
	(INTEGER)HostFiles_Reader_SetPos, 
	(INTEGER)HostFiles_Reader_ReadBytes, 
	(INTEGER)HostFiles_Reader_ReadByte, 
	(INTEGER)HostFiles_Reader_Pos, 
	(INTEGER)HostFiles_Reader_Base, 
	0, 
	12,
	(INTEGER)&HostFiles__desc,
	64<<8 | 0x11,
	(INTEGER)(Files_Reader__rec__desc + 7),
	(INTEGER)(HostFiles_Reader__rec__desc + 7),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)HostFiles_Reader__rec__flds, 
	4, -8
};
export INTEGER HostFiles_File__desc[] = {
	0,
	(INTEGER)&HostFiles__desc,
	72<<8 | 0x03,
	(INTEGER)(HostFiles_File__rec__desc + 11)
};
static INTEGER HostFiles_Writer__rec__flds[] = {
	2, 
	0, 0, 58<<8 | 0x15, (INTEGER)HostFiles_File__desc,
	0, 4, 60<<8 | 0x15, 6,
};
export INTEGER HostFiles_Writer__rec__desc[] = {
	-1, 
	(INTEGER)HostFiles_Writer_WriteBytes, 
	(INTEGER)HostFiles_Writer_WriteByte, 
	(INTEGER)HostFiles_Writer_SetPos, 
	(INTEGER)HostFiles_Writer_Pos, 
	(INTEGER)HostFiles_Writer_Base, 
	0, 
	8,
	(INTEGER)&HostFiles__desc,
	77<<8 | 0x11,
	(INTEGER)(Files_Writer__rec__desc + 7),
	(INTEGER)(HostFiles_Writer__rec__desc + 7),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)HostFiles_Writer__rec__flds, 
	0, -8
};
static INTEGER HostFiles_InodeIdentifier__flds[] = {
	1, 
	0, 8, 39<<8 | 0x15, 6,
};
export INTEGER HostFiles_InodeIdentifier__desc[] = {
	-1, 
	(INTEGER)HostFiles_InodeIdentifier_Identified, 
	0, 
	12,
	(INTEGER)&HostFiles__desc,
	85<<8 | 0x11,
	(INTEGER)(Kernel_Identifier__desc + 3),
	(INTEGER)(HostFiles_InodeIdentifier__desc + 3),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)HostFiles_InodeIdentifier__flds, 
	4, -8
};
export INTEGER HostFiles_NativeName__desc[] = {
	1024,
	(INTEGER)&HostFiles__desc,
	101<<8 | 0x02,
	2
};
export INTEGER HostFiles_Locator__desc[] = {
	0,
	(INTEGER)&HostFiles__desc,
	112<<8 | 0x03,
	(INTEGER)(HostFiles_Locator__rec__desc + 3)
};
static SYSTEM_MODDESC *HostFiles__imp[] = {
	&Files__desc,
	&HostLang__desc,
	&Kernel__desc,
	&Log__desc,
	&C99macro__desc,
};
static INTEGER HostFiles__exp[] = {
	23,
	0x227d6f36, (INTEGER)HostFiles_DirName, 120<<8 | 0x14, 0,
	0x7fb2de01, 0xe4aa7d83, 15<<8 | 0x12, (INTEGER)(HostFiles_Directory__rec__desc + 12),
	0xa0706f13, 0xb1cef096, 52<<8 | 0x12, (INTEGER)(HostFiles_File__rec__desc + 11),
	0xd0a49c21, 0xd0a49c21, 128<<8 | 0x42, (INTEGER)Files_Name__desc,
	0x227d6f36, (INTEGER)HostFiles_GetAttr, 137<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)HostFiles_GetError, 145<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)HostFiles_GetFileByInode, 154<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)HostFiles_IgnoreAsk, 169<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)HostFiles_Init, 179<<8 | 0x14, 0,
	0x590ad04e, 0xbb73dfd7, 85<<8 | 0x12, (INTEGER)(HostFiles_InodeIdentifier__desc + 3),
	0x227d6f36, (INTEGER)HostFiles_IsDir, 184<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)HostFiles_IsName, 190<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)HostFiles_IsRegFile, 197<<8 | 0x14, 0,
	0x97ccf175, 0x668d363e, 6<<8 | 0x12, (INTEGER)(HostFiles_Locator__rec__desc + 3),
	0x227d6f36, (INTEGER)HostFiles_MakeDir, 207<<8 | 0x14, 0,
	0x62e54e20, 0x62e54e20, 101<<8 | 0x42, (INTEGER)HostFiles_NativeName__desc,
	0x5e54a2fb, (INTEGER)HostFiles_NewLocator, 215<<8 | 0x44, 0,
	0x5e050c90, 0x6328b3a8, 64<<8 | 0x12, (INTEGER)(HostFiles_Reader__rec__desc + 7),
	0xf082c441, (INTEGER)HostFiles_SetRootDir, 226<<8 | 0x44, 0,
	0x5814f4d6, (INTEGER)HostFiles_UseAsk, 237<<8 | 0x44, 0,
	0x48a9d25e, 0x15664cbf, 77<<8 | 0x12, (INTEGER)(HostFiles_Writer__rec__desc + 7),
	0x9ffbf5cc, (INTEGER)&HostFiles_ignoreAsk, 244<<8 | 0x23, 1,
	0xd2071b29, (INTEGER)&HostFiles_root, 254<<8 | 0x13, (INTEGER)HostFiles_Locator__desc,
};
static char HostFiles__names[] = {
	0,
	'p','a','t','h',0,
	'L','o','c','a','t','o','r','^',0,
	'D','i','r','e','c','t','o','r','y','^',0,
	's','t','a','t','e',0,
	'l','e','n',0,
	'f','d',0,
	'i','n','o',0,
	'p','a','t','h','n','a','m','e',0,
	'F','i','l','e','^',0,
	'f',0,
	'p','o','s',0,
	'R','e','a','d','e','r','^',0,
	'F','i','l','e',0,
	'W','r','i','t','e','r','^',0,
	'I','n','o','d','e','I','d','e','n','t','i','f','i','e','r',0,
	'N','a','t','i','v','e','N','a','m','e',0,
	'L','o','c','a','t','o','r',0,
	'D','i','r','N','a','m','e',0,
	'F','u','l','l','N','a','m','e',0,
	'G','e','t','A','t','t','r',0,
	'G','e','t','E','r','r','o','r',0,
	'G','e','t','F','i','l','e','B','y','I','n','o','d','e',0,
	'I','g','n','o','r','e','A','s','k',0,
	'I','n','i','t',0,
	'I','s','D','i','r',0,
	'I','s','N','a','m','e',0,
	'I','s','R','e','g','F','i','l','e',0,
	'M','a','k','e','D','i','r',0,
	'N','e','w','L','o','c','a','t','o','r',0,
	'S','e','t','R','o','o','t','D','i','r',0,
	'U','s','e','A','s','k',0,
	'i','g','n','o','r','e','A','s','k',0,
	'r','o','o','t',0,
};
static INTEGER HostFiles__ptrs[] = {
	(INTEGER)&HostFiles_root + 0, 
};
struct SYSTEM_MODDESC HostFiles__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 4}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	HostFiles__body,
	0,
	5, /* nofimps */ 
	1, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	HostFiles__names,
	HostFiles__ptrs,
	HostFiles__imp,
	(SYSTEM_DIRECTORY*)HostFiles__exp,
	"HostFiles"
};

export void HostFiles__reg()
{
	__BEGREG(HostFiles__desc);
	Kernel__reg();
	HostLang__reg();
	Files__reg();
	Log__reg();
	C99macro__reg();
	__REGMOD(HostFiles__desc);
	HostFiles_Locator__rec__desc[2] = Files_Locator__rec__desc[2];
	HostFiles_Directory__rec__desc[11] = Files_Directory__rec__desc[11];
	HostFiles_File__rec__desc[6] = Files_File__rec__desc[6];
	HostFiles_Reader__rec__desc[6] = Files_Reader__rec__desc[6];
	HostFiles_Writer__rec__desc[6] = Files_Writer__rec__desc[6];
	HostFiles_InodeIdentifier__desc[2] = Kernel_Identifier__desc[2];
	__ENDREG;
}

export void HostFiles__body()
{
	__BEGBODY(HostFiles__desc);
	Kernel__body();
	HostLang__body();
	Files__body();
	Log__body();
	C99macro__body();
	HostFiles_Init();
	__ENDBODY;
}
