/*  CPfront 1.0 -48 */
#include "SYSTEM.h"




export INTEGER Int_Div (INTEGER x, INTEGER y);
static INTEGER Int_Div0 (INTEGER a, INTEGER b);
export INTEGER Int_Mod (INTEGER x, INTEGER y);
static INTEGER Int_Mod0 (INTEGER a, INTEGER b);
export INTEGER Int_Mul (INTEGER a, INTEGER b);

export void Int__reg();
export void Int__body();
export struct SYSTEM_MODDESC Int__desc;


INTEGER Int_Mul (INTEGER a, INTEGER b)
{
	INTEGER c;
	__ENTER("Int.Mul");
	c = 0;
	while (a >= 1) {
		if (__ODD(a)) {
			c += b;
		}
		a = __ASHR(a, 1, INTEGER);
		b = __ASHL(b, 1, INTEGER);
	}
	__EXIT;
	return c;
}

static INTEGER Int_Div0 (INTEGER a, INTEGER b)
{
	INTEGER r, s;
	__ENTER("Int.Div0");
	s = 1;
	r = 0;
	if (a < 0) {
		a = -a;
		s = -s;
	}
	if (b < 0) {
		b = -b;
		s = -s;
	}
	while (a >= 0) {
		a -= b;
		r += 1;
	}
	__EXIT;
	return (r - 1) * s;
}

INTEGER Int_Div (INTEGER x, INTEGER y)
{
	__ENTER("Int.Div");
	if (y > 0) {
		if (x < 0) {
			__EXIT;
			return (INTEGER)(~((SET)Int_Div0((INTEGER)(~((SET)x)), y)));
		} else {
			__EXIT;
			return Int_Div0(x, y);
		}
	} else if (y < 0) {
		if (x > 0) {
			__EXIT;
			return (INTEGER)(~((SET)Int_Div0(x - 1, -y)));
		} else {
			__EXIT;
			return Int_Div0(-x, -y);
		}
	} else {
		__HALT(0);
	}
	__RETCHK;
}

static INTEGER Int_Mod0 (INTEGER a, INTEGER b)
{
	INTEGER i, res;
	__ENTER("Int.Mod0");
	i = 1;
	res = 0;
	if (a < 0) {
		a = -a;
	}
	if (b < 0) {
		b = -b;
	}
	while (res <= a) {
		res = b * i;
		i += 1;
	}
	__EXIT;
	return a - (res - b);
}

INTEGER Int_Mod (INTEGER x, INTEGER y)
{
	__ENTER("Int.Mod");
	if (y > 0) {
		if (x < 0) {
			__EXIT;
			return y + (INTEGER)(~((SET)Int_Mod0((INTEGER)(~((SET)x)), y)));
		} else {
			__EXIT;
			return Int_Mod0(x, y);
		}
	} else if (y < 0) {
		if (x > 0) {
			__EXIT;
			return (y + 1) + Int_Mod0(x - 1, -y);
		} else {
			__EXIT;
			return -Int_Mod0(-x, -y);
		}
	} else {
		__HALT(0);
	}
	__RETCHK;
}

static SYSTEM_MODDESC *Int__imp[] = {
	0
};
static INTEGER Int__exp[] = {
	5,
	0xbbb8c781, (INTEGER)Int_Div, 1<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Int_Div0, 5<<8 | 0x14, 0,
	0xbbb8c781, (INTEGER)Int_Mod, 10<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Int_Mod0, 14<<8 | 0x14, 0,
	0xbbb8c781, (INTEGER)Int_Mul, 19<<8 | 0x44, 0,
};
static char Int__names[] = {
	0,
	'D','i','v',0,
	'D','i','v','0',0,
	'M','o','d',0,
	'M','o','d','0',0,
	'M','u','l',0,
};
static INTEGER Int__ptrs[] = {
	0
};
struct SYSTEM_MODDESC Int__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 2}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Int__body,
	0,
	0, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Int__names,
	Int__ptrs,
	Int__imp,
	(SYSTEM_DIRECTORY*)Int__exp,
	"Int"
};

export void Int__reg()
{
	__BEGREG(Int__desc);
	__REGMOD(Int__desc);
	__ENDREG;
}

export void Int__body()
{
	__BEGBODY(Int__desc);
	__ENDBODY;
}
