/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Files.h"
#include "Math.h"

typedef
	SHORTINT Integers_Digit;

typedef
	Integers_Digit *Integers_IntegerDesc;

typedef
	struct SHORTINT_ARRAY *Integers_Integer;

typedef
	INTEGER Integers_Index;

typedef
	struct Integers_Buffer {
		Integers_Integer digit;
		Integers_Index beg, len;
	} Integers_Buffer;

typedef
	INTEGER Integers_DoubleDigit;


static Integers_Integer Integers_zero, Integers_one, Integers_two, Integers_buf6;

export INTEGER Integers_Buffer__desc[];
export SYSTEM_TYPEDESC *Integers_Buffer__typ = (SYSTEM_TYPEDESC*)(Integers_Buffer__desc + 2);
export INTEGER Integers_Integer__desc[];
export SYSTEM_TYPEDESC *Integers_Integer__typ = (SYSTEM_TYPEDESC*)Integers_Integer__desc;
export INTEGER Integers_IntegerDesc__desc[];
export SYSTEM_TYPEDESC *Integers_IntegerDesc__typ = (SYSTEM_TYPEDESC*)Integers_IntegerDesc__desc;

export Integers_Integer Integers_Abs (Integers_Integer x);
static void Integers_Add (Integers_Integer x, Integers_Integer y, Integers_Integer sum, Integers_Index \
xL, Integers_Index yL, Integers_Index *sumL);
static void Integers_AddBuf (Integers_Buffer a, Integers_Buffer b, Integers_Buffer *c, SYSTEM_TYPEDESC \
*c__typ);
static Integers_Integer Integers_AddOp (Integers_Integer x, Integers_Integer y, BOOLEAN subtract);
static void Integers_AddToBuf (Integers_Buffer *a, SYSTEM_TYPEDESC *a__typ, Integers_Buffer b, Integers_Index \
shift);
static void Integers_BinPower (Integers_Integer x, INTEGER exp, Integers_Integer y, Integers_Index xL, \
Integers_Index *yL);
export INTEGER Integers_Compare (Integers_Integer x, Integers_Integer y);
export void Integers_ConvertFromString (CHAR *s, INTEGER s__len, Integers_Integer *x);
export void Integers_ConvertToString (Integers_Integer x, CHAR *s, INTEGER s__len);
static Integers_Integer Integers_CopyOf (Integers_Integer x, Integers_Index len);
static void Integers_DecomposeQuoRem (Integers_Integer x, Integers_Integer y, Integers_Index xL, Integers_Index \
yL);
export Integers_Integer Integers_Difference (Integers_Integer x, Integers_Integer y);
export INTEGER Integers_Digits10Of (Integers_Integer x);
export Integers_Integer Integers_Entier (REAL x);
export void Integers_Externalize (Files_Writer w, Integers_Integer x);
export REAL Integers_Float (Integers_Integer x);
export Integers_Integer Integers_GCD (Integers_Integer x, Integers_Integer y);
static void Integers_GetLength (Integers_Integer x, Integers_Index *len, BOOLEAN *negative);
static void Integers_GetQuoRem (Integers_Integer x, Integers_Integer y, Integers_Index xL, Integers_Index \
yL, BOOLEAN xNeg, BOOLEAN yNeg, Integers_Integer quo, Integers_Integer rem, Integers_Index *quoL, Integers_Index \
*remL, BOOLEAN *quoNeg, BOOLEAN *remNeg, BOOLEAN doQuo, BOOLEAN doRem);
export void Integers_Internalize (Files_Reader r, Integers_Integer *x);
static void Integers_KStep (Integers_Buffer a, Integers_Buffer b, Integers_Buffer *c, SYSTEM_TYPEDESC \
*c__typ, Integers_Buffer stack);
static void Integers_Karatsuba (Integers_Integer x, Integers_Integer y, Integers_Integer pro, Integers_Index \
xL, Integers_Index yL, Integers_Index *proL);
export Integers_Integer Integers_Long (LONGINT x);
static void Integers_Multiply (Integers_Integer x, Integers_Integer y, Integers_Integer pro, Integers_Index \
xL, Integers_Index yL, Integers_Index *proL);
static Integers_Integer Integers_New (Integers_Index nofDigits);
static void Integers_OneDigitMult (Integers_Buffer a, Integers_Buffer b, Integers_Buffer *c, SYSTEM_TYPEDESC \
*c__typ);
export Integers_Integer Integers_Power (Integers_Integer x, INTEGER exp);
export Integers_Integer Integers_Product (Integers_Integer x, Integers_Integer y);
export void Integers_QuoRem (Integers_Integer x, Integers_Integer y, Integers_Integer *quo, Integers_Integer \
*rem);
export Integers_Integer Integers_Quotient (Integers_Integer x, Integers_Integer y);
export Integers_Integer Integers_Remainder (Integers_Integer x, Integers_Integer y);
static void Integers_SetLength (Integers_Integer x, Integers_Index len, BOOLEAN negative);
export LONGINT Integers_Short (Integers_Integer x);
export INTEGER Integers_Sign (Integers_Integer x);
static void Integers_SimpleMult (Integers_Buffer a, Integers_Buffer b, Integers_Buffer *c, SYSTEM_TYPEDESC \
*c__typ);
static void Integers_Subtract (Integers_Integer x, Integers_Integer y, Integers_Integer dif, Integers_Index \
xL, Integers_Index yL, Integers_Index *difL);
static void Integers_SubtractFromBuf (Integers_Buffer *a, SYSTEM_TYPEDESC *a__typ, Integers_Buffer b, \
Integers_Buffer c);
export Integers_Integer Integers_Sum (Integers_Integer x, Integers_Integer y);
export CHAR Integers_ThisDigit10 (Integers_Integer x, INTEGER exp10);

export void Integers__reg();
export void Integers__body();
export struct SYSTEM_MODDESC Integers__desc;


static Integers_Integer Integers_CopyOf (Integers_Integer x, Integers_Index len)
{
	Integers_Integer buf = NIL;
	__ENTER("Integers.CopyOf");
	__ASSERT(len > 0, 20);
	buf = __NEWARR(2, len);
	do {
		len -= 1;
		(buf->data)[__X(len, buf->len[0])] = (x->data)[__X(len, x->len[0])];
	} while (!(len == 0));
	__EXIT;
	return buf;
}

static void Integers_Add (Integers_Integer x, Integers_Integer y, Integers_Integer sum, Integers_Index \
xL, Integers_Index yL, Integers_Index *sumL)
{
	Integers_Index i, l;
	Integers_Digit c;
	__ENTER("Integers.Add");
	l = __MIN(xL, yL);
	i = 0;
	c = 0;
	while (i < l) {
		c = (SHORTINT)((__DIV((INTEGER)c, 10000) + (INTEGER)(x->data)[__X(i, x->len[0])]) + (INTEGER)(y->data)[__X(i, \
y->len[0])]);
		(sum->data)[__X(i, sum->len[0])] = (SHORTINT)__MOD((INTEGER)c, 10000);
		i += 1;
	}
	while (i < xL) {
		c = (SHORTINT)(__DIV((INTEGER)c, 10000) + (INTEGER)(x->data)[__X(i, x->len[0])]);
		(sum->data)[__X(i, sum->len[0])] = (SHORTINT)__MOD((INTEGER)c, 10000);
		i += 1;
	}
	while (i < yL) {
		c = (SHORTINT)(__DIV((INTEGER)c, 10000) + (INTEGER)(y->data)[__X(i, y->len[0])]);
		(sum->data)[__X(i, sum->len[0])] = (SHORTINT)__MOD((INTEGER)c, 10000);
		i += 1;
	}
	if ((INTEGER)c >= 10000) {
		(sum->data)[__X(i, sum->len[0])] = (SHORTINT)__DIV((INTEGER)c, 10000);
		i += 1;
	}
	*sumL = i;
	__EXIT;
}

static void Integers_Subtract (Integers_Integer x, Integers_Integer y, Integers_Integer dif, Integers_Index \
xL, Integers_Index yL, Integers_Index *difL)
{
	Integers_Index i;
	Integers_Digit c, d;
	__ENTER("Integers.Subtract");
	__ASSERT(xL >= yL, 20);
	i = 0;
	*difL = 0;
	c = 0;
	while (i < yL) {
		c = (SHORTINT)((__DIV((INTEGER)c, 10000) + (INTEGER)(x->data)[__X(i, x->len[0])]) - (INTEGER)(y->data)[__X(i, \
y->len[0])]);
		d = (SHORTINT)__MOD((INTEGER)c, 10000);
		if ((INTEGER)d != 0) {
			while (*difL != i) {
				(dif->data)[__X(*difL, dif->len[0])] = 0;
				*difL += 1;
			}
			(dif->data)[__X(i, dif->len[0])] = d;
			*difL += 1;
		}
		i += 1;
	}
	while (i < xL) {
		c = (SHORTINT)(__DIV((INTEGER)c, 10000) + (INTEGER)(x->data)[__X(i, x->len[0])]);
		d = (SHORTINT)__MOD((INTEGER)c, 10000);
		if ((INTEGER)d != 0) {
			while (*difL != i) {
				(dif->data)[__X(*difL, dif->len[0])] = 0;
				*difL += 1;
			}
			(dif->data)[__X(i, dif->len[0])] = d;
			*difL += 1;
		}
		i += 1;
	}
	__ASSERT(__DIV((INTEGER)c, 10000) == 0, 100);
	__EXIT;
}

static void Integers_OneDigitMult (Integers_Buffer a, Integers_Buffer b, Integers_Buffer *c, SYSTEM_TYPEDESC \
*c__typ)
{
	Integers_Index i;
	Integers_DoubleDigit carry, factor;
	__ENTER("Integers.OneDigitMult");
	__ASSERT(a.len == 1, 20);
	factor = (a.digit->data)[__X(a.beg, a.digit->len[0])];
	i = 0;
	carry = 0;
	while (i != b.len) {
		carry = __DIV(carry, 10000) + factor * (INTEGER)(b.digit->data)[__X(b.beg + i, b.digit->len[0])];
		((*c).digit->data)[__X((*c).beg + i, (*c).digit->len[0])] = (SHORTINT)__MOD(carry, 10000);
		i += 1;
	}
	if (carry >= 10000) {
		((*c).digit->data)[__X((*c).beg + i, (*c).digit->len[0])] = (SHORTINT)__DIV(carry, 10000);
		i += 1;
	}
	(*c).len = i;
	__EXIT;
}

static void Integers_SimpleMult (Integers_Buffer a, Integers_Buffer b, Integers_Buffer *c, SYSTEM_TYPEDESC \
*c__typ)
{
	Integers_Index i, j, k;
	Integers_DoubleDigit c0, c1;
	__ENTER("Integers.SimpleMult");
	__ASSERT(a.len <= b.len, 20);
	(*c).len = (a.len + b.len) - 1;
	i = 0;
	c0 = 0;
	c1 = 0;
	do {
		if (i < b.len) {
			if (i < a.len) {
				j = i;
				k = 0;
			} else {
				j = a.len - 1;
				k = (i - a.len) + 1;
			}
			do {
				c0 = c0 + (INTEGER)(a.digit->data)[__X(a.beg + j, a.digit->len[0])] * (INTEGER)(b.digit->data)[__X(b.beg \
+ k, b.digit->len[0])];
				if (c0 > 1983660031) {
					c1 = c1 + __ASHR(c0, 14, Integers_DoubleDigit);
					c0 = __MASK(c0, -16384);
				}
				j -= 1;
				k += 1;
			} while (!(j < 0));
		} else {
			j = a.len - 1;
			k = (i - a.len) + 1;
			do {
				c0 = c0 + (INTEGER)(a.digit->data)[__X(a.beg + j, a.digit->len[0])] * (INTEGER)(b.digit->data)[__X(b.beg \
+ k, b.digit->len[0])];
				if (c0 > 1983660031) {
					c1 = c1 + __ASHR(c0, 14, Integers_DoubleDigit);
					c0 = __MASK(c0, -16384);
				}
				j -= 1;
				k += 1;
			} while (!(k == b.len));
		}
		if (c1 == 0) {
			((*c).digit->data)[__X((*c).beg + i, (*c).digit->len[0])] = (SHORTINT)__MOD(c0, 10000);
			c0 = __DIV(c0, 10000);
		} else {
			c0 = c0 + __ASHL(__MOD(c1, 10000), 14, Integers_DoubleDigit);
			((*c).digit->data)[__X((*c).beg + i, (*c).digit->len[0])] = (SHORTINT)__MOD(c0, 10000);
			c0 = __DIV(c0, 10000);
			c1 = __DIV(c1, 10000);
		}
		i += 1;
	} while (!(i == (*c).len));
	if (c0 != 0) {
		((*c).digit->data)[__X((*c).beg + (*c).len, (*c).digit->len[0])] = (SHORTINT)c0;
		(*c).len += 1;
	}
	__EXIT;
}

static void Integers_AddBuf (Integers_Buffer a, Integers_Buffer b, Integers_Buffer *c, SYSTEM_TYPEDESC \
*c__typ)
{
	Integers_Index i;
	Integers_Digit carry;
	__ENTER("Integers.AddBuf");
	__ASSERT(a.len <= b.len, 20);
	i = 0;
	carry = 0;
	while (i != a.len) {
		carry = (SHORTINT)((__DIV((INTEGER)carry, 10000) + (INTEGER)(a.digit->data)[__X(a.beg + i, a.digit->len[0])]) \
+ (INTEGER)(b.digit->data)[__X(b.beg + i, b.digit->len[0])]);
		((*c).digit->data)[__X((*c).beg + i, (*c).digit->len[0])] = (SHORTINT)__MOD((INTEGER)carry, 10000);
		i += 1;
	}
	while (i != b.len && (INTEGER)carry >= 10000) {
		carry = (SHORTINT)(__DIV((INTEGER)carry, 10000) + (INTEGER)(b.digit->data)[__X(b.beg + i, b.digit->len[0])]);
		((*c).digit->data)[__X((*c).beg + i, (*c).digit->len[0])] = (SHORTINT)__MOD((INTEGER)carry, 10000);
		i += 1;
	}
	if ((INTEGER)carry >= 10000) {
		((*c).digit->data)[__X((*c).beg + i, (*c).digit->len[0])] = (SHORTINT)__DIV((INTEGER)carry, 10000);
		i += 1;
	} else {
		while (i != b.len) {
			((*c).digit->data)[__X((*c).beg + i, (*c).digit->len[0])] = (b.digit->data)[__X(b.beg + i, b.digit->len[0])];
			i += 1;
		}
	}
	(*c).len = i;
	__EXIT;
}

static void Integers_AddToBuf (Integers_Buffer *a, SYSTEM_TYPEDESC *a__typ, Integers_Buffer b, Integers_Index \
shift)
{
	Integers_Index i, n;
	Integers_Digit carry;
	__ENTER("Integers.AddToBuf");
	b.beg = b.beg - shift;
	b.len = b.len + shift;
	i = shift;
	n = __MIN((*a).len, b.len);
	carry = 0;
	while (i != n) {
		carry = (SHORTINT)((__DIV((INTEGER)carry, 10000) + (INTEGER)((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])]) \
+ (INTEGER)(b.digit->data)[__X(b.beg + i, b.digit->len[0])]);
		((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (SHORTINT)__MOD((INTEGER)carry, 10000);
		i += 1;
	}
	if (i != (*a).len) {
		while (i != (*a).len && (INTEGER)carry >= 10000) {
			carry = (SHORTINT)(__DIV((INTEGER)carry, 10000) + (INTEGER)((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])]);
			((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (SHORTINT)__MOD((INTEGER)carry, 10000);
			i += 1;
		}
		if ((INTEGER)carry >= 10000) {
			((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (SHORTINT)__DIV((INTEGER)carry, 10000);
			i += 1;
		}
	} else {
		while (i != b.len && (INTEGER)carry >= 10000) {
			carry = (SHORTINT)(__DIV((INTEGER)carry, 10000) + (INTEGER)(b.digit->data)[__X(b.beg + i, b.digit->len[0])]);
			((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (SHORTINT)__MOD((INTEGER)carry, 10000);
			i += 1;
		}
		if ((INTEGER)carry >= 10000) {
			((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (SHORTINT)__DIV((INTEGER)carry, 10000);
			i += 1;
		} else {
			while (i != b.len) {
				((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (b.digit->data)[__X(b.beg + i, b.digit->len[0])];
				i += 1;
			}
		}
	}
	(*a).len = __MAX(i, (*a).len);
	__EXIT;
}

static void Integers_SubtractFromBuf (Integers_Buffer *a, SYSTEM_TYPEDESC *a__typ, Integers_Buffer b, \
Integers_Buffer c)
{
	Integers_Index i;
	Integers_Digit carry;
	__ENTER("Integers.SubtractFromBuf");
	__ASSERT(b.len <= c.len, 20);
	i = 0;
	carry = 0;
	while (i != b.len) {
		carry = (SHORTINT)(((__DIV((INTEGER)carry, 10000) + (INTEGER)((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])]) \
- (INTEGER)(b.digit->data)[__X(b.beg + i, b.digit->len[0])]) - (INTEGER)(c.digit->data)[__X(c.beg + i, \
c.digit->len[0])]);
		((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (SHORTINT)__MOD((INTEGER)carry, 10000);
		i += 1;
	}
	while (i != c.len) {
		carry = (SHORTINT)((__DIV((INTEGER)carry, 10000) + (INTEGER)((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])]) \
- (INTEGER)(c.digit->data)[__X(c.beg + i, c.digit->len[0])]);
		((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (SHORTINT)__MOD((INTEGER)carry, 10000);
		i += 1;
	}
	while ((INTEGER)carry < 0) {
		carry = (SHORTINT)(__DIV((INTEGER)carry, 10000) + (INTEGER)((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])]);
		((*a).digit->data)[__X((*a).beg + i, (*a).digit->len[0])] = (SHORTINT)__MOD((INTEGER)carry, 10000);
		i += 1;
	}
	__ASSERT(i <= (*a).len, 100);
	while ((*a).len != 0 && (INTEGER)((*a).digit->data)[__X(((*a).beg + (*a).len) - 1, (*a).digit->len[0])] \
== 0) {
		(*a).len -= 1;
	}
	__EXIT;
}

static void Integers_KStep (Integers_Buffer a, Integers_Buffer b, Integers_Buffer *c, SYSTEM_TYPEDESC \
*c__typ, Integers_Buffer stack)
{
	Integers_Index n2, i;
	Integers_Buffer a0 = {0}, a1 = {0}, b0 = {0}, b1 = {0}, c0 = {0}, c1 = {0}, h = {0};
	__ENTER("Integers.KStep");
	__ASSERT(a.len <= b.len, 20);
	if (a.len == 0) {
		(*c).len = 0;
	} else if (a.len == 1) {
		Integers_OneDigitMult(a, b, c, c__typ);
	} else if (a.len <= 41) {
		Integers_SimpleMult(a, b, c, c__typ);
	} else {
		n2 = __ASHR(b.len, 1, Integers_Index);
		c0.digit = (*c).digit;
		c0.beg = (*c).beg;
		c1.digit = (*c).digit;
		c1.beg = (*c).beg + __ASHL(n2, 1, Integers_Index);
		a0.digit = a.digit;
		a0.beg = a.beg;
		a0.len = __MIN(a.len, n2);
		a1.digit = a.digit;
		a1.beg = a.beg + n2;
		a1.len = __MAX(0, a.len - n2);
		while (a0.len != 0 && (INTEGER)(a0.digit->data)[__X((a0.beg + a0.len) - 1, a0.digit->len[0])] == 0) \
{
			a0.len -= 1;
		}
		b0.digit = b.digit;
		b0.beg = b.beg;
		b0.len = __MIN(b.len, n2);
		b1.digit = b.digit;
		b1.beg = b.beg + n2;
		b1.len = __MAX(0, b.len - n2);
		while (b0.len != 0 && (INTEGER)(b0.digit->data)[__X((b0.beg + b0.len) - 1, b0.digit->len[0])] == 0) \
{
			b0.len -= 1;
		}
		if (a0.len != 0 || b0.len != 0) {
			if (a0.len <= a1.len) {
				Integers_AddBuf(a0, a1, &c1, Integers_Buffer__typ);
			} else {
				Integers_AddBuf(a1, a0, &c1, Integers_Buffer__typ);
			}
			if (b0.len <= b1.len) {
				Integers_AddBuf(b0, b1, &c0, Integers_Buffer__typ);
			} else {
				Integers_AddBuf(b1, b0, &c0, Integers_Buffer__typ);
			}
			h.digit = stack.digit;
			h.beg = stack.beg;
			stack.beg = (stack.beg + c0.len) + c1.len;
			if (c0.len <= c1.len) {
				Integers_KStep(c0, c1, &h, Integers_Buffer__typ, stack);
			} else {
				Integers_KStep(c1, c0, &h, Integers_Buffer__typ, stack);
			}
			if (a0.len <= b0.len) {
				Integers_KStep(a0, b0, &c0, Integers_Buffer__typ, stack);
			} else {
				Integers_KStep(b0, a0, &c0, Integers_Buffer__typ, stack);
			}
			Integers_KStep(a1, b1, &c1, Integers_Buffer__typ, stack);
			if (c0.len <= c1.len) {
				Integers_SubtractFromBuf(&h, Integers_Buffer__typ, c0, c1);
			} else {
				Integers_SubtractFromBuf(&h, Integers_Buffer__typ, c1, c0);
			}
			if (c1.len != 0) {
				i = c0.beg + c0.len;
				while (i < c1.beg) {
					((*c).digit->data)[__X(i, (*c).digit->len[0])] = 0;
					i += 1;
				}
				(*c).len = (c1.beg + c1.len) - (*c).beg;
			} else {
				while (c0.len < n2) {
					(c0.digit->data)[__X(c0.beg + c0.len, c0.digit->len[0])] = 0;
					c0.len += 1;
				}
				(*c).len = c0.len;
			}
			__ASSERT(h.len != 0, 100);
			Integers_AddToBuf(c, c__typ, h, n2);
		} else {
			Integers_KStep(a1, b1, &c1, Integers_Buffer__typ, stack);
			(*c).len = (c1.beg + c1.len) - (*c).beg;
			i = (*c).beg;
			while (i != c1.beg) {
				((*c).digit->data)[__X(i, (*c).digit->len[0])] = 0;
				i += 1;
			}
		}
	}
	__EXIT;
}

static void Integers_Karatsuba (Integers_Integer x, Integers_Integer y, Integers_Integer pro, Integers_Index \
xL, Integers_Index yL, Integers_Index *proL)
{
	Integers_Buffer a = {0}, b = {0}, c = {0}, stack = {0};
	__ENTER("Integers.Karatsuba");
	__ASSERT(xL <= yL, 20);
	a.digit = x;
	a.beg = 0;
	a.len = xL;
	b.digit = y;
	b.beg = 0;
	b.len = yL;
	c.digit = pro;
	c.beg = 0;
	stack.digit = __NEWARR(2, __ASHL(b.len, 1, Integers_Index));
	stack.beg = 0;
	Integers_KStep(a, b, &c, Integers_Buffer__typ, stack);
	*proL = c.len;
	__EXIT;
}

static void Integers_Multiply (Integers_Integer x, Integers_Integer y, Integers_Integer pro, Integers_Index \
xL, Integers_Index yL, Integers_Index *proL)
{
	Integers_Index i, j, k;
	Integers_DoubleDigit c0, c1;
	__ENTER("Integers.Multiply");
	__ASSERT(xL <= yL, 20);
	if (xL > 41) {
		Integers_Karatsuba(x, y, pro, xL, yL, proL);
	} else if (xL == 1) {
		*proL = 0;
		c1 = (x->data)[0];
		c0 = 0;
		while (*proL < yL) {
			c0 = c1 * (INTEGER)(y->data)[__X(*proL, y->len[0])] + c0;
			(pro->data)[__X(*proL, pro->len[0])] = (SHORTINT)__MOD(c0, 10000);
			c0 = __DIV(c0, 10000);
			*proL += 1;
		}
		if (c0 != 0) {
			(pro->data)[__X(*proL, pro->len[0])] = (SHORTINT)c0;
			*proL += 1;
		}
	} else {
		*proL = (xL + yL) - 1;
		i = 0;
		c0 = 0;
		c1 = 0;
		do {
			if (i < yL) {
				if (i < xL) {
					j = i;
					k = 0;
				} else {
					j = xL - 1;
					k = (i - xL) + 1;
				}
				do {
					c0 = c0 + (INTEGER)(x->data)[__X(j, x->len[0])] * (INTEGER)(y->data)[__X(k, y->len[0])];
					if (c0 > 1983660031) {
						c1 = c1 + __ASHR(c0, 14, Integers_DoubleDigit);
						c0 = __MASK(c0, -16384);
					}
					j -= 1;
					k += 1;
				} while (!(j < 0));
			} else {
				j = xL - 1;
				k = (i - xL) + 1;
				do {
					c0 = c0 + (INTEGER)(x->data)[__X(j, x->len[0])] * (INTEGER)(y->data)[__X(k, y->len[0])];
					if (c0 > 1983660031) {
						c1 = c1 + __ASHR(c0, 14, Integers_DoubleDigit);
						c0 = __MASK(c0, -16384);
					}
					j -= 1;
					k += 1;
				} while (!(k == yL));
			}
			if (c1 == 0) {
				(pro->data)[__X(i, pro->len[0])] = (SHORTINT)__MOD(c0, 10000);
				c0 = __DIV(c0, 10000);
			} else {
				c0 = c0 + __ASHL(__MOD(c1, 10000), 14, Integers_DoubleDigit);
				(pro->data)[__X(i, pro->len[0])] = (SHORTINT)__MOD(c0, 10000);
				c0 = __DIV(c0, 10000);
				c1 = __DIV(c1, 10000);
			}
			i += 1;
		} while (!(i == *proL));
		if (c0 != 0) {
			(pro->data)[__X(*proL, pro->len[0])] = (SHORTINT)c0;
			*proL += 1;
		}
	}
	__EXIT;
}

static void Integers_DecomposeQuoRem (Integers_Integer x, Integers_Integer y, Integers_Index xL, Integers_Index \
yL)
{
	Integers_Index ix, iy, j;
	Integers_DoubleDigit d, q, h, yLead, ySecond;
	Integers_Integer yBuf = NIL;
	__ENTER("Integers.DecomposeQuoRem");
	__ASSERT(yL != 0 && (INTEGER)(y->data)[__X(yL - 1, y->len[0])] != 0, 20);
	if (yL == 1) {
		j = xL - 1;
		h = 0;
		d = (y->data)[0];
		while (j >= 0) {
			h = (INTEGER)(x->data)[__X(j, x->len[0])] + h * 10000;
			(x->data)[__X(j + 1, x->len[0])] = (SHORTINT)__DIVF(h, d);
			h = __MODF(h, d);
			j -= 1;
		}
		(x->data)[0] = (SHORTINT)h;
	} else if (xL >= yL) {
		(x->data)[__X(xL, x->len[0])] = 0;
		d = __DIVF(4999, (INTEGER)(y->data)[__X(yL - 1, y->len[0])]) + 1;
		yBuf = Integers_CopyOf(y, yL);
		if (d != 1) {
			j = 0;
			h = 0;
			while (j < xL) {
				h = d * (INTEGER)(x->data)[__X(j, x->len[0])] + __DIV(h, 10000);
				(x->data)[__X(j, x->len[0])] = (SHORTINT)__MOD(h, 10000);
				j += 1;
			}
			(x->data)[__X(xL, x->len[0])] = (SHORTINT)__DIV(h, 10000);
			j = 0;
			h = 0;
			while (j < yL) {
				h = d * (INTEGER)(yBuf->data)[__X(j, yBuf->len[0])] + __DIV(h, 10000);
				(yBuf->data)[__X(j, yBuf->len[0])] = (SHORTINT)__MOD(h, 10000);
				j += 1;
			}
			__ASSERT(__DIV(h, 10000) == 0, 100);
		}
		yLead = (yBuf->data)[__X(yL - 1, yBuf->len[0])];
		ySecond = (yBuf->data)[__X(yL - 2, yBuf->len[0])];
		j = xL;
		while (j >= yL) {
			if ((INTEGER)(x->data)[__X(j, x->len[0])] != yLead) {
				q = __DIVF((INTEGER)(x->data)[__X(j, x->len[0])] * 10000 + (INTEGER)(x->data)[__X(j - 1, x->len[0])], \
yLead);
			} else {
				q = 9999;
			}
			while (ySecond * q > (((INTEGER)(x->data)[__X(j, x->len[0])] * 10000 + (INTEGER)(x->data)[__X(j - 1, \
x->len[0])]) - yLead * q) * 10000 + (INTEGER)(x->data)[__X(j - 2, x->len[0])]) {
				q -= 1;
			}
			ix = j - yL;
			iy = 0;
			h = 0;
			while (iy < yL) {
				h = ((INTEGER)(x->data)[__X(ix, x->len[0])] - q * (INTEGER)(yBuf->data)[__X(iy, yBuf->len[0])]) + \
__DIV(h, 10000);
				(x->data)[__X(ix, x->len[0])] = (SHORTINT)__MOD(h, 10000);
				ix += 1;
				iy += 1;
			}
			if (-((INTEGER)(x->data)[__X(j, x->len[0])]) != __DIV(h, 10000)) {
				ix = j - yL;
				iy = 0;
				h = 0;
				while (iy < yL) {
					h = (__DIV(h, 10000) + (INTEGER)(x->data)[__X(ix, x->len[0])]) + (INTEGER)(yBuf->data)[__X(iy, yBuf->len[0])];
					(x->data)[__X(ix, x->len[0])] = (SHORTINT)__MOD(h, 10000);
					ix += 1;
					iy += 1;
				}
				(x->data)[__X(j, x->len[0])] = (SHORTINT)(q - 1);
			} else {
				(x->data)[__X(j, x->len[0])] = (SHORTINT)q;
			}
			j -= 1;
		}
		if (d != 1) {
			j = yL;
			h = 0;
			while (j != 0) {
				j -= 1;
				h = h + (INTEGER)(x->data)[__X(j, x->len[0])];
				(x->data)[__X(j, x->len[0])] = (SHORTINT)__DIVF(h, d);
				h = __MODF(h, d) * 10000;
			}
		}
	}
	__EXIT;
}

static void Integers_GetQuoRem (Integers_Integer x, Integers_Integer y, Integers_Index xL, Integers_Index \
yL, BOOLEAN xNeg, BOOLEAN yNeg, Integers_Integer quo, Integers_Integer rem, Integers_Index *quoL, Integers_Index \
*remL, BOOLEAN *quoNeg, BOOLEAN *remNeg, BOOLEAN doQuo, BOOLEAN doRem)
{
	Integers_Index i;
	Integers_Digit c;
	Integers_Integer xBuf = NIL;
	__ENTER("Integers.GetQuoRem");
	__ASSERT(xL >= yL, 20);
	xBuf = Integers_CopyOf(x, xL + 1);
	Integers_DecomposeQuoRem(xBuf, y, xL, yL);
	i = xL;
	while (i >= yL && (INTEGER)(xBuf->data)[__X(i, xBuf->len[0])] == 0) {
		i -= 1;
	}
	*quoL = (i - yL) + 1;
	i = yL - 1;
	while (i >= 0 && (INTEGER)(xBuf->data)[__X(i, xBuf->len[0])] == 0) {
		i -= 1;
	}
	*remL = i + 1;
	if (doQuo) {
		*quoNeg = xNeg != yNeg;
		if (*quoNeg && *remL != 0) {
			i = 0;
			c = 1;
			while (i != *quoL && (INTEGER)c != 0) {
				c = (SHORTINT)((INTEGER)c + (INTEGER)(xBuf->data)[__X(i + yL, xBuf->len[0])]);
				(quo->data)[__X(i, quo->len[0])] = (SHORTINT)__MOD((INTEGER)c, 10000);
				c = (SHORTINT)__DIV((INTEGER)c, 10000);
				i += 1;
			}
			if ((INTEGER)c == 0) {
				while (i != *quoL) {
					(quo->data)[__X(i, quo->len[0])] = (xBuf->data)[__X(i + yL, xBuf->len[0])];
					i += 1;
				}
			} else {
				(quo->data)[__X(i, quo->len[0])] = c;
				*quoL += 1;
			}
		} else {
			i = 0;
			while (i != *quoL) {
				(quo->data)[__X(i, quo->len[0])] = (xBuf->data)[__X(i + yL, xBuf->len[0])];
				i += 1;
			}
		}
	}
	if (doRem) {
		*remNeg = yNeg && *remL != 0;
		if (xNeg != yNeg && *remL != 0) {
			Integers_Subtract(y, xBuf, rem, yL, *remL, remL);
		} else {
			i = 0;
			while (i != *remL) {
				(rem->data)[__X(i, rem->len[0])] = (xBuf->data)[__X(i, xBuf->len[0])];
				i += 1;
			}
		}
	}
	__EXIT;
}

static void Integers_BinPower (Integers_Integer x, INTEGER exp, Integers_Integer y, Integers_Index xL, \
Integers_Index *yL)
{
	Integers_Index zL;
	INTEGER b;
	Integers_Integer z = NIL;
	__ENTER("Integers.BinPower");
	__ASSERT(exp > 0, 20);
	__ASSERT(xL != 0, 21);
	b = 1;
	while (__ASHL(b, 1, INTEGER) <= exp) {
		b = __ASHL(b, 1, INTEGER);
	}
	(y->data)[0] = 1;
	*yL = 1;
	z = __NEWARR(2, y->len[0]);
	while (exp != 0 || b != 1) {
		if (exp >= b) {
			exp = exp - b;
			if (xL <= *yL) {
				Integers_Multiply(x, y, z, xL, *yL, &zL);
			} else {
				Integers_Multiply(y, x, z, *yL, xL, &zL);
			}
		} else {
			b = __ASHR(b, 1, INTEGER);
			Integers_Multiply(y, y, z, *yL, *yL, &zL);
		}
		*yL = zL;
		do {
			zL -= 1;
			(y->data)[__X(zL, y->len[0])] = (z->data)[__X(zL, z->len[0])];
		} while (!(zL == 0));
	}
	__EXIT;
}

static Integers_Integer Integers_New (Integers_Index nofDigits)
{
	Integers_Integer x = NIL;
	__ENTER("Integers.New");
	x = __NEWARR(2, nofDigits + 2);
	__EXIT;
	return x;
}

static void Integers_SetLength (Integers_Integer x, Integers_Index len, BOOLEAN negative)
{
	Integers_Digit low, high;
	__ENTER("Integers.SetLength");
	__ASSERT(len >= 0, 20);
	__ASSERT(!negative || len != 0, 21);
	if (negative) {
		len = -len;
	}
	low = (SHORTINT)(__MASK(len, -65536) - 32768);
	high = (SHORTINT)__ASHR(len, 16, Integers_Index);
	(x->data)[__X(x->len[0] - 1, x->len[0])] = low;
	(x->data)[__X(x->len[0] - 2, x->len[0])] = high;
	__EXIT;
}

static void Integers_GetLength (Integers_Integer x, Integers_Index *len, BOOLEAN *negative)
{
	Integers_Digit low, high;
	__ENTER("Integers.GetLength");
	low = (x->data)[__X(x->len[0] - 1, x->len[0])];
	high = (x->data)[__X(x->len[0] - 2, x->len[0])];
	*len = ((INTEGER)low + 32768) + __ASHL((INTEGER)high, 16, INTEGER);
	*negative = *len < 0;
	*len = __ABS(*len);
	__EXIT;
}

Integers_Integer Integers_Long (LONGINT x)
{
	Integers_Index i;
	BOOLEAN negative;
	Integers_Integer int_ = NIL;
	__ENTER("Integers.Long");
	if (x != 0) {
		negative = x < 0;
		x = __ABS(x);
		int_ = Integers_New(5);
		i = 0;
		do {
			(int_->data)[__X(i, int_->len[0])] = (SHORTINT)__MOD(x, 10000);
			x = __DIV(x, 10000);
			i += 1;
		} while (!(x == 0));
		Integers_SetLength(int_, i, negative);
	} else {
		int_ = Integers_zero;
	}
	__EXIT;
	return int_;
}

LONGINT Integers_Short (Integers_Integer x)
{
	Integers_Index i;
	LONGINT res;
	BOOLEAN negative;
	__ENTER("Integers.Short");
	res = 0;
	Integers_GetLength(x, &i, &negative);
	while (i != 0) {
		i -= 1;
		res = res * 10000 + (LONGINT)(x->data)[__X(i, x->len[0])];
	}
	if (negative) {
		res = -res;
	}
	__EXIT;
	return res;
}

static struct Entier__14 {
	Integers_Index *mL, *yL;
	struct Entier__14 *lnk;
} *Entier__14_s;

static void __15 (Integers_Integer m, Integers_Index *mL);
static void __17 (Integers_Integer m, Integers_Index *mL);

static void __17 (Integers_Integer m, Integers_Index *mL)
{
	Integers_Index i;
	__ENTER("Integers.Inc");
	i = 0;
	while ((INTEGER)(m->data)[__X(i, m->len[0])] == 9999) {
		(m->data)[__X(i, m->len[0])] = 0;
		i += 1;
	}
	(m->data)[__X(i, m->len[0])] += 1;
	if (i == *mL) {
		*mL += 1;
		(m->data)[__X(*mL, m->len[0])] = 0;
	}
	__EXIT;
}

static void __15 (Integers_Integer m, Integers_Index *mL)
{
	Integers_Index i;
	Integers_Digit c;
	__ENTER("Integers.Double");
	i = 0;
	c = 0;
	while (i < *mL) {
		c = (SHORTINT)((INTEGER)c + __ASHL((INTEGER)(m->data)[__X(i, m->len[0])], 1, INTEGER));
		(m->data)[__X(i, m->len[0])] = (SHORTINT)__MOD((INTEGER)c, 10000);
		c = (SHORTINT)__DIV((INTEGER)c, 10000);
		i += 1;
	}
	if ((INTEGER)c != 0) {
		*mL += 1;
		(m->data)[__X(*mL, m->len[0])] = 0;
		(m->data)[__X(i, m->len[0])] = c;
	}
	__EXIT;
}

Integers_Integer Integers_Entier (REAL x)
{
	Integers_Index mL, yL, i;
	REAL mx;
	INTEGER ex;
	BOOLEAN neg;
	Integers_Integer y = NIL;
	Integers_Integer z = NIL;
	struct Entier__14 _s;
	__ENTER("Integers.Entier");
	_s.mL = &mL;
	_s.yL = &yL;
	_s.lnk = Entier__14_s;
	Entier__14_s = &_s;
	if (x >= (REAL)1 || x < (REAL)0) {
		neg = x < (REAL)0;
		x = __ABS(x);
		mL = 0;
		(Integers_buf6->data)[0] = 0;
		mx = Math_Mantissa(x);
		ex = Math_Exponent(x);
		while (mx != (REAL)0 && ex > 0) {
			if ((LONGINT)__ENTIERL(mx) == 1) {
				__17(Integers_buf6, &mL);
				mx = mx - (REAL)1;
			} else {
				__ASSERT((LONGINT)__ENTIERL(mx) == 0, 100);
			}
			__15(Integers_buf6, &mL);
			mx = (REAL)2 * mx;
			ex -= 1;
		}
		if ((LONGINT)__ENTIERL(mx) == 1 && ex == 0) {
			__17(Integers_buf6, &mL);
			mx = mx - (REAL)1;
		}
		if (ex > 0) {
			y = Integers_New(mL + (INTEGER)((LONGINT)__ENTIERL((Math_Ln((REAL)2) * (REAL)ex) / Math_Ln((REAL)10000)) \
+ 1));
			z = Integers_New((INTEGER)((LONGINT)__ENTIERL((Math_Ln((REAL)2) * (REAL)ex) / Math_Ln((REAL)10000)) \
+ 1));
			Integers_BinPower(Integers_two, ex, z, 1, &yL);
			if (mL <= yL) {
				Integers_Multiply(Integers_buf6, z, y, mL, yL, &yL);
			} else {
				Integers_Multiply(z, Integers_buf6, y, yL, mL, &yL);
			}
		} else {
			y = Integers_New(mL + 1);
			yL = mL;
			i = 0;
			while (i != mL) {
				(y->data)[__X(i, y->len[0])] = (Integers_buf6->data)[__X(i, Integers_buf6->len[0])];
				i += 1;
			}
		}
		if (neg && mx != (REAL)0) {
			__17(y, &yL);
		}
		Integers_SetLength(y, yL, neg);
	} else {
		y = Integers_zero;
	}
	Entier__14_s = _s.lnk;
	__EXIT;
	return y;
}

REAL Integers_Float (Integers_Integer x)
{
	Integers_Index i;
	REAL y;
	BOOLEAN negative;
	__ENTER("Integers.Float");
	y = (REAL)0;
	Integers_GetLength(x, &i, &negative);
	while (i != 0) {
		i -= 1;
		y = y * (REAL)10000 + (REAL)(x->data)[__X(i, x->len[0])];
	}
	if (negative) {
		y = -y;
	}
	__EXIT;
	return y;
}

INTEGER Integers_Sign (Integers_Integer x)
{
	Integers_Index len;
	BOOLEAN negative;
	__ENTER("Integers.Sign");
	Integers_GetLength(x, &len, &negative);
	if (len == 0) {
		__EXIT;
		return 0;
	} else if (negative) {
		__EXIT;
		return -1;
	} else {
		__EXIT;
		return 1;
	}
	__RETCHK;
}

Integers_Integer Integers_Abs (Integers_Integer x)
{
	Integers_Index len;
	BOOLEAN negative;
	Integers_Integer y = NIL;
	__ENTER("Integers.Abs");
	Integers_GetLength(x, &len, &negative);
	if (negative) {
		y = Integers_New(len);
		Integers_SetLength(y, len, 0);
		do {
			len -= 1;
			(y->data)[__X(len, y->len[0])] = (x->data)[__X(len, x->len[0])];
		} while (!(len == 0));
	} else {
		y = x;
	}
	__EXIT;
	return y;
}

INTEGER Integers_Digits10Of (Integers_Integer x)
{
	Integers_Index i, n;
	Integers_Digit d;
	BOOLEAN negative;
	__ENTER("Integers.Digits10Of");
	Integers_GetLength(x, &n, &negative);
	if (n != 0) {
		d = (x->data)[__X(n - 1, x->len[0])];
		i = 0;
		do {
			i += 1;
			d = (SHORTINT)__DIV((INTEGER)d, 10);
		} while (!((INTEGER)d == 0));
		n = __ASHL(n - 1, 2, Integers_Index) + i;
	}
	__EXIT;
	return n;
}

CHAR Integers_ThisDigit10 (Integers_Integer x, INTEGER exp10)
{
	Integers_Index i, n;
	Integers_Digit d;
	BOOLEAN negative;
	__ENTER("Integers.ThisDigit10");
	__ASSERT(exp10 >= 0, 20);
	Integers_GetLength(x, &n, &negative);
	i = __ASHR(exp10, 2, INTEGER);
	if (n > i) {
		d = (x->data)[__X(i, x->len[0])];
		i = __MASK(exp10, -4);
		while (i != 0) {
			d = (SHORTINT)__DIV((INTEGER)d, 10);
			i -= 1;
		}
		d = (SHORTINT)__MOD((INTEGER)d, 10);
	} else {
		d = 0;
	}
	__EXIT;
	return (CHAR)(48 + (INTEGER)d);
}

INTEGER Integers_Compare (Integers_Integer x, Integers_Integer y)
{
	Integers_Index xL, yL;
	INTEGER res;
	BOOLEAN xNeg, yNeg;
	__ENTER("Integers.Compare");
	Integers_GetLength(x, &xL, &xNeg);
	Integers_GetLength(y, &yL, &yNeg);
	if (xNeg == yNeg) {
		if (xL == yL && xL != 0) {
			xL -= 1;
			while (xL != 0 && (INTEGER)(x->data)[__X(xL, x->len[0])] == (INTEGER)(y->data)[__X(xL, y->len[0])]) \
{
				xL -= 1;
			}
			if ((INTEGER)(x->data)[__X(xL, x->len[0])] == (INTEGER)(y->data)[__X(xL, y->len[0])]) {
				res = 0;
			} else if ((INTEGER)(x->data)[__X(xL, x->len[0])] < (INTEGER)(y->data)[__X(xL, y->len[0])] == xNeg) \
{
				res = 1;
			} else {
				res = -1;
			}
		} else {
			if (xL == yL) {
				res = 0;
			} else if (xL < yL == xNeg) {
				res = 1;
			} else {
				res = -1;
			}
		}
	} else if (xNeg) {
		res = -1;
	} else {
		res = 1;
	}
	__EXIT;
	return res;
}

static Integers_Integer Integers_AddOp (Integers_Integer x, Integers_Integer y, BOOLEAN subtract)
{
	Integers_Index i, d, xL, yL, intL;
	BOOLEAN xNeg, yNeg;
	Integers_Integer int_ = NIL;
	__ENTER("Integers.AddOp");
	Integers_GetLength(x, &xL, &xNeg);
	Integers_GetLength(y, &yL, &yNeg);
	if (yL == 0) {
		int_ = x;
	} else if (xL == 0) {
		if (subtract) {
			int_ = Integers_New(yL);
			Integers_SetLength(int_, yL, !yNeg);
			do {
				yL -= 1;
				(int_->data)[__X(yL, int_->len[0])] = (y->data)[__X(yL, y->len[0])];
			} while (!(yL == 0));
		} else {
			int_ = y;
		}
	} else if ((xNeg == yNeg) != subtract) {
		int_ = Integers_New(__MAX(xL, yL) + 1);
		Integers_Add(x, y, int_, xL, yL, &intL);
		Integers_SetLength(int_, intL, xNeg);
	} else {
		d = xL - yL;
		if (d != 0) {
			i = __MAX(xL, yL) - 1;
		} else {
			i = xL;
			do {
				i -= 1;
				d = (INTEGER)(x->data)[__X(i, x->len[0])] - (INTEGER)(y->data)[__X(i, y->len[0])];
			} while (!(i == 0 || d != 0));
		}
		if (d > 0) {
			int_ = Integers_New(i + 1);
			Integers_Subtract(x, y, int_, xL, yL, &intL);
			Integers_SetLength(int_, intL, xNeg);
		} else if (d < 0) {
			int_ = Integers_New(i + 1);
			Integers_Subtract(y, x, int_, yL, xL, &intL);
			Integers_SetLength(int_, intL, yNeg != subtract);
		} else {
			int_ = Integers_zero;
		}
	}
	__EXIT;
	return int_;
}

Integers_Integer Integers_Sum (Integers_Integer x, Integers_Integer y)
{
	__ENTER("Integers.Sum");
	__EXIT;
	return Integers_AddOp(x, y, 0);
}

Integers_Integer Integers_Difference (Integers_Integer x, Integers_Integer y)
{
	__ENTER("Integers.Difference");
	__EXIT;
	return Integers_AddOp(x, y, 1);
}

Integers_Integer Integers_Product (Integers_Integer x, Integers_Integer y)
{
	Integers_Index xL, yL, intL;
	BOOLEAN neg, xNeg, yNeg;
	Integers_Integer int_ = NIL;
	__ENTER("Integers.Product");
	Integers_GetLength(x, &xL, &xNeg);
	Integers_GetLength(y, &yL, &yNeg);
	neg = xNeg != yNeg;
	if (xL > yL) {
		int_ = x;
		x = y;
		y = int_;
		intL = xL;
		xL = yL;
		yL = intL;
		xNeg = yNeg;
	}
	if (xL == 0) {
		int_ = Integers_zero;
	} else if (xL == 1 && (INTEGER)(x->data)[0] == 1) {
		if (xNeg) {
			int_ = Integers_New(yL);
			Integers_SetLength(int_, yL, neg);
			do {
				yL -= 1;
				(int_->data)[__X(yL, int_->len[0])] = (y->data)[__X(yL, y->len[0])];
			} while (!(yL == 0));
		} else {
			int_ = y;
		}
	} else {
		int_ = Integers_New(xL + yL);
		Integers_Multiply(x, y, int_, xL, yL, &intL);
		Integers_SetLength(int_, intL, neg);
	}
	__EXIT;
	return int_;
}

Integers_Integer Integers_Quotient (Integers_Integer x, Integers_Integer y)
{
	Integers_Index xL, yL, intL, remL;
	BOOLEAN xNeg, yNeg, qNeg, rNeg;
	Integers_Integer int_ = NIL;
	__ENTER("Integers.Quotient");
	Integers_GetLength(x, &xL, &xNeg);
	Integers_GetLength(y, &yL, &yNeg);
	__ASSERT(yL != 0, 20);
	if (xL < yL) {
		int_ = Integers_zero;
	} else if (yL == 1 && (INTEGER)(y->data)[0] == 1) {
		if (yNeg) {
			int_ = Integers_New(xL);
			Integers_SetLength(int_, xL, !xNeg);
			do {
				xL -= 1;
				(int_->data)[__X(xL, int_->len[0])] = (x->data)[__X(xL, x->len[0])];
			} while (!(xL == 0));
		} else {
			int_ = x;
		}
	} else {
		int_ = Integers_New((xL - yL) + 2);
		Integers_GetQuoRem(x, y, xL, yL, xNeg, yNeg, int_, NIL, &intL, &remL, &qNeg, &rNeg, 1, 0);
		Integers_SetLength(int_, intL, qNeg);
	}
	__EXIT;
	return int_;
}

Integers_Integer Integers_Remainder (Integers_Integer x, Integers_Integer y)
{
	Integers_Index xL, yL, intL, quoL;
	BOOLEAN xNeg, yNeg, qNeg, rNeg;
	Integers_Integer int_ = NIL;
	__ENTER("Integers.Remainder");
	Integers_GetLength(x, &xL, &xNeg);
	Integers_GetLength(y, &yL, &yNeg);
	__ASSERT(yL != 0, 20);
	if (xL < yL) {
		int_ = x;
	} else if (yL == 1 && (INTEGER)(y->data)[0] == 1) {
		int_ = Integers_zero;
	} else {
		int_ = Integers_New(yL);
		Integers_GetQuoRem(x, y, xL, yL, xNeg, yNeg, NIL, int_, &quoL, &intL, &qNeg, &rNeg, 0, 1);
		Integers_SetLength(int_, intL, rNeg);
	}
	__EXIT;
	return int_;
}

void Integers_QuoRem (Integers_Integer x, Integers_Integer y, Integers_Integer *quo, Integers_Integer \
*rem)
{
	Integers_Index xL, yL, quoL, remL;
	BOOLEAN xNeg, yNeg, qNeg, rNeg;
	__ENTER("Integers.QuoRem");
	*quo = NIL;
	*rem = NIL;
	Integers_GetLength(x, &xL, &xNeg);
	Integers_GetLength(y, &yL, &yNeg);
	__ASSERT(yL != 0, 20);
	if (xL < yL) {
		*quo = Integers_zero;
		*rem = x;
	} else if (yL == 1 && (INTEGER)(y->data)[0] == 1) {
		*rem = Integers_zero;
		if (yNeg) {
			*quo = Integers_New(xL);
			Integers_SetLength(*quo, xL, !xNeg);
			do {
				xL -= 1;
				((*quo)->data)[__X(xL, (*quo)->len[0])] = (x->data)[__X(xL, x->len[0])];
			} while (!(xL == 0));
		} else {
			*quo = x;
		}
	} else {
		*quo = Integers_New((xL - yL) + 2);
		*rem = Integers_New(yL);
		Integers_GetQuoRem(x, y, xL, yL, xNeg, yNeg, *quo, *rem, &quoL, &remL, &qNeg, &rNeg, 1, 1);
		Integers_SetLength(*quo, quoL, qNeg);
		Integers_SetLength(*rem, remL, rNeg);
	}
	__EXIT;
}

Integers_Integer Integers_GCD (Integers_Integer x, Integers_Integer y)
{
	Integers_Index xL, yL, i;
	Integers_Digit h;
	BOOLEAN negative;
	Integers_Integer xBuf = NIL;
	Integers_Integer yBuf = NIL;
	Integers_Integer int_ = NIL;
	__ENTER("Integers.GCD");
	Integers_GetLength(x, &xL, &negative);
	Integers_GetLength(y, &yL, &negative);
	if (xL == 0) {
		int_ = y;
	} else if (yL == 0) {
		int_ = x;
	} else {
		if (xL >= yL) {
			xBuf = Integers_CopyOf(x, xL + 1);
			yBuf = Integers_CopyOf(y, yL + 1);
		} else {
			xBuf = Integers_CopyOf(y, yL + 1);
			yBuf = Integers_CopyOf(x, xL + 1);
			i = xL;
			xL = yL;
			yL = i;
		}
		while (yL != 0) {
			Integers_DecomposeQuoRem(xBuf, yBuf, xL, yL);
			xL = yL;
			while (xL != 0 && (INTEGER)(xBuf->data)[__X(xL - 1, xBuf->len[0])] == 0) {
				xL -= 1;
			}
			i = yL;
			while (i != 0) {
				i -= 1;
				h = (xBuf->data)[__X(i, xBuf->len[0])];
				(xBuf->data)[__X(i, xBuf->len[0])] = (yBuf->data)[__X(i, yBuf->len[0])];
				(yBuf->data)[__X(i, yBuf->len[0])] = h;
			}
			i = xL;
			xL = yL;
			yL = i;
		}
		int_ = Integers_New(xL);
		Integers_SetLength(int_, xL, 0);
		while (xL != 0) {
			xL -= 1;
			(int_->data)[__X(xL, int_->len[0])] = (xBuf->data)[__X(xL, xBuf->len[0])];
		}
	}
	__EXIT;
	return int_;
}

Integers_Integer Integers_Power (Integers_Integer x, INTEGER exp)
{
	Integers_Index xL, intL;
	BOOLEAN negative;
	Integers_Integer int_ = NIL;
	__ENTER("Integers.Power");
	__ASSERT(exp >= 0, 20);
	Integers_GetLength(x, &xL, &negative);
	if (xL == 0) {
		int_ = Integers_zero;
	} else if (xL == 1 && (INTEGER)(x->data)[0] == 1) {
		if (negative && !__ODD(exp)) {
			int_ = Integers_New(xL);
			Integers_SetLength(int_, xL, 0);
			do {
				xL -= 1;
				(int_->data)[__X(xL, int_->len[0])] = (x->data)[__X(xL, x->len[0])];
			} while (!(xL == 0));
		} else {
			int_ = x;
		}
	} else if (exp == 0) {
		int_ = Integers_one;
	} else if (exp == 1) {
		int_ = x;
	} else {
		int_ = Integers_New((INTEGER)(((LONGINT)((xL - 1) * exp) + (LONGINT)__ENTIERL((Math_Ln((INTEGER)(x->data)[__X(xL \
- 1, x->len[0])] + 1) * (REAL)exp) / Math_Ln((REAL)10000))) + 1));
		Integers_BinPower(x, exp, int_, xL, &intL);
		Integers_SetLength(int_, intL, negative && __ODD(exp));
	}
	__EXIT;
	return int_;
}

void Integers_ConvertFromString (CHAR *s, INTEGER s__len, Integers_Integer *x)
{
	INTEGER i, j, k;
	Integers_Digit dig, b;
	CHAR ch;
	BOOLEAN negative;
	Integers_Integer new = NIL;
	__ENTER("Integers.ConvertFromString");
	*x = NIL;
	i = 0;
	ch = s[0];
	while (ch != 0 && ch <= (CHAR)L' ') {
		i += 1;
		ch = s[__X(i, s__len)];
	}
	negative = ch == (CHAR)L'-';
	if (negative) {
		i += 1;
		ch = s[__X(i, s__len)];
	}
	if (ch == (CHAR)L'+') {
		i += 1;
		ch = s[__X(i, s__len)];
	}
	while (ch != 0 && ch <= (CHAR)L' ') {
		i += 1;
		ch = s[__X(i, s__len)];
	}
	__ASSERT(ch >= (CHAR)L'0' && ch <= (CHAR)L'9', 20);
	while (ch == (CHAR)L'0') {
		i += 1;
		ch = s[__X(i, s__len)];
	}
	if (ch > (CHAR)L'0' && ch <= (CHAR)L'9') {
		j = i;
		do {
			j += 1;
			ch = s[__X(j, s__len)];
		} while (!(ch < (CHAR)L'0' || ch > (CHAR)L'9'));
		k = __ASHR((j - i) - 1, 2, INTEGER) + 2;
		new = Integers_New(k);
		Integers_SetLength(new, k - 1, negative);
		k = __MASK(j - i, -4);
		if (k != 0) {
			b = 1;
			k -= 1;
			while (k != 0) {
				k -= 1;
				b = (SHORTINT)((INTEGER)b * 10);
			}
		} else {
			b = 1000;
		}
		do {
			dig = 0;
			while ((INTEGER)b != 0) {
				dig = (SHORTINT)((INTEGER)dig + (INTEGER)b * ((INTEGER)s[__X(i, s__len)] - 48));
				b = (SHORTINT)__DIV((INTEGER)b, 10);
				i += 1;
			}
			(new->data)[__X(__ASHR(j - i, 2, INTEGER), new->len[0])] = dig;
			b = 1000;
		} while (!(i == j));
		*x = new;
	} else {
		*x = Integers_zero;
	}
	__EXIT;
}

void Integers_ConvertToString (Integers_Integer x, CHAR *s, INTEGER s__len)
{
	Integers_Index j;
	INTEGER i;
	Integers_Digit d, b;
	BOOLEAN negative;
	__ENTER("Integers.ConvertToString");
	Integers_GetLength(x, &j, &negative);
	if (negative) {
		s[0] = (CHAR)L'-';
		i = 1;
	} else {
		i = 0;
	}
	if (j != 0) {
		j -= 1;
		d = (x->data)[__X(j, x->len[0])];
		b = 1000;
		while (__DIVF((INTEGER)d, (INTEGER)b) == 0) {
			b = (SHORTINT)__DIV((INTEGER)b, 10);
		}
		do {
			s[__X(i, s__len)] = (CHAR)(__DIVF((INTEGER)d, (INTEGER)b) + 48);
			i += 1;
			d = (SHORTINT)__MODF((INTEGER)d, (INTEGER)b);
			b = (SHORTINT)__DIV((INTEGER)b, 10);
		} while (!((INTEGER)b == 0));
		while (j != 0) {
			j -= 1;
			d = (x->data)[__X(j, x->len[0])];
			b = 1000;
			do {
				s[__X(i, s__len)] = (CHAR)(__DIVF((INTEGER)d, (INTEGER)b) + 48);
				i += 1;
				d = (SHORTINT)__MODF((INTEGER)d, (INTEGER)b);
				b = (SHORTINT)__DIV((INTEGER)b, 10);
			} while (!((INTEGER)b == 0));
		}
	} else {
		s[__X(i, s__len)] = (CHAR)L'0';
		i += 1;
	}
	s[__X(i, s__len)] = 0;
	__EXIT;
}

void Integers_Internalize (Files_Reader r, Integers_Integer *x)
{
	Integers_Index len;
	INTEGER n, version;
	BOOLEAN negative;
	Integers_Integer new = NIL;
	BYTE buf[4];
	__ENTER("Integers.Internalize");
	*x = NIL;
	__Files_Reader_ReadByte(r, &buf[0]);
	version = buf[0];
	__ASSERT(version == 0 || version >= 128, 20);
	if (version == 0) {
		__Files_Reader_ReadBytes(r, (void*)buf, 4, 0, 4);
		len = __ASHL(__ASHL(__ASHL(__MASK((INTEGER)buf[0], -128), 8, INTEGER) + __MASK((INTEGER)buf[1], -256), \
8, INTEGER) + __MASK((INTEGER)buf[2], -256), 8, INTEGER) + __MASK((INTEGER)buf[3], -256);
		new = Integers_New(len);
		Integers_SetLength(new, len, (INTEGER)buf[0] < 0);
		while (len != 0) {
			len -= 1;
			__Files_Reader_ReadBytes(r, (void*)buf, 4, 0, 2);
			(new->data)[__X(len, new->len[0])] = (SHORTINT)(__ASHL(__MASK((INTEGER)buf[0], -256), 8, INTEGER) + \
__MASK((INTEGER)buf[1], -256));
		}
		*x = new;
	} else {
		__Files_Reader_ReadByte(r, &buf[1]);
		n = (__ASHL(__MASK((INTEGER)buf[0], -256), 8, INTEGER) + __MASK((INTEGER)buf[1], -256)) - 32768;
		__Files_Reader_ReadBytes(r, (void*)buf, 4, 0, 2);
		n -= 1;
		len = __ASHL(__MASK((INTEGER)buf[0], -256), 8, INTEGER) + __MASK((INTEGER)buf[1], -256);
		negative = len < 0;
		len = __ABS(len);
		new = Integers_New(len);
		Integers_SetLength(new, len, negative);
		while (n != len) {
			n -= 1;
			__Files_Reader_ReadBytes(r, (void*)buf, 4, 0, 2);
		}
		while (len != 0) {
			len -= 1;
			__Files_Reader_ReadBytes(r, (void*)buf, 4, 0, 2);
			(new->data)[__X(len, new->len[0])] = (SHORTINT)(__ASHL(__MASK((INTEGER)buf[0], -256), 8, INTEGER) + \
__MASK((INTEGER)buf[1], -256));
		}
		*x = new;
	}
	__EXIT;
}

static struct Externalize__19 {
	Integers_Index *len;
	BOOLEAN *negative;
	BYTE (*buf)[4];
	struct Externalize__19 *lnk;
} *Externalize__19_s;

static BYTE __20 (INTEGER x);

static BYTE __20 (INTEGER x)
{
	__ENTER("Integers.Byte");
	__ASSERT(x >= -128 && x <= 255, 20);
	if (x > 127) {
		__EXIT;
		return (BYTE)(x - 256);
	} else {
		__EXIT;
		return (BYTE)x;
	}
	__RETCHK;
}

void Integers_Externalize (Files_Writer w, Integers_Integer x)
{
	Integers_Index len, l;
	Integers_Digit d;
	INTEGER i;
	BOOLEAN negative;
	BYTE buf[4];
	struct Externalize__19 _s;
	__ENTER("Integers.Externalize");
	_s.len = &len;
	_s.negative = &negative;
	_s.buf = (void*)buf;
	_s.lnk = Externalize__19_s;
	Externalize__19_s = &_s;
	Integers_GetLength(x, &len, &negative);
	l = len;
	i = 4;
	do {
		i -= 1;
		buf[__X(i, 4)] = __20(__MASK(l, -256));
		l = __ASHR(l, 8, Integers_Index);
	} while (!(i == 0));
	if (negative) {
		buf[0] = __20(128 + __MASK((INTEGER)buf[0], -256));
	}
	__Files_Writer_WriteByte(w, 0);
	__Files_Writer_WriteBytes(w, (void*)buf, 4, 0, 4);
	while (len != 0) {
		len -= 1;
		d = (x->data)[__X(len, x->len[0])];
		buf[0] = __20(__ASHR((INTEGER)d, 8, INTEGER));
		buf[1] = __20(__MASK((INTEGER)d, -256));
		__Files_Writer_WriteBytes(w, (void*)buf, 4, 0, 2);
	}
	Externalize__19_s = _s.lnk;
	__EXIT;
}

static INTEGER Integers_Buffer__flds[] = {
	3, 
	0, 0, 1<<8 | 0x15, (INTEGER)Integers_Integer__desc,
	0, 4, 7<<8 | 0x15, 6,
	0, 8, 11<<8 | 0x15, 6,
};
export INTEGER Integers_Buffer__desc[] = {
	-1, 
	0, 
	12,
	(INTEGER)&Integers__desc,
	15<<8 | 0x01,
	(INTEGER)(Integers_Buffer__desc + 2),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Integers_Buffer__flds, 
	0, -8
};
export INTEGER Integers_IntegerDesc__desc[] = {
	0,
	(INTEGER)&Integers__desc,
	22<<8 | 0x12,
	5
};
export INTEGER Integers_Integer__desc[] = {
	0,
	(INTEGER)&Integers__desc,
	34<<8 | 0x03,
	(INTEGER)Integers_IntegerDesc__desc
};
static SYSTEM_MODDESC *Integers__imp[] = {
	&Files__desc,
	&Math__desc,
};
static INTEGER Integers__exp[] = {
	46,
	0x01bd1c8c, (INTEGER)Integers_Abs, 42<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Integers_Add, 46<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_AddBuf, 50<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_AddOp, 57<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_AddToBuf, 63<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_BinPower, 72<<8 | 0x14, 0,
	0xe3c02e39, 0x7453aba8, 15<<8 | 0x12, (INTEGER)(Integers_Buffer__desc + 2),
	0xf422734a, (INTEGER)Integers_Compare, 81<<8 | 0x44, 0,
	0x8813d486, (INTEGER)Integers_ConvertFromString, 89<<8 | 0x44, 0,
	0xc55663f6, (INTEGER)Integers_ConvertToString, 107<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Integers_CopyOf, 123<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_DecomposeQuoRem, 130<<8 | 0x14, 0,
	0x1a7700eb, (INTEGER)Integers_Difference, 146<<8 | 0x44, 0,
	0xa3dd4953, (INTEGER)Integers_Digits10Of, 157<<8 | 0x44, 0,
	0xd0c95d92, (INTEGER)Integers_Entier, 168<<8 | 0x44, 0,
	0xebe38533, (INTEGER)Integers_Externalize, 175<<8 | 0x44, 0,
	0x081e8c5c, (INTEGER)Integers_Float, 187<<8 | 0x44, 0,
	0x1a7700eb, (INTEGER)Integers_GCD, 193<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Integers_GetLength, 197<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_GetQuoRem, 207<<8 | 0x14, 0,
	0xb905efc9, 0xb905efc9, 34<<8 | 0x42, (INTEGER)Integers_Integer__desc,
	0x83831922, 0x83831922, 22<<8 | 0x12, (INTEGER)Integers_IntegerDesc__desc,
	0xf373b1fa, (INTEGER)Integers_Internalize, 217<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Integers_KStep, 229<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_Karatsuba, 235<<8 | 0x14, 0,
	0xb3525034, (INTEGER)Integers_Long, 245<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Integers_Multiply, 250<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_New, 259<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_OneDigitMult, 263<<8 | 0x14, 0,
	0xf78de1ff, (INTEGER)Integers_Power, 276<<8 | 0x44, 0,
	0x1a7700eb, (INTEGER)Integers_Product, 282<<8 | 0x44, 0,
	0x63f012f4, (INTEGER)Integers_QuoRem, 290<<8 | 0x44, 0,
	0x1a7700eb, (INTEGER)Integers_Quotient, 297<<8 | 0x44, 0,
	0x1a7700eb, (INTEGER)Integers_Remainder, 306<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Integers_SetLength, 316<<8 | 0x14, 0,
	0x7ed9ddcf, (INTEGER)Integers_Short, 326<<8 | 0x44, 0,
	0xa3dd4953, (INTEGER)Integers_Sign, 332<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Integers_SimpleMult, 337<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_Subtract, 348<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Integers_SubtractFromBuf, 357<<8 | 0x14, 0,
	0x1a7700eb, (INTEGER)Integers_Sum, 373<<8 | 0x44, 0,
	0x10c03df7, (INTEGER)Integers_ThisDigit10, 377<<8 | 0x44, 0,
	0xbde8949d, (INTEGER)&Integers_buf6, 389<<8 | 0x13, (INTEGER)Integers_Integer__desc,
	0xbde8949d, (INTEGER)&Integers_one, 394<<8 | 0x13, (INTEGER)Integers_Integer__desc,
	0xbde8949d, (INTEGER)&Integers_two, 398<<8 | 0x13, (INTEGER)Integers_Integer__desc,
	0xbde8949d, (INTEGER)&Integers_zero, 402<<8 | 0x13, (INTEGER)Integers_Integer__desc,
};
static char Integers__names[] = {
	0,
	'd','i','g','i','t',0,
	'b','e','g',0,
	'l','e','n',0,
	'B','u','f','f','e','r',0,
	'I','n','t','e','g','e','r','D','e','s','c',0,
	'I','n','t','e','g','e','r',0,
	'A','b','s',0,
	'A','d','d',0,
	'A','d','d','B','u','f',0,
	'A','d','d','O','p',0,
	'A','d','d','T','o','B','u','f',0,
	'B','i','n','P','o','w','e','r',0,
	'C','o','m','p','a','r','e',0,
	'C','o','n','v','e','r','t','F','r','o','m','S','t','r','i','n','g',0,
	'C','o','n','v','e','r','t','T','o','S','t','r','i','n','g',0,
	'C','o','p','y','O','f',0,
	'D','e','c','o','m','p','o','s','e','Q','u','o','R','e','m',0,
	'D','i','f','f','e','r','e','n','c','e',0,
	'D','i','g','i','t','s','1','0','O','f',0,
	'E','n','t','i','e','r',0,
	'E','x','t','e','r','n','a','l','i','z','e',0,
	'F','l','o','a','t',0,
	'G','C','D',0,
	'G','e','t','L','e','n','g','t','h',0,
	'G','e','t','Q','u','o','R','e','m',0,
	'I','n','t','e','r','n','a','l','i','z','e',0,
	'K','S','t','e','p',0,
	'K','a','r','a','t','s','u','b','a',0,
	'L','o','n','g',0,
	'M','u','l','t','i','p','l','y',0,
	'N','e','w',0,
	'O','n','e','D','i','g','i','t','M','u','l','t',0,
	'P','o','w','e','r',0,
	'P','r','o','d','u','c','t',0,
	'Q','u','o','R','e','m',0,
	'Q','u','o','t','i','e','n','t',0,
	'R','e','m','a','i','n','d','e','r',0,
	'S','e','t','L','e','n','g','t','h',0,
	'S','h','o','r','t',0,
	'S','i','g','n',0,
	'S','i','m','p','l','e','M','u','l','t',0,
	'S','u','b','t','r','a','c','t',0,
	'S','u','b','t','r','a','c','t','F','r','o','m','B','u','f',0,
	'S','u','m',0,
	'T','h','i','s','D','i','g','i','t','1','0',0,
	'b','u','f','6',0,
	'o','n','e',0,
	't','w','o',0,
	'z','e','r','o',0,
};
static INTEGER Integers__ptrs[] = {
	(INTEGER)&Integers_zero + 0, 
	(INTEGER)&Integers_one + 0, 
	(INTEGER)&Integers_two + 0, 
	(INTEGER)&Integers_buf6 + 0, 
};
struct SYSTEM_MODDESC Integers__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 3}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Integers__body,
	0,
	2, /* nofimps */ 
	4, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Integers__names,
	Integers__ptrs,
	Integers__imp,
	(SYSTEM_DIRECTORY*)Integers__exp,
	"Integers"
};

export void Integers__reg()
{
	__BEGREG(Integers__desc);
	Files__reg();
	Math__reg();
	__REGMOD(Integers__desc);
	__ENDREG;
}

export void Integers__body()
{
	__BEGBODY(Integers__desc);
	Files__body();
	Math__body();
	Integers_zero = Integers_New(0);
	Integers_SetLength(Integers_zero, 0, 0);
	Integers_one = Integers_New(1);
	(Integers_one->data)[0] = 1;
	Integers_SetLength(Integers_one, 1, 0);
	Integers_two = Integers_New(1);
	(Integers_two->data)[0] = 2;
	Integers_SetLength(Integers_two, 1, 0);
	Integers_buf6 = __NEWARR(2, 6);
	__ENDBODY;
}
