/*  CPfront 1.0 -48 */

#ifndef Kernel__h
#define Kernel__h

#include "SYSTEM.h"
#include "C99types.h"

typedef
	struct Kernel_Type__rec *Kernel_Type;

struct Kernel__18 {
	INTEGER id;
	Kernel_Type struct_;
};

typedef
	C99types_Pvoid Kernel_ADDRESS;

typedef
	SHORTCHAR *Kernel_StrPtr;

typedef
	Kernel_StrPtr *Kernel_ArrStrPtr;

typedef
	void (*Kernel_Command)(void);

typedef
	struct Kernel_Directory__rec *Kernel_Directory;

typedef
	struct Kernel_ObjDesc {
		INTEGER fprint, offs, id;
		Kernel_Type struct_;
	} Kernel_ObjDesc;

typedef
	struct Kernel_Directory__rec {
		INTEGER num;
		Kernel_ObjDesc obj[1000000];
	} Kernel_Directory__rec;

typedef
	void (*Kernel_Handler)(void);

typedef
	struct Kernel_Hook__rec *Kernel_Hook;

typedef
	struct Kernel_Hook__rec {
		char _prvt0[1];
	} Kernel_Hook__rec;

typedef
	struct Kernel_Identifier {
		INTEGER typ;
		ANYPTR obj;
	} Kernel_Identifier;

import BOOLEAN Kernel_Identifier_Identified (Kernel_Identifier *id, SYSTEM_TYPEDESC *id__typ);
#define __Kernel_Identifier_Identified(id, id__typ) __SEND(id__typ, 1, BOOLEAN(*)(Kernel_Identifier*, \
SYSTEM_TYPEDESC *), (id, id__typ))

typedef
	struct Kernel_Module__rec *Kernel_Module;

typedef
	struct Kernel_ItemExt__rec *Kernel_ItemExt;

typedef
	struct Kernel_ItemAttr {
		INTEGER obj, vis, typ, adr;
		Kernel_Module mod;
		Kernel_Type desc;
		SYSTEM_PTR ptr;
		Kernel_ItemExt ext;
	} Kernel_ItemAttr;

typedef
	struct Kernel_ItemExt__rec {
		char _prvt0[1];
	} Kernel_ItemExt__rec;

import INTEGER Kernel_ItemExt_BaseTyp (Kernel_ItemExt e);
import BOOLEAN Kernel_ItemExt_BoolVal (Kernel_ItemExt e);
import void Kernel_ItemExt_Call (Kernel_ItemExt e, BOOLEAN *ok);
import CHAR Kernel_ItemExt_CharVal (Kernel_ItemExt e);
import void Kernel_ItemExt_Deref (Kernel_ItemExt e, ANYREC *ref, SYSTEM_TYPEDESC *ref__typ);
import void Kernel_ItemExt_GetSStringVal (Kernel_ItemExt e, SHORTCHAR *x, INTEGER x__len, BOOLEAN *ok);
import void Kernel_ItemExt_GetStringVal (Kernel_ItemExt e, CHAR *x, INTEGER x__len, BOOLEAN *ok);
import void Kernel_ItemExt_Index (Kernel_ItemExt e, INTEGER index, ANYREC *elem, SYSTEM_TYPEDESC *elem__typ);
import INTEGER Kernel_ItemExt_IntVal (Kernel_ItemExt e);
import INTEGER Kernel_ItemExt_Len (Kernel_ItemExt e);
import LONGINT Kernel_ItemExt_LongVal (Kernel_ItemExt e);
import void Kernel_ItemExt_Lookup (Kernel_ItemExt e, CHAR *name, INTEGER name__len, ANYREC *i, SYSTEM_TYPEDESC \
*i__typ);
import ANYPTR Kernel_ItemExt_PtrVal (Kernel_ItemExt e);
import void Kernel_ItemExt_PutBoolVal (Kernel_ItemExt e, BOOLEAN x);
import void Kernel_ItemExt_PutCharVal (Kernel_ItemExt e, CHAR x);
import void Kernel_ItemExt_PutIntVal (Kernel_ItemExt e, INTEGER x);
import void Kernel_ItemExt_PutLongVal (Kernel_ItemExt e, LONGINT x);
import void Kernel_ItemExt_PutPtrVal (Kernel_ItemExt e, ANYPTR x);
import void Kernel_ItemExt_PutRealVal (Kernel_ItemExt e, REAL x);
import void Kernel_ItemExt_PutSStringVal (Kernel_ItemExt e, SHORTCHAR *x, INTEGER x__len, BOOLEAN *ok);
import void Kernel_ItemExt_PutSetVal (Kernel_ItemExt e, SET x);
import void Kernel_ItemExt_PutStringVal (Kernel_ItemExt e, CHAR *x, INTEGER x__len, BOOLEAN *ok);
import REAL Kernel_ItemExt_RealVal (Kernel_ItemExt e);
import SET Kernel_ItemExt_SetVal (Kernel_ItemExt e);
import INTEGER Kernel_ItemExt_Size (Kernel_ItemExt e);
import BOOLEAN Kernel_ItemExt_Valid (Kernel_ItemExt e);
#define __Kernel_ItemExt_BaseTyp(e) __SEND(__TYPEOF(e), 1, INTEGER(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_BoolVal(e) __SEND(__TYPEOF(e), 2, BOOLEAN(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_Call(e, ok) __SEND(__TYPEOF(e), 3, void(*)(Kernel_ItemExt, BOOLEAN*), (e, ok))
#define __Kernel_ItemExt_CharVal(e) __SEND(__TYPEOF(e), 4, CHAR(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_Deref(e, ref, ref__typ) __SEND(__TYPEOF(e), 5, void(*)(Kernel_ItemExt, ANYREC*, \
SYSTEM_TYPEDESC *), (e, ref, ref__typ))
#define __Kernel_ItemExt_GetSStringVal(e, x, x__len, ok) __SEND(__TYPEOF(e), 6, void(*)(Kernel_ItemExt, \
SHORTCHAR*, INTEGER , BOOLEAN*), (e, x, x__len, ok))
#define __Kernel_ItemExt_GetStringVal(e, x, x__len, ok) __SEND(__TYPEOF(e), 7, void(*)(Kernel_ItemExt, \
CHAR*, INTEGER , BOOLEAN*), (e, x, x__len, ok))
#define __Kernel_ItemExt_Index(e, index, elem, elem__typ) __SEND(__TYPEOF(e), 8, void(*)(Kernel_ItemExt, \
INTEGER, ANYREC*, SYSTEM_TYPEDESC *), (e, index, elem, elem__typ))
#define __Kernel_ItemExt_IntVal(e) __SEND(__TYPEOF(e), 9, INTEGER(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_Len(e) __SEND(__TYPEOF(e), 10, INTEGER(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_LongVal(e) __SEND(__TYPEOF(e), 11, LONGINT(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_Lookup(e, name, name__len, i, i__typ) __SEND(__TYPEOF(e), 12, void(*)(Kernel_ItemExt, \
CHAR*, INTEGER , ANYREC*, SYSTEM_TYPEDESC *), (e, name, name__len, i, i__typ))
#define __Kernel_ItemExt_PtrVal(e) __SEND(__TYPEOF(e), 13, ANYPTR(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_PutBoolVal(e, x) __SEND(__TYPEOF(e), 14, void(*)(Kernel_ItemExt, BOOLEAN), (e, \
x))
#define __Kernel_ItemExt_PutCharVal(e, x) __SEND(__TYPEOF(e), 15, void(*)(Kernel_ItemExt, CHAR), (e, x))
#define __Kernel_ItemExt_PutIntVal(e, x) __SEND(__TYPEOF(e), 16, void(*)(Kernel_ItemExt, INTEGER), (e, \
x))
#define __Kernel_ItemExt_PutLongVal(e, x) __SEND(__TYPEOF(e), 17, void(*)(Kernel_ItemExt, LONGINT), (e, \
x))
#define __Kernel_ItemExt_PutPtrVal(e, x) __SEND(__TYPEOF(e), 18, void(*)(Kernel_ItemExt, ANYPTR), (e, \
x))
#define __Kernel_ItemExt_PutRealVal(e, x) __SEND(__TYPEOF(e), 19, void(*)(Kernel_ItemExt, REAL), (e, x))
#define __Kernel_ItemExt_PutSStringVal(e, x, x__len, ok) __SEND(__TYPEOF(e), 20, void(*)(Kernel_ItemExt, \
SHORTCHAR*, INTEGER , BOOLEAN*), (e, x, x__len, ok))
#define __Kernel_ItemExt_PutSetVal(e, x) __SEND(__TYPEOF(e), 21, void(*)(Kernel_ItemExt, SET), (e, x))
#define __Kernel_ItemExt_PutStringVal(e, x, x__len, ok) __SEND(__TYPEOF(e), 22, void(*)(Kernel_ItemExt, \
CHAR*, INTEGER , BOOLEAN*), (e, x, x__len, ok))
#define __Kernel_ItemExt_RealVal(e) __SEND(__TYPEOF(e), 23, REAL(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_SetVal(e) __SEND(__TYPEOF(e), 24, SET(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_Size(e) __SEND(__TYPEOF(e), 25, INTEGER(*)(Kernel_ItemExt), (e))
#define __Kernel_ItemExt_Valid(e) __SEND(__TYPEOF(e), 26, BOOLEAN(*)(Kernel_ItemExt), (e))

typedef
	struct Kernel_LoaderHook__rec *Kernel_LoaderHook;

typedef
	struct Kernel_LoaderHook__rec {
		INTEGER res;
		CHAR importing[256], imported[256], object[256];
	} Kernel_LoaderHook__rec;

import Kernel_Module Kernel_LoaderHook_ThisMod (Kernel_LoaderHook h, CHAR *name, INTEGER name__len);
#define __Kernel_LoaderHook_ThisMod(h, name, name__len) __SEND(__TYPEOF(h), 1, Kernel_Module(*)(Kernel_LoaderHook, \
CHAR*, INTEGER ), (h, name, name__len))

typedef
	SHORTCHAR Kernel_Utf8Name[256];

typedef
	struct Kernel_Module__rec {
		Kernel_Module next;
		SET opts;
		INTEGER refcnt;
		SHORTINT compTime[6], loadTime[6];
		INTEGER ext;
		Kernel_Command term;
		INTEGER nofimps, nofptrs, csize, dsize, rsize, code, data, refs, procBase, varBase;
		SHORTCHAR *names;
		INTEGER *ptrs;
		Kernel_Module *imports;
		Kernel_Directory export_;
		Kernel_Utf8Name name;
	} Kernel_Module__rec;

typedef
	CHAR Kernel_Name[256];

typedef
	Kernel_ObjDesc *Kernel_Object;

typedef
	struct Kernel_Reducer__rec *Kernel_Reducer;

typedef
	struct Kernel_Reducer__rec {
		INTEGER _prvt0;
	} Kernel_Reducer__rec;

import void Kernel_Reducer_Reduce (Kernel_Reducer r, BOOLEAN full);
#define __Kernel_Reducer_Reduce(r, full) __SEND(__TYPEOF(r), 1, void(*)(Kernel_Reducer, BOOLEAN), (r, \
full))

typedef
	struct Kernel_Signature__rec *Kernel_Signature;

typedef
	struct Kernel_Signature__rec {
		Kernel_Type retStruct;
		INTEGER num;
		struct Kernel__18 par[1000000];
	} Kernel_Signature__rec;

typedef
	struct Kernel_TrapCleaner__rec *Kernel_TrapCleaner;

typedef
	struct Kernel_TrapCleaner__rec {
		INTEGER _prvt0;
	} Kernel_TrapCleaner__rec;

import void Kernel_TrapCleaner_Cleanup (Kernel_TrapCleaner c);
#define __Kernel_TrapCleaner_Cleanup(c) __SEND(__TYPEOF(c), 1, void(*)(Kernel_TrapCleaner), (c))

typedef
	void (*Kernel_TryHandler)(INTEGER, INTEGER, INTEGER);

typedef
	struct Kernel_Type__rec {
		INTEGER size;
		Kernel_Module mod;
		INTEGER id;
		Kernel_Type base[16];
		Kernel_Directory fields;
		INTEGER ptroffs[1000000];
	} Kernel_Type__rec;


import Kernel_Module Kernel_modList;
import INTEGER Kernel_trapCount, Kernel_err, Kernel_pc, Kernel_sp, Kernel_fp, Kernel_stack, Kernel_val, \
Kernel_argc;
import Kernel_ArrStrPtr Kernel_argv;
import void (*Kernel_watcher)(INTEGER);

import INTEGER Kernel_Module__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_Module__rec__typ;
import INTEGER Kernel_Module__desc[];
import SYSTEM_TYPEDESC *Kernel_Module__typ;
import INTEGER Kernel__1__desc[];
import SYSTEM_TYPEDESC *Kernel__1__typ;
import INTEGER Kernel_Command__desc[];
import SYSTEM_TYPEDESC *Kernel_Command__typ;
import INTEGER Kernel__3__desc[];
import SYSTEM_TYPEDESC *Kernel__3__typ;
import INTEGER Kernel__2__desc[];
import SYSTEM_TYPEDESC *Kernel__2__typ;
import INTEGER Kernel__5__desc[];
import SYSTEM_TYPEDESC *Kernel__5__typ;
import INTEGER Kernel__4__desc[];
import SYSTEM_TYPEDESC *Kernel__4__typ;
import INTEGER Kernel__7__desc[];
import SYSTEM_TYPEDESC *Kernel__7__typ;
import INTEGER Kernel__6__desc[];
import SYSTEM_TYPEDESC *Kernel__6__typ;
import INTEGER Kernel_Directory__desc[];
import SYSTEM_TYPEDESC *Kernel_Directory__typ;
import INTEGER Kernel_Directory__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_Directory__rec__typ;
import INTEGER Kernel_Utf8Name__desc[];
import SYSTEM_TYPEDESC *Kernel_Utf8Name__typ;
import INTEGER Kernel_Type__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_Type__rec__typ;
import INTEGER Kernel__8__desc[];
import SYSTEM_TYPEDESC *Kernel__8__typ;
import INTEGER Kernel_Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Type__typ;
import INTEGER Kernel__9__desc[];
import SYSTEM_TYPEDESC *Kernel__9__typ;
import INTEGER Kernel_ObjDesc__desc[];
import SYSTEM_TYPEDESC *Kernel_ObjDesc__typ;
import INTEGER Kernel__10__desc[];
import SYSTEM_TYPEDESC *Kernel__10__typ;
import INTEGER Kernel__18__desc[];
import SYSTEM_TYPEDESC *Kernel__18__typ;
import INTEGER Kernel_Signature__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_Signature__rec__typ;
import INTEGER Kernel__19__desc[];
import SYSTEM_TYPEDESC *Kernel__19__typ;
import INTEGER Kernel_Reducer__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_Reducer__rec__typ;
import INTEGER Kernel_Reducer__desc[];
import SYSTEM_TYPEDESC *Kernel_Reducer__typ;
import INTEGER Kernel_Identifier__desc[];
import SYSTEM_TYPEDESC *Kernel_Identifier__typ;
import INTEGER Kernel_TrapCleaner__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_TrapCleaner__rec__typ;
import INTEGER Kernel_TrapCleaner__desc[];
import SYSTEM_TYPEDESC *Kernel_TrapCleaner__typ;
import INTEGER Kernel_ItemExt__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_ItemExt__rec__typ;
import INTEGER Kernel_ItemAttr__desc[];
import SYSTEM_TYPEDESC *Kernel_ItemAttr__typ;
import INTEGER SYSTEM_PTR__desc[];
import SYSTEM_TYPEDESC *SYSTEM_PTR__typ;
import INTEGER Kernel_ItemExt__desc[];
import SYSTEM_TYPEDESC *Kernel_ItemExt__typ;
import INTEGER Kernel_Hook__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_Hook__rec__typ;
import INTEGER Kernel_LoaderHook__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_LoaderHook__rec__typ;
import INTEGER Kernel__16__desc[];
import SYSTEM_TYPEDESC *Kernel__16__typ;
import INTEGER Kernel_Block__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_Block__rec__typ;
import INTEGER Kernel_FreeDesc__desc[];
import SYSTEM_TYPEDESC *Kernel_FreeDesc__typ;
import INTEGER Kernel_FreeBlock__desc[];
import SYSTEM_TYPEDESC *Kernel_FreeBlock__typ;
import INTEGER Kernel_Cluster__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_Cluster__rec__typ;
import INTEGER Kernel_Cluster__desc[];
import SYSTEM_TYPEDESC *Kernel_Cluster__typ;
import INTEGER Kernel_FList__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_FList__rec__typ;
import INTEGER Kernel_FList__desc[];
import SYSTEM_TYPEDESC *Kernel_FList__typ;
import INTEGER Kernel_Block__desc[];
import SYSTEM_TYPEDESC *Kernel_Block__typ;
import INTEGER Kernel_CList__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_CList__rec__typ;
import INTEGER Kernel_CList__desc[];
import SYSTEM_TYPEDESC *Kernel_CList__typ;
import INTEGER Kernel_PtrType__desc[];
import SYSTEM_TYPEDESC *Kernel_PtrType__typ;
import INTEGER Kernel_Char8Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Char8Type__typ;
import INTEGER Kernel_Char16Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Char16Type__typ;
import INTEGER Kernel_Int8Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Int8Type__typ;
import INTEGER Kernel_Int16Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Int16Type__typ;
import INTEGER Kernel_Int32Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Int32Type__typ;
import INTEGER Kernel_Int64Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Int64Type__typ;
import INTEGER Kernel_BoolType__desc[];
import SYSTEM_TYPEDESC *Kernel_BoolType__typ;
import INTEGER Kernel_SetType__desc[];
import SYSTEM_TYPEDESC *Kernel_SetType__typ;
import INTEGER Kernel_Real32Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Real32Type__typ;
import INTEGER Kernel_Real64Type__desc[];
import SYSTEM_TYPEDESC *Kernel_Real64Type__typ;
import INTEGER Kernel_ProcType__desc[];
import SYSTEM_TYPEDESC *Kernel_ProcType__typ;
import INTEGER Kernel__38__desc[];
import SYSTEM_TYPEDESC *Kernel__38__typ;
import INTEGER Kernel_UPtrType__desc[];
import SYSTEM_TYPEDESC *Kernel_UPtrType__typ;
import INTEGER Kernel_DLink__rec__desc[];
import SYSTEM_TYPEDESC *Kernel_DLink__rec__typ;
import INTEGER Kernel_DLink__desc[];
import SYSTEM_TYPEDESC *Kernel_DLink__typ;
import INTEGER Kernel_StrPtr__desc[];
import SYSTEM_TYPEDESC *Kernel_StrPtr__typ;
import INTEGER Kernel__20__desc[];
import SYSTEM_TYPEDESC *Kernel__20__typ;
import INTEGER Kernel_Handler__desc[];
import SYSTEM_TYPEDESC *Kernel_Handler__typ;
import INTEGER Kernel_Hook__desc[];
import SYSTEM_TYPEDESC *Kernel_Hook__typ;
import INTEGER Kernel_LoaderHook__desc[];
import SYSTEM_TYPEDESC *Kernel_LoaderHook__typ;
import INTEGER Kernel_Name__desc[];
import SYSTEM_TYPEDESC *Kernel_Name__typ;
import INTEGER Kernel_Object__desc[];
import SYSTEM_TYPEDESC *Kernel_Object__typ;
import INTEGER Kernel_Signature__desc[];
import SYSTEM_TYPEDESC *Kernel_Signature__typ;
import INTEGER Kernel_TryHandler__desc[];
import SYSTEM_TYPEDESC *Kernel_TryHandler__typ;
import INTEGER Kernel_ArrStrPtr__desc[];
import SYSTEM_TYPEDESC *Kernel_ArrStrPtr__typ;
import INTEGER Kernel__24__desc[];
import SYSTEM_TYPEDESC *Kernel__24__typ;

import void Kernel_AllocModMem (INTEGER descSize, INTEGER modSize, INTEGER *descAdr, INTEGER *modAdr);
import INTEGER Kernel_Allocated (void);
import void Kernel_Beep (void);
import LONGINT Kernel_Call (INTEGER adr, Kernel_Signature sig, INTEGER *par, INTEGER par__len, INTEGER \
n);
import void Kernel_Cleanup (void);
import void Kernel_Collect (void);
import void Kernel_DeallocModMem (INTEGER descSize, INTEGER modSize, INTEGER descAdr, INTEGER modAdr);
import void Kernel_FastCollect (void);
import void Kernel_FatalError (INTEGER id, CHAR *str, INTEGER str__len);
import void Kernel_GetLoaderResult (INTEGER *res, CHAR *importing, INTEGER importing__len, CHAR *imported, \
INTEGER imported__len, CHAR *object, INTEGER object__len);
import void Kernel_GetModName (Kernel_Module mod, Kernel_Name name);
import void Kernel_GetObjName (Kernel_Module mod, Kernel_Object obj, Kernel_Name name);
import void Kernel_GetRefProc (INTEGER *ref, INTEGER *adr, Kernel_Utf8Name name);
import void Kernel_GetRefVar (INTEGER *ref, SHORTCHAR *mode, SHORTCHAR *form, Kernel_Type *desc, INTEGER \
*adr, Kernel_Utf8Name name);
import void Kernel_GetTypeName (Kernel_Type t, Kernel_Name name);
import void Kernel_InstallCleaner (Kernel_Command p);
import void Kernel_InstallReducer (Kernel_Reducer r);
import void Kernel_InstallTrapChecker (Kernel_Handler h);
import void Kernel_InstallTrapViewer (Kernel_Handler h);
import BOOLEAN Kernel_IsAlpha (CHAR ch);
import BOOLEAN Kernel_IsLower (CHAR ch);
import BOOLEAN Kernel_IsReadable (INTEGER from, INTEGER to);
import BOOLEAN Kernel_IsUpper (CHAR ch);
import SHORTINT Kernel_LevelOf (Kernel_Type t);
import void Kernel_LoadDll (CHAR *name, INTEGER name__len, BOOLEAN *ok);
import void Kernel_LoadMod (CHAR *name, INTEGER name__len);
import CHAR Kernel_Lower (CHAR ch);
import void Kernel_MakeFileName (CHAR *name, INTEGER name__len, CHAR *type, INTEGER type__len);
import INTEGER Kernel_NewArr (INTEGER eltyp, INTEGER nofelem, INTEGER nofdim);
import void Kernel_NewObj (SYSTEM_PTR *o, Kernel_Type t);
import INTEGER Kernel_NewRec (INTEGER typ);
import void Kernel_PopTrapCleaner (Kernel_TrapCleaner c);
import void Kernel_PushTrapCleaner (Kernel_TrapCleaner c);
import void Kernel_Quit (INTEGER exitCode);
import void Kernel_RegisterMod (Kernel_Module mod);
import void Kernel_RemoveCleaner (Kernel_Command p);
import INTEGER Kernel_Root (void);
import void Kernel_SearchProcVar (INTEGER var, Kernel_Module *m, INTEGER *adr);
import void Kernel_SetLoaderHook (Kernel_LoaderHook h);
import void Kernel_SetTrapGuard (BOOLEAN on);
import INTEGER Kernel_SourcePos (Kernel_Module mod, INTEGER codePos);
import void Kernel_SplitName (CHAR *name, INTEGER name__len, CHAR *head, INTEGER head__len, CHAR *tail, \
INTEGER tail__len);
import void Kernel_Start (Kernel_Command code);
import void Kernel_StringToUtf8 (CHAR *in, INTEGER in__len, SHORTCHAR *out, INTEGER out__len, INTEGER \
*res);
import Kernel_Command Kernel_ThisCommand (Kernel_Module mod, CHAR *name, INTEGER name__len);
import Kernel_Object Kernel_ThisDesc (Kernel_Module mod, INTEGER fprint);
import INTEGER Kernel_ThisDllObj (INTEGER mode, INTEGER fprint, CHAR *dll, INTEGER dll__len, CHAR *name, \
INTEGER name__len);
import Kernel_Object Kernel_ThisField (Kernel_Type rec, CHAR *name, INTEGER name__len);
import ANYPTR Kernel_ThisFinObj (Kernel_Identifier *id, SYSTEM_TYPEDESC *id__typ);
import Kernel_Module Kernel_ThisLoadedMod (CHAR *name, INTEGER name__len);
import Kernel_Module Kernel_ThisMod (CHAR *name, INTEGER name__len);
import Kernel_Object Kernel_ThisObject (Kernel_Module mod, CHAR *name, INTEGER name__len);
import Kernel_Type Kernel_ThisType (Kernel_Module mod, CHAR *name, INTEGER name__len);
import LONGINT Kernel_Time (void);
import void Kernel_Trap (INTEGER n);
import void Kernel_Try (Kernel_TryHandler h, INTEGER a, INTEGER b, INTEGER c);
import Kernel_Type Kernel_TypeOf (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ);
import void Kernel_UnloadMod (Kernel_Module mod);
import CHAR Kernel_Upper (CHAR ch);
import INTEGER Kernel_Used (void);
import void Kernel_Utf8ToString (SHORTCHAR *in, INTEGER in__len, CHAR *out, INTEGER out__len, INTEGER \
*res);
import BOOLEAN Kernel_WouldFinalize (void);

import void Kernel__reg();
import void Kernel__body();
import struct SYSTEM_MODDESC Kernel__desc;

#endif
