/*  CPfront 1.0 -48 */
#include "SYSTEM.h"


static REAL Math_eps, Math_e;


export REAL Math_ArcCos (REAL x);
export REAL Math_ArcCosh (REAL x);
export REAL Math_ArcSin (REAL x);
export REAL Math_ArcSinh (REAL x);
export REAL Math_ArcTan (REAL x);
export REAL Math_ArcTan2 (REAL y, REAL x);
export REAL Math_ArcTanh (REAL x);
export REAL Math_Ceiling (REAL x);
export REAL Math_CopySign (REAL x, REAL y);
export REAL Math_Cos (REAL x);
export REAL Math_Cosh (REAL x);
export REAL Math_Eps (void);
export REAL Math_Exp (REAL x);
export INTEGER Math_Exponent (REAL x);
export REAL Math_Floor (REAL x);
export REAL Math_Frac (REAL x);
export REAL Math_IntPower (REAL x, INTEGER n);
export REAL Math_Ln (REAL x);
export REAL Math_Log (REAL x);
export REAL Math_Mantissa (REAL x);
export REAL Math_Mod1 (REAL x);
export REAL Math_Pi (void);
export REAL Math_Power (REAL x, REAL y);
export REAL Math_Real (REAL m, INTEGER e);
export REAL Math_Round (REAL x);
export REAL Math_Sign (REAL x);
export BOOLEAN Math_SignBit (REAL x);
export REAL Math_Sin (REAL x);
export void Math_SinCos (REAL x, REAL *s, REAL *c);
export REAL Math_Sinh (REAL x);
export REAL Math_Sqrt (REAL x);
export REAL Math_Tan (REAL x);
export REAL Math_Tanh (REAL x);
export REAL Math_Trunc (REAL x);

#include <math.h>
#define Math_M_PI()	M_PI
#define Math_acos(x)	acos(x)
#define Math_acosh(x)	acosh(x)
#define Math_asin(x)	asin(x)
#define Math_asinh(x)	asinh(x)
#define Math_atan(x)	atan(x)
#define Math_atan2(y, x)	atan2(y, x)
#define Math_atanh(x)	atanh(x)
#define Math_ceil(x)	ceil(x)
#define Math_copysign(x, y)	copysign(x, y)
#define Math_cos(x)	cos(x)
#define Math_cosh(x)	cosh(x)
#define Math_exp(x)	exp(x)
#define Math_floor(x)	floor(x)
#define Math_frexp(x, exp)	frexp(x, exp)
#define Math_ldexp(x, exp)	ldexp(x, exp)
#define Math_log(x)	log(x)
#define Math_log10(x)	log10(x)
#define Math_pow(x, y)	pow(x, y)
#define Math_round(x)	round(x)
#define Math_sin(x)	sin(x)
#define Math_sinh(x)	sinh(x)
#define Math_sqrt(x)	sqrt(x)
#define Math_tan(x)	tan(x)
#define Math_tanh(x)	tanh(x)
#define Math_trunc(x)	trunc(x)
export void Math__reg();
export void Math__body();
export struct SYSTEM_MODDESC Math__desc;


REAL Math_Pi (void)
{
	__ENTER("Math.Pi");
	__EXIT;
	return Math_M_PI();
}

REAL Math_Eps (void)
{
	__ENTER("Math.Eps");
	__EXIT;
	return Math_eps;
}

REAL Math_Sqrt (REAL x)
{
	__ENTER("Math.Sqrt");
	__EXIT;
	return Math_sqrt(x);
}

REAL Math_Exp (REAL x)
{
	__ENTER("Math.Exp");
	__EXIT;
	return Math_exp(x);
}

REAL Math_Ln (REAL x)
{
	__ENTER("Math.Ln");
	__EXIT;
	return Math_log(x);
}

REAL Math_Log (REAL x)
{
	__ENTER("Math.Log");
	__EXIT;
	return Math_log10(x);
}

REAL Math_Power (REAL x, REAL y)
{
	__ENTER("Math.Power");
	__EXIT;
	return Math_pow(x, y);
}

REAL Math_IntPower (REAL x, INTEGER n)
{
	REAL y;
	__ENTER("Math.IntPower");
	if (n == (-2147483647-1)) {
		__EXIT;
		return Math_IntPower(x, n + 1) / x;
	}
	y = (REAL)1;
	if (n < 0) {
		x = (REAL)1 / x;
		n = -n;
	}
	while (n > 0) {
		if (__ODD(n)) {
			y = y * x;
			n -= 1;
		} else {
			x = x * x;
			n = __ASHR(n, 1, INTEGER);
		}
	}
	__EXIT;
	return y;
}

REAL Math_Sin (REAL x)
{
	__ENTER("Math.Sin");
	__EXIT;
	return Math_sin(x);
}

REAL Math_Cos (REAL x)
{
	__ENTER("Math.Cos");
	__EXIT;
	return Math_cos(x);
}

REAL Math_Tan (REAL x)
{
	__ENTER("Math.Tan");
	__EXIT;
	return Math_tan(x);
}

void Math_SinCos (REAL x, REAL *s, REAL *c)
{
	__ENTER("Math.SinCos");
	*s = Math_sin(x);
	*c = Math_cos(x);
	__EXIT;
}

REAL Math_ArcSin (REAL x)
{
	__ENTER("Math.ArcSin");
	__EXIT;
	return Math_asin(x);
}

REAL Math_ArcCos (REAL x)
{
	__ENTER("Math.ArcCos");
	__EXIT;
	return Math_acos(x);
}

REAL Math_ArcTan (REAL x)
{
	__ENTER("Math.ArcTan");
	__EXIT;
	return Math_atan(x);
}

REAL Math_ArcTan2 (REAL y, REAL x)
{
	__ENTER("Math.ArcTan2");
	__EXIT;
	return Math_atan2(y, x);
}

REAL Math_Sinh (REAL x)
{
	__ENTER("Math.Sinh");
	__EXIT;
	return Math_sinh(x);
}

REAL Math_Cosh (REAL x)
{
	__ENTER("Math.Cosh");
	__EXIT;
	return Math_cosh(x);
}

REAL Math_Tanh (REAL x)
{
	__ENTER("Math.Tanh");
	__EXIT;
	return Math_tanh(x);
}

REAL Math_ArcSinh (REAL x)
{
	__ENTER("Math.ArcSinh");
	__EXIT;
	return Math_asinh(x);
}

REAL Math_ArcCosh (REAL x)
{
	__ENTER("Math.ArcCosh");
	__EXIT;
	return Math_acosh(x);
}

REAL Math_ArcTanh (REAL x)
{
	__ENTER("Math.ArcTanh");
	__EXIT;
	return Math_atanh(x);
}

REAL Math_Floor (REAL x)
{
	__ENTER("Math.Floor");
	__EXIT;
	return Math_floor(x);
}

REAL Math_Ceiling (REAL x)
{
	__ENTER("Math.Ceiling");
	__EXIT;
	return Math_ceil(x);
}

REAL Math_Round (REAL x)
{
	__ENTER("Math.Round");
	__EXIT;
	return Math_round(x);
}

REAL Math_Trunc (REAL x)
{
	__ENTER("Math.Trunc");
	__EXIT;
	return Math_trunc(x);
}

REAL Math_Frac (REAL x)
{
	__ENTER("Math.Frac");
	if (x >= (REAL)0) {
		__EXIT;
		return x - (REAL)((LONGINT)__ENTIERL(x));
	} else {
		__EXIT;
		return x + (REAL)((LONGINT)__ENTIERL(-x));
	}
	__RETCHK;
}

REAL Math_Mod1 (REAL x)
{
	__ENTER("Math.Mod1");
	__EXIT;
	return x - (REAL)((LONGINT)__ENTIERL(x));
}

REAL Math_Sign (REAL x)
{
	__ENTER("Math.Sign");
	if (x > (REAL)0) {
		__EXIT;
		return (REAL)1;
	} else if (x < (REAL)0) {
		__EXIT;
		return (REAL)-1;
	} else {
		__EXIT;
		return x;
	}
	__RETCHK;
}

BOOLEAN Math_SignBit (REAL x)
{
	__ENTER("Math.SignBit");
	__EXIT;
	return Math_copysign((REAL)1, x) > (REAL)0;
}

REAL Math_CopySign (REAL x, REAL y)
{
	__ENTER("Math.CopySign");
	__EXIT;
	return Math_copysign(x, y);
}

REAL Math_Mantissa (REAL x)
{
	INTEGER e;
	__ENTER("Math.Mantissa");
	__EXIT;
	return Math_frexp(x, &e);
}

INTEGER Math_Exponent (REAL x)
{
	REAL m;
	INTEGER e;
	__ENTER("Math.Exponent");
	m = Math_frexp(x, &e);
	__EXIT;
	return e;
}

REAL Math_Real (REAL m, INTEGER e)
{
	__ENTER("Math.Real");
	__EXIT;
	return Math_ldexp(m, e);
}

static SYSTEM_MODDESC *Math__imp[] = {
	0
};
static INTEGER Math__exp[] = {
	36,
	0xd96acd42, (INTEGER)Math_ArcCos, 1<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_ArcCosh, 8<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_ArcSin, 16<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_ArcSinh, 23<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_ArcTan, 31<<8 | 0x44, 0,
	0xe2868fa2, (INTEGER)Math_ArcTan2, 38<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_ArcTanh, 46<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Ceiling, 54<<8 | 0x44, 0,
	0xe2868fa2, (INTEGER)Math_CopySign, 62<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Cos, 71<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Cosh, 75<<8 | 0x44, 0,
	0x4b10820a, (INTEGER)Math_Eps, 80<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Exp, 84<<8 | 0x44, 0,
	0x72a9084d, (INTEGER)Math_Exponent, 88<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Floor, 97<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Frac, 103<<8 | 0x44, 0,
	0xde082fa8, (INTEGER)Math_IntPower, 108<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Ln, 117<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Log, 120<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Mantissa, 124<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Mod1, 133<<8 | 0x44, 0,
	0x4b10820a, (INTEGER)Math_Pi, 138<<8 | 0x44, 0,
	0xe2868fa2, (INTEGER)Math_Power, 141<<8 | 0x44, 0,
	0xde082fa8, (INTEGER)Math_Real, 147<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Round, 152<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Sign, 158<<8 | 0x44, 0,
	0xb7e8870c, (INTEGER)Math_SignBit, 163<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Sin, 171<<8 | 0x44, 0,
	0xee56f910, (INTEGER)Math_SinCos, 175<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Sinh, 182<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Sqrt, 187<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Tan, 192<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Tanh, 196<<8 | 0x44, 0,
	0xd96acd42, (INTEGER)Math_Trunc, 201<<8 | 0x44, 0,
	0x226bec00, (INTEGER)&Math_e, 207<<8 | 0x13, 8,
	0x226bec00, (INTEGER)&Math_eps, 209<<8 | 0x13, 8,
};
static char Math__names[] = {
	0,
	'A','r','c','C','o','s',0,
	'A','r','c','C','o','s','h',0,
	'A','r','c','S','i','n',0,
	'A','r','c','S','i','n','h',0,
	'A','r','c','T','a','n',0,
	'A','r','c','T','a','n','2',0,
	'A','r','c','T','a','n','h',0,
	'C','e','i','l','i','n','g',0,
	'C','o','p','y','S','i','g','n',0,
	'C','o','s',0,
	'C','o','s','h',0,
	'E','p','s',0,
	'E','x','p',0,
	'E','x','p','o','n','e','n','t',0,
	'F','l','o','o','r',0,
	'F','r','a','c',0,
	'I','n','t','P','o','w','e','r',0,
	'L','n',0,
	'L','o','g',0,
	'M','a','n','t','i','s','s','a',0,
	'M','o','d','1',0,
	'P','i',0,
	'P','o','w','e','r',0,
	'R','e','a','l',0,
	'R','o','u','n','d',0,
	'S','i','g','n',0,
	'S','i','g','n','B','i','t',0,
	'S','i','n',0,
	'S','i','n','C','o','s',0,
	'S','i','n','h',0,
	'S','q','r','t',0,
	'T','a','n',0,
	'T','a','n','h',0,
	'T','r','u','n','c',0,
	'e',0,
	'e','p','s',0,
};
static INTEGER Math__ptrs[] = {
	0
};
struct SYSTEM_MODDESC Math__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 26, 59}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Math__body,
	0,
	0, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Math__names,
	Math__ptrs,
	Math__imp,
	(SYSTEM_DIRECTORY*)Math__exp,
	"Math"
};

export void Math__reg()
{
	__BEGREG(Math__desc);
	__REGMOD(Math__desc);
	__ENDREG;
}

export void Math__body()
{
	__BEGBODY(Math__desc);
	Math_eps = (REAL)1;
	Math_e = (REAL)2;
	while (Math_e > (REAL)1) {
		Math_eps = Math_eps / (REAL)(REAL)2;
		Math_e = (REAL)1 + Math_eps;
	}
	Math_eps = (REAL)2 * Math_eps;
	__ENDBODY;
}
