/*  CPfront 1.0 -48 */
#include "SYSTEM.h"


static SHORTREAL SMath_eps, SMath_e;


export SHORTREAL SMath_ArcCos (SHORTREAL x);
export SHORTREAL SMath_ArcCosh (SHORTREAL x);
export SHORTREAL SMath_ArcSin (SHORTREAL x);
export SHORTREAL SMath_ArcSinh (SHORTREAL x);
export SHORTREAL SMath_ArcTan (SHORTREAL x);
export SHORTREAL SMath_ArcTan2 (SHORTREAL y, SHORTREAL x);
export SHORTREAL SMath_ArcTanh (SHORTREAL x);
export SHORTREAL SMath_Ceiling (SHORTREAL x);
export SHORTREAL SMath_CopySign (SHORTREAL x, SHORTREAL y);
export SHORTREAL SMath_Cos (SHORTREAL x);
export SHORTREAL SMath_Cosh (SHORTREAL x);
export SHORTREAL SMath_Eps (void);
export SHORTREAL SMath_Exp (SHORTREAL x);
export INTEGER SMath_Exponent (SHORTREAL x);
export SHORTREAL SMath_Floor (SHORTREAL x);
export SHORTREAL SMath_Frac (SHORTREAL x);
export SHORTREAL SMath_IntPower (SHORTREAL x, INTEGER n);
export SHORTREAL SMath_Ln (SHORTREAL x);
export SHORTREAL SMath_Log (SHORTREAL x);
export SHORTREAL SMath_Mantissa (SHORTREAL x);
export SHORTREAL SMath_Mod1 (SHORTREAL x);
export SHORTREAL SMath_Pi (void);
export SHORTREAL SMath_Power (SHORTREAL x, SHORTREAL y);
export SHORTREAL SMath_Real (SHORTREAL m, INTEGER e);
export SHORTREAL SMath_Round (SHORTREAL x);
export SHORTREAL SMath_Sign (SHORTREAL x);
export BOOLEAN SMath_SignBit (SHORTREAL x);
export SHORTREAL SMath_Sin (SHORTREAL x);
export void SMath_SinCos (SHORTREAL x, SHORTREAL *s, SHORTREAL *c);
export SHORTREAL SMath_Sinh (SHORTREAL x);
export SHORTREAL SMath_Sqrt (SHORTREAL x);
export SHORTREAL SMath_Tan (SHORTREAL x);
export SHORTREAL SMath_Tanh (SHORTREAL x);
export SHORTREAL SMath_Trunc (SHORTREAL x);

#include <math.h>
#define SMath_M_PI()	M_PI
#define SMath_acosf(x)	acosf(x)
#define SMath_acoshf(x)	acoshf(x)
#define SMath_asinf(x)	asinf(x)
#define SMath_asinhf(x)	asinhf(x)
#define SMath_atan2f(y, x)	atan2f(y, x)
#define SMath_atanf(x)	atanf(x)
#define SMath_atanhf(x)	atanhf(x)
#define SMath_ceilf(x)	ceilf(x)
#define SMath_copysignf(x, y)	copysignf(x, y)
#define SMath_cosf(x)	cosf(x)
#define SMath_coshf(x)	coshf(x)
#define SMath_expf(x)	expf(x)
#define SMath_floorf(x)	floorf(x)
#define SMath_frexpf(x, exp)	frexpf(x, exp)
#define SMath_ldexpf(x, exp)	ldexpf(x, exp)
#define SMath_log10f(x)	log10f(x)
#define SMath_logf(x)	logf(x)
#define SMath_powf(x, y)	powf(x, y)
#define SMath_roundf(x)	roundf(x)
#define SMath_sinf(x)	sinf(x)
#define SMath_sinhf(x)	sinhf(x)
#define SMath_sqrtf(x)	sqrtf(x)
#define SMath_tanf(x)	tanf(x)
#define SMath_tanhf(x)	tanhf(x)
#define SMath_truncf(x)	truncf(x)
export void SMath__reg();
export void SMath__body();
export struct SYSTEM_MODDESC SMath__desc;


SHORTREAL SMath_Pi (void)
{
	__ENTER("SMath.Pi");
	__EXIT;
	return SMath_M_PI();
}

SHORTREAL SMath_Eps (void)
{
	__ENTER("SMath.Eps");
	__EXIT;
	return SMath_eps;
}

SHORTREAL SMath_Sqrt (SHORTREAL x)
{
	__ENTER("SMath.Sqrt");
	__EXIT;
	return SMath_sqrtf(x);
}

SHORTREAL SMath_Exp (SHORTREAL x)
{
	__ENTER("SMath.Exp");
	__EXIT;
	return SMath_expf(x);
}

SHORTREAL SMath_Ln (SHORTREAL x)
{
	__ENTER("SMath.Ln");
	__EXIT;
	return SMath_logf(x);
}

SHORTREAL SMath_Log (SHORTREAL x)
{
	__ENTER("SMath.Log");
	__EXIT;
	return SMath_log10f(x);
}

SHORTREAL SMath_Power (SHORTREAL x, SHORTREAL y)
{
	__ENTER("SMath.Power");
	__EXIT;
	return SMath_powf(x, y);
}

SHORTREAL SMath_IntPower (SHORTREAL x, INTEGER n)
{
	SHORTREAL y;
	__ENTER("SMath.IntPower");
	if (n == (-2147483647-1)) {
		__EXIT;
		return SMath_IntPower(x, n + 1) / x;
	}
	y = (SHORTREAL)1;
	if (n < 0) {
		x = (SHORTREAL)1 / x;
		n = -n;
	}
	while (n > 0) {
		if (__ODD(n)) {
			y = y * x;
			n -= 1;
		} else {
			x = x * x;
			n = __ASHR(n, 1, INTEGER);
		}
	}
	__EXIT;
	return y;
}

SHORTREAL SMath_Sin (SHORTREAL x)
{
	__ENTER("SMath.Sin");
	__EXIT;
	return SMath_sinf(x);
}

SHORTREAL SMath_Cos (SHORTREAL x)
{
	__ENTER("SMath.Cos");
	__EXIT;
	return SMath_cosf(x);
}

SHORTREAL SMath_Tan (SHORTREAL x)
{
	__ENTER("SMath.Tan");
	__EXIT;
	return SMath_tanf(x);
}

void SMath_SinCos (SHORTREAL x, SHORTREAL *s, SHORTREAL *c)
{
	__ENTER("SMath.SinCos");
	*s = SMath_sinf(x);
	*c = SMath_cosf(x);
	__EXIT;
}

SHORTREAL SMath_ArcSin (SHORTREAL x)
{
	__ENTER("SMath.ArcSin");
	__EXIT;
	return SMath_asinf(x);
}

SHORTREAL SMath_ArcCos (SHORTREAL x)
{
	__ENTER("SMath.ArcCos");
	__EXIT;
	return SMath_acosf(x);
}

SHORTREAL SMath_ArcTan (SHORTREAL x)
{
	__ENTER("SMath.ArcTan");
	__EXIT;
	return SMath_atanf(x);
}

SHORTREAL SMath_ArcTan2 (SHORTREAL y, SHORTREAL x)
{
	__ENTER("SMath.ArcTan2");
	__EXIT;
	return SMath_atan2f(y, x);
}

SHORTREAL SMath_Sinh (SHORTREAL x)
{
	__ENTER("SMath.Sinh");
	__EXIT;
	return SMath_sinhf(x);
}

SHORTREAL SMath_Cosh (SHORTREAL x)
{
	__ENTER("SMath.Cosh");
	__EXIT;
	return SMath_coshf(x);
}

SHORTREAL SMath_Tanh (SHORTREAL x)
{
	__ENTER("SMath.Tanh");
	__EXIT;
	return SMath_tanhf(x);
}

SHORTREAL SMath_ArcSinh (SHORTREAL x)
{
	__ENTER("SMath.ArcSinh");
	__EXIT;
	return SMath_asinhf(x);
}

SHORTREAL SMath_ArcCosh (SHORTREAL x)
{
	__ENTER("SMath.ArcCosh");
	__EXIT;
	return SMath_acoshf(x);
}

SHORTREAL SMath_ArcTanh (SHORTREAL x)
{
	__ENTER("SMath.ArcTanh");
	__EXIT;
	return SMath_atanhf(x);
}

SHORTREAL SMath_Floor (SHORTREAL x)
{
	__ENTER("SMath.Floor");
	__EXIT;
	return SMath_floorf(x);
}

SHORTREAL SMath_Ceiling (SHORTREAL x)
{
	__ENTER("SMath.Ceiling");
	__EXIT;
	return SMath_ceilf(x);
}

SHORTREAL SMath_Round (SHORTREAL x)
{
	__ENTER("SMath.Round");
	__EXIT;
	return SMath_roundf(x);
}

SHORTREAL SMath_Trunc (SHORTREAL x)
{
	__ENTER("SMath.Trunc");
	__EXIT;
	return SMath_truncf(x);
}

SHORTREAL SMath_Frac (SHORTREAL x)
{
	__ENTER("SMath.Frac");
	if (x >= (SHORTREAL)0) {
		__EXIT;
		return x - (SHORTREAL)((LONGINT)__ENTIERL(x));
	} else {
		__EXIT;
		return x + (SHORTREAL)((LONGINT)__ENTIERL(-x));
	}
	__RETCHK;
}

SHORTREAL SMath_Mod1 (SHORTREAL x)
{
	__ENTER("SMath.Mod1");
	__EXIT;
	return x - (SHORTREAL)((LONGINT)__ENTIERL(x));
}

SHORTREAL SMath_Sign (SHORTREAL x)
{
	__ENTER("SMath.Sign");
	if (x > (SHORTREAL)0) {
		__EXIT;
		return (SHORTREAL)1;
	} else if (x < (SHORTREAL)0) {
		__EXIT;
		return (SHORTREAL)-1;
	} else {
		__EXIT;
		return x;
	}
	__RETCHK;
}

BOOLEAN SMath_SignBit (SHORTREAL x)
{
	__ENTER("SMath.SignBit");
	__EXIT;
	return SMath_copysignf((SHORTREAL)1, x) > (SHORTREAL)0;
}

SHORTREAL SMath_CopySign (SHORTREAL x, SHORTREAL y)
{
	__ENTER("SMath.CopySign");
	__EXIT;
	return SMath_copysignf(x, y);
}

SHORTREAL SMath_Mantissa (SHORTREAL x)
{
	INTEGER e;
	__ENTER("SMath.Mantissa");
	__EXIT;
	return SMath_frexpf(x, &e);
}

INTEGER SMath_Exponent (SHORTREAL x)
{
	SHORTREAL m;
	INTEGER e;
	__ENTER("SMath.Exponent");
	m = SMath_frexpf(x, &e);
	__EXIT;
	return e;
}

SHORTREAL SMath_Real (SHORTREAL m, INTEGER e)
{
	__ENTER("SMath.Real");
	__EXIT;
	return SMath_ldexpf(m, e);
}

static SYSTEM_MODDESC *SMath__imp[] = {
	0
};
static INTEGER SMath__exp[] = {
	36,
	0xb8e61f96, (INTEGER)SMath_ArcCos, 1<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_ArcCosh, 8<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_ArcSin, 16<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_ArcSinh, 23<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_ArcTan, 31<<8 | 0x44, 0,
	0x5aaa410d, (INTEGER)SMath_ArcTan2, 38<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_ArcTanh, 46<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Ceiling, 54<<8 | 0x44, 0,
	0x5aaa410d, (INTEGER)SMath_CopySign, 62<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Cos, 71<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Cosh, 75<<8 | 0x44, 0,
	0x735f3fb7, (INTEGER)SMath_Eps, 80<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Exp, 84<<8 | 0x44, 0,
	0x4ae6b5f0, (INTEGER)SMath_Exponent, 88<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Floor, 97<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Frac, 103<<8 | 0x44, 0,
	0x5e6b5cba, (INTEGER)SMath_IntPower, 108<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Ln, 117<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Log, 120<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Mantissa, 124<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Mod1, 133<<8 | 0x44, 0,
	0x735f3fb7, (INTEGER)SMath_Pi, 138<<8 | 0x44, 0,
	0x5aaa410d, (INTEGER)SMath_Power, 141<<8 | 0x44, 0,
	0x5e6b5cba, (INTEGER)SMath_Real, 147<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Round, 152<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Sign, 158<<8 | 0x44, 0,
	0x8fa73ab1, (INTEGER)SMath_SignBit, 163<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Sin, 171<<8 | 0x44, 0,
	0x923fb506, (INTEGER)SMath_SinCos, 175<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Sinh, 182<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Sqrt, 187<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Tan, 192<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Tanh, 196<<8 | 0x44, 0,
	0xb8e61f96, (INTEGER)SMath_Trunc, 201<<8 | 0x44, 0,
	0x1a2451bd, (INTEGER)&SMath_e, 207<<8 | 0x13, 7,
	0x1a2451bd, (INTEGER)&SMath_eps, 209<<8 | 0x13, 7,
};
static char SMath__names[] = {
	0,
	'A','r','c','C','o','s',0,
	'A','r','c','C','o','s','h',0,
	'A','r','c','S','i','n',0,
	'A','r','c','S','i','n','h',0,
	'A','r','c','T','a','n',0,
	'A','r','c','T','a','n','2',0,
	'A','r','c','T','a','n','h',0,
	'C','e','i','l','i','n','g',0,
	'C','o','p','y','S','i','g','n',0,
	'C','o','s',0,
	'C','o','s','h',0,
	'E','p','s',0,
	'E','x','p',0,
	'E','x','p','o','n','e','n','t',0,
	'F','l','o','o','r',0,
	'F','r','a','c',0,
	'I','n','t','P','o','w','e','r',0,
	'L','n',0,
	'L','o','g',0,
	'M','a','n','t','i','s','s','a',0,
	'M','o','d','1',0,
	'P','i',0,
	'P','o','w','e','r',0,
	'R','e','a','l',0,
	'R','o','u','n','d',0,
	'S','i','g','n',0,
	'S','i','g','n','B','i','t',0,
	'S','i','n',0,
	'S','i','n','C','o','s',0,
	'S','i','n','h',0,
	'S','q','r','t',0,
	'T','a','n',0,
	'T','a','n','h',0,
	'T','r','u','n','c',0,
	'e',0,
	'e','p','s',0,
};
static INTEGER SMath__ptrs[] = {
	0
};
struct SYSTEM_MODDESC SMath__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 26, 59}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	SMath__body,
	0,
	0, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	SMath__names,
	SMath__ptrs,
	SMath__imp,
	(SYSTEM_DIRECTORY*)SMath__exp,
	"SMath"
};

export void SMath__reg()
{
	__BEGREG(SMath__desc);
	__REGMOD(SMath__desc);
	__ENDREG;
}

export void SMath__body()
{
	__BEGBODY(SMath__desc);
	SMath_eps = (SHORTREAL)1;
	SMath_e = (SHORTREAL)2;
	while (SMath_e > (SHORTREAL)1) {
		SMath_eps = SMath_eps / (SHORTREAL)(SHORTREAL)2;
		SMath_e = (SHORTREAL)1 + SMath_eps;
	}
	SMath_eps = (SHORTREAL)2 * SMath_eps;
	__ENDBODY;
}
