/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"

typedef
	struct Services_Action__rec *Services_Action;

typedef
	struct Services_ActionHook__rec *Services_ActionHook;

typedef
	struct Services_ActionHook__rec {
		char _prvt0[1];
	} Services_ActionHook__rec;

export void Services_ActionHook_Loop (Services_ActionHook h);
export void Services_ActionHook_Step (Services_ActionHook h);
#define __Services_ActionHook_Loop(h) __SEND(__TYPEOF(h), 1, void(*)(Services_ActionHook), (h))
#define __Services_ActionHook_Step(h) __SEND(__TYPEOF(h), 2, void(*)(Services_ActionHook), (h))

typedef
	struct Services_Action__rec {
		LONGINT notBefore;
		Services_Action next;
	} Services_Action__rec;

export void Services_Action_Do (Services_Action a);
#define __Services_Action_Do(a) __SEND(__TYPEOF(a), 1, void(*)(Services_Action), (a))

typedef
	struct Services_StdHook__rec *Services_StdHook;

typedef
	struct Services_StdHook__rec {
		char _prvt0[1];
	} Services_StdHook__rec;

static void Services_StdHook_Loop (Services_StdHook h);
static void Services_StdHook_Step (Services_StdHook h);


export Services_ActionHook Services_actionHook;
static Services_Action Services_actions, Services_candidates;
static BOOLEAN Services_hasImmediates;
static INTEGER Services_trapCnt;

export INTEGER Services_Action__rec__desc[];
export SYSTEM_TYPEDESC *Services_Action__rec__typ = (SYSTEM_TYPEDESC*)(Services_Action__rec__desc + 3);
export INTEGER Services_Action__desc[];
export SYSTEM_TYPEDESC *Services_Action__typ = (SYSTEM_TYPEDESC*)Services_Action__desc;
export INTEGER Services_ActionHook__rec__desc[];
export SYSTEM_TYPEDESC *Services_ActionHook__rec__typ = (SYSTEM_TYPEDESC*)(Services_ActionHook__rec__desc \
+ 4);
export INTEGER Services_StdHook__rec__desc[];
export SYSTEM_TYPEDESC *Services_StdHook__rec__typ = (SYSTEM_TYPEDESC*)(Services_StdHook__rec__desc + \
4);
export INTEGER Services_ActionHook__desc[];
export SYSTEM_TYPEDESC *Services_ActionHook__typ = (SYSTEM_TYPEDESC*)Services_ActionHook__desc;

export INTEGER Services_AdrOf (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ);
static void Services_Cleanup (void);
export void Services_Collect (void);
export void Services_DoLater (Services_Action a, LONGINT notBefore);
static void Services_Excl (Services_Action *l, Services_Action a);
static void Services_Exec (Services_Action a);
export BOOLEAN Services_Extends (CHAR *type, INTEGER type__len, CHAR *base, INTEGER base__len);
export void Services_GetTypeName (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ, CHAR *type, INTEGER type__len);
static BOOLEAN Services_In (Services_Action l, Services_Action a);
static void Services_Incl (Services_Action *l, Services_Action a);
static void Services_Init (void);
export BOOLEAN Services_Is (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ, CHAR *type, INTEGER type__len);
export BOOLEAN Services_IsExtensionOf (ANYREC *ra, SYSTEM_TYPEDESC *ra__typ, ANYREC *rb, SYSTEM_TYPEDESC \
*rb__typ);
static void Services_IterateOverActions (LONGINT time);
export INTEGER Services_Level (CHAR *type, INTEGER type__len);
export void Services_RemoveAction (Services_Action a);
export BOOLEAN Services_SameType (ANYREC *ra, SYSTEM_TYPEDESC *ra__typ, ANYREC *rb, SYSTEM_TYPEDESC *rb__typ);
static Kernel_Type Services_ThisDesc (CHAR *type, INTEGER type__len, BOOLEAN load);
export LONGINT Services_Ticks (void);
export INTEGER Services_TypeLevel (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ);

export void Services__reg();
export void Services__body();
export struct SYSTEM_MODDESC Services__desc;


LONGINT Services_Ticks (void)
{
	LONGINT t;
	__ENTER("Services.Ticks");
	t = Kernel_Time();
	__EXIT;
	return t;
}

static BOOLEAN Services_In (Services_Action l, Services_Action a)
{
	__ENTER("Services.In");
	while (l != NIL && l != a) {
		l = l->next;
	}
	__EXIT;
	return l != NIL;
}

static void Services_Incl (Services_Action *l, Services_Action a)
{
	__ENTER("Services.Incl");
	if (*l != NIL) {
		a->next = *l;
	}
	*l = a;
	__EXIT;
}

static void Services_Excl (Services_Action *l, Services_Action a)
{
	Services_Action p0 = NIL;
	Services_Action p1 = NIL;
	__ENTER("Services.Excl");
	if (*l == a) {
		*l = a->next;
		a->next = NIL;
	} else if (*l != NIL) {
		p0 = *l;
		p1 = p0->next;
		while (p1 != NIL && p1 != a) {
			p0 = p1;
			p1 = p0->next;
		}
		if (p1 == a) {
			p0->next = a->next;
			a->next = NIL;
		}
	}
	__EXIT;
}

static void Services_Exec (Services_Action a)
{
	Kernel_Type t = NIL;
	__ENTER("Services.Exec");
	t = Kernel_TypeOf((void*)a, __TYPEOF(a));
	if (t->mod->refcnt >= 0) {
		__Services_Action_Do(a);
	}
	__EXIT;
}

static void Services_Cleanup (void)
{
	Services_Action p = NIL;
	__ENTER("Services.Cleanup");
	if (Services_candidates != NIL) {
		p = Services_candidates;
		while (p->next != NIL) {
			p = p->next;
		}
		p->next = Services_actions;
		Services_actions = Services_candidates;
		Services_candidates = NIL;
	}
	Services_trapCnt = Kernel_trapCount;
	__EXIT;
}

void Services_DoLater (Services_Action a, LONGINT notBefore)
{
	__ENTER("Services.DoLater");
	__ASSERT(a != NIL, 20);
	if (!Services_In(Services_actions, a) && !Services_In(Services_candidates, a)) {
		Services_Incl(&Services_actions, a);
	}
	a->notBefore = notBefore;
	if (notBefore == -1) {
		Services_hasImmediates = 1;
	}
	__EXIT;
}

void Services_RemoveAction (Services_Action a)
{
	__ENTER("Services.RemoveAction");
	if (a != NIL) {
		Services_Excl(&Services_actions, a);
		Services_Excl(&Services_candidates, a);
	}
	__EXIT;
}

static void Services_IterateOverActions (LONGINT time)
{
	Services_Action p = NIL;
	__ENTER("Services.IterateOverActions");
	Services_Cleanup();
	Services_candidates = Services_actions;
	Services_actions = NIL;
	while (Services_candidates != NIL) {
		p = Services_candidates;
		Services_candidates = p->next;
		if (0 <= p->notBefore && p->notBefore <= time || p->notBefore <= time && time < 0) {
			p->next = NIL;
			Services_Exec(p);
		} else {
			p->next = Services_actions;
			Services_actions = p;
		}
	}
	__EXIT;
}

static void Services_StdHook_Step (Services_StdHook h)
{
	__ENTER("Services.StdHook.Step");
	if (Services_candidates == NIL || Services_trapCnt < Kernel_trapCount) {
		Services_IterateOverActions(Services_Ticks());
	}
	__EXIT;
}

static void Services_StdHook_Loop (Services_StdHook h)
{
	__ENTER("Services.StdHook.Loop");
	if (Services_hasImmediates) {
		__ASSERT(Services_candidates == NIL || Services_trapCnt < Kernel_trapCount, 100);
		Services_IterateOverActions(-1L);
		Services_hasImmediates = 0;
	}
	__EXIT;
}

static Kernel_Type Services_ThisDesc (CHAR *type, INTEGER type__len, BOOLEAN load)
{
	Kernel_Module m = NIL;
	Kernel_Type t = NIL;
	INTEGER i, j;
	CHAR ch;
	Kernel_Name typ, mod;
	__ENTER("Services.ThisDesc");
	__ASSERT(type[0] != 0, 20);
	i = 0;
	ch = type[0];
	while (ch != (CHAR)L'.' && ch != 0) {
		mod[__X(i, 256)] = ch;
		i += 1;
		ch = type[__X(i, type__len)];
	}
	__ASSERT(ch == (CHAR)L'.', 21);
	mod[__X(i, 256)] = 0;
	i += 1;
	t = NIL;
	if (load) {
		m = Kernel_ThisMod((void*)mod, 256);
	} else {
		m = Kernel_ThisLoadedMod((void*)mod, 256);
	}
	if (m != NIL) {
		j = 0;
		do {
			ch = type[__X(i, type__len)];
			typ[__X(j, 256)] = ch;
			i += 1;
			j += 1;
		} while (!(ch == 0));
		t = Kernel_ThisType(m, (void*)typ, 256);
		if (t == NIL) {
			typ[__X(j - 1, 256)] = (CHAR)L'^';
			typ[__X(j, 256)] = 0;
			t = Kernel_ThisType(m, (void*)typ, 256);
		}
	}
	if (t != NIL) {
		if (__MASK(t->id, -4) == 3) {
			t = t->base[0];
		}
		if (__MASK(t->id, -4) != 1) {
			t = NIL;
		}
	}
	__EXIT;
	return t;
}

void Services_GetTypeName (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ, CHAR *type, INTEGER type__len)
{
	INTEGER i, j;
	CHAR ch;
	Kernel_Type t = NIL;
	Kernel_Name modName, name;
	__ENTER("Services.GetTypeName");
	t = Kernel_TypeOf(rec, rec__typ);
	Kernel_GetModName(t->mod, modName);
	Kernel_GetTypeName(t, name);
	__STRCOPYLL(modName, type, type__len);
	i = 0;
	ch = type[0];
	while (ch != 0) {
		i += 1;
		ch = type[__X(i, type__len)];
	}
	type[__X(i, type__len)] = (CHAR)L'.';
	i += 1;
	j = 0;
	do {
		ch = name[__X(j, 256)];
		type[__X(i, type__len)] = ch;
		i += 1;
		j += 1;
	} while (!(ch == 0));
	if (type[__X(i - 2, type__len)] == (CHAR)L'^') {
		type[__X(i - 2, type__len)] = 0;
	}
	__EXIT;
}

BOOLEAN Services_SameType (ANYREC *ra, SYSTEM_TYPEDESC *ra__typ, ANYREC *rb, SYSTEM_TYPEDESC *rb__typ)
{
	__ENTER("Services.SameType");
	__EXIT;
	return Kernel_TypeOf(ra, ra__typ) == Kernel_TypeOf(rb, rb__typ);
}

BOOLEAN Services_IsExtensionOf (ANYREC *ra, SYSTEM_TYPEDESC *ra__typ, ANYREC *rb, SYSTEM_TYPEDESC *rb__typ)
{
	Kernel_Type ta = NIL;
	Kernel_Type tb = NIL;
	__ENTER("Services.IsExtensionOf");
	ta = Kernel_TypeOf(ra, ra__typ);
	tb = Kernel_TypeOf(rb, rb__typ);
	__EXIT;
	return ta->base[__X(__MASK(__ASHR(tb->id, 4, INTEGER), -16), 16)] == tb;
}

BOOLEAN Services_Is (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ, CHAR *type, INTEGER type__len)
{
	Kernel_Type ta = NIL;
	Kernel_Type tb = NIL;
	__ENTER("Services.Is");
	ta = Kernel_TypeOf(rec, rec__typ);
	tb = Services_ThisDesc((void*)type, type__len, 0);
	if (tb != NIL) {
		__EXIT;
		return ta->base[__X(__MASK(__ASHR(tb->id, 4, INTEGER), -16), 16)] == tb;
	} else {
		__EXIT;
		return 0;
	}
	__RETCHK;
}

BOOLEAN Services_Extends (CHAR *type, INTEGER type__len, CHAR *base, INTEGER base__len)
{
	Kernel_Type ta = NIL;
	Kernel_Type tb = NIL;
	__ENTER("Services.Extends");
	__ASSERT(type[0] != 0 && base[0] != 0, 20);
	ta = Services_ThisDesc((void*)type, type__len, 1);
	tb = Services_ThisDesc((void*)base, base__len, 0);
	if (ta != NIL && tb != NIL) {
		__EXIT;
		return ta->base[__X(__MASK(__ASHR(tb->id, 4, INTEGER), -16), 16)] == tb;
	} else {
		__EXIT;
		return 0;
	}
	__RETCHK;
}

INTEGER Services_Level (CHAR *type, INTEGER type__len)
{
	Kernel_Type t = NIL;
	__ENTER("Services.Level");
	t = Services_ThisDesc((void*)type, type__len, 1);
	__EXIT;
	return __MASK(__ASHR(t->id, 4, INTEGER), -16);
}

INTEGER Services_TypeLevel (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ)
{
	Kernel_Type t = NIL;
	__ENTER("Services.TypeLevel");
	t = Kernel_TypeOf(rec, rec__typ);
	if (t == NIL) {
		__EXIT;
		return -1;
	} else {
		__EXIT;
		return __MASK(__ASHR(t->id, 4, INTEGER), -16);
	}
	__RETCHK;
}

INTEGER Services_AdrOf (ANYREC *rec, SYSTEM_TYPEDESC *rec__typ)
{
	__ENTER("Services.AdrOf");
	__EXIT;
	return (INTEGER)rec;
}

void Services_Collect (void)
{
	__ENTER("Services.Collect");
	Kernel_FastCollect();
	__EXIT;
}

static void Services_Init (void)
{
	Services_StdHook h = NIL;
	__ENTER("Services.Init");
	h = __NEW(Services_StdHook__rec__typ);
	Services_actionHook = (Services_ActionHook)h;
	__EXIT;
}

static INTEGER Services_Action__rec__flds[] = {
	2, 
	0, 0, 1<<8 | 0x15, 10,
	0, 8, 11<<8 | 0x15, (INTEGER)Services_Action__desc,
};
export INTEGER Services_Action__rec__desc[] = {
	-1, 
	0, 
	0, 
	16,
	(INTEGER)&Services__desc,
	16<<8 | 0x0d,
	(INTEGER)(Services_Action__rec__desc + 3),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Services_Action__rec__flds, 
	8, -8
};
export INTEGER Services_Action__desc[] = {
	0,
	(INTEGER)&Services__desc,
	24<<8 | 0x03,
	(INTEGER)(Services_Action__rec__desc + 3)
};
static INTEGER Services_ActionHook__rec__flds[] = {
	0, 
};
export INTEGER Services_ActionHook__rec__desc[] = {
	-1, 
	0, 
	0, 
	0, 
	1,
	(INTEGER)&Services__desc,
	31<<8 | 0x1d,
	(INTEGER)(Kernel_Hook__rec__desc + 2),
	(INTEGER)(Services_ActionHook__rec__desc + 4),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Services_ActionHook__rec__flds, 
	-4
};
static INTEGER Services_StdHook__rec__flds[] = {
	0, 
};
export INTEGER Services_StdHook__rec__desc[] = {
	-1, 
	(INTEGER)Services_StdHook_Step, 
	(INTEGER)Services_StdHook_Loop, 
	0, 
	1,
	(INTEGER)&Services__desc,
	43<<8 | 0x21,
	(INTEGER)(Kernel_Hook__rec__desc + 2),
	(INTEGER)(Services_ActionHook__rec__desc + 4),
	(INTEGER)(Services_StdHook__rec__desc + 4),
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	(INTEGER)Services_StdHook__rec__flds, 
	-4
};
export INTEGER Services_ActionHook__desc[] = {
	0,
	(INTEGER)&Services__desc,
	52<<8 | 0x03,
	(INTEGER)(Services_ActionHook__rec__desc + 4)
};
static SYSTEM_MODDESC *Services__imp[] = {
	&Kernel__desc,
};
static INTEGER Services__exp[] = {
	33,
	0xf9186dcd, 0xf9186dcd, 24<<8 | 0x42, (INTEGER)Services_Action__desc,
	0xb5f3fdc6, 0xb5f3fdc6, 52<<8 | 0x42, (INTEGER)Services_ActionHook__desc,
	0xc7ed0f7a, 0x53064663, 31<<8 | 0x12, (INTEGER)(Services_ActionHook__rec__desc + 4),
	0x85e90a26, 0x8f2e8ee4, 16<<8 | 0x12, (INTEGER)(Services_Action__rec__desc + 3),
	0xfb32b1a3, (INTEGER)Services_AdrOf, 63<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Services_Cleanup, 69<<8 | 0x14, 0,
	0x5814f4d6, (INTEGER)Services_Collect, 77<<8 | 0x44, 0,
	0x24ecda04, (INTEGER)Services_DoLater, 85<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Services_Excl, 93<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Services_Exec, 98<<8 | 0x14, 0,
	0x3682a3fd, (INTEGER)Services_Extends, 103<<8 | 0x44, 0,
	0xf7d74c3e, (INTEGER)Services_GetTypeName, 111<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Services_In, 123<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Services_Incl, 126<<8 | 0x14, 0,
	0x227d6f36, (INTEGER)Services_Init, 131<<8 | 0x14, 0,
	0x3bdf34f1, (INTEGER)Services_Is, 136<<8 | 0x44, 0,
	0x5a3f17ab, (INTEGER)Services_IsExtensionOf, 139<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Services_IterateOverActions, 153<<8 | 0x14, 0,
	0x9ad292f9, (INTEGER)Services_Level, 172<<8 | 0x44, 0,
	0x652ba4bd, (INTEGER)Services_RemoveAction, 178<<8 | 0x44, 0,
	0x5a3f17ab, (INTEGER)Services_SameType, 191<<8 | 0x44, 0,
	0x757b8f7b, 0x6022bcc0, 43<<8 | 0x12, (INTEGER)(Services_StdHook__rec__desc + 4),
	0x227d6f36, (INTEGER)Services_ThisDesc, 200<<8 | 0x14, 0,
	0x288b8fac, (INTEGER)Services_Ticks, 209<<8 | 0x44, 0,
	0xfb32b1a3, (INTEGER)Services_TypeLevel, 215<<8 | 0x44, 0,
	0x9a30e6eb, (INTEGER)&Services_actionHook, 225<<8 | 0x23, (INTEGER)Services_ActionHook__desc,
	0x48748650, (INTEGER)&Services_actions, 236<<8 | 0x13, (INTEGER)Services_Action__desc,
	0x48748650, (INTEGER)&Services_candidates, 244<<8 | 0x13, (INTEGER)Services_Action__desc,
	0x0de13ad6, (INTEGER)&Services_hasImmediates, 255<<8 | 0x13, 1,
	0x9149d921, 0, 269<<8 | 0x41, 0,
	0x564d045a, 0, 281<<8 | 0x41, 0,
	0xc7079048, 0, 285<<8 | 0x41, 0,
	0x1ee54c0a, (INTEGER)&Services_trapCnt, 296<<8 | 0x13, 6,
};
static char Services__names[] = {
	0,
	'n','o','t','B','e','f','o','r','e',0,
	'n','e','x','t',0,
	'A','c','t','i','o','n','^',0,
	'A','c','t','i','o','n',0,
	'A','c','t','i','o','n','H','o','o','k','^',0,
	'S','t','d','H','o','o','k','^',0,
	'A','c','t','i','o','n','H','o','o','k',0,
	'A','d','r','O','f',0,
	'C','l','e','a','n','u','p',0,
	'C','o','l','l','e','c','t',0,
	'D','o','L','a','t','e','r',0,
	'E','x','c','l',0,
	'E','x','e','c',0,
	'E','x','t','e','n','d','s',0,
	'G','e','t','T','y','p','e','N','a','m','e',0,
	'I','n',0,
	'I','n','c','l',0,
	'I','n','i','t',0,
	'I','s',0,
	'I','s','E','x','t','e','n','s','i','o','n','O','f',0,
	'I','t','e','r','a','t','e','O','v','e','r','A','c','t','i','o','n','s',0,
	'L','e','v','e','l',0,
	'R','e','m','o','v','e','A','c','t','i','o','n',0,
	'S','a','m','e','T','y','p','e',0,
	'T','h','i','s','D','e','s','c',0,
	'T','i','c','k','s',0,
	'T','y','p','e','L','e','v','e','l',0,
	'a','c','t','i','o','n','H','o','o','k',0,
	'a','c','t','i','o','n','s',0,
	'c','a','n','d','i','d','a','t','e','s',0,
	'h','a','s','I','m','m','e','d','i','a','t','e','s',0,
	'i','m','m','e','d','i','a','t','e','l','y',0,
	'n','o','w',0,
	'r','e','s','o','l','u','t','i','o','n',0,
	't','r','a','p','C','n','t',0,
};
static INTEGER Services__ptrs[] = {
	(INTEGER)&Services_actionHook + 0, 
	(INTEGER)&Services_actions + 0, 
	(INTEGER)&Services_candidates + 0, 
};
struct SYSTEM_MODDESC Services__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 2}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Services__body,
	0,
	1, /* nofimps */ 
	3, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Services__names,
	Services__ptrs,
	Services__imp,
	(SYSTEM_DIRECTORY*)Services__exp,
	"Services"
};

export void Services__reg()
{
	__BEGREG(Services__desc);
	Kernel__reg();
	__REGMOD(Services__desc);
	Services_ActionHook__rec__desc[3] = Kernel_Hook__rec__desc[1];
	Services_StdHook__rec__desc[3] = Kernel_Hook__rec__desc[1];
	__ENDREG;
}

export void Services__body()
{
	__BEGBODY(Services__desc);
	Kernel__body();
	Services_Init();
	__ENDBODY;
}
