/*  CPfront 1.0 -48 */
#include "SYSTEM.h"
#include "Kernel.h"
#include "C99types.h"
#include "Math.h"


static INTEGER Strings_maxExp, Strings_maxDig;
static REAL Strings_factor;
static CHAR Strings_digits[17];
static CHAR Strings_toUpper[256], Strings_toLower[256];


export void Strings_Extract (CHAR *s, INTEGER s__len, INTEGER pos, INTEGER len, CHAR *res, INTEGER res__len);
export void Strings_Find (CHAR *s, INTEGER s__len, CHAR *pat, INTEGER pat__len, INTEGER start, INTEGER \
*pos);
static void Strings_Init (void);
export void Strings_IntToString (LONGINT x, CHAR *s, INTEGER s__len);
export void Strings_IntToStringForm (LONGINT x, INTEGER form, INTEGER minWidth, CHAR fillCh, BOOLEAN showBase, \
CHAR *s, INTEGER s__len);
export BOOLEAN Strings_IsAlpha (CHAR ch);
export BOOLEAN Strings_IsAlphaNumeric (CHAR ch);
export BOOLEAN Strings_IsIdent (CHAR ch);
export BOOLEAN Strings_IsIdentStart (CHAR ch);
export BOOLEAN Strings_IsLower (CHAR ch);
export BOOLEAN Strings_IsNumeric (CHAR ch);
export BOOLEAN Strings_IsUpper (CHAR ch);
export CHAR Strings_Lower (CHAR ch);
export void Strings_RealToString (REAL x, CHAR *s, INTEGER s__len);
export void Strings_RealToStringForm (REAL x, INTEGER precision, INTEGER minW, INTEGER expW, CHAR fillCh, \
CHAR *s, INTEGER s__len);
export void Strings_Replace (CHAR *s, INTEGER s__len, INTEGER pos, INTEGER len, CHAR *rep, INTEGER rep__len);
export void Strings_SetToString (SET x, CHAR *str, INTEGER str__len);
export void Strings_StringToInt (CHAR *s, INTEGER s__len, INTEGER *x, INTEGER *res);
export void Strings_StringToLInt (CHAR *s, INTEGER s__len, LONGINT *x, INTEGER *res);
export void Strings_StringToReal (CHAR *s, INTEGER s__len, REAL *x, INTEGER *res);
export void Strings_StringToSet (CHAR *s, INTEGER s__len, SET *x, INTEGER *res);
export void Strings_StringToUtf8 (CHAR *in, INTEGER in__len, SHORTCHAR *out, INTEGER out__len, INTEGER \
*res);
export void Strings_ToLower (CHAR *in, INTEGER in__len, CHAR *out, INTEGER out__len);
export void Strings_ToUpper (CHAR *in, INTEGER in__len, CHAR *out, INTEGER out__len);
export CHAR Strings_Upper (CHAR ch);
export void Strings_Utf8ToString (SHORTCHAR *in, INTEGER in__len, CHAR *out, INTEGER out__len, INTEGER \
*res);
export BOOLEAN Strings_Valid (CHAR *s, INTEGER s__len);

export void Strings__reg();
export void Strings__body();
export struct SYSTEM_MODDESC Strings__desc;


void Strings_IntToString (LONGINT x, CHAR *s, INTEGER s__len)
{
	INTEGER j, k;
	CHAR ch;
	CHAR a[32];
	__ENTER("Strings.IntToString");
	if (x != 0x8000000000000000) {
		if (x < 0) {
			s[0] = (CHAR)L'-';
			k = 1;
			x = -x;
		} else {
			k = 0;
		}
		j = 0;
		do {
			a[__X(j, 32)] = (CHAR)(__MOD(x, 10) + 48);
			x = __DIV(x, 10);
			j += 1;
		} while (!(x == 0));
	} else {
		__MOVE(((CHAR[]){56, 48, 56, 53, 55, 55, 52, 53, 56, 54, 51, 48, 50, 55, 51, 51, 50, 50, 57, 0}), a, \
40);
		s[0] = (CHAR)L'-';
		k = 1;
		j = 0;
		while (a[__X(j, 32)] != 0) {
			j += 1;
		}
	}
	__ASSERT(k + j < s__len, 23);
	do {
		j -= 1;
		ch = a[__X(j, 32)];
		s[__X(k, s__len)] = ch;
		k += 1;
	} while (!(j == 0));
	s[__X(k, s__len)] = 0;
	__EXIT;
}

void Strings_IntToStringForm (LONGINT x, INTEGER form, INTEGER minWidth, CHAR fillCh, BOOLEAN showBase, \
CHAR *s, INTEGER s__len)
{
	INTEGER base, i, j, k, si;
	BOOLEAN mSign;
	CHAR a[128];
	CHAR c1, c5, c10;
	__ENTER("Strings.IntToStringForm");
	__ASSERT(((form == -1 || form == -2) || form == -3) || form >= 2 && form <= 16, 20);
	__ASSERT(minWidth >= 0, 22);
	if (form == -1) {
		base = 16;
	} else if (form == -2) {
		base = 16;
	} else {
		base = form;
	}
	if (form == -3) {
		__ASSERT(x > 0 && x < 3999, 21);
		base = 1000;
		i = 0;
		mSign = 0;
		while (base > 0 && x > 0) {
			if (base == 1) {
				c1 = (CHAR)L'I';
				c5 = (CHAR)L'V';
				c10 = (CHAR)L'X';
			} else if (base == 10) {
				c1 = (CHAR)L'X';
				c5 = (CHAR)L'L';
				c10 = (CHAR)L'C';
			} else if (base == 100) {
				c1 = (CHAR)L'C';
				c5 = (CHAR)L'D';
				c10 = (CHAR)L'M';
			} else {
				c1 = (CHAR)L'M';
			}
			k = (INTEGER)__DIVFL(x, (LONGINT)base);
			x = __MODFL(x, (LONGINT)base);
			if (__IN(k, 0x0210)) {
				a[__X(i, 128)] = c1;
				i += 1;
			}
			if (__IN(k, 0x01f0)) {
				a[__X(i, 128)] = c5;
				i += 1;
			}
			if (k == 9) {
				a[__X(i, 128)] = c10;
				i += 1;
			} else if (__IN(k, 0x01ce)) {
				j = __MOD(k, 5);
				do {
					a[__X(i, 128)] = c1;
					i += 1;
					j -= 1;
				} while (!(j == 0));
			}
			base = __DIV(base, 10);
		}
	} else if (form == -2 || form == -1) {
		i = 0;
		mSign = 0;
		if (showBase) {
			minWidth -= 1;
		}
		do {
			a[__X(i, 128)] = Strings_digits[__X((INTEGER)__MODFL(x, (LONGINT)base), 17)];
			x = __DIVFL(x, (LONGINT)base);
			i += 1;
		} while (!((x == 0 || x == -1) || i == 128));
		if (x == -1) {
			fillCh = (CHAR)L'F';
		}
	} else {
		if (x < 0) {
			i = 0;
			mSign = 1;
			minWidth -= 1;
			do {
				if (__MODFL(x, (LONGINT)base) == 0) {
					a[__X(i, 128)] = Strings_digits[0];
					x = __DIVFL(x, (LONGINT)base);
				} else {
					a[__X(i, 128)] = Strings_digits[__X((INTEGER)((LONGINT)base - __MODFL(x, (LONGINT)base)), 17)];
					x = __DIVFL(x, (LONGINT)base) + 1;
				}
				i += 1;
			} while (!(x == 0 || i == 128));
		} else {
			i = 0;
			mSign = 0;
			do {
				a[__X(i, 128)] = Strings_digits[__X((INTEGER)__MODFL(x, (LONGINT)base), 17)];
				x = __DIVFL(x, (LONGINT)base);
				i += 1;
			} while (!(x == 0 || i == 128));
		}
		if (showBase) {
			minWidth -= 1;
			if (base < 10) {
				minWidth -= 1;
			} else {
				minWidth -= 2;
			}
		}
	}
	si = 0;
	if ((mSign && fillCh == (CHAR)L'0') && si < s__len) {
		s[__X(si, s__len)] = (CHAR)L'-';
		si += 1;
		mSign = 0;
	}
	while (minWidth > i) {
		if (si < s__len) {
			s[__X(si, s__len)] = fillCh;
			si += 1;
		}
		minWidth -= 1;
	}
	if (mSign && si < s__len) {
		s[__X(si, s__len)] = (CHAR)L'-';
		si += 1;
	}
	if (form == -3) {
		j = 0;
		while (j < i) {
			if (si < s__len) {
				s[__X(si, s__len)] = a[__X(j, 128)];
				si += 1;
			}
			j += 1;
		}
	} else {
		do {
			i -= 1;
			if (si < s__len) {
				s[__X(si, s__len)] = a[__X(i, 128)];
				si += 1;
			}
		} while (!(i == 0));
	}
	if (showBase && form != -3) {
		if (form == -1 && si < s__len) {
			s[__X(si, s__len)] = (CHAR)L'X';
			si += 1;
		} else if (form == -2 && si < s__len) {
			s[__X(si, s__len)] = (CHAR)L'H';
			si += 1;
		} else if (form < 10 && si < s__len - 1) {
			s[__X(si, s__len)] = (CHAR)L'%';
			s[__X(si + 1, s__len)] = Strings_digits[__X(base, 17)];
			si += 2;
		} else if (si < s__len - 2) {
			s[__X(si, s__len)] = (CHAR)L'%';
			s[__X(si + 1, s__len)] = Strings_digits[__X(__DIV(base, 10), 17)];
			s[__X(si + 2, s__len)] = Strings_digits[__X(__MOD(base, 10), 17)];
			si += 3;
		}
	}
	if (si < s__len) {
		s[__X(si, s__len)] = 0;
	} else {
		__HALT(23);
	}
	__EXIT;
}

void Strings_StringToInt (CHAR *s, INTEGER s__len, INTEGER *x, INTEGER *res)
{
	INTEGER i, j, k, digits;
	CHAR ch, top;
	BOOLEAN neg;
	INTEGER base;
	__ENTER("Strings.StringToInt");
	*res = 0;
	i = 0;
	ch = s[0];
	while (((ch != 0 && ch <= (CHAR)L' ' || ch == 139) || ch == 143) || ch == 160) {
		i += 1;
		ch = s[__X(i, s__len)];
	}
	j = i;
	top = (CHAR)L'0';
	while (((ch != 0 && ch != (CHAR)L'H') && ch != (CHAR)L'X') && ch != (CHAR)L'%') {
		if (ch > top) {
			top = ch;
		}
		j += 1;
		ch = s[__X(j, s__len)];
	}
	if (ch == (CHAR)L'H' || ch == (CHAR)L'X') {
		*x = 0;
		ch = s[__X(i, s__len)];
		if ((CHAR)L'0' <= ch && ch <= (CHAR)L'9' || (CHAR)L'A' <= ch && ch <= (CHAR)L'F') {
			while (ch == (CHAR)L'0') {
				i += 1;
				ch = s[__X(i, s__len)];
			}
			digits = 0;
			while (*res == 0 && ((CHAR)L'0' <= ch && ch <= (CHAR)L'9' || (CHAR)L'A' <= ch && ch <= (CHAR)L'F')) \
{
				if (ch < (CHAR)L'A') {
					k = (INTEGER)ch - 48;
				} else {
					k = ((INTEGER)ch - 65) + 10;
				}
				if (digits < 8) {
					*x = __MASK(*x, -268435456);
					if (*x >= 134217728) {
						*x = *x - 268435456;
					}
					*x = __ASHL(*x, 4, INTEGER) + k;
					i += 1;
					ch = s[__X(i, s__len)];
				} else {
					*res = 1;
				}
				digits += 1;
			}
			if (*res == 0) {
				if (ch != (CHAR)L'H' && ch != (CHAR)L'X' || s[__X(i + 1, s__len)] != 0) {
					*res = 2;
				}
			}
		} else {
			*res = 2;
		}
	} else {
		if (ch == (CHAR)L'%') {
			j += 1;
			ch = s[__X(j, s__len)];
			base = 0;
			if ((CHAR)L'0' <= ch && ch <= (CHAR)L'9') {
				k = (INTEGER)ch - 48;
				do {
					base = base * 10 + k;
					j += 1;
					ch = s[__X(j, s__len)];
					k = (INTEGER)ch - 48;
				} while (!((ch < (CHAR)L'0' || ch > (CHAR)L'9') || base > __DIV(2147483647 - k, 10)));
				if ((CHAR)L'0' <= ch && ch <= (CHAR)L'9') {
					base = 0;
				}
			}
		} else {
			base = 10;
		}
		if (base < 2 || base > 16) {
			*res = 2;
		} else if (base <= 10 && (INTEGER)top < base + 48 || base > 10 && (INTEGER)top < (base - 10) + 65) {
			*x = 0;
			ch = s[__X(i, s__len)];
			neg = 0;
			if (ch == (CHAR)L'-') {
				i += 1;
				ch = s[__X(i, s__len)];
				neg = 1;
			} else if (ch == (CHAR)L'+') {
				i += 1;
				ch = s[__X(i, s__len)];
			}
			while (ch != 0 && ch <= (CHAR)L' ') {
				i += 1;
				ch = s[__X(i, s__len)];
			}
			if ((CHAR)L'0' <= ch && ch <= (CHAR)L'9' || (CHAR)L'A' <= ch && ch <= (CHAR)L'F') {
				if (ch <= (CHAR)L'9') {
					k = (INTEGER)ch - 48;
				} else {
					k = ((INTEGER)ch - 65) + 10;
				}
				while (((CHAR)L'0' <= ch && ch <= (CHAR)L'9' || (CHAR)L'A' <= ch && ch <= (CHAR)L'F') && *res == 0) \
{
					if (*x >= __DIVF(((-2147483647-1) + (base - 1)) + k, base)) {
						*x = *x * base - k;
						i += 1;
						ch = s[__X(i, s__len)];
						if (ch <= (CHAR)L'9') {
							k = (INTEGER)ch - 48;
						} else {
							k = ((INTEGER)ch - 65) + 10;
						}
					} else {
						*res = 1;
					}
				}
			} else {
				*res = 2;
			}
			if (*res == 0) {
				if (!neg) {
					if (*x > (-2147483647-1)) {
						*x = -*x;
					} else {
						*res = 1;
					}
				}
				if (ch != 0 && ch != (CHAR)L'%') {
					*res = 2;
				}
			}
		} else {
			*res = 2;
		}
	}
	__EXIT;
}

void Strings_StringToLInt (CHAR *s, INTEGER s__len, LONGINT *x, INTEGER *res)
{
	INTEGER i, j, k, digits;
	CHAR ch, top;
	BOOLEAN neg;
	INTEGER base;
	__ENTER("Strings.StringToLInt");
	*res = 0;
	i = 0;
	ch = s[0];
	while (((ch != 0 && ch <= (CHAR)L' ' || ch == 139) || ch == 143) || ch == 160) {
		i += 1;
		ch = s[__X(i, s__len)];
	}
	j = i;
	top = (CHAR)L'0';
	while (((ch != 0 && ch != (CHAR)L'H') && ch != (CHAR)L'X') && ch != (CHAR)L'%') {
		if (ch > top) {
			top = ch;
		}
		j += 1;
		ch = s[__X(j, s__len)];
	}
	if (ch == (CHAR)L'H' || ch == (CHAR)L'X') {
		*x = 0;
		ch = s[__X(i, s__len)];
		if ((CHAR)L'0' <= ch && ch <= (CHAR)L'9' || (CHAR)L'A' <= ch && ch <= (CHAR)L'F') {
			while (ch == (CHAR)L'0') {
				i += 1;
				ch = s[__X(i, s__len)];
			}
			digits = 0;
			while (*res == 0 && ((CHAR)L'0' <= ch && ch <= (CHAR)L'9' || (CHAR)L'A' <= ch && ch <= (CHAR)L'F')) \
{
				if (ch < (CHAR)L'A') {
					k = (INTEGER)ch - 48;
				} else {
					k = ((INTEGER)ch - 65) + 10;
				}
				if (digits < 16) {
					*x = __MODFL(*x, 0x1000000000000000);
					if (*x >= 0x0800000000000000) {
						*x = *x - 0x1000000000000000;
					}
					*x = *x * 16 + (LONGINT)k;
					i += 1;
					ch = s[__X(i, s__len)];
				} else {
					*res = 1;
				}
				digits += 1;
			}
			if (*res == 0) {
				if (ch != (CHAR)L'H' && ch != (CHAR)L'X' || s[__X(i + 1, s__len)] != 0) {
					*res = 2;
				}
			}
		} else {
			*res = 2;
		}
	} else {
		if (ch == (CHAR)L'%') {
			j += 1;
			ch = s[__X(j, s__len)];
			base = 0;
			if ((CHAR)L'0' <= ch && ch <= (CHAR)L'9') {
				k = (INTEGER)ch - 48;
				do {
					base = base * 10 + k;
					j += 1;
					ch = s[__X(j, s__len)];
					k = (INTEGER)ch - 48;
				} while (!((ch < (CHAR)L'0' || ch > (CHAR)L'9') || base > __DIV(2147483647 - k, 10)));
				if ((CHAR)L'0' <= ch && ch <= (CHAR)L'9') {
					base = 0;
				}
			}
		} else {
			base = 10;
		}
		if (base < 2 || base > 16) {
			*res = 2;
		} else if (base <= 10 && (INTEGER)top < base + 48 || base > 10 && (INTEGER)top < (base - 10) + 65) {
			*x = 0;
			ch = s[__X(i, s__len)];
			neg = 0;
			if (ch == (CHAR)L'-') {
				i += 1;
				ch = s[__X(i, s__len)];
				neg = 1;
			} else if (ch == (CHAR)L'+') {
				i += 1;
				ch = s[__X(i, s__len)];
			}
			while (ch != 0 && ch <= (CHAR)L' ') {
				i += 1;
				ch = s[__X(i, s__len)];
			}
			if ((CHAR)L'0' <= ch && ch <= (CHAR)L'9' || (CHAR)L'A' <= ch && ch <= (CHAR)L'F') {
				if (ch <= (CHAR)L'9') {
					k = (INTEGER)ch - 48;
				} else {
					k = ((INTEGER)ch - 65) + 10;
				}
				while (((CHAR)L'0' <= ch && ch <= (CHAR)L'9' || (CHAR)L'A' <= ch && ch <= (CHAR)L'F') && *res == 0) \
{
					if (*x >= __DIVFL((0x8000000000000000 + (LONGINT)(base - 1)) + (LONGINT)k, (LONGINT)base)) {
						*x = *x * (LONGINT)base - (LONGINT)k;
						i += 1;
						ch = s[__X(i, s__len)];
						if (ch <= (CHAR)L'9') {
							k = (INTEGER)ch - 48;
						} else {
							k = ((INTEGER)ch - 65) + 10;
						}
					} else {
						*res = 1;
					}
				}
			} else {
				*res = 2;
			}
			if (*res == 0) {
				if (!neg) {
					if (*x > 0x8000000000000000) {
						*x = -*x;
					} else {
						*res = 1;
					}
				}
				if (ch != 0 && ch != (CHAR)L'%') {
					*res = 2;
				}
			}
		} else {
			*res = 2;
		}
	}
	__EXIT;
}

void Strings_RealToStringForm (REAL x, INTEGER precision, INTEGER minW, INTEGER expW, CHAR fillCh, CHAR \
*s, INTEGER s__len)
{
	INTEGER exp, len, i, j, n, k, p;
	CHAR m[80];
	BOOLEAN neg;
	__ENTER("Strings.RealToStringForm");
	__ASSERT(precision > 0, 20);
	__ASSERT(minW >= 0 && minW < s__len, 21);
	__ASSERT(expW > -s__len && expW <= 3, 22);
	exp = Math_Exponent(x);
	if (exp == 2147483647) {
		if (fillCh == (CHAR)L'0') {
			fillCh = 143;
		}
		x = Math_Mantissa(x);
		if (x == (REAL)-1) {
			__MOVE(((CHAR[]){45, 105, 110, 102, 0}), m, 10);
			n = 4;
		} else if (x == (REAL)1) {
			__MOVE(((CHAR[]){105, 110, 102, 0}), m, 8);
			n = 3;
		} else {
			__MOVE(((CHAR[]){110, 97, 110, 0}), m, 8);
			n = 3;
		}
		i = 0;
		j = 0;
		while (minW > n) {
			s[__X(i, s__len)] = fillCh;
			i += 1;
			minW -= 1;
		}
		while (j <= n && i < s__len) {
			s[__X(i, s__len)] = m[__X(j, 80)];
			i += 1;
			j += 1;
		}
	} else {
		neg = 0;
		len = 1;
		__MOVE(((CHAR[]){48, 48, 0}), m, 6);
		if (x < (REAL)0) {
			x = -x;
			neg = 1;
			minW -= 1;
		}
		if (x != (REAL)0) {
			exp = __DIV((exp - 8) * 30103, 100000);
			if (exp > 0) {
				n = (INTEGER)__ENTIER(x / Math_IntPower((REAL)10, exp));
				x = x / Math_IntPower((REAL)10, exp) - (REAL)n;
			} else if (exp > -Strings_maxExp) {
				n = (INTEGER)__ENTIER(x * Math_IntPower((REAL)10, -exp));
				x = x * Math_IntPower((REAL)10, -exp) - (REAL)n;
			} else {
				n = (INTEGER)__ENTIER(((x * Math_IntPower((REAL)10, -exp - __ASHL(Strings_maxDig, 1, INTEGER))) * \
Strings_factor) * Strings_factor);
				x = ((x * Math_IntPower((REAL)10, -exp - __ASHL(Strings_maxDig, 1, INTEGER))) * Strings_factor) * \
Strings_factor - (REAL)n;
			}
			p = precision - 4;
			if (n < 1000) {
				p += 1;
			}
			if (expW < 0 && p > exp - expW) {
				p = exp - expW;
			}
			if (p >= 0) {
				x = x + 0.5 / Math_IntPower((REAL)10, p);
				if (x >= (REAL)1) {
					n += 1;
					x = x - (REAL)1;
				}
			} else if (p == -1) {
				n += 5;
			} else if (p == -2) {
				n += 50;
			} else if (p == -3) {
				n += 500;
			}
			i = 0;
			k = 1000;
			exp += 3;
			if (n < 1000) {
				k = 100;
				exp -= 1;
			}
			while (i < precision && (k > 0 || x != (REAL)0)) {
				if (k > 0) {
					p = __DIVF(n, k);
					n = __MODF(n, k);
					k = __DIV(k, 10);
				} else {
					x = x * (REAL)10;
					p = (INTEGER)__ENTIER(x);
					x = x - (REAL)p;
				}
				m[__X(i, 80)] = (CHAR)(p + 48);
				i += 1;
				if (p != 0) {
					len = i;
				}
			}
		}
		i = 0;
		if (expW < 0 || (expW == 0 && exp >= -3) && exp <= len + 1) {
			n = exp + 1;
			k = len - n;
			if (n < 1) {
				n = 1;
			}
			if (expW < 0) {
				k = -expW;
			} else if (k < 1) {
				k = 1;
			}
			j = ((minW - n) - k) - 1;
			p = -exp;
			if (neg && p >= __MAX(0, n) + __MAX(0, k)) {
				neg = 0;
				j += 1;
			}
		} else {
			if (__ABS(exp) >= 100) {
				expW = 3;
			} else if (expW < 2 && __ABS(exp) >= 10) {
				expW = 2;
			} else if (expW < 1) {
				expW = 1;
			}
			if (len < 2) {
				len = 2;
			}
			j = ((minW - len) - 3) - expW;
			k = len;
			if (j > 0) {
				k = k + j;
				j = 0;
				if (k > precision) {
					j = k - precision;
					k = precision;
				}
			}
			n = 1;
			k -= 1;
			p = 0;
		}
		if (neg && fillCh == (CHAR)L'0') {
			s[__X(i, s__len)] = (CHAR)L'-';
			i += 1;
			neg = 0;
		}
		while (j > 0) {
			s[__X(i, s__len)] = fillCh;
			i += 1;
			j -= 1;
		}
		if (neg && i < s__len) {
			s[__X(i, s__len)] = (CHAR)L'-';
			i += 1;
		}
		j = 0;
		while (n > 0 && i < s__len) {
			if (p <= 0 && j < len) {
				s[__X(i, s__len)] = m[__X(j, 80)];
				j += 1;
			} else {
				s[__X(i, s__len)] = (CHAR)L'0';
			}
			i += 1;
			n -= 1;
			p -= 1;
		}
		if (i < s__len) {
			s[__X(i, s__len)] = (CHAR)L'.';
			i += 1;
		}
		while (k > 0 && i < s__len) {
			if (p <= 0 && j < len) {
				s[__X(i, s__len)] = m[__X(j, 80)];
				j += 1;
			} else {
				s[__X(i, s__len)] = (CHAR)L'0';
			}
			i += 1;
			k -= 1;
			p -= 1;
		}
		if (expW > 0) {
			if (i < s__len) {
				s[__X(i, s__len)] = (CHAR)L'E';
				i += 1;
			}
			if (i < s__len) {
				if (exp < 0) {
					s[__X(i, s__len)] = (CHAR)L'-';
					exp = -exp;
				} else {
					s[__X(i, s__len)] = (CHAR)L'+';
				}
				i += 1;
			}
			if (expW == 3 && i < s__len) {
				s[__X(i, s__len)] = (CHAR)(__DIV(exp, 100) + 48);
				i += 1;
			}
			if (expW >= 2 && i < s__len) {
				s[__X(i, s__len)] = (CHAR)(__MOD(__DIV(exp, 10), 10) + 48);
				i += 1;
			}
			if (i < s__len) {
				s[__X(i, s__len)] = (CHAR)(__MOD(exp, 10) + 48);
				i += 1;
			}
		}
	}
	if (i < s__len) {
		s[__X(i, s__len)] = 0;
	} else {
		__HALT(23);
	}
	__EXIT;
}

void Strings_RealToString (REAL x, CHAR *s, INTEGER s__len)
{
	__ENTER("Strings.RealToString");
	Strings_RealToStringForm(x, 16, 0, 0, 143, (void*)s, s__len);
	__EXIT;
}

void Strings_StringToReal (CHAR *s, INTEGER s__len, REAL *x, INTEGER *res)
{
	INTEGER first, last, point, e, n, i, exp;
	REAL y;
	CHAR ch;
	BOOLEAN neg, negExp, dig;
	__ENTER("Strings.StringToReal");
	*res = 0;
	i = 0;
	ch = s[0];
	dig = 0;
	while (((ch != 0 && ch <= (CHAR)L' ' || ch == 139) || ch == 143) || ch == 160) {
		i += 1;
		ch = s[__X(i, s__len)];
	}
	if (ch == (CHAR)L'+') {
		neg = 0;
		i += 1;
		ch = s[__X(i, s__len)];
	} else if (ch == (CHAR)L'-') {
		neg = 1;
		i += 1;
		ch = s[__X(i, s__len)];
	} else {
		neg = 0;
	}
	while (ch == (CHAR)L'0') {
		i += 1;
		ch = s[__X(i, s__len)];
		dig = 1;
	}
	first = i;
	e = 0;
	while ((CHAR)L'0' <= ch && ch <= (CHAR)L'9') {
		i += 1;
		ch = s[__X(i, s__len)];
		e += 1;
		dig = 1;
	}
	point = i;
	if (ch == (CHAR)L'.') {
		i += 1;
		ch = s[__X(i, s__len)];
		if (e == 0) {
			while (ch == (CHAR)L'0') {
				i += 1;
				ch = s[__X(i, s__len)];
				e -= 1;
				dig = 1;
			}
			first = i;
		}
		while ((CHAR)L'0' <= ch && ch <= (CHAR)L'9') {
			i += 1;
			ch = s[__X(i, s__len)];
			dig = 1;
		}
	}
	last = i - 1;
	exp = 0;
	if (ch == (CHAR)L'E' || ch == (CHAR)L'D') {
		i += 1;
		ch = s[__X(i, s__len)];
		negExp = 0;
		if (ch == (CHAR)L'-') {
			negExp = 1;
			i += 1;
			ch = s[__X(i, s__len)];
		} else if (ch == (CHAR)L'+') {
			i += 1;
			ch = s[__X(i, s__len)];
		}
		while (((CHAR)L'0' <= ch && ch <= (CHAR)L'9') && exp < 1000) {
			exp = exp * 10 + ((INTEGER)ch - 48);
			i += 1;
			ch = s[__X(i, s__len)];
		}
		if (negExp) {
			exp = -exp;
		}
	}
	exp = exp + e;
	*x = (REAL)0;
	y = (REAL)0;
	n = 0;
	while (n < Strings_maxDig && first <= last) {
		if (first != point) {
			*x = *x * (REAL)10 + (REAL)((INTEGER)s[__X(first, s__len)] - 48);
			n += 1;
		}
		first += 1;
	}
	while (last >= first) {
		if (last != point) {
			y = (y + (REAL)((INTEGER)s[__X(last, s__len)] - 48)) / (REAL)(REAL)10;
		}
		last -= 1;
	}
	if (!dig || ch != 0) {
		*res = 2;
	} else if (exp < -Strings_maxExp - Strings_maxDig) {
		*x = (REAL)0;
	} else if (exp < -Strings_maxExp + Strings_maxDig) {
		*x = (((*x + y) / Math_IntPower((REAL)10, (n - exp) - __ASHL(Strings_maxDig, 1, INTEGER))) / Strings_factor) \
/ Strings_factor;
	} else if (exp < n) {
		*x = (*x + y) / Math_IntPower((REAL)10, n - exp);
	} else if (exp < Strings_maxExp) {
		*x = (*x + y) * Math_IntPower((REAL)10, exp - n);
	} else if (exp == Strings_maxExp) {
		*x = (*x + y) * (Math_IntPower((REAL)10, exp - n) / (REAL)(REAL)16);
		if (*x <= 1.123558209288947E+307) {
			*x = *x * (REAL)16;
		} else {
			*res = 1;
		}
	} else {
		*res = 1;
	}
	if (neg) {
		*x = -*x;
	}
	__EXIT;
}

static struct SetToString__17 {
	CHAR *str;
	INTEGER str__len;
	INTEGER *len;
	struct SetToString__17 *lnk;
} *SetToString__17_s;

static void __18 (CHAR ch);
static void __20 (INTEGER x);

static void __18 (CHAR ch)
{
	__ENTER("Strings.AppendChar");
	__ASSERT((*SetToString__17_s->len) < SetToString__17_s->str__len, 23);
	SetToString__17_s->str[__X((*SetToString__17_s->len), SetToString__17_s->str__len)] = ch;
	(*SetToString__17_s->len) += 1;
	__EXIT;
}

static void __20 (INTEGER x)
{
	INTEGER i;
	CHAR ch;
	CHAR buf[32];
	__ENTER("Strings.AppendInt");
	Strings_IntToString(x, (void*)buf, 32);
	ch = buf[0];
	i = 0;
	while (ch != 0) {
		__18(ch);
		i += 1;
		ch = buf[__X(i, 32)];
	}
	__EXIT;
}

void Strings_SetToString (SET x, CHAR *str, INTEGER str__len)
{
	INTEGER len, i;
	struct SetToString__17 _s;
	__ENTER("Strings.SetToString");
	_s.str = (void*)str; _s.str__len = str__len;
	_s.len = &len;
	_s.lnk = SetToString__17_s;
	SetToString__17_s = &_s;
	len = 0;
	__18((CHAR)L'{');
	i = 0;
	while (x != 0x0) {
		if (__IN(i, x)) {
			__20(i);
			x &= ~__SETOF(i);
			if ((i <= 29 && __IN(i + 1, x)) && __IN(i + 2, x)) {
				__18((CHAR)L'.');
				__18((CHAR)L'.');
				x = x & ~(__SETOF(i + 1) | __SETOF(i + 2));
				i += 3;
				while (i <= 31 && __IN(i, x)) {
					x &= ~__SETOF(i);
					i += 1;
				}
				__20(i - 1);
			}
			if (x != 0x0) {
				__18((CHAR)L',');
				__18((CHAR)L' ');
			}
		}
		i += 1;
	}
	__18((CHAR)L'}');
	__18(0);
	SetToString__17_s = _s.lnk;
	__EXIT;
}

static struct StringToSet__25 {
	CHAR *s;
	INTEGER s__len;
	SET *x;
	INTEGER *res;
	INTEGER *next, *x1;
	CHAR *ch;
	struct StringToSet__25 *lnk;
} *StringToSet__25_s;

static void __26 (void);
static INTEGER __28 (void);
static void __30 (void);

static void __26 (void)
{
	__ENTER("Strings.NextChar");
	(*StringToSet__25_s->ch) = StringToSet__25_s->s[__X((*StringToSet__25_s->next), StringToSet__25_s->s__len)];
	while ((*StringToSet__25_s->ch) <= (CHAR)L' ' && (*StringToSet__25_s->ch) != 0) {
		(*StringToSet__25_s->next) += 1;
		(*StringToSet__25_s->ch) = StringToSet__25_s->s[__X((*StringToSet__25_s->next), StringToSet__25_s->s__len)];
	}
	if ((*StringToSet__25_s->ch) != 0) {
		(*StringToSet__25_s->next) += 1;
	}
	__EXIT;
}

static INTEGER __28 (void)
{
	INTEGER intval;
	__ENTER("Strings.ParseInt");
	intval = (INTEGER)(*StringToSet__25_s->ch) - 48;
	(*StringToSet__25_s->ch) = StringToSet__25_s->s[__X((*StringToSet__25_s->next), StringToSet__25_s->s__len)];
	while ((CHAR)L'0' <= (*StringToSet__25_s->ch) && (*StringToSet__25_s->ch) <= (CHAR)L'9') {
		intval = (intval * 10 + (INTEGER)(*StringToSet__25_s->ch)) - 48;
		if (intval > 31) {
			*StringToSet__25_s->res = 1;
			intval = 0;
		}
		(*StringToSet__25_s->next) += 1;
		(*StringToSet__25_s->ch) = StringToSet__25_s->s[__X((*StringToSet__25_s->next), StringToSet__25_s->s__len)];
	}
	__26();
	__EXIT;
	return intval;
}

static void __30 (void)
{
	INTEGER x2, i, _for__32;
	__ENTER("Strings.ParseRange");
	(*StringToSet__25_s->ch) = StringToSet__25_s->s[__X((*StringToSet__25_s->next), StringToSet__25_s->s__len)];
	(*StringToSet__25_s->next) += 1;
	if ((*StringToSet__25_s->ch) == (CHAR)L'.') {
		__26();
		if ((CHAR)L'0' <= (*StringToSet__25_s->ch) && (*StringToSet__25_s->ch) <= (CHAR)L'9') {
			x2 = __28();
			if (*StringToSet__25_s->res == 0) {
				if (x2 >= (*StringToSet__25_s->x1)) {
					_for__32 = x2;
					i = (*StringToSet__25_s->x1);
					while (i <= _for__32) {
						*StringToSet__25_s->x |= __SETOF(i);
						i += 1;
					}
				} else {
					*StringToSet__25_s->res = 2;
				}
			}
		} else {
			*StringToSet__25_s->res = 2;
		}
	} else {
		*StringToSet__25_s->res = 2;
	}
	__EXIT;
}

void Strings_StringToSet (CHAR *s, INTEGER s__len, SET *x, INTEGER *res)
{
	INTEGER next, x1;
	CHAR ch;
	struct StringToSet__25 _s;
	__ENTER("Strings.StringToSet");
	_s.s = (void*)s; _s.s__len = s__len;
	_s.x = x;
	_s.res = res;
	_s.next = &next;
	_s.x1 = &x1;
	_s.ch = &ch;
	_s.lnk = StringToSet__25_s;
	StringToSet__25_s = &_s;
	*x = 0x0;
	*res = 0;
	next = 0;
	__26();
	if (ch == (CHAR)L'{') {
		__26();
		while (((CHAR)L'0' <= ch && ch <= (CHAR)L'9') && *res != 2) {
			x1 = __28();
			if (ch == (CHAR)L'.') {
				__30();
			} else if (*res == 0) {
				*x |= __SETOF(x1);
			}
			if (ch == (CHAR)L',') {
				__26();
			}
		}
		if (ch == (CHAR)L'}') {
			__26();
			if (ch != 0) {
				*res = 2;
			}
		} else {
			*res = 2;
		}
	} else {
		*res = 2;
	}
	StringToSet__25_s = _s.lnk;
	__EXIT;
}

BOOLEAN Strings_IsUpper (CHAR ch)
{
	__ENTER("Strings.IsUpper");
	if ((INTEGER)ch < 256) {
		__EXIT;
		return Strings_toLower[__X((INTEGER)ch, 256)] != ch;
	} else {
		__EXIT;
		return Kernel_IsUpper(ch);
	}
	__RETCHK;
}

CHAR Strings_Upper (CHAR ch)
{
	__ENTER("Strings.Upper");
	if ((INTEGER)ch < 256) {
		__EXIT;
		return Strings_toUpper[__X((INTEGER)ch, 256)];
	} else {
		__EXIT;
		return Kernel_Upper(ch);
	}
	__RETCHK;
}

BOOLEAN Strings_IsLower (CHAR ch)
{
	__ENTER("Strings.IsLower");
	if ((INTEGER)ch < 256) {
		__EXIT;
		return Strings_toUpper[__X((INTEGER)ch, 256)] != ch;
	} else {
		__EXIT;
		return Kernel_IsLower(ch);
	}
	__RETCHK;
}

CHAR Strings_Lower (CHAR ch)
{
	__ENTER("Strings.Lower");
	if ((INTEGER)ch < 256) {
		__EXIT;
		return Strings_toLower[__X((INTEGER)ch, 256)];
	} else {
		__EXIT;
		return Kernel_Lower(ch);
	}
	__RETCHK;
}

BOOLEAN Strings_IsAlpha (CHAR ch)
{
	__ENTER("Strings.IsAlpha");
	switch (ch) {
		case (CHAR)'A': case (CHAR)'B': case (CHAR)'C': case (CHAR)'D': case (CHAR)'E': 
		case (CHAR)'F': case (CHAR)'G': case (CHAR)'H': case (CHAR)'I': case (CHAR)'J': 
		case (CHAR)'K': case (CHAR)'L': case (CHAR)'M': case (CHAR)'N': case (CHAR)'O': 
		case (CHAR)'P': case (CHAR)'Q': case (CHAR)'R': case (CHAR)'S': case (CHAR)'T': 
		case (CHAR)'U': case (CHAR)'V': case (CHAR)'W': case (CHAR)'X': case (CHAR)'Y': 
		case (CHAR)'Z': case (CHAR)'a': case (CHAR)'b': case (CHAR)'c': case (CHAR)'d': 
		case (CHAR)'e': case (CHAR)'f': case (CHAR)'g': case (CHAR)'h': case (CHAR)'i': 
		case (CHAR)'j': case (CHAR)'k': case (CHAR)'l': case (CHAR)'m': case (CHAR)'n': 
		case (CHAR)'o': case (CHAR)'p': case (CHAR)'q': case (CHAR)'r': case (CHAR)'s': 
		case (CHAR)'t': case (CHAR)'u': case (CHAR)'v': case (CHAR)'w': case (CHAR)'x': 
		case (CHAR)'y': case (CHAR)'z': 
			__EXIT;
			return 1;
			break;
		default: 
			if (ch > 127) {
				__EXIT;
				return Kernel_IsAlpha(ch);
			} else {
				__EXIT;
				return 0;
			}
			break;
	}
	__RETCHK;
}

BOOLEAN Strings_IsNumeric (CHAR ch)
{
	__ENTER("Strings.IsNumeric");
	__EXIT;
	return (CHAR)L'0' <= ch && ch <= (CHAR)L'9';
}

BOOLEAN Strings_IsAlphaNumeric (CHAR ch)
{
	__ENTER("Strings.IsAlphaNumeric");
	__EXIT;
	return Strings_IsAlpha(ch) || Strings_IsNumeric(ch);
}

BOOLEAN Strings_IsIdentStart (CHAR ch)
{
	__ENTER("Strings.IsIdentStart");
	switch (ch) {
		case (CHAR)'A': case (CHAR)'B': case (CHAR)'C': case (CHAR)'D': case (CHAR)'E': 
		case (CHAR)'F': case (CHAR)'G': case (CHAR)'H': case (CHAR)'I': case (CHAR)'J': 
		case (CHAR)'K': case (CHAR)'L': case (CHAR)'M': case (CHAR)'N': case (CHAR)'O': 
		case (CHAR)'P': case (CHAR)'Q': case (CHAR)'R': case (CHAR)'S': case (CHAR)'T': 
		case (CHAR)'U': case (CHAR)'V': case (CHAR)'W': case (CHAR)'X': case (CHAR)'Y': 
		case (CHAR)'Z': case (CHAR)'_': case (CHAR)'a': case (CHAR)'b': case (CHAR)'c': 
		case (CHAR)'d': case (CHAR)'e': case (CHAR)'f': case (CHAR)'g': case (CHAR)'h': 
		case (CHAR)'i': case (CHAR)'j': case (CHAR)'k': case (CHAR)'l': case (CHAR)'m': 
		case (CHAR)'n': case (CHAR)'o': case (CHAR)'p': case (CHAR)'q': case (CHAR)'r': 
		case (CHAR)'s': case (CHAR)'t': case (CHAR)'u': case (CHAR)'v': case (CHAR)'w': 
		case (CHAR)'x': case (CHAR)'y': case (CHAR)'z': 
			__EXIT;
			return 1;
			break;
		default: 
			if (ch > 127) {
				__EXIT;
				return Kernel_IsAlpha(ch);
			} else {
				__EXIT;
				return 0;
			}
			break;
	}
	__RETCHK;
}

BOOLEAN Strings_IsIdent (CHAR ch)
{
	__ENTER("Strings.IsIdent");
	switch (ch) {
		case (CHAR)'0': case (CHAR)'1': case (CHAR)'2': case (CHAR)'3': case (CHAR)'4': 
		case (CHAR)'5': case (CHAR)'6': case (CHAR)'7': case (CHAR)'8': case (CHAR)'9': 
		case (CHAR)'A': case (CHAR)'B': case (CHAR)'C': case (CHAR)'D': case (CHAR)'E': 
		case (CHAR)'F': case (CHAR)'G': case (CHAR)'H': case (CHAR)'I': case (CHAR)'J': 
		case (CHAR)'K': case (CHAR)'L': case (CHAR)'M': case (CHAR)'N': case (CHAR)'O': 
		case (CHAR)'P': case (CHAR)'Q': case (CHAR)'R': case (CHAR)'S': case (CHAR)'T': 
		case (CHAR)'U': case (CHAR)'V': case (CHAR)'W': case (CHAR)'X': case (CHAR)'Y': 
		case (CHAR)'Z': case (CHAR)'_': case (CHAR)'a': case (CHAR)'b': case (CHAR)'c': 
		case (CHAR)'d': case (CHAR)'e': case (CHAR)'f': case (CHAR)'g': case (CHAR)'h': 
		case (CHAR)'i': case (CHAR)'j': case (CHAR)'k': case (CHAR)'l': case (CHAR)'m': 
		case (CHAR)'n': case (CHAR)'o': case (CHAR)'p': case (CHAR)'q': case (CHAR)'r': 
		case (CHAR)'s': case (CHAR)'t': case (CHAR)'u': case (CHAR)'v': case (CHAR)'w': 
		case (CHAR)'x': case (CHAR)'y': case (CHAR)'z': 
			__EXIT;
			return 1;
			break;
		default: 
			if (ch > 127) {
				__EXIT;
				return Kernel_IsAlpha(ch);
			} else {
				__EXIT;
				return 0;
			}
			break;
	}
	__RETCHK;
}

BOOLEAN Strings_Valid (CHAR *s, INTEGER s__len)
{
	INTEGER i;
	__ENTER("Strings.Valid");
	i = 0;
	while (i < s__len && s[__X(i, s__len)] != 0) {
		i += 1;
	}
	__EXIT;
	return i < s__len;
}

void Strings_ToUpper (CHAR *in, INTEGER in__len, CHAR *out, INTEGER out__len)
{
	INTEGER i, max;
	__ENTER("Strings.ToUpper");
	i = 0;
	max = out__len - 1;
	while (in[__X(i, in__len)] != 0 && i < max) {
		if ((INTEGER)in[__X(i, in__len)] < 256) {
			out[__X(i, out__len)] = Strings_toUpper[__X((INTEGER)in[__X(i, in__len)], 256)];
		} else {
			out[__X(i, out__len)] = Kernel_Upper(in[__X(i, in__len)]);
		}
		i += 1;
	}
	out[__X(i, out__len)] = 0;
	__EXIT;
}

void Strings_ToLower (CHAR *in, INTEGER in__len, CHAR *out, INTEGER out__len)
{
	INTEGER i, max;
	__ENTER("Strings.ToLower");
	i = 0;
	max = out__len - 1;
	while (in[__X(i, in__len)] != 0 && i < max) {
		if ((INTEGER)in[__X(i, in__len)] < 256) {
			out[__X(i, out__len)] = Strings_toLower[__X((INTEGER)in[__X(i, in__len)], 256)];
		} else {
			out[__X(i, out__len)] = Kernel_Lower(in[__X(i, in__len)]);
		}
		i += 1;
	}
	out[__X(i, out__len)] = 0;
	__EXIT;
}

void Strings_Utf8ToString (SHORTCHAR *in, INTEGER in__len, CHAR *out, INTEGER out__len, INTEGER *res)
{
	__ENTER("Strings.Utf8ToString");
	Kernel_Utf8ToString((void*)in, in__len, (void*)out, out__len, res);
	__EXIT;
}

void Strings_StringToUtf8 (CHAR *in, INTEGER in__len, SHORTCHAR *out, INTEGER out__len, INTEGER *res)
{
	__ENTER("Strings.StringToUtf8");
	Kernel_StringToUtf8((void*)in, in__len, (void*)out, out__len, res);
	__EXIT;
}

void Strings_Replace (CHAR *s, INTEGER s__len, INTEGER pos, INTEGER len, CHAR *rep, INTEGER rep__len)
{
	INTEGER i, j, k, max, lenS;
	CHAR ch;
	__ENTER("Strings.Replace");
	__ASSERT(len >= 0, 20);
	__ASSERT(pos >= 0, 21);
	lenS = __STRLEN(s);
	max = s__len - 1;
	if (pos <= lenS) {
		i = pos;
		j = 0;
		ch = rep[0];
		if (pos + len > lenS) {
			len = lenS - pos;
		}
		while (ch != 0 && len > 0) {
			s[__X(i, s__len)] = ch;
			i += 1;
			j += 1;
			len -= 1;
			ch = rep[__X(j, rep__len)];
		}
		if (len > 0) {
			do {
				ch = s[__X(i + len, s__len)];
				s[__X(i, s__len)] = ch;
				i += 1;
			} while (!(ch == 0));
		} else if (ch != 0) {
			len = __STRLEN(rep) - j;
			k = lenS + len;
			if (k > max) {
				k = max;
			}
			s[__X(k, s__len)] = 0;
			k -= 1;
			while (k - len >= i) {
				s[__X(k, s__len)] = s[__X(k - len, s__len)];
				k -= 1;
			}
			while (rep[__X(j, rep__len)] != 0 && i < max) {
				s[__X(i, s__len)] = rep[__X(j, rep__len)];
				i += 1;
				j += 1;
			}
		}
	}
	__EXIT;
}

void Strings_Extract (CHAR *s, INTEGER s__len, INTEGER pos, INTEGER len, CHAR *res, INTEGER res__len)
{
	INTEGER i, j, max;
	__ENTER("Strings.Extract");
	__DUP(s, s__len);
	__ASSERT(len >= 0, 20);
	__ASSERT(pos >= 0, 21);
	i = 0;
	j = 0;
	max = res__len - 1;
	while (i < pos && s[__X(i, s__len)] != 0) {
		i += 1;
	}
	while ((j < len && j < max) && s[__X(i, s__len)] != 0) {
		res[__X(j, res__len)] = s[__X(i, s__len)];
		j += 1;
		i += 1;
	}
	res[__X(j, res__len)] = 0;
	__DEL(s);
	__EXIT;
}

void Strings_Find (CHAR *s, INTEGER s__len, CHAR *pat, INTEGER pat__len, INTEGER start, INTEGER *pos)
{
	INTEGER j;
	__ENTER("Strings.Find");
	__ASSERT(start >= 0, 20);
	if (start == 0 || start <= __STRLEN(s) - __STRLEN(pat)) {
		*pos = start;
		while (s[__X(*pos, s__len)] != 0) {
			j = 0;
			while (s[__X(*pos + j, s__len)] == pat[__X(j, pat__len)] && pat[__X(j, pat__len)] != 0) {
				j += 1;
			}
			if (pat[__X(j, pat__len)] == 0) {
				__EXIT;
				return;
			}
			*pos += 1;
		}
	}
	*pos = -1;
	__EXIT;
}

static void Strings_Init (void)
{
	INTEGER i;
	__ENTER("Strings.Init");
	i = 0;
	while (i <= 255) {
		Strings_toUpper[__X(i, 256)] = (CHAR)i;
		Strings_toLower[__X(i, 256)] = (CHAR)i;
		i += 1;
	}
	i = 65;
	while (i <= 90) {
		Strings_toLower[__X(i, 256)] = (CHAR)(i + 32);
		Strings_toUpper[__X(i + 32, 256)] = (CHAR)i;
		i += 1;
	}
	i = 192;
	while (i <= 214) {
		Strings_toLower[__X(i, 256)] = (CHAR)(i + 32);
		Strings_toUpper[__X(i + 32, 256)] = (CHAR)i;
		i += 1;
	}
	i = 216;
	while (i <= 222) {
		Strings_toLower[__X(i, 256)] = (CHAR)(i + 32);
		Strings_toUpper[__X(i + 32, 256)] = (CHAR)i;
		i += 1;
	}
	Strings_toUpper[255] = 33144;
	__MOVE(((CHAR[]){48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, 0}), Strings_digits, \
34);
	Strings_maxExp = (INTEGER)__ENTIER(Math_Log((8.988465674311579E+307 * 2))) + 1;
	Strings_maxDig = (INTEGER)__ENTIER(-Math_Log(Math_Eps()));
	Strings_factor = Math_IntPower((REAL)10, Strings_maxDig);
	__EXIT;
}

export INTEGER Strings__1__desc[] = {
	17,
	(INTEGER)&Strings__desc,
	0<<8 | 0x02,
	3
};
export INTEGER Strings__2__desc[] = {
	256,
	(INTEGER)&Strings__desc,
	0<<8 | 0x02,
	3
};
static SYSTEM_MODDESC *Strings__imp[] = {
	&Kernel__desc,
	&Math__desc,
};
static INTEGER Strings__exp[] = {
	40,
	0x9955e211, (INTEGER)Strings_Extract, 1<<8 | 0x44, 0,
	0x96cddc9d, (INTEGER)Strings_Find, 9<<8 | 0x44, 0,
	0x227d6f36, (INTEGER)Strings_Init, 14<<8 | 0x14, 0,
	0x8e9ade0a, (INTEGER)Strings_IntToString, 19<<8 | 0x44, 0,
	0xf8fe7fd7, (INTEGER)Strings_IntToStringForm, 31<<8 | 0x44, 0,
	0xddf1b1c4, (INTEGER)Strings_IsAlpha, 47<<8 | 0x44, 0,
	0xddf1b1c4, (INTEGER)Strings_IsAlphaNumeric, 55<<8 | 0x44, 0,
	0xddf1b1c4, (INTEGER)Strings_IsIdent, 70<<8 | 0x44, 0,
	0xddf1b1c4, (INTEGER)Strings_IsIdentStart, 78<<8 | 0x44, 0,
	0xddf1b1c4, (INTEGER)Strings_IsLower, 91<<8 | 0x44, 0,
	0xddf1b1c4, (INTEGER)Strings_IsNumeric, 99<<8 | 0x44, 0,
	0xddf1b1c4, (INTEGER)Strings_IsUpper, 109<<8 | 0x44, 0,
	0x2574e362, (INTEGER)Strings_Lower, 117<<8 | 0x44, 0,
	0xb6bd4fc0, (INTEGER)Strings_RealToString, 123<<8 | 0x44, 0,
	0xeac4cd11, (INTEGER)Strings_RealToStringForm, 136<<8 | 0x44, 0,
	0x7e127681, (INTEGER)Strings_Replace, 153<<8 | 0x44, 0,
	0x5e1919c5, (INTEGER)Strings_SetToString, 161<<8 | 0x44, 0,
	0x3f9ce54f, (INTEGER)Strings_StringToInt, 173<<8 | 0x44, 0,
	0x1922285c, (INTEGER)Strings_StringToLInt, 185<<8 | 0x44, 0,
	0xf1efc869, (INTEGER)Strings_StringToReal, 198<<8 | 0x44, 0,
	0xe63cf934, (INTEGER)Strings_StringToSet, 211<<8 | 0x44, 0,
	0xbf10cc31, (INTEGER)Strings_StringToUtf8, 223<<8 | 0x44, 0,
	0xfa8adb32, (INTEGER)Strings_ToLower, 236<<8 | 0x44, 0,
	0xfa8adb32, (INTEGER)Strings_ToUpper, 244<<8 | 0x44, 0,
	0x2574e362, (INTEGER)Strings_Upper, 252<<8 | 0x44, 0,
	0xf90aaa55, (INTEGER)Strings_Utf8ToString, 258<<8 | 0x44, 0,
	0x3500ec34, (INTEGER)Strings_Valid, 271<<8 | 0x44, 0,
	0x9149d921, 0, 277<<8 | 0x41, 0,
	0x79c7d28c, 0, 286<<8 | 0x41, 0,
	0x4c406161, (INTEGER)&Strings_digits, 294<<8 | 0x13, (INTEGER)Strings__1__desc,
	0x6ef7bd07, 0, 301<<8 | 0x41, 0,
	0x226bec00, (INTEGER)&Strings_factor, 312<<8 | 0x13, 8,
	0x9588c496, 0, 319<<8 | 0x41, 0,
	0x76b987d9, 0, 331<<8 | 0x41, 0,
	0x1ee54c0a, (INTEGER)&Strings_maxDig, 340<<8 | 0x13, 6,
	0x1ee54c0a, (INTEGER)&Strings_maxExp, 347<<8 | 0x13, 6,
	0x98cbe24f, 0, 354<<8 | 0x41, 0,
	0x72789a6e, 0, 360<<8 | 0x41, 0,
	0xe652f226, (INTEGER)&Strings_toLower, 369<<8 | 0x13, (INTEGER)Strings__2__desc,
	0xe652f226, (INTEGER)&Strings_toUpper, 377<<8 | 0x13, (INTEGER)Strings__2__desc,
};
static char Strings__names[] = {
	0,
	'E','x','t','r','a','c','t',0,
	'F','i','n','d',0,
	'I','n','i','t',0,
	'I','n','t','T','o','S','t','r','i','n','g',0,
	'I','n','t','T','o','S','t','r','i','n','g','F','o','r','m',0,
	'I','s','A','l','p','h','a',0,
	'I','s','A','l','p','h','a','N','u','m','e','r','i','c',0,
	'I','s','I','d','e','n','t',0,
	'I','s','I','d','e','n','t','S','t','a','r','t',0,
	'I','s','L','o','w','e','r',0,
	'I','s','N','u','m','e','r','i','c',0,
	'I','s','U','p','p','e','r',0,
	'L','o','w','e','r',0,
	'R','e','a','l','T','o','S','t','r','i','n','g',0,
	'R','e','a','l','T','o','S','t','r','i','n','g','F','o','r','m',0,
	'R','e','p','l','a','c','e',0,
	'S','e','t','T','o','S','t','r','i','n','g',0,
	'S','t','r','i','n','g','T','o','I','n','t',0,
	'S','t','r','i','n','g','T','o','L','I','n','t',0,
	'S','t','r','i','n','g','T','o','R','e','a','l',0,
	'S','t','r','i','n','g','T','o','S','e','t',0,
	'S','t','r','i','n','g','T','o','U','t','f','8',0,
	'T','o','L','o','w','e','r',0,
	'T','o','U','p','p','e','r',0,
	'U','p','p','e','r',0,
	'U','t','f','8','T','o','S','t','r','i','n','g',0,
	'V','a','l','i','d',0,
	'c','h','a','r','C','o','d','e',0,
	'd','e','c','i','m','a','l',0,
	'd','i','g','i','t','s',0,
	'd','i','g','i','t','s','p','a','c','e',0,
	'f','a','c','t','o','r',0,
	'h','e','x','a','d','e','c','i','m','a','l',0,
	'h','i','d','e','B','a','s','e',0,
	'm','a','x','D','i','g',0,
	'm','a','x','E','x','p',0,
	'r','o','m','a','n',0,
	's','h','o','w','B','a','s','e',0,
	't','o','L','o','w','e','r',0,
	't','o','U','p','p','e','r',0,
};
static INTEGER Strings__ptrs[] = {
	0
};
struct SYSTEM_MODDESC Strings__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 2}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	Strings__body,
	0,
	2, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	Strings__names,
	Strings__ptrs,
	Strings__imp,
	(SYSTEM_DIRECTORY*)Strings__exp,
	"Strings"
};

export void Strings__reg()
{
	__BEGREG(Strings__desc);
	Kernel__reg();
	Math__reg();
	__REGMOD(Strings__desc);
	__ENDREG;
}

export void Strings__body()
{
	__BEGBODY(Strings__desc);
	Kernel__body();
	Math__body();
	Strings_Init();
	__ENDBODY;
}
