/*  CPfront 1.0 -m48 */
#include "SYSTEM.h"
#include "C99types.h"
#include "C99macro.h"
#include "errno.h"
#include "sys/stat.h"
#include "sys/types.h"
#include "time.h"
#include "Kernel.h"
#include "Console.h"
#include "Files.h"
#include "Dates.h"
#include "Math.h"
#include "Strings.h"
#include "Services.h"
#include "Log.h"
#include "HostLang.h"
#include "HostConsole.h"
#include "HostFiles.h"
#include "HostDates.h"
#include "DswLog.h"
#include "DevCPM.h"
#include "DevCPT.h"
#include "DevCPS.h"
#include "DevCPB.h"
#include "DevCPP.h"
#include "DevCPE.h"
#include "DevCPH.h"
#include "CPfrontCPG.h"
#include "CPfrontCPC.h"
#include "CPfrontCPV.h"
#include "DswDocuments.h"
#include "DswCompilerCPfrontMain.h"





export void cpfront__reg();
export void cpfront__body();
export struct SYSTEM_MODDESC cpfront__desc;


static SYSTEM_MODDESC *cpfront__imp[] = {
	&C99macro__desc,
	&C99types__desc,
	&CPfrontCPC__desc,
	&CPfrontCPG__desc,
	&CPfrontCPV__desc,
	&Console__desc,
	&Dates__desc,
	&DevCPB__desc,
	&DevCPE__desc,
	&DevCPH__desc,
	&DevCPM__desc,
	&DevCPP__desc,
	&DevCPS__desc,
	&DevCPT__desc,
	&DswCompilerCPfrontMain__desc,
	&DswDocuments__desc,
	&DswLog__desc,
	&Files__desc,
	&HostConsole__desc,
	&HostDates__desc,
	&HostFiles__desc,
	&HostLang__desc,
	&Kernel__desc,
	&Log__desc,
	&Math__desc,
	&Services__desc,
	&Strings__desc,
};
static INTEGER cpfront__exp[] = {
	0,
};
static char cpfront__names[] = {
	0,
};
static INTEGER cpfront__ptrs[] = {
	0
};
struct SYSTEM_MODDESC cpfront__desc = {
	0, 13, 0, /* next, opts, refcnt */ 
	{2019, 6, 9, 21, 27, 22}, /* compTime */ 
	{0, 0, 0, 0, 0, 0}, /* loadTime */ 
	cpfront__body,
	0,
	27, /* nofimps */ 
	0, /* nofptrs */ 
	0, 0, 0, 0, 0, 0, 0, 0, /* csize..varBase */ 
	cpfront__names,
	cpfront__ptrs,
	cpfront__imp,
	(SYSTEM_DIRECTORY*)cpfront__exp,
	"cpfront"
};

export void cpfront__reg()
{
	__BEGREG(cpfront__desc);
	C99types__reg();
	C99macro__reg();
	Kernel__reg();
	Console__reg();
	Files__reg();
	Dates__reg();
	Math__reg();
	Strings__reg();
	Services__reg();
	Log__reg();
	HostLang__reg();
	HostConsole__reg();
	HostFiles__reg();
	HostDates__reg();
	DswLog__reg();
	DevCPM__reg();
	DevCPT__reg();
	DevCPS__reg();
	DevCPB__reg();
	DevCPP__reg();
	DevCPE__reg();
	DevCPH__reg();
	CPfrontCPG__reg();
	CPfrontCPC__reg();
	CPfrontCPV__reg();
	DswDocuments__reg();
	DswCompilerCPfrontMain__reg();
	__REGMOD(cpfront__desc);
	__ENDREG;
}

export void cpfront__body()
{
	__BEGBODY(cpfront__desc);
	C99types__body();
	C99macro__body();
	Kernel__body();
	Console__body();
	Files__body();
	Dates__body();
	Math__body();
	Strings__body();
	Services__body();
	Log__body();
	HostLang__body();
	HostConsole__body();
	HostFiles__body();
	HostDates__body();
	DswLog__body();
	DevCPM__body();
	DevCPT__body();
	DevCPS__body();
	DevCPB__body();
	DevCPP__body();
	DevCPE__body();
	DevCPH__body();
	CPfrontCPG__body();
	CPfrontCPC__body();
	CPfrontCPV__body();
	DswDocuments__body();
	DswCompilerCPfrontMain__body();
	__ENDBODY;
}

int main(int argc, char **argv)
{
	__INIT(argc, argv);
	cpfront__reg();
	cpfront__body();
	return 0;
}
