#! /bin/sh

set -e

THIS="$(dirname "$(readlink -f "$0")")"
OUT="$THIS/stage0/i486"

linkall() {
	local name="$1";
	shift

	local list=""
	for mod in "$@" "$name"; do
		list="$list $THIS/CodeC/$mod.c"
	done

	gcc -m32 -g -O0 -lm -ldl -o "$OUT/$name" \
		-Wno-int-conversion \
		-Wno-int-to-pointer-cast \
		-Wno-incompatible-pointer-types \
		-Wno-implicit-function-declaration \
		-I "$THIS/C" "$THIS/C/SYSTEM.c" $list
}

rm -rf "$OUT"
mkdir -p "$OUT"

linkall cpc486 \
	C99types C99macro \
	Kernel Console Files Dates Math Strings Services Log \
	HostLang HostConsole HostFiles HostDates DswLog \
	DevCPM DevCPT DevCPS DevCPB DevCPP DevCPE DevCPH \
	DevCPL486 DevCPC486 DevCPV486 \
	DswDocuments DswCompiler486Main

linkall cpfront \
	C99types C99macro \
	Kernel Console Files Dates Math Strings Services Log \
	HostLang HostConsole HostFiles HostDates DswLog \
	DevCPM DevCPT DevCPS DevCPB DevCPP DevCPE DevCPH \
	CPfrontCPG CPfrontCPC CPfrontCPV\
	DswDocuments DswCompilerCPfrontMain

linkall cpl486 \
	C99types C99macro \
	Kernel Console Files Math Strings Services Log \
	HostLang HostConsole HostFiles DswLog \
	Dev2LnkBase Dev2LnkChmod Dev2LnkLoad Dev2LnkWriteElf \
	Dev2LnkWriteElfStatic Dev2LnkWritePe \
	DswLinker486Main

#linkall cplist \
#	C99types C99macro \
#	Kernel Console Files Math Strings Services Log \
#	HostLang HostConsole HostFiles DswLog \
#	DswListMain

#linkall cpecho \
#	C99types C99macro \
#	Kernel Console Files Math Strings Services Log \
#	HostLang HostConsole HostFiles DswLog \
#	DswEchoMain

#linkall cploop \
#	C99types C99macro \
#	Kernel Console Files Math Strings Services Log \
#	HostLang HostConsole HostFiles DswLog \
#	DswLoopMain

chmod a+x "$OUT/cpfront" "$OUT/cpc486" "$OUT/cpl486"
